/* Album.c generated by valac 0.42.6, the Vala compiler
 * generated from Album.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */
/*
 * An object representing an album.
 *
 * Currently only used by the album grid view to keep an internal cache.
 *
 * TODO (a lot of work for 1.0 ++)
 * - Replace album-related Media fields with an album object.
 * - Allow organizing media by disc number. Creating a Disc object would probably
 *   be overkill, considering our basic needs.
 * - Modify code accordingly
 * - Save albums to database
 * - Keep albums organized by library manager
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>


#define NOISE_TYPE_ALBUM (noise_album_get_type ())
#define NOISE_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUM, NoiseAlbum))
#define NOISE_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUM, NoiseAlbumClass))
#define NOISE_IS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUM))
#define NOISE_IS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUM))
#define NOISE_ALBUM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUM, NoiseAlbumClass))

typedef struct _NoiseAlbum NoiseAlbum;
typedef struct _NoiseAlbumClass NoiseAlbumClass;
typedef struct _NoiseAlbumPrivate NoiseAlbumPrivate;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
enum  {
	NOISE_ALBUM_0_PROPERTY,
	NOISE_ALBUM_ARTIST_PROPERTY,
	NOISE_ALBUM_NAME_PROPERTY,
	NOISE_ALBUM_YEAR_PROPERTY,
	NOISE_ALBUM_COVER_ICON_PROPERTY,
	NOISE_ALBUM_IS_EMPTY_PROPERTY,
	NOISE_ALBUM_NUM_PROPERTIES
};
static GParamSpec* noise_album_properties[NOISE_ALBUM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
enum  {
	NOISE_ALBUM_COVER_RENDERED_SIGNAL,
	NOISE_ALBUM_NUM_SIGNALS
};
static guint noise_album_signals[NOISE_ALBUM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NoiseAlbum {
	GObject parent_instance;
	NoiseAlbumPrivate * priv;
};

struct _NoiseAlbumClass {
	GObjectClass parent_class;
};

struct _NoiseAlbumPrivate {
	gchar* _artist;
	gchar* _name;
	guint _year;
	GIcon* _cover_icon;
	guint _n_discs;
	GeeHashSet* media;
	GdkPixbuf* cover_pixbuf;
	gint cover_pixbuf_scale;
};

struct _Block1Data {
	int _ref_count_;
	NoiseAlbum* self;
	GtkIconInfo* icon_info;
	gint scale;
};

struct _Block2Data {
	int _ref_count_;
	NoiseAlbum* self;
	GFile* file;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	GFile* dest;
};

struct _Block4Data {
	int _ref_count_;
	NoiseAlbum* self;
	GdkPixbuf* pixbuf;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GFile* dest;
};


static gint NoiseAlbum_private_offset;
static gpointer noise_album_parent_class = NULL;

GType noise_album_get_type (void) G_GNUC_CONST;
GType noise_media_get_type (void) G_GNUC_CONST;
NoiseAlbum* noise_album_new (const gchar* name,
                             const gchar* artist);
NoiseAlbum* noise_album_construct (GType object_type,
                                   const gchar* name,
                                   const gchar* artist);
GFile* noise_album_get_cached_cover_file (NoiseAlbum* self);
void noise_album_set_cover_icon (NoiseAlbum* self,
                                 GIcon* value);
NoiseAlbum* noise_album_new_from_media (NoiseMedia* media);
NoiseAlbum* noise_album_construct_from_media (GType object_type,
                                              NoiseMedia* media);
const gchar* noise_media_get_album_artist (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
guint noise_media_get_year (NoiseMedia* self);
gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
const gchar* noise_album_get_artist (NoiseAlbum* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
void noise_album_set_artist (NoiseAlbum* self,
                             const gchar* value);
gchar* noise_album_get_display_name (NoiseAlbum* self);
gchar* noise_media_get_simple_display_text (const gchar* text);
const gchar* noise_album_get_name (NoiseAlbum* self);
gchar* noise_album_get_display_artist (NoiseAlbum* self);
gboolean noise_album_is_compatible (NoiseAlbum* self,
                                    NoiseMedia* m);
guint noise_media_get_album_hashkey (NoiseMedia* self);
guint noise_album_get_hashkey (NoiseAlbum* self);
void noise_album_remove_media (NoiseAlbum* self,
                               NoiseMedia* m);
void noise_media_set_album_info (NoiseMedia* self,
                                 NoiseAlbum* value);
void noise_album_add_media (NoiseAlbum* self,
                            NoiseMedia* m);
GeeCollection* noise_album_get_media (NoiseAlbum* self,
                                      guint n_disc);
static guint noise_album_get_n_discs (NoiseAlbum* self);
GdkPixbuf* noise_album_get_cached_cover_pixbuf (NoiseAlbum* self,
                                                gint scale);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
GIcon* noise_album_get_cover_icon (NoiseAlbum* self);
static void __lambda4_ (Block1Data* _data1_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
void noise_album_save_cover_file (NoiseAlbum* self,
                                  GFile* file);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void* __lambda5_ (Block2Data* _data2_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static GFile* noise_album_get_cover_cache (void);
static gboolean ___lambda6_ (Block3Data* _data3_);
static gboolean ____lambda6__gsource_func (gpointer self);
static gpointer ___lambda5__gthread_func (gpointer self);
void noise_album_save_cover_pixbuf (NoiseAlbum* self,
                                    GdkPixbuf* pixbuf);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void* __lambda7_ (Block4Data* _data4_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean ___lambda8_ (Block5Data* _data5_);
static gboolean ____lambda8__gsource_func (gpointer self);
static gpointer ___lambda7__gthread_func (gpointer self);
GFile* noise_file_utils_get_cache_directory (void);
void noise_album_set_name (NoiseAlbum* self,
                           const gchar* value);
guint noise_album_get_year (NoiseAlbum* self);
void noise_album_set_year (NoiseAlbum* self,
                           guint value);
static void noise_album_set_n_discs (NoiseAlbum* self,
                              guint value);
gboolean noise_album_get_is_empty (NoiseAlbum* self);
static GObject * noise_album_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _noise_album___lambda9_ (NoiseAlbum* self);
static void __noise_album___lambda9__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
static void noise_album_finalize (GObject * obj);
static void _vala_noise_album_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_noise_album_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


static inline gpointer
noise_album_get_instance_private (NoiseAlbum* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseAlbum_private_offset);
}


/**
     * Convenience constructor.
     *
     * This is a temporary workaround used by the Grid View and will be
     * deprecated after the TODO list is completed.
     */
NoiseAlbum*
noise_album_construct (GType object_type,
                       const gchar* name,
                       const gchar* artist)
{
	NoiseAlbum * self = NULL;
	GFile* cover_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 66 "../core/Album.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 66 "../core/Album.vala"
	g_return_val_if_fail (artist != NULL, NULL);
#line 67 "../core/Album.vala"
	self = (NoiseAlbum*) g_object_new (object_type, "artist", artist, "name", name, NULL);
#line 72 "../core/Album.vala"
	_tmp0_ = noise_album_get_cached_cover_file (self);
#line 72 "../core/Album.vala"
	cover_file = _tmp0_;
#line 73 "../core/Album.vala"
	_tmp1_ = cover_file;
#line 73 "../core/Album.vala"
	if (_tmp1_ != NULL) {
#line 297 "Album.c"
		GFile* _tmp2_;
		GFileIcon* _tmp3_;
		GFileIcon* _tmp4_;
#line 74 "../core/Album.vala"
		_tmp2_ = cover_file;
#line 74 "../core/Album.vala"
		_tmp3_ = (GFileIcon*) g_file_icon_new (_tmp2_);
#line 74 "../core/Album.vala"
		_tmp4_ = _tmp3_;
#line 74 "../core/Album.vala"
		noise_album_set_cover_icon (self, (GIcon*) _tmp4_);
#line 74 "../core/Album.vala"
		_g_object_unref0 (_tmp4_);
#line 311 "Album.c"
	}
#line 66 "../core/Album.vala"
	_g_object_unref0 (cover_file);
#line 66 "../core/Album.vala"
	return self;
#line 317 "Album.c"
}


NoiseAlbum*
noise_album_new (const gchar* name,
                 const gchar* artist)
{
#line 66 "../core/Album.vala"
	return noise_album_construct (NOISE_TYPE_ALBUM, name, artist);
#line 327 "Album.c"
}


NoiseAlbum*
noise_album_construct_from_media (GType object_type,
                                  NoiseMedia* media)
{
	NoiseAlbum * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	const gchar* _tmp6_;
	GFile* cover_file = NULL;
	GFile* _tmp9_;
	GFile* _tmp10_;
#line 78 "../core/Album.vala"
	g_return_val_if_fail (media != NULL, NULL);
#line 79 "../core/Album.vala"
	_tmp0_ = noise_media_get_album_artist (media);
#line 79 "../core/Album.vala"
	_tmp1_ = _tmp0_;
#line 79 "../core/Album.vala"
	_tmp2_ = noise_media_get_album (media);
#line 79 "../core/Album.vala"
	_tmp3_ = _tmp2_;
#line 79 "../core/Album.vala"
	_tmp4_ = noise_media_get_year (media);
#line 79 "../core/Album.vala"
	_tmp5_ = _tmp4_;
#line 79 "../core/Album.vala"
	self = (NoiseAlbum*) g_object_new (object_type, "artist", _tmp1_, "name", _tmp3_, "year", _tmp5_, NULL);
#line 85 "../core/Album.vala"
	_tmp6_ = self->priv->_artist;
#line 85 "../core/Album.vala"
	if (noise_string_is_empty (_tmp6_, TRUE)) {
#line 366 "Album.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 86 "../core/Album.vala"
		_tmp7_ = noise_media_get_artist (media);
#line 86 "../core/Album.vala"
		_tmp8_ = _tmp7_;
#line 86 "../core/Album.vala"
		noise_album_set_artist (self, _tmp8_);
#line 375 "Album.c"
	}
#line 89 "../core/Album.vala"
	_tmp9_ = noise_album_get_cached_cover_file (self);
#line 89 "../core/Album.vala"
	cover_file = _tmp9_;
#line 90 "../core/Album.vala"
	_tmp10_ = cover_file;
#line 90 "../core/Album.vala"
	if (_tmp10_ != NULL) {
#line 385 "Album.c"
		GFile* _tmp11_;
		GFileIcon* _tmp12_;
		GFileIcon* _tmp13_;
#line 91 "../core/Album.vala"
		_tmp11_ = cover_file;
#line 91 "../core/Album.vala"
		_tmp12_ = (GFileIcon*) g_file_icon_new (_tmp11_);
#line 91 "../core/Album.vala"
		_tmp13_ = _tmp12_;
#line 91 "../core/Album.vala"
		noise_album_set_cover_icon (self, (GIcon*) _tmp13_);
#line 91 "../core/Album.vala"
		_g_object_unref0 (_tmp13_);
#line 399 "Album.c"
	}
#line 78 "../core/Album.vala"
	_g_object_unref0 (cover_file);
#line 78 "../core/Album.vala"
	return self;
#line 405 "Album.c"
}


NoiseAlbum*
noise_album_new_from_media (NoiseMedia* media)
{
#line 78 "../core/Album.vala"
	return noise_album_construct_from_media (NOISE_TYPE_ALBUM, media);
#line 414 "Album.c"
}


inline gchar*
noise_album_get_display_name (NoiseAlbum* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 105 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../core/Album.vala"
	_tmp0_ = self->priv->_name;
#line 106 "../core/Album.vala"
	_tmp1_ = noise_media_get_simple_display_text (_tmp0_);
#line 106 "../core/Album.vala"
	result = _tmp1_;
#line 106 "../core/Album.vala"
	return result;
#line 434 "Album.c"
}


inline gchar*
noise_album_get_display_artist (NoiseAlbum* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 109 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../core/Album.vala"
	_tmp0_ = self->priv->_artist;
#line 110 "../core/Album.vala"
	_tmp1_ = noise_media_get_simple_display_text (_tmp0_);
#line 110 "../core/Album.vala"
	result = _tmp1_;
#line 110 "../core/Album.vala"
	return result;
#line 454 "Album.c"
}


gboolean
noise_album_is_compatible (NoiseAlbum* self,
                           NoiseMedia* m)
{
	gboolean result = FALSE;
#line 113 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 113 "../core/Album.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 114 "../core/Album.vala"
	if (noise_media_get_album_hashkey (m) == noise_album_get_hashkey (self)) {
#line 115 "../core/Album.vala"
		result = TRUE;
#line 115 "../core/Album.vala"
		return result;
#line 473 "Album.c"
	} else {
#line 117 "../core/Album.vala"
		result = FALSE;
#line 117 "../core/Album.vala"
		return result;
#line 479 "Album.c"
	}
}


void
noise_album_remove_media (NoiseAlbum* self,
                          NoiseMedia* m)
{
	GeeHashSet* _tmp0_;
#line 120 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 120 "../core/Album.vala"
	g_return_if_fail (m != NULL);
#line 121 "../core/Album.vala"
	noise_media_set_album_info (m, NULL);
#line 122 "../core/Album.vala"
	_tmp0_ = self->priv->media;
#line 122 "../core/Album.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, m);
#line 499 "Album.c"
}


void
noise_album_add_media (NoiseAlbum* self,
                       NoiseMedia* m)
{
	GeeHashSet* _tmp0_;
#line 125 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 125 "../core/Album.vala"
	g_return_if_fail (m != NULL);
#line 126 "../core/Album.vala"
	_tmp0_ = self->priv->media;
#line 126 "../core/Album.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, m);
#line 127 "../core/Album.vala"
	noise_media_set_album_info (m, self);
#line 518 "Album.c"
}


guint
noise_album_get_hashkey (NoiseAlbum* self)
{
	guint result = 0U;
	GString* builder = NULL;
	GString* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 130 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 131 "../core/Album.vala"
	_tmp0_ = g_string_new ("");
#line 131 "../core/Album.vala"
	builder = _tmp0_;
#line 132 "../core/Album.vala"
	_tmp1_ = self->priv->_name;
#line 132 "../core/Album.vala"
	g_string_append (builder, _tmp1_);
#line 133 "../core/Album.vala"
	_tmp2_ = self->priv->_artist;
#line 133 "../core/Album.vala"
	g_string_append (builder, _tmp2_);
#line 134 "../core/Album.vala"
	_tmp3_ = builder->str;
#line 134 "../core/Album.vala"
	result = g_str_hash (_tmp3_);
#line 134 "../core/Album.vala"
	_g_string_free0 (builder);
#line 134 "../core/Album.vala"
	return result;
#line 553 "Album.c"
}


/**
     * Returns the media contained by the disc specified
     */
GeeCollection*
noise_album_get_media (NoiseAlbum* self,
                       guint n_disc)
{
	GeeCollection* result = NULL;
	guint _tmp0_;
	GeeHashSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
#line 140 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../core/Album.vala"
	_vala_return_val_if_fail (n_disc > ((guint) 0), "n_disc > 0", NULL);
#line 140 "../core/Album.vala"
	_tmp0_ = self->priv->_n_discs;
#line 140 "../core/Album.vala"
	_vala_return_val_if_fail (n_disc <= _tmp0_, "n_disc <= n_discs", NULL);
#line 144 "../core/Album.vala"
	_tmp1_ = self->priv->media;
#line 144 "../core/Album.vala"
	_tmp2_ = gee_abstract_set_get_read_only_view ((GeeAbstractSet*) _tmp1_);
#line 144 "../core/Album.vala"
	_tmp3_ = _tmp2_;
#line 144 "../core/Album.vala"
	result = (GeeCollection*) _tmp3_;
#line 144 "../core/Album.vala"
	return result;
#line 587 "Album.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 147 "../core/Album.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 147 "../core/Album.vala"
	return _data1_;
#line 598 "Album.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 147 "../core/Album.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 609 "Album.c"
		NoiseAlbum* self;
#line 147 "../core/Album.vala"
		self = _data1_->self;
#line 147 "../core/Album.vala"
		_gtk_icon_info_free0 (_data1_->icon_info);
#line 147 "../core/Album.vala"
		_g_object_unref0 (self);
#line 147 "../core/Album.vala"
		g_slice_free (Block1Data, _data1_);
#line 619 "Album.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 149 "../core/Album.vala"
	return self ? g_object_ref (self) : NULL;
#line 629 "Album.c"
}


static void
__lambda4_ (Block1Data* _data1_,
            GObject* obj,
            GAsyncResult* res)
{
	NoiseAlbum* self;
	GError* _inner_error0_ = NULL;
#line 157 "../core/Album.vala"
	self = _data1_->self;
#line 157 "../core/Album.vala"
	g_return_if_fail (res != NULL);
#line 644 "Album.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GtkIconInfo* _tmp1_;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 159 "../core/Album.vala"
		_tmp1_ = _data1_->icon_info;
#line 159 "../core/Album.vala"
		_tmp2_ = gtk_icon_info_load_icon_finish (_tmp1_, res, &_inner_error0_);
#line 159 "../core/Album.vala"
		_tmp0_ = _tmp2_;
#line 159 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 658 "Album.c"
			goto __catch0_g_error;
		}
#line 159 "../core/Album.vala"
		_tmp3_ = _tmp0_;
#line 159 "../core/Album.vala"
		_tmp0_ = NULL;
#line 159 "../core/Album.vala"
		_g_object_unref0 (self->priv->cover_pixbuf);
#line 159 "../core/Album.vala"
		self->priv->cover_pixbuf = _tmp3_;
#line 160 "../core/Album.vala"
		self->priv->cover_pixbuf_scale = _data1_->scale;
#line 161 "../core/Album.vala"
		g_signal_emit (self, noise_album_signals[NOISE_ALBUM_COVER_RENDERED_SIGNAL], 0);
#line 158 "../core/Album.vala"
		_g_object_unref0 (_tmp0_);
#line 675 "Album.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 158 "../core/Album.vala"
		e = _inner_error0_;
#line 158 "../core/Album.vala"
		_inner_error0_ = NULL;
#line 163 "../core/Album.vala"
		_tmp4_ = e;
#line 163 "../core/Album.vala"
		_tmp5_ = _tmp4_->message;
#line 163 "../core/Album.vala"
		g_critical ("Album.vala:163: %s", _tmp5_);
#line 158 "../core/Album.vala"
		_g_error_free0 (e);
#line 695 "Album.c"
	}
	__finally0:
#line 158 "../core/Album.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 158 "../core/Album.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../core/Album.vala"
		g_clear_error (&_inner_error0_);
#line 158 "../core/Album.vala"
		return;
#line 706 "Album.c"
	}
}


static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 157 "../core/Album.vala"
	__lambda4_ (self, source_object, res);
#line 157 "../core/Album.vala"
	block1_data_unref (self);
#line 720 "Album.c"
}


GdkPixbuf*
noise_album_get_cached_cover_pixbuf (NoiseAlbum* self,
                                     gint scale)
{
	GdkPixbuf* result = NULL;
	Block1Data* _data1_;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp1_;
	GIcon* _tmp5_;
	GtkIconTheme* _tmp6_;
	GIcon* _tmp7_;
	GtkIconInfo* _tmp8_;
	GtkIconInfo* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
#line 147 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "../core/Album.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 147 "../core/Album.vala"
	_data1_->_ref_count_ = 1;
#line 147 "../core/Album.vala"
	_data1_->self = g_object_ref (self);
#line 147 "../core/Album.vala"
	_data1_->scale = scale;
#line 148 "../core/Album.vala"
	_tmp1_ = self->priv->cover_pixbuf;
#line 148 "../core/Album.vala"
	if (_tmp1_ != NULL) {
#line 753 "Album.c"
		gint _tmp2_;
#line 148 "../core/Album.vala"
		_tmp2_ = self->priv->cover_pixbuf_scale;
#line 148 "../core/Album.vala"
		_tmp0_ = _tmp2_ == _data1_->scale;
#line 759 "Album.c"
	} else {
#line 148 "../core/Album.vala"
		_tmp0_ = FALSE;
#line 763 "Album.c"
	}
#line 148 "../core/Album.vala"
	if (_tmp0_) {
#line 767 "Album.c"
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 149 "../core/Album.vala"
		_tmp3_ = self->priv->cover_pixbuf;
#line 149 "../core/Album.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 149 "../core/Album.vala"
		result = _tmp4_;
#line 149 "../core/Album.vala"
		block1_data_unref (_data1_);
#line 149 "../core/Album.vala"
		_data1_ = NULL;
#line 149 "../core/Album.vala"
		return result;
#line 782 "Album.c"
	}
#line 152 "../core/Album.vala"
	_tmp5_ = self->priv->_cover_icon;
#line 152 "../core/Album.vala"
	if (_tmp5_ == NULL) {
#line 153 "../core/Album.vala"
		result = NULL;
#line 153 "../core/Album.vala"
		block1_data_unref (_data1_);
#line 153 "../core/Album.vala"
		_data1_ = NULL;
#line 153 "../core/Album.vala"
		return result;
#line 796 "Album.c"
	}
#line 156 "../core/Album.vala"
	_tmp6_ = gtk_icon_theme_get_default ();
#line 156 "../core/Album.vala"
	_tmp7_ = self->priv->_cover_icon;
#line 156 "../core/Album.vala"
	_tmp8_ = gtk_icon_theme_lookup_by_gicon_for_scale (_tmp6_, _tmp7_, 128, _data1_->scale, 0);
#line 156 "../core/Album.vala"
	_data1_->icon_info = _tmp8_;
#line 157 "../core/Album.vala"
	_tmp9_ = _data1_->icon_info;
#line 157 "../core/Album.vala"
	gtk_icon_info_load_icon_async (_tmp9_, NULL, ___lambda4__gasync_ready_callback, block1_data_ref (_data1_));
#line 167 "../core/Album.vala"
	_tmp10_ = self->priv->cover_pixbuf;
#line 167 "../core/Album.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 167 "../core/Album.vala"
	result = _tmp11_;
#line 167 "../core/Album.vala"
	block1_data_unref (_data1_);
#line 167 "../core/Album.vala"
	_data1_ = NULL;
#line 167 "../core/Album.vala"
	return result;
#line 822 "Album.c"
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 170 "../core/Album.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 170 "../core/Album.vala"
	return _data2_;
#line 833 "Album.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 170 "../core/Album.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 844 "Album.c"
		NoiseAlbum* self;
#line 170 "../core/Album.vala"
		self = _data2_->self;
#line 170 "../core/Album.vala"
		_g_object_unref0 (_data2_->file);
#line 170 "../core/Album.vala"
		_g_object_unref0 (self);
#line 170 "../core/Album.vala"
		g_slice_free (Block2Data, _data2_);
#line 854 "Album.c"
	}
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 171 "../core/Album.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 171 "../core/Album.vala"
	return _data3_;
#line 866 "Album.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 171 "../core/Album.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 877 "Album.c"
		NoiseAlbum* self;
#line 171 "../core/Album.vala"
		self = _data3_->_data2_->self;
#line 171 "../core/Album.vala"
		_g_object_unref0 (_data3_->dest);
#line 171 "../core/Album.vala"
		block2_data_unref (_data3_->_data2_);
#line 171 "../core/Album.vala"
		_data3_->_data2_ = NULL;
#line 171 "../core/Album.vala"
		g_slice_free (Block3Data, _data3_);
#line 889 "Album.c"
	}
}


static gboolean
___lambda6_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	NoiseAlbum* self;
	gboolean result = FALSE;
	GFileIcon* _tmp0_;
	GFileIcon* _tmp1_;
#line 175 "../core/Album.vala"
	_data2_ = _data3_->_data2_;
#line 175 "../core/Album.vala"
	self = _data2_->self;
#line 176 "../core/Album.vala"
	_tmp0_ = (GFileIcon*) g_file_icon_new (_data3_->dest);
#line 176 "../core/Album.vala"
	_tmp1_ = _tmp0_;
#line 176 "../core/Album.vala"
	noise_album_set_cover_icon (self, (GIcon*) _tmp1_);
#line 176 "../core/Album.vala"
	_g_object_unref0 (_tmp1_);
#line 177 "../core/Album.vala"
	result = FALSE;
#line 177 "../core/Album.vala"
	return result;
#line 918 "Album.c"
}


static gboolean
____lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda6_ (self);
#line 175 "../core/Album.vala"
	return result;
#line 929 "Album.c"
}


static void*
__lambda5_ (Block2Data* _data2_)
{
	NoiseAlbum* self;
	void* result = NULL;
	Block3Data* _data3_;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 171 "../core/Album.vala"
	self = _data2_->self;
#line 171 "../core/Album.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 171 "../core/Album.vala"
	_data3_->_ref_count_ = 1;
#line 171 "../core/Album.vala"
	_data3_->_data2_ = block2_data_ref (_data2_);
#line 172 "../core/Album.vala"
	_tmp0_ = noise_album_get_cover_cache ();
#line 172 "../core/Album.vala"
	_tmp1_ = _tmp0_;
#line 172 "../core/Album.vala"
	_tmp2_ = g_strdup_printf ("%u", noise_album_get_hashkey (self));
#line 172 "../core/Album.vala"
	_tmp3_ = _tmp2_;
#line 172 "../core/Album.vala"
	_tmp4_ = g_file_get_child (_tmp1_, _tmp3_);
#line 172 "../core/Album.vala"
	_tmp5_ = _tmp4_;
#line 172 "../core/Album.vala"
	_g_free0 (_tmp3_);
#line 172 "../core/Album.vala"
	_g_object_unref0 (_tmp1_);
#line 172 "../core/Album.vala"
	_data3_->dest = _tmp5_;
#line 972 "Album.c"
	{
#line 174 "../core/Album.vala"
		g_file_copy (_data2_->file, _data3_->dest, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 174 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 978 "Album.c"
			goto __catch1_g_error;
		}
#line 175 "../core/Album.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda6__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 983 "Album.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 173 "../core/Album.vala"
		e = _inner_error0_;
#line 173 "../core/Album.vala"
		_inner_error0_ = NULL;
#line 180 "../core/Album.vala"
		_tmp6_ = e;
#line 180 "../core/Album.vala"
		_tmp7_ = _tmp6_->message;
#line 180 "../core/Album.vala"
		g_critical ("Album.vala:180: %s", _tmp7_);
#line 173 "../core/Album.vala"
		_g_error_free0 (e);
#line 1003 "Album.c"
	}
	__finally1:
#line 173 "../core/Album.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../core/Album.vala"
		block3_data_unref (_data3_);
#line 173 "../core/Album.vala"
		_data3_ = NULL;
#line 173 "../core/Album.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "../core/Album.vala"
		g_clear_error (&_inner_error0_);
#line 173 "../core/Album.vala"
		return NULL;
#line 1018 "Album.c"
	}
#line 183 "../core/Album.vala"
	result = NULL;
#line 183 "../core/Album.vala"
	block3_data_unref (_data3_);
#line 183 "../core/Album.vala"
	_data3_ = NULL;
#line 183 "../core/Album.vala"
	return result;
#line 1028 "Album.c"
}


static gpointer
___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda5_ (self);
#line 171 "../core/Album.vala"
	block2_data_unref (self);
#line 171 "../core/Album.vala"
	return result;
#line 1041 "Album.c"
}


void
noise_album_save_cover_file (NoiseAlbum* self,
                             GFile* file)
{
	Block2Data* _data2_;
	GFile* _tmp0_;
	GThread* _tmp1_;
	GThread* _tmp2_;
#line 170 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 170 "../core/Album.vala"
	g_return_if_fail (file != NULL);
#line 170 "../core/Album.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 170 "../core/Album.vala"
	_data2_->_ref_count_ = 1;
#line 170 "../core/Album.vala"
	_data2_->self = g_object_ref (self);
#line 170 "../core/Album.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 170 "../core/Album.vala"
	_g_object_unref0 (_data2_->file);
#line 170 "../core/Album.vala"
	_data2_->file = _tmp0_;
#line 171 "../core/Album.vala"
	_tmp1_ = g_thread_new (NULL, ___lambda5__gthread_func, block2_data_ref (_data2_));
#line 171 "../core/Album.vala"
	_tmp2_ = _tmp1_;
#line 171 "../core/Album.vala"
	_g_thread_unref0 (_tmp2_);
#line 170 "../core/Album.vala"
	block2_data_unref (_data2_);
#line 170 "../core/Album.vala"
	_data2_ = NULL;
#line 1079 "Album.c"
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 187 "../core/Album.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 187 "../core/Album.vala"
	return _data4_;
#line 1090 "Album.c"
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 187 "../core/Album.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1101 "Album.c"
		NoiseAlbum* self;
#line 187 "../core/Album.vala"
		self = _data4_->self;
#line 187 "../core/Album.vala"
		_g_object_unref0 (_data4_->pixbuf);
#line 187 "../core/Album.vala"
		_g_object_unref0 (self);
#line 187 "../core/Album.vala"
		g_slice_free (Block4Data, _data4_);
#line 1111 "Album.c"
	}
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 188 "../core/Album.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 188 "../core/Album.vala"
	return _data5_;
#line 1123 "Album.c"
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 188 "../core/Album.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1134 "Album.c"
		NoiseAlbum* self;
#line 188 "../core/Album.vala"
		self = _data5_->_data4_->self;
#line 188 "../core/Album.vala"
		_g_object_unref0 (_data5_->dest);
#line 188 "../core/Album.vala"
		block4_data_unref (_data5_->_data4_);
#line 188 "../core/Album.vala"
		_data5_->_data4_ = NULL;
#line 188 "../core/Album.vala"
		g_slice_free (Block5Data, _data5_);
#line 1146 "Album.c"
	}
}


static gboolean
___lambda8_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	NoiseAlbum* self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFileIcon* _tmp1_;
	GFileIcon* _tmp2_;
#line 198 "../core/Album.vala"
	_data4_ = _data5_->_data4_;
#line 198 "../core/Album.vala"
	self = _data4_->self;
#line 199 "../core/Album.vala"
	_tmp0_ = _data5_->dest;
#line 199 "../core/Album.vala"
	_tmp1_ = (GFileIcon*) g_file_icon_new (_tmp0_);
#line 199 "../core/Album.vala"
	_tmp2_ = _tmp1_;
#line 199 "../core/Album.vala"
	noise_album_set_cover_icon (self, (GIcon*) _tmp2_);
#line 199 "../core/Album.vala"
	_g_object_unref0 (_tmp2_);
#line 200 "../core/Album.vala"
	result = FALSE;
#line 200 "../core/Album.vala"
	return result;
#line 1178 "Album.c"
}


static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ (self);
#line 198 "../core/Album.vala"
	return result;
#line 1189 "Album.c"
}


static void*
__lambda7_ (Block4Data* _data4_)
{
	NoiseAlbum* self;
	void* result = NULL;
	Block5Data* _data5_;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 188 "../core/Album.vala"
	self = _data4_->self;
#line 188 "../core/Album.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 188 "../core/Album.vala"
	_data5_->_ref_count_ = 1;
#line 188 "../core/Album.vala"
	_data5_->_data4_ = block4_data_ref (_data4_);
#line 189 "../core/Album.vala"
	_tmp0_ = noise_album_get_cover_cache ();
#line 189 "../core/Album.vala"
	_tmp1_ = _tmp0_;
#line 189 "../core/Album.vala"
	_tmp2_ = g_strdup_printf ("%u", noise_album_get_hashkey (self));
#line 189 "../core/Album.vala"
	_tmp3_ = _tmp2_;
#line 189 "../core/Album.vala"
	_tmp4_ = g_file_get_child (_tmp1_, _tmp3_);
#line 189 "../core/Album.vala"
	_tmp5_ = _tmp4_;
#line 189 "../core/Album.vala"
	_g_free0 (_tmp3_);
#line 189 "../core/Album.vala"
	_g_object_unref0 (_tmp1_);
#line 189 "../core/Album.vala"
	_data5_->dest = _tmp5_;
#line 1232 "Album.c"
	{
		GFileOutputStream* output_stream = NULL;
		GFile* _tmp6_;
		GFileOutputStream* _tmp7_;
		guint8* buffer = NULL;
		gint buffer_length1 = 0;
		gint _buffer_size_ = 0;
		guint8* _tmp8_ = NULL;
		gsize _tmp9_;
		GFileOutputStream* _tmp10_;
		guint8* _tmp11_;
		gint _tmp11__length1;
		GFileOutputStream* _tmp12_;
#line 191 "../core/Album.vala"
		_tmp6_ = _data5_->dest;
#line 191 "../core/Album.vala"
		_tmp7_ = g_file_create (_tmp6_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 191 "../core/Album.vala"
		output_stream = _tmp7_;
#line 191 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1254 "Album.c"
			goto __catch2_g_error;
		}
#line 194 "../core/Album.vala"
		gdk_pixbuf_save_to_buffer (_data4_->pixbuf, &_tmp8_, &_tmp9_, "jpeg", &_inner_error0_, NULL);
#line 194 "../core/Album.vala"
		buffer = (g_free (buffer), NULL);
#line 194 "../core/Album.vala"
		buffer = _tmp8_;
#line 194 "../core/Album.vala"
		buffer_length1 = _tmp9_;
#line 194 "../core/Album.vala"
		_buffer_size_ = buffer_length1;
#line 194 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../core/Album.vala"
			buffer = (g_free (buffer), NULL);
#line 194 "../core/Album.vala"
			_g_object_unref0 (output_stream);
#line 1273 "Album.c"
			goto __catch2_g_error;
		}
#line 196 "../core/Album.vala"
		_tmp10_ = output_stream;
#line 196 "../core/Album.vala"
		_tmp11_ = buffer;
#line 196 "../core/Album.vala"
		_tmp11__length1 = buffer_length1;
#line 196 "../core/Album.vala"
		g_output_stream_write ((GOutputStream*) _tmp10_, _tmp11_, (gsize) _tmp11__length1, NULL, &_inner_error0_);
#line 196 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../core/Album.vala"
			buffer = (g_free (buffer), NULL);
#line 196 "../core/Album.vala"
			_g_object_unref0 (output_stream);
#line 1290 "Album.c"
			goto __catch2_g_error;
		}
#line 197 "../core/Album.vala"
		_tmp12_ = output_stream;
#line 197 "../core/Album.vala"
		g_output_stream_close ((GOutputStream*) _tmp12_, NULL, &_inner_error0_);
#line 197 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../core/Album.vala"
			buffer = (g_free (buffer), NULL);
#line 197 "../core/Album.vala"
			_g_object_unref0 (output_stream);
#line 1303 "Album.c"
			goto __catch2_g_error;
		}
#line 198 "../core/Album.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda8__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 190 "../core/Album.vala"
		buffer = (g_free (buffer), NULL);
#line 190 "../core/Album.vala"
		_g_object_unref0 (output_stream);
#line 1312 "Album.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 190 "../core/Album.vala"
		e = _inner_error0_;
#line 190 "../core/Album.vala"
		_inner_error0_ = NULL;
#line 203 "../core/Album.vala"
		_tmp13_ = e;
#line 203 "../core/Album.vala"
		_tmp14_ = _tmp13_->message;
#line 203 "../core/Album.vala"
		g_critical ("Album.vala:203: %s", _tmp14_);
#line 190 "../core/Album.vala"
		_g_error_free0 (e);
#line 1332 "Album.c"
	}
	__finally2:
#line 190 "../core/Album.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../core/Album.vala"
		block5_data_unref (_data5_);
#line 190 "../core/Album.vala"
		_data5_ = NULL;
#line 190 "../core/Album.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../core/Album.vala"
		g_clear_error (&_inner_error0_);
#line 190 "../core/Album.vala"
		return NULL;
#line 1347 "Album.c"
	}
#line 206 "../core/Album.vala"
	result = NULL;
#line 206 "../core/Album.vala"
	block5_data_unref (_data5_);
#line 206 "../core/Album.vala"
	_data5_ = NULL;
#line 206 "../core/Album.vala"
	return result;
#line 1357 "Album.c"
}


static gpointer
___lambda7__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda7_ (self);
#line 188 "../core/Album.vala"
	block4_data_unref (self);
#line 188 "../core/Album.vala"
	return result;
#line 1370 "Album.c"
}


void
noise_album_save_cover_pixbuf (NoiseAlbum* self,
                               GdkPixbuf* pixbuf)
{
	Block4Data* _data4_;
	GdkPixbuf* _tmp0_;
	GThread* _tmp1_;
	GThread* _tmp2_;
#line 187 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 187 "../core/Album.vala"
	g_return_if_fail (pixbuf != NULL);
#line 187 "../core/Album.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 187 "../core/Album.vala"
	_data4_->_ref_count_ = 1;
#line 187 "../core/Album.vala"
	_data4_->self = g_object_ref (self);
#line 187 "../core/Album.vala"
	_tmp0_ = _g_object_ref0 (pixbuf);
#line 187 "../core/Album.vala"
	_g_object_unref0 (_data4_->pixbuf);
#line 187 "../core/Album.vala"
	_data4_->pixbuf = _tmp0_;
#line 188 "../core/Album.vala"
	_tmp1_ = g_thread_new (NULL, ___lambda7__gthread_func, block4_data_ref (_data4_));
#line 188 "../core/Album.vala"
	_tmp2_ = _tmp1_;
#line 188 "../core/Album.vala"
	_g_thread_unref0 (_tmp2_);
#line 187 "../core/Album.vala"
	block4_data_unref (_data4_);
#line 187 "../core/Album.vala"
	_data4_ = NULL;
#line 1408 "Album.c"
}


GFile*
noise_album_get_cached_cover_file (NoiseAlbum* self)
{
	GFile* result = NULL;
	GFile* cover_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
#line 210 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 211 "../core/Album.vala"
	_tmp0_ = noise_album_get_cover_cache ();
#line 211 "../core/Album.vala"
	_tmp1_ = _tmp0_;
#line 211 "../core/Album.vala"
	_tmp2_ = g_strdup_printf ("%u", noise_album_get_hashkey (self));
#line 211 "../core/Album.vala"
	_tmp3_ = _tmp2_;
#line 211 "../core/Album.vala"
	_tmp4_ = g_file_get_child (_tmp1_, _tmp3_);
#line 211 "../core/Album.vala"
	_tmp5_ = _tmp4_;
#line 211 "../core/Album.vala"
	_g_free0 (_tmp3_);
#line 211 "../core/Album.vala"
	_g_object_unref0 (_tmp1_);
#line 211 "../core/Album.vala"
	cover_file = _tmp5_;
#line 212 "../core/Album.vala"
	_tmp6_ = cover_file;
#line 212 "../core/Album.vala"
	if (g_file_query_exists (_tmp6_, NULL)) {
#line 213 "../core/Album.vala"
		result = cover_file;
#line 213 "../core/Album.vala"
		return result;
#line 1452 "Album.c"
	}
#line 216 "../core/Album.vala"
	result = NULL;
#line 216 "../core/Album.vala"
	_g_object_unref0 (cover_file);
#line 216 "../core/Album.vala"
	return result;
#line 1460 "Album.c"
}


static GFile*
noise_album_get_cover_cache (void)
{
	GFile* result = NULL;
	GFile* cache_dir = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 220 "../core/Album.vala"
	_tmp0_ = noise_file_utils_get_cache_directory ();
#line 220 "../core/Album.vala"
	_tmp1_ = _tmp0_;
#line 220 "../core/Album.vala"
	_tmp2_ = g_file_get_child (_tmp1_, "album-art");
#line 220 "../core/Album.vala"
	_tmp3_ = _tmp2_;
#line 220 "../core/Album.vala"
	_g_object_unref0 (_tmp1_);
#line 220 "../core/Album.vala"
	cache_dir = _tmp3_;
#line 1486 "Album.c"
	{
#line 222 "../core/Album.vala"
		g_file_make_directory_with_parents (cache_dir, NULL, &_inner_error0_);
#line 222 "../core/Album.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1492 "Album.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 221 "../core/Album.vala"
		err = _inner_error0_;
#line 221 "../core/Album.vala"
		_inner_error0_ = NULL;
#line 224 "../core/Album.vala"
		_tmp4_ = err;
#line 224 "../core/Album.vala"
		if (g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_EXISTS) == FALSE) {
#line 1509 "Album.c"
			GError* _tmp5_;
			const gchar* _tmp6_;
#line 225 "../core/Album.vala"
			_tmp5_ = err;
#line 225 "../core/Album.vala"
			_tmp6_ = _tmp5_->message;
#line 225 "../core/Album.vala"
			g_error ("Album.vala:225: Could not create data directory: %s", _tmp6_);
#line 1518 "Album.c"
		}
#line 221 "../core/Album.vala"
		_g_error_free0 (err);
#line 1522 "Album.c"
	}
	__finally3:
#line 221 "../core/Album.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../core/Album.vala"
		_g_object_unref0 (cache_dir);
#line 221 "../core/Album.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../core/Album.vala"
		g_clear_error (&_inner_error0_);
#line 221 "../core/Album.vala"
		return NULL;
#line 1535 "Album.c"
	}
#line 228 "../core/Album.vala"
	result = cache_dir;
#line 228 "../core/Album.vala"
	return result;
#line 1541 "Album.c"
}


const gchar*
noise_album_get_artist (NoiseAlbum* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../core/Album.vala"
	_tmp0_ = self->priv->_artist;
#line 45 "../core/Album.vala"
	result = _tmp0_;
#line 45 "../core/Album.vala"
	return result;
#line 1558 "Album.c"
}


void
noise_album_set_artist (NoiseAlbum* self,
                        const gchar* value)
{
#line 45 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 45 "../core/Album.vala"
	if (g_strcmp0 (value, noise_album_get_artist (self)) != 0) {
#line 1570 "Album.c"
		gchar* _tmp0_;
#line 45 "../core/Album.vala"
		_tmp0_ = g_strdup (value);
#line 45 "../core/Album.vala"
		_g_free0 (self->priv->_artist);
#line 45 "../core/Album.vala"
		self->priv->_artist = _tmp0_;
#line 45 "../core/Album.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_album_properties[NOISE_ALBUM_ARTIST_PROPERTY]);
#line 1580 "Album.c"
	}
}


const gchar*
noise_album_get_name (NoiseAlbum* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../core/Album.vala"
	_tmp0_ = self->priv->_name;
#line 46 "../core/Album.vala"
	result = _tmp0_;
#line 46 "../core/Album.vala"
	return result;
#line 1598 "Album.c"
}


void
noise_album_set_name (NoiseAlbum* self,
                      const gchar* value)
{
#line 46 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 46 "../core/Album.vala"
	if (g_strcmp0 (value, noise_album_get_name (self)) != 0) {
#line 1610 "Album.c"
		gchar* _tmp0_;
#line 46 "../core/Album.vala"
		_tmp0_ = g_strdup (value);
#line 46 "../core/Album.vala"
		_g_free0 (self->priv->_name);
#line 46 "../core/Album.vala"
		self->priv->_name = _tmp0_;
#line 46 "../core/Album.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_album_properties[NOISE_ALBUM_NAME_PROPERTY]);
#line 1620 "Album.c"
	}
}


guint
noise_album_get_year (NoiseAlbum* self)
{
	guint result;
	guint _tmp0_;
#line 47 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 47 "../core/Album.vala"
	_tmp0_ = self->priv->_year;
#line 47 "../core/Album.vala"
	result = _tmp0_;
#line 47 "../core/Album.vala"
	return result;
#line 1638 "Album.c"
}


void
noise_album_set_year (NoiseAlbum* self,
                      guint value)
{
#line 47 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/Album.vala"
	if (noise_album_get_year (self) != value) {
#line 47 "../core/Album.vala"
		self->priv->_year = value;
#line 47 "../core/Album.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_album_properties[NOISE_ALBUM_YEAR_PROPERTY]);
#line 1654 "Album.c"
	}
}


GIcon*
noise_album_get_cover_icon (NoiseAlbum* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 48 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../core/Album.vala"
	_tmp0_ = self->priv->_cover_icon;
#line 48 "../core/Album.vala"
	result = _tmp0_;
#line 48 "../core/Album.vala"
	return result;
#line 1672 "Album.c"
}


void
noise_album_set_cover_icon (NoiseAlbum* self,
                            GIcon* value)
{
#line 48 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 48 "../core/Album.vala"
	if (noise_album_get_cover_icon (self) != value) {
#line 1684 "Album.c"
		GIcon* _tmp0_;
#line 48 "../core/Album.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 48 "../core/Album.vala"
		_g_object_unref0 (self->priv->_cover_icon);
#line 48 "../core/Album.vala"
		self->priv->_cover_icon = _tmp0_;
#line 48 "../core/Album.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_album_properties[NOISE_ALBUM_COVER_ICON_PROPERTY]);
#line 1694 "Album.c"
	}
}


static guint
noise_album_get_n_discs (NoiseAlbum* self)
{
	guint result;
	guint _tmp0_;
#line 51 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 51 "../core/Album.vala"
	_tmp0_ = self->priv->_n_discs;
#line 51 "../core/Album.vala"
	result = _tmp0_;
#line 51 "../core/Album.vala"
	return result;
#line 1712 "Album.c"
}


static void
noise_album_set_n_discs (NoiseAlbum* self,
                         guint value)
{
#line 51 "../core/Album.vala"
	g_return_if_fail (self != NULL);
#line 51 "../core/Album.vala"
	self->priv->_n_discs = value;
#line 1724 "Album.c"
}


gboolean
noise_album_get_is_empty (NoiseAlbum* self)
{
	gboolean result;
	GeeHashSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 102 "../core/Album.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 102 "../core/Album.vala"
	_tmp0_ = self->priv->media;
#line 102 "../core/Album.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 102 "../core/Album.vala"
	_tmp2_ = _tmp1_;
#line 102 "../core/Album.vala"
	result = _tmp2_ < 1;
#line 102 "../core/Album.vala"
	return result;
#line 1747 "Album.c"
}


static void
_noise_album___lambda9_ (NoiseAlbum* self)
{
#line 97 "../core/Album.vala"
	_g_object_unref0 (self->priv->cover_pixbuf);
#line 97 "../core/Album.vala"
	self->priv->cover_pixbuf = NULL;
#line 1758 "Album.c"
}


static void
__noise_album___lambda9__g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
#line 96 "../core/Album.vala"
	_noise_album___lambda9_ ((NoiseAlbum*) self);
#line 1769 "Album.c"
}


static GObject *
noise_album_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseAlbum * self;
#line 95 "../core/Album.vala"
	parent_class = G_OBJECT_CLASS (noise_album_parent_class);
#line 95 "../core/Album.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 95 "../core/Album.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 96 "../core/Album.vala"
	g_signal_connect_object ((GObject*) self, "notify::cover-icon", (GCallback) __noise_album___lambda9__g_object_notify, self, 0);
#line 95 "../core/Album.vala"
	return obj;
#line 1791 "Album.c"
}


static void
noise_album_class_init (NoiseAlbumClass * klass)
{
#line 42 "../core/Album.vala"
	noise_album_parent_class = g_type_class_peek_parent (klass);
#line 42 "../core/Album.vala"
	g_type_class_adjust_private_offset (klass, &NoiseAlbum_private_offset);
#line 42 "../core/Album.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_album_get_property;
#line 42 "../core/Album.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_album_set_property;
#line 42 "../core/Album.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_album_constructor;
#line 42 "../core/Album.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_album_finalize;
#line 42 "../core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_ARTIST_PROPERTY, noise_album_properties[NOISE_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_NAME_PROPERTY, noise_album_properties[NOISE_ALBUM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_YEAR_PROPERTY, noise_album_properties[NOISE_ALBUM_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 42 "../core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_COVER_ICON_PROPERTY, noise_album_properties[NOISE_ALBUM_COVER_ICON_PROPERTY] = g_param_spec_object ("cover-icon", "cover-icon", "cover-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 42 "../core/Album.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_ALBUM_IS_EMPTY_PROPERTY, noise_album_properties[NOISE_ALBUM_IS_EMPTY_PROPERTY] = g_param_spec_boolean ("is-empty", "is-empty", "is-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 42 "../core/Album.vala"
	noise_album_signals[NOISE_ALBUM_COVER_RENDERED_SIGNAL] = g_signal_new ("cover-rendered", NOISE_TYPE_ALBUM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1822 "Album.c"
}


static void
noise_album_instance_init (NoiseAlbum * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashSet* _tmp2_;
#line 42 "../core/Album.vala"
	self->priv = noise_album_get_instance_private (self);
#line 45 "../core/Album.vala"
	_tmp0_ = g_strdup ("");
#line 45 "../core/Album.vala"
	self->priv->_artist = _tmp0_;
#line 46 "../core/Album.vala"
	_tmp1_ = g_strdup ("");
#line 46 "../core/Album.vala"
	self->priv->_name = _tmp1_;
#line 47 "../core/Album.vala"
	self->priv->_year = (guint) 0;
#line 51 "../core/Album.vala"
	self->priv->_n_discs = (guint) 1;
#line 52 "../core/Album.vala"
	_tmp2_ = gee_hash_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 52 "../core/Album.vala"
	self->priv->media = _tmp2_;
#line 54 "../core/Album.vala"
	self->priv->cover_pixbuf_scale = 1;
#line 1852 "Album.c"
}


static void
noise_album_finalize (GObject * obj)
{
	NoiseAlbum * self;
	GeeHashSet* _tmp0_;
#line 42 "../core/Album.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 57 "../core/Album.vala"
	_tmp0_ = self->priv->media;
#line 57 "../core/Album.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 45 "../core/Album.vala"
	_g_free0 (self->priv->_artist);
#line 46 "../core/Album.vala"
	_g_free0 (self->priv->_name);
#line 48 "../core/Album.vala"
	_g_object_unref0 (self->priv->_cover_icon);
#line 52 "../core/Album.vala"
	_g_object_unref0 (self->priv->media);
#line 53 "../core/Album.vala"
	_g_object_unref0 (self->priv->cover_pixbuf);
#line 42 "../core/Album.vala"
	G_OBJECT_CLASS (noise_album_parent_class)->finalize (obj);
#line 1879 "Album.c"
}


GType
noise_album_get_type (void)
{
	static volatile gsize noise_album_type_id__volatile = 0;
	if (g_once_init_enter (&noise_album_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseAlbumClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_album_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseAlbum), 0, (GInstanceInitFunc) noise_album_instance_init, NULL };
		GType noise_album_type_id;
		noise_album_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseAlbum", &g_define_type_info, 0);
		NoiseAlbum_private_offset = g_type_add_instance_private (noise_album_type_id, sizeof (NoiseAlbumPrivate));
		g_once_init_leave (&noise_album_type_id__volatile, noise_album_type_id);
	}
	return noise_album_type_id__volatile;
}


static void
_vala_noise_album_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	NoiseAlbum * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 42 "../core/Album.vala"
	switch (property_id) {
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_ARTIST_PROPERTY:
#line 42 "../core/Album.vala"
		g_value_set_string (value, noise_album_get_artist (self));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_NAME_PROPERTY:
#line 42 "../core/Album.vala"
		g_value_set_string (value, noise_album_get_name (self));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_YEAR_PROPERTY:
#line 42 "../core/Album.vala"
		g_value_set_uint (value, noise_album_get_year (self));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_COVER_ICON_PROPERTY:
#line 42 "../core/Album.vala"
		g_value_set_object (value, noise_album_get_cover_icon (self));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_IS_EMPTY_PROPERTY:
#line 42 "../core/Album.vala"
		g_value_set_boolean (value, noise_album_get_is_empty (self));
#line 42 "../core/Album.vala"
		break;
#line 1938 "Album.c"
		default:
#line 42 "../core/Album.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../core/Album.vala"
		break;
#line 1944 "Album.c"
	}
}


static void
_vala_noise_album_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	NoiseAlbum * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_ALBUM, NoiseAlbum);
#line 42 "../core/Album.vala"
	switch (property_id) {
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_ARTIST_PROPERTY:
#line 42 "../core/Album.vala"
		noise_album_set_artist (self, g_value_get_string (value));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_NAME_PROPERTY:
#line 42 "../core/Album.vala"
		noise_album_set_name (self, g_value_get_string (value));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_YEAR_PROPERTY:
#line 42 "../core/Album.vala"
		noise_album_set_year (self, g_value_get_uint (value));
#line 42 "../core/Album.vala"
		break;
#line 42 "../core/Album.vala"
		case NOISE_ALBUM_COVER_ICON_PROPERTY:
#line 42 "../core/Album.vala"
		noise_album_set_cover_icon (self, g_value_get_object (value));
#line 42 "../core/Album.vala"
		break;
#line 1983 "Album.c"
		default:
#line 42 "../core/Album.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 42 "../core/Album.vala"
		break;
#line 1989 "Album.c"
	}
}



