/* Device.c generated by valac 0.42.6, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>


#define NOISE_TYPE_DEVICE (noise_device_get_type ())
#define NOISE_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE, NoiseDevice))
#define NOISE_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE))
#define NOISE_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_DEVICE, NoiseDeviceIface))

typedef struct _NoiseDevice NoiseDevice;
typedef struct _NoiseDeviceIface NoiseDeviceIface;

#define NOISE_TYPE_LIBRARY (noise_library_get_type ())
#define NOISE_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY, NoiseLibrary))
#define NOISE_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY, NoiseLibraryClass))
#define NOISE_IS_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY))
#define NOISE_IS_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY))
#define NOISE_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY, NoiseLibraryClass))

typedef struct _NoiseLibrary NoiseLibrary;
typedef struct _NoiseLibraryClass NoiseLibraryClass;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NOISE_DEVICE_INITIALIZED_SIGNAL,
	NOISE_DEVICE_DEVICE_UNMOUNTED_SIGNAL,
	NOISE_DEVICE_INFOBAR_MESSAGE_SIGNAL,
	NOISE_DEVICE_NUM_SIGNALS
};
static guint noise_device_signals[NOISE_DEVICE_NUM_SIGNALS] = {0};

struct _NoiseDeviceIface {
	GTypeInterface parent_iface;
	gboolean (*start_initialization) (NoiseDevice* self);
	void (*finish_initialization) (NoiseDevice* self);
	gchar* (*get_content_type) (NoiseDevice* self);
	gchar* (*get_display_name) (NoiseDevice* self);
	gchar* (*get_empty_device_title) (NoiseDevice* self);
	gchar* (*get_empty_device_description) (NoiseDevice* self);
	void (*set_display_name) (NoiseDevice* self, const gchar* name);
	gchar* (*get_fancy_description) (NoiseDevice* self);
	void (*set_mount) (NoiseDevice* self, GMount* mount);
	GMount* (*get_mount) (NoiseDevice* self);
	gchar* (*get_uri) (NoiseDevice* self);
	void (*set_icon) (NoiseDevice* self, GIcon* icon);
	GIcon* (*get_icon) (NoiseDevice* self);
	guint64 (*get_capacity) (NoiseDevice* self);
	gchar* (*get_fancy_capacity) (NoiseDevice* self);
	guint64 (*get_used_space) (NoiseDevice* self);
	guint64 (*get_free_space) (NoiseDevice* self);
	void (*unmount) (NoiseDevice* self);
	void (*eject) (NoiseDevice* self);
	void (*synchronize) (NoiseDevice* self);
	gboolean (*only_use_custom_view) (NoiseDevice* self);
	GtkWidget* (*get_custom_view) (NoiseDevice* self);
	gboolean (*read_only) (NoiseDevice* self);
	NoiseLibrary* (*get_library) (NoiseDevice* self);
	gchar* (*get_unique_identifier) (NoiseDevice* self);
};



GType noise_library_get_type (void) G_GNUC_CONST;
GType noise_device_get_type (void) G_GNUC_CONST;
gboolean noise_device_start_initialization (NoiseDevice* self);
void noise_device_finish_initialization (NoiseDevice* self);
gchar* noise_device_get_content_type (NoiseDevice* self);
gchar* noise_device_get_display_name (NoiseDevice* self);
gchar* noise_device_get_empty_device_title (NoiseDevice* self);
gchar* noise_device_get_empty_device_description (NoiseDevice* self);
void noise_device_set_display_name (NoiseDevice* self,
                                    const gchar* name);
gchar* noise_device_get_fancy_description (NoiseDevice* self);
void noise_device_set_mount (NoiseDevice* self,
                             GMount* mount);
GMount* noise_device_get_mount (NoiseDevice* self);
gchar* noise_device_get_uri (NoiseDevice* self);
void noise_device_set_icon (NoiseDevice* self,
                            GIcon* icon);
GIcon* noise_device_get_icon (NoiseDevice* self);
guint64 noise_device_get_capacity (NoiseDevice* self);
gchar* noise_device_get_fancy_capacity (NoiseDevice* self);
guint64 noise_device_get_used_space (NoiseDevice* self);
guint64 noise_device_get_free_space (NoiseDevice* self);
void noise_device_unmount (NoiseDevice* self);
void noise_device_eject (NoiseDevice* self);
void noise_device_synchronize (NoiseDevice* self);
gboolean noise_device_only_use_custom_view (NoiseDevice* self);
GtkWidget* noise_device_get_custom_view (NoiseDevice* self);
gboolean noise_device_read_only (NoiseDevice* self);
NoiseLibrary* noise_device_get_library (NoiseDevice* self);
GType noise_media_get_type (void) G_GNUC_CONST;
GeeCollection* noise_device_delete_doubles (NoiseDevice* self,
                                            GeeCollection* source_list,
                                            GeeCollection* to_remove);
const gchar* noise_media_get_title (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gboolean noise_device_will_fit (NoiseDevice* self,
                                GeeCollection* list);
guint64 noise_media_get_file_size (NoiseMedia* self);
gchar* noise_device_get_unique_identifier (NoiseDevice* self);
static gchar* noise_device_real_get_unique_identifier (NoiseDevice* self);
static void g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);


gboolean
noise_device_start_initialization (NoiseDevice* self)
{
#line 36 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->start_initialization (self);
#line 168 "Device.c"
}


void
noise_device_finish_initialization (NoiseDevice* self)
{
#line 37 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 37 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->finish_initialization (self);
#line 179 "Device.c"
}


gchar*
noise_device_get_content_type (NoiseDevice* self)
{
#line 38 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_content_type (self);
#line 190 "Device.c"
}


gchar*
noise_device_get_display_name (NoiseDevice* self)
{
#line 39 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_display_name (self);
#line 201 "Device.c"
}


gchar*
noise_device_get_empty_device_title (NoiseDevice* self)
{
#line 40 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_empty_device_title (self);
#line 212 "Device.c"
}


gchar*
noise_device_get_empty_device_description (NoiseDevice* self)
{
#line 41 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_empty_device_description (self);
#line 223 "Device.c"
}


void
noise_device_set_display_name (NoiseDevice* self,
                               const gchar* name)
{
#line 42 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 42 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->set_display_name (self, name);
#line 235 "Device.c"
}


gchar*
noise_device_get_fancy_description (NoiseDevice* self)
{
#line 43 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_fancy_description (self);
#line 246 "Device.c"
}


void
noise_device_set_mount (NoiseDevice* self,
                        GMount* mount)
{
#line 44 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 44 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->set_mount (self, mount);
#line 258 "Device.c"
}


GMount*
noise_device_get_mount (NoiseDevice* self)
{
#line 45 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_mount (self);
#line 269 "Device.c"
}


gchar*
noise_device_get_uri (NoiseDevice* self)
{
#line 46 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_uri (self);
#line 280 "Device.c"
}


void
noise_device_set_icon (NoiseDevice* self,
                       GIcon* icon)
{
#line 47 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->set_icon (self, icon);
#line 292 "Device.c"
}


GIcon*
noise_device_get_icon (NoiseDevice* self)
{
#line 48 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_icon (self);
#line 303 "Device.c"
}


guint64
noise_device_get_capacity (NoiseDevice* self)
{
#line 49 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 49 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_capacity (self);
#line 314 "Device.c"
}


gchar*
noise_device_get_fancy_capacity (NoiseDevice* self)
{
#line 50 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_fancy_capacity (self);
#line 325 "Device.c"
}


guint64
noise_device_get_used_space (NoiseDevice* self)
{
#line 51 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 51 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_used_space (self);
#line 336 "Device.c"
}


guint64
noise_device_get_free_space (NoiseDevice* self)
{
#line 52 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 52 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_free_space (self);
#line 347 "Device.c"
}


void
noise_device_unmount (NoiseDevice* self)
{
#line 53 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 53 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->unmount (self);
#line 358 "Device.c"
}


void
noise_device_eject (NoiseDevice* self)
{
#line 54 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 54 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->eject (self);
#line 369 "Device.c"
}


void
noise_device_synchronize (NoiseDevice* self)
{
#line 55 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 55 "../core/Devices/Device.vala"
	NOISE_DEVICE_GET_INTERFACE (self)->synchronize (self);
#line 380 "Device.c"
}


gboolean
noise_device_only_use_custom_view (NoiseDevice* self)
{
#line 56 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->only_use_custom_view (self);
#line 391 "Device.c"
}


GtkWidget*
noise_device_get_custom_view (NoiseDevice* self)
{
#line 57 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_custom_view (self);
#line 402 "Device.c"
}


gboolean
noise_device_read_only (NoiseDevice* self)
{
#line 58 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->read_only (self);
#line 413 "Device.c"
}


NoiseLibrary*
noise_device_get_library (NoiseDevice* self)
{
#line 59 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_library (self);
#line 424 "Device.c"
}


GeeCollection*
noise_device_delete_doubles (NoiseDevice* self,
                             GeeCollection* source_list,
                             GeeCollection* to_remove)
{
	GeeCollection* result = NULL;
	GeeLinkedList* new_list = NULL;
	GeeLinkedList* _tmp0_;
#line 61 "../core/Devices/Device.vala"
	g_return_val_if_fail (source_list != NULL, NULL);
#line 61 "../core/Devices/Device.vala"
	g_return_val_if_fail (to_remove != NULL, NULL);
#line 62 "../core/Devices/Device.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 62 "../core/Devices/Device.vala"
	new_list = _tmp0_;
#line 444 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 63 "../core/Devices/Device.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) source_list);
#line 63 "../core/Devices/Device.vala"
		_m_it = _tmp1_;
#line 63 "../core/Devices/Device.vala"
		while (TRUE) {
#line 454 "Device.c"
			GeeIterator* _tmp2_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			NoiseMedia* _tmp5_;
#line 63 "../core/Devices/Device.vala"
			_tmp2_ = _m_it;
#line 63 "../core/Devices/Device.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 63 "../core/Devices/Device.vala"
				break;
#line 466 "Device.c"
			}
#line 63 "../core/Devices/Device.vala"
			_tmp3_ = _m_it;
#line 63 "../core/Devices/Device.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 63 "../core/Devices/Device.vala"
			m = (NoiseMedia*) _tmp4_;
#line 64 "../core/Devices/Device.vala"
			_tmp5_ = m;
#line 64 "../core/Devices/Device.vala"
			if (_tmp5_ != NULL) {
#line 478 "Device.c"
				gboolean needed = FALSE;
				gboolean _tmp77_;
#line 65 "../core/Devices/Device.vala"
				needed = TRUE;
#line 483 "Device.c"
				{
					GeeIterator* _med_it = NULL;
					GeeIterator* _tmp6_;
#line 66 "../core/Devices/Device.vala"
					_tmp6_ = gee_iterable_iterator ((GeeIterable*) to_remove);
#line 66 "../core/Devices/Device.vala"
					_med_it = _tmp6_;
#line 66 "../core/Devices/Device.vala"
					while (TRUE) {
#line 493 "Device.c"
						GeeIterator* _tmp7_;
						NoiseMedia* med = NULL;
						GeeIterator* _tmp8_;
						gpointer _tmp9_;
						gboolean _tmp10_ = FALSE;
						NoiseMedia* _tmp11_;
#line 66 "../core/Devices/Device.vala"
						_tmp7_ = _med_it;
#line 66 "../core/Devices/Device.vala"
						if (!gee_iterator_next (_tmp7_)) {
#line 66 "../core/Devices/Device.vala"
							break;
#line 506 "Device.c"
						}
#line 66 "../core/Devices/Device.vala"
						_tmp8_ = _med_it;
#line 66 "../core/Devices/Device.vala"
						_tmp9_ = gee_iterator_get (_tmp8_);
#line 66 "../core/Devices/Device.vala"
						med = (NoiseMedia*) _tmp9_;
#line 67 "../core/Devices/Device.vala"
						_tmp11_ = med;
#line 67 "../core/Devices/Device.vala"
						if (_tmp11_ != NULL) {
#line 518 "Device.c"
							NoiseMedia* _tmp12_;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
#line 67 "../core/Devices/Device.vala"
							_tmp12_ = med;
#line 67 "../core/Devices/Device.vala"
							_tmp13_ = noise_media_get_title (_tmp12_);
#line 67 "../core/Devices/Device.vala"
							_tmp14_ = _tmp13_;
#line 67 "../core/Devices/Device.vala"
							_tmp10_ = _tmp14_ != NULL;
#line 530 "Device.c"
						} else {
#line 67 "../core/Devices/Device.vala"
							_tmp10_ = FALSE;
#line 534 "Device.c"
						}
#line 67 "../core/Devices/Device.vala"
						if (_tmp10_) {
#line 538 "Device.c"
							gboolean _tmp15_ = FALSE;
							NoiseMedia* _tmp16_;
							const gchar* _tmp17_;
							const gchar* _tmp18_;
#line 68 "../core/Devices/Device.vala"
							_tmp16_ = med;
#line 68 "../core/Devices/Device.vala"
							_tmp17_ = noise_media_get_album (_tmp16_);
#line 68 "../core/Devices/Device.vala"
							_tmp18_ = _tmp17_;
#line 68 "../core/Devices/Device.vala"
							if (_tmp18_ != NULL) {
#line 551 "Device.c"
								NoiseMedia* _tmp19_;
								const gchar* _tmp20_;
								const gchar* _tmp21_;
#line 68 "../core/Devices/Device.vala"
								_tmp19_ = m;
#line 68 "../core/Devices/Device.vala"
								_tmp20_ = noise_media_get_album (_tmp19_);
#line 68 "../core/Devices/Device.vala"
								_tmp21_ = _tmp20_;
#line 68 "../core/Devices/Device.vala"
								_tmp15_ = _tmp21_ != NULL;
#line 563 "Device.c"
							} else {
#line 68 "../core/Devices/Device.vala"
								_tmp15_ = FALSE;
#line 567 "Device.c"
							}
#line 68 "../core/Devices/Device.vala"
							if (_tmp15_) {
#line 571 "Device.c"
								gboolean _tmp22_ = FALSE;
								gboolean _tmp23_ = FALSE;
								NoiseMedia* _tmp24_;
								const gchar* _tmp25_;
								const gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								NoiseMedia* _tmp29_;
								const gchar* _tmp30_;
								const gchar* _tmp31_;
								gchar* _tmp32_;
								gchar* _tmp33_;
								gboolean _tmp34_;
#line 69 "../core/Devices/Device.vala"
								_tmp24_ = med;
#line 69 "../core/Devices/Device.vala"
								_tmp25_ = noise_media_get_title (_tmp24_);
#line 69 "../core/Devices/Device.vala"
								_tmp26_ = _tmp25_;
#line 69 "../core/Devices/Device.vala"
								_tmp27_ = g_utf8_strdown (_tmp26_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
								_tmp28_ = _tmp27_;
#line 69 "../core/Devices/Device.vala"
								_tmp29_ = m;
#line 69 "../core/Devices/Device.vala"
								_tmp30_ = noise_media_get_title (_tmp29_);
#line 69 "../core/Devices/Device.vala"
								_tmp31_ = _tmp30_;
#line 69 "../core/Devices/Device.vala"
								_tmp32_ = g_utf8_strdown (_tmp31_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
								_tmp33_ = _tmp32_;
#line 69 "../core/Devices/Device.vala"
								_tmp34_ = g_strcmp0 (_tmp28_, _tmp33_) == 0;
#line 69 "../core/Devices/Device.vala"
								_g_free0 (_tmp33_);
#line 69 "../core/Devices/Device.vala"
								_g_free0 (_tmp28_);
#line 69 "../core/Devices/Device.vala"
								if (_tmp34_) {
#line 613 "Device.c"
									NoiseMedia* _tmp35_;
									const gchar* _tmp36_;
									const gchar* _tmp37_;
									gchar* _tmp38_;
									gchar* _tmp39_;
									NoiseMedia* _tmp40_;
									const gchar* _tmp41_;
									const gchar* _tmp42_;
									gchar* _tmp43_;
									gchar* _tmp44_;
#line 69 "../core/Devices/Device.vala"
									_tmp35_ = med;
#line 69 "../core/Devices/Device.vala"
									_tmp36_ = noise_media_get_artist (_tmp35_);
#line 69 "../core/Devices/Device.vala"
									_tmp37_ = _tmp36_;
#line 69 "../core/Devices/Device.vala"
									_tmp38_ = g_utf8_strdown (_tmp37_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp39_ = _tmp38_;
#line 69 "../core/Devices/Device.vala"
									_tmp40_ = m;
#line 69 "../core/Devices/Device.vala"
									_tmp41_ = noise_media_get_artist (_tmp40_);
#line 69 "../core/Devices/Device.vala"
									_tmp42_ = _tmp41_;
#line 69 "../core/Devices/Device.vala"
									_tmp43_ = g_utf8_strdown (_tmp42_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp44_ = _tmp43_;
#line 69 "../core/Devices/Device.vala"
									_tmp23_ = g_strcmp0 (_tmp39_, _tmp44_) == 0;
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp44_);
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp39_);
#line 650 "Device.c"
								} else {
#line 69 "../core/Devices/Device.vala"
									_tmp23_ = FALSE;
#line 654 "Device.c"
								}
#line 69 "../core/Devices/Device.vala"
								if (_tmp23_) {
#line 658 "Device.c"
									NoiseMedia* _tmp45_;
									const gchar* _tmp46_;
									const gchar* _tmp47_;
									gchar* _tmp48_;
									gchar* _tmp49_;
									NoiseMedia* _tmp50_;
									const gchar* _tmp51_;
									const gchar* _tmp52_;
									gchar* _tmp53_;
									gchar* _tmp54_;
#line 69 "../core/Devices/Device.vala"
									_tmp45_ = med;
#line 69 "../core/Devices/Device.vala"
									_tmp46_ = noise_media_get_album (_tmp45_);
#line 69 "../core/Devices/Device.vala"
									_tmp47_ = _tmp46_;
#line 69 "../core/Devices/Device.vala"
									_tmp48_ = g_utf8_strdown (_tmp47_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp49_ = _tmp48_;
#line 69 "../core/Devices/Device.vala"
									_tmp50_ = m;
#line 69 "../core/Devices/Device.vala"
									_tmp51_ = noise_media_get_album (_tmp50_);
#line 69 "../core/Devices/Device.vala"
									_tmp52_ = _tmp51_;
#line 69 "../core/Devices/Device.vala"
									_tmp53_ = g_utf8_strdown (_tmp52_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp54_ = _tmp53_;
#line 69 "../core/Devices/Device.vala"
									_tmp22_ = g_strcmp0 (_tmp49_, _tmp54_) == 0;
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp54_);
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp49_);
#line 695 "Device.c"
								} else {
#line 69 "../core/Devices/Device.vala"
									_tmp22_ = FALSE;
#line 699 "Device.c"
								}
#line 69 "../core/Devices/Device.vala"
								if (_tmp22_) {
#line 70 "../core/Devices/Device.vala"
									needed = FALSE;
#line 71 "../core/Devices/Device.vala"
									_g_object_unref0 (med);
#line 71 "../core/Devices/Device.vala"
									break;
#line 709 "Device.c"
								}
							} else {
								gboolean _tmp55_ = FALSE;
								NoiseMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gchar* _tmp59_;
								gchar* _tmp60_;
								NoiseMedia* _tmp61_;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								gchar* _tmp64_;
								gchar* _tmp65_;
								gboolean _tmp66_;
#line 74 "../core/Devices/Device.vala"
								_tmp56_ = med;
#line 74 "../core/Devices/Device.vala"
								_tmp57_ = noise_media_get_title (_tmp56_);
#line 74 "../core/Devices/Device.vala"
								_tmp58_ = _tmp57_;
#line 74 "../core/Devices/Device.vala"
								_tmp59_ = g_utf8_strdown (_tmp58_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
								_tmp60_ = _tmp59_;
#line 74 "../core/Devices/Device.vala"
								_tmp61_ = m;
#line 74 "../core/Devices/Device.vala"
								_tmp62_ = noise_media_get_title (_tmp61_);
#line 74 "../core/Devices/Device.vala"
								_tmp63_ = _tmp62_;
#line 74 "../core/Devices/Device.vala"
								_tmp64_ = g_utf8_strdown (_tmp63_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
								_tmp65_ = _tmp64_;
#line 74 "../core/Devices/Device.vala"
								_tmp66_ = g_strcmp0 (_tmp60_, _tmp65_) == 0;
#line 74 "../core/Devices/Device.vala"
								_g_free0 (_tmp65_);
#line 74 "../core/Devices/Device.vala"
								_g_free0 (_tmp60_);
#line 74 "../core/Devices/Device.vala"
								if (_tmp66_) {
#line 752 "Device.c"
									NoiseMedia* _tmp67_;
									const gchar* _tmp68_;
									const gchar* _tmp69_;
									gchar* _tmp70_;
									gchar* _tmp71_;
									NoiseMedia* _tmp72_;
									const gchar* _tmp73_;
									const gchar* _tmp74_;
									gchar* _tmp75_;
									gchar* _tmp76_;
#line 74 "../core/Devices/Device.vala"
									_tmp67_ = med;
#line 74 "../core/Devices/Device.vala"
									_tmp68_ = noise_media_get_artist (_tmp67_);
#line 74 "../core/Devices/Device.vala"
									_tmp69_ = _tmp68_;
#line 74 "../core/Devices/Device.vala"
									_tmp70_ = g_utf8_strdown (_tmp69_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
									_tmp71_ = _tmp70_;
#line 74 "../core/Devices/Device.vala"
									_tmp72_ = m;
#line 74 "../core/Devices/Device.vala"
									_tmp73_ = noise_media_get_artist (_tmp72_);
#line 74 "../core/Devices/Device.vala"
									_tmp74_ = _tmp73_;
#line 74 "../core/Devices/Device.vala"
									_tmp75_ = g_utf8_strdown (_tmp74_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
									_tmp76_ = _tmp75_;
#line 74 "../core/Devices/Device.vala"
									_tmp55_ = g_strcmp0 (_tmp71_, _tmp76_) == 0;
#line 74 "../core/Devices/Device.vala"
									_g_free0 (_tmp76_);
#line 74 "../core/Devices/Device.vala"
									_g_free0 (_tmp71_);
#line 789 "Device.c"
								} else {
#line 74 "../core/Devices/Device.vala"
									_tmp55_ = FALSE;
#line 793 "Device.c"
								}
#line 74 "../core/Devices/Device.vala"
								if (_tmp55_) {
#line 75 "../core/Devices/Device.vala"
									needed = FALSE;
#line 76 "../core/Devices/Device.vala"
									_g_object_unref0 (med);
#line 76 "../core/Devices/Device.vala"
									break;
#line 803 "Device.c"
								}
							}
						}
#line 66 "../core/Devices/Device.vala"
						_g_object_unref0 (med);
#line 809 "Device.c"
					}
#line 66 "../core/Devices/Device.vala"
					_g_object_unref0 (_med_it);
#line 813 "Device.c"
				}
#line 81 "../core/Devices/Device.vala"
				_tmp77_ = needed;
#line 81 "../core/Devices/Device.vala"
				if (_tmp77_ == TRUE) {
#line 819 "Device.c"
					GeeLinkedList* _tmp78_;
					NoiseMedia* _tmp79_;
#line 82 "../core/Devices/Device.vala"
					_tmp78_ = new_list;
#line 82 "../core/Devices/Device.vala"
					_tmp79_ = m;
#line 82 "../core/Devices/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp78_, _tmp79_);
#line 828 "Device.c"
				}
			}
#line 63 "../core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 833 "Device.c"
		}
#line 63 "../core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 837 "Device.c"
	}
#line 87 "../core/Devices/Device.vala"
	result = (GeeCollection*) new_list;
#line 87 "../core/Devices/Device.vala"
	return result;
#line 843 "Device.c"
}


gboolean
noise_device_will_fit (NoiseDevice* self,
                       GeeCollection* list)
{
	gboolean result = FALSE;
	guint64 list_size = 0ULL;
	guint64 _tmp8_;
#line 90 "../core/Devices/Device.vala"
	g_return_val_if_fail (list != NULL, FALSE);
#line 91 "../core/Devices/Device.vala"
	list_size = (guint64) 0;
#line 858 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp0_;
#line 92 "../core/Devices/Device.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) list);
#line 92 "../core/Devices/Device.vala"
		_m_it = _tmp0_;
#line 92 "../core/Devices/Device.vala"
		while (TRUE) {
#line 868 "Device.c"
			GeeIterator* _tmp1_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			guint64 _tmp4_;
			NoiseMedia* _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 92 "../core/Devices/Device.vala"
			_tmp1_ = _m_it;
#line 92 "../core/Devices/Device.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 92 "../core/Devices/Device.vala"
				break;
#line 883 "Device.c"
			}
#line 92 "../core/Devices/Device.vala"
			_tmp2_ = _m_it;
#line 92 "../core/Devices/Device.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 92 "../core/Devices/Device.vala"
			m = (NoiseMedia*) _tmp3_;
#line 93 "../core/Devices/Device.vala"
			_tmp4_ = list_size;
#line 93 "../core/Devices/Device.vala"
			_tmp5_ = m;
#line 93 "../core/Devices/Device.vala"
			_tmp6_ = noise_media_get_file_size (_tmp5_);
#line 93 "../core/Devices/Device.vala"
			_tmp7_ = _tmp6_;
#line 93 "../core/Devices/Device.vala"
			list_size = _tmp4_ + _tmp7_;
#line 92 "../core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 903 "Device.c"
		}
#line 92 "../core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 907 "Device.c"
	}
#line 96 "../core/Devices/Device.vala"
	_tmp8_ = list_size;
#line 96 "../core/Devices/Device.vala"
	result = noise_device_get_capacity (self) > _tmp8_;
#line 96 "../core/Devices/Device.vala"
	return result;
#line 915 "Device.c"
}


static gchar*
noise_device_real_get_unique_identifier (NoiseDevice* self)
{
	gchar* result = NULL;
	GMount* m = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
#line 100 "../core/Devices/Device.vala"
	_tmp0_ = noise_device_get_mount (self);
#line 100 "../core/Devices/Device.vala"
	m = _tmp0_;
#line 101 "../core/Devices/Device.vala"
	_tmp1_ = m;
#line 101 "../core/Devices/Device.vala"
	if (_tmp1_ != NULL) {
#line 934 "Device.c"
		gchar* uuid = NULL;
		GMount* _tmp2_;
		gchar* _tmp3_;
		GFile* root = NULL;
		GMount* _tmp4_;
		GFile* _tmp5_;
		gchar* rv = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GFile* _tmp9_;
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
#line 102 "../core/Devices/Device.vala"
		_tmp2_ = m;
#line 102 "../core/Devices/Device.vala"
		_tmp3_ = g_mount_get_uuid (_tmp2_);
#line 102 "../core/Devices/Device.vala"
		uuid = _tmp3_;
#line 103 "../core/Devices/Device.vala"
		_tmp4_ = m;
#line 103 "../core/Devices/Device.vala"
		_tmp5_ = g_mount_get_root (_tmp4_);
#line 103 "../core/Devices/Device.vala"
		root = _tmp5_;
#line 104 "../core/Devices/Device.vala"
		_tmp6_ = g_strdup ("");
#line 104 "../core/Devices/Device.vala"
		rv = _tmp6_;
#line 105 "../core/Devices/Device.vala"
		_tmp7_ = uuid;
#line 105 "../core/Devices/Device.vala"
		g_debug ("Device.vala:105: uuid: %s\n", _tmp7_);
#line 106 "../core/Devices/Device.vala"
		_tmp9_ = root;
#line 106 "../core/Devices/Device.vala"
		if (_tmp9_ != NULL) {
#line 972 "Device.c"
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 106 "../core/Devices/Device.vala"
			_tmp10_ = root;
#line 106 "../core/Devices/Device.vala"
			_tmp11_ = g_file_get_uri (_tmp10_);
#line 106 "../core/Devices/Device.vala"
			_tmp12_ = _tmp11_;
#line 106 "../core/Devices/Device.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 106 "../core/Devices/Device.vala"
			_g_free0 (_tmp12_);
#line 986 "Device.c"
		} else {
#line 106 "../core/Devices/Device.vala"
			_tmp8_ = FALSE;
#line 990 "Device.c"
		}
#line 106 "../core/Devices/Device.vala"
		if (_tmp8_) {
#line 994 "Device.c"
			const gchar* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 107 "../core/Devices/Device.vala"
			_tmp13_ = rv;
#line 107 "../core/Devices/Device.vala"
			_tmp14_ = root;
#line 107 "../core/Devices/Device.vala"
			_tmp15_ = g_file_get_uri (_tmp14_);
#line 107 "../core/Devices/Device.vala"
			_tmp16_ = _tmp15_;
#line 107 "../core/Devices/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 107 "../core/Devices/Device.vala"
			_g_free0 (rv);
#line 107 "../core/Devices/Device.vala"
			rv = _tmp17_;
#line 107 "../core/Devices/Device.vala"
			_g_free0 (_tmp16_);
#line 1016 "Device.c"
		}
#line 109 "../core/Devices/Device.vala"
		_tmp19_ = uuid;
#line 109 "../core/Devices/Device.vala"
		if (_tmp19_ != NULL) {
#line 1022 "Device.c"
			const gchar* _tmp20_;
#line 109 "../core/Devices/Device.vala"
			_tmp20_ = uuid;
#line 109 "../core/Devices/Device.vala"
			_tmp18_ = g_strcmp0 (_tmp20_, "") != 0;
#line 1028 "Device.c"
		} else {
#line 109 "../core/Devices/Device.vala"
			_tmp18_ = FALSE;
#line 1032 "Device.c"
		}
#line 109 "../core/Devices/Device.vala"
		if (_tmp18_) {
#line 1036 "Device.c"
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 110 "../core/Devices/Device.vala"
			_tmp21_ = rv;
#line 110 "../core/Devices/Device.vala"
			_tmp22_ = uuid;
#line 110 "../core/Devices/Device.vala"
			_tmp23_ = g_strconcat ("/", _tmp22_, NULL);
#line 110 "../core/Devices/Device.vala"
			_tmp24_ = _tmp23_;
#line 110 "../core/Devices/Device.vala"
			_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 110 "../core/Devices/Device.vala"
			_g_free0 (rv);
#line 110 "../core/Devices/Device.vala"
			rv = _tmp25_;
#line 110 "../core/Devices/Device.vala"
			_g_free0 (_tmp24_);
#line 1058 "Device.c"
		}
#line 113 "../core/Devices/Device.vala"
		result = rv;
#line 113 "../core/Devices/Device.vala"
		_g_object_unref0 (root);
#line 113 "../core/Devices/Device.vala"
		_g_free0 (uuid);
#line 113 "../core/Devices/Device.vala"
		_g_object_unref0 (m);
#line 113 "../core/Devices/Device.vala"
		return result;
#line 1070 "Device.c"
	} else {
		gchar* _tmp26_;
#line 115 "../core/Devices/Device.vala"
		_tmp26_ = noise_device_get_uri (self);
#line 115 "../core/Devices/Device.vala"
		result = _tmp26_;
#line 115 "../core/Devices/Device.vala"
		_g_object_unref0 (m);
#line 115 "../core/Devices/Device.vala"
		return result;
#line 1081 "Device.c"
	}
#line 99 "../core/Devices/Device.vala"
	_g_object_unref0 (m);
#line 1085 "Device.c"
}


gchar*
noise_device_get_unique_identifier (NoiseDevice* self)
{
#line 99 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../core/Devices/Device.vala"
	return NOISE_DEVICE_GET_INTERFACE (self)->get_unique_identifier (self);
#line 1096 "Device.c"
}


static void
g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_ENUM) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 31 "../core/Devices/Device.vala"
	g_return_if_fail (n_param_values == 3);
#line 31 "../core/Devices/Device.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 31 "../core/Devices/Device.vala"
		data1 = closure->data;
#line 31 "../core/Devices/Device.vala"
		data2 = param_values->data[0].v_pointer;
#line 1122 "Device.c"
	} else {
#line 31 "../core/Devices/Device.vala"
		data1 = param_values->data[0].v_pointer;
#line 31 "../core/Devices/Device.vala"
		data2 = closure->data;
#line 1128 "Device.c"
	}
#line 31 "../core/Devices/Device.vala"
	callback = (GMarshalFunc_VOID__STRING_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 31 "../core/Devices/Device.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 1134 "Device.c"
}


static void
noise_device_default_init (NoiseDeviceIface * iface)
{
#line 31 "../core/Devices/Device.vala"
	noise_device_signals[NOISE_DEVICE_INITIALIZED_SIGNAL] = g_signal_new ("initialized", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_DEVICE);
#line 31 "../core/Devices/Device.vala"
	noise_device_signals[NOISE_DEVICE_DEVICE_UNMOUNTED_SIGNAL] = g_signal_new ("device-unmounted", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../core/Devices/Device.vala"
	noise_device_signals[NOISE_DEVICE_INFOBAR_MESSAGE_SIGNAL] = g_signal_new ("infobar-message", NOISE_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_ENUM, G_TYPE_NONE, 2, G_TYPE_STRING, gtk_message_type_get_type ());
#line 31 "../core/Devices/Device.vala"
	iface->get_unique_identifier = noise_device_real_get_unique_identifier;
#line 1149 "Device.c"
}


GType
noise_device_get_type (void)
{
	static volatile gsize noise_device_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDeviceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_device_type_id;
		noise_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseDevice", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_device_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&noise_device_type_id__volatile, noise_device_type_id);
	}
	return noise_device_type_id__volatile;
}



