/* EqualizerPreset.c generated by valac 0.42.6, the Vala compiler
 * generated from EqualizerPreset.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_EQUALIZER_PRESET (noise_equalizer_preset_get_type ())
#define NOISE_EQUALIZER_PRESET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset))
#define NOISE_EQUALIZER_PRESET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPresetClass))
#define NOISE_IS_EQUALIZER_PRESET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_EQUALIZER_PRESET))
#define NOISE_IS_EQUALIZER_PRESET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_EQUALIZER_PRESET))
#define NOISE_EQUALIZER_PRESET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPresetClass))

typedef struct _NoiseEqualizerPreset NoiseEqualizerPreset;
typedef struct _NoiseEqualizerPresetClass NoiseEqualizerPresetClass;
typedef struct _NoiseEqualizerPresetPrivate NoiseEqualizerPresetPrivate;
enum  {
	NOISE_EQUALIZER_PRESET_0_PROPERTY,
	NOISE_EQUALIZER_PRESET_NAME_PROPERTY,
	NOISE_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY,
	NOISE_EQUALIZER_PRESET_NUM_PROPERTIES
};
static GParamSpec* noise_equalizer_preset_properties[NOISE_EQUALIZER_PRESET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoiseEqualizerPreset {
	GObject parent_instance;
	NoiseEqualizerPresetPrivate * priv;
	GeeArrayList* gains;
};

struct _NoiseEqualizerPresetClass {
	GObjectClass parent_class;
};

struct _NoiseEqualizerPresetPrivate {
	gchar* _name;
	gboolean _is_default;
};


static gint NoiseEqualizerPreset_private_offset;
static gpointer noise_equalizer_preset_parent_class = NULL;

GType noise_equalizer_preset_get_type (void) G_GNUC_CONST;
NoiseEqualizerPreset* noise_equalizer_preset_new_basic (const gchar* name);
NoiseEqualizerPreset* noise_equalizer_preset_construct_basic (GType object_type,
                                                              const gchar* name);
NoiseEqualizerPreset* noise_equalizer_preset_new_with_gains (const gchar* name,
                                                             gint* items,
                                                             int items_length1);
NoiseEqualizerPreset* noise_equalizer_preset_construct_with_gains (GType object_type,
                                                                   const gchar* name,
                                                                   gint* items,
                                                                   int items_length1);
NoiseEqualizerPreset* noise_equalizer_preset_new_from_string (const gchar* data);
NoiseEqualizerPreset* noise_equalizer_preset_construct_from_string (GType object_type,
                                                                    const gchar* data);
gchar* noise_equalizer_preset_to_string (NoiseEqualizerPreset* self);
const gchar* noise_equalizer_preset_get_name (NoiseEqualizerPreset* self);
gint noise_equalizer_preset_get_gain (NoiseEqualizerPreset* self,
                                      gint index);
void noise_equalizer_preset_set_gain (NoiseEqualizerPreset* self,
                                      gint index,
                                      gint val);
NoiseEqualizerPreset* noise_equalizer_preset_new (void);
NoiseEqualizerPreset* noise_equalizer_preset_construct (GType object_type);
void noise_equalizer_preset_set_name (NoiseEqualizerPreset* self,
                                      const gchar* value);
gboolean noise_equalizer_preset_get_is_default (NoiseEqualizerPreset* self);
void noise_equalizer_preset_set_is_default (NoiseEqualizerPreset* self,
                                            gboolean value);
static void noise_equalizer_preset_finalize (GObject * obj);
static void _vala_noise_equalizer_preset_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_equalizer_preset_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
noise_equalizer_preset_get_instance_private (NoiseEqualizerPreset* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseEqualizerPreset_private_offset);
}


NoiseEqualizerPreset*
noise_equalizer_preset_construct_basic (GType object_type,
                                        const gchar* name)
{
	NoiseEqualizerPreset * self = NULL;
#line 37 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 38 "../core/EqualizerPreset.vala"
	self = (NoiseEqualizerPreset*) g_object_new (object_type, "name", name, NULL);
#line 144 "EqualizerPreset.c"
	{
		gint i = 0;
#line 39 "../core/EqualizerPreset.vala"
		i = 0;
#line 149 "EqualizerPreset.c"
		{
			gboolean _tmp0_ = FALSE;
#line 39 "../core/EqualizerPreset.vala"
			_tmp0_ = TRUE;
#line 39 "../core/EqualizerPreset.vala"
			while (TRUE) {
#line 156 "EqualizerPreset.c"
				gint _tmp2_;
				GeeArrayList* _tmp3_;
#line 39 "../core/EqualizerPreset.vala"
				if (!_tmp0_) {
#line 161 "EqualizerPreset.c"
					gint _tmp1_;
#line 39 "../core/EqualizerPreset.vala"
					_tmp1_ = i;
#line 39 "../core/EqualizerPreset.vala"
					i = _tmp1_ + 1;
#line 167 "EqualizerPreset.c"
				}
#line 39 "../core/EqualizerPreset.vala"
				_tmp0_ = FALSE;
#line 39 "../core/EqualizerPreset.vala"
				_tmp2_ = i;
#line 39 "../core/EqualizerPreset.vala"
				if (!(_tmp2_ < 10)) {
#line 39 "../core/EqualizerPreset.vala"
					break;
#line 177 "EqualizerPreset.c"
				}
#line 40 "../core/EqualizerPreset.vala"
				_tmp3_ = self->gains;
#line 40 "../core/EqualizerPreset.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, (gpointer) ((gintptr) 0));
#line 183 "EqualizerPreset.c"
			}
		}
	}
#line 37 "../core/EqualizerPreset.vala"
	return self;
#line 189 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_new_basic (const gchar* name)
{
#line 37 "../core/EqualizerPreset.vala"
	return noise_equalizer_preset_construct_basic (NOISE_TYPE_EQUALIZER_PRESET, name);
#line 198 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_construct_with_gains (GType object_type,
                                             const gchar* name,
                                             gint* items,
                                             int items_length1)
{
	NoiseEqualizerPreset * self = NULL;
#line 44 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 45 "../core/EqualizerPreset.vala"
	self = (NoiseEqualizerPreset*) g_object_new (object_type, "name", name, NULL);
#line 213 "EqualizerPreset.c"
	{
		gint i = 0;
#line 46 "../core/EqualizerPreset.vala"
		i = 0;
#line 218 "EqualizerPreset.c"
		{
			gboolean _tmp0_ = FALSE;
#line 46 "../core/EqualizerPreset.vala"
			_tmp0_ = TRUE;
#line 46 "../core/EqualizerPreset.vala"
			while (TRUE) {
#line 225 "EqualizerPreset.c"
				gint _tmp2_;
				GeeArrayList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 46 "../core/EqualizerPreset.vala"
				if (!_tmp0_) {
#line 232 "EqualizerPreset.c"
					gint _tmp1_;
#line 46 "../core/EqualizerPreset.vala"
					_tmp1_ = i;
#line 46 "../core/EqualizerPreset.vala"
					i = _tmp1_ + 1;
#line 238 "EqualizerPreset.c"
				}
#line 46 "../core/EqualizerPreset.vala"
				_tmp0_ = FALSE;
#line 46 "../core/EqualizerPreset.vala"
				_tmp2_ = i;
#line 46 "../core/EqualizerPreset.vala"
				if (!(_tmp2_ < 10)) {
#line 46 "../core/EqualizerPreset.vala"
					break;
#line 248 "EqualizerPreset.c"
				}
#line 47 "../core/EqualizerPreset.vala"
				_tmp3_ = self->gains;
#line 47 "../core/EqualizerPreset.vala"
				_tmp4_ = i;
#line 47 "../core/EqualizerPreset.vala"
				_tmp5_ = items[_tmp4_];
#line 47 "../core/EqualizerPreset.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, (gpointer) ((gintptr) _tmp5_));
#line 258 "EqualizerPreset.c"
			}
		}
	}
#line 44 "../core/EqualizerPreset.vala"
	return self;
#line 264 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_new_with_gains (const gchar* name,
                                       gint* items,
                                       int items_length1)
{
#line 44 "../core/EqualizerPreset.vala"
	return noise_equalizer_preset_construct_with_gains (NOISE_TYPE_EQUALIZER_PRESET, name, items, items_length1);
#line 275 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_construct_from_string (GType object_type,
                                              const gchar* data)
{
	NoiseEqualizerPreset * self = NULL;
	gchar** vals = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint vals_length1;
	gint _vals_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
#line 51 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 52 "../core/EqualizerPreset.vala"
	_tmp1_ = _tmp0_ = g_strsplit (data, "/", 0);
#line 52 "../core/EqualizerPreset.vala"
	vals = _tmp1_;
#line 52 "../core/EqualizerPreset.vala"
	vals_length1 = _vala_array_length (_tmp0_);
#line 52 "../core/EqualizerPreset.vala"
	_vals_size_ = vals_length1;
#line 53 "../core/EqualizerPreset.vala"
	_tmp2_ = vals;
#line 53 "../core/EqualizerPreset.vala"
	_tmp2__length1 = vals_length1;
#line 53 "../core/EqualizerPreset.vala"
	_tmp3_ = _tmp2_[0];
#line 53 "../core/EqualizerPreset.vala"
	self = (NoiseEqualizerPreset*) g_object_new (object_type, "name", _tmp3_, NULL);
#line 310 "EqualizerPreset.c"
	{
		gint i = 0;
#line 54 "../core/EqualizerPreset.vala"
		i = 1;
#line 315 "EqualizerPreset.c"
		{
			gboolean _tmp4_ = FALSE;
#line 54 "../core/EqualizerPreset.vala"
			_tmp4_ = TRUE;
#line 54 "../core/EqualizerPreset.vala"
			while (TRUE) {
#line 322 "EqualizerPreset.c"
				gint _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				GeeArrayList* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gint _tmp10_;
				const gchar* _tmp11_;
#line 54 "../core/EqualizerPreset.vala"
				if (!_tmp4_) {
#line 333 "EqualizerPreset.c"
					gint _tmp5_;
#line 54 "../core/EqualizerPreset.vala"
					_tmp5_ = i;
#line 54 "../core/EqualizerPreset.vala"
					i = _tmp5_ + 1;
#line 339 "EqualizerPreset.c"
				}
#line 54 "../core/EqualizerPreset.vala"
				_tmp4_ = FALSE;
#line 54 "../core/EqualizerPreset.vala"
				_tmp6_ = i;
#line 54 "../core/EqualizerPreset.vala"
				_tmp7_ = vals;
#line 54 "../core/EqualizerPreset.vala"
				_tmp7__length1 = vals_length1;
#line 54 "../core/EqualizerPreset.vala"
				if (!(_tmp6_ < _tmp7__length1)) {
#line 54 "../core/EqualizerPreset.vala"
					break;
#line 353 "EqualizerPreset.c"
				}
#line 55 "../core/EqualizerPreset.vala"
				_tmp8_ = self->gains;
#line 55 "../core/EqualizerPreset.vala"
				_tmp9_ = vals;
#line 55 "../core/EqualizerPreset.vala"
				_tmp9__length1 = vals_length1;
#line 55 "../core/EqualizerPreset.vala"
				_tmp10_ = i;
#line 55 "../core/EqualizerPreset.vala"
				_tmp11_ = _tmp9_[_tmp10_];
#line 55 "../core/EqualizerPreset.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, (gpointer) ((gintptr) atoi (_tmp11_)));
#line 367 "EqualizerPreset.c"
			}
		}
	}
#line 51 "../core/EqualizerPreset.vala"
	vals = (_vala_array_free (vals, vals_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../core/EqualizerPreset.vala"
	return self;
#line 375 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_new_from_string (const gchar* data)
{
#line 51 "../core/EqualizerPreset.vala"
	return noise_equalizer_preset_construct_from_string (NOISE_TYPE_EQUALIZER_PRESET, data);
#line 384 "EqualizerPreset.c"
}


gchar*
noise_equalizer_preset_to_string (NoiseEqualizerPreset* self)
{
	gchar* result = NULL;
	gchar* str_preset = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
#line 59 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../core/EqualizerPreset.vala"
	_tmp0_ = g_strdup ("");
#line 60 "../core/EqualizerPreset.vala"
	str_preset = _tmp0_;
#line 62 "../core/EqualizerPreset.vala"
	_tmp2_ = self->priv->_name;
#line 62 "../core/EqualizerPreset.vala"
	if (_tmp2_ != NULL) {
#line 406 "EqualizerPreset.c"
		const gchar* _tmp3_;
#line 62 "../core/EqualizerPreset.vala"
		_tmp3_ = self->priv->_name;
#line 62 "../core/EqualizerPreset.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 412 "EqualizerPreset.c"
	} else {
#line 62 "../core/EqualizerPreset.vala"
		_tmp1_ = FALSE;
#line 416 "EqualizerPreset.c"
	}
#line 62 "../core/EqualizerPreset.vala"
	if (_tmp1_) {
#line 420 "EqualizerPreset.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 63 "../core/EqualizerPreset.vala"
		_tmp4_ = self->priv->_name;
#line 63 "../core/EqualizerPreset.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 63 "../core/EqualizerPreset.vala"
		_g_free0 (str_preset);
#line 63 "../core/EqualizerPreset.vala"
		str_preset = _tmp5_;
#line 431 "EqualizerPreset.c"
		{
			gint i = 0;
#line 64 "../core/EqualizerPreset.vala"
			i = 0;
#line 436 "EqualizerPreset.c"
			{
				gboolean _tmp6_ = FALSE;
#line 64 "../core/EqualizerPreset.vala"
				_tmp6_ = TRUE;
#line 64 "../core/EqualizerPreset.vala"
				while (TRUE) {
#line 443 "EqualizerPreset.c"
					gint _tmp8_;
					const gchar* _tmp9_;
					gint _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
#line 64 "../core/EqualizerPreset.vala"
					if (!_tmp6_) {
#line 454 "EqualizerPreset.c"
						gint _tmp7_;
#line 64 "../core/EqualizerPreset.vala"
						_tmp7_ = i;
#line 64 "../core/EqualizerPreset.vala"
						i = _tmp7_ + 1;
#line 460 "EqualizerPreset.c"
					}
#line 64 "../core/EqualizerPreset.vala"
					_tmp6_ = FALSE;
#line 64 "../core/EqualizerPreset.vala"
					_tmp8_ = i;
#line 64 "../core/EqualizerPreset.vala"
					if (!(_tmp8_ < 10)) {
#line 64 "../core/EqualizerPreset.vala"
						break;
#line 470 "EqualizerPreset.c"
					}
#line 65 "../core/EqualizerPreset.vala"
					_tmp9_ = str_preset;
#line 65 "../core/EqualizerPreset.vala"
					_tmp10_ = i;
#line 65 "../core/EqualizerPreset.vala"
					_tmp11_ = g_strdup_printf ("%i", noise_equalizer_preset_get_gain (self, _tmp10_));
#line 65 "../core/EqualizerPreset.vala"
					_tmp12_ = _tmp11_;
#line 65 "../core/EqualizerPreset.vala"
					_tmp13_ = g_strconcat ("/", _tmp12_, NULL);
#line 65 "../core/EqualizerPreset.vala"
					_tmp14_ = _tmp13_;
#line 65 "../core/EqualizerPreset.vala"
					_tmp15_ = g_strconcat (_tmp9_, _tmp14_, NULL);
#line 65 "../core/EqualizerPreset.vala"
					_g_free0 (str_preset);
#line 65 "../core/EqualizerPreset.vala"
					str_preset = _tmp15_;
#line 65 "../core/EqualizerPreset.vala"
					_g_free0 (_tmp14_);
#line 65 "../core/EqualizerPreset.vala"
					_g_free0 (_tmp12_);
#line 494 "EqualizerPreset.c"
				}
			}
		}
	}
#line 69 "../core/EqualizerPreset.vala"
	result = str_preset;
#line 69 "../core/EqualizerPreset.vala"
	return result;
#line 503 "EqualizerPreset.c"
}


void
noise_equalizer_preset_set_gain (NoiseEqualizerPreset* self,
                                 gint index,
                                 gint val)
{
	GeeArrayList* _tmp0_;
#line 72 "../core/EqualizerPreset.vala"
	g_return_if_fail (self != NULL);
#line 73 "../core/EqualizerPreset.vala"
	if (index > 9) {
#line 74 "../core/EqualizerPreset.vala"
		return;
#line 519 "EqualizerPreset.c"
	}
#line 77 "../core/EqualizerPreset.vala"
	_tmp0_ = self->gains;
#line 77 "../core/EqualizerPreset.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp0_, index, (gpointer) ((gintptr) val));
#line 525 "EqualizerPreset.c"
}


gint
noise_equalizer_preset_get_gain (NoiseEqualizerPreset* self,
                                 gint index)
{
	gint result = 0;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
#line 80 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 81 "../core/EqualizerPreset.vala"
	_tmp0_ = self->gains;
#line 81 "../core/EqualizerPreset.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, index);
#line 81 "../core/EqualizerPreset.vala"
	result = (gint) ((gintptr) _tmp1_);
#line 81 "../core/EqualizerPreset.vala"
	return result;
#line 546 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_construct (GType object_type)
{
	NoiseEqualizerPreset * self = NULL;
#line 31 "../core/EqualizerPreset.vala"
	self = (NoiseEqualizerPreset*) g_object_new (object_type, NULL);
#line 31 "../core/EqualizerPreset.vala"
	return self;
#line 558 "EqualizerPreset.c"
}


NoiseEqualizerPreset*
noise_equalizer_preset_new (void)
{
#line 31 "../core/EqualizerPreset.vala"
	return noise_equalizer_preset_construct (NOISE_TYPE_EQUALIZER_PRESET);
#line 567 "EqualizerPreset.c"
}


const gchar*
noise_equalizer_preset_get_name (NoiseEqualizerPreset* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/EqualizerPreset.vala"
	_tmp0_ = self->priv->_name;
#line 32 "../core/EqualizerPreset.vala"
	result = _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
	return result;
#line 584 "EqualizerPreset.c"
}


void
noise_equalizer_preset_set_name (NoiseEqualizerPreset* self,
                                 const gchar* value)
{
#line 32 "../core/EqualizerPreset.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/EqualizerPreset.vala"
	if (g_strcmp0 (value, noise_equalizer_preset_get_name (self)) != 0) {
#line 596 "EqualizerPreset.c"
		gchar* _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../core/EqualizerPreset.vala"
		_g_free0 (self->priv->_name);
#line 32 "../core/EqualizerPreset.vala"
		self->priv->_name = _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_equalizer_preset_properties[NOISE_EQUALIZER_PRESET_NAME_PROPERTY]);
#line 606 "EqualizerPreset.c"
	}
}


gboolean
noise_equalizer_preset_get_is_default (NoiseEqualizerPreset* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 35 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../core/EqualizerPreset.vala"
	_tmp0_ = self->priv->_is_default;
#line 35 "../core/EqualizerPreset.vala"
	result = _tmp0_;
#line 35 "../core/EqualizerPreset.vala"
	return result;
#line 624 "EqualizerPreset.c"
}


void
noise_equalizer_preset_set_is_default (NoiseEqualizerPreset* self,
                                       gboolean value)
{
#line 35 "../core/EqualizerPreset.vala"
	g_return_if_fail (self != NULL);
#line 35 "../core/EqualizerPreset.vala"
	if (noise_equalizer_preset_get_is_default (self) != value) {
#line 35 "../core/EqualizerPreset.vala"
		self->priv->_is_default = value;
#line 35 "../core/EqualizerPreset.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_equalizer_preset_properties[NOISE_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY]);
#line 640 "EqualizerPreset.c"
	}
}


static void
noise_equalizer_preset_class_init (NoiseEqualizerPresetClass * klass)
{
#line 31 "../core/EqualizerPreset.vala"
	noise_equalizer_preset_parent_class = g_type_class_peek_parent (klass);
#line 31 "../core/EqualizerPreset.vala"
	g_type_class_adjust_private_offset (klass, &NoiseEqualizerPreset_private_offset);
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_equalizer_preset_get_property;
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_equalizer_preset_set_property;
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_equalizer_preset_finalize;
#line 31 "../core/EqualizerPreset.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_EQUALIZER_PRESET_NAME_PROPERTY, noise_equalizer_preset_properties[NOISE_EQUALIZER_PRESET_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 31 "../core/EqualizerPreset.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY, noise_equalizer_preset_properties[NOISE_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 662 "EqualizerPreset.c"
}


static void
noise_equalizer_preset_instance_init (NoiseEqualizerPreset * self)
{
	GeeArrayList* _tmp0_;
#line 31 "../core/EqualizerPreset.vala"
	self->priv = noise_equalizer_preset_get_instance_private (self);
#line 33 "../core/EqualizerPreset.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 33 "../core/EqualizerPreset.vala"
	self->gains = _tmp0_;
#line 35 "../core/EqualizerPreset.vala"
	self->priv->_is_default = FALSE;
#line 678 "EqualizerPreset.c"
}


static void
noise_equalizer_preset_finalize (GObject * obj)
{
	NoiseEqualizerPreset * self;
#line 31 "../core/EqualizerPreset.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset);
#line 32 "../core/EqualizerPreset.vala"
	_g_free0 (self->priv->_name);
#line 33 "../core/EqualizerPreset.vala"
	_g_object_unref0 (self->gains);
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (noise_equalizer_preset_parent_class)->finalize (obj);
#line 694 "EqualizerPreset.c"
}


GType
noise_equalizer_preset_get_type (void)
{
	static volatile gsize noise_equalizer_preset_type_id__volatile = 0;
	if (g_once_init_enter (&noise_equalizer_preset_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseEqualizerPresetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_equalizer_preset_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseEqualizerPreset), 0, (GInstanceInitFunc) noise_equalizer_preset_instance_init, NULL };
		GType noise_equalizer_preset_type_id;
		noise_equalizer_preset_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseEqualizerPreset", &g_define_type_info, 0);
		NoiseEqualizerPreset_private_offset = g_type_add_instance_private (noise_equalizer_preset_type_id, sizeof (NoiseEqualizerPresetPrivate));
		g_once_init_leave (&noise_equalizer_preset_type_id__volatile, noise_equalizer_preset_type_id);
	}
	return noise_equalizer_preset_type_id__volatile;
}


static void
_vala_noise_equalizer_preset_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoiseEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset);
#line 31 "../core/EqualizerPreset.vala"
	switch (property_id) {
#line 31 "../core/EqualizerPreset.vala"
		case NOISE_EQUALIZER_PRESET_NAME_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		g_value_set_string (value, noise_equalizer_preset_get_name (self));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 31 "../core/EqualizerPreset.vala"
		case NOISE_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		g_value_set_boolean (value, noise_equalizer_preset_get_is_default (self));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 735 "EqualizerPreset.c"
		default:
#line 31 "../core/EqualizerPreset.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 741 "EqualizerPreset.c"
	}
}


static void
_vala_noise_equalizer_preset_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoiseEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset);
#line 31 "../core/EqualizerPreset.vala"
	switch (property_id) {
#line 31 "../core/EqualizerPreset.vala"
		case NOISE_EQUALIZER_PRESET_NAME_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		noise_equalizer_preset_set_name (self, g_value_get_string (value));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 31 "../core/EqualizerPreset.vala"
		case NOISE_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		noise_equalizer_preset_set_is_default (self, g_value_get_boolean (value));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 768 "EqualizerPreset.c"
		default:
#line 31 "../core/EqualizerPreset.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 774 "EqualizerPreset.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



