/* Pipeline.c generated by valac 0.42.6, the Vala compiler
 * generated from Pipeline.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>


#define NOISE_TYPE_PIPELINE (noise_pipeline_get_type ())
#define NOISE_PIPELINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PIPELINE, NoisePipeline))
#define NOISE_PIPELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PIPELINE, NoisePipelineClass))
#define NOISE_IS_PIPELINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PIPELINE))
#define NOISE_IS_PIPELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PIPELINE))
#define NOISE_PIPELINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PIPELINE, NoisePipelineClass))

typedef struct _NoisePipeline NoisePipeline;
typedef struct _NoisePipelineClass NoisePipelineClass;
typedef struct _NoisePipelinePrivate NoisePipelinePrivate;

#define NOISE_TYPE_EQUALIZER (noise_equalizer_get_type ())
#define NOISE_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_EQUALIZER, NoiseEqualizer))
#define NOISE_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_EQUALIZER, NoiseEqualizerClass))
#define NOISE_IS_EQUALIZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_EQUALIZER))
#define NOISE_IS_EQUALIZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_EQUALIZER))
#define NOISE_EQUALIZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_EQUALIZER, NoiseEqualizerClass))

typedef struct _NoiseEqualizer NoiseEqualizer;
typedef struct _NoiseEqualizerClass NoiseEqualizerClass;
enum  {
	NOISE_PIPELINE_0_PROPERTY,
	NOISE_PIPELINE_NUM_PROPERTIES
};
static GParamSpec* noise_pipeline_properties[NOISE_PIPELINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NoiseEqualizerPrivate NoiseEqualizerPrivate;

struct _NoisePipeline {
	GObject parent_instance;
	NoisePipelinePrivate * priv;
	GstPipeline* pipe;
	NoiseEqualizer* eq;
	GstBus* bus;
	GstPad* pad;
	GstElement* audiosink;
	GstElement* audiosinkqueue;
	GstElement* eq_audioconvert;
	GstElement* eq_audioconvert2;
	GstElement* playbin;
	GstElement* audiotee;
	GstElement* audiobin;
	GstElement* preamp;
};

struct _NoisePipelineClass {
	GObjectClass parent_class;
};

struct _NoiseEqualizer {
	GObject parent_instance;
	NoiseEqualizerPrivate * priv;
	GstElement* element;
};

struct _NoiseEqualizerClass {
	GObjectClass parent_class;
};


static gpointer noise_pipeline_parent_class = NULL;

GType noise_pipeline_get_type (void) G_GNUC_CONST;
GType noise_equalizer_get_type (void) G_GNUC_CONST;
NoisePipeline* noise_pipeline_new (void);
NoisePipeline* noise_pipeline_construct (GType object_type);
NoiseEqualizer* noise_equalizer_new (void);
NoiseEqualizer* noise_equalizer_construct (GType object_type);
void noise_pipeline_enableEqualizer (NoisePipeline* self);
void noise_pipeline_disableEqualizer (NoisePipeline* self);
static void noise_pipeline_finalize (GObject * obj);


NoisePipeline*
noise_pipeline_construct (GType object_type)
{
	NoisePipeline * self = NULL;
	GstPipeline* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GstBin* _tmp3_;
	GstElement* _tmp4_;
	GstElement* _tmp5_;
	NoiseEqualizer* _tmp6_;
	NoiseEqualizer* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp18_;
	GstElement* _tmp19_;
	GstElement* _tmp20_;
	GstElement* _tmp21_;
	GstElement* _tmp22_;
	GstElement* _tmp23_;
	GstPad* _tmp24_;
	GstPad* _tmp25_;
	GstGhostPad* _tmp26_;
	GstGhostPad* _tmp27_;
	NoiseEqualizer* _tmp28_;
	GstElement* _tmp29_;
	GstElement* _tmp39_;
	GstElement* _tmp40_;
	GstElement* _tmp41_;
	GstBus* _tmp42_;
	GstPad* sinkpad = NULL;
	GstElement* _tmp43_;
	GstPad* _tmp44_;
	GstElement* _tmp45_;
	GstPad* _tmp46_;
	GstElement* _tmp47_;
	GstPad* _tmp48_;
	GstPad* _tmp49_;
#line 46 "../core/GStreamer/Pipeline.vala"
	self = (NoisePipeline*) g_object_new (object_type, NULL);
#line 48 "../core/GStreamer/Pipeline.vala"
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("pipeline");
#line 48 "../core/GStreamer/Pipeline.vala"
	g_object_ref_sink (_tmp0_);
#line 48 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->pipe);
#line 48 "../core/GStreamer/Pipeline.vala"
	self->pipe = _tmp0_;
#line 49 "../core/GStreamer/Pipeline.vala"
	_tmp1_ = gst_element_factory_make ("playbin", "play");
#line 49 "../core/GStreamer/Pipeline.vala"
	if (_tmp1_ != NULL) {
#line 49 "../core/GStreamer/Pipeline.vala"
		g_object_ref_sink (_tmp1_);
#line 165 "Pipeline.c"
	}
#line 49 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->playbin);
#line 49 "../core/GStreamer/Pipeline.vala"
	self->playbin = _tmp1_;
#line 51 "../core/GStreamer/Pipeline.vala"
	_tmp2_ = gst_element_factory_make ("autoaudiosink", "audio-sink");
#line 51 "../core/GStreamer/Pipeline.vala"
	if (_tmp2_ != NULL) {
#line 51 "../core/GStreamer/Pipeline.vala"
		g_object_ref_sink (_tmp2_);
#line 177 "Pipeline.c"
	}
#line 51 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiosink);
#line 51 "../core/GStreamer/Pipeline.vala"
	self->audiosink = _tmp2_;
#line 53 "../core/GStreamer/Pipeline.vala"
	_tmp3_ = (GstBin*) gst_bin_new ("audiobin");
#line 53 "../core/GStreamer/Pipeline.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiobin);
#line 53 "../core/GStreamer/Pipeline.vala"
	self->audiobin = (GstElement*) _tmp3_;
#line 55 "../core/GStreamer/Pipeline.vala"
	_tmp4_ = gst_element_factory_make ("tee", NULL);
#line 55 "../core/GStreamer/Pipeline.vala"
	if (_tmp4_ != NULL) {
#line 55 "../core/GStreamer/Pipeline.vala"
		g_object_ref_sink (_tmp4_);
#line 197 "Pipeline.c"
	}
#line 55 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiotee);
#line 55 "../core/GStreamer/Pipeline.vala"
	self->audiotee = _tmp4_;
#line 56 "../core/GStreamer/Pipeline.vala"
	_tmp5_ = gst_element_factory_make ("queue", NULL);
#line 56 "../core/GStreamer/Pipeline.vala"
	if (_tmp5_ != NULL) {
#line 56 "../core/GStreamer/Pipeline.vala"
		g_object_ref_sink (_tmp5_);
#line 209 "Pipeline.c"
	}
#line 56 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiosinkqueue);
#line 56 "../core/GStreamer/Pipeline.vala"
	self->audiosinkqueue = _tmp5_;
#line 58 "../core/GStreamer/Pipeline.vala"
	_tmp6_ = noise_equalizer_new ();
#line 58 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->eq);
#line 58 "../core/GStreamer/Pipeline.vala"
	self->eq = _tmp6_;
#line 59 "../core/GStreamer/Pipeline.vala"
	_tmp7_ = self->eq;
#line 59 "../core/GStreamer/Pipeline.vala"
	_tmp8_ = _tmp7_->element;
#line 59 "../core/GStreamer/Pipeline.vala"
	if (_tmp8_ != NULL) {
#line 227 "Pipeline.c"
		GstElement* _tmp9_;
		GstElement* _tmp10_;
		GstElement* _tmp11_;
		GstElement* _tmp12_;
		NoiseEqualizer* _tmp13_;
		GstElement* _tmp14_;
		GstElement* _tmp15_;
		GstElement* _tmp16_;
		GstElement* _tmp17_;
#line 60 "../core/GStreamer/Pipeline.vala"
		_tmp9_ = gst_element_factory_make ("audioconvert", NULL);
#line 60 "../core/GStreamer/Pipeline.vala"
		if (_tmp9_ != NULL) {
#line 60 "../core/GStreamer/Pipeline.vala"
			g_object_ref_sink (_tmp9_);
#line 243 "Pipeline.c"
		}
#line 60 "../core/GStreamer/Pipeline.vala"
		_g_object_unref0 (self->eq_audioconvert);
#line 60 "../core/GStreamer/Pipeline.vala"
		self->eq_audioconvert = _tmp9_;
#line 61 "../core/GStreamer/Pipeline.vala"
		_tmp10_ = gst_element_factory_make ("audioconvert", NULL);
#line 61 "../core/GStreamer/Pipeline.vala"
		if (_tmp10_ != NULL) {
#line 61 "../core/GStreamer/Pipeline.vala"
			g_object_ref_sink (_tmp10_);
#line 255 "Pipeline.c"
		}
#line 61 "../core/GStreamer/Pipeline.vala"
		_g_object_unref0 (self->eq_audioconvert2);
#line 61 "../core/GStreamer/Pipeline.vala"
		self->eq_audioconvert2 = _tmp10_;
#line 62 "../core/GStreamer/Pipeline.vala"
		_tmp11_ = gst_element_factory_make ("volume", "preamp");
#line 62 "../core/GStreamer/Pipeline.vala"
		if (_tmp11_ != NULL) {
#line 62 "../core/GStreamer/Pipeline.vala"
			g_object_ref_sink (_tmp11_);
#line 267 "Pipeline.c"
		}
#line 62 "../core/GStreamer/Pipeline.vala"
		_g_object_unref0 (self->preamp);
#line 62 "../core/GStreamer/Pipeline.vala"
		self->preamp = _tmp11_;
#line 64 "../core/GStreamer/Pipeline.vala"
		_tmp12_ = self->audiobin;
#line 64 "../core/GStreamer/Pipeline.vala"
		_tmp13_ = self->eq;
#line 64 "../core/GStreamer/Pipeline.vala"
		_tmp14_ = _tmp13_->element;
#line 64 "../core/GStreamer/Pipeline.vala"
		_tmp15_ = self->eq_audioconvert;
#line 64 "../core/GStreamer/Pipeline.vala"
		_tmp16_ = self->eq_audioconvert2;
#line 64 "../core/GStreamer/Pipeline.vala"
		_tmp17_ = self->preamp;
#line 64 "../core/GStreamer/Pipeline.vala"
		gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gst_bin_get_type (), GstBin), _tmp14_, _tmp15_, _tmp16_, _tmp17_, NULL);
#line 287 "Pipeline.c"
	}
#line 67 "../core/GStreamer/Pipeline.vala"
	_tmp18_ = self->audiobin;
#line 67 "../core/GStreamer/Pipeline.vala"
	_tmp19_ = self->audiotee;
#line 67 "../core/GStreamer/Pipeline.vala"
	_tmp20_ = self->audiosinkqueue;
#line 67 "../core/GStreamer/Pipeline.vala"
	_tmp21_ = self->audiosink;
#line 67 "../core/GStreamer/Pipeline.vala"
	gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gst_bin_get_type (), GstBin), _tmp19_, _tmp20_, _tmp21_, NULL);
#line 69 "../core/GStreamer/Pipeline.vala"
	_tmp22_ = self->audiobin;
#line 69 "../core/GStreamer/Pipeline.vala"
	_tmp23_ = self->audiotee;
#line 69 "../core/GStreamer/Pipeline.vala"
	_tmp24_ = gst_element_get_static_pad (_tmp23_, "sink");
#line 69 "../core/GStreamer/Pipeline.vala"
	_tmp25_ = _tmp24_;
#line 69 "../core/GStreamer/Pipeline.vala"
	_tmp26_ = (GstGhostPad*) gst_ghost_pad_new ("sink", _tmp25_);
#line 69 "../core/GStreamer/Pipeline.vala"
	g_object_ref_sink (_tmp26_);
#line 69 "../core/GStreamer/Pipeline.vala"
	_tmp27_ = _tmp26_;
#line 69 "../core/GStreamer/Pipeline.vala"
	gst_element_add_pad (_tmp22_, (GstPad*) _tmp27_);
#line 69 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (_tmp27_);
#line 69 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (_tmp25_);
#line 71 "../core/GStreamer/Pipeline.vala"
	_tmp28_ = self->eq;
#line 71 "../core/GStreamer/Pipeline.vala"
	_tmp29_ = _tmp28_->element;
#line 71 "../core/GStreamer/Pipeline.vala"
	if (_tmp29_ != NULL) {
#line 325 "Pipeline.c"
		GstElement* _tmp30_;
		GstElement* _tmp31_;
		GstElement* _tmp32_;
		NoiseEqualizer* _tmp33_;
		GstElement* _tmp34_;
		GstElement* _tmp35_;
		GstElement* _tmp36_;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp30_ = self->audiosinkqueue;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp31_ = self->eq_audioconvert;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp32_ = self->preamp;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp33_ = self->eq;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp34_ = _tmp33_->element;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp35_ = self->eq_audioconvert2;
#line 72 "../core/GStreamer/Pipeline.vala"
		_tmp36_ = self->audiosink;
#line 72 "../core/GStreamer/Pipeline.vala"
		gst_element_link_many (_tmp30_, _tmp31_, _tmp32_, _tmp34_, _tmp35_, _tmp36_, NULL);
#line 349 "Pipeline.c"
	} else {
		GstElement* _tmp37_;
		GstElement* _tmp38_;
#line 74 "../core/GStreamer/Pipeline.vala"
		_tmp37_ = self->audiosinkqueue;
#line 74 "../core/GStreamer/Pipeline.vala"
		_tmp38_ = self->audiosink;
#line 74 "../core/GStreamer/Pipeline.vala"
		gst_element_link_many (_tmp37_, _tmp38_, NULL);
#line 359 "Pipeline.c"
	}
#line 77 "../core/GStreamer/Pipeline.vala"
	_tmp39_ = self->playbin;
#line 77 "../core/GStreamer/Pipeline.vala"
	_tmp40_ = self->audiobin;
#line 77 "../core/GStreamer/Pipeline.vala"
	g_object_set ((GObject*) _tmp39_, "audio-sink", _tmp40_, NULL);
#line 78 "../core/GStreamer/Pipeline.vala"
	_tmp41_ = self->playbin;
#line 78 "../core/GStreamer/Pipeline.vala"
	_tmp42_ = gst_element_get_bus (_tmp41_);
#line 78 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->bus);
#line 78 "../core/GStreamer/Pipeline.vala"
	self->bus = _tmp42_;
#line 81 "../core/GStreamer/Pipeline.vala"
	_tmp43_ = self->audiosinkqueue;
#line 81 "../core/GStreamer/Pipeline.vala"
	_tmp44_ = gst_element_get_static_pad (_tmp43_, "sink");
#line 81 "../core/GStreamer/Pipeline.vala"
	sinkpad = _tmp44_;
#line 82 "../core/GStreamer/Pipeline.vala"
	_tmp45_ = self->audiotee;
#line 82 "../core/GStreamer/Pipeline.vala"
	_tmp46_ = gst_element_get_request_pad (_tmp45_, "src_%u");
#line 82 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->pad);
#line 82 "../core/GStreamer/Pipeline.vala"
	self->pad = _tmp46_;
#line 83 "../core/GStreamer/Pipeline.vala"
	_tmp47_ = self->audiotee;
#line 83 "../core/GStreamer/Pipeline.vala"
	_tmp48_ = self->pad;
#line 83 "../core/GStreamer/Pipeline.vala"
	g_object_set ((GObject*) _tmp47_, "alloc-pad", _tmp48_, NULL);
#line 84 "../core/GStreamer/Pipeline.vala"
	_tmp49_ = self->pad;
#line 84 "../core/GStreamer/Pipeline.vala"
	gst_pad_link_full (_tmp49_, sinkpad, GST_PAD_LINK_CHECK_DEFAULT);
#line 46 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (sinkpad);
#line 46 "../core/GStreamer/Pipeline.vala"
	return self;
#line 403 "Pipeline.c"
}


NoisePipeline*
noise_pipeline_new (void)
{
#line 46 "../core/GStreamer/Pipeline.vala"
	return noise_pipeline_construct (NOISE_TYPE_PIPELINE);
#line 412 "Pipeline.c"
}


void
noise_pipeline_enableEqualizer (NoisePipeline* self)
{
	NoiseEqualizer* _tmp0_;
	GstElement* _tmp1_;
#line 87 "../core/GStreamer/Pipeline.vala"
	g_return_if_fail (self != NULL);
#line 88 "../core/GStreamer/Pipeline.vala"
	_tmp0_ = self->eq;
#line 88 "../core/GStreamer/Pipeline.vala"
	_tmp1_ = _tmp0_->element;
#line 88 "../core/GStreamer/Pipeline.vala"
	if (_tmp1_ != NULL) {
#line 429 "Pipeline.c"
		GstElement* _tmp2_;
		GstElement* _tmp3_;
		GstElement* _tmp4_;
		GstElement* _tmp5_;
		GstElement* _tmp6_;
		NoiseEqualizer* _tmp7_;
		GstElement* _tmp8_;
		GstElement* _tmp9_;
		GstElement* _tmp10_;
#line 89 "../core/GStreamer/Pipeline.vala"
		_tmp2_ = self->audiosinkqueue;
#line 89 "../core/GStreamer/Pipeline.vala"
		_tmp3_ = self->audiosink;
#line 89 "../core/GStreamer/Pipeline.vala"
		gst_element_unlink (_tmp2_, _tmp3_);
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp4_ = self->audiosinkqueue;
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp5_ = self->eq_audioconvert;
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp6_ = self->preamp;
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp7_ = self->eq;
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp8_ = _tmp7_->element;
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp9_ = self->eq_audioconvert2;
#line 90 "../core/GStreamer/Pipeline.vala"
		_tmp10_ = self->audiosink;
#line 90 "../core/GStreamer/Pipeline.vala"
		gst_element_link_many (_tmp4_, _tmp5_, _tmp6_, _tmp8_, _tmp9_, _tmp10_, NULL);
#line 461 "Pipeline.c"
	}
}


void
noise_pipeline_disableEqualizer (NoisePipeline* self)
{
	NoiseEqualizer* _tmp0_;
	GstElement* _tmp1_;
#line 94 "../core/GStreamer/Pipeline.vala"
	g_return_if_fail (self != NULL);
#line 95 "../core/GStreamer/Pipeline.vala"
	_tmp0_ = self->eq;
#line 95 "../core/GStreamer/Pipeline.vala"
	_tmp1_ = _tmp0_->element;
#line 95 "../core/GStreamer/Pipeline.vala"
	if (_tmp1_ != NULL) {
#line 479 "Pipeline.c"
		GstElement* _tmp2_;
		GstElement* _tmp3_;
		GstElement* _tmp4_;
		GstElement* _tmp5_;
		GstElement* _tmp6_;
		NoiseEqualizer* _tmp7_;
		GstElement* _tmp8_;
		GstElement* _tmp9_;
		GstElement* _tmp10_;
		GstElement* _tmp11_;
		GstElement* _tmp12_;
		GstElement* _tmp13_;
		GstElement* _tmp14_;
#line 96 "../core/GStreamer/Pipeline.vala"
		_tmp2_ = self->audiosinkqueue;
#line 96 "../core/GStreamer/Pipeline.vala"
		_tmp3_ = self->eq_audioconvert;
#line 96 "../core/GStreamer/Pipeline.vala"
		gst_element_unlink (_tmp2_, _tmp3_);
#line 97 "../core/GStreamer/Pipeline.vala"
		_tmp4_ = self->audiosinkqueue;
#line 97 "../core/GStreamer/Pipeline.vala"
		_tmp5_ = self->preamp;
#line 97 "../core/GStreamer/Pipeline.vala"
		gst_element_unlink (_tmp4_, _tmp5_);
#line 98 "../core/GStreamer/Pipeline.vala"
		_tmp6_ = self->audiosinkqueue;
#line 98 "../core/GStreamer/Pipeline.vala"
		_tmp7_ = self->eq;
#line 98 "../core/GStreamer/Pipeline.vala"
		_tmp8_ = _tmp7_->element;
#line 98 "../core/GStreamer/Pipeline.vala"
		gst_element_unlink (_tmp6_, _tmp8_);
#line 99 "../core/GStreamer/Pipeline.vala"
		_tmp9_ = self->audiosinkqueue;
#line 99 "../core/GStreamer/Pipeline.vala"
		_tmp10_ = self->eq_audioconvert2;
#line 99 "../core/GStreamer/Pipeline.vala"
		gst_element_unlink (_tmp9_, _tmp10_);
#line 100 "../core/GStreamer/Pipeline.vala"
		_tmp11_ = self->audiosinkqueue;
#line 100 "../core/GStreamer/Pipeline.vala"
		_tmp12_ = self->audiosink;
#line 100 "../core/GStreamer/Pipeline.vala"
		gst_element_unlink (_tmp11_, _tmp12_);
#line 101 "../core/GStreamer/Pipeline.vala"
		_tmp13_ = self->audiosinkqueue;
#line 101 "../core/GStreamer/Pipeline.vala"
		_tmp14_ = self->audiosink;
#line 101 "../core/GStreamer/Pipeline.vala"
		gst_element_link_many (_tmp13_, _tmp14_, NULL);
#line 531 "Pipeline.c"
	}
}


static void
noise_pipeline_class_init (NoisePipelineClass * klass)
{
#line 29 "../core/GStreamer/Pipeline.vala"
	noise_pipeline_parent_class = g_type_class_peek_parent (klass);
#line 29 "../core/GStreamer/Pipeline.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_pipeline_finalize;
#line 543 "Pipeline.c"
}


static void
noise_pipeline_instance_init (NoisePipeline * self)
{
}


static void
noise_pipeline_finalize (GObject * obj)
{
	NoisePipeline * self;
#line 29 "../core/GStreamer/Pipeline.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PIPELINE, NoisePipeline);
#line 30 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->pipe);
#line 31 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->eq);
#line 33 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->bus);
#line 34 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->pad);
#line 36 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiosink);
#line 37 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiosinkqueue);
#line 38 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->eq_audioconvert);
#line 39 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->eq_audioconvert2);
#line 41 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->playbin);
#line 42 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiotee);
#line 43 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->audiobin);
#line 44 "../core/GStreamer/Pipeline.vala"
	_g_object_unref0 (self->preamp);
#line 29 "../core/GStreamer/Pipeline.vala"
	G_OBJECT_CLASS (noise_pipeline_parent_class)->finalize (obj);
#line 585 "Pipeline.c"
}


GType
noise_pipeline_get_type (void)
{
	static volatile gsize noise_pipeline_type_id__volatile = 0;
	if (g_once_init_enter (&noise_pipeline_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePipelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_pipeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePipeline), 0, (GInstanceInitFunc) noise_pipeline_instance_init, NULL };
		GType noise_pipeline_type_id;
		noise_pipeline_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePipeline", &g_define_type_info, 0);
		g_once_init_leave (&noise_pipeline_type_id__volatile, noise_pipeline_type_id);
	}
	return noise_pipeline_type_id__volatile;
}



