/* Playlist.c generated by valac 0.42.6, the Vala compiler
 * generated from Playlist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define NOISE_TYPE_PLAYLIST (noise_playlist_get_type ())
#define NOISE_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylist))
#define NOISE_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))
#define NOISE_IS_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYLIST))
#define NOISE_IS_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYLIST))
#define NOISE_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYLIST, NoisePlaylistClass))

typedef struct _NoisePlaylist NoisePlaylist;
typedef struct _NoisePlaylistClass NoisePlaylistClass;
typedef struct _NoisePlaylistPrivate NoisePlaylistPrivate;

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
enum  {
	NOISE_PLAYLIST_0_PROPERTY,
	NOISE_PLAYLIST_MEDIAS_PROPERTY,
	NOISE_PLAYLIST_ROWID_PROPERTY,
	NOISE_PLAYLIST_NAME_PROPERTY,
	NOISE_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* noise_playlist_properties[NOISE_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_PLAYLIST_REQUEST_PLAY_SIGNAL,
	NOISE_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_PLAYLIST_MEDIA_REMOVED_SIGNAL,
	NOISE_PLAYLIST_UPDATED_SIGNAL,
	NOISE_PLAYLIST_CLEARED_SIGNAL,
	NOISE_PLAYLIST_NUM_SIGNALS
};
static guint noise_playlist_signals[NOISE_PLAYLIST_NUM_SIGNALS] = {0};

struct _NoisePlaylist {
	GObject parent_instance;
	NoisePlaylistPrivate * priv;
	GIcon* icon;
	gchar* _name;
};

struct _NoisePlaylistClass {
	GObjectClass parent_class;
	void (*add_media) (NoisePlaylist* self, NoiseMedia* to_remove);
	void (*add_medias) (NoisePlaylist* self, GeeCollection* to_add);
	void (*remove_media) (NoisePlaylist* self, NoiseMedia* to_remove);
	void (*remove_medias) (NoisePlaylist* self, GeeCollection* to_remove);
	void (*clear) (NoisePlaylist* self);
	GeeArrayList* (*get_medias) (NoisePlaylist* self);
	void (*set_medias) (NoisePlaylist* self, GeeArrayList* value);
	const gchar* (*get_name) (NoisePlaylist* self);
	void (*set_name) (NoisePlaylist* self, const gchar* value);
};

struct _NoisePlaylistPrivate {
	GeeArrayList* _medias;
	gint64 _rowid;
};


static gint NoisePlaylist_private_offset;
static gpointer noise_playlist_parent_class = NULL;

GType noise_playlist_get_type (void) G_GNUC_CONST;
GType noise_media_get_type (void) G_GNUC_CONST;
void noise_playlist_add_media (NoisePlaylist* self,
                               NoiseMedia* to_remove);
static void noise_playlist_real_add_media (NoisePlaylist* self,
                                    NoiseMedia* to_remove);
void noise_playlist_add_medias (NoisePlaylist* self,
                                GeeCollection* to_add);
static void noise_playlist_real_add_medias (NoisePlaylist* self,
                                     GeeCollection* to_add);
void noise_playlist_remove_media (NoisePlaylist* self,
                                  NoiseMedia* to_remove);
static void noise_playlist_real_remove_media (NoisePlaylist* self,
                                       NoiseMedia* to_remove);
void noise_playlist_remove_medias (NoisePlaylist* self,
                                   GeeCollection* to_remove);
static void noise_playlist_real_remove_medias (NoisePlaylist* self,
                                        GeeCollection* to_remove);
void noise_playlist_clear (NoisePlaylist* self);
static void noise_playlist_real_clear (NoisePlaylist* self);
gboolean noise_playlist_is_empty (NoisePlaylist* self);
GeeArrayList* noise_playlist_get_medias (NoisePlaylist* self);
NoiseMedia* noise_playlist_get (NoisePlaylist* self,
                                gint index);
void noise_playlist_set (NoisePlaylist* self,
                         gint index,
                         NoiseMedia* m);
GeeIterator* noise_playlist_iterator (NoisePlaylist* self);
NoisePlaylist* noise_playlist_construct (GType object_type);
void noise_playlist_set_medias (NoisePlaylist* self,
                                GeeArrayList* value);
gint64 noise_playlist_get_rowid (NoisePlaylist* self);
void noise_playlist_set_rowid (NoisePlaylist* self,
                               gint64 value);
const gchar* noise_playlist_get_name (NoisePlaylist* self);
void noise_playlist_set_name (NoisePlaylist* self,
                              const gchar* value);
static void noise_playlist_finalize (GObject * obj);
static void _vala_noise_playlist_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_noise_playlist_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);


static inline gpointer
noise_playlist_get_instance_private (NoisePlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlaylist_private_offset);
}


static void
noise_playlist_real_add_media (NoisePlaylist* self,
                               NoiseMedia* to_remove)
{
#line 53 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_playlist_add_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 53 "../core/Playlists/Playlist.vala"
	return;
#line 174 "Playlist.c"
}


void
noise_playlist_add_media (NoisePlaylist* self,
                          NoiseMedia* to_remove)
{
#line 53 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 53 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->add_media (self, to_remove);
#line 186 "Playlist.c"
}


static void
noise_playlist_real_add_medias (NoisePlaylist* self,
                                GeeCollection* to_add)
{
#line 54 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_playlist_add_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 54 "../core/Playlists/Playlist.vala"
	return;
#line 198 "Playlist.c"
}


void
noise_playlist_add_medias (NoisePlaylist* self,
                           GeeCollection* to_add)
{
#line 54 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 54 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->add_medias (self, to_add);
#line 210 "Playlist.c"
}


static void
noise_playlist_real_remove_media (NoisePlaylist* self,
                                  NoiseMedia* to_remove)
{
#line 55 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_playlist_remove_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 55 "../core/Playlists/Playlist.vala"
	return;
#line 222 "Playlist.c"
}


void
noise_playlist_remove_media (NoisePlaylist* self,
                             NoiseMedia* to_remove)
{
#line 55 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 55 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->remove_media (self, to_remove);
#line 234 "Playlist.c"
}


static void
noise_playlist_real_remove_medias (NoisePlaylist* self,
                                   GeeCollection* to_remove)
{
#line 56 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_playlist_remove_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 56 "../core/Playlists/Playlist.vala"
	return;
#line 246 "Playlist.c"
}


void
noise_playlist_remove_medias (NoisePlaylist* self,
                              GeeCollection* to_remove)
{
#line 56 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 56 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->remove_medias (self, to_remove);
#line 258 "Playlist.c"
}


static void
noise_playlist_real_clear (NoisePlaylist* self)
{
#line 57 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_playlist_clear'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 57 "../core/Playlists/Playlist.vala"
	return;
#line 269 "Playlist.c"
}


void
noise_playlist_clear (NoisePlaylist* self)
{
#line 57 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 57 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->clear (self);
#line 280 "Playlist.c"
}


gboolean
noise_playlist_is_empty (NoisePlaylist* self)
{
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 59 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../core/Playlists/Playlist.vala"
	_tmp0_ = noise_playlist_get_medias (self);
#line 60 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 60 "../core/Playlists/Playlist.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 60 "../core/Playlists/Playlist.vala"
	_tmp3_ = _tmp2_;
#line 60 "../core/Playlists/Playlist.vala"
	result = _tmp3_ <= 0;
#line 60 "../core/Playlists/Playlist.vala"
	return result;
#line 306 "Playlist.c"
}


/**
    * Retrives a Media at an index in this playlist
    */
NoiseMedia*
noise_playlist_get (NoisePlaylist* self,
                    gint index)
{
	NoiseMedia* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
#line 66 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../core/Playlists/Playlist.vala"
	_tmp0_ = noise_playlist_get_medias (self);
#line 67 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 67 "../core/Playlists/Playlist.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, index);
#line 67 "../core/Playlists/Playlist.vala"
	result = (NoiseMedia*) _tmp2_;
#line 67 "../core/Playlists/Playlist.vala"
	return result;
#line 333 "Playlist.c"
}


void
noise_playlist_set (NoisePlaylist* self,
                    gint index,
                    NoiseMedia* m)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 70 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 70 "../core/Playlists/Playlist.vala"
	g_return_if_fail (m != NULL);
#line 71 "../core/Playlists/Playlist.vala"
	_tmp0_ = noise_playlist_get_medias (self);
#line 71 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 71 "../core/Playlists/Playlist.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp1_, index, m);
#line 354 "Playlist.c"
}


GeeIterator*
noise_playlist_iterator (NoisePlaylist* self)
{
	GeeIterator* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeIterator* _tmp2_;
#line 74 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../core/Playlists/Playlist.vala"
	_tmp0_ = noise_playlist_get_medias (self);
#line 75 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 75 "../core/Playlists/Playlist.vala"
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 75 "../core/Playlists/Playlist.vala"
	result = _tmp2_;
#line 75 "../core/Playlists/Playlist.vala"
	return result;
#line 377 "Playlist.c"
}


NoisePlaylist*
noise_playlist_construct (GType object_type)
{
	NoisePlaylist * self = NULL;
#line 29 "../core/Playlists/Playlist.vala"
	self = (NoisePlaylist*) g_object_new (object_type, NULL);
#line 29 "../core/Playlists/Playlist.vala"
	return self;
#line 389 "Playlist.c"
}


GeeArrayList*
noise_playlist_get_medias (NoisePlaylist* self)
{
#line 32 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/Playlists/Playlist.vala"
	return NOISE_PLAYLIST_GET_CLASS (self)->get_medias (self);
#line 400 "Playlist.c"
}


static GeeArrayList*
noise_playlist_real_get_medias (NoisePlaylist* base)
{
	GeeArrayList* result;
	NoisePlaylist* self;
	GeeArrayList* _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
	self = base;
#line 32 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->priv->_medias;
#line 32 "../core/Playlists/Playlist.vala"
	result = _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
	return result;
#line 418 "Playlist.c"
}


void
noise_playlist_set_medias (NoisePlaylist* self,
                           GeeArrayList* value)
{
#line 32 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->set_medias (self, value);
#line 430 "Playlist.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../core/Playlists/Playlist.vala"
	return self ? g_object_ref (self) : NULL;
#line 439 "Playlist.c"
}


static void
noise_playlist_real_set_medias (NoisePlaylist* base,
                                GeeArrayList* value)
{
	NoisePlaylist* self;
#line 32 "../core/Playlists/Playlist.vala"
	self = base;
#line 32 "../core/Playlists/Playlist.vala"
	if (noise_playlist_real_get_medias (base) != value) {
#line 452 "Playlist.c"
		GeeArrayList* _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../core/Playlists/Playlist.vala"
		_g_object_unref0 (self->priv->_medias);
#line 32 "../core/Playlists/Playlist.vala"
		self->priv->_medias = _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playlist_properties[NOISE_PLAYLIST_MEDIAS_PROPERTY]);
#line 462 "Playlist.c"
	}
}


gint64
noise_playlist_get_rowid (NoisePlaylist* self)
{
	gint64 result;
	gint64 _tmp0_;
#line 34 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 34 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->priv->_rowid;
#line 34 "../core/Playlists/Playlist.vala"
	result = _tmp0_;
#line 34 "../core/Playlists/Playlist.vala"
	return result;
#line 480 "Playlist.c"
}


void
noise_playlist_set_rowid (NoisePlaylist* self,
                          gint64 value)
{
#line 34 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 34 "../core/Playlists/Playlist.vala"
	if (noise_playlist_get_rowid (self) != value) {
#line 34 "../core/Playlists/Playlist.vala"
		self->priv->_rowid = value;
#line 34 "../core/Playlists/Playlist.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playlist_properties[NOISE_PLAYLIST_ROWID_PROPERTY]);
#line 496 "Playlist.c"
	}
}


const gchar*
noise_playlist_get_name (NoisePlaylist* self)
{
#line 38 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../core/Playlists/Playlist.vala"
	return NOISE_PLAYLIST_GET_CLASS (self)->get_name (self);
#line 508 "Playlist.c"
}


static const gchar*
noise_playlist_real_get_name (NoisePlaylist* base)
{
	const gchar* result;
	NoisePlaylist* self;
	const gchar* _tmp0_;
#line 38 "../core/Playlists/Playlist.vala"
	self = base;
#line 39 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->_name;
#line 39 "../core/Playlists/Playlist.vala"
	result = _tmp0_;
#line 39 "../core/Playlists/Playlist.vala"
	return result;
#line 526 "Playlist.c"
}


void
noise_playlist_set_name (NoisePlaylist* self,
                         const gchar* value)
{
#line 41 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 41 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_GET_CLASS (self)->set_name (self, value);
#line 538 "Playlist.c"
}


static void
noise_playlist_real_set_name (NoisePlaylist* base,
                              const gchar* value)
{
	NoisePlaylist* self;
	gchar* old_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 41 "../core/Playlists/Playlist.vala"
	self = base;
#line 42 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->_name;
#line 42 "../core/Playlists/Playlist.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 42 "../core/Playlists/Playlist.vala"
	old_name = _tmp1_;
#line 43 "../core/Playlists/Playlist.vala"
	_tmp2_ = g_strdup (value);
#line 43 "../core/Playlists/Playlist.vala"
	_g_free0 (self->_name);
#line 43 "../core/Playlists/Playlist.vala"
	self->_name = _tmp2_;
#line 44 "../core/Playlists/Playlist.vala"
	g_signal_emit (self, noise_playlist_signals[NOISE_PLAYLIST_UPDATED_SIGNAL], 0, old_name);
#line 41 "../core/Playlists/Playlist.vala"
	_g_free0 (old_name);
#line 41 "../core/Playlists/Playlist.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playlist_properties[NOISE_PLAYLIST_NAME_PROPERTY]);
#line 571 "Playlist.c"
}


static void
noise_playlist_class_init (NoisePlaylistClass * klass)
{
#line 29 "../core/Playlists/Playlist.vala"
	noise_playlist_parent_class = g_type_class_peek_parent (klass);
#line 29 "../core/Playlists/Playlist.vala"
	g_type_class_adjust_private_offset (klass, &NoisePlaylist_private_offset);
#line 29 "../core/Playlists/Playlist.vala"
	((NoisePlaylistClass *) klass)->add_media = (void (*) (NoisePlaylist*, NoiseMedia*)) noise_playlist_real_add_media;
#line 29 "../core/Playlists/Playlist.vala"
	((NoisePlaylistClass *) klass)->add_medias = (void (*) (NoisePlaylist*, GeeCollection*)) noise_playlist_real_add_medias;
#line 29 "../core/Playlists/Playlist.vala"
	((NoisePlaylistClass *) klass)->remove_media = (void (*) (NoisePlaylist*, NoiseMedia*)) noise_playlist_real_remove_media;
#line 29 "../core/Playlists/Playlist.vala"
	((NoisePlaylistClass *) klass)->remove_medias = (void (*) (NoisePlaylist*, GeeCollection*)) noise_playlist_real_remove_medias;
#line 29 "../core/Playlists/Playlist.vala"
	((NoisePlaylistClass *) klass)->clear = (void (*) (NoisePlaylist*)) noise_playlist_real_clear;
#line 29 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_CLASS (klass)->get_medias = noise_playlist_real_get_medias;
#line 29 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_CLASS (klass)->set_medias = noise_playlist_real_set_medias;
#line 29 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_CLASS (klass)->get_name = noise_playlist_real_get_name;
#line 29 "../core/Playlists/Playlist.vala"
	NOISE_PLAYLIST_CLASS (klass)->set_name = noise_playlist_real_set_name;
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playlist_get_property;
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playlist_set_property;
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_playlist_finalize;
#line 29 "../core/Playlists/Playlist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYLIST_MEDIAS_PROPERTY, noise_playlist_properties[NOISE_PLAYLIST_MEDIAS_PROPERTY] = g_param_spec_object ("medias", "medias", "medias", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Playlists/Playlist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYLIST_ROWID_PROPERTY, noise_playlist_properties[NOISE_PLAYLIST_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../core/Playlists/Playlist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYLIST_NAME_PROPERTY, noise_playlist_properties[NOISE_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Playlists/Playlist.vala"
	noise_playlist_signals[NOISE_PLAYLIST_REQUEST_PLAY_SIGNAL] = g_signal_new ("request-play", NOISE_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/Playlists/Playlist.vala"
	noise_playlist_signals[NOISE_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("media-added", NOISE_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Playlists/Playlist.vala"
	noise_playlist_signals[NOISE_PLAYLIST_MEDIA_REMOVED_SIGNAL] = g_signal_new ("media-removed", NOISE_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Playlists/Playlist.vala"
	noise_playlist_signals[NOISE_PLAYLIST_UPDATED_SIGNAL] = g_signal_new ("updated", NOISE_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 29 "../core/Playlists/Playlist.vala"
	noise_playlist_signals[NOISE_PLAYLIST_CLEARED_SIGNAL] = g_signal_new ("cleared", NOISE_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 622 "Playlist.c"
}


static void
noise_playlist_instance_init (NoisePlaylist * self)
{
	GeeArrayList* _tmp0_;
	gchar* _tmp1_;
#line 29 "../core/Playlists/Playlist.vala"
	self->priv = noise_playlist_get_instance_private (self);
#line 32 "../core/Playlists/Playlist.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 32 "../core/Playlists/Playlist.vala"
	self->priv->_medias = _tmp0_;
#line 36 "../core/Playlists/Playlist.vala"
	_tmp1_ = g_strdup ("");
#line 36 "../core/Playlists/Playlist.vala"
	self->_name = _tmp1_;
#line 641 "Playlist.c"
}


static void
noise_playlist_finalize (GObject * obj)
{
	NoisePlaylist * self;
#line 29 "../core/Playlists/Playlist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYLIST, NoisePlaylist);
#line 32 "../core/Playlists/Playlist.vala"
	_g_object_unref0 (self->priv->_medias);
#line 35 "../core/Playlists/Playlist.vala"
	_g_object_unref0 (self->icon);
#line 36 "../core/Playlists/Playlist.vala"
	_g_free0 (self->_name);
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (noise_playlist_parent_class)->finalize (obj);
#line 659 "Playlist.c"
}


GType
noise_playlist_get_type (void)
{
	static volatile gsize noise_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaylist), 0, (GInstanceInitFunc) noise_playlist_instance_init, NULL };
		GType noise_playlist_type_id;
		noise_playlist_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaylist", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		NoisePlaylist_private_offset = g_type_add_instance_private (noise_playlist_type_id, sizeof (NoisePlaylistPrivate));
		g_once_init_leave (&noise_playlist_type_id__volatile, noise_playlist_type_id);
	}
	return noise_playlist_type_id__volatile;
}


static void
_vala_noise_playlist_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	NoisePlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYLIST, NoisePlaylist);
#line 29 "../core/Playlists/Playlist.vala"
	switch (property_id) {
#line 29 "../core/Playlists/Playlist.vala"
		case NOISE_PLAYLIST_MEDIAS_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		g_value_set_object (value, noise_playlist_get_medias (self));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case NOISE_PLAYLIST_ROWID_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		g_value_set_int64 (value, noise_playlist_get_rowid (self));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case NOISE_PLAYLIST_NAME_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		g_value_set_string (value, noise_playlist_get_name (self));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 706 "Playlist.c"
		default:
#line 29 "../core/Playlists/Playlist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 712 "Playlist.c"
	}
}


static void
_vala_noise_playlist_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	NoisePlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYLIST, NoisePlaylist);
#line 29 "../core/Playlists/Playlist.vala"
	switch (property_id) {
#line 29 "../core/Playlists/Playlist.vala"
		case NOISE_PLAYLIST_MEDIAS_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		noise_playlist_set_medias (self, g_value_get_object (value));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case NOISE_PLAYLIST_ROWID_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		noise_playlist_set_rowid (self, g_value_get_int64 (value));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case NOISE_PLAYLIST_NAME_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		noise_playlist_set_name (self, g_value_get_string (value));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 745 "Playlist.c"
		default:
#line 29 "../core/Playlists/Playlist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 751 "Playlist.c"
	}
}



