/* CompareFunctionHolder.c generated by valac 0.42.6, the Vala compiler
 * generated from CompareFunctionHolder.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
#define _g_free0(var) (var = (g_free (var), NULL))



GType noise_media_get_type (void) G_GNUC_CONST;
gint noise_compare_titles (NoiseMedia* a,
                           NoiseMedia* b);
gint noise_string_compare (const gchar* a,
                           const gchar* b);
gchar* noise_media_get_display_title (NoiseMedia* self);
gint noise_compare_genres (NoiseMedia* a,
                           NoiseMedia* b);
gchar* noise_media_get_display_genre (NoiseMedia* self);
gint noise_compare_album_artists (NoiseMedia* a,
                                  NoiseMedia* b);
gint noise_compare_artists (NoiseMedia* a,
                            NoiseMedia* b);
gchar* noise_media_get_display_artist (NoiseMedia* self);
gint noise_compare_standard_unsigned (guint a,
                                      guint b);
guint noise_media_get_year (NoiseMedia* self);
gint noise_compare_albums (NoiseMedia* a,
                           NoiseMedia* b);
gchar* noise_media_get_display_album_artist (NoiseMedia* self,
                                             gboolean use_artist_fallback);
gchar* noise_media_get_display_album (NoiseMedia* self);
guint noise_media_get_album_number (NoiseMedia* self);
gint noise_compare_track_numbers (NoiseMedia* a,
                                  NoiseMedia* b);
guint noise_media_get_track (NoiseMedia* self);
gint noise_compare_standard (gint a,
                             gint b);
gint noise_compare_standard_64 (gint64 a,
                                gint64 b);


inline gint
noise_compare_titles (NoiseMedia* a,
                      NoiseMedia* b)
{
	gint result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
#line 32 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 32 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = noise_media_get_display_title (a);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = noise_media_get_display_title (b);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = noise_string_compare (_tmp1_, _tmp3_);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	result = _tmp4_;
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 118 "CompareFunctionHolder.c"
}


inline gint
noise_compare_genres (NoiseMedia* a,
                      NoiseMedia* b)
{
	gint result = 0;
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 36 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 36 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = noise_media_get_display_genre (a);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = noise_media_get_display_genre (b);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = noise_string_compare (_tmp1_, _tmp3_);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 38 "../core/Utils/CompareFunctionHolder.vala"
	_tmp5_ = order;
#line 38 "../core/Utils/CompareFunctionHolder.vala"
	if (_tmp5_ == 0) {
#line 39 "../core/Utils/CompareFunctionHolder.vala"
		order = noise_compare_album_artists (a, b);
#line 160 "CompareFunctionHolder.c"
	}
#line 40 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 40 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 166 "CompareFunctionHolder.c"
}


inline gint
noise_compare_artists (NoiseMedia* a,
                       NoiseMedia* b)
{
	gint result = 0;
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp10_;
#line 43 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 43 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = noise_media_get_display_artist (a);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = noise_media_get_display_artist (b);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = noise_string_compare (_tmp1_, _tmp3_);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 46 "../core/Utils/CompareFunctionHolder.vala"
	_tmp5_ = order;
#line 46 "../core/Utils/CompareFunctionHolder.vala"
	if (_tmp5_ == 0) {
#line 207 "CompareFunctionHolder.c"
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		guint _tmp9_;
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp6_ = noise_media_get_year (a);
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp7_ = _tmp6_;
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp8_ = noise_media_get_year (b);
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp9_ = _tmp8_;
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		order = noise_compare_standard_unsigned (_tmp7_, _tmp9_);
#line 222 "CompareFunctionHolder.c"
	}
#line 48 "../core/Utils/CompareFunctionHolder.vala"
	_tmp10_ = order;
#line 48 "../core/Utils/CompareFunctionHolder.vala"
	if (_tmp10_ == 0) {
#line 49 "../core/Utils/CompareFunctionHolder.vala"
		order = noise_compare_albums (a, b);
#line 230 "CompareFunctionHolder.c"
	}
#line 50 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 50 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 236 "CompareFunctionHolder.c"
}


inline gint
noise_compare_album_artists (NoiseMedia* a,
                             NoiseMedia* b)
{
	gint result = 0;
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 53 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 53 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = noise_media_get_display_album_artist (a, TRUE);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = noise_media_get_display_album_artist (b, TRUE);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = noise_string_compare (_tmp1_, _tmp3_);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 55 "../core/Utils/CompareFunctionHolder.vala"
	_tmp5_ = order;
#line 55 "../core/Utils/CompareFunctionHolder.vala"
	if (_tmp5_ == 0) {
#line 56 "../core/Utils/CompareFunctionHolder.vala"
		order = noise_compare_albums (a, b);
#line 278 "CompareFunctionHolder.c"
	}
#line 57 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 57 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 284 "CompareFunctionHolder.c"
}


inline gint
noise_compare_albums (NoiseMedia* a,
                      NoiseMedia* b)
{
	gint result = 0;
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp10_;
#line 60 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 60 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = noise_media_get_display_album (a);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = noise_media_get_display_album (b);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = noise_string_compare (_tmp1_, _tmp3_);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 62 "../core/Utils/CompareFunctionHolder.vala"
	_tmp5_ = order;
#line 62 "../core/Utils/CompareFunctionHolder.vala"
	if (_tmp5_ == 0) {
#line 325 "CompareFunctionHolder.c"
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		guint _tmp9_;
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp6_ = noise_media_get_album_number (a);
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp7_ = _tmp6_;
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp8_ = noise_media_get_album_number (b);
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp9_ = _tmp8_;
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		order = noise_compare_standard_unsigned (_tmp7_, _tmp9_);
#line 340 "CompareFunctionHolder.c"
	}
#line 64 "../core/Utils/CompareFunctionHolder.vala"
	_tmp10_ = order;
#line 64 "../core/Utils/CompareFunctionHolder.vala"
	if (_tmp10_ == 0) {
#line 65 "../core/Utils/CompareFunctionHolder.vala"
		order = noise_compare_track_numbers (a, b);
#line 348 "CompareFunctionHolder.c"
	}
#line 66 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 66 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 354 "CompareFunctionHolder.c"
}


inline gint
noise_compare_track_numbers (NoiseMedia* a,
                             NoiseMedia* b)
{
	gint result = 0;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
#line 69 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 69 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = noise_media_get_track (a);
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = noise_media_get_track (b);
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	result = noise_compare_standard_unsigned (_tmp1_, _tmp3_);
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 383 "CompareFunctionHolder.c"
}


inline gint
noise_compare_standard (gint a,
                        gint b)
{
	gint result = 0;
#line 74 "../core/Utils/CompareFunctionHolder.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 74 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 396 "CompareFunctionHolder.c"
}


inline gint
noise_compare_standard_unsigned (guint a,
                                 guint b)
{
	gint result = 0;
#line 78 "../core/Utils/CompareFunctionHolder.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 78 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 409 "CompareFunctionHolder.c"
}


inline gint
noise_compare_standard_64 (gint64 a,
                           gint64 b)
{
	gint result = 0;
#line 82 "../core/Utils/CompareFunctionHolder.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 82 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 422 "CompareFunctionHolder.c"
}



