/* TimeUtils.c generated by valac 0.42.6, the Vala compiler
 * generated from TimeUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>




#define NOISE_TIME_UTILS_NANO_INV ((guint64) 1000000000)
#define NOISE_TIME_UTILS_MILI_INV ((guint64) 1000)
#define NOISE_TIME_UTILS_SEC_INV ((guint64) 1)
gchar* noise_time_utils_pretty_timestamp_from_time (struct tm* dt);
guint noise_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds);
guint noise_time_utils_nanoseconds_to_seconds (guint64 nanoseconds);
guint64 noise_time_utils_seconds_to_nanoseconds (guint64 seconds);


/**
     * Returns a formatted date and time string.
     */
static gchar*
g_time_format (struct tm *self,
               const gchar* format)
{
	gchar* result = NULL;
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
#line 2939 "glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 2940 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 64);
#line 2940 "glib-2.0.vapi"
	buffer = _tmp0_;
#line 2940 "glib-2.0.vapi"
	buffer_length1 = 64;
#line 2940 "glib-2.0.vapi"
	_buffer_size_ = buffer_length1;
#line 2941 "glib-2.0.vapi"
	_tmp1_ = buffer;
#line 2941 "glib-2.0.vapi"
	_tmp1__length1 = buffer_length1;
#line 2941 "glib-2.0.vapi"
	strftime (_tmp1_, _tmp1__length1, format, &(*self));
#line 2942 "glib-2.0.vapi"
	_tmp2_ = buffer;
#line 2942 "glib-2.0.vapi"
	_tmp2__length1 = buffer_length1;
#line 2942 "glib-2.0.vapi"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 2942 "glib-2.0.vapi"
	result = _tmp3_;
#line 2942 "glib-2.0.vapi"
	buffer = (g_free (buffer), NULL);
#line 2942 "glib-2.0.vapi"
	return result;
#line 98 "TimeUtils.c"
}


inline gchar*
noise_time_utils_pretty_timestamp_from_time (struct tm* dt)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 37 "../core/Utils/TimeUtils.vala"
	g_return_val_if_fail (dt != NULL, NULL);
#line 40 "../core/Utils/TimeUtils.vala"
	_tmp0_ = g_time_format (dt, _ ("%m/%e/%Y %l:%M %p"));
#line 40 "../core/Utils/TimeUtils.vala"
	result = _tmp0_;
#line 40 "../core/Utils/TimeUtils.vala"
	return result;
#line 115 "TimeUtils.c"
}


/**
     * Convert from nanoseconds (10E-9) to miliseconds (10E-3);
     *
     * This is used extensively because {@link Noise.Media} stores
     * miliseconds, while GStreamer uses nanoseconds.
     *
     * The method does its best to avoid losing precision.
     */
inline guint
noise_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds)
{
	guint result = 0U;
#line 52 "../core/Utils/TimeUtils.vala"
	result = (guint) ((nanoseconds * NOISE_TIME_UTILS_MILI_INV) / NOISE_TIME_UTILS_NANO_INV);
#line 52 "../core/Utils/TimeUtils.vala"
	return result;
#line 135 "TimeUtils.c"
}


inline guint
noise_time_utils_nanoseconds_to_seconds (guint64 nanoseconds)
{
	guint result = 0U;
#line 56 "../core/Utils/TimeUtils.vala"
	result = (guint) ((nanoseconds * NOISE_TIME_UTILS_SEC_INV) / NOISE_TIME_UTILS_NANO_INV);
#line 56 "../core/Utils/TimeUtils.vala"
	return result;
#line 147 "TimeUtils.c"
}


inline guint64
noise_time_utils_seconds_to_nanoseconds (guint64 seconds)
{
	guint64 result = 0ULL;
#line 60 "../core/Utils/TimeUtils.vala"
	result = (guint64) ((seconds * NOISE_TIME_UTILS_NANO_INV) / NOISE_TIME_UTILS_SEC_INV);
#line 60 "../core/Utils/TimeUtils.vala"
	return result;
#line 159 "TimeUtils.c"
}



