/* CoverImport.c generated by valac 0.42.6, the Vala compiler
 * generated from CoverImport.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/pbutils/pbutils.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/gst.h>
#include <gst/tag/tag.h>


#define NOISE_TYPE_COVER_IMPORT (noise_cover_import_get_type ())
#define NOISE_COVER_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_COVER_IMPORT, NoiseCoverImport))
#define NOISE_COVER_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_COVER_IMPORT, NoiseCoverImportClass))
#define NOISE_IS_COVER_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_COVER_IMPORT))
#define NOISE_IS_COVER_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_COVER_IMPORT))
#define NOISE_COVER_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_COVER_IMPORT, NoiseCoverImportClass))

typedef struct _NoiseCoverImport NoiseCoverImport;
typedef struct _NoiseCoverImportClass NoiseCoverImportClass;
typedef struct _NoiseCoverImportPrivate NoiseCoverImportPrivate;
enum  {
	NOISE_COVER_IMPORT_0_PROPERTY,
	NOISE_COVER_IMPORT_NUM_PROPERTIES
};
static GParamSpec* noise_cover_import_properties[NOISE_COVER_IMPORT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block17Data Block17Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_sample_unref0(var) ((var == NULL) ? NULL : (var = (gst_sample_unref (var), NULL)))
#define _gst_buffer_unref0(var) ((var == NULL) ? NULL : (var = (gst_buffer_unref (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))

struct _NoiseCoverImport {
	GObject parent_instance;
	NoiseCoverImportPrivate * priv;
};

struct _NoiseCoverImportClass {
	GObjectClass parent_class;
};

struct _NoiseCoverImportPrivate {
	GstDiscoverer* discoverer;
	NoiseAlbum* album;
	GRecMutex __lock_album;
};

struct _Block17Data {
	int _ref_count_;
	NoiseCoverImport* self;
	NoiseAlbum* album;
};


static gint NoiseCoverImport_private_offset;
static gpointer noise_cover_import_parent_class = NULL;

GType noise_cover_import_get_type (void) G_GNUC_CONST;
#define NOISE_COVER_IMPORT_DISCOVERER_TIMEOUT 5
NoiseCoverImport* noise_cover_import_new (NoiseAlbum* album);
NoiseCoverImport* noise_cover_import_construct (GType object_type,
                                                NoiseAlbum* album);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void* __lambda32_ (Block17Data* _data17_);
static void noise_cover_import_read_info (NoiseCoverImport* self,
                                   GstDiscovererInfo* info);
static gpointer ___lambda32__gthread_func (gpointer self);
static GstSample* noise_cover_import_get_cover_sample (GstTagList* tag_list);
static GdkPixbuf* noise_cover_import_get_pixbuf_from_buffer (GstBuffer* buffer);
static GObject * noise_cover_import_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void noise_cover_import_finalize (GObject * obj);


static inline gpointer
noise_cover_import_get_instance_private (NoiseCoverImport* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseCoverImport_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../src/GStreamer/CoverImport.vala"
	return self ? g_object_ref (self) : NULL;
#line 127 "CoverImport.c"
}


static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 43 "../src/GStreamer/CoverImport.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 43 "../src/GStreamer/CoverImport.vala"
	return _data17_;
#line 138 "CoverImport.c"
}


static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 43 "../src/GStreamer/CoverImport.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 149 "CoverImport.c"
		NoiseCoverImport* self;
#line 43 "../src/GStreamer/CoverImport.vala"
		self = _data17_->self;
#line 43 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (_data17_->album);
#line 43 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (self);
#line 43 "../src/GStreamer/CoverImport.vala"
		g_slice_free (Block17Data, _data17_);
#line 159 "CoverImport.c"
	}
}


static void*
__lambda32_ (Block17Data* _data17_)
{
	NoiseCoverImport* self;
	void* result = NULL;
	GError* _inner_error0_ = NULL;
#line 45 "../src/GStreamer/CoverImport.vala"
	self = _data17_->self;
#line 172 "CoverImport.c"
	{
		NoiseAlbum* _tmp0_;
#line 46 "../src/GStreamer/CoverImport.vala"
		_tmp0_ = self->priv->album;
#line 46 "../src/GStreamer/CoverImport.vala"
		g_rec_mutex_lock (&self->priv->__lock_album);
#line 179 "CoverImport.c"
		{
			{
				GeeIterator* _media_it = NULL;
				GeeCollection* _tmp1_;
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _tmp4_;
#line 47 "../src/GStreamer/CoverImport.vala"
				_tmp1_ = noise_album_get_media (_data17_->album, (guint) 1);
#line 47 "../src/GStreamer/CoverImport.vala"
				_tmp2_ = _tmp1_;
#line 47 "../src/GStreamer/CoverImport.vala"
				_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 47 "../src/GStreamer/CoverImport.vala"
				_tmp4_ = _tmp3_;
#line 47 "../src/GStreamer/CoverImport.vala"
				_g_object_unref0 (_tmp2_);
#line 47 "../src/GStreamer/CoverImport.vala"
				_media_it = _tmp4_;
#line 47 "../src/GStreamer/CoverImport.vala"
				while (TRUE) {
#line 201 "CoverImport.c"
					GeeIterator* _tmp5_;
					NoiseMedia* media = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
#line 47 "../src/GStreamer/CoverImport.vala"
					_tmp5_ = _media_it;
#line 47 "../src/GStreamer/CoverImport.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 47 "../src/GStreamer/CoverImport.vala"
						break;
#line 212 "CoverImport.c"
					}
#line 47 "../src/GStreamer/CoverImport.vala"
					_tmp6_ = _media_it;
#line 47 "../src/GStreamer/CoverImport.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 47 "../src/GStreamer/CoverImport.vala"
					media = (NoiseMedia*) _tmp7_;
#line 220 "CoverImport.c"
					{
						GstDiscovererInfo* info = NULL;
						GstDiscoverer* _tmp8_;
						NoiseMedia* _tmp9_;
						gchar* _tmp10_;
						gchar* _tmp11_;
						gchar* _tmp12_;
						GstDiscovererInfo* _tmp13_;
						GstDiscovererInfo* _tmp14_;
						GstDiscovererInfo* _tmp15_;
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp8_ = self->priv->discoverer;
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp9_ = media;
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp10_ = noise_media_get_uri (_tmp9_);
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp11_ = _tmp10_;
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp12_ = _tmp11_;
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp13_ = gst_discoverer_discover_uri (_tmp8_, _tmp12_, &_inner_error0_);
#line 49 "../src/GStreamer/CoverImport.vala"
						_tmp14_ = _tmp13_;
#line 49 "../src/GStreamer/CoverImport.vala"
						_g_free0 (_tmp12_);
#line 49 "../src/GStreamer/CoverImport.vala"
						info = _tmp14_;
#line 49 "../src/GStreamer/CoverImport.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "CoverImport.c"
							goto __catch23_g_error;
						}
#line 50 "../src/GStreamer/CoverImport.vala"
						_tmp15_ = info;
#line 50 "../src/GStreamer/CoverImport.vala"
						noise_cover_import_read_info (self, _tmp15_);
#line 48 "../src/GStreamer/CoverImport.vala"
						_g_object_unref0 (info);
#line 260 "CoverImport.c"
					}
					goto __finally23;
					__catch23_g_error:
					{
						GError* err = NULL;
						const gchar* _tmp16_;
						const gchar* _tmp17_;
						GError* _tmp18_;
						const gchar* _tmp19_;
#line 48 "../src/GStreamer/CoverImport.vala"
						err = _inner_error0_;
#line 48 "../src/GStreamer/CoverImport.vala"
						_inner_error0_ = NULL;
#line 52 "../src/GStreamer/CoverImport.vala"
						_tmp16_ = noise_album_get_name (_data17_->album);
#line 52 "../src/GStreamer/CoverImport.vala"
						_tmp17_ = _tmp16_;
#line 52 "../src/GStreamer/CoverImport.vala"
						_tmp18_ = err;
#line 52 "../src/GStreamer/CoverImport.vala"
						_tmp19_ = _tmp18_->message;
#line 52 "../src/GStreamer/CoverImport.vala"
						g_critical ("CoverImport.vala:52: Error while importing cover for %s: %s", _tmp17_, _tmp19_);
#line 48 "../src/GStreamer/CoverImport.vala"
						_g_error_free0 (err);
#line 286 "CoverImport.c"
					}
					__finally23:
#line 48 "../src/GStreamer/CoverImport.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/GStreamer/CoverImport.vala"
						_g_object_unref0 (media);
#line 48 "../src/GStreamer/CoverImport.vala"
						_g_object_unref0 (_media_it);
#line 48 "../src/GStreamer/CoverImport.vala"
						_g_object_unref0 (media);
#line 48 "../src/GStreamer/CoverImport.vala"
						_g_object_unref0 (_media_it);
#line 299 "CoverImport.c"
						{
							NoiseAlbum* _tmp20_;
#line 46 "../src/GStreamer/CoverImport.vala"
							_tmp20_ = self->priv->album;
#line 46 "../src/GStreamer/CoverImport.vala"
							g_rec_mutex_unlock (&self->priv->__lock_album);
#line 306 "CoverImport.c"
						}
#line 48 "../src/GStreamer/CoverImport.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/GStreamer/CoverImport.vala"
						g_clear_error (&_inner_error0_);
#line 48 "../src/GStreamer/CoverImport.vala"
						return NULL;
#line 314 "CoverImport.c"
					}
#line 47 "../src/GStreamer/CoverImport.vala"
					_g_object_unref0 (media);
#line 318 "CoverImport.c"
				}
#line 47 "../src/GStreamer/CoverImport.vala"
				_g_object_unref0 (_media_it);
#line 322 "CoverImport.c"
			}
		}
		__finally22:
		{
			NoiseAlbum* _tmp21_;
#line 46 "../src/GStreamer/CoverImport.vala"
			_tmp21_ = self->priv->album;
#line 46 "../src/GStreamer/CoverImport.vala"
			g_rec_mutex_unlock (&self->priv->__lock_album);
#line 332 "CoverImport.c"
		}
#line 46 "../src/GStreamer/CoverImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/GStreamer/CoverImport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/GStreamer/CoverImport.vala"
			g_clear_error (&_inner_error0_);
#line 46 "../src/GStreamer/CoverImport.vala"
			return NULL;
#line 342 "CoverImport.c"
		}
	}
#line 56 "../src/GStreamer/CoverImport.vala"
	result = NULL;
#line 56 "../src/GStreamer/CoverImport.vala"
	return result;
#line 349 "CoverImport.c"
}


static gpointer
___lambda32__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda32_ (self);
#line 45 "../src/GStreamer/CoverImport.vala"
	block17_data_unref (self);
#line 45 "../src/GStreamer/CoverImport.vala"
	return result;
#line 362 "CoverImport.c"
}


NoiseCoverImport*
noise_cover_import_construct (GType object_type,
                              NoiseAlbum* album)
{
	NoiseCoverImport * self = NULL;
	Block17Data* _data17_;
	NoiseAlbum* _tmp0_;
	NoiseAlbum* _tmp1_;
	GThread* _tmp2_;
	GThread* _tmp3_;
#line 43 "../src/GStreamer/CoverImport.vala"
	g_return_val_if_fail (album != NULL, NULL);
#line 43 "../src/GStreamer/CoverImport.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 43 "../src/GStreamer/CoverImport.vala"
	_data17_->_ref_count_ = 1;
#line 43 "../src/GStreamer/CoverImport.vala"
	_tmp0_ = _g_object_ref0 (album);
#line 43 "../src/GStreamer/CoverImport.vala"
	_g_object_unref0 (_data17_->album);
#line 43 "../src/GStreamer/CoverImport.vala"
	_data17_->album = _tmp0_;
#line 43 "../src/GStreamer/CoverImport.vala"
	self = (NoiseCoverImport*) g_object_new (object_type, NULL);
#line 43 "../src/GStreamer/CoverImport.vala"
	_data17_->self = g_object_ref (self);
#line 44 "../src/GStreamer/CoverImport.vala"
	_tmp1_ = _g_object_ref0 (_data17_->album);
#line 44 "../src/GStreamer/CoverImport.vala"
	_g_object_unref0 (self->priv->album);
#line 44 "../src/GStreamer/CoverImport.vala"
	self->priv->album = _tmp1_;
#line 45 "../src/GStreamer/CoverImport.vala"
	_tmp2_ = g_thread_new (NULL, ___lambda32__gthread_func, block17_data_ref (_data17_));
#line 45 "../src/GStreamer/CoverImport.vala"
	_tmp3_ = _tmp2_;
#line 45 "../src/GStreamer/CoverImport.vala"
	_g_thread_unref0 (_tmp3_);
#line 43 "../src/GStreamer/CoverImport.vala"
	block17_data_unref (_data17_);
#line 43 "../src/GStreamer/CoverImport.vala"
	_data17_ = NULL;
#line 43 "../src/GStreamer/CoverImport.vala"
	return self;
#line 410 "CoverImport.c"
}


NoiseCoverImport*
noise_cover_import_new (NoiseAlbum* album)
{
#line 43 "../src/GStreamer/CoverImport.vala"
	return noise_cover_import_construct (NOISE_TYPE_COVER_IMPORT, album);
#line 419 "CoverImport.c"
}


static gpointer
_gst_tag_list_ref0 (gpointer self)
{
#line 97 "../src/GStreamer/CoverImport.vala"
	return self ? gst_tag_list_ref (self) : NULL;
#line 428 "CoverImport.c"
}


static gpointer
_gst_buffer_ref0 (gpointer self)
{
#line 105 "../src/GStreamer/CoverImport.vala"
	return self ? gst_buffer_ref (self) : NULL;
#line 437 "CoverImport.c"
}


static void
noise_cover_import_read_info (NoiseCoverImport* self,
                              GstDiscovererInfo* info)
{
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean gstreamer_discovery_successful = FALSE;
	gboolean _tmp7_;
	GError* _inner_error0_ = NULL;
#line 60 "../src/GStreamer/CoverImport.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/GStreamer/CoverImport.vala"
	g_return_if_fail (info != NULL);
#line 61 "../src/GStreamer/CoverImport.vala"
	_tmp0_ = gst_discoverer_info_get_uri (info);
#line 61 "../src/GStreamer/CoverImport.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 61 "../src/GStreamer/CoverImport.vala"
	uri = _tmp1_;
#line 62 "../src/GStreamer/CoverImport.vala"
	gstreamer_discovery_successful = FALSE;
#line 63 "../src/GStreamer/CoverImport.vala"
	switch (gst_discoverer_info_get_result (info)) {
#line 63 "../src/GStreamer/CoverImport.vala"
		case GST_DISCOVERER_OK:
#line 467 "CoverImport.c"
		{
#line 65 "../src/GStreamer/CoverImport.vala"
			gstreamer_discovery_successful = TRUE;
#line 66 "../src/GStreamer/CoverImport.vala"
			break;
#line 473 "CoverImport.c"
		}
#line 63 "../src/GStreamer/CoverImport.vala"
		case GST_DISCOVERER_URI_INVALID:
#line 477 "CoverImport.c"
		{
			const gchar* _tmp2_;
#line 69 "../src/GStreamer/CoverImport.vala"
			_tmp2_ = uri;
#line 69 "../src/GStreamer/CoverImport.vala"
			g_warning ("CoverImport.vala:69: GStreamer could not import '%s': invalid URI.", _tmp2_);
#line 70 "../src/GStreamer/CoverImport.vala"
			break;
#line 486 "CoverImport.c"
		}
#line 63 "../src/GStreamer/CoverImport.vala"
		case GST_DISCOVERER_ERROR:
#line 490 "CoverImport.c"
		{
			const gchar* _tmp3_;
#line 73 "../src/GStreamer/CoverImport.vala"
			_tmp3_ = uri;
#line 73 "../src/GStreamer/CoverImport.vala"
			g_warning ("CoverImport.vala:73: GStreamer could not import '%s'", _tmp3_);
#line 74 "../src/GStreamer/CoverImport.vala"
			break;
#line 499 "CoverImport.c"
		}
#line 63 "../src/GStreamer/CoverImport.vala"
		case GST_DISCOVERER_TIMEOUT:
#line 503 "CoverImport.c"
		{
			const gchar* _tmp4_;
#line 77 "../src/GStreamer/CoverImport.vala"
			_tmp4_ = uri;
#line 77 "../src/GStreamer/CoverImport.vala"
			g_warning ("CoverImport.vala:77: GStreamer could not import '%s': Discovery timed " \
"out.", _tmp4_);
#line 78 "../src/GStreamer/CoverImport.vala"
			break;
#line 512 "CoverImport.c"
		}
#line 63 "../src/GStreamer/CoverImport.vala"
		case GST_DISCOVERER_BUSY:
#line 516 "CoverImport.c"
		{
			const gchar* _tmp5_;
#line 81 "../src/GStreamer/CoverImport.vala"
			_tmp5_ = uri;
#line 81 "../src/GStreamer/CoverImport.vala"
			g_warning ("CoverImport.vala:81: GStreamer could not import '%s': Already discover" \
"ing a file.", _tmp5_);
#line 82 "../src/GStreamer/CoverImport.vala"
			break;
#line 525 "CoverImport.c"
		}
#line 63 "../src/GStreamer/CoverImport.vala"
		case GST_DISCOVERER_MISSING_PLUGINS:
#line 529 "CoverImport.c"
		{
			const gchar* _tmp6_;
#line 85 "../src/GStreamer/CoverImport.vala"
			_tmp6_ = uri;
#line 85 "../src/GStreamer/CoverImport.vala"
			g_warning ("CoverImport.vala:85: GStreamer could not import '%s': Missing plugins.", _tmp6_);
#line 92 "../src/GStreamer/CoverImport.vala"
			break;
#line 538 "CoverImport.c"
		}
		default:
#line 63 "../src/GStreamer/CoverImport.vala"
		break;
#line 543 "CoverImport.c"
	}
#line 95 "../src/GStreamer/CoverImport.vala"
	_tmp7_ = gstreamer_discovery_successful;
#line 95 "../src/GStreamer/CoverImport.vala"
	if (_tmp7_) {
#line 549 "CoverImport.c"
		GdkPixbuf* pixbuf = NULL;
		GstTagList* tag_list = NULL;
		GstTagList* _tmp8_;
		GstTagList* _tmp9_;
		GstSample* sample = NULL;
		GstTagList* _tmp10_;
		GstSample* _tmp11_;
		GstSample* _tmp12_;
		GstSample* _tmp15_;
#line 96 "../src/GStreamer/CoverImport.vala"
		pixbuf = NULL;
#line 97 "../src/GStreamer/CoverImport.vala"
		_tmp8_ = gst_discoverer_info_get_tags (info);
#line 97 "../src/GStreamer/CoverImport.vala"
		_tmp9_ = _gst_tag_list_ref0 (_tmp8_);
#line 97 "../src/GStreamer/CoverImport.vala"
		tag_list = _tmp9_;
#line 98 "../src/GStreamer/CoverImport.vala"
		_tmp10_ = tag_list;
#line 98 "../src/GStreamer/CoverImport.vala"
		_tmp11_ = noise_cover_import_get_cover_sample (_tmp10_);
#line 98 "../src/GStreamer/CoverImport.vala"
		sample = _tmp11_;
#line 100 "../src/GStreamer/CoverImport.vala"
		_tmp12_ = sample;
#line 100 "../src/GStreamer/CoverImport.vala"
		if (_tmp12_ == NULL) {
#line 577 "CoverImport.c"
			GstTagList* _tmp13_;
			GstSample* _tmp14_ = NULL;
#line 101 "../src/GStreamer/CoverImport.vala"
			_tmp13_ = tag_list;
#line 101 "../src/GStreamer/CoverImport.vala"
			gst_tag_list_get_sample_index (_tmp13_, GST_TAG_PREVIEW_IMAGE, (guint) 0, &_tmp14_);
#line 101 "../src/GStreamer/CoverImport.vala"
			_gst_sample_unref0 (sample);
#line 101 "../src/GStreamer/CoverImport.vala"
			sample = _tmp14_;
#line 588 "CoverImport.c"
		}
#line 104 "../src/GStreamer/CoverImport.vala"
		_tmp15_ = sample;
#line 104 "../src/GStreamer/CoverImport.vala"
		if (_tmp15_ != NULL) {
#line 594 "CoverImport.c"
			GstBuffer* buffer = NULL;
			GstSample* _tmp16_;
			GstBuffer* _tmp17_;
			GstBuffer* _tmp18_;
			GstBuffer* _tmp19_;
			const gchar* _tmp27_;
#line 105 "../src/GStreamer/CoverImport.vala"
			_tmp16_ = sample;
#line 105 "../src/GStreamer/CoverImport.vala"
			_tmp17_ = gst_sample_get_buffer (_tmp16_);
#line 105 "../src/GStreamer/CoverImport.vala"
			_tmp18_ = _gst_buffer_ref0 (_tmp17_);
#line 105 "../src/GStreamer/CoverImport.vala"
			buffer = _tmp18_;
#line 107 "../src/GStreamer/CoverImport.vala"
			_tmp19_ = buffer;
#line 107 "../src/GStreamer/CoverImport.vala"
			if (_tmp19_ != NULL) {
#line 613 "CoverImport.c"
				GstBuffer* _tmp20_;
				GdkPixbuf* _tmp21_;
				GdkPixbuf* _tmp22_;
#line 108 "../src/GStreamer/CoverImport.vala"
				_tmp20_ = buffer;
#line 108 "../src/GStreamer/CoverImport.vala"
				_tmp21_ = noise_cover_import_get_pixbuf_from_buffer (_tmp20_);
#line 108 "../src/GStreamer/CoverImport.vala"
				_g_object_unref0 (pixbuf);
#line 108 "../src/GStreamer/CoverImport.vala"
				pixbuf = _tmp21_;
#line 109 "../src/GStreamer/CoverImport.vala"
				_tmp22_ = pixbuf;
#line 109 "../src/GStreamer/CoverImport.vala"
				if (_tmp22_ != NULL) {
#line 629 "CoverImport.c"
					{
						NoiseAlbum* _tmp23_;
#line 110 "../src/GStreamer/CoverImport.vala"
						_tmp23_ = self->priv->album;
#line 110 "../src/GStreamer/CoverImport.vala"
						g_rec_mutex_lock (&self->priv->__lock_album);
#line 636 "CoverImport.c"
						{
							NoiseAlbum* _tmp24_;
							GdkPixbuf* _tmp25_;
#line 111 "../src/GStreamer/CoverImport.vala"
							_tmp24_ = self->priv->album;
#line 111 "../src/GStreamer/CoverImport.vala"
							_tmp25_ = pixbuf;
#line 111 "../src/GStreamer/CoverImport.vala"
							noise_album_save_cover_pixbuf (_tmp24_, _tmp25_);
#line 646 "CoverImport.c"
						}
						__finally24:
						{
							NoiseAlbum* _tmp26_;
#line 110 "../src/GStreamer/CoverImport.vala"
							_tmp26_ = self->priv->album;
#line 110 "../src/GStreamer/CoverImport.vala"
							g_rec_mutex_unlock (&self->priv->__lock_album);
#line 655 "CoverImport.c"
						}
#line 110 "../src/GStreamer/CoverImport.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/GStreamer/CoverImport.vala"
							_gst_buffer_unref0 (buffer);
#line 110 "../src/GStreamer/CoverImport.vala"
							_gst_sample_unref0 (sample);
#line 110 "../src/GStreamer/CoverImport.vala"
							_gst_tag_list_unref0 (tag_list);
#line 110 "../src/GStreamer/CoverImport.vala"
							_g_object_unref0 (pixbuf);
#line 110 "../src/GStreamer/CoverImport.vala"
							_g_free0 (uri);
#line 110 "../src/GStreamer/CoverImport.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/GStreamer/CoverImport.vala"
							g_clear_error (&_inner_error0_);
#line 110 "../src/GStreamer/CoverImport.vala"
							return;
#line 675 "CoverImport.c"
						}
					}
				}
			}
#line 116 "../src/GStreamer/CoverImport.vala"
			_tmp27_ = gst_discoverer_info_get_uri (info);
#line 116 "../src/GStreamer/CoverImport.vala"
			g_debug ("CoverImport.vala:116: Final image buffer is NULL for '%s'", _tmp27_);
#line 104 "../src/GStreamer/CoverImport.vala"
			_gst_buffer_unref0 (buffer);
#line 686 "CoverImport.c"
		} else {
			const gchar* _tmp28_;
#line 118 "../src/GStreamer/CoverImport.vala"
			_tmp28_ = gst_discoverer_info_get_uri (info);
#line 118 "../src/GStreamer/CoverImport.vala"
			g_debug ("CoverImport.vala:118: Image sample is NULL for '%s'", _tmp28_);
#line 693 "CoverImport.c"
		}
#line 95 "../src/GStreamer/CoverImport.vala"
		_gst_sample_unref0 (sample);
#line 95 "../src/GStreamer/CoverImport.vala"
		_gst_tag_list_unref0 (tag_list);
#line 95 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (pixbuf);
#line 701 "CoverImport.c"
	}
#line 60 "../src/GStreamer/CoverImport.vala"
	_g_free0 (uri);
#line 705 "CoverImport.c"
}


static gpointer
_gst_caps_ref0 (gpointer self)
{
#line 127 "../src/GStreamer/CoverImport.vala"
	return self ? gst_caps_ref (self) : NULL;
#line 714 "CoverImport.c"
}


static gpointer
_gst_sample_ref0 (gpointer self)
{
#line 132 "../src/GStreamer/CoverImport.vala"
	return self ? gst_sample_ref (self) : NULL;
#line 723 "CoverImport.c"
}


static GstSample*
noise_cover_import_get_cover_sample (GstTagList* tag_list)
{
	GstSample* result = NULL;
	GstSample* cover_sample = NULL;
	GstSample* sample = NULL;
#line 123 "../src/GStreamer/CoverImport.vala"
	g_return_val_if_fail (tag_list != NULL, NULL);
#line 124 "../src/GStreamer/CoverImport.vala"
	cover_sample = NULL;
#line 737 "CoverImport.c"
	{
		gint i = 0;
#line 126 "../src/GStreamer/CoverImport.vala"
		i = 0;
#line 742 "CoverImport.c"
		{
			gboolean _tmp0_ = FALSE;
#line 126 "../src/GStreamer/CoverImport.vala"
			_tmp0_ = TRUE;
#line 126 "../src/GStreamer/CoverImport.vala"
			while (TRUE) {
#line 749 "CoverImport.c"
				gint _tmp2_;
				GstSample* _tmp3_ = NULL;
				gboolean _tmp4_;
				GstCaps* caps = NULL;
				GstSample* _tmp5_;
				GstCaps* _tmp6_;
				GstCaps* _tmp7_;
				GstStructure* caps_struct = NULL;
				GstCaps* _tmp8_;
				GstStructure* _tmp9_;
				gint image_type = 0;
				GstStructure* _tmp10_;
				gint _tmp11_ = 0;
				gboolean _tmp12_ = FALSE;
				gint _tmp13_;
#line 126 "../src/GStreamer/CoverImport.vala"
				if (!_tmp0_) {
#line 767 "CoverImport.c"
					gint _tmp1_;
#line 126 "../src/GStreamer/CoverImport.vala"
					_tmp1_ = i;
#line 126 "../src/GStreamer/CoverImport.vala"
					i = _tmp1_ + 1;
#line 773 "CoverImport.c"
				}
#line 126 "../src/GStreamer/CoverImport.vala"
				_tmp0_ = FALSE;
#line 126 "../src/GStreamer/CoverImport.vala"
				_tmp2_ = i;
#line 126 "../src/GStreamer/CoverImport.vala"
				_tmp4_ = gst_tag_list_get_sample_index (tag_list, GST_TAG_IMAGE, (guint) _tmp2_, &_tmp3_);
#line 126 "../src/GStreamer/CoverImport.vala"
				_gst_sample_unref0 (sample);
#line 126 "../src/GStreamer/CoverImport.vala"
				sample = _tmp3_;
#line 126 "../src/GStreamer/CoverImport.vala"
				if (!_tmp4_) {
#line 126 "../src/GStreamer/CoverImport.vala"
					break;
#line 789 "CoverImport.c"
				}
#line 127 "../src/GStreamer/CoverImport.vala"
				_tmp5_ = sample;
#line 127 "../src/GStreamer/CoverImport.vala"
				_tmp6_ = gst_sample_get_caps (_tmp5_);
#line 127 "../src/GStreamer/CoverImport.vala"
				_tmp7_ = _gst_caps_ref0 (_tmp6_);
#line 127 "../src/GStreamer/CoverImport.vala"
				caps = _tmp7_;
#line 128 "../src/GStreamer/CoverImport.vala"
				_tmp8_ = caps;
#line 128 "../src/GStreamer/CoverImport.vala"
				_tmp9_ = gst_caps_get_structure (_tmp8_, (guint) 0);
#line 128 "../src/GStreamer/CoverImport.vala"
				caps_struct = _tmp9_;
#line 129 "../src/GStreamer/CoverImport.vala"
				image_type = (gint) GST_TAG_IMAGE_TYPE_UNDEFINED;
#line 130 "../src/GStreamer/CoverImport.vala"
				_tmp10_ = caps_struct;
#line 130 "../src/GStreamer/CoverImport.vala"
				gst_structure_get_enum (_tmp10_, "image-type", gst_tag_image_type_get_type (), &_tmp11_);
#line 130 "../src/GStreamer/CoverImport.vala"
				image_type = _tmp11_;
#line 131 "../src/GStreamer/CoverImport.vala"
				_tmp13_ = image_type;
#line 131 "../src/GStreamer/CoverImport.vala"
				if (_tmp13_ == ((gint) GST_TAG_IMAGE_TYPE_UNDEFINED)) {
#line 817 "CoverImport.c"
					GstSample* _tmp14_;
#line 131 "../src/GStreamer/CoverImport.vala"
					_tmp14_ = cover_sample;
#line 131 "../src/GStreamer/CoverImport.vala"
					_tmp12_ = _tmp14_ == NULL;
#line 823 "CoverImport.c"
				} else {
#line 131 "../src/GStreamer/CoverImport.vala"
					_tmp12_ = FALSE;
#line 827 "CoverImport.c"
				}
#line 131 "../src/GStreamer/CoverImport.vala"
				if (_tmp12_) {
#line 831 "CoverImport.c"
					GstSample* _tmp15_;
					GstSample* _tmp16_;
#line 132 "../src/GStreamer/CoverImport.vala"
					_tmp15_ = sample;
#line 132 "../src/GStreamer/CoverImport.vala"
					_tmp16_ = _gst_sample_ref0 (_tmp15_);
#line 132 "../src/GStreamer/CoverImport.vala"
					_gst_sample_unref0 (cover_sample);
#line 132 "../src/GStreamer/CoverImport.vala"
					cover_sample = _tmp16_;
#line 842 "CoverImport.c"
				} else {
					gint _tmp17_;
#line 133 "../src/GStreamer/CoverImport.vala"
					_tmp17_ = image_type;
#line 133 "../src/GStreamer/CoverImport.vala"
					if (_tmp17_ == ((gint) GST_TAG_IMAGE_TYPE_FRONT_COVER)) {
#line 134 "../src/GStreamer/CoverImport.vala"
						result = sample;
#line 134 "../src/GStreamer/CoverImport.vala"
						_gst_caps_unref0 (caps);
#line 134 "../src/GStreamer/CoverImport.vala"
						_gst_sample_unref0 (cover_sample);
#line 134 "../src/GStreamer/CoverImport.vala"
						return result;
#line 857 "CoverImport.c"
					}
				}
#line 126 "../src/GStreamer/CoverImport.vala"
				_gst_caps_unref0 (caps);
#line 862 "CoverImport.c"
			}
		}
	}
#line 138 "../src/GStreamer/CoverImport.vala"
	result = cover_sample;
#line 138 "../src/GStreamer/CoverImport.vala"
	_gst_sample_unref0 (sample);
#line 138 "../src/GStreamer/CoverImport.vala"
	return result;
#line 872 "CoverImport.c"
}


static GdkPixbuf*
noise_cover_import_get_pixbuf_from_buffer (GstBuffer* buffer)
{
	GdkPixbuf* result = NULL;
	GstMapInfo map_info = {0};
	GstMapInfo _tmp0_ = {0};
	gboolean _tmp1_;
	GdkPixbuf* pix = NULL;
	GstMapInfo _tmp15_;
	GError* _inner_error0_ = NULL;
#line 141 "../src/GStreamer/CoverImport.vala"
	g_return_val_if_fail (buffer != NULL, NULL);
#line 144 "../src/GStreamer/CoverImport.vala"
	_tmp1_ = gst_buffer_map (buffer, &_tmp0_, GST_MAP_READ);
#line 144 "../src/GStreamer/CoverImport.vala"
	map_info = _tmp0_;
#line 144 "../src/GStreamer/CoverImport.vala"
	if (!_tmp1_) {
#line 145 "../src/GStreamer/CoverImport.vala"
		g_warning ("CoverImport.vala:145: Could not map memory buffer");
#line 146 "../src/GStreamer/CoverImport.vala"
		result = NULL;
#line 146 "../src/GStreamer/CoverImport.vala"
		return result;
#line 900 "CoverImport.c"
	}
#line 149 "../src/GStreamer/CoverImport.vala"
	pix = NULL;
#line 904 "CoverImport.c"
	{
		GdkPixbufLoader* loader = NULL;
		GdkPixbufLoader* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		GdkPixbufLoader* _tmp5_;
		GstMapInfo _tmp6_;
		guint8* _tmp7_;
		gint _tmp7__length1;
#line 152 "../src/GStreamer/CoverImport.vala"
		_tmp2_ = gdk_pixbuf_loader_new ();
#line 152 "../src/GStreamer/CoverImport.vala"
		loader = _tmp2_;
#line 154 "../src/GStreamer/CoverImport.vala"
		_tmp5_ = loader;
#line 154 "../src/GStreamer/CoverImport.vala"
		_tmp6_ = map_info;
#line 154 "../src/GStreamer/CoverImport.vala"
		_tmp7_ = _tmp6_.data;
#line 154 "../src/GStreamer/CoverImport.vala"
		_tmp7__length1 = (gint) _tmp6_.size;
#line 154 "../src/GStreamer/CoverImport.vala"
		_tmp4_ = gdk_pixbuf_loader_write (_tmp5_, _tmp7_, (gsize) _tmp7__length1, &_inner_error0_);
#line 154 "../src/GStreamer/CoverImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/GStreamer/CoverImport.vala"
			_g_object_unref0 (loader);
#line 932 "CoverImport.c"
			goto __catch25_g_error;
		}
#line 154 "../src/GStreamer/CoverImport.vala"
		if (_tmp4_) {
#line 937 "CoverImport.c"
			gboolean _tmp8_ = FALSE;
			GdkPixbufLoader* _tmp9_;
#line 154 "../src/GStreamer/CoverImport.vala"
			_tmp9_ = loader;
#line 154 "../src/GStreamer/CoverImport.vala"
			_tmp8_ = gdk_pixbuf_loader_close (_tmp9_, &_inner_error0_);
#line 154 "../src/GStreamer/CoverImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/GStreamer/CoverImport.vala"
				_g_object_unref0 (loader);
#line 948 "CoverImport.c"
				goto __catch25_g_error;
			}
#line 154 "../src/GStreamer/CoverImport.vala"
			_tmp3_ = _tmp8_;
#line 953 "CoverImport.c"
		} else {
#line 154 "../src/GStreamer/CoverImport.vala"
			_tmp3_ = FALSE;
#line 957 "CoverImport.c"
		}
#line 154 "../src/GStreamer/CoverImport.vala"
		if (_tmp3_) {
#line 961 "CoverImport.c"
			GdkPixbufLoader* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
#line 155 "../src/GStreamer/CoverImport.vala"
			_tmp10_ = loader;
#line 155 "../src/GStreamer/CoverImport.vala"
			_tmp11_ = gdk_pixbuf_loader_get_pixbuf (_tmp10_);
#line 155 "../src/GStreamer/CoverImport.vala"
			_tmp12_ = _g_object_ref0 (_tmp11_);
#line 155 "../src/GStreamer/CoverImport.vala"
			_g_object_unref0 (pix);
#line 155 "../src/GStreamer/CoverImport.vala"
			pix = _tmp12_;
#line 975 "CoverImport.c"
		}
#line 151 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (loader);
#line 979 "CoverImport.c"
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 151 "../src/GStreamer/CoverImport.vala"
		err = _inner_error0_;
#line 151 "../src/GStreamer/CoverImport.vala"
		_inner_error0_ = NULL;
#line 157 "../src/GStreamer/CoverImport.vala"
		_tmp13_ = err;
#line 157 "../src/GStreamer/CoverImport.vala"
		_tmp14_ = _tmp13_->message;
#line 157 "../src/GStreamer/CoverImport.vala"
		g_warning ("CoverImport.vala:157: Error processing image data: %s", _tmp14_);
#line 151 "../src/GStreamer/CoverImport.vala"
		_g_error_free0 (err);
#line 999 "CoverImport.c"
	}
	__finally25:
#line 151 "../src/GStreamer/CoverImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (pix);
#line 151 "../src/GStreamer/CoverImport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/GStreamer/CoverImport.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../src/GStreamer/CoverImport.vala"
		return NULL;
#line 1012 "CoverImport.c"
	}
#line 160 "../src/GStreamer/CoverImport.vala"
	_tmp15_ = map_info;
#line 160 "../src/GStreamer/CoverImport.vala"
	gst_buffer_unmap (buffer, &_tmp15_);
#line 162 "../src/GStreamer/CoverImport.vala"
	result = pix;
#line 162 "../src/GStreamer/CoverImport.vala"
	return result;
#line 1022 "CoverImport.c"
}


static GObject *
noise_cover_import_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseCoverImport * self;
	GError* _inner_error0_ = NULL;
#line 35 "../src/GStreamer/CoverImport.vala"
	parent_class = G_OBJECT_CLASS (noise_cover_import_parent_class);
#line 35 "../src/GStreamer/CoverImport.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/GStreamer/CoverImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_COVER_IMPORT, NoiseCoverImport);
#line 1041 "CoverImport.c"
	{
		GstDiscoverer* _tmp0_ = NULL;
		GstDiscoverer* _tmp1_;
		GstDiscoverer* _tmp2_;
#line 37 "../src/GStreamer/CoverImport.vala"
		_tmp1_ = gst_discoverer_new ((GstClockTime) (NOISE_COVER_IMPORT_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error0_);
#line 37 "../src/GStreamer/CoverImport.vala"
		_tmp0_ = _tmp1_;
#line 37 "../src/GStreamer/CoverImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1052 "CoverImport.c"
			goto __catch26_g_error;
		}
#line 37 "../src/GStreamer/CoverImport.vala"
		_tmp2_ = _tmp0_;
#line 37 "../src/GStreamer/CoverImport.vala"
		_tmp0_ = NULL;
#line 37 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (self->priv->discoverer);
#line 37 "../src/GStreamer/CoverImport.vala"
		self->priv->discoverer = _tmp2_;
#line 36 "../src/GStreamer/CoverImport.vala"
		_g_object_unref0 (_tmp0_);
#line 1065 "CoverImport.c"
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 36 "../src/GStreamer/CoverImport.vala"
		err = _inner_error0_;
#line 36 "../src/GStreamer/CoverImport.vala"
		_inner_error0_ = NULL;
#line 39 "../src/GStreamer/CoverImport.vala"
		_tmp3_ = err;
#line 39 "../src/GStreamer/CoverImport.vala"
		_tmp4_ = _tmp3_->message;
#line 39 "../src/GStreamer/CoverImport.vala"
		g_critical ("CoverImport.vala:39: Could not create Gst discoverer object: %s", _tmp4_);
#line 36 "../src/GStreamer/CoverImport.vala"
		_g_error_free0 (err);
#line 1085 "CoverImport.c"
	}
	__finally26:
#line 36 "../src/GStreamer/CoverImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 36 "../src/GStreamer/CoverImport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../src/GStreamer/CoverImport.vala"
		g_clear_error (&_inner_error0_);
#line 1094 "CoverImport.c"
	}
#line 35 "../src/GStreamer/CoverImport.vala"
	return obj;
#line 1098 "CoverImport.c"
}


static void
noise_cover_import_class_init (NoiseCoverImportClass * klass)
{
#line 29 "../src/GStreamer/CoverImport.vala"
	noise_cover_import_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/GStreamer/CoverImport.vala"
	g_type_class_adjust_private_offset (klass, &NoiseCoverImport_private_offset);
#line 29 "../src/GStreamer/CoverImport.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_cover_import_constructor;
#line 29 "../src/GStreamer/CoverImport.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_cover_import_finalize;
#line 1113 "CoverImport.c"
}


static void
noise_cover_import_instance_init (NoiseCoverImport * self)
{
#line 29 "../src/GStreamer/CoverImport.vala"
	self->priv = noise_cover_import_get_instance_private (self);
#line 33 "../src/GStreamer/CoverImport.vala"
	g_rec_mutex_init (&self->priv->__lock_album);
#line 1124 "CoverImport.c"
}


static void
noise_cover_import_finalize (GObject * obj)
{
	NoiseCoverImport * self;
#line 29 "../src/GStreamer/CoverImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_COVER_IMPORT, NoiseCoverImport);
#line 32 "../src/GStreamer/CoverImport.vala"
	_g_object_unref0 (self->priv->discoverer);
#line 33 "../src/GStreamer/CoverImport.vala"
	g_rec_mutex_clear (&self->priv->__lock_album);
#line 33 "../src/GStreamer/CoverImport.vala"
	_g_object_unref0 (self->priv->album);
#line 29 "../src/GStreamer/CoverImport.vala"
	G_OBJECT_CLASS (noise_cover_import_parent_class)->finalize (obj);
#line 1142 "CoverImport.c"
}


GType
noise_cover_import_get_type (void)
{
	static volatile gsize noise_cover_import_type_id__volatile = 0;
	if (g_once_init_enter (&noise_cover_import_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseCoverImportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_cover_import_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseCoverImport), 0, (GInstanceInitFunc) noise_cover_import_instance_init, NULL };
		GType noise_cover_import_type_id;
		noise_cover_import_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseCoverImport", &g_define_type_info, 0);
		NoiseCoverImport_private_offset = g_type_add_instance_private (noise_cover_import_type_id, sizeof (NoiseCoverImportPrivate));
		g_once_init_leave (&noise_cover_import_type_id__volatile, noise_cover_import_type_id);
	}
	return noise_cover_import_type_id__volatile;
}



