/* GStreamerTagger.c generated by valac 0.42.6, the Vala compiler
 * generated from GStreamerTagger.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/pbutils/pbutils.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include "io.elementary.music-core.h"
#include <float.h>
#include <math.h>
#include <time.h>


#define NOISE_TYPE_GSTREAMER_TAGGER (noise_gstreamer_tagger_get_type ())
#define NOISE_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger))
#define NOISE_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))
#define NOISE_IS_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_IS_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_GSTREAMER_TAGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))

typedef struct _NoiseGStreamerTagger NoiseGStreamerTagger;
typedef struct _NoiseGStreamerTaggerClass NoiseGStreamerTaggerClass;
typedef struct _NoiseGStreamerTaggerPrivate NoiseGStreamerTaggerPrivate;
enum  {
	NOISE_GSTREAMER_TAGGER_0_PROPERTY,
	NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES
};
static GParamSpec* noise_gstreamer_tagger_properties[NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_date_time_unref0(var) ((var == NULL) ? NULL : (var = (gst_date_time_unref (var), NULL)))
enum  {
	NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL,
	NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_NUM_SIGNALS
};
static guint noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_NUM_SIGNALS] = {0};

struct _NoiseGStreamerTagger {
	GObject parent_instance;
	NoiseGStreamerTaggerPrivate * priv;
};

struct _NoiseGStreamerTaggerClass {
	GObjectClass parent_class;
};

struct _NoiseGStreamerTaggerPrivate {
	GstDiscoverer* d;
	GeeLinkedList* uri_queue;
	GRecMutex __lock_uri_queue;
	GCancellable* cancellable;
};


static gint NoiseGStreamerTagger_private_offset;
static gpointer noise_gstreamer_tagger_parent_class = NULL;

GType noise_gstreamer_tagger_get_type (void) G_GNUC_CONST;
#define NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT 5
NoiseGStreamerTagger* noise_gstreamer_tagger_new (GCancellable* cancellable);
NoiseGStreamerTagger* noise_gstreamer_tagger_construct (GType object_type,
                                                        GCancellable* cancellable);
static void noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self,
                                          GstDiscovererInfo* info,
                                          GError* err);
static void _noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                     GstDiscovererInfo* info,
                                                                     GError* err,
                                                                     gpointer self);
static void noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self);
static void _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                        gpointer self);
static void noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self);
void noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self,
                                                     GeeCollection* uris);
static void* __lambda12_ (NoiseGStreamerTagger* self);
static gpointer ___lambda12__gthread_func (gpointer self);
static GDate* _g_date_dup (GDate* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void noise_gstreamer_tagger_finalize (GObject * obj);


static inline gpointer
noise_gstreamer_tagger_get_instance_private (NoiseGStreamerTagger* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseGStreamerTagger_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	return self ? g_object_ref (self) : NULL;
#line 141 "GStreamerTagger.c"
}


static void
_noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                GstDiscovererInfo* info,
                                                                GError* err,
                                                                gpointer self)
{
#line 48 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_import_media ((NoiseGStreamerTagger*) self, info, err);
#line 153 "GStreamerTagger.c"
}


static void
_noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                   gpointer self)
{
#line 49 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_file_set_finished ((NoiseGStreamerTagger*) self);
#line 163 "GStreamerTagger.c"
}


NoiseGStreamerTagger*
noise_gstreamer_tagger_construct (GType object_type,
                                  GCancellable* cancellable)
{
	NoiseGStreamerTagger * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 41 "../src/GStreamer/GStreamerTagger.vala"
	self = (NoiseGStreamerTagger*) g_object_new (object_type, NULL);
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = _g_object_ref0 (cancellable);
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	self->priv->cancellable = _tmp0_;
#line 43 "../src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = self->priv->cancellable;
#line 43 "../src/GStreamer/GStreamerTagger.vala"
	if (_tmp1_ == NULL) {
#line 187 "GStreamerTagger.c"
		GCancellable* _tmp2_;
#line 44 "../src/GStreamer/GStreamerTagger.vala"
		_tmp2_ = g_cancellable_new ();
#line 44 "../src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (self->priv->cancellable);
#line 44 "../src/GStreamer/GStreamerTagger.vala"
		self->priv->cancellable = _tmp2_;
#line 195 "GStreamerTagger.c"
	}
	{
		GstDiscoverer* _tmp3_ = NULL;
		GstDiscoverer* _tmp4_;
		GstDiscoverer* _tmp5_;
		GstDiscoverer* _tmp6_;
		GstDiscoverer* _tmp7_;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = gst_discoverer_new ((GstClockTime) (NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error0_);
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = _tmp4_;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "GStreamerTagger.c"
			goto __catch27_g_error;
		}
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp5_ = _tmp3_;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = NULL;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (self->priv->d);
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		self->priv->d = _tmp5_;
#line 48 "../src/GStreamer/GStreamerTagger.vala"
		_tmp6_ = self->priv->d;
#line 48 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_connect_object (_tmp6_, "discovered", (GCallback) _noise_gstreamer_tagger_import_media_gst_discoverer_discovered, self, 0);
#line 49 "../src/GStreamer/GStreamerTagger.vala"
		_tmp7_ = self->priv->d;
#line 49 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_connect_object (_tmp7_, "finished", (GCallback) _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished, self, 0);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (_tmp3_);
#line 230 "GStreamerTagger.c"
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		err = _inner_error0_;
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		_inner_error0_ = NULL;
#line 51 "../src/GStreamer/GStreamerTagger.vala"
		_tmp8_ = err;
#line 51 "../src/GStreamer/GStreamerTagger.vala"
		_tmp9_ = _tmp8_->message;
#line 51 "../src/GStreamer/GStreamerTagger.vala"
		g_critical ("GStreamerTagger.vala:51: Could not create Gst discoverer object: %s", _tmp9_);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		_g_error_free0 (err);
#line 250 "GStreamerTagger.c"
	}
	__finally27:
#line 46 "../src/GStreamer/GStreamerTagger.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		g_clear_error (&_inner_error0_);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		return NULL;
#line 261 "GStreamerTagger.c"
	}
#line 41 "../src/GStreamer/GStreamerTagger.vala"
	return self;
#line 265 "GStreamerTagger.c"
}


NoiseGStreamerTagger*
noise_gstreamer_tagger_new (GCancellable* cancellable)
{
#line 41 "../src/GStreamer/GStreamerTagger.vala"
	return noise_gstreamer_tagger_construct (NOISE_TYPE_GSTREAMER_TAGGER, cancellable);
#line 274 "GStreamerTagger.c"
}


static void
noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self)
{
	GCancellable* _tmp0_;
#line 55 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = self->priv->cancellable;
#line 56 "../src/GStreamer/GStreamerTagger.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 288 "GStreamerTagger.c"
		GstDiscoverer* _tmp1_;
#line 57 "../src/GStreamer/GStreamerTagger.vala"
		g_debug ("GStreamerTagger.vala:57: import cancelled");
#line 58 "../src/GStreamer/GStreamerTagger.vala"
		_tmp1_ = self->priv->d;
#line 58 "../src/GStreamer/GStreamerTagger.vala"
		gst_discoverer_stop (_tmp1_);
#line 59 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 298 "GStreamerTagger.c"
	} else {
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		_tmp2_ = self->priv->uri_queue;
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = _tmp3_;
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp4_ == 0) {
#line 311 "GStreamerTagger.c"
			GstDiscoverer* _tmp5_;
#line 61 "../src/GStreamer/GStreamerTagger.vala"
			g_debug ("GStreamerTagger.vala:61: queue finished");
#line 62 "../src/GStreamer/GStreamerTagger.vala"
			_tmp5_ = self->priv->d;
#line 62 "../src/GStreamer/GStreamerTagger.vala"
			gst_discoverer_stop (_tmp5_);
#line 63 "../src/GStreamer/GStreamerTagger.vala"
			g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 321 "GStreamerTagger.c"
		} else {
#line 65 "../src/GStreamer/GStreamerTagger.vala"
			noise_gstreamer_tagger_import_next_file_set (self);
#line 325 "GStreamerTagger.c"
		}
	}
}


static void
noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self)
{
	GError* _inner_error0_ = NULL;
#line 69 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 337 "GStreamerTagger.c"
	{
		GeeLinkedList* _tmp0_;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
		_tmp0_ = self->priv->uri_queue;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 344 "GStreamerTagger.c"
		{
			{
				gchar* uri = NULL;
				GeeLinkedList* _tmp1_;
				gpointer _tmp2_;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				_tmp1_ = self->priv->uri_queue;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				_tmp2_ = gee_deque_poll_head ((GeeDeque*) _tmp1_);
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				uri = (gchar*) _tmp2_;
#line 356 "GStreamerTagger.c"
				{
					gboolean _tmp3_ = FALSE;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
					_tmp3_ = TRUE;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
					while (TRUE) {
#line 363 "GStreamerTagger.c"
						const gchar* _tmp6_;
						GstDiscoverer* _tmp7_;
						const gchar* _tmp8_;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						if (!_tmp3_) {
#line 369 "GStreamerTagger.c"
							GeeLinkedList* _tmp4_;
							gpointer _tmp5_;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							_tmp4_ = self->priv->uri_queue;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							_tmp5_ = gee_deque_poll_head ((GeeDeque*) _tmp4_);
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							_g_free0 (uri);
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							uri = (gchar*) _tmp5_;
#line 380 "GStreamerTagger.c"
						}
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						_tmp3_ = FALSE;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						_tmp6_ = uri;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						if (!(_tmp6_ != NULL)) {
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							break;
#line 390 "GStreamerTagger.c"
						}
#line 72 "../src/GStreamer/GStreamerTagger.vala"
						_tmp7_ = self->priv->d;
#line 72 "../src/GStreamer/GStreamerTagger.vala"
						_tmp8_ = uri;
#line 72 "../src/GStreamer/GStreamerTagger.vala"
						gst_discoverer_discover_uri_async (_tmp7_, _tmp8_);
#line 398 "GStreamerTagger.c"
					}
				}
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				_g_free0 (uri);
#line 403 "GStreamerTagger.c"
			}
		}
		__finally28:
		{
			GeeLinkedList* _tmp9_;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			_tmp9_ = self->priv->uri_queue;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 413 "GStreamerTagger.c"
		}
#line 70 "../src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			return;
#line 423 "GStreamerTagger.c"
		}
	}
}


static void*
__lambda12_ (NoiseGStreamerTagger* self)
{
	void* result = NULL;
#line 84 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_import_next_file_set (self);
#line 85 "../src/GStreamer/GStreamerTagger.vala"
	result = NULL;
#line 85 "../src/GStreamer/GStreamerTagger.vala"
	return result;
#line 439 "GStreamerTagger.c"
}


static gpointer
___lambda12__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda12_ ((NoiseGStreamerTagger*) self);
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	g_object_unref (self);
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	return result;
#line 452 "GStreamerTagger.c"
}


void
noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self,
                                                GeeCollection* uris)
{
	GstDiscoverer* _tmp3_;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 77 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (uris != NULL);
#line 468 "GStreamerTagger.c"
	{
		GeeLinkedList* _tmp0_;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
		_tmp0_ = self->priv->uri_queue;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 475 "GStreamerTagger.c"
		{
			GeeLinkedList* _tmp1_;
#line 79 "../src/GStreamer/GStreamerTagger.vala"
			_tmp1_ = self->priv->uri_queue;
#line 79 "../src/GStreamer/GStreamerTagger.vala"
			gee_collection_add_all ((GeeCollection*) _tmp1_, uris);
#line 482 "GStreamerTagger.c"
		}
		__finally29:
		{
			GeeLinkedList* _tmp2_;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			_tmp2_ = self->priv->uri_queue;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 491 "GStreamerTagger.c"
		}
#line 78 "../src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			g_clear_error (&_inner_error0_);
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			return;
#line 501 "GStreamerTagger.c"
		}
	}
#line 82 "../src/GStreamer/GStreamerTagger.vala"
	_tmp3_ = self->priv->d;
#line 82 "../src/GStreamer/GStreamerTagger.vala"
	gst_discoverer_start (_tmp3_);
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	_tmp4_ = g_thread_new (NULL, ___lambda12__gthread_func, g_object_ref (self));
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	_tmp5_ = _tmp4_;
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	_g_thread_unref0 (_tmp5_);
#line 514 "GStreamerTagger.c"
}


static GDate*
_g_date_dup (GDate* self)
{
	GDate* dup;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	dup = g_new0 (GDate, 1);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	memcpy (dup, self, sizeof (GDate));
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	return dup;
#line 528 "GStreamerTagger.c"
}


static gpointer
__g_date_dup0 (gpointer self)
{
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	return self ? _g_date_dup (self) : NULL;
#line 537 "GStreamerTagger.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 241 "../src/GStreamer/GStreamerTagger.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 546 "GStreamerTagger.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 241 "../src/GStreamer/GStreamerTagger.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 555 "GStreamerTagger.c"
}


static void
noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self,
                                     GstDiscovererInfo* info,
                                     GError* err)
{
	GCancellable* _tmp0_;
	gchar* uri = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean gstreamer_discovery_successful = FALSE;
	gboolean _tmp13_;
	NoiseMedia* m = NULL;
	const gchar* _tmp15_;
	NoiseMedia* _tmp16_;
	guint64 duration = 0ULL;
	GstTagList* tags = NULL;
	GstTagList* _tmp17_;
	GstTagList* _tmp18_;
	NoiseMedia* _tmp118_;
	guint64 _tmp119_;
	GList* _tmp120_;
	NoiseMedia* _tmp145_;
	NoiseMedia* _tmp146_;
	GFile* _tmp147_;
	GFile* _tmp148_;
	NoiseMedia* _tmp149_;
	time_t _tmp150_;
	NoiseMedia* _tmp151_;
	GError* _inner_error0_ = NULL;
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (info != NULL);
#line 90 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = self->priv->cancellable;
#line 90 "../src/GStreamer/GStreamerTagger.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 596 "GStreamerTagger.c"
		GstDiscoverer* _tmp1_;
#line 91 "../src/GStreamer/GStreamerTagger.vala"
		_tmp1_ = self->priv->d;
#line 91 "../src/GStreamer/GStreamerTagger.vala"
		gst_discoverer_stop (_tmp1_);
#line 602 "GStreamerTagger.c"
		{
			GeeLinkedList* _tmp2_;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
			_tmp2_ = self->priv->uri_queue;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 609 "GStreamerTagger.c"
			{
				GeeLinkedList* _tmp3_;
#line 93 "../src/GStreamer/GStreamerTagger.vala"
				_tmp3_ = self->priv->uri_queue;
#line 93 "../src/GStreamer/GStreamerTagger.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
#line 616 "GStreamerTagger.c"
			}
			__finally30:
			{
				GeeLinkedList* _tmp4_;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				_tmp4_ = self->priv->uri_queue;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 625 "GStreamerTagger.c"
			}
#line 92 "../src/GStreamer/GStreamerTagger.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				g_clear_error (&_inner_error0_);
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				return;
#line 635 "GStreamerTagger.c"
			}
		}
#line 96 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 97 "../src/GStreamer/GStreamerTagger.vala"
		return;
#line 642 "GStreamerTagger.c"
	}
#line 100 "../src/GStreamer/GStreamerTagger.vala"
	_tmp5_ = gst_discoverer_info_get_uri (info);
#line 100 "../src/GStreamer/GStreamerTagger.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 100 "../src/GStreamer/GStreamerTagger.vala"
	uri = _tmp6_;
#line 101 "../src/GStreamer/GStreamerTagger.vala"
	gstreamer_discovery_successful = FALSE;
#line 103 "../src/GStreamer/GStreamerTagger.vala"
	switch (gst_discoverer_info_get_result (info)) {
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_OK:
#line 656 "GStreamerTagger.c"
		{
#line 105 "../src/GStreamer/GStreamerTagger.vala"
			gstreamer_discovery_successful = TRUE;
#line 106 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 662 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_URI_INVALID:
#line 666 "GStreamerTagger.c"
		{
			const gchar* _tmp7_;
#line 109 "../src/GStreamer/GStreamerTagger.vala"
			_tmp7_ = uri;
#line 109 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:109: GStreamer could not import '%s': invalid URI" \
".", _tmp7_);
#line 110 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 675 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_ERROR:
#line 679 "GStreamerTagger.c"
		{
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 113 "../src/GStreamer/GStreamerTagger.vala"
			_tmp8_ = uri;
#line 113 "../src/GStreamer/GStreamerTagger.vala"
			_tmp9_ = err->message;
#line 113 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:113: GStreamer could not import '%s': %s", _tmp8_, _tmp9_);
#line 114 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 691 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_TIMEOUT:
#line 695 "GStreamerTagger.c"
		{
			const gchar* _tmp10_;
#line 117 "../src/GStreamer/GStreamerTagger.vala"
			_tmp10_ = uri;
#line 117 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:117: GStreamer could not import '%s': Discovery t" \
"imed out.", _tmp10_);
#line 118 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 704 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_BUSY:
#line 708 "GStreamerTagger.c"
		{
			const gchar* _tmp11_;
#line 121 "../src/GStreamer/GStreamerTagger.vala"
			_tmp11_ = uri;
#line 121 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:121: GStreamer could not import '%s': Already dis" \
"covering a file.", _tmp11_);
#line 122 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 717 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_MISSING_PLUGINS:
#line 721 "GStreamerTagger.c"
		{
			const gchar* _tmp12_;
#line 125 "../src/GStreamer/GStreamerTagger.vala"
			_tmp12_ = uri;
#line 125 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:125: GStreamer could not import '%s': Missing plu" \
"gins.", _tmp12_);
#line 132 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 730 "GStreamerTagger.c"
		}
		default:
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		break;
#line 735 "GStreamerTagger.c"
	}
#line 135 "../src/GStreamer/GStreamerTagger.vala"
	_tmp13_ = gstreamer_discovery_successful;
#line 135 "../src/GStreamer/GStreamerTagger.vala"
	if (!_tmp13_) {
#line 741 "GStreamerTagger.c"
		const gchar* _tmp14_;
#line 136 "../src/GStreamer/GStreamerTagger.vala"
		_tmp14_ = uri;
#line 136 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL], 0, _tmp14_, err);
#line 137 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (uri);
#line 137 "../src/GStreamer/GStreamerTagger.vala"
		return;
#line 751 "GStreamerTagger.c"
	}
#line 140 "../src/GStreamer/GStreamerTagger.vala"
	_tmp15_ = uri;
#line 140 "../src/GStreamer/GStreamerTagger.vala"
	_tmp16_ = noise_media_new (_tmp15_);
#line 140 "../src/GStreamer/GStreamerTagger.vala"
	m = _tmp16_;
#line 142 "../src/GStreamer/GStreamerTagger.vala"
	duration = (guint64) gst_discoverer_info_get_duration (info);
#line 146 "../src/GStreamer/GStreamerTagger.vala"
	_tmp17_ = gst_discoverer_info_get_tags (info);
#line 146 "../src/GStreamer/GStreamerTagger.vala"
	tags = _tmp17_;
#line 148 "../src/GStreamer/GStreamerTagger.vala"
	_tmp18_ = tags;
#line 148 "../src/GStreamer/GStreamerTagger.vala"
	if (_tmp18_ != NULL) {
#line 769 "GStreamerTagger.c"
		gchar* title = NULL;
		GstTagList* _tmp19_;
		gchar* _tmp20_ = NULL;
		gboolean _tmp21_;
		gchar* artist = NULL;
		GstTagList* _tmp24_;
		gchar* _tmp25_ = NULL;
		gboolean _tmp26_;
		gchar* composer = NULL;
		GstTagList* _tmp29_;
		gchar* _tmp30_ = NULL;
		gboolean _tmp31_;
		gchar* album_artist = NULL;
		GstTagList* _tmp34_;
		gchar* _tmp35_ = NULL;
		gboolean _tmp36_;
		gchar* album = NULL;
		GstTagList* _tmp39_;
		gchar* _tmp40_ = NULL;
		gboolean _tmp41_;
		gchar* grouping = NULL;
		GstTagList* _tmp44_;
		gchar* _tmp45_ = NULL;
		gboolean _tmp46_;
		gchar* genre = NULL;
		GstTagList* _tmp49_;
		gchar* _tmp50_ = NULL;
		gboolean _tmp51_;
		gchar* comment = NULL;
		GstTagList* _tmp54_;
		gchar* _tmp55_ = NULL;
		gboolean _tmp56_;
		gchar* lyrics = NULL;
		GstTagList* _tmp59_;
		gchar* _tmp60_ = NULL;
		gboolean _tmp61_;
		guint track_number = 0U;
		GstTagList* _tmp64_;
		guint _tmp65_ = 0U;
		gboolean _tmp66_;
		guint track_count = 0U;
		GstTagList* _tmp69_;
		guint _tmp70_ = 0U;
		gboolean _tmp71_;
		guint album_number = 0U;
		GstTagList* _tmp74_;
		guint _tmp75_ = 0U;
		gboolean _tmp76_;
		guint album_count = 0U;
		GstTagList* _tmp79_;
		guint _tmp80_ = 0U;
		gboolean _tmp81_;
		guint bitrate = 0U;
		GstTagList* _tmp84_;
		guint _tmp85_ = 0U;
		gboolean _tmp86_;
		guint rating = 0U;
		GstTagList* _tmp89_;
		guint _tmp90_ = 0U;
		gboolean _tmp91_;
		GstDateTime* datetime = NULL;
		GstTagList* _tmp94_;
		GstDateTime* _tmp95_ = NULL;
		gboolean _tmp96_;
		gdouble bpm = 0.0;
		GstTagList* _tmp108_;
		gdouble _tmp109_ = 0.0;
		gboolean _tmp110_;
		guint64 _tmp114_;
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		_tmp19_ = tags;
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		_tmp21_ = gst_tag_list_get_string (_tmp19_, GST_TAG_TITLE, &_tmp20_);
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (title);
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		title = _tmp20_;
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp21_) {
#line 849 "GStreamerTagger.c"
			NoiseMedia* _tmp22_;
			const gchar* _tmp23_;
#line 152 "../src/GStreamer/GStreamerTagger.vala"
			_tmp22_ = m;
#line 152 "../src/GStreamer/GStreamerTagger.vala"
			_tmp23_ = title;
#line 152 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_title (_tmp22_, _tmp23_);
#line 858 "GStreamerTagger.c"
		}
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		_tmp24_ = tags;
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		_tmp26_ = gst_tag_list_get_string (_tmp24_, GST_TAG_ARTIST, &_tmp25_);
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (artist);
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		artist = _tmp25_;
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp26_) {
#line 870 "GStreamerTagger.c"
			NoiseMedia* _tmp27_;
			const gchar* _tmp28_;
#line 156 "../src/GStreamer/GStreamerTagger.vala"
			_tmp27_ = m;
#line 156 "../src/GStreamer/GStreamerTagger.vala"
			_tmp28_ = artist;
#line 156 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_artist (_tmp27_, _tmp28_);
#line 879 "GStreamerTagger.c"
		}
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		_tmp29_ = tags;
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		_tmp31_ = gst_tag_list_get_string (_tmp29_, GST_TAG_COMPOSER, &_tmp30_);
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (composer);
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		composer = _tmp30_;
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp31_) {
#line 891 "GStreamerTagger.c"
			NoiseMedia* _tmp32_;
			const gchar* _tmp33_;
#line 160 "../src/GStreamer/GStreamerTagger.vala"
			_tmp32_ = m;
#line 160 "../src/GStreamer/GStreamerTagger.vala"
			_tmp33_ = composer;
#line 160 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_composer (_tmp32_, _tmp33_);
#line 900 "GStreamerTagger.c"
		}
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		_tmp34_ = tags;
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		_tmp36_ = gst_tag_list_get_string (_tmp34_, GST_TAG_ALBUM_ARTIST, &_tmp35_);
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album_artist);
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		album_artist = _tmp35_;
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp36_) {
#line 912 "GStreamerTagger.c"
			NoiseMedia* _tmp37_;
			const gchar* _tmp38_;
#line 164 "../src/GStreamer/GStreamerTagger.vala"
			_tmp37_ = m;
#line 164 "../src/GStreamer/GStreamerTagger.vala"
			_tmp38_ = album_artist;
#line 164 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_artist (_tmp37_, _tmp38_);
#line 921 "GStreamerTagger.c"
		}
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		_tmp39_ = tags;
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		_tmp41_ = gst_tag_list_get_string (_tmp39_, GST_TAG_ALBUM, &_tmp40_);
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album);
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		album = _tmp40_;
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp41_) {
#line 933 "GStreamerTagger.c"
			NoiseMedia* _tmp42_;
			const gchar* _tmp43_;
#line 168 "../src/GStreamer/GStreamerTagger.vala"
			_tmp42_ = m;
#line 168 "../src/GStreamer/GStreamerTagger.vala"
			_tmp43_ = album;
#line 168 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album (_tmp42_, _tmp43_);
#line 942 "GStreamerTagger.c"
		}
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		_tmp44_ = tags;
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		_tmp46_ = gst_tag_list_get_string (_tmp44_, GST_TAG_GROUPING, &_tmp45_);
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (grouping);
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		grouping = _tmp45_;
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp46_) {
#line 954 "GStreamerTagger.c"
			NoiseMedia* _tmp47_;
			const gchar* _tmp48_;
#line 172 "../src/GStreamer/GStreamerTagger.vala"
			_tmp47_ = m;
#line 172 "../src/GStreamer/GStreamerTagger.vala"
			_tmp48_ = grouping;
#line 172 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_grouping (_tmp47_, _tmp48_);
#line 963 "GStreamerTagger.c"
		}
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		_tmp49_ = tags;
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		_tmp51_ = gst_tag_list_get_string (_tmp49_, GST_TAG_GENRE, &_tmp50_);
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (genre);
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		genre = _tmp50_;
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp51_) {
#line 975 "GStreamerTagger.c"
			NoiseMedia* _tmp52_;
			const gchar* _tmp53_;
#line 176 "../src/GStreamer/GStreamerTagger.vala"
			_tmp52_ = m;
#line 176 "../src/GStreamer/GStreamerTagger.vala"
			_tmp53_ = genre;
#line 176 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_genre (_tmp52_, _tmp53_);
#line 984 "GStreamerTagger.c"
		}
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		_tmp54_ = tags;
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		_tmp56_ = gst_tag_list_get_string (_tmp54_, GST_TAG_COMMENT, &_tmp55_);
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (comment);
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		comment = _tmp55_;
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp56_) {
#line 996 "GStreamerTagger.c"
			NoiseMedia* _tmp57_;
			const gchar* _tmp58_;
#line 180 "../src/GStreamer/GStreamerTagger.vala"
			_tmp57_ = m;
#line 180 "../src/GStreamer/GStreamerTagger.vala"
			_tmp58_ = comment;
#line 180 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_comment (_tmp57_, _tmp58_);
#line 1005 "GStreamerTagger.c"
		}
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		_tmp59_ = tags;
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		_tmp61_ = gst_tag_list_get_string (_tmp59_, GST_TAG_LYRICS, &_tmp60_);
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (lyrics);
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		lyrics = _tmp60_;
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp61_) {
#line 1017 "GStreamerTagger.c"
			NoiseMedia* _tmp62_;
			const gchar* _tmp63_;
#line 184 "../src/GStreamer/GStreamerTagger.vala"
			_tmp62_ = m;
#line 184 "../src/GStreamer/GStreamerTagger.vala"
			_tmp63_ = lyrics;
#line 184 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_lyrics (_tmp62_, _tmp63_);
#line 1026 "GStreamerTagger.c"
		}
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		_tmp64_ = tags;
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		_tmp66_ = gst_tag_list_get_uint (_tmp64_, GST_TAG_TRACK_NUMBER, &_tmp65_);
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		track_number = _tmp65_;
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp66_) {
#line 1036 "GStreamerTagger.c"
			NoiseMedia* _tmp67_;
			guint _tmp68_;
#line 188 "../src/GStreamer/GStreamerTagger.vala"
			_tmp67_ = m;
#line 188 "../src/GStreamer/GStreamerTagger.vala"
			_tmp68_ = track_number;
#line 188 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_track (_tmp67_, _tmp68_);
#line 1045 "GStreamerTagger.c"
		}
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		_tmp69_ = tags;
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		_tmp71_ = gst_tag_list_get_uint (_tmp69_, GST_TAG_TRACK_COUNT, &_tmp70_);
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		track_count = _tmp70_;
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp71_) {
#line 1055 "GStreamerTagger.c"
			NoiseMedia* _tmp72_;
			guint _tmp73_;
#line 192 "../src/GStreamer/GStreamerTagger.vala"
			_tmp72_ = m;
#line 192 "../src/GStreamer/GStreamerTagger.vala"
			_tmp73_ = track_count;
#line 192 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_track_count (_tmp72_, _tmp73_);
#line 1064 "GStreamerTagger.c"
		}
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		_tmp74_ = tags;
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		_tmp76_ = gst_tag_list_get_uint (_tmp74_, GST_TAG_ALBUM_VOLUME_NUMBER, &_tmp75_);
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		album_number = _tmp75_;
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp76_) {
#line 1074 "GStreamerTagger.c"
			NoiseMedia* _tmp77_;
			guint _tmp78_;
#line 196 "../src/GStreamer/GStreamerTagger.vala"
			_tmp77_ = m;
#line 196 "../src/GStreamer/GStreamerTagger.vala"
			_tmp78_ = album_number;
#line 196 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_number (_tmp77_, _tmp78_);
#line 1083 "GStreamerTagger.c"
		}
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		_tmp79_ = tags;
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		_tmp81_ = gst_tag_list_get_uint (_tmp79_, GST_TAG_ALBUM_VOLUME_COUNT, &_tmp80_);
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		album_count = _tmp80_;
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp81_) {
#line 1093 "GStreamerTagger.c"
			NoiseMedia* _tmp82_;
			guint _tmp83_;
#line 200 "../src/GStreamer/GStreamerTagger.vala"
			_tmp82_ = m;
#line 200 "../src/GStreamer/GStreamerTagger.vala"
			_tmp83_ = album_count;
#line 200 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_count (_tmp82_, _tmp83_);
#line 1102 "GStreamerTagger.c"
		}
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		_tmp84_ = tags;
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		_tmp86_ = gst_tag_list_get_uint (_tmp84_, GST_TAG_BITRATE, &_tmp85_);
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		bitrate = _tmp85_;
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp86_) {
#line 1112 "GStreamerTagger.c"
			NoiseMedia* _tmp87_;
			guint _tmp88_;
#line 204 "../src/GStreamer/GStreamerTagger.vala"
			_tmp87_ = m;
#line 204 "../src/GStreamer/GStreamerTagger.vala"
			_tmp88_ = bitrate;
#line 204 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_bitrate (_tmp87_, _tmp88_ / 1000);
#line 1121 "GStreamerTagger.c"
		}
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		_tmp89_ = tags;
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		_tmp91_ = gst_tag_list_get_uint (_tmp89_, GST_TAG_USER_RATING, &_tmp90_);
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		rating = _tmp90_;
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp91_) {
#line 1131 "GStreamerTagger.c"
			NoiseMedia* _tmp92_;
			guint _tmp93_;
#line 208 "../src/GStreamer/GStreamerTagger.vala"
			_tmp92_ = m;
#line 208 "../src/GStreamer/GStreamerTagger.vala"
			_tmp93_ = rating;
#line 208 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_rating (_tmp92_, _tmp93_);
#line 1140 "GStreamerTagger.c"
		}
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		_tmp94_ = tags;
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		_tmp96_ = gst_tag_list_get_date_time (_tmp94_, GST_TAG_DATE_TIME, &_tmp95_);
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		_gst_date_time_unref0 (datetime);
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		datetime = _tmp95_;
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp96_) {
#line 1152 "GStreamerTagger.c"
			GstDateTime* _tmp97_;
#line 217 "../src/GStreamer/GStreamerTagger.vala"
			_tmp97_ = datetime;
#line 217 "../src/GStreamer/GStreamerTagger.vala"
			if (_tmp97_ != NULL) {
#line 1158 "GStreamerTagger.c"
				NoiseMedia* _tmp98_;
				GstDateTime* _tmp99_;
#line 218 "../src/GStreamer/GStreamerTagger.vala"
				_tmp98_ = m;
#line 218 "../src/GStreamer/GStreamerTagger.vala"
				_tmp99_ = datetime;
#line 218 "../src/GStreamer/GStreamerTagger.vala"
				noise_media_set_year (_tmp98_, (guint) gst_date_time_get_year (_tmp99_));
#line 1167 "GStreamerTagger.c"
			} else {
				GDate* date = NULL;
				GstTagList* _tmp100_;
				GDate _tmp101_ = {0};
				gboolean _tmp102_;
				GDate _tmp103_;
				GDate* _tmp104_;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp100_ = tags;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp102_ = gst_tag_list_get_date (_tmp100_, GST_TAG_DATE, &_tmp101_);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_g_free0 (date);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp103_ = _tmp101_;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp104_ = __g_date_dup0 (&_tmp103_);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				date = _tmp104_;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp102_) {
#line 1189 "GStreamerTagger.c"
					GDate* _tmp105_;
#line 224 "../src/GStreamer/GStreamerTagger.vala"
					_tmp105_ = date;
#line 224 "../src/GStreamer/GStreamerTagger.vala"
					if (_tmp105_ != NULL) {
#line 1195 "GStreamerTagger.c"
						NoiseMedia* _tmp106_;
						GDate* _tmp107_;
#line 225 "../src/GStreamer/GStreamerTagger.vala"
						_tmp106_ = m;
#line 225 "../src/GStreamer/GStreamerTagger.vala"
						_tmp107_ = date;
#line 225 "../src/GStreamer/GStreamerTagger.vala"
						noise_media_set_year (_tmp106_, (guint) g_date_get_year (_tmp107_));
#line 1204 "GStreamerTagger.c"
					}
				}
#line 217 "../src/GStreamer/GStreamerTagger.vala"
				_g_free0 (date);
#line 1209 "GStreamerTagger.c"
			}
		}
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		_tmp108_ = tags;
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		_tmp110_ = gst_tag_list_get_double (_tmp108_, GST_TAG_BEATS_PER_MINUTE, &_tmp109_);
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		bpm = _tmp109_;
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp110_) {
#line 1220 "GStreamerTagger.c"
			NoiseMedia* _tmp111_;
			gdouble _tmp112_;
			gdouble _tmp113_;
#line 233 "../src/GStreamer/GStreamerTagger.vala"
			_tmp111_ = m;
#line 233 "../src/GStreamer/GStreamerTagger.vala"
			_tmp112_ = bpm;
#line 233 "../src/GStreamer/GStreamerTagger.vala"
			_tmp113_ = bpm;
#line 233 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_bpm (_tmp111_, (guint) CLAMP (_tmp112_, (gdouble) 0, _tmp113_));
#line 1232 "GStreamerTagger.c"
		}
#line 235 "../src/GStreamer/GStreamerTagger.vala"
		_tmp114_ = duration;
#line 235 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp114_ == ((guint64) 0)) {
#line 1238 "GStreamerTagger.c"
			GstTagList* _tmp115_;
			guint64 _tmp116_ = 0ULL;
			gboolean _tmp117_;
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			_tmp115_ = tags;
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			_tmp117_ = gst_tag_list_get_uint64 (_tmp115_, GST_TAG_DURATION, &_tmp116_);
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			duration = _tmp116_;
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			if (!_tmp117_) {
#line 237 "../src/GStreamer/GStreamerTagger.vala"
				duration = (guint64) 0;
#line 1252 "GStreamerTagger.c"
			}
		}
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_gst_date_time_unref0 (datetime);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (lyrics);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (comment);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (genre);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (grouping);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album_artist);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (composer);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (artist);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (title);
#line 1275 "GStreamerTagger.c"
	}
#line 240 "../src/GStreamer/GStreamerTagger.vala"
	_tmp118_ = m;
#line 240 "../src/GStreamer/GStreamerTagger.vala"
	_tmp119_ = duration;
#line 240 "../src/GStreamer/GStreamerTagger.vala"
	noise_media_set_length (_tmp118_, noise_time_utils_nanoseconds_to_miliseconds (_tmp119_));
#line 241 "../src/GStreamer/GStreamerTagger.vala"
	_tmp120_ = gst_discoverer_info_get_audio_streams (info);
#line 1285 "GStreamerTagger.c"
	{
		GList* stream_info_collection = NULL;
		GList* stream_info_it = NULL;
#line 241 "../src/GStreamer/GStreamerTagger.vala"
		stream_info_collection = _tmp120_;
#line 241 "../src/GStreamer/GStreamerTagger.vala"
		for (stream_info_it = stream_info_collection; stream_info_it != NULL; stream_info_it = stream_info_it->next) {
#line 1293 "GStreamerTagger.c"
			GstDiscovererStreamInfo* _tmp121_;
			GstDiscovererStreamInfo* stream_info = NULL;
#line 241 "../src/GStreamer/GStreamerTagger.vala"
			_tmp121_ = _g_object_ref0 ((GstDiscovererStreamInfo*) stream_info_it->data);
#line 241 "../src/GStreamer/GStreamerTagger.vala"
			stream_info = _tmp121_;
#line 1300 "GStreamerTagger.c"
			{
				GstDiscovererAudioInfo* audio_stream = NULL;
				GstDiscovererStreamInfo* _tmp122_;
				GstDiscovererAudioInfo* _tmp123_;
				GstDiscovererAudioInfo* _tmp124_;
				NoiseMedia* _tmp125_;
				guint _tmp126_;
				guint _tmp127_;
				NoiseMedia* _tmp135_;
				guint _tmp136_;
				guint _tmp137_;
#line 242 "../src/GStreamer/GStreamerTagger.vala"
				_tmp122_ = stream_info;
#line 242 "../src/GStreamer/GStreamerTagger.vala"
				_tmp123_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp122_, gst_discoverer_audio_info_get_type ()) ? ((GstDiscovererAudioInfo*) _tmp122_) : NULL);
#line 242 "../src/GStreamer/GStreamerTagger.vala"
				audio_stream = _tmp123_;
#line 243 "../src/GStreamer/GStreamerTagger.vala"
				_tmp124_ = audio_stream;
#line 243 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp124_ == NULL) {
#line 244 "../src/GStreamer/GStreamerTagger.vala"
					_g_object_unref0 (audio_stream);
#line 244 "../src/GStreamer/GStreamerTagger.vala"
					_g_object_unref0 (stream_info);
#line 244 "../src/GStreamer/GStreamerTagger.vala"
					continue;
#line 1328 "GStreamerTagger.c"
				}
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				_tmp125_ = m;
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				_tmp126_ = noise_media_get_samplerate (_tmp125_);
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				_tmp127_ = _tmp126_;
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp127_ == ((guint) 0)) {
#line 1338 "GStreamerTagger.c"
					NoiseMedia* _tmp128_;
					GstDiscovererAudioInfo* _tmp129_;
					NoiseMedia* _tmp130_;
					guint _tmp131_;
					guint _tmp132_;
					gchar* _tmp133_;
					gchar* _tmp134_;
#line 247 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:247: Getting sample rate from stream info");
#line 248 "../src/GStreamer/GStreamerTagger.vala"
					_tmp128_ = m;
#line 248 "../src/GStreamer/GStreamerTagger.vala"
					_tmp129_ = audio_stream;
#line 248 "../src/GStreamer/GStreamerTagger.vala"
					noise_media_set_samplerate (_tmp128_, gst_discoverer_audio_info_get_sample_rate (_tmp129_));
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp130_ = m;
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp131_ = noise_media_get_samplerate (_tmp130_);
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp132_ = _tmp131_;
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp133_ = g_strdup_printf ("%u", _tmp132_);
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp134_ = _tmp133_;
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:249: Sample rate = %s", _tmp134_);
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_g_free0 (_tmp134_);
#line 1368 "GStreamerTagger.c"
				}
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				_tmp135_ = m;
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				_tmp136_ = noise_media_get_bitrate (_tmp135_);
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				_tmp137_ = _tmp136_;
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp137_ == ((guint) 0)) {
#line 1378 "GStreamerTagger.c"
					NoiseMedia* _tmp138_;
					GstDiscovererAudioInfo* _tmp139_;
					NoiseMedia* _tmp140_;
					guint _tmp141_;
					guint _tmp142_;
					gchar* _tmp143_;
					gchar* _tmp144_;
#line 253 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:253: Getting bitrate from stream info");
#line 254 "../src/GStreamer/GStreamerTagger.vala"
					_tmp138_ = m;
#line 254 "../src/GStreamer/GStreamerTagger.vala"
					_tmp139_ = audio_stream;
#line 254 "../src/GStreamer/GStreamerTagger.vala"
					noise_media_set_bitrate (_tmp138_, gst_discoverer_audio_info_get_bitrate (_tmp139_));
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp140_ = m;
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp141_ = noise_media_get_bitrate (_tmp140_);
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp142_ = _tmp141_;
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp143_ = g_strdup_printf ("%u", _tmp142_);
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp144_ = _tmp143_;
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:255: Bitrate = %s", _tmp144_);
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_g_free0 (_tmp144_);
#line 1408 "GStreamerTagger.c"
				}
#line 258 "../src/GStreamer/GStreamerTagger.vala"
				_g_object_unref0 (audio_stream);
#line 258 "../src/GStreamer/GStreamerTagger.vala"
				_g_object_unref0 (stream_info);
#line 258 "../src/GStreamer/GStreamerTagger.vala"
				break;
#line 1416 "GStreamerTagger.c"
			}
		}
#line 241 "../src/GStreamer/GStreamerTagger.vala"
		(stream_info_collection == NULL) ? NULL : (stream_info_collection = (_g_list_free__g_object_unref0_ (stream_info_collection), NULL));
#line 1421 "GStreamerTagger.c"
	}
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp145_ = m;
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp146_ = m;
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp147_ = noise_media_get_file (_tmp146_);
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp148_ = _tmp147_;
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	noise_media_set_file_size (_tmp145_, noise_file_utils_get_size (_tmp148_, NULL));
#line 262 "../src/GStreamer/GStreamerTagger.vala"
	_tmp149_ = m;
#line 262 "../src/GStreamer/GStreamerTagger.vala"
	_tmp150_ = time (NULL);
#line 262 "../src/GStreamer/GStreamerTagger.vala"
	noise_media_set_date_added (_tmp149_, (guint) ((gint) _tmp150_));
#line 263 "../src/GStreamer/GStreamerTagger.vala"
	_tmp151_ = m;
#line 263 "../src/GStreamer/GStreamerTagger.vala"
	g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL], 0, _tmp151_);
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (m);
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	_g_free0 (uri);
#line 1447 "GStreamerTagger.c"
}


static void
g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (n_param_values == 3);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data1 = closure->data;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data2 = param_values->data[0].v_pointer;
#line 1473 "GStreamerTagger.c"
	} else {
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data2 = closure->data;
#line 1479 "GStreamerTagger.c"
	}
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 1485 "GStreamerTagger.c"
}


static void
noise_gstreamer_tagger_class_init (NoiseGStreamerTaggerClass * klass)
{
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	g_type_class_adjust_private_offset (klass, &NoiseGStreamerTagger_private_offset);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_gstreamer_tagger_finalize;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL] = g_signal_new ("import-error", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_POINTER);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL] = g_signal_new ("queue-finished", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1504 "GStreamerTagger.c"
}


static void
noise_gstreamer_tagger_instance_init (NoiseGStreamerTagger * self)
{
	GeeLinkedList* _tmp0_;
	GCancellable* _tmp1_;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	self->priv = noise_gstreamer_tagger_get_instance_private (self);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	g_rec_mutex_init (&self->priv->__lock_uri_queue);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	self->priv->uri_queue = _tmp0_;
#line 39 "../src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = g_cancellable_new ();
#line 39 "../src/GStreamer/GStreamerTagger.vala"
	self->priv->cancellable = _tmp1_;
#line 1525 "GStreamerTagger.c"
}


static void
noise_gstreamer_tagger_finalize (GObject * obj)
{
	NoiseGStreamerTagger * self;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger);
#line 37 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->d);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	g_rec_mutex_clear (&self->priv->__lock_uri_queue);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->uri_queue);
#line 39 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	G_OBJECT_CLASS (noise_gstreamer_tagger_parent_class)->finalize (obj);
#line 1545 "GStreamerTagger.c"
}


GType
noise_gstreamer_tagger_get_type (void)
{
	static volatile gsize noise_gstreamer_tagger_type_id__volatile = 0;
	if (g_once_init_enter (&noise_gstreamer_tagger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseGStreamerTaggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_gstreamer_tagger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseGStreamerTagger), 0, (GInstanceInitFunc) noise_gstreamer_tagger_instance_init, NULL };
		GType noise_gstreamer_tagger_type_id;
		noise_gstreamer_tagger_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseGStreamerTagger", &g_define_type_info, 0);
		NoiseGStreamerTagger_private_offset = g_type_add_instance_private (noise_gstreamer_tagger_type_id, sizeof (NoiseGStreamerTaggerPrivate));
		g_once_init_leave (&noise_gstreamer_tagger_type_id__volatile, noise_gstreamer_tagger_type_id);
	}
	return noise_gstreamer_tagger_type_id__volatile;
}



