/* DeviceView.c generated by valac 0.42.6, the Vala compiler
 * generated from DeviceView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_DEVICE_VIEW (noise_device_view_get_type ())
#define NOISE_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView))
#define NOISE_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))
#define NOISE_IS_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_IS_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_DEVICE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))

typedef struct _NoiseDeviceView NoiseDeviceView;
typedef struct _NoiseDeviceViewClass NoiseDeviceViewClass;
typedef struct _NoiseDeviceViewPrivate NoiseDeviceViewPrivate;

#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;
enum  {
	NOISE_DEVICE_VIEW_0_PROPERTY,
	NOISE_DEVICE_VIEW_DEVICE_PROPERTY,
	NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY,
	NOISE_DEVICE_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_device_view_properties[NOISE_DEVICE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block21Data Block21Data;

#define NOISE_TYPE_DEVICE_SUMMARY_WIDGET (noise_device_summary_widget_get_type ())
#define NOISE_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget))
#define NOISE_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidgetClass))
#define NOISE_IS_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET))
#define NOISE_IS_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_SUMMARY_WIDGET))
#define NOISE_DEVICE_SUMMARY_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidgetClass))

typedef struct _NoiseDeviceSummaryWidget NoiseDeviceSummaryWidget;
typedef struct _NoiseDeviceSummaryWidgetClass NoiseDeviceSummaryWidgetClass;

struct _NoiseDeviceView {
	GtkGrid parent_instance;
	NoiseDeviceViewPrivate * priv;
};

struct _NoiseDeviceViewClass {
	GtkGridClass parent_class;
};

struct _NoiseDeviceViewPrivate {
	NoiseDevice* _device;
	NoiseDevicePreferences* _preferences;
};

struct _Block21Data {
	int _ref_count_;
	NoiseDeviceView* self;
	GtkLabel* infobar_label;
	GtkInfoBar* infobar;
	gulong connector;
};


static gint NoiseDeviceView_private_offset;
static gpointer noise_device_view_parent_class = NULL;

GType noise_device_view_get_type (void) G_GNUC_CONST;
GType noise_device_preferences_get_type (void) G_GNUC_CONST;
NoiseDeviceView* noise_device_view_new (NoiseDevice* device,
                                        NoiseDevicePreferences* preferences);
NoiseDeviceView* noise_device_view_construct (GType object_type,
                                              NoiseDevice* device,
                                              NoiseDevicePreferences* preferences);
NoiseDevice* noise_device_view_get_device (NoiseDeviceView* self);
static void noise_device_view_set_device (NoiseDeviceView* self,
                                   NoiseDevice* value);
NoiseDevicePreferences* noise_device_view_get_preferences (NoiseDeviceView* self);
static void noise_device_view_set_preferences (NoiseDeviceView* self,
                                        NoiseDevicePreferences* value);
static GObject * noise_device_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
GType noise_device_summary_widget_get_type (void) G_GNUC_CONST;
NoiseDeviceSummaryWidget* noise_device_summary_widget_new (NoiseDevice* device,
                                                           NoiseDevicePreferences* preferences);
NoiseDeviceSummaryWidget* noise_device_summary_widget_construct (GType object_type,
                                                                 NoiseDevice* device,
                                                                 NoiseDevicePreferences* preferences);
static void _noise_device_view___lambda115_ (NoiseDeviceView* self);
static void __noise_device_view___lambda115__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                                                    gpointer self);
static void _noise_device_view___lambda116_ (Block21Data* _data21_);
static void __noise_device_view___lambda116__noise_device_device_unmounted (NoiseDevice* _sender,
                                                                     gpointer self);
static void _noise_device_view___lambda117_ (Block21Data* _data21_,
                                      const gchar* label,
                                      GtkMessageType message_type);
static void __noise_device_view___lambda117__noise_device_infobar_message (NoiseDevice* _sender,
                                                                    const gchar* label,
                                                                    GtkMessageType message_type,
                                                                    gpointer self);
static void _noise_device_view___lambda118_ (Block21Data* _data21_,
                                      GtkInfoBar* _self_,
                                      gint response);
static void __noise_device_view___lambda118__gtk_info_bar_response (GtkInfoBar* _sender,
                                                             gint response_id,
                                                             gpointer self);
gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self);
void noise_device_summary_widget_sync_clicked (NoiseDeviceSummaryWidget* self);
static void noise_device_view_finalize (GObject * obj);
static void _vala_noise_device_view_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_device_view_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_device_view_get_instance_private (NoiseDeviceView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseDeviceView_private_offset);
}


NoiseDeviceView*
noise_device_view_construct (GType object_type,
                             NoiseDevice* device,
                             NoiseDevicePreferences* preferences)
{
	NoiseDeviceView * self = NULL;
#line 33 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 33 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (preferences != NULL, NULL);
#line 34 "../src/Views/DeviceView.vala"
	self = (NoiseDeviceView*) g_object_new (object_type, "device", device, "preferences", preferences, NULL);
#line 33 "../src/Views/DeviceView.vala"
	return self;
#line 186 "DeviceView.c"
}


NoiseDeviceView*
noise_device_view_new (NoiseDevice* device,
                       NoiseDevicePreferences* preferences)
{
#line 33 "../src/Views/DeviceView.vala"
	return noise_device_view_construct (NOISE_TYPE_DEVICE_VIEW, device, preferences);
#line 196 "DeviceView.c"
}


NoiseDevice*
noise_device_view_get_device (NoiseDeviceView* self)
{
	NoiseDevice* result;
	NoiseDevice* _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_device;
#line 30 "../src/Views/DeviceView.vala"
	result = _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
	return result;
#line 213 "DeviceView.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Views/DeviceView.vala"
	return self ? g_object_ref (self) : NULL;
#line 222 "DeviceView.c"
}


static void
noise_device_view_set_device (NoiseDeviceView* self,
                              NoiseDevice* value)
{
#line 30 "../src/Views/DeviceView.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Views/DeviceView.vala"
	if (noise_device_view_get_device (self) != value) {
#line 234 "DeviceView.c"
		NoiseDevice* _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Views/DeviceView.vala"
		_g_object_unref0 (self->priv->_device);
#line 30 "../src/Views/DeviceView.vala"
		self->priv->_device = _tmp0_;
#line 30 "../src/Views/DeviceView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_device_view_properties[NOISE_DEVICE_VIEW_DEVICE_PROPERTY]);
#line 244 "DeviceView.c"
	}
}


NoiseDevicePreferences*
noise_device_view_get_preferences (NoiseDeviceView* self)
{
	NoiseDevicePreferences* result;
	NoiseDevicePreferences* _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_preferences;
#line 31 "../src/Views/DeviceView.vala"
	result = _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
	return result;
#line 262 "DeviceView.c"
}


static void
noise_device_view_set_preferences (NoiseDeviceView* self,
                                   NoiseDevicePreferences* value)
{
#line 31 "../src/Views/DeviceView.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Views/DeviceView.vala"
	if (noise_device_view_get_preferences (self) != value) {
#line 274 "DeviceView.c"
		NoiseDevicePreferences* _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Views/DeviceView.vala"
		_g_object_unref0 (self->priv->_preferences);
#line 31 "../src/Views/DeviceView.vala"
		self->priv->_preferences = _tmp0_;
#line 31 "../src/Views/DeviceView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_device_view_properties[NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY]);
#line 284 "DeviceView.c"
	}
}


static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 40 "../src/Views/DeviceView.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 40 "../src/Views/DeviceView.vala"
	return _data21_;
#line 296 "DeviceView.c"
}


static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 40 "../src/Views/DeviceView.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 307 "DeviceView.c"
		NoiseDeviceView* self;
#line 40 "../src/Views/DeviceView.vala"
		self = _data21_->self;
#line 40 "../src/Views/DeviceView.vala"
		_g_object_unref0 (_data21_->infobar);
#line 40 "../src/Views/DeviceView.vala"
		_g_object_unref0 (_data21_->infobar_label);
#line 40 "../src/Views/DeviceView.vala"
		_g_object_unref0 (self);
#line 40 "../src/Views/DeviceView.vala"
		g_slice_free (Block21Data, _data21_);
#line 319 "DeviceView.c"
	}
}


static void
_noise_device_view___lambda115_ (NoiseDeviceView* self)
{
	NoiseDevice* _tmp0_;
	NoiseLibrary* _tmp1_;
	NoiseLibrary* _tmp2_;
	gboolean _tmp3_;
#line 65 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_device;
#line 65 "../src/Views/DeviceView.vala"
	_tmp1_ = noise_device_get_library (_tmp0_);
#line 65 "../src/Views/DeviceView.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/Views/DeviceView.vala"
	_tmp3_ = noise_library_doing_file_operations (_tmp2_);
#line 65 "../src/Views/DeviceView.vala"
	_g_object_unref0 (_tmp2_);
#line 65 "../src/Views/DeviceView.vala"
	if (_tmp3_) {
#line 343 "DeviceView.c"
		NoiseNotificationManager* _tmp4_;
		NoiseNotificationManager* _tmp5_;
#line 66 "../src/Views/DeviceView.vala"
		_tmp4_ = noise_notification_manager_get_default ();
#line 66 "../src/Views/DeviceView.vala"
		_tmp5_ = _tmp4_;
#line 66 "../src/Views/DeviceView.vala"
		g_signal_emit_by_name (_tmp5_, "show-alert", _ ("Cancelling…"), _ ("Device operation has been cancelled and will stop after this media."));
#line 66 "../src/Views/DeviceView.vala"
		_g_object_unref0 (_tmp5_);
#line 354 "DeviceView.c"
	}
}


static void
__noise_device_view___lambda115__noise_notification_manager_progress_canceled (NoiseNotificationManager* _sender,
                                                                               gpointer self)
{
#line 64 "../src/Views/DeviceView.vala"
	_noise_device_view___lambda115_ ((NoiseDeviceView*) self);
#line 365 "DeviceView.c"
}


static void
_noise_device_view___lambda116_ (Block21Data* _data21_)
{
	NoiseDeviceView* self;
	NoiseDevice* _tmp0_;
	gulong _tmp1_;
#line 70 "../src/Views/DeviceView.vala"
	self = _data21_->self;
#line 71 "../src/Views/DeviceView.vala"
	g_message ("DeviceView.vala:71: device unmounted\n");
#line 72 "../src/Views/DeviceView.vala"
	_tmp0_ = self->priv->_device;
#line 72 "../src/Views/DeviceView.vala"
	_tmp1_ = _data21_->connector;
#line 72 "../src/Views/DeviceView.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _tmp1_);
#line 385 "DeviceView.c"
}


static void
__noise_device_view___lambda116__noise_device_device_unmounted (NoiseDevice* _sender,
                                                                gpointer self)
{
#line 70 "../src/Views/DeviceView.vala"
	_noise_device_view___lambda116_ (self);
#line 395 "DeviceView.c"
}


static void
_noise_device_view___lambda117_ (Block21Data* _data21_,
                                 const gchar* label,
                                 GtkMessageType message_type)
{
	NoiseDeviceView* self;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
#line 75 "../src/Views/DeviceView.vala"
	self = _data21_->self;
#line 75 "../src/Views/DeviceView.vala"
	g_return_if_fail (label != NULL);
#line 76 "../src/Views/DeviceView.vala"
	_tmp0_ = _data21_->infobar_label;
#line 76 "../src/Views/DeviceView.vala"
	gtk_label_set_label (_tmp0_, label);
#line 77 "../src/Views/DeviceView.vala"
	_tmp1_ = _data21_->infobar;
#line 77 "../src/Views/DeviceView.vala"
	gtk_info_bar_set_message_type (_tmp1_, message_type);
#line 78 "../src/Views/DeviceView.vala"
	_tmp2_ = _data21_->infobar;
#line 78 "../src/Views/DeviceView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 424 "DeviceView.c"
}


static void
__noise_device_view___lambda117__noise_device_infobar_message (NoiseDevice* _sender,
                                                               const gchar* label,
                                                               GtkMessageType message_type,
                                                               gpointer self)
{
#line 75 "../src/Views/DeviceView.vala"
	_noise_device_view___lambda117_ (self, label, message_type);
#line 436 "DeviceView.c"
}


static void
_noise_device_view___lambda118_ (Block21Data* _data21_,
                                 GtkInfoBar* _self_,
                                 gint response)
{
	NoiseDeviceView* self;
	GtkInfoBar* _tmp0_;
#line 81 "../src/Views/DeviceView.vala"
	self = _data21_->self;
#line 81 "../src/Views/DeviceView.vala"
	g_return_if_fail (_self_ != NULL);
#line 82 "../src/Views/DeviceView.vala"
	_tmp0_ = _data21_->infobar;
#line 82 "../src/Views/DeviceView.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 455 "DeviceView.c"
}


static void
__noise_device_view___lambda118__gtk_info_bar_response (GtkInfoBar* _sender,
                                                        gint response_id,
                                                        gpointer self)
{
#line 81 "../src/Views/DeviceView.vala"
	_noise_device_view___lambda118_ (self, _sender, response_id);
#line 466 "DeviceView.c"
}


static GObject *
noise_device_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseDeviceView * self;
	Block21Data* _data21_;
	GtkLabel* _tmp0_;
	GtkInfoBar* _tmp1_;
	GtkInfoBar* _tmp2_;
	GtkInfoBar* _tmp3_;
	GtkInfoBar* _tmp4_;
	GtkContainer* _tmp5_;
	GtkLabel* _tmp6_;
	NoiseDeviceSummaryWidget* summary = NULL;
	NoiseDevice* _tmp7_;
	NoiseDevicePreferences* _tmp8_;
	NoiseDeviceSummaryWidget* _tmp9_;
	GtkInfoBar* _tmp10_;
	GtkWidget* custom_view = NULL;
	NoiseDevice* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkInfoBar* _tmp16_;
	NoiseNotificationManager* _tmp17_;
	NoiseNotificationManager* _tmp18_;
	gulong _tmp19_;
	gulong _tmp20_;
	NoiseDevice* _tmp21_;
	NoiseDevice* _tmp22_;
	GtkInfoBar* _tmp23_;
	NoiseDevicePreferences* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
#line 40 "../src/Views/DeviceView.vala"
	parent_class = G_OBJECT_CLASS (noise_device_view_parent_class);
#line 40 "../src/Views/DeviceView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/Views/DeviceView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
#line 40 "../src/Views/DeviceView.vala"
	_data21_ = g_slice_new0 (Block21Data);
#line 40 "../src/Views/DeviceView.vala"
	_data21_->_ref_count_ = 1;
#line 40 "../src/Views/DeviceView.vala"
	_data21_->self = g_object_ref (self);
#line 41 "../src/Views/DeviceView.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 41 "../src/Views/DeviceView.vala"
	g_object_ref_sink (_tmp0_);
#line 41 "../src/Views/DeviceView.vala"
	_data21_->infobar_label = _tmp0_;
#line 43 "../src/Views/DeviceView.vala"
	_tmp1_ = (GtkInfoBar*) gtk_info_bar_new ();
#line 43 "../src/Views/DeviceView.vala"
	g_object_ref_sink (_tmp1_);
#line 43 "../src/Views/DeviceView.vala"
	_data21_->infobar = _tmp1_;
#line 44 "../src/Views/DeviceView.vala"
	_tmp2_ = _data21_->infobar;
#line 44 "../src/Views/DeviceView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 45 "../src/Views/DeviceView.vala"
	_tmp3_ = _data21_->infobar;
#line 45 "../src/Views/DeviceView.vala"
	gtk_info_bar_add_button (_tmp3_, _ ("Close"), 0);
#line 46 "../src/Views/DeviceView.vala"
	_tmp4_ = _data21_->infobar;
#line 46 "../src/Views/DeviceView.vala"
	_tmp5_ = gtk_info_bar_get_content_area (_tmp4_);
#line 46 "../src/Views/DeviceView.vala"
	_tmp6_ = _data21_->infobar_label;
#line 46 "../src/Views/DeviceView.vala"
	gtk_container_add (_tmp5_, (GtkWidget*) _tmp6_);
#line 48 "../src/Views/DeviceView.vala"
	_tmp7_ = self->priv->_device;
#line 48 "../src/Views/DeviceView.vala"
	_tmp8_ = self->priv->_preferences;
#line 48 "../src/Views/DeviceView.vala"
	_tmp9_ = noise_device_summary_widget_new (_tmp7_, _tmp8_);
#line 48 "../src/Views/DeviceView.vala"
	g_object_ref_sink (_tmp9_);
#line 48 "../src/Views/DeviceView.vala"
	summary = _tmp9_;
#line 50 "../src/Views/DeviceView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 51 "../src/Views/DeviceView.vala"
	_tmp10_ = _data21_->infobar;
#line 51 "../src/Views/DeviceView.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
#line 53 "../src/Views/DeviceView.vala"
	_tmp11_ = self->priv->_device;
#line 53 "../src/Views/DeviceView.vala"
	_tmp12_ = noise_device_get_custom_view (_tmp11_);
#line 53 "../src/Views/DeviceView.vala"
	custom_view = _tmp12_;
#line 54 "../src/Views/DeviceView.vala"
	_tmp13_ = custom_view;
#line 54 "../src/Views/DeviceView.vala"
	if (_tmp13_ != NULL) {
#line 572 "DeviceView.c"
		GtkWidget* _tmp14_;
#line 55 "../src/Views/DeviceView.vala"
		_tmp14_ = custom_view;
#line 55 "../src/Views/DeviceView.vala"
		gtk_grid_attach ((GtkGrid*) self, _tmp14_, 0, 1, 1, 1);
#line 578 "DeviceView.c"
	} else {
		NoiseDeviceSummaryWidget* _tmp15_;
#line 57 "../src/Views/DeviceView.vala"
		_tmp15_ = summary;
#line 57 "../src/Views/DeviceView.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 0, 1, 1, 1);
#line 585 "DeviceView.c"
	}
#line 60 "../src/Views/DeviceView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 62 "../src/Views/DeviceView.vala"
	_tmp16_ = _data21_->infobar;
#line 62 "../src/Views/DeviceView.vala"
	gtk_widget_hide ((GtkWidget*) _tmp16_);
#line 64 "../src/Views/DeviceView.vala"
	_tmp17_ = noise_notification_manager_get_default ();
#line 64 "../src/Views/DeviceView.vala"
	_tmp18_ = _tmp17_;
#line 64 "../src/Views/DeviceView.vala"
	_tmp19_ = g_signal_connect_object (_tmp18_, "progress-canceled", (GCallback) __noise_device_view___lambda115__noise_notification_manager_progress_canceled, self, 0);
#line 64 "../src/Views/DeviceView.vala"
	_tmp20_ = _tmp19_;
#line 64 "../src/Views/DeviceView.vala"
	_g_object_unref0 (_tmp18_);
#line 64 "../src/Views/DeviceView.vala"
	_data21_->connector = _tmp20_;
#line 70 "../src/Views/DeviceView.vala"
	_tmp21_ = self->priv->_device;
#line 70 "../src/Views/DeviceView.vala"
	g_signal_connect_data (_tmp21_, "device-unmounted", (GCallback) __noise_device_view___lambda116__noise_device_device_unmounted, block21_data_ref (_data21_), (GClosureNotify) block21_data_unref, 0);
#line 75 "../src/Views/DeviceView.vala"
	_tmp22_ = self->priv->_device;
#line 75 "../src/Views/DeviceView.vala"
	g_signal_connect_data (_tmp22_, "infobar-message", (GCallback) __noise_device_view___lambda117__noise_device_infobar_message, block21_data_ref (_data21_), (GClosureNotify) block21_data_unref, 0);
#line 81 "../src/Views/DeviceView.vala"
	_tmp23_ = _data21_->infobar;
#line 81 "../src/Views/DeviceView.vala"
	g_signal_connect_data (_tmp23_, "response", (GCallback) __noise_device_view___lambda118__gtk_info_bar_response, block21_data_ref (_data21_), (GClosureNotify) block21_data_unref, 0);
#line 85 "../src/Views/DeviceView.vala"
	_tmp24_ = self->priv->_preferences;
#line 85 "../src/Views/DeviceView.vala"
	_tmp25_ = noise_device_preferences_get_sync_when_mounted (_tmp24_);
#line 85 "../src/Views/DeviceView.vala"
	_tmp26_ = _tmp25_;
#line 85 "../src/Views/DeviceView.vala"
	if (_tmp26_) {
#line 625 "DeviceView.c"
		NoiseDeviceSummaryWidget* _tmp27_;
#line 86 "../src/Views/DeviceView.vala"
		_tmp27_ = summary;
#line 86 "../src/Views/DeviceView.vala"
		noise_device_summary_widget_sync_clicked (_tmp27_);
#line 631 "DeviceView.c"
	}
#line 40 "../src/Views/DeviceView.vala"
	_g_object_unref0 (custom_view);
#line 40 "../src/Views/DeviceView.vala"
	_g_object_unref0 (summary);
#line 40 "../src/Views/DeviceView.vala"
	block21_data_unref (_data21_);
#line 40 "../src/Views/DeviceView.vala"
	_data21_ = NULL;
#line 40 "../src/Views/DeviceView.vala"
	return obj;
#line 643 "DeviceView.c"
}


static void
noise_device_view_class_init (NoiseDeviceViewClass * klass)
{
#line 29 "../src/Views/DeviceView.vala"
	noise_device_view_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Views/DeviceView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseDeviceView_private_offset);
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_device_view_get_property;
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_device_view_set_property;
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_device_view_constructor;
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_device_view_finalize;
#line 29 "../src/Views/DeviceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_VIEW_DEVICE_PROPERTY, noise_device_view_properties[NOISE_DEVICE_VIEW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", NOISE_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Views/DeviceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY, noise_device_view_properties[NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY] = g_param_spec_object ("preferences", "preferences", "preferences", NOISE_TYPE_DEVICE_PREFERENCES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 666 "DeviceView.c"
}


static void
noise_device_view_instance_init (NoiseDeviceView * self)
{
#line 29 "../src/Views/DeviceView.vala"
	self->priv = noise_device_view_get_instance_private (self);
#line 675 "DeviceView.c"
}


static void
noise_device_view_finalize (GObject * obj)
{
	NoiseDeviceView * self;
#line 29 "../src/Views/DeviceView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
#line 30 "../src/Views/DeviceView.vala"
	_g_object_unref0 (self->priv->_device);
#line 31 "../src/Views/DeviceView.vala"
	_g_object_unref0 (self->priv->_preferences);
#line 29 "../src/Views/DeviceView.vala"
	G_OBJECT_CLASS (noise_device_view_parent_class)->finalize (obj);
#line 691 "DeviceView.c"
}


GType
noise_device_view_get_type (void)
{
	static volatile gsize noise_device_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDeviceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseDeviceView), 0, (GInstanceInitFunc) noise_device_view_instance_init, NULL };
		GType noise_device_view_type_id;
		noise_device_view_type_id = g_type_register_static (gtk_grid_get_type (), "NoiseDeviceView", &g_define_type_info, 0);
		NoiseDeviceView_private_offset = g_type_add_instance_private (noise_device_view_type_id, sizeof (NoiseDeviceViewPrivate));
		g_once_init_leave (&noise_device_view_type_id__volatile, noise_device_view_type_id);
	}
	return noise_device_view_type_id__volatile;
}


static void
_vala_noise_device_view_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoiseDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
#line 29 "../src/Views/DeviceView.vala"
	switch (property_id) {
#line 29 "../src/Views/DeviceView.vala"
		case NOISE_DEVICE_VIEW_DEVICE_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		g_value_set_object (value, noise_device_view_get_device (self));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 29 "../src/Views/DeviceView.vala"
		case NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		g_value_set_object (value, noise_device_view_get_preferences (self));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 732 "DeviceView.c"
		default:
#line 29 "../src/Views/DeviceView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 738 "DeviceView.c"
	}
}


static void
_vala_noise_device_view_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoiseDeviceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView);
#line 29 "../src/Views/DeviceView.vala"
	switch (property_id) {
#line 29 "../src/Views/DeviceView.vala"
		case NOISE_DEVICE_VIEW_DEVICE_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		noise_device_view_set_device (self, g_value_get_object (value));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 29 "../src/Views/DeviceView.vala"
		case NOISE_DEVICE_VIEW_PREFERENCES_PROPERTY:
#line 29 "../src/Views/DeviceView.vala"
		noise_device_view_set_preferences (self, g_value_get_object (value));
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 765 "DeviceView.c"
		default:
#line 29 "../src/Views/DeviceView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/DeviceView.vala"
		break;
#line 771 "DeviceView.c"
	}
}



