/* ColumnBrowser.c generated by valac 0.42.6, the Vala compiler
 * generated from ColumnBrowser.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define NOISE_TYPE_COLUMN_BROWSER (noise_column_browser_get_type ())
#define NOISE_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser))
#define NOISE_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))
#define NOISE_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))

typedef struct _NoiseColumnBrowser NoiseColumnBrowser;
typedef struct _NoiseColumnBrowserClass NoiseColumnBrowserClass;
typedef struct _NoiseColumnBrowserPrivate NoiseColumnBrowserPrivate;
typedef enum  {
	NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC,
	NOISE_COLUMN_BROWSER_POSITION_LEFT,
	NOISE_COLUMN_BROWSER_POSITION_TOP
} NoiseColumnBrowserPosition;


#define NOISE_COLUMN_BROWSER_TYPE_POSITION (noise_column_browser_position_get_type ())

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;

#define NOISE_TYPE_BROWSER_COLUMN (noise_browser_column_get_type ())
#define NOISE_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_BROWSER_COLUMN, NoiseBrowserColumn))
#define NOISE_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_BROWSER_COLUMN, NoiseBrowserColumnClass))
#define NOISE_IS_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_BROWSER_COLUMN))
#define NOISE_IS_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_BROWSER_COLUMN))
#define NOISE_BROWSER_COLUMN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_BROWSER_COLUMN, NoiseBrowserColumnClass))

typedef struct _NoiseBrowserColumn NoiseBrowserColumn;
typedef struct _NoiseBrowserColumnClass NoiseBrowserColumnClass;
enum  {
	NOISE_COLUMN_BROWSER_0_PROPERTY,
	NOISE_COLUMN_BROWSER_POSITION_PROPERTY,
	NOISE_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY,
	NOISE_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY,
	NOISE_COLUMN_BROWSER_FILTERED_PROPERTY,
	NOISE_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY,
	NOISE_COLUMN_BROWSER_INITIALIZED_PROPERTY,
	NOISE_COLUMN_BROWSER_COLUMNS_PROPERTY,
	NOISE_COLUMN_BROWSER_NUM_PROPERTIES
};
static GParamSpec* noise_column_browser_properties[NOISE_COLUMN_BROWSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	NOISE_BROWSER_COLUMN_CATEGORY_RATING,
	NOISE_BROWSER_COLUMN_CATEGORY_GROUPING,
	NOISE_BROWSER_COLUMN_CATEGORY_YEAR,
	NOISE_BROWSER_COLUMN_CATEGORY_GENRE,
	NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER,
	NOISE_BROWSER_COLUMN_CATEGORY_ARTIST,
	NOISE_BROWSER_COLUMN_CATEGORY_ALBUM,
	NOISE_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} NoiseBrowserColumnCategory;


#define NOISE_BROWSER_COLUMN_TYPE_CATEGORY (noise_browser_column_category_get_type ())
typedef struct _Block22Data Block22Data;

#define NOISE_TYPE_LIST_VIEW (noise_list_view_get_type ())
#define NOISE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIST_VIEW, NoiseListView))
#define NOISE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))
#define NOISE_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIST_VIEW))
#define NOISE_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIST_VIEW))
#define NOISE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))

typedef struct _NoiseListView NoiseListView;
typedef struct _NoiseListViewClass NoiseListViewClass;

#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_COLUMN_BROWSER_CHANGED_SIGNAL,
	NOISE_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL,
	NOISE_COLUMN_BROWSER_NUM_SIGNALS
};
static guint noise_column_browser_signals[NOISE_COLUMN_BROWSER_NUM_SIGNALS] = {0};

struct _NoiseColumnBrowser {
	GtkGrid parent_instance;
	NoiseColumnBrowserPrivate * priv;
};

struct _NoiseColumnBrowserClass {
	GtkGridClass parent_class;
};

struct _NoiseColumnBrowserPrivate {
	NoiseColumnBrowserPosition _position;
	NoiseColumnBrowserPosition _actual_position;
	NoiseViewWrapper* _view_wrapper;
	GeeTreeSet* _columns;
	GeeLinkedList* media;
	GeeCollection* search_results;
	GtkMenu* column_chooser_menu;
	GtkRadioMenuItem* top_menu_item;
	GtkRadioMenuItem* left_menu_item;
	GtkRadioMenuItem* automatic_menu_item;
};

struct _Block22Data {
	int _ref_count_;
	NoiseColumnBrowser* self;
	NoiseBrowserColumn* column;
};


static gint NoiseColumnBrowser_private_offset;
static gpointer noise_column_browser_parent_class = NULL;

GType noise_column_browser_get_type (void) G_GNUC_CONST;
GType noise_column_browser_position_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
GType noise_browser_column_get_type (void) G_GNUC_CONST;
NoiseColumnBrowser* noise_column_browser_new (NoiseViewWrapper* view_wrapper);
NoiseColumnBrowser* noise_column_browser_construct (GType object_type,
                                                    NoiseViewWrapper* view_wrapper);
void noise_column_browser_reset_filters (NoiseColumnBrowser* self);
GeeTreeSet* noise_column_browser_get_columns (NoiseColumnBrowser* self);
void noise_browser_column_select_first_item (NoiseBrowserColumn* self);
GType noise_browser_column_category_get_type (void) G_GNUC_CONST;
NoiseBrowserColumn* noise_column_browser_add_column (NoiseColumnBrowser* self,
                                                     NoiseBrowserColumnCategory type);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
NoiseBrowserColumn* noise_browser_column_new (NoiseColumnBrowser* miller_parent,
                                              NoiseBrowserColumnCategory category);
NoiseBrowserColumn* noise_browser_column_construct (GType object_type,
                                                    NoiseColumnBrowser* miller_parent,
                                                    NoiseBrowserColumnCategory category);
static void noise_column_browser_column_selection_changed (NoiseColumnBrowser* self,
                                                    NoiseBrowserColumnCategory category,
                                                    const gchar* val);
static void _noise_column_browser_column_selection_changed_noise_browser_column_selection_changed (NoiseBrowserColumn* _sender,
                                                                                            NoiseBrowserColumnCategory type,
                                                                                            const gchar* val,
                                                                                            gpointer self);
static void __lambda66_ (Block22Data* _data22_);
static void ___lambda66__noise_browser_column_reset_requested (NoiseBrowserColumn* _sender,
                                                        gpointer self);
GtkCheckMenuItem* noise_browser_column_get_menu_item (NoiseBrowserColumn* self);
static void noise_column_browser_column_row_activated (NoiseColumnBrowser* self);
static void _noise_column_browser_column_row_activated_noise_browser_column_row_activated (NoiseBrowserColumn* _sender,
                                                                                    const gchar* text,
                                                                                    gpointer self);
static void noise_column_browser_column_header_clicked (NoiseColumnBrowser* self,
                                                 GdkEventButton* e);
static void _noise_column_browser_column_header_clicked_noise_browser_column_header_clicked (NoiseBrowserColumn* _sender,
                                                                                      GdkEventButton* e,
                                                                                      gpointer self);
static void noise_column_browser_update_column_separators (NoiseColumnBrowser* self);
static void _noise_column_browser_update_column_separators_noise_browser_column_visibility_changed (NoiseBrowserColumn* _sender,
                                                                                             gboolean visible,
                                                                                             gpointer self);
void noise_column_browser_set_media (NoiseColumnBrowser* self,
                                     GeeCollection* media);
NoiseBrowserColumnCategory noise_browser_column_category_first (void);
static void noise_column_browser_populate_columns (NoiseColumnBrowser* self,
                                            NoiseBrowserColumnCategory category,
                                            gboolean inclusive);
NoiseViewWrapper* noise_column_browser_get_view_wrapper (NoiseColumnBrowser* self);
void noise_view_wrapper_play_first_media (NoiseViewWrapper* self,
                                          gboolean* force);
static void noise_column_browser_update_search_results (NoiseColumnBrowser* self,
                                                 NoiseBrowserColumnCategory parent_category);
GType noise_list_view_get_type (void) G_GNUC_CONST;
NoiseListView* noise_view_wrapper_get_list_view (NoiseViewWrapper* self);
GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
NoiseMusicListView* noise_list_view_get_list_view (NoiseListView* self);
void noise_generic_list_set_research_needed (NoiseGenericList* self,
                                             gboolean value);
static void noise_column_browser_get_filters (NoiseColumnBrowser* self,
                                       NoiseBrowserColumnCategory parent_category,
                                       gint* rating,
                                       gint* year,
                                       gchar* * genre,
                                       gchar* * album_artist,
                                       gchar* * album,
                                       gchar* * grouping,
                                       gchar* * composer);
NoiseBrowserColumnCategory noise_browser_column_get_category (NoiseBrowserColumn* self);
gchar* noise_browser_column_get_selected (NoiseBrowserColumn* self);
void noise_column_browser_fill_column (NoiseColumnBrowser* self,
                                       NoiseBrowserColumn* column);
void noise_browser_column_populate (NoiseBrowserColumn* self,
                                    GeeHashSet* items);
gboolean noise_column_browser_match_media (NoiseColumnBrowser* self,
                                           NoiseMedia* m);
NoiseBrowserColumnCategory noise_browser_column_category_last (void);
GeeTreeSet* noise_column_browser_get_visible_columns (NoiseColumnBrowser* self);
void noise_browser_column_set_show_separator (NoiseBrowserColumn* self,
                                              gboolean value);
static void noise_column_browser_save_current_state (NoiseColumnBrowser* self);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
GSettings* noise_app_get_saved_state (void);
NoiseColumnBrowserPosition noise_column_browser_get_position (NoiseColumnBrowser* self);
void noise_column_browser_set_position (NoiseColumnBrowser* self,
                                        NoiseColumnBrowserPosition value);
NoiseColumnBrowserPosition noise_column_browser_get_actual_position (NoiseColumnBrowser* self);
void noise_column_browser_set_actual_position (NoiseColumnBrowser* self,
                                               NoiseColumnBrowserPosition value);
static void noise_column_browser_set_view_wrapper (NoiseColumnBrowser* self,
                                            NoiseViewWrapper* value);
gboolean noise_column_browser_get_filtered (NoiseColumnBrowser* self);
gboolean noise_browser_column_get_first_item_selected (NoiseBrowserColumn* self);
gboolean noise_browser_column_get_visible (NoiseBrowserColumn* self);
void noise_column_browser_set_visible_columns (NoiseColumnBrowser* self,
                                               GeeTreeSet* value);
void noise_browser_column_set_visible (NoiseBrowserColumn* self,
                                       gboolean value);
gboolean noise_column_browser_get_initialized (NoiseColumnBrowser* self);
static void noise_column_browser_set_columns (NoiseColumnBrowser* self,
                                       GeeTreeSet* value);
static GObject * noise_column_browser_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void _vala_array_add6 (NoiseBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       NoiseBrowserColumnCategory value);
static void _vala_array_add7 (NoiseBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       NoiseBrowserColumnCategory value);
static void _vala_array_add8 (NoiseBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       NoiseBrowserColumnCategory value);
static void _vala_array_add9 (NoiseBrowserColumnCategory* * array,
                       int* length,
                       int* size,
                       NoiseBrowserColumnCategory value);
static void _vala_array_add10 (NoiseBrowserColumnCategory* * array,
                        int* length,
                        int* size,
                        NoiseBrowserColumnCategory value);
static void _vala_array_add11 (NoiseBrowserColumnCategory* * array,
                        int* length,
                        int* size,
                        NoiseBrowserColumnCategory value);
static void _vala_array_add12 (NoiseBrowserColumnCategory* * array,
                        int* length,
                        int* size,
                        NoiseBrowserColumnCategory value);
static void _noise_column_browser___lambda67_ (NoiseColumnBrowser* self);
static void __noise_column_browser___lambda67__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _noise_column_browser___lambda68_ (NoiseColumnBrowser* self);
static void __noise_column_browser___lambda68__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _noise_column_browser___lambda69_ (NoiseColumnBrowser* self);
static void __noise_column_browser___lambda69__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                     gpointer self);
static void _noise_column_browser_save_current_state_gtk_widget_destroy (GtkWidget* _sender,
                                                                  gpointer self);
static void noise_column_browser_finalize (GObject * obj);
static void _vala_noise_column_browser_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_noise_column_browser_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
noise_column_browser_get_instance_private (NoiseColumnBrowser* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseColumnBrowser_private_offset);
}


GType
noise_column_browser_position_get_type (void)
{
	static volatile gsize noise_column_browser_position_type_id__volatile = 0;
	if (g_once_init_enter (&noise_column_browser_position_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC, "NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC", "automatic"}, {NOISE_COLUMN_BROWSER_POSITION_LEFT, "NOISE_COLUMN_BROWSER_POSITION_LEFT", "left"}, {NOISE_COLUMN_BROWSER_POSITION_TOP, "NOISE_COLUMN_BROWSER_POSITION_TOP", "top"}, {0, NULL, NULL}};
		GType noise_column_browser_position_type_id;
		noise_column_browser_position_type_id = g_enum_register_static ("NoiseColumnBrowserPosition", values);
		g_once_init_leave (&noise_column_browser_position_type_id__volatile, noise_column_browser_position_type_id);
	}
	return noise_column_browser_position_type_id__volatile;
}


NoiseColumnBrowser*
noise_column_browser_construct (GType object_type,
                                NoiseViewWrapper* view_wrapper)
{
	NoiseColumnBrowser * self = NULL;
#line 140 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 141 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = (NoiseColumnBrowser*) g_object_new (object_type, "view-wrapper", view_wrapper, NULL);
#line 140 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return self;
#line 383 "ColumnBrowser.c"
}


NoiseColumnBrowser*
noise_column_browser_new (NoiseViewWrapper* view_wrapper)
{
#line 140 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return noise_column_browser_construct (NOISE_TYPE_COLUMN_BROWSER, view_wrapper);
#line 392 "ColumnBrowser.c"
}


void
noise_column_browser_reset_filters (NoiseColumnBrowser* self)
{
#line 204 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 401 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp1_;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 414 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			NoiseBrowserColumn* col = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			NoiseBrowserColumn* _tmp5_;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _col_it;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 426 "ColumnBrowser.c"
			}
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _col_it;
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (NoiseBrowserColumn*) _tmp4_;
#line 206 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = col;
#line 206 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			noise_browser_column_select_first_item (_tmp5_);
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 440 "ColumnBrowser.c"
		}
#line 205 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 444 "ColumnBrowser.c"
	}
}


static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return _data22_;
#line 456 "ColumnBrowser.c"
}


static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 467 "ColumnBrowser.c"
		NoiseColumnBrowser* self;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self = _data22_->self;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_data22_->column);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (self);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_slice_free (Block22Data, _data22_);
#line 477 "ColumnBrowser.c"
	}
}


static void
_noise_column_browser_column_selection_changed_noise_browser_column_selection_changed (NoiseBrowserColumn* _sender,
                                                                                       NoiseBrowserColumnCategory type,
                                                                                       const gchar* val,
                                                                                       gpointer self)
{
#line 213 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_column_selection_changed ((NoiseColumnBrowser*) self, type, val);
#line 490 "ColumnBrowser.c"
}


static void
__lambda66_ (Block22Data* _data22_)
{
	NoiseColumnBrowser* self;
#line 218 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = _data22_->self;
#line 219 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_browser_column_select_first_item (_data22_->column);
#line 502 "ColumnBrowser.c"
}


static void
___lambda66__noise_browser_column_reset_requested (NoiseBrowserColumn* _sender,
                                                   gpointer self)
{
#line 218 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	__lambda66_ (self);
#line 512 "ColumnBrowser.c"
}


static void
_noise_column_browser_column_row_activated_noise_browser_column_row_activated (NoiseBrowserColumn* _sender,
                                                                               const gchar* text,
                                                                               gpointer self)
{
#line 229 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_column_row_activated ((NoiseColumnBrowser*) self);
#line 523 "ColumnBrowser.c"
}


static void
_noise_column_browser_column_header_clicked_noise_browser_column_header_clicked (NoiseBrowserColumn* _sender,
                                                                                 GdkEventButton* e,
                                                                                 gpointer self)
{
#line 230 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_column_header_clicked ((NoiseColumnBrowser*) self, e);
#line 534 "ColumnBrowser.c"
}


static void
_noise_column_browser_update_column_separators_noise_browser_column_visibility_changed (NoiseBrowserColumn* _sender,
                                                                                        gboolean visible,
                                                                                        gpointer self)
{
#line 231 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_update_column_separators ((NoiseColumnBrowser*) self);
#line 545 "ColumnBrowser.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return self ? g_object_ref (self) : NULL;
#line 554 "ColumnBrowser.c"
}


NoiseBrowserColumn*
noise_column_browser_add_column (NoiseColumnBrowser* self,
                                 NoiseBrowserColumnCategory type)
{
	NoiseBrowserColumn* result = NULL;
	Block22Data* _data22_;
	NoiseBrowserColumn* _tmp0_;
	GeeTreeSet* _tmp1_;
	GtkMenu* _tmp2_;
	GtkCheckMenuItem* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	NoiseBrowserColumn* _tmp5_;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data22_ = g_slice_new0 (Block22Data);
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data22_->_ref_count_ = 1;
#line 209 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data22_->self = g_object_ref (self);
#line 211 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = noise_browser_column_new (self, type);
#line 211 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp0_);
#line 211 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data22_->column = _tmp0_;
#line 213 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data22_->column, "selection-changed", (GCallback) _noise_column_browser_column_selection_changed_noise_browser_column_selection_changed, self, G_CONNECT_AFTER);
#line 216 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_set_size_request ((GtkWidget*) _data22_->column, 60, 100);
#line 218 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_data (_data22_->column, "reset-requested", (GCallback) ___lambda66__noise_browser_column_reset_requested, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
#line 222 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->_columns;
#line 222 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _data22_->column);
#line 224 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _data22_->column, TRUE);
#line 224 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _data22_->column, TRUE);
#line 225 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _data22_->column, (gint) type, 0, 1, 1);
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = self->priv->column_chooser_menu;
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = noise_browser_column_get_menu_item (_data22_->column);
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = _tmp3_;
#line 227 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp2_, (GtkMenuItem*) _tmp4_);
#line 229 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data22_->column, "row-activated", (GCallback) _noise_column_browser_column_row_activated_noise_browser_column_row_activated, self, 0);
#line 230 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data22_->column, "header-clicked", (GCallback) _noise_column_browser_column_header_clicked_noise_browser_column_header_clicked, self, 0);
#line 231 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object (_data22_->column, "visibility-changed", (GCallback) _noise_column_browser_update_column_separators_noise_browser_column_visibility_changed, self, 0);
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp5_ = _g_object_ref0 (_data22_->column);
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp5_;
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	block22_data_unref (_data22_);
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_data22_ = NULL;
#line 233 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 624 "ColumnBrowser.c"
}


void
noise_column_browser_set_media (NoiseColumnBrowser* self,
                                GeeCollection* media)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	NoiseBrowserColumnCategory highest_category = 0;
#line 236 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (media != NULL);
#line 237 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->media;
#line 237 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 238 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->media;
#line 238 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, media);
#line 240 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = self->priv->search_results;
#line 240 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_collection_clear (_tmp2_);
#line 241 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = self->priv->search_results;
#line 241 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gee_collection_add_all (_tmp3_, media);
#line 243 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	highest_category = noise_browser_column_category_first ();
#line 245 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_populate_columns (self, highest_category, TRUE);
#line 247 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_emit (self, noise_column_browser_signals[NOISE_COLUMN_BROWSER_CHANGED_SIGNAL], 0);
#line 663 "ColumnBrowser.c"
}


static void
noise_column_browser_column_row_activated (NoiseColumnBrowser* self)
{
	NoiseViewWrapper* _tmp0_;
	gboolean _tmp1_;
#line 250 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 251 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = FALSE;
#line 251 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_view_wrapper_play_first_media (_tmp0_, &_tmp1_);
#line 680 "ColumnBrowser.c"
}


static void
noise_column_browser_column_selection_changed (NoiseColumnBrowser* self,
                                               NoiseBrowserColumnCategory category,
                                               const gchar* val)
{
	NoiseViewWrapper* _tmp0_;
	NoiseListView* _tmp1_;
	NoiseListView* _tmp2_;
	NoiseMusicListView* _tmp3_;
	NoiseMusicListView* _tmp4_;
#line 254 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (val != NULL);
#line 255 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_update_search_results (self, category);
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = noise_view_wrapper_get_list_view (_tmp0_);
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = noise_list_view_get_list_view (_tmp2_);
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = _tmp3_;
#line 256 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_generic_list_set_research_needed ((NoiseGenericList*) _tmp4_, TRUE);
#line 257 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_populate_columns (self, category, FALSE);
#line 258 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_emit (self, noise_column_browser_signals[NOISE_COLUMN_BROWSER_CHANGED_SIGNAL], 0);
#line 716 "ColumnBrowser.c"
}


static void
noise_column_browser_update_search_results (NoiseColumnBrowser* self,
                                            NoiseBrowserColumnCategory parent_category)
{
	gint rating = 0;
	gint year = 0;
	gchar* genre = NULL;
	gchar* album_artist = NULL;
	gchar* album = NULL;
	gchar* grouping = NULL;
	gchar* composer = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GeeLinkedList* _tmp7_;
	GeeCollection* _tmp8_ = NULL;
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_get_filters (self, parent_category, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	rating = _tmp0_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	year = _tmp1_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	genre = _tmp2_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album_artist = _tmp3_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album = _tmp4_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	grouping = _tmp5_;
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 264 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	composer = _tmp6_;
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp7_ = self->priv->media;
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_search_search_in_media_list ((GeeCollection*) _tmp7_, &_tmp8_, album_artist, album, genre, grouping, composer, year, rating, NULL);
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->search_results);
#line 268 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->search_results = _tmp8_;
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 261 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 786 "ColumnBrowser.c"
}


static void
noise_column_browser_get_filters (NoiseColumnBrowser* self,
                                  NoiseBrowserColumnCategory parent_category,
                                  gint* rating,
                                  gint* year,
                                  gchar* * genre,
                                  gchar* * album_artist,
                                  gchar* * album,
                                  gchar* * grouping,
                                  gchar* * composer)
{
	gint _vala_rating = 0;
	gint _vala_year = 0;
	gchar* _vala_genre = NULL;
	gchar* _vala_album_artist = NULL;
	gchar* _vala_album = NULL;
	gchar* _vala_grouping = NULL;
	gchar* _vala_composer = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_rating = -1;
#line 283 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_year = -1;
#line 284 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = g_strdup ("");
#line 284 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_genre);
#line 284 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_genre = _tmp0_;
#line 285 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = g_strdup ("");
#line 285 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_album_artist);
#line 285 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_album_artist = _tmp1_;
#line 286 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = g_strdup ("");
#line 286 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_album);
#line 286 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_album = _tmp2_;
#line 287 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = g_strdup ("");
#line 287 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_grouping);
#line 287 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_grouping = _tmp3_;
#line 288 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = g_strdup ("");
#line 288 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (_vala_composer);
#line 288 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_composer = _tmp4_;
#line 849 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp5_;
		GeeIterator* _tmp6_;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp5_ = self->priv->_columns;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp5_);
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp6_;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 862 "ColumnBrowser.c"
			GeeIterator* _tmp7_;
			NoiseBrowserColumn* col = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			NoiseBrowserColumn* _tmp10_;
			NoiseBrowserColumnCategory _tmp11_;
			NoiseBrowserColumnCategory _tmp12_;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _col_it;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 876 "ColumnBrowser.c"
			}
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp8_ = _col_it;
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (NoiseBrowserColumn*) _tmp9_;
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp10_ = col;
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = noise_browser_column_get_category (_tmp10_);
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = _tmp11_;
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp12_ <= parent_category) {
#line 892 "ColumnBrowser.c"
				gchar* selected = NULL;
				NoiseBrowserColumn* _tmp13_;
				gchar* _tmp14_;
				NoiseBrowserColumn* _tmp15_;
				NoiseBrowserColumnCategory _tmp16_;
				NoiseBrowserColumnCategory _tmp17_;
#line 293 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp13_ = col;
#line 293 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp14_ = noise_browser_column_get_selected (_tmp13_);
#line 293 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				selected = _tmp14_;
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp15_ = col;
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp16_ = noise_browser_column_get_category (_tmp15_);
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp17_ = _tmp16_;
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				switch (_tmp17_) {
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_GENRE:
#line 915 "ColumnBrowser.c"
					{
						const gchar* _tmp18_;
						gchar* _tmp19_;
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp18_ = selected;
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp19_ = g_strdup (_tmp18_);
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_genre);
#line 297 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_genre = _tmp19_;
#line 298 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 929 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 933 "ColumnBrowser.c"
					{
						const gchar* _tmp20_;
						gchar* _tmp21_;
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp20_ = selected;
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp21_ = g_strdup (_tmp20_);
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_album_artist);
#line 301 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_album_artist = _tmp21_;
#line 302 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 947 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 951 "ColumnBrowser.c"
					{
						const gchar* _tmp22_;
						gchar* _tmp23_;
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp22_ = selected;
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp23_ = g_strdup (_tmp22_);
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_album);
#line 305 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_album = _tmp23_;
#line 306 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 965 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 969 "ColumnBrowser.c"
					{
						const gchar* _tmp24_;
						gchar* _tmp25_;
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp24_ = selected;
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp25_ = g_strdup (_tmp24_);
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_grouping);
#line 309 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_grouping = _tmp25_;
#line 310 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 983 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 987 "ColumnBrowser.c"
					{
						const gchar* _tmp26_;
						gchar* _tmp27_;
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp26_ = selected;
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp27_ = g_strdup (_tmp26_);
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_vala_composer);
#line 313 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_composer = _tmp27_;
#line 314 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1001 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1005 "ColumnBrowser.c"
					{
						gint _tmp28_ = 0;
						const gchar* _tmp29_;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp29_ = selected;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						if (noise_string_is_empty (_tmp29_, FALSE)) {
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp28_ = -1;
#line 1015 "ColumnBrowser.c"
						} else {
							const gchar* _tmp30_;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp30_ = selected;
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp28_ = (gint) noise_string_uint_from_string (_tmp30_);
#line 1022 "ColumnBrowser.c"
						}
#line 319 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_year = _tmp28_;
#line 320 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1028 "ColumnBrowser.c"
					}
#line 295 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					case NOISE_BROWSER_COLUMN_CATEGORY_RATING:
#line 1032 "ColumnBrowser.c"
					{
						gint _tmp31_ = 0;
						const gchar* _tmp32_;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp32_ = selected;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						if (noise_string_is_empty (_tmp32_, FALSE)) {
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp31_ = -1;
#line 1042 "ColumnBrowser.c"
						} else {
							const gchar* _tmp33_;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp33_ = selected;
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp31_ = (gint) noise_string_uint_from_string (_tmp33_);
#line 1049 "ColumnBrowser.c"
						}
#line 336 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_vala_rating = _tmp31_;
#line 337 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1055 "ColumnBrowser.c"
					}
					default:
					{
#line 340 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						g_assert_not_reached ();
#line 1061 "ColumnBrowser.c"
					}
				}
#line 292 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_free0 (selected);
#line 1066 "ColumnBrowser.c"
			}
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 1070 "ColumnBrowser.c"
		}
#line 290 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 1074 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (rating) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*rating = _vala_rating;
#line 1080 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (year) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*year = _vala_year;
#line 1086 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (genre) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*genre = _vala_genre;
#line 1092 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_genre);
#line 1096 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (album_artist) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*album_artist = _vala_album_artist;
#line 1102 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_album_artist);
#line 1106 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (album) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*album = _vala_album;
#line 1112 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_album);
#line 1116 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (grouping) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*grouping = _vala_grouping;
#line 1122 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_grouping);
#line 1126 "ColumnBrowser.c"
	}
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (composer) {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*composer = _vala_composer;
#line 1132 "ColumnBrowser.c"
	} else {
#line 272 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_free0 (_vala_composer);
#line 1136 "ColumnBrowser.c"
	}
}


static void
noise_column_browser_populate_columns (NoiseColumnBrowser* self,
                                       NoiseBrowserColumnCategory category,
                                       gboolean inclusive)
{
#line 346 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 1148 "ColumnBrowser.c"
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_column_it = _tmp1_;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 1161 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			NoiseBrowserColumn* column = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			NoiseBrowserColumn* _tmp5_;
			NoiseBrowserColumnCategory _tmp6_;
			NoiseBrowserColumnCategory _tmp7_;
			gboolean _tmp8_ = FALSE;
			NoiseBrowserColumn* _tmp9_;
			NoiseBrowserColumnCategory _tmp10_;
			NoiseBrowserColumnCategory _tmp11_;
			NoiseBrowserColumn* _tmp12_;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _column_it;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 1180 "ColumnBrowser.c"
			}
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _column_it;
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column = (NoiseBrowserColumn*) _tmp4_;
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = column;
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = noise_browser_column_get_category (_tmp5_);
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _tmp6_;
#line 350 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp7_ < category) {
#line 351 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (column);
#line 351 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				continue;
#line 1200 "ColumnBrowser.c"
			}
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9_ = column;
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp10_ = noise_browser_column_get_category (_tmp9_);
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = _tmp10_;
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp11_ == category) {
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp8_ = !inclusive;
#line 1212 "ColumnBrowser.c"
			} else {
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp8_ = FALSE;
#line 1216 "ColumnBrowser.c"
			}
#line 353 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp8_) {
#line 354 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (column);
#line 354 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				continue;
#line 1224 "ColumnBrowser.c"
			}
#line 356 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = column;
#line 356 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			noise_column_browser_fill_column (self, _tmp12_);
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (column);
#line 1232 "ColumnBrowser.c"
		}
#line 348 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_column_it);
#line 1236 "ColumnBrowser.c"
	}
}


void
noise_column_browser_fill_column (NoiseColumnBrowser* self,
                                  NoiseBrowserColumn* column)
{
	GeeHashSet* column_set = NULL;
	GeeHashSet* _tmp0_;
	NoiseBrowserColumnCategory _tmp1_;
	NoiseBrowserColumnCategory _tmp2_;
	GeeHashSet* _tmp101_;
	NoiseBrowserColumnCategory _tmp102_;
	NoiseBrowserColumnCategory _tmp103_;
#line 360 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (column != NULL);
#line 361 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 361 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	column_set = _tmp0_;
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = noise_browser_column_get_category (column);
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (_tmp2_) {
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_GENRE:
#line 1268 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp3_;
				GeeIterator* _tmp4_;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp3_ = self->priv->search_results;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp4_;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1282 "ColumnBrowser.c"
					GeeIterator* _tmp5_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp6_;
					gpointer _tmp7_;
					gchar* genre = NULL;
					NoiseMedia* _tmp8_;
					gchar* _tmp9_;
					GeeHashSet* _tmp10_;
					const gchar* _tmp11_;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp5_ = _m_it;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp5_)) {
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1298 "ColumnBrowser.c"
					}
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp6_ = _m_it;
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp7_ = gee_iterator_get (_tmp6_);
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp7_;
#line 366 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp8_ = m;
#line 366 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp9_ = noise_media_get_display_genre (_tmp8_);
#line 366 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					genre = _tmp9_;
#line 367 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp10_ = column_set;
#line 367 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp11_ = genre;
#line 367 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, _tmp11_)) {
#line 1318 "ColumnBrowser.c"
						GeeHashSet* _tmp12_;
						const gchar* _tmp13_;
#line 368 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp12_ = column_set;
#line 368 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp13_ = genre;
#line 368 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 1327 "ColumnBrowser.c"
					}
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (genre);
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1333 "ColumnBrowser.c"
				}
#line 365 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1337 "ColumnBrowser.c"
			}
#line 370 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1341 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 1345 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp14_ = self->priv->search_results;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp15_;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1359 "ColumnBrowser.c"
					GeeIterator* _tmp16_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					gchar* artist = NULL;
					NoiseMedia* _tmp19_;
					gchar* _tmp20_;
					GeeHashSet* _tmp21_;
					const gchar* _tmp22_;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp16_ = _m_it;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1375 "ColumnBrowser.c"
					}
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp17_ = _m_it;
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp18_;
#line 374 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp19_ = m;
#line 374 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp20_ = noise_media_get_display_album_artist (_tmp19_, TRUE);
#line 374 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					artist = _tmp20_;
#line 375 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp21_ = column_set;
#line 375 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp22_ = artist;
#line 375 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp21_, _tmp22_)) {
#line 1395 "ColumnBrowser.c"
						GeeHashSet* _tmp23_;
						const gchar* _tmp24_;
#line 376 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp23_ = column_set;
#line 376 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp24_ = artist;
#line 376 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 1404 "ColumnBrowser.c"
					}
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (artist);
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1410 "ColumnBrowser.c"
				}
#line 373 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1414 "ColumnBrowser.c"
			}
#line 378 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1418 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 1422 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp25_;
				GeeIterator* _tmp26_;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp25_ = self->priv->search_results;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp26_;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1436 "ColumnBrowser.c"
					GeeIterator* _tmp27_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp28_;
					gpointer _tmp29_;
					gchar* grouping = NULL;
					NoiseMedia* _tmp30_;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gchar* _tmp33_;
					gboolean _tmp34_ = FALSE;
					const gchar* _tmp35_;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp27_ = _m_it;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp27_)) {
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1454 "ColumnBrowser.c"
					}
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp28_ = _m_it;
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp29_ = gee_iterator_get (_tmp28_);
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp29_;
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp30_ = m;
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp31_ = noise_media_get_grouping (_tmp30_);
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp32_ = _tmp31_;
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp33_ = g_strdup (_tmp32_);
#line 382 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					grouping = _tmp33_;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp35_ = grouping;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!noise_string_is_empty (_tmp35_, FALSE)) {
#line 1476 "ColumnBrowser.c"
						GeeHashSet* _tmp36_;
						const gchar* _tmp37_;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp36_ = column_set;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp37_ = grouping;
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp34_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 1485 "ColumnBrowser.c"
					} else {
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp34_ = FALSE;
#line 1489 "ColumnBrowser.c"
					}
#line 385 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp34_) {
#line 1493 "ColumnBrowser.c"
						GeeHashSet* _tmp38_;
						const gchar* _tmp39_;
#line 386 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp38_ = column_set;
#line 386 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp39_ = grouping;
#line 386 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
#line 1502 "ColumnBrowser.c"
					}
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (grouping);
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1508 "ColumnBrowser.c"
				}
#line 381 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1512 "ColumnBrowser.c"
			}
#line 388 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1516 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 1520 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp40_;
				GeeIterator* _tmp41_;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp40_ = self->priv->search_results;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp41_ = gee_iterable_iterator ((GeeIterable*) _tmp40_);
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp41_;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1534 "ColumnBrowser.c"
					GeeIterator* _tmp42_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp43_;
					gpointer _tmp44_;
					gchar* composer = NULL;
					NoiseMedia* _tmp45_;
					gchar* _tmp46_;
					GeeHashSet* _tmp47_;
					const gchar* _tmp48_;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp42_ = _m_it;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp42_)) {
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1550 "ColumnBrowser.c"
					}
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp43_ = _m_it;
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp44_ = gee_iterator_get (_tmp43_);
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp44_;
#line 392 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp45_ = m;
#line 392 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp46_ = noise_media_get_display_composer (_tmp45_);
#line 392 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					composer = _tmp46_;
#line 393 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp47_ = column_set;
#line 393 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp48_ = composer;
#line 393 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp47_, _tmp48_)) {
#line 1570 "ColumnBrowser.c"
						GeeHashSet* _tmp49_;
						const gchar* _tmp50_;
#line 394 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp49_ = column_set;
#line 394 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp50_ = composer;
#line 394 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp50_);
#line 1579 "ColumnBrowser.c"
					}
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (composer);
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1585 "ColumnBrowser.c"
				}
#line 391 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1589 "ColumnBrowser.c"
			}
#line 396 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1593 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 1597 "ColumnBrowser.c"
		{
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp51_;
				GeeIterator* _tmp52_;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp51_ = self->priv->search_results;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp52_ = gee_iterable_iterator ((GeeIterable*) _tmp51_);
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp52_;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1611 "ColumnBrowser.c"
					GeeIterator* _tmp53_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp54_;
					gpointer _tmp55_;
					gchar* album = NULL;
					NoiseMedia* _tmp56_;
					gchar* _tmp57_;
					GeeHashSet* _tmp58_;
					const gchar* _tmp59_;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp53_ = _m_it;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp53_)) {
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1627 "ColumnBrowser.c"
					}
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp54_ = _m_it;
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp55_ = gee_iterator_get (_tmp54_);
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp55_;
#line 400 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp56_ = m;
#line 400 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp57_ = noise_media_get_display_album (_tmp56_);
#line 400 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					album = _tmp57_;
#line 401 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp58_ = column_set;
#line 401 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp59_ = album;
#line 401 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp58_, _tmp59_)) {
#line 1647 "ColumnBrowser.c"
						GeeHashSet* _tmp60_;
						const gchar* _tmp61_;
#line 402 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp60_ = column_set;
#line 402 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp61_ = album;
#line 402 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp60_, _tmp61_);
#line 1656 "ColumnBrowser.c"
					}
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_free0 (album);
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1662 "ColumnBrowser.c"
				}
#line 399 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1666 "ColumnBrowser.c"
			}
#line 404 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1670 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1674 "ColumnBrowser.c"
		{
			GeeHashSet* numeric_set = NULL;
			GeeHashSet* _tmp62_;
#line 408 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp62_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 408 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			numeric_set = _tmp62_;
#line 1682 "ColumnBrowser.c"
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp63_;
				GeeIterator* _tmp64_;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp63_ = self->priv->search_results;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp64_ = gee_iterable_iterator ((GeeIterable*) _tmp63_);
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp64_;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1695 "ColumnBrowser.c"
					GeeIterator* _tmp65_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp66_;
					gpointer _tmp67_;
					guint year = 0U;
					NoiseMedia* _tmp68_;
					guint _tmp69_;
					guint _tmp70_;
					gboolean _tmp71_ = FALSE;
					guint _tmp72_;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp65_ = _m_it;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp65_)) {
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1712 "ColumnBrowser.c"
					}
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp66_ = _m_it;
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp67_ = gee_iterator_get (_tmp66_);
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp67_;
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp68_ = m;
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp69_ = noise_media_get_year (_tmp68_);
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp70_ = _tmp69_;
#line 410 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					year = _tmp70_;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp72_ = year;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp72_ > ((guint) 0)) {
#line 1732 "ColumnBrowser.c"
						GeeHashSet* _tmp73_;
						guint _tmp74_;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp73_ = numeric_set;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp74_ = year;
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp71_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp73_, (gpointer) ((guintptr) _tmp74_));
#line 1741 "ColumnBrowser.c"
					} else {
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp71_ = FALSE;
#line 1745 "ColumnBrowser.c"
					}
#line 411 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp71_) {
#line 1749 "ColumnBrowser.c"
						GeeHashSet* _tmp75_;
						guint _tmp76_;
						GeeHashSet* _tmp77_;
						guint _tmp78_;
						gchar* _tmp79_;
						gchar* _tmp80_;
#line 412 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp75_ = numeric_set;
#line 412 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp76_ = year;
#line 412 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp75_, (gpointer) ((guintptr) _tmp76_));
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp77_ = column_set;
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp78_ = year;
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp79_ = g_strdup_printf ("%u", _tmp78_);
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp80_ = _tmp79_;
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp77_, _tmp80_);
#line 413 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (_tmp80_);
#line 1774 "ColumnBrowser.c"
					}
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1778 "ColumnBrowser.c"
				}
#line 409 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1782 "ColumnBrowser.c"
			}
#line 416 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (numeric_set);
#line 416 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1788 "ColumnBrowser.c"
		}
#line 363 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_RATING:
#line 1792 "ColumnBrowser.c"
		{
			GeeHashSet* numeric_set = NULL;
			GeeHashSet* _tmp81_;
#line 420 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp81_ = gee_hash_set_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 420 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			numeric_set = _tmp81_;
#line 1800 "ColumnBrowser.c"
			{
				GeeIterator* _m_it = NULL;
				GeeCollection* _tmp82_;
				GeeIterator* _tmp83_;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp82_ = self->priv->search_results;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp83_ = gee_iterable_iterator ((GeeIterable*) _tmp82_);
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_m_it = _tmp83_;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 1813 "ColumnBrowser.c"
					GeeIterator* _tmp84_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp85_;
					gpointer _tmp86_;
					guint rating = 0U;
					NoiseMedia* _tmp87_;
					guint _tmp88_;
					guint _tmp89_;
					GeeHashSet* _tmp90_;
					guint _tmp91_;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp84_ = _m_it;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp84_)) {
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 1830 "ColumnBrowser.c"
					}
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp85_ = _m_it;
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp86_ = gee_iterator_get (_tmp85_);
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					m = (NoiseMedia*) _tmp86_;
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp87_ = m;
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp88_ = noise_media_get_rating (_tmp87_);
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp89_ = _tmp88_;
#line 422 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					rating = _tmp89_;
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp90_ = numeric_set;
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp91_ = rating;
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp90_, (gpointer) ((guintptr) _tmp91_))) {
#line 1852 "ColumnBrowser.c"
						GeeHashSet* _tmp92_;
						guint _tmp93_;
						gchar* rating_str = NULL;
						guint _tmp94_;
						GeeHashSet* _tmp99_;
						const gchar* _tmp100_;
#line 424 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp92_ = numeric_set;
#line 424 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp93_ = rating;
#line 424 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp92_, (gpointer) ((guintptr) _tmp93_));
#line 427 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp94_ = rating;
#line 427 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						if (_tmp94_ < ((guint) 1)) {
#line 1869 "ColumnBrowser.c"
							gchar* _tmp95_;
#line 428 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp95_ = g_strdup (_ ("Unrated"));
#line 428 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_g_free0 (rating_str);
#line 428 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							rating_str = _tmp95_;
#line 1877 "ColumnBrowser.c"
						} else {
							guint _tmp96_;
							guint _tmp97_;
							gchar* _tmp98_;
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp96_ = rating;
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp97_ = rating;
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_tmp98_ = g_strdup_printf (ngettext ("%u Star", "%u Stars", (gulong) _tmp96_), _tmp97_);
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							_g_free0 (rating_str);
#line 430 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
							rating_str = _tmp98_;
#line 1892 "ColumnBrowser.c"
						}
#line 432 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp99_ = column_set;
#line 432 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_tmp100_ = rating_str;
#line 432 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp99_, _tmp100_);
#line 423 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						_g_free0 (rating_str);
#line 1902 "ColumnBrowser.c"
					}
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_g_object_unref0 (m);
#line 1906 "ColumnBrowser.c"
				}
#line 421 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_m_it);
#line 1910 "ColumnBrowser.c"
			}
#line 435 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (numeric_set);
#line 435 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 1916 "ColumnBrowser.c"
		}
		default:
		{
#line 438 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			g_assert_not_reached ();
#line 1922 "ColumnBrowser.c"
		}
	}
#line 441 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp101_ = column_set;
#line 441 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_browser_column_populate (column, _tmp101_);
#line 448 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp102_ = noise_browser_column_get_category (column);
#line 448 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp103_ = _tmp102_;
#line 448 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_update_search_results (self, _tmp103_);
#line 360 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (column_set);
#line 1937 "ColumnBrowser.c"
}


gboolean
noise_column_browser_match_media (NoiseColumnBrowser* self,
                                  NoiseMedia* m)
{
	gboolean result = FALSE;
	gint rating = 0;
	gint year = 0;
	gchar* genre = NULL;
	gchar* album_artist = NULL;
	gchar* album = NULL;
	gchar* grouping = NULL;
	gchar* composer = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 451 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_get_filters (self, noise_browser_column_category_last (), &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	rating = _tmp0_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	year = _tmp1_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	genre = _tmp2_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album_artist = _tmp3_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	album = _tmp4_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	grouping = _tmp5_;
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 459 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	composer = _tmp6_;
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = noise_search_match_fields_to_media (m, album_artist, album, genre, grouping, composer, year, rating);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (composer);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (grouping);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (album_artist);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_free0 (genre);
#line 463 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2004 "ColumnBrowser.c"
}


static void
noise_column_browser_update_column_separators (NoiseColumnBrowser* self)
{
	guint n_visible_columns = 0U;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
	NoiseBrowserColumnCategory first_col = 0;
#line 467 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = noise_column_browser_get_visible_columns (self);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = _tmp0_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = _tmp3_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp5_ = (guint) _tmp4_;
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (_tmp2_);
#line 468 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	n_visible_columns = _tmp5_;
#line 471 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	first_col = noise_browser_column_category_first ();
#line 2039 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp6_;
		GeeTreeSet* _tmp7_;
		GeeTreeSet* _tmp8_;
		GeeIterator* _tmp9_;
		GeeIterator* _tmp10_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp6_ = noise_column_browser_get_visible_columns (self);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp7_ = _tmp6_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp8_ = _tmp7_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp9_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp8_);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp10_ = _tmp9_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_tmp8_);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp10_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2063 "ColumnBrowser.c"
			GeeIterator* _tmp11_;
			NoiseBrowserColumnCategory col = 0;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			NoiseBrowserColumnCategory _tmp14_;
			NoiseBrowserColumnCategory _tmp15_;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = _col_it;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2076 "ColumnBrowser.c"
			}
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp12_ = _col_it;
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (NoiseBrowserColumnCategory) ((gintptr) _tmp13_);
#line 473 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp14_ = col;
#line 473 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp15_ = first_col;
#line 473 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp14_ > _tmp15_) {
#line 2090 "ColumnBrowser.c"
				NoiseBrowserColumnCategory _tmp16_;
#line 474 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp16_ = col;
#line 474 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				first_col = _tmp16_;
#line 2096 "ColumnBrowser.c"
			}
		}
#line 472 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 2101 "ColumnBrowser.c"
	}
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp17_;
		GeeIterator* _tmp18_;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp17_ = self->priv->_columns;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp18_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp17_);
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp18_;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2115 "ColumnBrowser.c"
			GeeIterator* _tmp19_;
			NoiseBrowserColumn* col = NULL;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			gboolean _tmp22_ = FALSE;
			NoiseBrowserColumn* _tmp23_;
			NoiseBrowserColumnCategory _tmp24_;
			NoiseBrowserColumnCategory _tmp25_;
			NoiseBrowserColumnCategory _tmp26_;
			NoiseBrowserColumn* _tmp28_;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp19_ = _col_it;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2132 "ColumnBrowser.c"
			}
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp20_ = _col_it;
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (NoiseBrowserColumn*) _tmp21_;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp23_ = col;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp24_ = noise_browser_column_get_category (_tmp23_);
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp25_ = _tmp24_;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp26_ = first_col;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp25_ != _tmp26_) {
#line 2150 "ColumnBrowser.c"
				guint _tmp27_;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp27_ = n_visible_columns;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp22_ = _tmp27_ > ((guint) 1);
#line 2156 "ColumnBrowser.c"
			} else {
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp22_ = FALSE;
#line 2160 "ColumnBrowser.c"
			}
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp28_ = col;
#line 478 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			noise_browser_column_set_show_separator (_tmp28_, _tmp22_);
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 2168 "ColumnBrowser.c"
		}
#line 477 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 2172 "ColumnBrowser.c"
	}
}


static void
noise_column_browser_column_header_clicked (NoiseColumnBrowser* self,
                                            GdkEventButton* e)
{
	guint _tmp0_;
#line 481 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (e != NULL);
#line 482 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = e->button;
#line 482 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp0_ == ((guint) GDK_BUTTON_SECONDARY)) {
#line 2190 "ColumnBrowser.c"
		GtkMenu* _tmp1_;
#line 483 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = self->priv->column_chooser_menu;
#line 483 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		gtk_menu_popup_at_pointer (_tmp1_, (GdkEvent*) e);
#line 2196 "ColumnBrowser.c"
	}
}


static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2213 "ColumnBrowser.c"
	}
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[*length] = NULL;
#line 2219 "ColumnBrowser.c"
}


static void
noise_column_browser_save_current_state (NoiseColumnBrowser* self)
{
	gchar** visible_categories = NULL;
	gchar** _tmp0_;
	gint visible_categories_length1;
	gint _visible_categories_size_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	GSettings* _tmp15_;
	GSettings* _tmp16_;
	NoiseColumnBrowserPosition _tmp17_;
	NoiseColumnBrowserPosition _tmp18_;
#line 487 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories = _tmp0_;
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories_length1 = 0;
#line 488 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_visible_categories_size_ = visible_categories_length1;
#line 2248 "ColumnBrowser.c"
	{
		GeeIterator* _col_cat_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeTreeSet* _tmp2_;
		GeeTreeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = noise_column_browser_get_visible_columns (self);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp2_ = _tmp1_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp3_ = _tmp2_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp5_ = _tmp4_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_tmp3_);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_cat_it = _tmp5_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2272 "ColumnBrowser.c"
			GeeIterator* _tmp6_;
			NoiseBrowserColumnCategory col_cat = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			gchar** _tmp9_;
			gint _tmp9__length1;
			NoiseBrowserColumnCategory _tmp10_;
			gchar* _tmp11_;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = _col_cat_it;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2287 "ColumnBrowser.c"
			}
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _col_cat_it;
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col_cat = (NoiseBrowserColumnCategory) ((gintptr) _tmp8_);
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9_ = visible_categories;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp9__length1 = visible_categories_length1;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp10_ = col_cat;
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp11_ = g_strdup_printf ("%i", (gint) _tmp10_);
#line 491 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_vala_array_add5 (&visible_categories, &visible_categories_length1, &_visible_categories_size_, _tmp11_);
#line 2305 "ColumnBrowser.c"
		}
#line 490 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_cat_it);
#line 2309 "ColumnBrowser.c"
	}
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12_ = noise_app_get_saved_state ();
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp13_ = _tmp12_;
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp14_ = visible_categories;
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp14__length1 = visible_categories_length1;
#line 494 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_settings_set_strv (_tmp13_, "column-browser-visible-columns", _tmp14_);
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp15_ = noise_app_get_saved_state ();
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp16_ = _tmp15_;
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp17_ = noise_column_browser_get_position (self);
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp18_ = _tmp17_;
#line 495 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_settings_set_int (_tmp16_, "column-browser-position", (gint) _tmp18_);
#line 487 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories = (_vala_array_free (visible_categories, visible_categories_length1, (GDestroyNotify) g_free), NULL);
#line 2333 "ColumnBrowser.c"
}


NoiseColumnBrowserPosition
noise_column_browser_get_position (NoiseColumnBrowser* self)
{
	NoiseColumnBrowserPosition result;
	NoiseColumnBrowserPosition _tmp0_;
#line 42 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_position;
#line 43 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 43 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2350 "ColumnBrowser.c"
}


void
noise_column_browser_set_position (NoiseColumnBrowser* self,
                                   NoiseColumnBrowserPosition value)
{
	NoiseColumnBrowserPosition _tmp0_;
	NoiseColumnBrowserPosition _tmp1_;
#line 45 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->_position = value;
#line 48 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_position;
#line 48 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_emit (self, noise_column_browser_signals[NOISE_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL], 0, _tmp0_);
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->_position;
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (_tmp1_) {
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC:
#line 2374 "ColumnBrowser.c"
		{
			GtkRadioMenuItem* _tmp2_;
#line 52 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = self->priv->automatic_menu_item;
#line 52 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp2_, TRUE);
#line 53 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 2383 "ColumnBrowser.c"
		}
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_POSITION_LEFT:
#line 2387 "ColumnBrowser.c"
		{
			GtkRadioMenuItem* _tmp3_;
#line 55 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = self->priv->left_menu_item;
#line 55 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp3_, TRUE);
#line 56 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 2396 "ColumnBrowser.c"
		}
#line 50 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_POSITION_TOP:
#line 2400 "ColumnBrowser.c"
		{
			GtkRadioMenuItem* _tmp4_;
#line 58 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = self->priv->top_menu_item;
#line 58 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			gtk_check_menu_item_set_active ((GtkCheckMenuItem*) _tmp4_, TRUE);
#line 59 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			break;
#line 2409 "ColumnBrowser.c"
		}
		default:
		{
#line 61 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			g_assert_not_reached ();
#line 2415 "ColumnBrowser.c"
		}
	}
#line 45 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_column_browser_properties[NOISE_COLUMN_BROWSER_POSITION_PROPERTY]);
#line 2420 "ColumnBrowser.c"
}


NoiseColumnBrowserPosition
noise_column_browser_get_actual_position (NoiseColumnBrowser* self)
{
	NoiseColumnBrowserPosition result;
	NoiseColumnBrowserPosition _tmp0_;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_actual_position;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2437 "ColumnBrowser.c"
}


void
noise_column_browser_set_actual_position (NoiseColumnBrowser* self,
                                          NoiseColumnBrowserPosition value)
{
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (noise_column_browser_get_actual_position (self) != value) {
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self->priv->_actual_position = value;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_column_browser_properties[NOISE_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY]);
#line 2453 "ColumnBrowser.c"
	}
}


NoiseViewWrapper*
noise_column_browser_get_view_wrapper (NoiseColumnBrowser* self)
{
	NoiseViewWrapper* result;
	NoiseViewWrapper* _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2471 "ColumnBrowser.c"
}


static void
noise_column_browser_set_view_wrapper (NoiseColumnBrowser* self,
                                       NoiseViewWrapper* value)
{
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (noise_column_browser_get_view_wrapper (self) != value) {
#line 2483 "ColumnBrowser.c"
		NoiseViewWrapper* _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (self->priv->_view_wrapper);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self->priv->_view_wrapper = _tmp0_;
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_column_browser_properties[NOISE_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY]);
#line 2493 "ColumnBrowser.c"
	}
}


gboolean
noise_column_browser_get_filtered (NoiseColumnBrowser* self)
{
	gboolean result;
#line 76 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2504 "ColumnBrowser.c"
	{
		GeeIterator* _col_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_col_it = _tmp1_;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2517 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			NoiseBrowserColumn* col = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			NoiseBrowserColumn* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _col_it;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2531 "ColumnBrowser.c"
			}
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _col_it;
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col = (NoiseBrowserColumn*) _tmp4_;
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = col;
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = noise_browser_column_get_first_item_selected (_tmp5_);
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = _tmp6_;
#line 78 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!_tmp7_) {
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				result = TRUE;
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (col);
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_col_it);
#line 79 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				return result;
#line 2555 "ColumnBrowser.c"
			}
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (col);
#line 2559 "ColumnBrowser.c"
		}
#line 77 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_col_it);
#line 2563 "ColumnBrowser.c"
	}
#line 81 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = FALSE;
#line 81 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2569 "ColumnBrowser.c"
}


GeeTreeSet*
noise_column_browser_get_visible_columns (NoiseColumnBrowser* self)
{
	GeeTreeSet* result;
	GeeTreeSet* visible_columns = NULL;
	GeeTreeSet* _tmp0_;
#line 86 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = gee_tree_set_new (NOISE_BROWSER_COLUMN_TYPE_CATEGORY, NULL, NULL, NULL, NULL, NULL);
#line 87 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_columns = _tmp0_;
#line 2585 "ColumnBrowser.c"
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = self->priv->_columns;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_column_it = _tmp2_;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2598 "ColumnBrowser.c"
			GeeIterator* _tmp3_;
			NoiseBrowserColumn* column = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			NoiseBrowserColumn* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _column_it;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2612 "ColumnBrowser.c"
			}
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = _column_it;
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column = (NoiseBrowserColumn*) _tmp5_;
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp6_ = column;
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp7_ = noise_browser_column_get_visible (_tmp6_);
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp8_ = _tmp7_;
#line 89 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp8_) {
#line 2628 "ColumnBrowser.c"
				GeeTreeSet* _tmp9_;
				NoiseBrowserColumn* _tmp10_;
				NoiseBrowserColumnCategory _tmp11_;
				NoiseBrowserColumnCategory _tmp12_;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp9_ = visible_columns;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp10_ = column;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp11_ = noise_browser_column_get_category (_tmp10_);
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp12_ = _tmp11_;
#line 90 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (gpointer) ((gintptr) _tmp12_));
#line 2643 "ColumnBrowser.c"
			}
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (column);
#line 2647 "ColumnBrowser.c"
		}
#line 88 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_column_it);
#line 2651 "ColumnBrowser.c"
	}
#line 92 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = visible_columns;
#line 92 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2657 "ColumnBrowser.c"
}


void
noise_column_browser_set_visible_columns (NoiseColumnBrowser* self,
                                          GeeTreeSet* value)
{
	gboolean no_column_enabled = FALSE;
	gboolean _tmp16_;
#line 94 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	no_column_enabled = TRUE;
#line 2671 "ColumnBrowser.c"
	{
		GeeIterator* _column_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = self->priv->_columns;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_column_it = _tmp1_;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		while (TRUE) {
#line 2684 "ColumnBrowser.c"
			GeeIterator* _tmp2_;
			NoiseBrowserColumn* column = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean column_visible = FALSE;
			NoiseBrowserColumn* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp2_ = _column_it;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				break;
#line 2699 "ColumnBrowser.c"
			}
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp3_ = _column_it;
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column = (NoiseBrowserColumn*) _tmp4_;
#line 100 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			column_visible = FALSE;
#line 2709 "ColumnBrowser.c"
			{
				GeeIterator* _category_it = NULL;
				GeeIterator* _tmp5_;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp5_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) value);
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_category_it = _tmp5_;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				while (TRUE) {
#line 2719 "ColumnBrowser.c"
					GeeIterator* _tmp6_;
					NoiseBrowserColumnCategory category = 0;
					GeeIterator* _tmp7_;
					gpointer _tmp8_;
					NoiseBrowserColumn* _tmp9_;
					NoiseBrowserColumnCategory _tmp10_;
					NoiseBrowserColumnCategory _tmp11_;
					NoiseBrowserColumnCategory _tmp12_;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp6_ = _category_it;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (!gee_iterator_next (_tmp6_)) {
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 2734 "ColumnBrowser.c"
					}
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp7_ = _category_it;
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp8_ = gee_iterator_get (_tmp7_);
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					category = (NoiseBrowserColumnCategory) ((gintptr) _tmp8_);
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp9_ = column;
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp10_ = noise_browser_column_get_category (_tmp9_);
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp11_ = _tmp10_;
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					_tmp12_ = category;
#line 103 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
					if (_tmp11_ == _tmp12_) {
#line 104 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						column_visible = TRUE;
#line 105 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
						break;
#line 2756 "ColumnBrowser.c"
					}
				}
#line 102 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_category_it);
#line 2761 "ColumnBrowser.c"
			}
#line 109 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp13_ = column;
#line 109 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp14_ = column_visible;
#line 109 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			noise_browser_column_set_visible (_tmp13_, _tmp14_);
#line 111 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp15_ = column_visible;
#line 111 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			if (_tmp15_) {
#line 112 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				no_column_enabled = FALSE;
#line 2775 "ColumnBrowser.c"
			}
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_g_object_unref0 (column);
#line 2779 "ColumnBrowser.c"
		}
#line 99 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (_column_it);
#line 2783 "ColumnBrowser.c"
	}
#line 116 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp16_ = no_column_enabled;
#line 116 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp16_) {
#line 2789 "ColumnBrowser.c"
		NoiseBrowserColumn* col = NULL;
		GeeTreeSet* _tmp17_;
		gpointer _tmp18_;
		NoiseBrowserColumn* _tmp19_;
#line 117 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp17_ = self->priv->_columns;
#line 117 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp18_ = gee_abstract_sorted_set_first ((GeeAbstractSortedSet*) _tmp17_);
#line 117 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col = (NoiseBrowserColumn*) _tmp18_;
#line 118 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp19_ = col;
#line 118 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		if (_tmp19_ != NULL) {
#line 2804 "ColumnBrowser.c"
			NoiseBrowserColumn* _tmp20_;
#line 119 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp20_ = col;
#line 119 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			noise_browser_column_set_visible (_tmp20_, TRUE);
#line 2810 "ColumnBrowser.c"
		}
#line 116 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (col);
#line 2814 "ColumnBrowser.c"
	}
#line 94 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_column_browser_properties[NOISE_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY]);
#line 2818 "ColumnBrowser.c"
}


gboolean
noise_column_browser_get_initialized (NoiseColumnBrowser* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = self->priv->media;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp1_ == NULL) {
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = TRUE;
#line 2836 "ColumnBrowser.c"
	} else {
		GeeCollection* _tmp2_;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp2_ = self->priv->search_results;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 2843 "ColumnBrowser.c"
	}
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 124 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2849 "ColumnBrowser.c"
}


GeeTreeSet*
noise_column_browser_get_columns (NoiseColumnBrowser* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->_columns;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	result = _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return result;
#line 2866 "ColumnBrowser.c"
}


static void
noise_column_browser_set_columns (NoiseColumnBrowser* self,
                                  GeeTreeSet* value)
{
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (noise_column_browser_get_columns (self) != value) {
#line 2878 "ColumnBrowser.c"
		GeeTreeSet* _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		_g_object_unref0 (self->priv->_columns);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		self->priv->_columns = _tmp0_;
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_column_browser_properties[NOISE_COLUMN_BROWSER_COLUMNS_PROPERTY]);
#line 2888 "ColumnBrowser.c"
	}
}


static void
_g_object_unref0_ (gpointer var)
{
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2898 "ColumnBrowser.c"
}


static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2907 "ColumnBrowser.c"
}


static void
_vala_array_add6 (NoiseBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  NoiseBrowserColumnCategory value)
{
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 2923 "ColumnBrowser.c"
	}
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2927 "ColumnBrowser.c"
}


static void
_vala_array_add7 (NoiseBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  NoiseBrowserColumnCategory value)
{
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 2943 "ColumnBrowser.c"
	}
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2947 "ColumnBrowser.c"
}


static void
_vala_array_add8 (NoiseBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  NoiseBrowserColumnCategory value)
{
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 2963 "ColumnBrowser.c"
	}
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2967 "ColumnBrowser.c"
}


static void
_vala_array_add9 (NoiseBrowserColumnCategory* * array,
                  int* length,
                  int* size,
                  NoiseBrowserColumnCategory value)
{
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 2983 "ColumnBrowser.c"
	}
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 2987 "ColumnBrowser.c"
}


static void
_vala_array_add10 (NoiseBrowserColumnCategory* * array,
                   int* length,
                   int* size,
                   NoiseBrowserColumnCategory value)
{
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 3003 "ColumnBrowser.c"
	}
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 3007 "ColumnBrowser.c"
}


static void
_vala_array_add11 (NoiseBrowserColumnCategory* * array,
                   int* length,
                   int* size,
                   NoiseBrowserColumnCategory value)
{
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 3023 "ColumnBrowser.c"
	}
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 3027 "ColumnBrowser.c"
}


static void
_vala_array_add12 (NoiseBrowserColumnCategory* * array,
                   int* length,
                   int* size,
                   NoiseBrowserColumnCategory value)
{
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if ((*length) == (*size)) {
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		*array = g_renew (NoiseBrowserColumnCategory, *array, *size);
#line 3043 "ColumnBrowser.c"
	}
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(*array)[(*length)++] = value;
#line 3047 "ColumnBrowser.c"
}


static void
_noise_column_browser___lambda67_ (NoiseColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->automatic_menu_item;
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 184 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp2_) {
#line 185 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_position (self, NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC);
#line 3067 "ColumnBrowser.c"
	}
}


static void
__noise_column_browser___lambda67__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 183 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_noise_column_browser___lambda67_ ((NoiseColumnBrowser*) self);
#line 3078 "ColumnBrowser.c"
}


static void
_noise_column_browser___lambda68_ (NoiseColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->left_menu_item;
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 190 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp2_) {
#line 191 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_position (self, NOISE_COLUMN_BROWSER_POSITION_LEFT);
#line 3098 "ColumnBrowser.c"
	}
}


static void
__noise_column_browser___lambda68__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 189 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_noise_column_browser___lambda68_ ((NoiseColumnBrowser*) self);
#line 3109 "ColumnBrowser.c"
}


static void
_noise_column_browser___lambda69_ (NoiseColumnBrowser* self)
{
	GtkRadioMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = self->priv->top_menu_item;
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gtk_check_menu_item_get_active ((GtkCheckMenuItem*) _tmp0_);
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = _tmp1_;
#line 196 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	if (_tmp2_) {
#line 197 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_position (self, NOISE_COLUMN_BROWSER_POSITION_TOP);
#line 3129 "ColumnBrowser.c"
	}
}


static void
__noise_column_browser___lambda69__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                                                gpointer self)
{
#line 195 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_noise_column_browser___lambda69_ ((NoiseColumnBrowser*) self);
#line 3140 "ColumnBrowser.c"
}


static void
_noise_column_browser_save_current_state_gtk_widget_destroy (GtkWidget* _sender,
                                                             gpointer self)
{
#line 201 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_save_current_state ((NoiseColumnBrowser*) self);
#line 3150 "ColumnBrowser.c"
}


static GObject *
noise_column_browser_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseColumnBrowser * self;
	GSList* _tmp0_;
	GtkRadioMenuItem* _tmp1_;
	GtkRadioMenuItem* _tmp2_;
	GSList* _tmp3_;
	GtkRadioMenuItem* _tmp4_;
	GtkRadioMenuItem* _tmp5_;
	GSList* _tmp6_;
	GtkRadioMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	NoiseBrowserColumnCategory* categories = NULL;
	NoiseBrowserColumnCategory* _tmp9_;
	gint categories_length1;
	gint _categories_size_;
	NoiseBrowserColumnCategory* _tmp10_;
	gint _tmp10__length1;
	NoiseBrowserColumnCategory* _tmp11_;
	gint _tmp11__length1;
	NoiseBrowserColumnCategory* _tmp12_;
	gint _tmp12__length1;
	NoiseBrowserColumnCategory* _tmp13_;
	gint _tmp13__length1;
	NoiseBrowserColumnCategory* _tmp14_;
	gint _tmp14__length1;
	NoiseBrowserColumnCategory* _tmp15_;
	gint _tmp15__length1;
	NoiseBrowserColumnCategory* _tmp16_;
	gint _tmp16__length1;
	GeeTreeSet* _tmp17_;
	GeeTreeSet* _tmp18_;
	NoiseBrowserColumnCategory* _tmp19_;
	gint _tmp19__length1;
	GeeTreeSet* visible_categories = NULL;
	GeeTreeSet* _tmp23_;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	GeeTreeSet* _tmp31_;
	GtkMenu* _tmp32_;
	GtkSeparatorMenuItem* _tmp33_;
	GtkSeparatorMenuItem* _tmp34_;
	GtkMenu* _tmp35_;
	GtkRadioMenuItem* _tmp36_;
	GtkMenu* _tmp37_;
	GtkRadioMenuItem* _tmp38_;
	GtkMenu* _tmp39_;
	GtkRadioMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	GSettings* _tmp42_;
	GSettings* _tmp43_;
	GtkRadioMenuItem* _tmp44_;
	GtkRadioMenuItem* _tmp45_;
	GtkRadioMenuItem* _tmp46_;
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	parent_class = G_OBJECT_CLASS (noise_column_browser_parent_class);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser);
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = NULL;
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp0_, _ ("Automatic"));
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp1_);
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->automatic_menu_item);
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->automatic_menu_item = _tmp1_;
#line 145 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_slist_free__g_object_unref0_ (_tmp0_), NULL));
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp2_ = self->priv->automatic_menu_item;
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp3_ = gtk_radio_menu_item_get_group (_tmp2_);
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp4_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp3_, _ ("On Left"));
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp4_);
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->left_menu_item);
#line 146 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->left_menu_item = _tmp4_;
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp5_ = self->priv->left_menu_item;
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp6_ = gtk_radio_menu_item_get_group (_tmp5_);
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp7_ = (GtkRadioMenuItem*) gtk_radio_menu_item_new_with_label (_tmp6_, _ ("On Top"));
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp7_);
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->top_menu_item);
#line 147 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->top_menu_item = _tmp7_;
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp8_ = (GtkMenu*) gtk_menu_new ();
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp8_);
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->column_chooser_menu);
#line 149 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->column_chooser_menu = _tmp8_;
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp9_ = g_new0 (NoiseBrowserColumnCategory, 0);
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	categories = _tmp9_;
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	categories_length1 = 0;
#line 151 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_categories_size_ = categories_length1;
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp10_ = categories;
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp10__length1 = categories_length1;
#line 152 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add6 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_RATING);
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp11_ = categories;
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp11__length1 = categories_length1;
#line 153 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add7 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_GROUPING);
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12_ = categories;
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp12__length1 = categories_length1;
#line 154 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add8 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_YEAR);
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp13_ = categories;
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp13__length1 = categories_length1;
#line 155 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add9 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_GENRE);
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp14_ = categories;
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp14__length1 = categories_length1;
#line 156 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add10 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER);
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp15_ = categories;
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp15__length1 = categories_length1;
#line 157 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add11 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_ARTIST);
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp16_ = categories;
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp16__length1 = categories_length1;
#line 158 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_vala_array_add12 (&categories, &categories_length1, &_categories_size_, NOISE_BROWSER_COLUMN_CATEGORY_ALBUM);
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp17_ = gee_tree_set_new (NOISE_TYPE_BROWSER_COLUMN, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp18_ = _tmp17_;
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_set_columns (self, _tmp18_);
#line 160 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (_tmp18_);
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp19_ = categories;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp19__length1 = categories_length1;
#line 3327 "ColumnBrowser.c"
	{
		NoiseBrowserColumnCategory* category_collection = NULL;
		gint category_collection_length1 = 0;
		gint _category_collection_size_ = 0;
		gint category_it = 0;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		category_collection = _tmp19_;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		category_collection_length1 = _tmp19__length1;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		for (category_it = 0; category_it < _tmp19__length1; category_it = category_it + 1) {
#line 3339 "ColumnBrowser.c"
			NoiseBrowserColumnCategory category = 0;
#line 162 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			category = category_collection[category_it];
#line 3343 "ColumnBrowser.c"
			{
				NoiseBrowserColumnCategory _tmp20_;
				NoiseBrowserColumn* _tmp21_;
				NoiseBrowserColumn* _tmp22_;
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp20_ = category;
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp21_ = noise_column_browser_add_column (self, _tmp20_);
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp22_ = _tmp21_;
#line 163 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_object_unref0 (_tmp22_);
#line 3356 "ColumnBrowser.c"
			}
		}
	}
#line 166 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp23_ = gee_tree_set_new (NOISE_BROWSER_COLUMN_TYPE_CATEGORY, NULL, NULL, NULL, NULL, NULL);
#line 166 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	visible_categories = _tmp23_;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp24_ = noise_app_get_saved_state ();
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp25_ = _tmp24_;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp27_ = _tmp26_ = g_settings_get_strv (_tmp25_, "column-browser-visible-columns");
#line 3370 "ColumnBrowser.c"
	{
		gchar** col_n_collection = NULL;
		gint col_n_collection_length1 = 0;
		gint _col_n_collection_size_ = 0;
		gint col_n_it = 0;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col_n_collection = _tmp27_;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col_n_collection_length1 = _vala_array_length (_tmp26_);
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		for (col_n_it = 0; col_n_it < _vala_array_length (_tmp26_); col_n_it = col_n_it + 1) {
#line 3382 "ColumnBrowser.c"
			gchar* _tmp28_;
			gchar* col_n = NULL;
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			_tmp28_ = g_strdup (col_n_collection[col_n_it]);
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
			col_n = _tmp28_;
#line 3389 "ColumnBrowser.c"
			{
				GeeTreeSet* _tmp29_;
				const gchar* _tmp30_;
#line 169 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp29_ = visible_categories;
#line 169 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_tmp30_ = col_n;
#line 169 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, (gpointer) ((gintptr) ((NoiseBrowserColumnCategory) atoi (_tmp30_))));
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
				_g_free0 (col_n);
#line 3401 "ColumnBrowser.c"
			}
		}
#line 168 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		col_n_collection = (_vala_array_free (col_n_collection, col_n_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3406 "ColumnBrowser.c"
	}
#line 172 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp31_ = visible_categories;
#line 172 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_set_visible_columns (self, _tmp31_);
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp32_ = self->priv->column_chooser_menu;
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp33_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_ref_sink (_tmp33_);
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp34_ = _tmp33_;
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp32_, (GtkMenuItem*) _tmp34_);
#line 174 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (_tmp34_);
#line 175 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp35_ = self->priv->column_chooser_menu;
#line 175 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp36_ = self->priv->automatic_menu_item;
#line 175 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp35_, (GtkMenuItem*) _tmp36_);
#line 176 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp37_ = self->priv->column_chooser_menu;
#line 176 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp38_ = self->priv->top_menu_item;
#line 176 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp37_, (GtkMenuItem*) _tmp38_);
#line 177 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp39_ = self->priv->column_chooser_menu;
#line 177 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp40_ = self->priv->left_menu_item;
#line 177 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp39_, (GtkMenuItem*) _tmp40_);
#line 178 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp41_ = self->priv->column_chooser_menu;
#line 178 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp41_);
#line 180 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 181 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp42_ = noise_app_get_saved_state ();
#line 181 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp43_ = _tmp42_;
#line 181 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_set_position (self, (NoiseColumnBrowserPosition) g_settings_get_int (_tmp43_, "column-browser-position"));
#line 183 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp44_ = self->priv->automatic_menu_item;
#line 183 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp44_, "toggled", (GCallback) __noise_column_browser___lambda67__gtk_check_menu_item_toggled, self, 0);
#line 189 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp45_ = self->priv->left_menu_item;
#line 189 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp45_, "toggled", (GCallback) __noise_column_browser___lambda68__gtk_check_menu_item_toggled, self, 0);
#line 195 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp46_ = self->priv->top_menu_item;
#line 195 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkCheckMenuItem*) _tmp46_, "toggled", (GCallback) __noise_column_browser___lambda69__gtk_check_menu_item_toggled, self, 0);
#line 201 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _noise_column_browser_save_current_state_gtk_widget_destroy, self, 0);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (visible_categories);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	categories = (g_free (categories), NULL);
#line 144 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	return obj;
#line 3474 "ColumnBrowser.c"
}


static void
noise_column_browser_class_init (NoiseColumnBrowserClass * klass)
{
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_type_class_adjust_private_offset (klass, &NoiseColumnBrowser_private_offset);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_column_browser_get_property;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_column_browser_set_property;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_column_browser_constructor;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_column_browser_finalize;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_POSITION_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_POSITION_PROPERTY] = g_param_spec_enum ("position", "position", "position", NOISE_COLUMN_BROWSER_TYPE_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY] = g_param_spec_enum ("actual-position", "actual-position", "actual-position", NOISE_COLUMN_BROWSER_TYPE_POSITION, NOISE_COLUMN_BROWSER_POSITION_LEFT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("view-wrapper", "view-wrapper", "view-wrapper", NOISE_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3499 "ColumnBrowser.c"
	/**
	     * Whether the columns are filtered or not based on the current selection.
	     * Although 'media.size == search_results.size' would produce a similar result,
	     * here we want to know if the "All ..." filter is selected in every column.
	     */
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_FILTERED_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_FILTERED_PROPERTY] = g_param_spec_boolean ("filtered", "filtered", "filtered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY] = g_param_spec_object ("visible-columns", "visible-columns", "visible-columns", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_INITIALIZED_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_INITIALIZED_PROPERTY] = g_param_spec_boolean ("initialized", "initialized", "initialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_COLUMN_BROWSER_COLUMNS_PROPERTY, noise_column_browser_properties[NOISE_COLUMN_BROWSER_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_signals[NOISE_COLUMN_BROWSER_CHANGED_SIGNAL] = g_signal_new ("changed", NOISE_TYPE_COLUMN_BROWSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	noise_column_browser_signals[NOISE_COLUMN_BROWSER_POSITION_CHANGED_SIGNAL] = g_signal_new ("position-changed", NOISE_TYPE_COLUMN_BROWSER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, NOISE_COLUMN_BROWSER_TYPE_POSITION);
#line 3517 "ColumnBrowser.c"
}


static void
noise_column_browser_instance_init (NoiseColumnBrowser * self)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv = noise_column_browser_get_instance_private (self);
#line 40 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->_position = NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC;
#line 66 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->_actual_position = NOISE_COLUMN_BROWSER_POSITION_LEFT;
#line 129 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 129 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->media = _tmp0_;
#line 133 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_tmp1_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 133 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self->priv->search_results = (GeeCollection*) _tmp1_;
#line 3540 "ColumnBrowser.c"
}


static void
noise_column_browser_finalize (GObject * obj)
{
	NoiseColumnBrowser * self;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser);
#line 68 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->_view_wrapper);
#line 126 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->_columns);
#line 129 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->media);
#line 133 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->search_results);
#line 135 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->column_chooser_menu);
#line 136 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->top_menu_item);
#line 137 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->left_menu_item);
#line 138 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	_g_object_unref0 (self->priv->automatic_menu_item);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	G_OBJECT_CLASS (noise_column_browser_parent_class)->finalize (obj);
#line 3568 "ColumnBrowser.c"
}


GType
noise_column_browser_get_type (void)
{
	static volatile gsize noise_column_browser_type_id__volatile = 0;
	if (g_once_init_enter (&noise_column_browser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseColumnBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_column_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseColumnBrowser), 0, (GInstanceInitFunc) noise_column_browser_instance_init, NULL };
		GType noise_column_browser_type_id;
		noise_column_browser_type_id = g_type_register_static (gtk_grid_get_type (), "NoiseColumnBrowser", &g_define_type_info, 0);
		NoiseColumnBrowser_private_offset = g_type_add_instance_private (noise_column_browser_type_id, sizeof (NoiseColumnBrowserPrivate));
		g_once_init_leave (&noise_column_browser_type_id__volatile, noise_column_browser_type_id);
	}
	return noise_column_browser_type_id__volatile;
}


static void
_vala_noise_column_browser_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	NoiseColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_enum (value, noise_column_browser_get_position (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_enum (value, noise_column_browser_get_actual_position (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_object (value, noise_column_browser_get_view_wrapper (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_FILTERED_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_boolean (value, noise_column_browser_get_filtered (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_take_object (value, noise_column_browser_get_visible_columns (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_INITIALIZED_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_boolean (value, noise_column_browser_get_initialized (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		g_value_set_object (value, noise_column_browser_get_columns (self));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3639 "ColumnBrowser.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3645 "ColumnBrowser.c"
	}
}


static void
_vala_noise_column_browser_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	NoiseColumnBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_position (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_ACTUAL_POSITION_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_actual_position (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_VIEW_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_view_wrapper (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_VISIBLE_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_visible_columns (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		case NOISE_COLUMN_BROWSER_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		noise_column_browser_set_columns (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3690 "ColumnBrowser.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/ColumnBrowser.vala"
		break;
#line 3696 "ColumnBrowser.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



