/* TreeViewSetup.c generated by valac 0.42.6, the Vala compiler
 * generated from TreeViewSetup.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libgda/libgda.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define NOISE_TYPE_TREE_VIEW_SETUP (noise_tree_view_setup_get_type ())
#define NOISE_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup))
#define NOISE_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))
#define NOISE_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))

typedef struct _NoiseTreeViewSetup NoiseTreeViewSetup;
typedef struct _NoiseTreeViewSetupClass NoiseTreeViewSetupClass;
typedef struct _NoiseTreeViewSetupPrivate NoiseTreeViewSetupPrivate;
typedef enum  {
	NOISE_LIST_COLUMN_ICON = 0,
	NOISE_LIST_COLUMN_NUMBER,
	NOISE_LIST_COLUMN_TRACK,
	NOISE_LIST_COLUMN_TITLE,
	NOISE_LIST_COLUMN_LENGTH,
	NOISE_LIST_COLUMN_ARTIST,
	NOISE_LIST_COLUMN_ALBUM,
	NOISE_LIST_COLUMN_ALBUM_ARTIST,
	NOISE_LIST_COLUMN_COMPOSER,
	NOISE_LIST_COLUMN_GENRE,
	NOISE_LIST_COLUMN_YEAR,
	NOISE_LIST_COLUMN_GROUPING,
	NOISE_LIST_COLUMN_BITRATE,
	NOISE_LIST_COLUMN_RATING,
	NOISE_LIST_COLUMN_PLAY_COUNT,
	NOISE_LIST_COLUMN_SKIP_COUNT,
	NOISE_LIST_COLUMN_DATE_ADDED,
	NOISE_LIST_COLUMN_LAST_PLAYED,
	NOISE_LIST_COLUMN_BPM,
	NOISE_LIST_COLUMN_FILE_LOCATION,
	NOISE_LIST_COLUMN_FILE_SIZE,
	NOISE_LIST_COLUMN_N_COLUMNS
} NoiseListColumn;


#define NOISE_TYPE_LIST_COLUMN (noise_list_column_get_type ())
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
enum  {
	NOISE_TREE_VIEW_SETUP_0_PROPERTY,
	NOISE_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY,
	NOISE_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY,
	NOISE_TREE_VIEW_SETUP_HINT_PROPERTY,
	NOISE_TREE_VIEW_SETUP_CONNECTION_PROPERTY,
	NOISE_TREE_VIEW_SETUP_UID_PROPERTY,
	NOISE_TREE_VIEW_SETUP_NUM_PROPERTIES
};
static GParamSpec* noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block25Data Block25Data;
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseTreeViewSetup {
	GObject parent_instance;
	NoiseTreeViewSetupPrivate * priv;
};

struct _NoiseTreeViewSetupClass {
	GObjectClass parent_class;
};

struct _NoiseTreeViewSetupPrivate {
	NoiseListColumn _sort_column_id;
	GtkSortType _sort_direction;
	NoiseViewWrapperHint _hint;
	GdaConnection* _connection;
	gchar* _uid;
	GeeLinkedList* columns;
};

struct _Block25Data {
	int _ref_count_;
	NoiseTreeViewSetup* self;
	GtkTreeViewColumn* column;
};


static gint NoiseTreeViewSetup_private_offset;
static gpointer noise_tree_view_setup_parent_class = NULL;

GType noise_tree_view_setup_get_type (void) G_GNUC_CONST;
GType noise_list_column_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
#define NOISE_TREE_VIEW_SETUP_ASCENDING_STRING "ASCENDING"
#define NOISE_TREE_VIEW_SETUP_DESCENDING_STRING "DESCENDING"
#define NOISE_TREE_VIEW_SETUP_COLUMN_SEP_STRING "<c_sep>"
#define NOISE_TREE_VIEW_SETUP_VALUE_SEP_STRING "<v_sep>"
#define NOISE_TREE_VIEW_SETUP_TYPE_DATA_KEY "setup-list-column-type"
NoiseTreeViewSetup* noise_tree_view_setup_new (NoiseViewWrapperHint hint,
                                               const gchar* uid,
                                               GdaConnection* connection);
NoiseTreeViewSetup* noise_tree_view_setup_construct (GType object_type,
                                                     NoiseViewWrapperHint hint,
                                                     const gchar* uid,
                                                     GdaConnection* connection);
GeeCollection* noise_tree_view_setup_get_columns (NoiseTreeViewSetup* self);
NoiseViewWrapperHint noise_tree_view_setup_get_hint (NoiseTreeViewSetup* self);
const gchar* noise_view_wrapper_hint_to_string (NoiseViewWrapperHint self);
static void noise_tree_view_setup_create_default_columns (NoiseTreeViewSetup* self);
static void noise_tree_view_setup_set_columns (NoiseTreeViewSetup* self,
                                        GeeCollection* cols);
static gboolean noise_tree_view_setup_import_columns (NoiseTreeViewSetup* self,
                                               const gchar* cols);
static gint noise_tree_view_setup_column_compare_func (NoiseTreeViewSetup* self,
                                                GtkTreeViewColumn* column_a,
                                                GtkTreeViewColumn* column_b);
static gint _noise_tree_view_setup_column_compare_func_gcompare_data_func (gconstpointer a,
                                                                    gconstpointer b,
                                                                    gpointer self);
static GtkTreeViewColumn* noise_tree_view_setup_create_column (NoiseTreeViewSetup* self,
                                                        NoiseListColumn type,
                                                        gboolean visible);
static gchar* noise_tree_view_setup_columns_to_string (NoiseTreeViewSetup* self);
NoiseListColumn* noise_tree_view_setup_get_column_type (GtkTreeViewColumn* column);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void noise_tree_view_setup_set_column_type (GtkTreeViewColumn* column,
                                            NoiseListColumn type);
gchar* noise_list_column_to_string (NoiseListColumn self);
NoiseListColumn noise_tree_view_setup_get_sort_column_id (NoiseTreeViewSetup* self);
GtkSortType noise_tree_view_setup_get_sort_direction (NoiseTreeViewSetup* self);
static void __lambda6_ (NoiseTreeViewSetup* self);
static void noise_tree_view_setup_set_field (NoiseTreeViewSetup* self,
                                      const gchar* field,
                                      GValue* value);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (Block25Data* _data25_);
void noise_tree_view_setup_set_sort_direction (NoiseTreeViewSetup* self,
                                               GtkSortType value);
void noise_tree_view_setup_set_sort_column_id (NoiseTreeViewSetup* self,
                                               NoiseListColumn value);
static void ___lambda7__gtk_tree_view_column_clicked (GtkTreeViewColumn* _sender,
                                               gpointer self);
static NoiseListColumn* _noise_list_column_dup (NoiseListColumn* self);
static void noise_tree_view_setup_append_new_column (NoiseTreeViewSetup* self,
                                              NoiseListColumn column,
                                              gboolean initially_visible);
static gboolean noise_tree_view_setup_exists (NoiseTreeViewSetup* self);
#define NOISE_DATABASE_COLUMNS_TABLE_NAME "columns"
const gchar* noise_tree_view_setup_get_uid (NoiseTreeViewSetup* self);
static void _vala_GValue_free (GValue* self);
GdaConnection* noise_tree_view_setup_get_connection (NoiseTreeViewSetup* self);
static GValue* noise_tree_view_setup_query_field (NoiseTreeViewSetup* self,
                                           const gchar* field);
static GValue* _g_value_dup (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
void noise_tree_view_setup_set_hint (NoiseTreeViewSetup* self,
                                     NoiseViewWrapperHint value);
static void noise_tree_view_setup_set_connection (NoiseTreeViewSetup* self,
                                           GdaConnection* value);
static void noise_tree_view_setup_set_uid (NoiseTreeViewSetup* self,
                                    const gchar* value);
static GObject * noise_tree_view_setup_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _noise_tree_view_setup____lambda8_ (NoiseTreeViewSetup* self);
static void __noise_tree_view_setup____lambda8__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _noise_tree_view_setup____lambda9_ (NoiseTreeViewSetup* self);
static void __noise_tree_view_setup____lambda9__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void noise_tree_view_setup_finalize (GObject * obj);
static void _vala_noise_tree_view_setup_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_noise_tree_view_setup_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
noise_tree_view_setup_get_instance_private (NoiseTreeViewSetup* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseTreeViewSetup_private_offset);
}


NoiseTreeViewSetup*
noise_tree_view_setup_construct (GType object_type,
                                 NoiseViewWrapperHint hint,
                                 const gchar* uid,
                                 GdaConnection* connection)
{
	NoiseTreeViewSetup * self = NULL;
#line 46 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self = (NoiseTreeViewSetup*) g_object_new (object_type, "connection", connection, "hint", hint, "uid", uid, NULL);
#line 45 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return self;
#line 268 "TreeViewSetup.c"
}


NoiseTreeViewSetup*
noise_tree_view_setup_new (NoiseViewWrapperHint hint,
                           const gchar* uid,
                           GdaConnection* connection)
{
#line 45 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return noise_tree_view_setup_construct (NOISE_TYPE_TREE_VIEW_SETUP, hint, uid, connection);
#line 279 "TreeViewSetup.c"
}


GeeCollection*
noise_tree_view_setup_get_columns (NoiseTreeViewSetup* self)
{
	GeeCollection* result = NULL;
	gboolean _tmp0_ = FALSE;
	GeeLinkedList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GeeLinkedList* _tmp9_;
	GeeBidirList* _tmp10_;
	GeeBidirList* _tmp11_;
#line 99 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = self->priv->columns;
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (_tmp3_ < 1) {
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = TRUE;
#line 306 "TreeViewSetup.c"
	} else {
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp4_ = self->priv->columns;
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp6_ = _tmp5_;
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = _tmp6_ != ((gint) NOISE_LIST_COLUMN_N_COLUMNS);
#line 319 "TreeViewSetup.c"
	}
#line 100 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (_tmp0_) {
#line 323 "TreeViewSetup.c"
		NoiseViewWrapperHint _tmp7_;
		GEnumValue* _tmp8_;
#line 101 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp7_ = self->priv->_hint;
#line 101 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp8_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp7_);
#line 101 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_debug ("TreeViewSetup.vala:101: Creating a new TreeViewSetup for %s", (_tmp8_ != NULL) ? _tmp8_->value_name : NULL);
#line 102 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		noise_tree_view_setup_create_default_columns (self);
#line 334 "TreeViewSetup.c"
	}
#line 105 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp9_ = self->priv->columns;
#line 105 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp10_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp9_);
#line 105 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp11_ = _tmp10_;
#line 105 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = (GeeCollection*) _tmp11_;
#line 105 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 346 "TreeViewSetup.c"
}


/**
     * Sets the list of columns that will be stored by the treeview setup.
     *
     * Each column must have been created using create_column(), or bad things
     * will happen. E.g. columns_to_string() will not work.
     */
static void
noise_tree_view_setup_set_columns (NoiseTreeViewSetup* self,
                                   GeeCollection* cols)
{
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 114 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (cols != NULL);
#line 115 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->columns;
#line 115 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 116 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = self->priv->columns;
#line 116 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, cols);
#line 374 "TreeViewSetup.c"
}


/**
     * Transforms the string representation of the columns into a real list of
     * treeview columns. This overwrites the previous list of columns.
     *
     * It the string cannot be parsed, //false// is returned and the previous
     * list of columns remains unmodified.
     *
     * @param cols string representation of columns created by columns_to_string().
     * @return Whether the string was succesfully parsed and imported.
     */
static gint
_noise_tree_view_setup_column_compare_func_gcompare_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self)
{
	gint result;
	result = noise_tree_view_setup_column_compare_func ((NoiseTreeViewSetup*) self, (GtkTreeViewColumn*) a, (GtkTreeViewColumn*) b);
#line 131 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 397 "TreeViewSetup.c"
}


static gboolean
noise_tree_view_setup_import_columns (NoiseTreeViewSetup* self,
                                      const gchar* cols)
{
	gboolean result = FALSE;
	gchar** col_strings = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint col_strings_length1;
	gint _col_strings_size_;
	GeeTreeSet* new_columns = NULL;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp24_;
#line 129 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (cols != NULL, FALSE);
#line 130 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = _tmp0_ = g_strsplit (cols, NOISE_TREE_VIEW_SETUP_COLUMN_SEP_STRING, 0);
#line 130 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	col_strings = _tmp1_;
#line 130 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	col_strings_length1 = _vala_array_length (_tmp0_);
#line 130 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_col_strings_size_ = col_strings_length1;
#line 131 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp2_ = gee_tree_set_new (gtk_tree_view_column_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _noise_tree_view_setup_column_compare_func_gcompare_data_func, g_object_ref (self), g_object_unref);
#line 131 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	new_columns = _tmp2_;
#line 430 "TreeViewSetup.c"
	{
		gint index = 0;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		index = 0;
#line 435 "TreeViewSetup.c"
		{
			gboolean _tmp3_ = FALSE;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp3_ = TRUE;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			while (TRUE) {
#line 442 "TreeViewSetup.c"
				gint _tmp5_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** pieces_of_column = NULL;
				gchar** _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				const gchar* _tmp9_;
				gchar** _tmp10_;
				gchar** _tmp11_;
				gint pieces_of_column_length1;
				gint _pieces_of_column_size_;
				NoiseListColumn type = 0;
				gchar** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				gint visible_val = 0;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				gboolean _tmp16_ = FALSE;
				gint _tmp17_;
				GeeTreeSet* _tmp19_;
				NoiseListColumn _tmp20_;
				gint _tmp21_;
				GtkTreeViewColumn* _tmp22_;
				GtkTreeViewColumn* _tmp23_;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				if (!_tmp3_) {
#line 472 "TreeViewSetup.c"
					gint _tmp4_;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_tmp4_ = index;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					index = _tmp4_ + 1;
#line 478 "TreeViewSetup.c"
				}
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp3_ = FALSE;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp5_ = index;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp6_ = col_strings;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp6__length1 = col_strings_length1;
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				if (!(_tmp5_ < (_tmp6__length1 - 1))) {
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					break;
#line 492 "TreeViewSetup.c"
				}
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp7_ = col_strings;
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp7__length1 = col_strings_length1;
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp8_ = index;
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp9_ = _tmp7_[_tmp8_];
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, NOISE_TREE_VIEW_SETUP_VALUE_SEP_STRING, 0);
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				pieces_of_column = _tmp11_;
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				pieces_of_column_length1 = _vala_array_length (_tmp10_);
#line 135 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_pieces_of_column_size_ = pieces_of_column_length1;
#line 137 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp12_ = pieces_of_column;
#line 137 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp12__length1 = pieces_of_column_length1;
#line 137 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp13_ = _tmp12_[0];
#line 137 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				type = (NoiseListColumn) atoi (_tmp13_);
#line 139 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp14_ = pieces_of_column;
#line 139 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp14__length1 = pieces_of_column_length1;
#line 139 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp15_ = _tmp14_[1];
#line 139 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				visible_val = atoi (_tmp15_);
#line 140 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp17_ = visible_val;
#line 140 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				if (_tmp17_ != 1) {
#line 530 "TreeViewSetup.c"
					gint _tmp18_;
#line 140 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_tmp18_ = visible_val;
#line 140 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_tmp16_ = _tmp18_ != 0;
#line 536 "TreeViewSetup.c"
				} else {
#line 140 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_tmp16_ = FALSE;
#line 540 "TreeViewSetup.c"
				}
#line 140 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				if (_tmp16_) {
#line 141 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					result = FALSE;
#line 141 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					pieces_of_column = (_vala_array_free (pieces_of_column, pieces_of_column_length1, (GDestroyNotify) g_free), NULL);
#line 141 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_g_object_unref0 (new_columns);
#line 141 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					col_strings = (_vala_array_free (col_strings, col_strings_length1, (GDestroyNotify) g_free), NULL);
#line 141 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					return result;
#line 554 "TreeViewSetup.c"
				}
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp19_ = new_columns;
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp20_ = type;
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp21_ = visible_val;
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp22_ = noise_tree_view_setup_create_column (self, _tmp20_, _tmp21_ == 1);
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp23_ = _tmp22_;
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp23_);
#line 143 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_g_object_unref0 (_tmp23_);
#line 134 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				pieces_of_column = (_vala_array_free (pieces_of_column, pieces_of_column_length1, (GDestroyNotify) g_free), NULL);
#line 572 "TreeViewSetup.c"
			}
		}
	}
#line 146 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp24_ = new_columns;
#line 146 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_columns (self, (GeeCollection*) _tmp24_);
#line 147 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = TRUE;
#line 147 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_object_unref0 (new_columns);
#line 147 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	col_strings = (_vala_array_free (col_strings, col_strings_length1, (GDestroyNotify) g_free), NULL);
#line 147 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 588 "TreeViewSetup.c"
}


static gchar*
noise_tree_view_setup_columns_to_string (NoiseTreeViewSetup* self)
{
	gchar* result = NULL;
	GString* columns_string = NULL;
	GString* _tmp0_;
	GeeCollection* columns = NULL;
	GeeCollection* _tmp1_;
	GString* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
#line 150 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = g_string_new ("");
#line 151 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	columns_string = _tmp0_;
#line 153 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = noise_tree_view_setup_get_columns (self);
#line 153 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	columns = _tmp1_;
#line 613 "TreeViewSetup.c"
	{
		GeeIterator* _tvc_it = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp2_ = columns;
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tvc_it = _tmp3_;
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		while (TRUE) {
#line 626 "TreeViewSetup.c"
			GeeIterator* _tmp4_;
			GtkTreeViewColumn* tvc = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			gint type = 0;
			GtkTreeViewColumn* _tmp7_;
			NoiseListColumn* _tmp8_;
			NoiseListColumn* _tmp9_;
			gint _tmp10_;
			GString* _tmp11_;
			gint _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			GString* _tmp15_;
			const gchar* _tmp16_ = NULL;
			GtkTreeViewColumn* _tmp17_;
			gboolean _tmp18_;
			gboolean _tmp19_;
			GString* _tmp20_;
			GString* _tmp21_;
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp4_ = _tvc_it;
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				break;
#line 653 "TreeViewSetup.c"
			}
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp5_ = _tvc_it;
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			tvc = (GtkTreeViewColumn*) _tmp6_;
#line 163 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp7_ = tvc;
#line 163 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp8_ = noise_tree_view_setup_get_column_type (_tmp7_);
#line 163 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp9_ = _tmp8_;
#line 163 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp10_ = *_tmp9_;
#line 163 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_free0 (_tmp9_);
#line 163 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			type = _tmp10_;
#line 164 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp11_ = columns_string;
#line 164 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp12_ = type;
#line 164 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp13_ = g_strdup_printf ("%i", _tmp12_);
#line 164 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp14_ = _tmp13_;
#line 164 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			g_string_append (_tmp11_, _tmp14_);
#line 164 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_free0 (_tmp14_);
#line 165 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp15_ = columns_string;
#line 165 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			g_string_append (_tmp15_, NOISE_TREE_VIEW_SETUP_VALUE_SEP_STRING);
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp17_ = tvc;
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp18_ = gtk_tree_view_column_get_visible (_tmp17_);
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp19_ = _tmp18_;
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp19_) {
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp16_ = "1";
#line 699 "TreeViewSetup.c"
			} else {
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp16_ = "0";
#line 703 "TreeViewSetup.c"
			}
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp20_ = columns_string;
#line 166 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			g_string_append (_tmp20_, _tmp16_);
#line 167 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp21_ = columns_string;
#line 167 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			g_string_append (_tmp21_, NOISE_TREE_VIEW_SETUP_COLUMN_SEP_STRING);
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (tvc);
#line 715 "TreeViewSetup.c"
		}
#line 154 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (_tvc_it);
#line 719 "TreeViewSetup.c"
	}
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp22_ = columns_string;
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp23_ = _tmp22_->str;
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp24_;
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_object_unref0 (columns);
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_string_free0 (columns_string);
#line 170 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 735 "TreeViewSetup.c"
}


/**
     * Creates a new treeview column for use in the views and treeview setups.
     *
     * Every column that goes into a list *must* be created by this method. Otherwise,
     * columns_to_string() won't work and bad things could happen.
     */
static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return _data25_;
#line 752 "TreeViewSetup.c"
}


static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 763 "TreeViewSetup.c"
		NoiseTreeViewSetup* self;
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		self = _data25_->self;
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (_data25_->column);
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (self);
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_slice_free (Block25Data, _data25_);
#line 773 "TreeViewSetup.c"
	}
}


static void
__lambda6_ (NoiseTreeViewSetup* self)
{
	gchar* _tmp0_;
	GValue _tmp1_ = {0};
#line 190 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = noise_tree_view_setup_columns_to_string (self);
#line 190 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_init (&_tmp1_, G_TYPE_STRING);
#line 190 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_take_string (&_tmp1_, _tmp0_);
#line 190 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_field (self, "columns", &_tmp1_);
#line 190 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
#line 793 "TreeViewSetup.c"
}


static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 189 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	__lambda6_ ((NoiseTreeViewSetup*) self);
#line 804 "TreeViewSetup.c"
}


static void
__lambda7_ (Block25Data* _data25_)
{
	NoiseTreeViewSetup* self;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	NoiseListColumn* _tmp2_;
	NoiseListColumn* _tmp3_;
#line 193 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self = _data25_->self;
#line 194 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = _data25_->column;
#line 194 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_sort_direction (self, gtk_tree_view_column_get_sort_order (_tmp0_));
#line 195 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = _data25_->column;
#line 195 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp2_ = noise_tree_view_setup_get_column_type (_tmp1_);
#line 195 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp3_ = _tmp2_;
#line 195 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_sort_column_id (self, *_tmp3_);
#line 195 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_free0 (_tmp3_);
#line 832 "TreeViewSetup.c"
}


static void
___lambda7__gtk_tree_view_column_clicked (GtkTreeViewColumn* _sender,
                                          gpointer self)
{
#line 193 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	__lambda7_ (self);
#line 842 "TreeViewSetup.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return self ? g_object_ref (self) : NULL;
#line 851 "TreeViewSetup.c"
}


static GtkTreeViewColumn*
noise_tree_view_setup_create_column (NoiseTreeViewSetup* self,
                                     NoiseListColumn type,
                                     gboolean visible)
{
	GtkTreeViewColumn* result = NULL;
	Block25Data* _data25_;
	GtkTreeViewColumn* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	GtkTreeViewColumn* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	NoiseListColumn _tmp6_;
	GtkTreeViewColumn* _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GtkTreeViewColumn* _tmp12_;
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_data25_->_ref_count_ = 1;
#line 179 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_data25_->self = g_object_ref (self);
#line 180 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = gtk_tree_view_column_new ();
#line 180 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_ref_sink (_tmp0_);
#line 180 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_data25_->column = _tmp0_;
#line 181 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = _data25_->column;
#line 181 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_column_type (_tmp1_, type);
#line 182 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp2_ = _data25_->column;
#line 182 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp3_ = noise_list_column_to_string (type);
#line 182 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp4_ = _tmp3_;
#line 182 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	gtk_tree_view_column_set_title (_tmp2_, _tmp4_);
#line 182 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_free0 (_tmp4_);
#line 183 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp5_ = _data25_->column;
#line 183 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	gtk_tree_view_column_set_visible (_tmp5_, visible);
#line 185 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp6_ = self->priv->_sort_column_id;
#line 185 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (type == _tmp6_) {
#line 909 "TreeViewSetup.c"
		GtkTreeViewColumn* _tmp7_;
		GtkSortType _tmp8_;
#line 186 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp7_ = _data25_->column;
#line 186 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp8_ = self->priv->_sort_direction;
#line 186 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gtk_tree_view_column_set_sort_order (_tmp7_, _tmp8_);
#line 918 "TreeViewSetup.c"
	}
#line 189 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp9_ = _data25_->column;
#line 189 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::visible", (GCallback) ___lambda6__g_object_notify, self, 0);
#line 193 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp10_ = _data25_->column;
#line 193 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_signal_connect_data (_tmp10_, "clicked", (GCallback) ___lambda7__gtk_tree_view_column_clicked, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp11_ = _data25_->column;
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp12_;
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	block25_data_unref (_data25_);
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_data25_ = NULL;
#line 197 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 940 "TreeViewSetup.c"
}


static NoiseListColumn*
_noise_list_column_dup (NoiseListColumn* self)
{
	NoiseListColumn* dup;
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	dup = g_new0 (NoiseListColumn, 1);
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	memcpy (dup, self, sizeof (NoiseListColumn));
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return dup;
#line 954 "TreeViewSetup.c"
}


static gpointer
__noise_list_column_dup0 (gpointer self)
{
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return self ? _noise_list_column_dup (self) : NULL;
#line 963 "TreeViewSetup.c"
}


NoiseListColumn*
noise_tree_view_setup_get_column_type (GtkTreeViewColumn* column)
{
	NoiseListColumn* result = NULL;
	gint type = 0;
	gconstpointer _tmp0_;
	NoiseListColumn _tmp3_;
	NoiseListColumn* _tmp4_;
#line 200 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (column != NULL, NULL);
#line 201 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = g_object_get_data ((GObject*) column, NOISE_TREE_VIEW_SETUP_TYPE_DATA_KEY);
#line 201 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	type = (gint) ((gintptr) _tmp0_);
#line 203 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (type < 0) {
#line 983 "TreeViewSetup.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 204 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp1_ = gtk_tree_view_column_get_title (column);
#line 204 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp2_ = _tmp1_;
#line 204 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_critical ("TreeViewSetup.vala:204: get_column_type: Column '%s' has no associated" \
" type.", _tmp2_);
#line 205 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_return_val_if_reached (NULL);
#line 994 "TreeViewSetup.c"
	}
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp3_ = (NoiseListColumn) type;
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp4_ = __noise_list_column_dup0 (&_tmp3_);
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp4_;
#line 208 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1004 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_set_column_type (GtkTreeViewColumn* column,
                                       NoiseListColumn type)
{
#line 211 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (column != NULL);
#line 213 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_set_data_full ((GObject*) column, NOISE_TREE_VIEW_SETUP_TYPE_DATA_KEY, (gpointer) ((gintptr) ((gint) type)), NULL);
#line 1016 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_create_default_columns (NoiseTreeViewSetup* self)
{
	GeeLinkedList* _tmp0_;
	NoiseViewWrapperHint _tmp1_;
#line 216 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->columns;
#line 217 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 221 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = self->priv->_hint;
#line 221 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	switch (_tmp1_) {
#line 221 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST:
#line 1037 "TreeViewSetup.c"
		{
#line 223 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ICON, TRUE);
#line 224 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_TITLE, TRUE);
#line 225 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_LENGTH, TRUE);
#line 226 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			break;
#line 1047 "TreeViewSetup.c"
		}
#line 221 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_VIEW_WRAPPER_HINT_CDROM:
#line 1051 "TreeViewSetup.c"
		{
#line 229 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ICON, TRUE);
#line 230 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_NUMBER, FALSE);
#line 231 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_TRACK, TRUE);
#line 232 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_TITLE, TRUE);
#line 233 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_LENGTH, TRUE);
#line 234 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ARTIST, FALSE);
#line 235 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ALBUM, FALSE);
#line 236 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_GENRE, FALSE);
#line 237 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			break;
#line 1071 "TreeViewSetup.c"
		}
		default:
		{
			gboolean _tmp2_ = FALSE;
			NoiseViewWrapperHint _tmp3_;
			gboolean num_column_visible = FALSE;
			gboolean _tmp5_;
#line 240 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ICON, TRUE);
#line 242 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp3_ = self->priv->_hint;
#line 242 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp3_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 242 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp2_ = TRUE;
#line 1087 "TreeViewSetup.c"
			} else {
				NoiseViewWrapperHint _tmp4_;
#line 243 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp4_ = self->priv->_hint;
#line 243 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp2_ = _tmp4_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST;
#line 1094 "TreeViewSetup.c"
			}
#line 242 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			num_column_visible = _tmp2_;
#line 245 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp5_ = num_column_visible;
#line 245 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_NUMBER, _tmp5_);
#line 246 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_TRACK, FALSE);
#line 247 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_TITLE, TRUE);
#line 248 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_LENGTH, TRUE);
#line 249 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ARTIST, TRUE);
#line 250 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ALBUM, TRUE);
#line 251 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_ALBUM_ARTIST, FALSE);
#line 252 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_COMPOSER, FALSE);
#line 253 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_GENRE, TRUE);
#line 254 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_YEAR, FALSE);
#line 255 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_GROUPING, FALSE);
#line 256 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_BITRATE, FALSE);
#line 257 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_RATING, FALSE);
#line 258 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_PLAY_COUNT, FALSE);
#line 259 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_SKIP_COUNT, FALSE);
#line 260 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_DATE_ADDED, FALSE);
#line 261 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_LAST_PLAYED, FALSE);
#line 262 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_BPM, FALSE);
#line 263 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_FILE_LOCATION, FALSE);
#line 264 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_append_new_column (self, NOISE_LIST_COLUMN_FILE_SIZE, FALSE);
#line 265 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			break;
#line 1142 "TreeViewSetup.c"
		}
	}
}


static void
noise_tree_view_setup_append_new_column (NoiseTreeViewSetup* self,
                                         NoiseListColumn column,
                                         gboolean initially_visible)
{
	GeeLinkedList* _tmp0_;
	GtkTreeViewColumn* _tmp1_;
	GtkTreeViewColumn* _tmp2_;
#line 269 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->columns;
#line 270 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = noise_tree_view_setup_create_column (self, column, initially_visible);
#line 270 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp2_ = _tmp1_;
#line 270 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp2_);
#line 270 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_object_unref0 (_tmp2_);
#line 1168 "TreeViewSetup.c"
}


static gint
noise_tree_view_setup_column_compare_func (NoiseTreeViewSetup* self,
                                           GtkTreeViewColumn* column_a,
                                           GtkTreeViewColumn* column_b)
{
	gint result = 0;
	gint a = 0;
	NoiseListColumn* _tmp0_;
	gint b = 0;
	NoiseListColumn* _tmp1_;
#line 273 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 273 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (column_a != NULL, 0);
#line 273 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (column_b != NULL, 0);
#line 274 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = noise_tree_view_setup_get_column_type (column_a);
#line 274 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	a = (gint) (*_tmp0_);
#line 275 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = noise_tree_view_setup_get_column_type (column_b);
#line 275 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	b = (gint) (*_tmp1_);
#line 278 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 278 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1200 "TreeViewSetup.c"
}


static void
_vala_GValue_free (GValue* self)
{
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_unset (self);
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_free (self);
#line 1211 "TreeViewSetup.c"
}


static gboolean
noise_tree_view_setup_exists (NoiseTreeViewSetup* self)
{
	gboolean result = FALSE;
	gboolean _tmp23_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 285 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1223 "TreeViewSetup.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilderId _tmp10_;
		GdaSqlBuilderId _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilderId _tmp13_;
		GdaStatement* _tmp14_ = NULL;
		GdaSqlBuilder* _tmp15_;
		GdaStatement* _tmp16_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp17_;
		GdaDataModel* _tmp18_;
		GValue* _tmp19_ = NULL;
		GdaDataModel* _tmp20_;
		GdaDataModel* _tmp21_;
#line 287 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 287 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		sql = _tmp0_;
#line 288 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp1_ = sql;
#line 288 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_sql_builder_select_add_target (_tmp1_, NOISE_DATABASE_COLUMNS_TABLE_NAME, NULL);
#line 289 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp2_ = sql;
#line 289 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp3_ = sql;
#line 289 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, "*"), (GdaSqlBuilderId) 0);
#line 290 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp4_ = sql;
#line 290 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp5_ = sql;
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp6_ = self->priv->_uid;
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp7_ = g_new0 (GValue, 1);
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_init (_tmp7_, G_TYPE_STRING);
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_string (_tmp7_, _tmp6_);
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		__vala_GValue_free0 (_tmp7_);
#line 291 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		id_param = _tmp8_;
#line 292 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp9_ = sql;
#line 292 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp10_ = id_field;
#line 292 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp11_ = id_param;
#line 292 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, _tmp10_, _tmp11_, (GdaSqlBuilderId) 0);
#line 293 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp12_ = sql;
#line 293 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp13_ = id_cond;
#line 293 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_sql_builder_set_where (_tmp12_, _tmp13_);
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp15_ = sql;
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp16_ = gda_sql_builder_get_statement (_tmp15_, &_inner_error0_);
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp14_ = _tmp16_;
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 1310 "TreeViewSetup.c"
			goto __catch89_g_error;
		}
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp17_ = self->priv->_connection;
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp18_ = gda_connection_statement_execute_select (_tmp17_, _tmp14_, NULL, &_inner_error0_);
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		data_model = _tmp18_;
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (_tmp14_);
#line 294 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 1325 "TreeViewSetup.c"
			goto __catch89_g_error;
		}
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp20_ = data_model;
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp21_ = data_model;
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp19_ = gda_data_model_get_value_at (_tmp20_, gda_data_model_get_column_index (_tmp21_, "unique_id"), 0, &_inner_error0_);
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (data_model);
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (_tmp14_);
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 1342 "TreeViewSetup.c"
			goto __catch89_g_error;
		}
#line 295 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (_tmp19_ == NULL) {
#line 296 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			result = FALSE;
#line 296 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (data_model);
#line 296 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (_tmp14_);
#line 296 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 296 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			return result;
#line 1357 "TreeViewSetup.c"
		}
#line 299 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		result = TRUE;
#line 299 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (data_model);
#line 299 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (_tmp14_);
#line 299 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (sql);
#line 299 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		return result;
#line 1369 "TreeViewSetup.c"
	}
	goto __finally89;
	__catch89_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp22_;
#line 286 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		e = _inner_error0_;
#line 286 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_inner_error0_ = NULL;
#line 301 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp22_ = self->priv->_uid;
#line 301 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_debug ("TreeViewSetup.vala:301: Column %lld doesn't exist, a new one will be c" \
"reated", _tmp22_);
#line 302 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		result = FALSE;
#line 302 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_error_free0 (e);
#line 302 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		return result;
#line 1390 "TreeViewSetup.c"
	}
	__finally89:
#line 286 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 286 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_clear_error (&_inner_error0_);
#line 286 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return _tmp23_;
#line 1399 "TreeViewSetup.c"
}


static GValue*
_g_value_dup (GValue* self)
{
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 1408 "TreeViewSetup.c"
}


static gpointer
__g_value_dup0 (gpointer self)
{
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return self ? _g_value_dup (self) : NULL;
#line 1417 "TreeViewSetup.c"
}


static GValue*
noise_tree_view_setup_query_field (NoiseTreeViewSetup* self,
                                   const gchar* field)
{
	GValue* result = NULL;
	GError* _inner_error0_ = NULL;
#line 306 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 306 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (field != NULL, NULL);
#line 1431 "TreeViewSetup.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilderId _tmp10_;
		GdaSqlBuilderId _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilderId _tmp13_;
		GdaStatement* _tmp14_ = NULL;
		GdaSqlBuilder* _tmp15_;
		GdaStatement* _tmp16_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp17_;
		GdaDataModel* _tmp18_;
		GValue* _tmp19_ = NULL;
		GdaDataModel* _tmp20_;
		GdaDataModel* _tmp21_;
		GValue* _tmp22_;
#line 308 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 308 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		sql = _tmp0_;
#line 309 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp1_ = sql;
#line 309 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_sql_builder_select_add_target (_tmp1_, NOISE_DATABASE_COLUMNS_TABLE_NAME, NULL);
#line 310 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp2_ = sql;
#line 310 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp3_ = sql;
#line 310 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, field), (GdaSqlBuilderId) 0);
#line 311 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp4_ = sql;
#line 311 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp5_ = sql;
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp6_ = self->priv->_uid;
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp7_ = g_new0 (GValue, 1);
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_init (_tmp7_, G_TYPE_STRING);
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_string (_tmp7_, _tmp6_);
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		__vala_GValue_free0 (_tmp7_);
#line 312 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		id_param = _tmp8_;
#line 313 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp9_ = sql;
#line 313 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp10_ = id_field;
#line 313 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp11_ = id_param;
#line 313 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, _tmp10_, _tmp11_, (GdaSqlBuilderId) 0);
#line 314 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp12_ = sql;
#line 314 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp13_ = id_cond;
#line 314 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_sql_builder_set_where (_tmp12_, _tmp13_);
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp15_ = sql;
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp16_ = gda_sql_builder_get_statement (_tmp15_, &_inner_error0_);
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp14_ = _tmp16_;
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 1519 "TreeViewSetup.c"
			goto __catch90_g_error;
		}
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp17_ = self->priv->_connection;
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp18_ = gda_connection_statement_execute_select (_tmp17_, _tmp14_, NULL, &_inner_error0_);
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		data_model = _tmp18_;
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (_tmp14_);
#line 315 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 1534 "TreeViewSetup.c"
			goto __catch90_g_error;
		}
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp20_ = data_model;
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp21_ = data_model;
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp19_ = gda_data_model_get_value_at (_tmp20_, gda_data_model_get_column_index (_tmp21_, field), 0, &_inner_error0_);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (data_model);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (_tmp14_);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_g_object_unref0 (sql);
#line 1551 "TreeViewSetup.c"
			goto __catch90_g_error;
		}
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp22_ = __g_value_dup0 (_tmp19_);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		result = _tmp22_;
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (data_model);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (_tmp14_);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (sql);
#line 316 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		return result;
#line 1566 "TreeViewSetup.c"
	}
	goto __finally90;
	__catch90_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 307 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		e = _inner_error0_;
#line 307 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_inner_error0_ = NULL;
#line 318 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp23_ = e;
#line 318 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp24_ = _tmp23_->message;
#line 318 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_critical ("TreeViewSetup.vala:318: Could not query field %s: %s", field, _tmp24_);
#line 319 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		result = NULL;
#line 319 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_error_free0 (e);
#line 319 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		return result;
#line 1590 "TreeViewSetup.c"
	}
	__finally90:
#line 307 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_clear_error (&_inner_error0_);
#line 307 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return NULL;
#line 1599 "TreeViewSetup.c"
}


static void
__vala_GValue_free0_ (gpointer var)
{
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 1608 "TreeViewSetup.c"
}


static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 1617 "TreeViewSetup.c"
}


static void
_g_free0_ (gpointer var)
{
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	var = (g_free (var), NULL);
#line 1626 "TreeViewSetup.c"
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 1635 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_set_field (NoiseTreeViewSetup* self,
                                 const gchar* field,
                                 GValue* value)
{
	GError* _inner_error0_ = NULL;
#line 323 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 323 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (field != NULL);
#line 323 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (value != NULL);
#line 1651 "TreeViewSetup.c"
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		GSList* values = NULL;
		GValue _tmp1_;
		GValue _tmp2_;
		GValue* _tmp3_;
		GdaConnection* _tmp4_;
		const gchar* _tmp5_;
		GValue _tmp6_ = {0};
#line 325 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		col_names = NULL;
#line 326 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = g_strdup (field);
#line 326 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		col_names = g_slist_append (col_names, _tmp0_);
#line 327 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		values = NULL;
#line 328 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp1_ = *value;
#line 328 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp2_ = _tmp1_;
#line 328 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp3_ = __g_value_dup0 (&_tmp2_);
#line 328 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		values = g_slist_append (values, _tmp3_);
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp4_ = self->priv->_connection;
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp5_ = self->priv->_uid;
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_init (&_tmp6_, G_TYPE_STRING);
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_string (&_tmp6_, _tmp5_);
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		gda_connection_update_row_in_table_v (_tmp4_, NOISE_DATABASE_COLUMNS_TABLE_NAME, "unique_id", &_tmp6_, col_names, values, &_inner_error0_);
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 329 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1696 "TreeViewSetup.c"
			goto __catch91_g_error;
		}
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 1703 "TreeViewSetup.c"
	}
	goto __finally91;
	__catch91_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		e = _inner_error0_;
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_inner_error0_ = NULL;
#line 331 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp7_ = e;
#line 331 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp8_ = _tmp7_->message;
#line 331 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_critical ("TreeViewSetup.vala:331: Could not set field %s: %s", field, _tmp8_);
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_error_free0 (e);
#line 1723 "TreeViewSetup.c"
	}
	__finally91:
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_clear_error (&_inner_error0_);
#line 324 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		return;
#line 1734 "TreeViewSetup.c"
	}
}


NoiseListColumn
noise_tree_view_setup_get_sort_column_id (NoiseTreeViewSetup* self)
{
	NoiseListColumn result;
	NoiseListColumn _tmp0_;
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_sort_column_id;
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp0_;
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1752 "TreeViewSetup.c"
}


void
noise_tree_view_setup_set_sort_column_id (NoiseTreeViewSetup* self,
                                          NoiseListColumn value)
{
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (noise_tree_view_setup_get_sort_column_id (self) != value) {
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		self->priv->_sort_column_id = value;
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY]);
#line 1768 "TreeViewSetup.c"
	}
}


GtkSortType
noise_tree_view_setup_get_sort_direction (NoiseTreeViewSetup* self)
{
	GtkSortType result;
	GtkSortType _tmp0_;
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_sort_direction;
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp0_;
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1786 "TreeViewSetup.c"
}


void
noise_tree_view_setup_set_sort_direction (NoiseTreeViewSetup* self,
                                          GtkSortType value)
{
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (noise_tree_view_setup_get_sort_direction (self) != value) {
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		self->priv->_sort_direction = value;
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY]);
#line 1802 "TreeViewSetup.c"
	}
}


NoiseViewWrapperHint
noise_tree_view_setup_get_hint (NoiseTreeViewSetup* self)
{
	NoiseViewWrapperHint result;
	NoiseViewWrapperHint _tmp0_;
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_hint;
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp0_;
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1820 "TreeViewSetup.c"
}


void
noise_tree_view_setup_set_hint (NoiseTreeViewSetup* self,
                                NoiseViewWrapperHint value)
{
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (noise_tree_view_setup_get_hint (self) != value) {
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		self->priv->_hint = value;
#line 39 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_HINT_PROPERTY]);
#line 1836 "TreeViewSetup.c"
	}
}


GdaConnection*
noise_tree_view_setup_get_connection (NoiseTreeViewSetup* self)
{
	GdaConnection* result;
	GdaConnection* _tmp0_;
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_connection;
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp0_;
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1854 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_set_connection (NoiseTreeViewSetup* self,
                                      GdaConnection* value)
{
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (noise_tree_view_setup_get_connection (self) != value) {
#line 1866 "TreeViewSetup.c"
		GdaConnection* _tmp0_;
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_object_unref0 (self->priv->_connection);
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		self->priv->_connection = _tmp0_;
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_CONNECTION_PROPERTY]);
#line 1876 "TreeViewSetup.c"
	}
}


const gchar*
noise_tree_view_setup_get_uid (NoiseTreeViewSetup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_uid;
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	result = _tmp0_;
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return result;
#line 1894 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_set_uid (NoiseTreeViewSetup* self,
                               const gchar* value)
{
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (g_strcmp0 (value, noise_tree_view_setup_get_uid (self)) != 0) {
#line 1906 "TreeViewSetup.c"
		gchar* _tmp0_;
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_tmp0_ = g_strdup (value);
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		_g_free0 (self->priv->_uid);
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		self->priv->_uid = _tmp0_;
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_UID_PROPERTY]);
#line 1916 "TreeViewSetup.c"
	}
}


static void
_noise_tree_view_setup____lambda8_ (NoiseTreeViewSetup* self)
{
	GtkSortType _tmp0_;
	GValue _tmp1_ = {0};
#line 90 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_sort_direction;
#line 90 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_init (&_tmp1_, G_TYPE_INT);
#line 90 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_set_int (&_tmp1_, (gint) _tmp0_);
#line 90 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_field (self, "sort_direction", &_tmp1_);
#line 90 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
#line 1936 "TreeViewSetup.c"
}


static void
__noise_tree_view_setup____lambda8__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 89 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_noise_tree_view_setup____lambda8_ ((NoiseTreeViewSetup*) self);
#line 1947 "TreeViewSetup.c"
}


static void
_noise_tree_view_setup____lambda9_ (NoiseTreeViewSetup* self)
{
	NoiseListColumn _tmp0_;
	GValue _tmp1_ = {0};
#line 94 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_sort_column_id;
#line 94 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_init (&_tmp1_, G_TYPE_INT);
#line 94 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_value_set_int (&_tmp1_, (gint) _tmp0_);
#line 94 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_set_field (self, "sort_column_id", &_tmp1_);
#line 94 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
#line 1966 "TreeViewSetup.c"
}


static void
__noise_tree_view_setup____lambda9__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 93 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_noise_tree_view_setup____lambda9_ ((NoiseTreeViewSetup*) self);
#line 1977 "TreeViewSetup.c"
}


static GObject *
noise_tree_view_setup_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseTreeViewSetup * self;
	NoiseViewWrapperHint _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 53 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	parent_class = G_OBJECT_CLASS (noise_tree_view_setup_parent_class);
#line 53 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup);
#line 54 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = self->priv->_hint;
#line 54 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	switch (_tmp0_) {
#line 54 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
#line 54 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 54 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 2008 "TreeViewSetup.c"
		{
#line 58 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			noise_tree_view_setup_set_sort_column_id (self, NOISE_LIST_COLUMN_NUMBER);
#line 59 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			break;
#line 2014 "TreeViewSetup.c"
		}
		default:
#line 54 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 2019 "TreeViewSetup.c"
	}
#line 62 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp1_ = self->priv->_uid;
#line 62 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	if (_tmp1_ != NULL) {
#line 63 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		if (noise_tree_view_setup_exists (self) == FALSE) {
#line 2027 "TreeViewSetup.c"
			{
				GdaSqlBuilder* builder = NULL;
				GdaSqlBuilder* _tmp2_;
				GdaSqlBuilder* _tmp3_;
				GdaSqlBuilder* _tmp4_;
				const gchar* _tmp5_;
				GValue* _tmp6_ = NULL;
				GdaStatement* _tmp7_ = NULL;
				GdaSqlBuilder* _tmp8_;
				GdaStatement* _tmp9_;
				GdaConnection* _tmp10_;
#line 65 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp2_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
#line 65 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				builder = _tmp2_;
#line 66 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp3_ = builder;
#line 66 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				gda_sql_builder_set_table (_tmp3_, NOISE_DATABASE_COLUMNS_TABLE_NAME);
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp4_ = builder;
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp5_ = self->priv->_uid;
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp6_ = g_new0 (GValue, 1);
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				g_value_init (_tmp6_, G_TYPE_STRING);
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				g_value_set_string (_tmp6_, _tmp5_);
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				gda_sql_builder_add_field_value_as_gvalue (_tmp4_, "unique_id", _tmp6_);
#line 67 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				__vala_GValue_free0 (_tmp6_);
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp8_ = builder;
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp9_ = gda_sql_builder_get_statement (_tmp8_, &_inner_error0_);
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp7_ = _tmp9_;
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_g_object_unref0 (builder);
#line 2071 "TreeViewSetup.c"
					goto __catch92_g_error;
				}
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp10_ = self->priv->_connection;
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				gda_connection_statement_execute_non_select (_tmp10_, _tmp7_, NULL, NULL, &_inner_error0_);
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_g_object_unref0 (_tmp7_);
#line 68 "../src/Views/ListView/Lists/TreeViewSetup.vala"
					_g_object_unref0 (builder);
#line 2084 "TreeViewSetup.c"
					goto __catch92_g_error;
				}
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_g_object_unref0 (_tmp7_);
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_g_object_unref0 (builder);
#line 2091 "TreeViewSetup.c"
			}
			goto __finally92;
			__catch92_g_error:
			{
				GError* e = NULL;
				GError* _tmp11_;
				const gchar* _tmp12_;
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				e = _inner_error0_;
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_inner_error0_ = NULL;
#line 70 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp11_ = e;
#line 70 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp12_ = _tmp11_->message;
#line 70 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				g_warning ("TreeViewSetup.vala:70: Could not save treeviewsetup: %s", _tmp12_);
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_g_error_free0 (e);
#line 2111 "TreeViewSetup.c"
			}
			__finally92:
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				g_clear_error (&_inner_error0_);
#line 2120 "TreeViewSetup.c"
			}
		} else {
			GValue* direction = NULL;
			GValue* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GValue* _tmp15_;
			GValue* direction_column = NULL;
			GValue* _tmp18_;
			gboolean _tmp19_ = FALSE;
			GValue* _tmp20_;
			GValue* columns_var = NULL;
			GValue* _tmp23_;
			gboolean _tmp24_ = FALSE;
			GValue* _tmp25_;
#line 73 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp13_ = noise_tree_view_setup_query_field (self, "sort_direction");
#line 73 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			direction = _tmp13_;
#line 74 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp15_ = direction;
#line 74 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp15_ != NULL) {
#line 2143 "TreeViewSetup.c"
				GValue* _tmp16_;
#line 74 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp16_ = direction;
#line 74 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp14_ = G_VALUE_TYPE (_tmp16_) != gda_null_get_type ();
#line 2149 "TreeViewSetup.c"
			} else {
#line 74 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp14_ = FALSE;
#line 2153 "TreeViewSetup.c"
			}
#line 74 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp14_) {
#line 2157 "TreeViewSetup.c"
				GValue* _tmp17_;
#line 75 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp17_ = direction;
#line 75 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				noise_tree_view_setup_set_sort_direction (self, (GtkSortType) g_value_get_int (_tmp17_));
#line 2163 "TreeViewSetup.c"
			}
#line 78 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp18_ = noise_tree_view_setup_query_field (self, "sort_column_id");
#line 78 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			direction_column = _tmp18_;
#line 79 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp20_ = direction_column;
#line 79 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp20_ != NULL) {
#line 2173 "TreeViewSetup.c"
				GValue* _tmp21_;
#line 79 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp21_ = direction_column;
#line 79 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp19_ = G_VALUE_TYPE (_tmp21_) != gda_null_get_type ();
#line 2179 "TreeViewSetup.c"
			} else {
#line 79 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp19_ = FALSE;
#line 2183 "TreeViewSetup.c"
			}
#line 79 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp19_) {
#line 2187 "TreeViewSetup.c"
				GValue* _tmp22_;
#line 80 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp22_ = direction_column;
#line 80 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				noise_tree_view_setup_set_sort_column_id (self, (NoiseListColumn) g_value_get_int (_tmp22_));
#line 2193 "TreeViewSetup.c"
			}
#line 83 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp23_ = noise_tree_view_setup_query_field (self, "columns");
#line 83 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			columns_var = _tmp23_;
#line 84 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			_tmp25_ = columns_var;
#line 84 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp25_ != NULL) {
#line 2203 "TreeViewSetup.c"
				GValue* _tmp26_;
#line 84 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp26_ = columns_var;
#line 84 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp24_ = G_VALUE_TYPE (_tmp26_) != gda_null_get_type ();
#line 2209 "TreeViewSetup.c"
			} else {
#line 84 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp24_ = FALSE;
#line 2213 "TreeViewSetup.c"
			}
#line 84 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			if (_tmp24_) {
#line 2217 "TreeViewSetup.c"
				GValue* _tmp27_;
				const gchar* _tmp28_;
#line 85 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp27_ = columns_var;
#line 85 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				_tmp28_ = g_value_get_string (_tmp27_);
#line 85 "../src/Views/ListView/Lists/TreeViewSetup.vala"
				noise_tree_view_setup_import_columns (self, _tmp28_);
#line 2226 "TreeViewSetup.c"
			}
#line 63 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			__vala_GValue_free0 (columns_var);
#line 63 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			__vala_GValue_free0 (direction_column);
#line 63 "../src/Views/ListView/Lists/TreeViewSetup.vala"
			__vala_GValue_free0 (direction);
#line 2234 "TreeViewSetup.c"
		}
#line 89 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_signal_connect_object ((GObject*) self, "notify::sort-direction", (GCallback) __noise_tree_view_setup____lambda8__g_object_notify, self, 0);
#line 93 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_signal_connect_object ((GObject*) self, "notify::sort-column-id", (GCallback) __noise_tree_view_setup____lambda9__g_object_notify, self, 0);
#line 2240 "TreeViewSetup.c"
	}
#line 53 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	return obj;
#line 2244 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_class_init (NoiseTreeViewSetupClass * klass)
{
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	noise_tree_view_setup_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_type_class_adjust_private_offset (klass, &NoiseTreeViewSetup_private_offset);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_tree_view_setup_get_property;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_tree_view_setup_set_property;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_tree_view_setup_constructor;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_tree_view_setup_finalize;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY] = g_param_spec_enum ("sort-column-id", "sort-column-id", "sort-column-id", NOISE_TYPE_LIST_COLUMN, NOISE_LIST_COLUMN_ARTIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY] = g_param_spec_enum ("sort-direction", "sort-direction", "sort-direction", gtk_sort_type_get_type (), GTK_SORT_ASCENDING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_TREE_VIEW_SETUP_HINT_PROPERTY, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_TREE_VIEW_SETUP_CONNECTION_PROPERTY, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", gda_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_TREE_VIEW_SETUP_UID_PROPERTY, noise_tree_view_setup_properties[NOISE_TREE_VIEW_SETUP_UID_PROPERTY] = g_param_spec_string ("uid", "uid", "uid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2273 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_instance_init (NoiseTreeViewSetup * self)
{
	GeeLinkedList* _tmp0_;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self->priv = noise_tree_view_setup_get_instance_private (self);
#line 37 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self->priv->_sort_column_id = NOISE_LIST_COLUMN_ARTIST;
#line 38 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self->priv->_sort_direction = GTK_SORT_ASCENDING;
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self->priv->_connection = NULL;
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self->priv->_uid = NULL;
#line 43 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_tmp0_ = gee_linked_list_new (gtk_tree_view_column_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 43 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self->priv->columns = _tmp0_;
#line 2295 "TreeViewSetup.c"
}


static void
noise_tree_view_setup_finalize (GObject * obj)
{
	NoiseTreeViewSetup * self;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup);
#line 40 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_object_unref0 (self->priv->_connection);
#line 41 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_free0 (self->priv->_uid);
#line 43 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	_g_object_unref0 (self->priv->columns);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	G_OBJECT_CLASS (noise_tree_view_setup_parent_class)->finalize (obj);
#line 2313 "TreeViewSetup.c"
}


GType
noise_tree_view_setup_get_type (void)
{
	static volatile gsize noise_tree_view_setup_type_id__volatile = 0;
	if (g_once_init_enter (&noise_tree_view_setup_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseTreeViewSetupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_tree_view_setup_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseTreeViewSetup), 0, (GInstanceInitFunc) noise_tree_view_setup_instance_init, NULL };
		GType noise_tree_view_setup_type_id;
		noise_tree_view_setup_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseTreeViewSetup", &g_define_type_info, 0);
		NoiseTreeViewSetup_private_offset = g_type_add_instance_private (noise_tree_view_setup_type_id, sizeof (NoiseTreeViewSetupPrivate));
		g_once_init_leave (&noise_tree_view_setup_type_id__volatile, noise_tree_view_setup_type_id);
	}
	return noise_tree_view_setup_type_id__volatile;
}


static void
_vala_noise_tree_view_setup_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NoiseTreeViewSetup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_enum (value, noise_tree_view_setup_get_sort_column_id (self));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_enum (value, noise_tree_view_setup_get_sort_direction (self));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_HINT_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_enum (value, noise_tree_view_setup_get_hint (self));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_CONNECTION_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_object (value, noise_tree_view_setup_get_connection (self));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_UID_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		g_value_set_string (value, noise_tree_view_setup_get_uid (self));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 2372 "TreeViewSetup.c"
		default:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 2378 "TreeViewSetup.c"
	}
}


static void
_vala_noise_tree_view_setup_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NoiseTreeViewSetup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_SORT_COLUMN_ID_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		noise_tree_view_setup_set_sort_column_id (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_SORT_DIRECTION_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		noise_tree_view_setup_set_sort_direction (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_HINT_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		noise_tree_view_setup_set_hint (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_CONNECTION_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		noise_tree_view_setup_set_connection (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		case NOISE_TREE_VIEW_SETUP_UID_PROPERTY:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		noise_tree_view_setup_set_uid (self, g_value_get_string (value));
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 2423 "TreeViewSetup.c"
		default:
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/Lists/TreeViewSetup.vala"
		break;
#line 2429 "TreeViewSetup.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



