/* PresetList.c generated by valac 0.42.6, the Vala compiler
 * generated from PresetList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <gee.h>


#define NOISE_TYPE_PRESET_LIST (noise_preset_list_get_type ())
#define NOISE_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PRESET_LIST, NoisePresetList))
#define NOISE_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PRESET_LIST, NoisePresetListClass))
#define NOISE_IS_PRESET_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PRESET_LIST))
#define NOISE_IS_PRESET_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PRESET_LIST))
#define NOISE_PRESET_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PRESET_LIST, NoisePresetListClass))

typedef struct _NoisePresetList NoisePresetList;
typedef struct _NoisePresetListClass NoisePresetListClass;
typedef struct _NoisePresetListPrivate NoisePresetListPrivate;
enum  {
	NOISE_PRESET_LIST_0_PROPERTY,
	NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY,
	NOISE_PRESET_LIST_NUM_PROPERTIES
};
static GParamSpec* noise_preset_list_properties[NOISE_PRESET_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL,
	NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL,
	NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL,
	NOISE_PRESET_LIST_NUM_SIGNALS
};
static guint noise_preset_list_signals[NOISE_PRESET_LIST_NUM_SIGNALS] = {0};

struct _NoisePresetList {
	GtkComboBox parent_instance;
	NoisePresetListPrivate * priv;
	NoiseEqualizerPreset* last_selected_preset;
};

struct _NoisePresetListClass {
	GtkComboBoxClass parent_class;
	void (*list_selection_change) (NoisePresetList* self);
};

struct _NoisePresetListPrivate {
	gint _ncustompresets;
	gboolean modifying_list;
	gboolean automatic_selected;
	GtkListStore* store;
};


static gint NoisePresetList_private_offset;
static gpointer noise_preset_list_parent_class = NULL;
static gchar* noise_preset_list_AUTOMATIC_MODE;
static gchar* noise_preset_list_AUTOMATIC_MODE = NULL;
static gchar* noise_preset_list_DELETE_PRESET;
static gchar* noise_preset_list_DELETE_PRESET = NULL;

GType noise_preset_list_get_type (void) G_GNUC_CONST;
#define NOISE_PRESET_LIST_SEPARATOR_NAME "<separator_item_unique_name>"
NoisePresetList* noise_preset_list_new (void);
NoisePresetList* noise_preset_list_construct (GType object_type);
static void noise_preset_list_set_ncustompresets (NoisePresetList* self,
                                           gint value);
static gboolean __lambda20_ (NoisePresetList* self,
                      GtkTreeModel* model,
                      GtkTreeIter* iter);
static gboolean ___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                        GtkTreeIter* iter,
                                                        gpointer self);
void noise_preset_list_list_selection_change (NoisePresetList* self);
static void _noise_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
void noise_preset_list_add_separator (NoisePresetList* self);
void noise_preset_list_add_preset (NoisePresetList* self,
                                   NoiseEqualizerPreset* ep);
static gint noise_preset_list_get_ncustompresets (NoisePresetList* self);
void noise_preset_list_remove_current_preset (NoisePresetList* self);
static void noise_preset_list_remove_separator_item (NoisePresetList* self,
                                              gint index);
void noise_preset_list_select_automatic_preset (NoisePresetList* self);
static void noise_preset_list_real_list_selection_change (NoisePresetList* self);
static void noise_preset_list_add_delete_preset_option (NoisePresetList* self);
static void noise_preset_list_remove_delete_option (NoisePresetList* self);
void noise_preset_list_select_preset (NoisePresetList* self,
                                      const gchar* preset_name);
NoiseEqualizerPreset* noise_preset_list_get_selected_preset (NoisePresetList* self);
GeeCollection* noise_preset_list_get_presets (NoisePresetList* self);
gboolean noise_preset_list_get_automatic_chosen (NoisePresetList* self);
static void noise_preset_list_finalize (GObject * obj);
static void _vala_noise_preset_list_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_preset_list_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);


static inline gpointer
noise_preset_list_get_instance_private (NoisePresetList* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePresetList_private_offset);
}


static gboolean
__lambda20_ (NoisePresetList* self,
             GtkTreeModel* model,
             GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gchar* content = NULL;
	gchar* _tmp0_;
	GtkTreeIter _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
#line 65 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 65 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 66 "../src/Widgets/PresetList.vala"
	_tmp0_ = g_strdup ("");
#line 66 "../src/Widgets/PresetList.vala"
	content = _tmp0_;
#line 67 "../src/Widgets/PresetList.vala"
	_tmp1_ = *iter;
#line 67 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get (model, &_tmp1_, 1, &_tmp2_, -1);
#line 67 "../src/Widgets/PresetList.vala"
	_g_free0 (content);
#line 67 "../src/Widgets/PresetList.vala"
	content = _tmp2_;
#line 69 "../src/Widgets/PresetList.vala"
	_tmp3_ = content;
#line 69 "../src/Widgets/PresetList.vala"
	result = g_strcmp0 (_tmp3_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 69 "../src/Widgets/PresetList.vala"
	_g_free0 (content);
#line 69 "../src/Widgets/PresetList.vala"
	return result;
#line 181 "PresetList.c"
}


static gboolean
___lambda20__gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                               GtkTreeIter* iter,
                                               gpointer self)
{
	gboolean result;
	result = __lambda20_ ((NoisePresetList*) self, model, iter);
#line 65 "../src/Widgets/PresetList.vala"
	return result;
#line 194 "PresetList.c"
}


static void
_noise_preset_list_list_selection_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 78 "../src/Widgets/PresetList.vala"
	noise_preset_list_list_selection_change ((NoisePresetList*) self);
#line 204 "PresetList.c"
}


NoisePresetList*
noise_preset_list_construct (GType object_type)
{
	NoisePresetList * self = NULL;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
#line 55 "../src/Widgets/PresetList.vala"
	self = (NoisePresetList*) g_object_new (object_type, NULL);
#line 56 "../src/Widgets/PresetList.vala"
	noise_preset_list_set_ncustompresets (self, 0);
#line 57 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 58 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = FALSE;
#line 60 "../src/Widgets/PresetList.vala"
	_tmp0_ = gtk_list_store_new (2, G_TYPE_OBJECT, G_TYPE_STRING, -1);
#line 60 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->priv->store);
#line 60 "../src/Widgets/PresetList.vala"
	self->priv->store = _tmp0_;
#line 62 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 62 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_model ((GtkComboBox*) self, (GtkTreeModel*) _tmp1_);
#line 63 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_id_column ((GtkComboBox*) self, 1);
#line 65 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_row_separator_func ((GtkComboBox*) self, ___lambda20__gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
#line 72 "../src/Widgets/PresetList.vala"
	_tmp2_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 72 "../src/Widgets/PresetList.vala"
	g_object_ref_sink (_tmp2_);
#line 72 "../src/Widgets/PresetList.vala"
	cell = _tmp2_;
#line 73 "../src/Widgets/PresetList.vala"
	g_object_set (cell, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 75 "../src/Widgets/PresetList.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, (GtkCellRenderer*) cell, TRUE);
#line 76 "../src/Widgets/PresetList.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, (GtkCellRenderer*) cell, "text", 1);
#line 78 "../src/Widgets/PresetList.vala"
	g_signal_connect_object ((GtkComboBox*) self, "changed", (GCallback) _noise_preset_list_list_selection_change_gtk_combo_box_changed, self, 0);
#line 80 "../src/Widgets/PresetList.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 82 "../src/Widgets/PresetList.vala"
	_tmp3_ = self->priv->store;
#line 82 "../src/Widgets/PresetList.vala"
	gtk_list_store_clear (_tmp3_);
#line 85 "../src/Widgets/PresetList.vala"
	_tmp4_ = self->priv->store;
#line 85 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp4_, &_tmp5_);
#line 85 "../src/Widgets/PresetList.vala"
	iter = _tmp5_;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp6_ = self->priv->store;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp7_ = iter;
#line 86 "../src/Widgets/PresetList.vala"
	_tmp8_ = noise_preset_list_AUTOMATIC_MODE;
#line 86 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, NULL, 1, _tmp8_, -1);
#line 88 "../src/Widgets/PresetList.vala"
	noise_preset_list_add_separator (self);
#line 55 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (cell);
#line 55 "../src/Widgets/PresetList.vala"
	return self;
#line 285 "PresetList.c"
}


NoisePresetList*
noise_preset_list_new (void)
{
#line 55 "../src/Widgets/PresetList.vala"
	return noise_preset_list_construct (NOISE_TYPE_PRESET_LIST);
#line 294 "PresetList.c"
}


void
noise_preset_list_add_separator (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
#line 91 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->store;
#line 93 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp0_, &_tmp1_);
#line 93 "../src/Widgets/PresetList.vala"
	iter = _tmp1_;
#line 94 "../src/Widgets/PresetList.vala"
	_tmp2_ = self->priv->store;
#line 94 "../src/Widgets/PresetList.vala"
	_tmp3_ = iter;
#line 94 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp2_, &_tmp3_, 0, NULL, 1, NOISE_PRESET_LIST_SEPARATOR_NAME, -1);
#line 320 "PresetList.c"
}


void
noise_preset_list_add_preset (NoisePresetList* self,
                              NoiseEqualizerPreset* ep)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_ = {0};
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeIter _tmp10_;
#line 97 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Widgets/PresetList.vala"
	g_return_if_fail (ep != NULL);
#line 98 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = TRUE;
#line 100 "../src/Widgets/PresetList.vala"
	_tmp0_ = noise_equalizer_preset_get_is_default (ep);
#line 100 "../src/Widgets/PresetList.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/Widgets/PresetList.vala"
	if (!_tmp1_) {
#line 350 "PresetList.c"
		gint _tmp2_;
		gint _tmp3_;
#line 102 "../src/Widgets/PresetList.vala"
		_tmp2_ = self->priv->_ncustompresets;
#line 102 "../src/Widgets/PresetList.vala"
		if (_tmp2_ < 1) {
#line 103 "../src/Widgets/PresetList.vala"
			noise_preset_list_add_separator (self);
#line 359 "PresetList.c"
		}
#line 106 "../src/Widgets/PresetList.vala"
		_tmp3_ = self->priv->_ncustompresets;
#line 106 "../src/Widgets/PresetList.vala"
		noise_preset_list_set_ncustompresets (self, _tmp3_ + 1);
#line 365 "PresetList.c"
	}
#line 110 "../src/Widgets/PresetList.vala"
	_tmp4_ = self->priv->store;
#line 110 "../src/Widgets/PresetList.vala"
	gtk_list_store_append (_tmp4_, &_tmp5_);
#line 110 "../src/Widgets/PresetList.vala"
	iter = _tmp5_;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp6_ = self->priv->store;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp7_ = iter;
#line 111 "../src/Widgets/PresetList.vala"
	_tmp8_ = noise_equalizer_preset_get_name (ep);
#line 111 "../src/Widgets/PresetList.vala"
	_tmp9_ = _tmp8_;
#line 111 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp6_, &_tmp7_, 0, ep, 1, _tmp9_, -1);
#line 113 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 114 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = FALSE;
#line 116 "../src/Widgets/PresetList.vala"
	_tmp10_ = iter;
#line 116 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp10_);
#line 391 "PresetList.c"
}


void
noise_preset_list_remove_current_preset (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
	gint _tmp23_;
#line 119 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = TRUE;
#line 404 "PresetList.c"
	{
		gint i = 0;
#line 123 "../src/Widgets/PresetList.vala"
		i = 0;
#line 409 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 123 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 123 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 416 "PresetList.c"
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				GObject* o = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				GObject* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				GObject* _tmp14_;
#line 123 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 433 "PresetList.c"
					gint _tmp1_;
#line 123 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 123 "../src/Widgets/PresetList.vala"
					i = _tmp1_ + 1;
#line 439 "PresetList.c"
				}
#line 123 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp3_ = i;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 123 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
#line 123 "../src/Widgets/PresetList.vala"
				iter = _tmp6_;
#line 123 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 123 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 123 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 123 "../src/Widgets/PresetList.vala"
					break;
#line 463 "PresetList.c"
				}
#line 125 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 125 "../src/Widgets/PresetList.vala"
				_tmp10_ = iter;
#line 125 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
#line 125 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 125 "../src/Widgets/PresetList.vala"
				o = _tmp11_;
#line 127 "../src/Widgets/PresetList.vala"
				_tmp14_ = o;
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp14_ != NULL) {
#line 479 "PresetList.c"
					GObject* _tmp15_;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp15_ = o;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp13_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, NOISE_TYPE_EQUALIZER_PRESET);
#line 485 "PresetList.c"
				} else {
#line 127 "../src/Widgets/PresetList.vala"
					_tmp13_ = FALSE;
#line 489 "PresetList.c"
				}
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp13_) {
#line 493 "PresetList.c"
					GObject* _tmp16_;
					NoiseEqualizerPreset* _tmp17_;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp16_ = o;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp17_ = self->last_selected_preset;
#line 127 "../src/Widgets/PresetList.vala"
					_tmp12_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset) == _tmp17_;
#line 502 "PresetList.c"
				} else {
#line 127 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 506 "PresetList.c"
				}
#line 127 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 510 "PresetList.c"
					GObject* _tmp18_;
					gboolean _tmp19_;
					gboolean _tmp20_;
#line 128 "../src/Widgets/PresetList.vala"
					_tmp18_ = o;
#line 128 "../src/Widgets/PresetList.vala"
					_tmp19_ = noise_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, NOISE_TYPE_EQUALIZER_PRESET, NoiseEqualizerPreset));
#line 128 "../src/Widgets/PresetList.vala"
					_tmp20_ = _tmp19_;
#line 128 "../src/Widgets/PresetList.vala"
					if (!_tmp20_) {
#line 522 "PresetList.c"
						gint _tmp21_;
						GtkListStore* _tmp22_;
#line 129 "../src/Widgets/PresetList.vala"
						_tmp21_ = self->priv->_ncustompresets;
#line 129 "../src/Widgets/PresetList.vala"
						noise_preset_list_set_ncustompresets (self, _tmp21_ - 1);
#line 131 "../src/Widgets/PresetList.vala"
						_tmp22_ = self->priv->store;
#line 131 "../src/Widgets/PresetList.vala"
						gtk_list_store_remove (_tmp22_, &iter);
#line 135 "../src/Widgets/PresetList.vala"
						_g_object_unref0 (o);
#line 135 "../src/Widgets/PresetList.vala"
						break;
#line 537 "PresetList.c"
					}
				}
#line 123 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 542 "PresetList.c"
			}
		}
	}
#line 141 "../src/Widgets/PresetList.vala"
	_tmp23_ = self->priv->_ncustompresets;
#line 141 "../src/Widgets/PresetList.vala"
	if (_tmp23_ < 1) {
#line 142 "../src/Widgets/PresetList.vala"
		noise_preset_list_remove_separator_item (self, -1);
#line 552 "PresetList.c"
	}
#line 145 "../src/Widgets/PresetList.vala"
	self->priv->modifying_list = FALSE;
#line 147 "../src/Widgets/PresetList.vala"
	noise_preset_list_select_automatic_preset (self);
#line 558 "PresetList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 162 "../src/Widgets/PresetList.vala"
	return self ? g_object_ref (self) : NULL;
#line 567 "PresetList.c"
}


static void
noise_preset_list_real_list_selection_change (NoisePresetList* self)
{
	gboolean _tmp0_;
	GtkTreeIter it = {0};
	GtkTreeIter _tmp1_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GObject* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GObject* _tmp6_;
	gchar* option = NULL;
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
#line 151 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->modifying_list;
#line 151 "../src/Widgets/PresetList.vala"
	if (_tmp0_) {
#line 152 "../src/Widgets/PresetList.vala"
		return;
#line 595 "PresetList.c"
	}
#line 156 "../src/Widgets/PresetList.vala"
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp1_);
#line 156 "../src/Widgets/PresetList.vala"
	it = _tmp1_;
#line 159 "../src/Widgets/PresetList.vala"
	_tmp2_ = self->priv->store;
#line 159 "../src/Widgets/PresetList.vala"
	_tmp3_ = it;
#line 159 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp2_, &_tmp3_, 0, &_tmp4_, -1);
#line 159 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 159 "../src/Widgets/PresetList.vala"
	o = _tmp4_;
#line 161 "../src/Widgets/PresetList.vala"
	_tmp6_ = o;
#line 161 "../src/Widgets/PresetList.vala"
	if (_tmp6_ != NULL) {
#line 615 "PresetList.c"
		GObject* _tmp7_;
#line 161 "../src/Widgets/PresetList.vala"
		_tmp7_ = o;
#line 161 "../src/Widgets/PresetList.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, NOISE_TYPE_EQUALIZER_PRESET);
#line 621 "PresetList.c"
	} else {
#line 161 "../src/Widgets/PresetList.vala"
		_tmp5_ = FALSE;
#line 625 "PresetList.c"
	}
#line 161 "../src/Widgets/PresetList.vala"
	if (_tmp5_) {
#line 629 "PresetList.c"
		GObject* _tmp8_;
		NoiseEqualizerPreset* _tmp9_;
		GObject* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		GObject* _tmp13_;
#line 162 "../src/Widgets/PresetList.vala"
		_tmp8_ = o;
#line 162 "../src/Widgets/PresetList.vala"
		_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp8_) : NULL);
#line 162 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (self->last_selected_preset);
#line 162 "../src/Widgets/PresetList.vala"
		self->last_selected_preset = _tmp9_;
#line 164 "../src/Widgets/PresetList.vala"
		_tmp10_ = o;
#line 164 "../src/Widgets/PresetList.vala"
		_tmp11_ = noise_equalizer_preset_get_is_default (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp10_) : NULL);
#line 164 "../src/Widgets/PresetList.vala"
		_tmp12_ = _tmp11_;
#line 164 "../src/Widgets/PresetList.vala"
		if (!_tmp12_) {
#line 165 "../src/Widgets/PresetList.vala"
			noise_preset_list_add_delete_preset_option (self);
#line 654 "PresetList.c"
		} else {
#line 167 "../src/Widgets/PresetList.vala"
			noise_preset_list_remove_delete_option (self);
#line 658 "PresetList.c"
		}
#line 170 "../src/Widgets/PresetList.vala"
		self->priv->automatic_selected = FALSE;
#line 171 "../src/Widgets/PresetList.vala"
		_tmp13_ = o;
#line 171 "../src/Widgets/PresetList.vala"
		g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp13_) : NULL);
#line 172 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 172 "../src/Widgets/PresetList.vala"
		return;
#line 670 "PresetList.c"
	}
#line 176 "../src/Widgets/PresetList.vala"
	_tmp14_ = self->priv->store;
#line 176 "../src/Widgets/PresetList.vala"
	_tmp15_ = it;
#line 176 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp14_, &_tmp15_, 1, &_tmp16_, -1);
#line 176 "../src/Widgets/PresetList.vala"
	_g_free0 (option);
#line 176 "../src/Widgets/PresetList.vala"
	option = _tmp16_;
#line 178 "../src/Widgets/PresetList.vala"
	_tmp17_ = option;
#line 178 "../src/Widgets/PresetList.vala"
	_tmp18_ = noise_preset_list_AUTOMATIC_MODE;
#line 178 "../src/Widgets/PresetList.vala"
	if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 179 "../src/Widgets/PresetList.vala"
		self->priv->automatic_selected = TRUE;
#line 180 "../src/Widgets/PresetList.vala"
		noise_preset_list_remove_delete_option (self);
#line 181 "../src/Widgets/PresetList.vala"
		g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
#line 694 "PresetList.c"
	} else {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 182 "../src/Widgets/PresetList.vala"
		_tmp19_ = option;
#line 182 "../src/Widgets/PresetList.vala"
		_tmp20_ = noise_preset_list_DELETE_PRESET;
#line 182 "../src/Widgets/PresetList.vala"
		if (g_strcmp0 (_tmp19_, _tmp20_) == 0) {
#line 183 "../src/Widgets/PresetList.vala"
			g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL], 0);
#line 706 "PresetList.c"
		}
	}
#line 150 "../src/Widgets/PresetList.vala"
	_g_free0 (option);
#line 150 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 713 "PresetList.c"
}


void
noise_preset_list_list_selection_change (NoisePresetList* self)
{
#line 150 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Widgets/PresetList.vala"
	NOISE_PRESET_LIST_GET_CLASS (self)->list_selection_change (self);
#line 724 "PresetList.c"
}


void
noise_preset_list_select_automatic_preset (NoisePresetList* self)
{
#line 187 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/Widgets/PresetList.vala"
	self->priv->automatic_selected = TRUE;
#line 189 "../src/Widgets/PresetList.vala"
	g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL], 0);
#line 190 "../src/Widgets/PresetList.vala"
	gtk_combo_box_set_active ((GtkComboBox*) self, 0);
#line 739 "PresetList.c"
}


void
noise_preset_list_select_preset (NoisePresetList* self,
                                 const gchar* preset_name)
{
	gboolean _tmp0_ = FALSE;
#line 193 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Widgets/PresetList.vala"
	if (preset_name == NULL) {
#line 195 "../src/Widgets/PresetList.vala"
		_tmp0_ = TRUE;
#line 754 "PresetList.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 195 "../src/Widgets/PresetList.vala"
		_tmp1_ = strlen (preset_name);
#line 195 "../src/Widgets/PresetList.vala"
		_tmp2_ = _tmp1_;
#line 195 "../src/Widgets/PresetList.vala"
		_tmp0_ = _tmp2_ < 1;
#line 764 "PresetList.c"
	}
#line 195 "../src/Widgets/PresetList.vala"
	if (!_tmp0_) {
#line 768 "PresetList.c"
		GtkTreeIter iter = {0};
		{
			gint i = 0;
#line 197 "../src/Widgets/PresetList.vala"
			i = 0;
#line 774 "PresetList.c"
			{
				gboolean _tmp3_ = FALSE;
#line 197 "../src/Widgets/PresetList.vala"
				_tmp3_ = TRUE;
#line 197 "../src/Widgets/PresetList.vala"
				while (TRUE) {
#line 781 "PresetList.c"
					GtkListStore* _tmp5_;
					gint _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					GtkTreeIter _tmp9_ = {0};
					gboolean _tmp10_;
					gboolean _tmp11_;
					GObject* o = NULL;
					GtkListStore* _tmp12_;
					GtkTreeIter _tmp13_;
					GObject* _tmp14_ = NULL;
					gboolean _tmp15_ = FALSE;
					gboolean _tmp16_ = FALSE;
					GObject* _tmp17_;
#line 197 "../src/Widgets/PresetList.vala"
					if (!_tmp3_) {
#line 798 "PresetList.c"
						gint _tmp4_;
#line 197 "../src/Widgets/PresetList.vala"
						_tmp4_ = i;
#line 197 "../src/Widgets/PresetList.vala"
						i = _tmp4_ + 1;
#line 804 "PresetList.c"
					}
#line 197 "../src/Widgets/PresetList.vala"
					_tmp3_ = FALSE;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp5_ = self->priv->store;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp6_ = i;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 197 "../src/Widgets/PresetList.vala"
					_tmp8_ = _tmp7_;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp10_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp5_, &_tmp9_, _tmp8_);
#line 197 "../src/Widgets/PresetList.vala"
					iter = _tmp9_;
#line 197 "../src/Widgets/PresetList.vala"
					_tmp11_ = !_tmp10_;
#line 197 "../src/Widgets/PresetList.vala"
					_g_free0 (_tmp8_);
#line 197 "../src/Widgets/PresetList.vala"
					if (_tmp11_) {
#line 197 "../src/Widgets/PresetList.vala"
						break;
#line 828 "PresetList.c"
					}
#line 199 "../src/Widgets/PresetList.vala"
					_tmp12_ = self->priv->store;
#line 199 "../src/Widgets/PresetList.vala"
					_tmp13_ = iter;
#line 199 "../src/Widgets/PresetList.vala"
					gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 0, &_tmp14_, -1);
#line 199 "../src/Widgets/PresetList.vala"
					_g_object_unref0 (o);
#line 199 "../src/Widgets/PresetList.vala"
					o = _tmp14_;
#line 201 "../src/Widgets/PresetList.vala"
					_tmp17_ = o;
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp17_ != NULL) {
#line 844 "PresetList.c"
						GObject* _tmp18_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp18_ = o;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp16_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, NOISE_TYPE_EQUALIZER_PRESET);
#line 850 "PresetList.c"
					} else {
#line 201 "../src/Widgets/PresetList.vala"
						_tmp16_ = FALSE;
#line 854 "PresetList.c"
					}
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp16_) {
#line 858 "PresetList.c"
						GObject* _tmp19_;
						const gchar* _tmp20_;
						const gchar* _tmp21_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp19_ = o;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp20_ = noise_equalizer_preset_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp19_) : NULL);
#line 201 "../src/Widgets/PresetList.vala"
						_tmp21_ = _tmp20_;
#line 201 "../src/Widgets/PresetList.vala"
						_tmp15_ = g_strcmp0 (_tmp21_, preset_name) == 0;
#line 870 "PresetList.c"
					} else {
#line 201 "../src/Widgets/PresetList.vala"
						_tmp15_ = FALSE;
#line 874 "PresetList.c"
					}
#line 201 "../src/Widgets/PresetList.vala"
					if (_tmp15_) {
#line 878 "PresetList.c"
						GtkTreeIter _tmp22_;
						GObject* _tmp23_;
#line 202 "../src/Widgets/PresetList.vala"
						_tmp22_ = iter;
#line 202 "../src/Widgets/PresetList.vala"
						gtk_combo_box_set_active_iter ((GtkComboBox*) self, &_tmp22_);
#line 203 "../src/Widgets/PresetList.vala"
						self->priv->automatic_selected = FALSE;
#line 204 "../src/Widgets/PresetList.vala"
						_tmp23_ = o;
#line 204 "../src/Widgets/PresetList.vala"
						g_signal_emit (self, noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp23_) : NULL);
#line 205 "../src/Widgets/PresetList.vala"
						_g_object_unref0 (o);
#line 205 "../src/Widgets/PresetList.vala"
						return;
#line 895 "PresetList.c"
					}
#line 197 "../src/Widgets/PresetList.vala"
					_g_object_unref0 (o);
#line 899 "PresetList.c"
				}
			}
		}
	}
#line 210 "../src/Widgets/PresetList.vala"
	noise_preset_list_select_automatic_preset (self);
#line 906 "PresetList.c"
}


NoiseEqualizerPreset*
noise_preset_list_get_selected_preset (NoisePresetList* self)
{
	NoiseEqualizerPreset* result = NULL;
	GtkTreeIter it = {0};
	GtkTreeIter _tmp0_ = {0};
	GObject* o = NULL;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_;
	GObject* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GObject* _tmp5_;
#line 213 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "../src/Widgets/PresetList.vala"
	gtk_combo_box_get_active_iter ((GtkComboBox*) self, &_tmp0_);
#line 215 "../src/Widgets/PresetList.vala"
	it = _tmp0_;
#line 218 "../src/Widgets/PresetList.vala"
	_tmp1_ = self->priv->store;
#line 218 "../src/Widgets/PresetList.vala"
	_tmp2_ = it;
#line 218 "../src/Widgets/PresetList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp1_, &_tmp2_, 0, &_tmp3_, -1);
#line 218 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 218 "../src/Widgets/PresetList.vala"
	o = _tmp3_;
#line 220 "../src/Widgets/PresetList.vala"
	_tmp5_ = o;
#line 220 "../src/Widgets/PresetList.vala"
	if (_tmp5_ != NULL) {
#line 942 "PresetList.c"
		GObject* _tmp6_;
#line 220 "../src/Widgets/PresetList.vala"
		_tmp6_ = o;
#line 220 "../src/Widgets/PresetList.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, NOISE_TYPE_EQUALIZER_PRESET);
#line 948 "PresetList.c"
	} else {
#line 220 "../src/Widgets/PresetList.vala"
		_tmp4_ = FALSE;
#line 952 "PresetList.c"
	}
#line 220 "../src/Widgets/PresetList.vala"
	if (_tmp4_) {
#line 956 "PresetList.c"
		GObject* _tmp7_;
		NoiseEqualizerPreset* _tmp8_;
#line 221 "../src/Widgets/PresetList.vala"
		_tmp7_ = o;
#line 221 "../src/Widgets/PresetList.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp7_) : NULL);
#line 221 "../src/Widgets/PresetList.vala"
		result = _tmp8_;
#line 221 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 221 "../src/Widgets/PresetList.vala"
		return result;
#line 969 "PresetList.c"
	} else {
#line 223 "../src/Widgets/PresetList.vala"
		result = NULL;
#line 223 "../src/Widgets/PresetList.vala"
		_g_object_unref0 (o);
#line 223 "../src/Widgets/PresetList.vala"
		return result;
#line 977 "PresetList.c"
	}
#line 213 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (o);
#line 981 "PresetList.c"
}


GeeCollection*
noise_preset_list_get_presets (NoisePresetList* self)
{
	GeeCollection* result = NULL;
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GtkTreeIter iter = {0};
#line 227 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../src/Widgets/PresetList.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 229 "../src/Widgets/PresetList.vala"
	rv = _tmp0_;
#line 998 "PresetList.c"
	{
		gint i = 0;
#line 232 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1003 "PresetList.c"
		{
			gboolean _tmp1_ = FALSE;
#line 232 "../src/Widgets/PresetList.vala"
			_tmp1_ = TRUE;
#line 232 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1010 "PresetList.c"
				GtkListStore* _tmp3_;
				gint _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				GtkTreeIter _tmp7_ = {0};
				gboolean _tmp8_;
				gboolean _tmp9_;
				GObject* o = NULL;
				GtkListStore* _tmp10_;
				GtkTreeIter _tmp11_;
				GObject* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				GObject* _tmp14_;
#line 232 "../src/Widgets/PresetList.vala"
				if (!_tmp1_) {
#line 1026 "PresetList.c"
					gint _tmp2_;
#line 232 "../src/Widgets/PresetList.vala"
					_tmp2_ = i;
#line 232 "../src/Widgets/PresetList.vala"
					i = _tmp2_ + 1;
#line 1032 "PresetList.c"
				}
#line 232 "../src/Widgets/PresetList.vala"
				_tmp1_ = FALSE;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp3_ = self->priv->store;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp4_ = i;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 232 "../src/Widgets/PresetList.vala"
				_tmp6_ = _tmp5_;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp8_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp3_, &_tmp7_, _tmp6_);
#line 232 "../src/Widgets/PresetList.vala"
				iter = _tmp7_;
#line 232 "../src/Widgets/PresetList.vala"
				_tmp9_ = !_tmp8_;
#line 232 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp6_);
#line 232 "../src/Widgets/PresetList.vala"
				if (_tmp9_) {
#line 232 "../src/Widgets/PresetList.vala"
					break;
#line 1056 "PresetList.c"
				}
#line 234 "../src/Widgets/PresetList.vala"
				_tmp10_ = self->priv->store;
#line 234 "../src/Widgets/PresetList.vala"
				_tmp11_ = iter;
#line 234 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp11_, 0, &_tmp12_, -1);
#line 234 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 234 "../src/Widgets/PresetList.vala"
				o = _tmp12_;
#line 236 "../src/Widgets/PresetList.vala"
				_tmp14_ = o;
#line 236 "../src/Widgets/PresetList.vala"
				if (_tmp14_ != NULL) {
#line 1072 "PresetList.c"
					GObject* _tmp15_;
#line 236 "../src/Widgets/PresetList.vala"
					_tmp15_ = o;
#line 236 "../src/Widgets/PresetList.vala"
					_tmp13_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, NOISE_TYPE_EQUALIZER_PRESET);
#line 1078 "PresetList.c"
				} else {
#line 236 "../src/Widgets/PresetList.vala"
					_tmp13_ = FALSE;
#line 1082 "PresetList.c"
				}
#line 236 "../src/Widgets/PresetList.vala"
				if (_tmp13_) {
#line 1086 "PresetList.c"
					GeeLinkedList* _tmp16_;
					GObject* _tmp17_;
#line 237 "../src/Widgets/PresetList.vala"
					_tmp16_ = rv;
#line 237 "../src/Widgets/PresetList.vala"
					_tmp17_ = o;
#line 237 "../src/Widgets/PresetList.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, NOISE_TYPE_EQUALIZER_PRESET) ? ((NoiseEqualizerPreset*) _tmp17_) : NULL);
#line 1095 "PresetList.c"
				}
#line 232 "../src/Widgets/PresetList.vala"
				_g_object_unref0 (o);
#line 1099 "PresetList.c"
			}
		}
	}
#line 241 "../src/Widgets/PresetList.vala"
	result = (GeeCollection*) rv;
#line 241 "../src/Widgets/PresetList.vala"
	return result;
#line 1107 "PresetList.c"
}


static void
noise_preset_list_remove_delete_option (NoisePresetList* self)
{
	GtkTreeIter iter = {0};
#line 244 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 1117 "PresetList.c"
	{
		gint i = 0;
#line 246 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1122 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 246 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 246 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1129 "PresetList.c"
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gchar* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				const gchar* _tmp13_;
#line 246 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 1145 "PresetList.c"
					gint _tmp1_;
#line 246 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 246 "../src/Widgets/PresetList.vala"
					i = _tmp1_ + 1;
#line 1151 "PresetList.c"
				}
#line 246 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp3_ = i;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 246 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
#line 246 "../src/Widgets/PresetList.vala"
				iter = _tmp6_;
#line 246 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 246 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 246 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 246 "../src/Widgets/PresetList.vala"
					break;
#line 1175 "PresetList.c"
				}
#line 248 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 248 "../src/Widgets/PresetList.vala"
				_tmp10_ = iter;
#line 248 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &_tmp11_, -1);
#line 248 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 248 "../src/Widgets/PresetList.vala"
				text = _tmp11_;
#line 250 "../src/Widgets/PresetList.vala"
				_tmp13_ = text;
#line 250 "../src/Widgets/PresetList.vala"
				if (_tmp13_ != NULL) {
#line 1191 "PresetList.c"
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp14_ = text;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp15_ = noise_preset_list_DELETE_PRESET;
#line 250 "../src/Widgets/PresetList.vala"
					_tmp12_ = g_strcmp0 (_tmp14_, _tmp15_) == 0;
#line 1200 "PresetList.c"
				} else {
#line 250 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 1204 "PresetList.c"
				}
#line 250 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 1208 "PresetList.c"
					GtkListStore* _tmp16_;
#line 252 "../src/Widgets/PresetList.vala"
					_tmp16_ = self->priv->store;
#line 252 "../src/Widgets/PresetList.vala"
					gtk_list_store_remove (_tmp16_, &iter);
#line 257 "../src/Widgets/PresetList.vala"
					noise_preset_list_remove_separator_item (self, 1);
#line 1216 "PresetList.c"
				}
#line 246 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1220 "PresetList.c"
			}
		}
	}
}


static void
noise_preset_list_remove_separator_item (NoisePresetList* self,
                                         gint index)
{
	gint count = 0;
	gint nitems = 0;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
#line 262 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/Widgets/PresetList.vala"
	count = 0;
#line 263 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->store;
#line 263 "../src/Widgets/PresetList.vala"
	nitems = gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp0_, NULL);
#line 1243 "PresetList.c"
	{
		gint i = 0;
		gint _tmp1_;
#line 266 "../src/Widgets/PresetList.vala"
		_tmp1_ = nitems;
#line 266 "../src/Widgets/PresetList.vala"
		i = _tmp1_ - 1;
#line 1251 "PresetList.c"
		{
			gboolean _tmp2_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
			_tmp2_ = TRUE;
#line 266 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1258 "PresetList.c"
				GtkListStore* _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				GtkTreeIter _tmp8_ = {0};
				gboolean _tmp9_;
				gboolean _tmp10_;
				gint _tmp11_;
				gchar* text = NULL;
				GtkListStore* _tmp12_;
				GtkTreeIter _tmp13_;
				gchar* _tmp14_ = NULL;
				gboolean _tmp15_ = FALSE;
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				gint _tmp18_;
				gint _tmp19_;
#line 266 "../src/Widgets/PresetList.vala"
				if (!_tmp2_) {
#line 1278 "PresetList.c"
					gint _tmp3_;
#line 266 "../src/Widgets/PresetList.vala"
					_tmp3_ = i;
#line 266 "../src/Widgets/PresetList.vala"
					i = _tmp3_ - 1;
#line 1284 "PresetList.c"
				}
#line 266 "../src/Widgets/PresetList.vala"
				_tmp2_ = FALSE;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp4_ = self->priv->store;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp5_ = i;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 266 "../src/Widgets/PresetList.vala"
				_tmp7_ = _tmp6_;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp9_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp4_, &_tmp8_, _tmp7_);
#line 266 "../src/Widgets/PresetList.vala"
				iter = _tmp8_;
#line 266 "../src/Widgets/PresetList.vala"
				_tmp10_ = !_tmp9_;
#line 266 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp7_);
#line 266 "../src/Widgets/PresetList.vala"
				if (_tmp10_) {
#line 266 "../src/Widgets/PresetList.vala"
					break;
#line 1308 "PresetList.c"
				}
#line 267 "../src/Widgets/PresetList.vala"
				_tmp11_ = count;
#line 267 "../src/Widgets/PresetList.vala"
				count = _tmp11_ + 1;
#line 269 "../src/Widgets/PresetList.vala"
				_tmp12_ = self->priv->store;
#line 269 "../src/Widgets/PresetList.vala"
				_tmp13_ = iter;
#line 269 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp12_, &_tmp13_, 1, &_tmp14_, -1);
#line 269 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 269 "../src/Widgets/PresetList.vala"
				text = _tmp14_;
#line 271 "../src/Widgets/PresetList.vala"
				_tmp18_ = nitems;
#line 271 "../src/Widgets/PresetList.vala"
				_tmp19_ = count;
#line 271 "../src/Widgets/PresetList.vala"
				if ((_tmp18_ - index) == _tmp19_) {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp17_ = TRUE;
#line 1332 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp17_ = index == -1;
#line 1336 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp17_) {
#line 1340 "PresetList.c"
					const gchar* _tmp20_;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp20_ = text;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp16_ = _tmp20_ != NULL;
#line 1346 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp16_ = FALSE;
#line 1350 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp16_) {
#line 1354 "PresetList.c"
					const gchar* _tmp21_;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp21_ = text;
#line 271 "../src/Widgets/PresetList.vala"
					_tmp15_ = g_strcmp0 (_tmp21_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 1360 "PresetList.c"
				} else {
#line 271 "../src/Widgets/PresetList.vala"
					_tmp15_ = FALSE;
#line 1364 "PresetList.c"
				}
#line 271 "../src/Widgets/PresetList.vala"
				if (_tmp15_) {
#line 1368 "PresetList.c"
					GtkListStore* _tmp22_;
#line 273 "../src/Widgets/PresetList.vala"
					_tmp22_ = self->priv->store;
#line 273 "../src/Widgets/PresetList.vala"
					gtk_list_store_remove (_tmp22_, &iter);
#line 277 "../src/Widgets/PresetList.vala"
					_g_free0 (text);
#line 277 "../src/Widgets/PresetList.vala"
					break;
#line 1378 "PresetList.c"
				}
#line 266 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1382 "PresetList.c"
			}
		}
	}
}


static void
noise_preset_list_add_delete_preset_option (NoisePresetList* self)
{
	gboolean already_added = FALSE;
	GtkTreeIter last_iter = {0};
	GtkTreeIter new_iter = {0};
	gboolean _tmp23_;
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_;
	GtkTreeIter _tmp26_ = {0};
	GtkListStore* _tmp27_;
	GtkTreeIter _tmp28_;
	const gchar* _tmp29_;
	GtkTreeIter _tmp30_;
	GtkListStore* _tmp31_;
	GtkTreeIter _tmp32_;
	GtkTreeIter _tmp33_ = {0};
	GtkListStore* _tmp34_;
	GtkTreeIter _tmp35_;
#line 282 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Widgets/PresetList.vala"
	already_added = FALSE;
#line 1412 "PresetList.c"
	{
		gint i = 0;
#line 286 "../src/Widgets/PresetList.vala"
		i = 0;
#line 1417 "PresetList.c"
		{
			gboolean _tmp0_ = FALSE;
#line 286 "../src/Widgets/PresetList.vala"
			_tmp0_ = TRUE;
#line 286 "../src/Widgets/PresetList.vala"
			while (TRUE) {
#line 1424 "PresetList.c"
				GtkListStore* _tmp2_;
				gint _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GtkTreeIter _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
				gchar* text = NULL;
				GtkListStore* _tmp9_;
				GtkTreeIter _tmp10_;
				gchar* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				const gchar* _tmp13_;
#line 286 "../src/Widgets/PresetList.vala"
				if (!_tmp0_) {
#line 1440 "PresetList.c"
					gint _tmp1_;
#line 286 "../src/Widgets/PresetList.vala"
					_tmp1_ = i;
#line 286 "../src/Widgets/PresetList.vala"
					i = _tmp1_ + 1;
#line 1446 "PresetList.c"
				}
#line 286 "../src/Widgets/PresetList.vala"
				_tmp0_ = FALSE;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp2_ = self->priv->store;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp3_ = i;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp4_ = g_strdup_printf ("%i", _tmp3_);
#line 286 "../src/Widgets/PresetList.vala"
				_tmp5_ = _tmp4_;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp7_ = gtk_tree_model_get_iter_from_string ((GtkTreeModel*) _tmp2_, &_tmp6_, _tmp5_);
#line 286 "../src/Widgets/PresetList.vala"
				last_iter = _tmp6_;
#line 286 "../src/Widgets/PresetList.vala"
				_tmp8_ = !_tmp7_;
#line 286 "../src/Widgets/PresetList.vala"
				_g_free0 (_tmp5_);
#line 286 "../src/Widgets/PresetList.vala"
				if (_tmp8_) {
#line 286 "../src/Widgets/PresetList.vala"
					break;
#line 1470 "PresetList.c"
				}
#line 288 "../src/Widgets/PresetList.vala"
				_tmp9_ = self->priv->store;
#line 288 "../src/Widgets/PresetList.vala"
				_tmp10_ = last_iter;
#line 288 "../src/Widgets/PresetList.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 1, &_tmp11_, -1);
#line 288 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 288 "../src/Widgets/PresetList.vala"
				text = _tmp11_;
#line 290 "../src/Widgets/PresetList.vala"
				_tmp13_ = text;
#line 290 "../src/Widgets/PresetList.vala"
				if (_tmp13_ != NULL) {
#line 1486 "PresetList.c"
					const gchar* _tmp14_;
#line 290 "../src/Widgets/PresetList.vala"
					_tmp14_ = text;
#line 290 "../src/Widgets/PresetList.vala"
					_tmp12_ = g_strcmp0 (_tmp14_, NOISE_PRESET_LIST_SEPARATOR_NAME) == 0;
#line 1492 "PresetList.c"
				} else {
#line 290 "../src/Widgets/PresetList.vala"
					_tmp12_ = FALSE;
#line 1496 "PresetList.c"
				}
#line 290 "../src/Widgets/PresetList.vala"
				if (_tmp12_) {
#line 1500 "PresetList.c"
					GtkTreeIter _tmp15_;
					GtkListStore* _tmp16_;
					gboolean _tmp17_;
#line 291 "../src/Widgets/PresetList.vala"
					_tmp15_ = last_iter;
#line 291 "../src/Widgets/PresetList.vala"
					new_iter = _tmp15_;
#line 293 "../src/Widgets/PresetList.vala"
					_tmp16_ = self->priv->store;
#line 293 "../src/Widgets/PresetList.vala"
					_tmp17_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp16_, &new_iter);
#line 293 "../src/Widgets/PresetList.vala"
					if (_tmp17_) {
#line 1514 "PresetList.c"
						GtkListStore* _tmp18_;
						GtkTreeIter _tmp19_;
						gchar* _tmp20_ = NULL;
						const gchar* _tmp21_;
						const gchar* _tmp22_;
#line 294 "../src/Widgets/PresetList.vala"
						_tmp18_ = self->priv->store;
#line 294 "../src/Widgets/PresetList.vala"
						_tmp19_ = new_iter;
#line 294 "../src/Widgets/PresetList.vala"
						gtk_tree_model_get ((GtkTreeModel*) _tmp18_, &_tmp19_, 1, &_tmp20_, -1);
#line 294 "../src/Widgets/PresetList.vala"
						_g_free0 (text);
#line 294 "../src/Widgets/PresetList.vala"
						text = _tmp20_;
#line 295 "../src/Widgets/PresetList.vala"
						_tmp21_ = text;
#line 295 "../src/Widgets/PresetList.vala"
						_tmp22_ = noise_preset_list_DELETE_PRESET;
#line 295 "../src/Widgets/PresetList.vala"
						already_added = g_strcmp0 (_tmp21_, _tmp22_) == 0;
#line 1536 "PresetList.c"
					}
#line 298 "../src/Widgets/PresetList.vala"
					_g_free0 (text);
#line 298 "../src/Widgets/PresetList.vala"
					break;
#line 1542 "PresetList.c"
				}
#line 286 "../src/Widgets/PresetList.vala"
				_g_free0 (text);
#line 1546 "PresetList.c"
			}
		}
	}
#line 302 "../src/Widgets/PresetList.vala"
	_tmp23_ = already_added;
#line 302 "../src/Widgets/PresetList.vala"
	if (_tmp23_) {
#line 303 "../src/Widgets/PresetList.vala"
		return;
#line 1556 "PresetList.c"
	}
#line 307 "../src/Widgets/PresetList.vala"
	_tmp24_ = self->priv->store;
#line 307 "../src/Widgets/PresetList.vala"
	_tmp25_ = last_iter;
#line 307 "../src/Widgets/PresetList.vala"
	gtk_list_store_insert_after (_tmp24_, &_tmp26_, &_tmp25_);
#line 307 "../src/Widgets/PresetList.vala"
	new_iter = _tmp26_;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp27_ = self->priv->store;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp28_ = new_iter;
#line 308 "../src/Widgets/PresetList.vala"
	_tmp29_ = noise_preset_list_DELETE_PRESET;
#line 308 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp27_, &_tmp28_, 0, NULL, 1, _tmp29_, -1);
#line 310 "../src/Widgets/PresetList.vala"
	_tmp30_ = new_iter;
#line 310 "../src/Widgets/PresetList.vala"
	last_iter = _tmp30_;
#line 313 "../src/Widgets/PresetList.vala"
	_tmp31_ = self->priv->store;
#line 313 "../src/Widgets/PresetList.vala"
	_tmp32_ = last_iter;
#line 313 "../src/Widgets/PresetList.vala"
	gtk_list_store_insert_after (_tmp31_, &_tmp33_, &_tmp32_);
#line 313 "../src/Widgets/PresetList.vala"
	new_iter = _tmp33_;
#line 314 "../src/Widgets/PresetList.vala"
	_tmp34_ = self->priv->store;
#line 314 "../src/Widgets/PresetList.vala"
	_tmp35_ = new_iter;
#line 314 "../src/Widgets/PresetList.vala"
	gtk_list_store_set (_tmp34_, &_tmp35_, 0, NULL, 1, NOISE_PRESET_LIST_SEPARATOR_NAME, -1);
#line 1592 "PresetList.c"
}


gboolean
noise_preset_list_get_automatic_chosen (NoisePresetList* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 35 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->automatic_selected;
#line 36 "../src/Widgets/PresetList.vala"
	result = _tmp0_;
#line 36 "../src/Widgets/PresetList.vala"
	return result;
#line 1609 "PresetList.c"
}


static gint
noise_preset_list_get_ncustompresets (NoisePresetList* self)
{
	gint result;
	gint _tmp0_;
#line 42 "../src/Widgets/PresetList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Widgets/PresetList.vala"
	_tmp0_ = self->priv->_ncustompresets;
#line 42 "../src/Widgets/PresetList.vala"
	result = _tmp0_;
#line 42 "../src/Widgets/PresetList.vala"
	return result;
#line 1626 "PresetList.c"
}


static void
noise_preset_list_set_ncustompresets (NoisePresetList* self,
                                      gint value)
{
#line 42 "../src/Widgets/PresetList.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Widgets/PresetList.vala"
	self->priv->_ncustompresets = value;
#line 1638 "PresetList.c"
}


static void
noise_preset_list_class_init (NoisePresetListClass * klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/PresetList.vala"
	g_type_class_adjust_private_offset (klass, &NoisePresetList_private_offset);
#line 29 "../src/Widgets/PresetList.vala"
	((NoisePresetListClass *) klass)->list_selection_change = (void (*) (NoisePresetList*)) noise_preset_list_real_list_selection_change;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_preset_list_get_property;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_preset_list_set_property;
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_preset_list_finalize;
#line 29 "../src/Widgets/PresetList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY, noise_preset_list_properties[NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY] = g_param_spec_boolean ("automatic-chosen", "automatic-chosen", "automatic-chosen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_signals[NOISE_PRESET_LIST_PRESET_SELECTED_SIGNAL] = g_signal_new ("preset-selected", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_EQUALIZER_PRESET);
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_signals[NOISE_PRESET_LIST_AUTOMATIC_PRESET_CHOSEN_SIGNAL] = g_signal_new ("automatic-preset-chosen", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../src/Widgets/PresetList.vala"
	noise_preset_list_signals[NOISE_PRESET_LIST_DELETE_PRESET_CHOSEN_SIGNAL] = g_signal_new ("delete-preset-chosen", NOISE_TYPE_PRESET_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 52 "../src/Widgets/PresetList.vala"
	_tmp0_ = g_strdup (_ ("Automatic"));
#line 52 "../src/Widgets/PresetList.vala"
	noise_preset_list_AUTOMATIC_MODE = _tmp0_;
#line 53 "../src/Widgets/PresetList.vala"
	_tmp1_ = g_strdup (_ ("Delete Current"));
#line 53 "../src/Widgets/PresetList.vala"
	noise_preset_list_DELETE_PRESET = _tmp1_;
#line 1675 "PresetList.c"
}


static void
noise_preset_list_instance_init (NoisePresetList * self)
{
#line 29 "../src/Widgets/PresetList.vala"
	self->priv = noise_preset_list_get_instance_private (self);
#line 1684 "PresetList.c"
}


static void
noise_preset_list_finalize (GObject * obj)
{
	NoisePresetList * self;
#line 29 "../src/Widgets/PresetList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PRESET_LIST, NoisePresetList);
#line 40 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->last_selected_preset);
#line 47 "../src/Widgets/PresetList.vala"
	_g_object_unref0 (self->priv->store);
#line 29 "../src/Widgets/PresetList.vala"
	G_OBJECT_CLASS (noise_preset_list_parent_class)->finalize (obj);
#line 1700 "PresetList.c"
}


GType
noise_preset_list_get_type (void)
{
	static volatile gsize noise_preset_list_type_id__volatile = 0;
	if (g_once_init_enter (&noise_preset_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePresetListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_preset_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePresetList), 0, (GInstanceInitFunc) noise_preset_list_instance_init, NULL };
		GType noise_preset_list_type_id;
		noise_preset_list_type_id = g_type_register_static (gtk_combo_box_get_type (), "NoisePresetList", &g_define_type_info, 0);
		NoisePresetList_private_offset = g_type_add_instance_private (noise_preset_list_type_id, sizeof (NoisePresetListPrivate));
		g_once_init_leave (&noise_preset_list_type_id__volatile, noise_preset_list_type_id);
	}
	return noise_preset_list_type_id__volatile;
}


static void
_vala_noise_preset_list_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PRESET_LIST, NoisePresetList);
#line 29 "../src/Widgets/PresetList.vala"
	switch (property_id) {
#line 29 "../src/Widgets/PresetList.vala"
		case NOISE_PRESET_LIST_AUTOMATIC_CHOSEN_PROPERTY:
#line 29 "../src/Widgets/PresetList.vala"
		g_value_set_boolean (value, noise_preset_list_get_automatic_chosen (self));
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1735 "PresetList.c"
		default:
#line 29 "../src/Widgets/PresetList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1741 "PresetList.c"
	}
}


static void
_vala_noise_preset_list_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoisePresetList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PRESET_LIST, NoisePresetList);
#line 29 "../src/Widgets/PresetList.vala"
	switch (property_id) {
#line 1756 "PresetList.c"
		default:
#line 29 "../src/Widgets/PresetList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/PresetList.vala"
		break;
#line 1762 "PresetList.c"
	}
}



