/* NotImportedDialog.c generated by valac 0.42.6, the Vala compiler
 * generated from NotImportedDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Merely a place holder for multiple pieces of information regarding
 * the current media playing. Mostly here because of dependence. */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gio/gio.h>


#define NOISE_TYPE_NOT_IMPORTED_DIALOG (noise_not_imported_dialog_get_type ())
#define NOISE_NOT_IMPORTED_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialog))
#define NOISE_NOT_IMPORTED_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialogClass))
#define NOISE_IS_NOT_IMPORTED_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_NOT_IMPORTED_DIALOG))
#define NOISE_IS_NOT_IMPORTED_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_NOT_IMPORTED_DIALOG))
#define NOISE_NOT_IMPORTED_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialogClass))

typedef struct _NoiseNotImportedDialog NoiseNotImportedDialog;
typedef struct _NoiseNotImportedDialogClass NoiseNotImportedDialogClass;
typedef struct _NoiseNotImportedDialogPrivate NoiseNotImportedDialogPrivate;
enum  {
	NOISE_NOT_IMPORTED_DIALOG_0_PROPERTY,
	NOISE_NOT_IMPORTED_DIALOG_NUM_PROPERTIES
};
static GParamSpec* noise_not_imported_dialog_properties[NOISE_NOT_IMPORTED_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block13Data Block13Data;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _NoiseNotImportedDialog {
	GtkDialog parent_instance;
	NoiseNotImportedDialogPrivate * priv;
};

struct _NoiseNotImportedDialogClass {
	GtkDialogClass parent_class;
	void (*moveToTrashClick) (NoiseNotImportedDialog* self);
	void (*ignoreClick) (NoiseNotImportedDialog* self);
};

struct _NoiseNotImportedDialogPrivate {
	GeeLinkedList* _files;
	gchar* music_folder;
	GtkListStore* filesModel;
	GtkButton* moveToTrash;
};

struct _Block13Data {
	int _ref_count_;
	NoiseNotImportedDialog* self;
	GtkCheckButton* trashAll;
	GtkTreeView* filesView;
	GtkExpander* expander;
};


static gint NoiseNotImportedDialog_private_offset;
static gpointer noise_not_imported_dialog_parent_class = NULL;

GType noise_not_imported_dialog_get_type (void) G_GNUC_CONST;
NoiseNotImportedDialog* noise_not_imported_dialog_new (GeeCollection* files,
                                                       const gchar* music);
NoiseNotImportedDialog* noise_not_imported_dialog_construct (GType object_type,
                                                             GeeCollection* files,
                                                             const gchar* music);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_not_imported_dialog_moveToTrashClick (NoiseNotImportedDialog* self);
static void _noise_not_imported_dialog_moveToTrashClick_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static void __lambda13_ (NoiseNotImportedDialog* self,
                  GtkCellRendererToggle* toggle,
                  const gchar* path);
gboolean noise_not_imported_dialog_updateMoveToTrashSensetivity (NoiseNotImportedDialog* self,
                                                                 GtkTreeModel* model,
                                                                 GtkTreePath* path,
                                                                 GtkTreeIter* iter);
static gboolean _noise_not_imported_dialog_updateMoveToTrashSensetivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                              GtkTreePath* path,
                                                                                              GtkTreeIter* iter,
                                                                                              gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda13__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                    const gchar* path,
                                                    gpointer self);
static void __lambda14_ (Block13Data* _data13_);
gboolean noise_not_imported_dialog_selectAll (NoiseNotImportedDialog* self,
                                              GtkTreeModel* model,
                                              GtkTreePath* path,
                                              GtkTreeIter* iter);
static gboolean _noise_not_imported_dialog_selectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                           GtkTreePath* path,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
gboolean noise_not_imported_dialog_unselectAll (NoiseNotImportedDialog* self,
                                                GtkTreeModel* model,
                                                GtkTreePath* path,
                                                GtkTreeIter* iter);
static gboolean _noise_not_imported_dialog_unselectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                             GtkTreePath* path,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (NoiseNotImportedDialog* self);
static void ___lambda15__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda16_ (Block13Data* _data13_);
static void ___lambda16__gtk_expander_activate (GtkExpander* _sender,
                                         gpointer self);
gboolean noise_not_imported_dialog_deleteSelectedItems (NoiseNotImportedDialog* self,
                                                        GtkTreeModel* model,
                                                        GtkTreePath* path,
                                                        GtkTreeIter* iter);
static void noise_not_imported_dialog_real_moveToTrashClick (NoiseNotImportedDialog* self);
static gboolean _noise_not_imported_dialog_deleteSelectedItems_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                     GtkTreePath* path,
                                                                                     GtkTreeIter* iter,
                                                                                     gpointer self);
void noise_not_imported_dialog_ignoreClick (NoiseNotImportedDialog* self);
static void noise_not_imported_dialog_real_ignoreClick (NoiseNotImportedDialog* self);
static void noise_not_imported_dialog_finalize (GObject * obj);


static inline gpointer
noise_not_imported_dialog_get_instance_private (NoiseNotImportedDialog* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseNotImportedDialog_private_offset);
}


static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	return _data13_;
#line 190 "NotImportedDialog.c"
}


static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 201 "NotImportedDialog.c"
		NoiseNotImportedDialog* self;
#line 39 "../src/Dialogs/NotImportedDialog.vala"
		self = _data13_->self;
#line 39 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_data13_->expander);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_data13_->filesView);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_data13_->trashAll);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (self);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
		g_slice_free (Block13Data, _data13_);
#line 215 "NotImportedDialog.c"
	}
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 239 "NotImportedDialog.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 243 "NotImportedDialog.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 249 "NotImportedDialog.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 253 "NotImportedDialog.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 257 "NotImportedDialog.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 265 "NotImportedDialog.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 293 "NotImportedDialog.c"
				goto __catch20_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 302 "NotImportedDialog.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 316 "NotImportedDialog.c"
				goto __catch20_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 327 "NotImportedDialog.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 341 "NotImportedDialog.c"
	}
	goto __finally20;
	__catch20_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 355 "NotImportedDialog.c"
	}
	__finally20:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 366 "NotImportedDialog.c"
	}
}


static void
_noise_not_imported_dialog_moveToTrashClick_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
#line 126 "../src/Dialogs/NotImportedDialog.vala"
	noise_not_imported_dialog_moveToTrashClick ((NoiseNotImportedDialog*) self);
#line 377 "NotImportedDialog.c"
}


static gboolean
_noise_not_imported_dialog_updateMoveToTrashSensetivity_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                                     GtkTreePath* path,
                                                                                     GtkTreeIter* iter,
                                                                                     gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_updateMoveToTrashSensetivity ((NoiseNotImportedDialog*) self, model, path, iter);
#line 135 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 391 "NotImportedDialog.c"
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 400 "NotImportedDialog.c"
}


static void
__lambda13_ (NoiseNotImportedDialog* self,
             GtkCellRendererToggle* toggle,
             const gchar* path)
{
	GtkTreePath* tree_path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	GtkListStore* _tmp3_;
	GtkTreeIter _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkButton* _tmp7_;
	GtkListStore* _tmp8_;
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (toggle != NULL);
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (path != NULL);
#line 129 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = gtk_tree_path_new_from_string (path);
#line 129 "../src/Dialogs/NotImportedDialog.vala"
	tree_path = _tmp0_;
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = self->priv->filesModel;
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp1_, &_tmp2_, tree_path);
#line 131 "../src/Dialogs/NotImportedDialog.vala"
	iter = _tmp2_;
#line 132 "../src/Dialogs/NotImportedDialog.vala"
	_tmp3_ = self->priv->filesModel;
#line 132 "../src/Dialogs/NotImportedDialog.vala"
	_tmp4_ = iter;
#line 132 "../src/Dialogs/NotImportedDialog.vala"
	_tmp5_ = gtk_cell_renderer_toggle_get_active (toggle);
#line 132 "../src/Dialogs/NotImportedDialog.vala"
	_tmp6_ = _tmp5_;
#line 132 "../src/Dialogs/NotImportedDialog.vala"
	gtk_list_store_set (_tmp3_, &_tmp4_, 0, !_tmp6_, -1);
#line 134 "../src/Dialogs/NotImportedDialog.vala"
	_tmp7_ = self->priv->moveToTrash;
#line 134 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 135 "../src/Dialogs/NotImportedDialog.vala"
	_tmp8_ = self->priv->filesModel;
#line 135 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp8_, _noise_not_imported_dialog_updateMoveToTrashSensetivity_gtk_tree_model_foreach_func, self);
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	__vala_GtkTreePath_free0 (tree_path);
#line 454 "NotImportedDialog.c"
}


static void
___lambda13__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                               const gchar* path,
                                               gpointer self)
{
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	__lambda13_ ((NoiseNotImportedDialog*) self, _sender, path);
#line 465 "NotImportedDialog.c"
}


static gboolean
_noise_not_imported_dialog_selectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                  GtkTreePath* path,
                                                                  GtkTreeIter* iter,
                                                                  gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_selectAll ((NoiseNotImportedDialog*) self, model, path, iter);
#line 140 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 479 "NotImportedDialog.c"
}


static gboolean
_noise_not_imported_dialog_unselectAll_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                    GtkTreePath* path,
                                                                    GtkTreeIter* iter,
                                                                    gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_unselectAll ((NoiseNotImportedDialog*) self, model, path, iter);
#line 144 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 493 "NotImportedDialog.c"
}


static void
__lambda14_ (Block13Data* _data13_)
{
	NoiseNotImportedDialog* self;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	self = _data13_->self;
#line 139 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = _data13_->trashAll;
#line 139 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 139 "../src/Dialogs/NotImportedDialog.vala"
	_tmp2_ = _tmp1_;
#line 139 "../src/Dialogs/NotImportedDialog.vala"
	if (_tmp2_) {
#line 514 "NotImportedDialog.c"
		GtkListStore* _tmp3_;
		GtkTreeView* _tmp4_;
		GtkButton* _tmp5_;
#line 140 "../src/Dialogs/NotImportedDialog.vala"
		_tmp3_ = self->priv->filesModel;
#line 140 "../src/Dialogs/NotImportedDialog.vala"
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, _noise_not_imported_dialog_selectAll_gtk_tree_model_foreach_func, self);
#line 141 "../src/Dialogs/NotImportedDialog.vala"
		_tmp4_ = _data13_->filesView;
#line 141 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
#line 142 "../src/Dialogs/NotImportedDialog.vala"
		_tmp5_ = self->priv->moveToTrash;
#line 142 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
#line 530 "NotImportedDialog.c"
	} else {
		GtkListStore* _tmp6_;
		GtkTreeView* _tmp7_;
		GtkButton* _tmp8_;
#line 144 "../src/Dialogs/NotImportedDialog.vala"
		_tmp6_ = self->priv->filesModel;
#line 144 "../src/Dialogs/NotImportedDialog.vala"
		gtk_tree_model_foreach ((GtkTreeModel*) _tmp6_, _noise_not_imported_dialog_unselectAll_gtk_tree_model_foreach_func, self);
#line 145 "../src/Dialogs/NotImportedDialog.vala"
		_tmp7_ = _data13_->filesView;
#line 145 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, TRUE);
#line 146 "../src/Dialogs/NotImportedDialog.vala"
		_tmp8_ = self->priv->moveToTrash;
#line 146 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 547 "NotImportedDialog.c"
	}
}


static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	__lambda14_ (self);
#line 558 "NotImportedDialog.c"
}


static void
__lambda15_ (NoiseNotImportedDialog* self)
{
#line 151 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 567 "NotImportedDialog.c"
}


static void
___lambda15__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 150 "../src/Dialogs/NotImportedDialog.vala"
	__lambda15_ ((NoiseNotImportedDialog*) self);
#line 577 "NotImportedDialog.c"
}


static void
__lambda16_ (Block13Data* _data13_)
{
	NoiseNotImportedDialog* self;
#line 154 "../src/Dialogs/NotImportedDialog.vala"
	self = _data13_->self;
#line 155 "../src/Dialogs/NotImportedDialog.vala"
	if (gtk_expander_get_expanded (_data13_->expander)) {
#line 156 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) _data13_->expander, -1, -1);
#line 591 "NotImportedDialog.c"
	} else {
#line 158 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) _data13_->expander, -1, 120);
#line 595 "NotImportedDialog.c"
	}
}


static void
___lambda16__gtk_expander_activate (GtkExpander* _sender,
                                    gpointer self)
{
#line 154 "../src/Dialogs/NotImportedDialog.vala"
	__lambda16_ (self);
#line 606 "NotImportedDialog.c"
}


NoiseNotImportedDialog*
noise_not_imported_dialog_construct (GType object_type,
                                     GeeCollection* files,
                                     const gchar* music)
{
	NoiseNotImportedDialog * self = NULL;
	Block13Data* _data13_;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gchar* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	GtkImage* warning = NULL;
	GtkImage* _tmp5_;
	GtkLabel* title = NULL;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	gchar* secondary_text = NULL;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	GtkLabel* info = NULL;
	const gchar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkCheckButton* _tmp23_;
	GtkCheckButton* _tmp24_;
	GtkCellRendererToggle* toggle = NULL;
	GtkCellRendererToggle* _tmp25_;
	GtkTreeViewColumn* column = NULL;
	GtkTreeViewColumn* _tmp26_;
	GtkTreeViewColumn* _tmp27_;
	GtkTreeViewColumn* _tmp28_;
	GtkCellRendererToggle* _tmp29_;
	GtkTreeViewColumn* _tmp30_;
	GtkCellRendererToggle* _tmp31_;
	GtkListStore* _tmp32_;
	GtkTreeView* _tmp33_;
	GtkTreeView* _tmp34_;
	GtkListStore* _tmp35_;
	GtkTreeView* _tmp36_;
	GtkTreeViewColumn* _tmp37_;
	GtkTreeView* _tmp38_;
	GtkCellRendererText* _tmp39_;
	GtkCellRendererText* _tmp40_;
	GtkTreeView* _tmp41_;
	GtkScrolledWindow* files_scrolled = NULL;
	GtkScrolledWindow* _tmp58_;
	GtkTreeView* _tmp59_;
	GtkExpander* _tmp60_;
	GtkButton* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* okButton = NULL;
	GtkButton* _tmp63_;
	GtkButtonBox* bottomButtons = NULL;
	GtkButtonBox* _tmp64_;
	GtkButton* _tmp65_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp66_;
	GtkImage* _tmp67_;
	GtkLabel* _tmp68_;
	GtkLabel* _tmp69_;
	GtkCheckButton* _tmp70_;
	GtkBox* _tmp71_;
	GtkButton* _tmp72_;
	GtkCellRendererToggle* _tmp73_;
	GtkCheckButton* _tmp74_;
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (files != NULL, NULL);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (music != NULL, NULL);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_data13_->_ref_count_ = 1;
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	self = (NoiseNotImportedDialog*) g_object_new (object_type, NULL);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_data13_->self = g_object_ref (self);
#line 40 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 40 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->_files);
#line 40 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->_files = _tmp0_;
#line 41 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = self->priv->_files;
#line 41 "../src/Dialogs/NotImportedDialog.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, files);
#line 42 "../src/Dialogs/NotImportedDialog.vala"
	_tmp2_ = g_strdup (music);
#line 42 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (self->priv->music_folder);
#line 42 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->music_folder = _tmp2_;
#line 44 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 45 "../src/Dialogs/NotImportedDialog.vala"
	_tmp3_ = noise_app_get_main_window ();
#line 45 "../src/Dialogs/NotImportedDialog.vala"
	_tmp4_ = _tmp3_;
#line 45 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp4_);
#line 46 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
#line 47 "../src/Dialogs/NotImportedDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 49 "../src/Dialogs/NotImportedDialog.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-error", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 49 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 49 "../src/Dialogs/NotImportedDialog.vala"
	warning = _tmp5_;
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_tmp6_ = self->priv->music_folder;
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_tmp7_ = g_strdup_printf (_ ("Issues while importing from %s"), _tmp6_);
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_tmp8_ = _tmp7_;
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_tmp10_ = _tmp9_;
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (_tmp8_);
#line 51 "../src/Dialogs/NotImportedDialog.vala"
	title = _tmp10_;
#line 52 "../src/Dialogs/NotImportedDialog.vala"
	_tmp11_ = title;
#line 52 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
#line 53 "../src/Dialogs/NotImportedDialog.vala"
	_tmp12_ = title;
#line 53 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 54 "../src/Dialogs/NotImportedDialog.vala"
	_tmp13_ = title;
#line 54 "../src/Dialogs/NotImportedDialog.vala"
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
#line 54 "../src/Dialogs/NotImportedDialog.vala"
	gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_PRIMARY_LABEL);
#line 56 "../src/Dialogs/NotImportedDialog.vala"
	_tmp15_ = gee_collection_get_size (files);
#line 56 "../src/Dialogs/NotImportedDialog.vala"
	_tmp16_ = _tmp15_;
#line 56 "../src/Dialogs/NotImportedDialog.vala"
	_tmp17_ = gee_collection_get_size (files);
#line 56 "../src/Dialogs/NotImportedDialog.vala"
	_tmp18_ = _tmp17_;
#line 56 "../src/Dialogs/NotImportedDialog.vala"
	_tmp19_ = g_strdup_printf (ngettext ("Unable to import %d item. The file may be damaged.", "Unable to import %d items. The files may be damaged.", (gulong) _tmp16_), _tmp18_);
#line 56 "../src/Dialogs/NotImportedDialog.vala"
	secondary_text = _tmp19_;
#line 62 "../src/Dialogs/NotImportedDialog.vala"
	_tmp20_ = secondary_text;
#line 62 "../src/Dialogs/NotImportedDialog.vala"
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
#line 62 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp21_);
#line 62 "../src/Dialogs/NotImportedDialog.vala"
	info = _tmp21_;
#line 63 "../src/Dialogs/NotImportedDialog.vala"
	_tmp22_ = info;
#line 63 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp22_, GTK_ALIGN_START);
#line 65 "../src/Dialogs/NotImportedDialog.vala"
	_tmp23_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Move all corrupted files to trash"));
#line 65 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp23_);
#line 65 "../src/Dialogs/NotImportedDialog.vala"
	_data13_->trashAll = _tmp23_;
#line 66 "../src/Dialogs/NotImportedDialog.vala"
	_tmp24_ = _data13_->trashAll;
#line 66 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp24_, GTK_ALIGN_CENTER);
#line 69 "../src/Dialogs/NotImportedDialog.vala"
	_tmp25_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
#line 69 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp25_);
#line 69 "../src/Dialogs/NotImportedDialog.vala"
	toggle = _tmp25_;
#line 71 "../src/Dialogs/NotImportedDialog.vala"
	_tmp26_ = gtk_tree_view_column_new ();
#line 71 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp26_);
#line 71 "../src/Dialogs/NotImportedDialog.vala"
	column = _tmp26_;
#line 72 "../src/Dialogs/NotImportedDialog.vala"
	_tmp27_ = column;
#line 72 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_column_set_title (_tmp27_, _ ("del"));
#line 73 "../src/Dialogs/NotImportedDialog.vala"
	_tmp28_ = column;
#line 73 "../src/Dialogs/NotImportedDialog.vala"
	_tmp29_ = toggle;
#line 73 "../src/Dialogs/NotImportedDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp28_, (GtkCellRenderer*) _tmp29_, FALSE);
#line 74 "../src/Dialogs/NotImportedDialog.vala"
	_tmp30_ = column;
#line 74 "../src/Dialogs/NotImportedDialog.vala"
	_tmp31_ = toggle;
#line 74 "../src/Dialogs/NotImportedDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp30_, (GtkCellRenderer*) _tmp31_, "active", 0);
#line 76 "../src/Dialogs/NotImportedDialog.vala"
	_tmp32_ = gtk_list_store_new (2, G_TYPE_BOOLEAN, G_TYPE_STRING, -1);
#line 76 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->filesModel);
#line 76 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->filesModel = _tmp32_;
#line 78 "../src/Dialogs/NotImportedDialog.vala"
	_tmp33_ = (GtkTreeView*) gtk_tree_view_new ();
#line 78 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 78 "../src/Dialogs/NotImportedDialog.vala"
	_data13_->filesView = _tmp33_;
#line 79 "../src/Dialogs/NotImportedDialog.vala"
	_tmp34_ = _data13_->filesView;
#line 79 "../src/Dialogs/NotImportedDialog.vala"
	_tmp35_ = self->priv->filesModel;
#line 79 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	_tmp36_ = _data13_->filesView;
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	_tmp37_ = column;
#line 80 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_append_column (_tmp36_, _tmp37_);
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	_tmp38_ = _data13_->filesView;
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	_tmp39_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp39_);
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	_tmp40_ = _tmp39_;
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp38_, -1, _ ("File Location"), (GtkCellRenderer*) _tmp40_, "text", 1, NULL, NULL);
#line 81 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (_tmp40_);
#line 82 "../src/Dialogs/NotImportedDialog.vala"
	_tmp41_ = _data13_->filesView;
#line 82 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_view_set_headers_visible (_tmp41_, FALSE);
#line 864 "NotImportedDialog.c"
	{
		GeeIterator* _file_it = NULL;
		GeeIterator* _tmp42_;
#line 85 "../src/Dialogs/NotImportedDialog.vala"
		_tmp42_ = gee_iterable_iterator ((GeeIterable*) files);
#line 85 "../src/Dialogs/NotImportedDialog.vala"
		_file_it = _tmp42_;
#line 85 "../src/Dialogs/NotImportedDialog.vala"
		while (TRUE) {
#line 874 "NotImportedDialog.c"
			GeeIterator* _tmp43_;
			gchar* file = NULL;
			GeeIterator* _tmp44_;
			gpointer _tmp45_;
			GtkTreeIter item = {0};
			GtkListStore* _tmp46_;
			GtkTreeIter _tmp47_ = {0};
			GtkListStore* _tmp48_;
			GtkTreeIter _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
#line 85 "../src/Dialogs/NotImportedDialog.vala"
			_tmp43_ = _file_it;
#line 85 "../src/Dialogs/NotImportedDialog.vala"
			if (!gee_iterator_next (_tmp43_)) {
#line 85 "../src/Dialogs/NotImportedDialog.vala"
				break;
#line 898 "NotImportedDialog.c"
			}
#line 85 "../src/Dialogs/NotImportedDialog.vala"
			_tmp44_ = _file_it;
#line 85 "../src/Dialogs/NotImportedDialog.vala"
			_tmp45_ = gee_iterator_get (_tmp44_);
#line 85 "../src/Dialogs/NotImportedDialog.vala"
			file = (gchar*) _tmp45_;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			_tmp46_ = self->priv->filesModel;
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			gtk_list_store_append (_tmp46_, &_tmp47_);
#line 87 "../src/Dialogs/NotImportedDialog.vala"
			item = _tmp47_;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp48_ = self->priv->filesModel;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp49_ = item;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp50_ = file;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp51_ = self->priv->music_folder;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp52_ = g_strconcat ("file://", _tmp51_, NULL);
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp53_ = _tmp52_;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp54_ = string_replace (_tmp50_, _tmp53_, "");
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp55_ = _tmp54_;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp56_ = g_uri_unescape_string (_tmp55_, NULL);
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_tmp57_ = _tmp56_;
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			gtk_list_store_set (_tmp48_, &_tmp49_, 0, FALSE, 1, _tmp57_, -1);
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp57_);
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp55_);
#line 88 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp53_);
#line 85 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (file);
#line 942 "NotImportedDialog.c"
		}
#line 85 "../src/Dialogs/NotImportedDialog.vala"
		_g_object_unref0 (_file_it);
#line 946 "NotImportedDialog.c"
	}
#line 91 "../src/Dialogs/NotImportedDialog.vala"
	_tmp58_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 91 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp58_);
#line 91 "../src/Dialogs/NotImportedDialog.vala"
	files_scrolled = _tmp58_;
#line 92 "../src/Dialogs/NotImportedDialog.vala"
	_tmp59_ = _data13_->filesView;
#line 92 "../src/Dialogs/NotImportedDialog.vala"
	gtk_container_add ((GtkContainer*) files_scrolled, (GtkWidget*) _tmp59_);
#line 93 "../src/Dialogs/NotImportedDialog.vala"
	gtk_scrolled_window_set_policy (files_scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 94 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) files_scrolled, "expand", TRUE, NULL);
#line 95 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) files_scrolled, "margin", 6, NULL);
#line 97 "../src/Dialogs/NotImportedDialog.vala"
	_tmp60_ = (GtkExpander*) gtk_expander_new (_ ("Select individual files to move to trash:"));
#line 97 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp60_);
#line 97 "../src/Dialogs/NotImportedDialog.vala"
	_data13_->expander = _tmp60_;
#line 98 "../src/Dialogs/NotImportedDialog.vala"
	gtk_container_add ((GtkContainer*) _data13_->expander, (GtkWidget*) files_scrolled);
#line 99 "../src/Dialogs/NotImportedDialog.vala"
	gtk_expander_set_expanded (_data13_->expander, FALSE);
#line 101 "../src/Dialogs/NotImportedDialog.vala"
	_tmp61_ = (GtkButton*) gtk_button_new_with_label (_ ("Move to Trash"));
#line 101 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp61_);
#line 101 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->moveToTrash);
#line 101 "../src/Dialogs/NotImportedDialog.vala"
	self->priv->moveToTrash = _tmp61_;
#line 102 "../src/Dialogs/NotImportedDialog.vala"
	_tmp62_ = self->priv->moveToTrash;
#line 102 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp62_, FALSE);
#line 104 "../src/Dialogs/NotImportedDialog.vala"
	_tmp63_ = (GtkButton*) gtk_button_new_with_label (_ ("Ignore"));
#line 104 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp63_);
#line 104 "../src/Dialogs/NotImportedDialog.vala"
	okButton = _tmp63_;
#line 106 "../src/Dialogs/NotImportedDialog.vala"
	_tmp64_ = (GtkButtonBox*) gtk_button_box_new (GTK_ORIENTATION_HORIZONTAL);
#line 106 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp64_);
#line 106 "../src/Dialogs/NotImportedDialog.vala"
	bottomButtons = _tmp64_;
#line 107 "../src/Dialogs/NotImportedDialog.vala"
	gtk_button_box_set_layout (bottomButtons, GTK_BUTTONBOX_END);
#line 108 "../src/Dialogs/NotImportedDialog.vala"
	_tmp65_ = self->priv->moveToTrash;
#line 108 "../src/Dialogs/NotImportedDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) _tmp65_, FALSE, FALSE, (guint) 0);
#line 109 "../src/Dialogs/NotImportedDialog.vala"
	gtk_box_pack_end ((GtkBox*) bottomButtons, (GtkWidget*) okButton, FALSE, FALSE, (guint) 0);
#line 110 "../src/Dialogs/NotImportedDialog.vala"
	gtk_box_set_spacing ((GtkBox*) bottomButtons, 12);
#line 112 "../src/Dialogs/NotImportedDialog.vala"
	_tmp66_ = (GtkGrid*) gtk_grid_new ();
#line 112 "../src/Dialogs/NotImportedDialog.vala"
	g_object_ref_sink (_tmp66_);
#line 112 "../src/Dialogs/NotImportedDialog.vala"
	grid = _tmp66_;
#line 113 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 114 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 115 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) grid, "margin", 12, NULL);
#line 116 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) grid, 0);
#line 117 "../src/Dialogs/NotImportedDialog.vala"
	g_object_set ((GtkWidget*) grid, "expand", TRUE, NULL);
#line 118 "../src/Dialogs/NotImportedDialog.vala"
	_tmp67_ = warning;
#line 118 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp67_, 0, 0, 1, 2);
#line 119 "../src/Dialogs/NotImportedDialog.vala"
	_tmp68_ = title;
#line 119 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp68_, 1, 0, 1, 1);
#line 120 "../src/Dialogs/NotImportedDialog.vala"
	_tmp69_ = info;
#line 120 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp69_, 1, 1, 1, 1);
#line 121 "../src/Dialogs/NotImportedDialog.vala"
	_tmp70_ = _data13_->trashAll;
#line 121 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp70_, 0, 2, 2, 1);
#line 122 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) _data13_->expander, 0, 3, 2, 1);
#line 123 "../src/Dialogs/NotImportedDialog.vala"
	gtk_grid_attach (grid, (GtkWidget*) bottomButtons, 0, 4, 2, 1);
#line 124 "../src/Dialogs/NotImportedDialog.vala"
	_tmp71_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 124 "../src/Dialogs/NotImportedDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) grid);
#line 126 "../src/Dialogs/NotImportedDialog.vala"
	_tmp72_ = self->priv->moveToTrash;
#line 126 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_object (_tmp72_, "clicked", (GCallback) _noise_not_imported_dialog_moveToTrashClick_gtk_button_clicked, self, 0);
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	_tmp73_ = toggle;
#line 128 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_object (_tmp73_, "toggled", (GCallback) ___lambda13__gtk_cell_renderer_toggle_toggled, self, 0);
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	_tmp74_ = _data13_->trashAll;
#line 138 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp74_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 150 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_object (okButton, "clicked", (GCallback) ___lambda15__gtk_button_clicked, self, 0);
#line 154 "../src/Dialogs/NotImportedDialog.vala"
	g_signal_connect_data (_data13_->expander, "activate", (GCallback) ___lambda16__gtk_expander_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 162 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (grid);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (bottomButtons);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (okButton);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (files_scrolled);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (column);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (toggle);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (info);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (secondary_text);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (title);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (warning);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	block13_data_unref (_data13_);
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	_data13_ = NULL;
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	return self;
#line 1092 "NotImportedDialog.c"
}


NoiseNotImportedDialog*
noise_not_imported_dialog_new (GeeCollection* files,
                               const gchar* music)
{
#line 39 "../src/Dialogs/NotImportedDialog.vala"
	return noise_not_imported_dialog_construct (NOISE_TYPE_NOT_IMPORTED_DIALOG, files, music);
#line 1102 "NotImportedDialog.c"
}


gboolean
noise_not_imported_dialog_updateMoveToTrashSensetivity (NoiseNotImportedDialog* self,
                                                        GtkTreeModel* model,
                                                        GtkTreePath* path,
                                                        GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean sel = FALSE;
	GtkTreeIter _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 165 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 165 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 165 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 166 "../src/Dialogs/NotImportedDialog.vala"
	sel = FALSE;
#line 167 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = *iter;
#line 167 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get (model, &_tmp0_, 0, &_tmp1_, -1);
#line 167 "../src/Dialogs/NotImportedDialog.vala"
	sel = _tmp1_;
#line 169 "../src/Dialogs/NotImportedDialog.vala"
	_tmp2_ = sel;
#line 169 "../src/Dialogs/NotImportedDialog.vala"
	if (_tmp2_) {
#line 1137 "NotImportedDialog.c"
		GtkButton* _tmp3_;
#line 170 "../src/Dialogs/NotImportedDialog.vala"
		_tmp3_ = self->priv->moveToTrash;
#line 170 "../src/Dialogs/NotImportedDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
#line 171 "../src/Dialogs/NotImportedDialog.vala"
		result = TRUE;
#line 171 "../src/Dialogs/NotImportedDialog.vala"
		return result;
#line 1147 "NotImportedDialog.c"
	}
#line 174 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 174 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1153 "NotImportedDialog.c"
}


gboolean
noise_not_imported_dialog_selectAll (NoiseNotImportedDialog* self,
                                     GtkTreeModel* model,
                                     GtkTreePath* path,
                                     GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 177 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 178 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->filesModel;
#line 178 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = *iter;
#line 178 "../src/Dialogs/NotImportedDialog.vala"
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, TRUE, -1);
#line 179 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 179 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1184 "NotImportedDialog.c"
}


gboolean
noise_not_imported_dialog_unselectAll (NoiseNotImportedDialog* self,
                                       GtkTreeModel* model,
                                       GtkTreePath* path,
                                       GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 182 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 183 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->filesModel;
#line 183 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = *iter;
#line 183 "../src/Dialogs/NotImportedDialog.vala"
	gtk_list_store_set (_tmp0_, &_tmp1_, 0, FALSE, -1);
#line 184 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 184 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1215 "NotImportedDialog.c"
}


gboolean
noise_not_imported_dialog_deleteSelectedItems (NoiseNotImportedDialog* self,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean selected = FALSE;
	gchar* location = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkListStore* _tmp3_;
	GtkTreeIter _tmp4_;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
#line 187 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 187 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 187 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 187 "../src/Dialogs/NotImportedDialog.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->filesModel;
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	_tmp1_ = *iter;
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, 0, &_tmp2_, -1);
#line 190 "../src/Dialogs/NotImportedDialog.vala"
	selected = _tmp2_;
#line 191 "../src/Dialogs/NotImportedDialog.vala"
	_tmp3_ = self->priv->filesModel;
#line 191 "../src/Dialogs/NotImportedDialog.vala"
	_tmp4_ = *iter;
#line 191 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 1, &_tmp5_, -1);
#line 191 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (location);
#line 191 "../src/Dialogs/NotImportedDialog.vala"
	location = _tmp5_;
#line 193 "../src/Dialogs/NotImportedDialog.vala"
	_tmp6_ = selected;
#line 193 "../src/Dialogs/NotImportedDialog.vala"
	if (_tmp6_) {
#line 1266 "NotImportedDialog.c"
		{
			GFile* file = NULL;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp7_ = self->priv->music_folder;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp8_ = location;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp9_ = g_strconcat (_tmp7_, _tmp8_, NULL);
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp10_ = _tmp9_;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp11_ = g_file_new_for_path (_tmp10_);
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_tmp12_ = _tmp11_;
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (_tmp10_);
#line 195 "../src/Dialogs/NotImportedDialog.vala"
			file = _tmp12_;
#line 196 "../src/Dialogs/NotImportedDialog.vala"
			_tmp13_ = file;
#line 196 "../src/Dialogs/NotImportedDialog.vala"
			g_file_trash (_tmp13_, NULL, &_inner_error0_);
#line 196 "../src/Dialogs/NotImportedDialog.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/Dialogs/NotImportedDialog.vala"
				_g_object_unref0 (file);
#line 1300 "NotImportedDialog.c"
				goto __catch21_g_error;
			}
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_g_object_unref0 (file);
#line 1305 "NotImportedDialog.c"
		}
		goto __finally21;
		__catch21_g_error:
		{
			GError* err = NULL;
			const gchar* _tmp14_;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			err = _inner_error0_;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_inner_error0_ = NULL;
#line 198 "../src/Dialogs/NotImportedDialog.vala"
			_tmp14_ = location;
#line 198 "../src/Dialogs/NotImportedDialog.vala"
			_tmp15_ = err;
#line 198 "../src/Dialogs/NotImportedDialog.vala"
			_tmp16_ = _tmp15_->message;
#line 198 "../src/Dialogs/NotImportedDialog.vala"
			g_warning ("NotImportedDialog.vala:198: Could not move file %s to recycle: %s\n", _tmp14_, _tmp16_);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_g_error_free0 (err);
#line 1328 "NotImportedDialog.c"
		}
		__finally21:
#line 194 "../src/Dialogs/NotImportedDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1333 "NotImportedDialog.c"
			gboolean _tmp17_ = FALSE;
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			_g_free0 (location);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			g_clear_error (&_inner_error0_);
#line 194 "../src/Dialogs/NotImportedDialog.vala"
			return _tmp17_;
#line 1343 "NotImportedDialog.c"
		}
	}
#line 202 "../src/Dialogs/NotImportedDialog.vala"
	result = FALSE;
#line 202 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (location);
#line 202 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1352 "NotImportedDialog.c"
}


static gboolean
_noise_not_imported_dialog_deleteSelectedItems_gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                                            GtkTreePath* path,
                                                                            GtkTreeIter* iter,
                                                                            gpointer self)
{
	gboolean result;
	result = noise_not_imported_dialog_deleteSelectedItems ((NoiseNotImportedDialog*) self, model, path, iter);
#line 206 "../src/Dialogs/NotImportedDialog.vala"
	return result;
#line 1366 "NotImportedDialog.c"
}


static void
noise_not_imported_dialog_real_moveToTrashClick (NoiseNotImportedDialog* self)
{
	GtkListStore* _tmp0_;
#line 206 "../src/Dialogs/NotImportedDialog.vala"
	_tmp0_ = self->priv->filesModel;
#line 206 "../src/Dialogs/NotImportedDialog.vala"
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp0_, _noise_not_imported_dialog_deleteSelectedItems_gtk_tree_model_foreach_func, self);
#line 207 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1380 "NotImportedDialog.c"
}


void
noise_not_imported_dialog_moveToTrashClick (NoiseNotImportedDialog* self)
{
#line 205 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/Dialogs/NotImportedDialog.vala"
	NOISE_NOT_IMPORTED_DIALOG_GET_CLASS (self)->moveToTrashClick (self);
#line 1391 "NotImportedDialog.c"
}


static void
noise_not_imported_dialog_real_ignoreClick (NoiseNotImportedDialog* self)
{
#line 211 "../src/Dialogs/NotImportedDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1400 "NotImportedDialog.c"
}


void
noise_not_imported_dialog_ignoreClick (NoiseNotImportedDialog* self)
{
#line 210 "../src/Dialogs/NotImportedDialog.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/Dialogs/NotImportedDialog.vala"
	NOISE_NOT_IMPORTED_DIALOG_GET_CLASS (self)->ignoreClick (self);
#line 1411 "NotImportedDialog.c"
}


static void
noise_not_imported_dialog_class_init (NoiseNotImportedDialogClass * klass)
{
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	noise_not_imported_dialog_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	g_type_class_adjust_private_offset (klass, &NoiseNotImportedDialog_private_offset);
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	((NoiseNotImportedDialogClass *) klass)->moveToTrashClick = (void (*) (NoiseNotImportedDialog*)) noise_not_imported_dialog_real_moveToTrashClick;
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	((NoiseNotImportedDialogClass *) klass)->ignoreClick = (void (*) (NoiseNotImportedDialog*)) noise_not_imported_dialog_real_ignoreClick;
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_not_imported_dialog_finalize;
#line 1428 "NotImportedDialog.c"
}


static void
noise_not_imported_dialog_instance_init (NoiseNotImportedDialog * self)
{
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	self->priv = noise_not_imported_dialog_get_instance_private (self);
#line 1437 "NotImportedDialog.c"
}


static void
noise_not_imported_dialog_finalize (GObject * obj)
{
	NoiseNotImportedDialog * self;
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_NOT_IMPORTED_DIALOG, NoiseNotImportedDialog);
#line 33 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->_files);
#line 34 "../src/Dialogs/NotImportedDialog.vala"
	_g_free0 (self->priv->music_folder);
#line 36 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->filesModel);
#line 37 "../src/Dialogs/NotImportedDialog.vala"
	_g_object_unref0 (self->priv->moveToTrash);
#line 32 "../src/Dialogs/NotImportedDialog.vala"
	G_OBJECT_CLASS (noise_not_imported_dialog_parent_class)->finalize (obj);
#line 1457 "NotImportedDialog.c"
}


GType
noise_not_imported_dialog_get_type (void)
{
	static volatile gsize noise_not_imported_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&noise_not_imported_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseNotImportedDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_not_imported_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseNotImportedDialog), 0, (GInstanceInitFunc) noise_not_imported_dialog_instance_init, NULL };
		GType noise_not_imported_dialog_type_id;
		noise_not_imported_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "NoiseNotImportedDialog", &g_define_type_info, 0);
		NoiseNotImportedDialog_private_offset = g_type_add_instance_private (noise_not_imported_dialog_type_id, sizeof (NoiseNotImportedDialogPrivate));
		g_once_init_leave (&noise_not_imported_dialog_type_id__volatile, noise_not_imported_dialog_type_id);
	}
	return noise_not_imported_dialog_type_id__volatile;
}



