/* SyncWarningDialog.c generated by valac 0.42.6, the Vala compiler
 * generated from SyncWarningDialog.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_SYNC_WARNING_DIALOG (noise_sync_warning_dialog_get_type ())
#define NOISE_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog))
#define NOISE_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogClass))
#define NOISE_IS_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG))
#define NOISE_IS_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SYNC_WARNING_DIALOG))
#define NOISE_SYNC_WARNING_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogClass))

typedef struct _NoiseSyncWarningDialog NoiseSyncWarningDialog;
typedef struct _NoiseSyncWarningDialogClass NoiseSyncWarningDialogClass;
typedef struct _NoiseSyncWarningDialogPrivate NoiseSyncWarningDialogPrivate;
enum  {
	NOISE_SYNC_WARNING_DIALOG_0_PROPERTY,
	NOISE_SYNC_WARNING_DIALOG_DEVICE_PROPERTY,
	NOISE_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY,
	NOISE_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY,
	NOISE_SYNC_WARNING_DIALOG_NUM_PROPERTIES
};
static GParamSpec* noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_NUM_PROPERTIES];
typedef enum  {
	NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA = 1,
	NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE,
	NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP
} NoiseSyncWarningDialogResponseId;


#define NOISE_SYNC_WARNING_DIALOG_TYPE_RESPONSE_ID (noise_sync_warning_dialog_response_id_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoiseSyncWarningDialog {
	GraniteMessageDialog parent_instance;
	NoiseSyncWarningDialogPrivate * priv;
};

struct _NoiseSyncWarningDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _NoiseSyncWarningDialogPrivate {
	NoiseDevice* _device;
	GeeTreeSet* _to_sync;
	GeeTreeSet* _to_remove;
	GtkWidget* import_media_button;
	GtkWidget* continue_button;
};


static gint NoiseSyncWarningDialog_private_offset;
static gpointer noise_sync_warning_dialog_parent_class = NULL;

GType noise_sync_warning_dialog_get_type (void) G_GNUC_CONST;
GType noise_sync_warning_dialog_response_id_get_type (void) G_GNUC_CONST;
NoiseSyncWarningDialog* noise_sync_warning_dialog_new (NoiseDevice* d,
                                                       GeeTreeSet* to_sync,
                                                       GeeTreeSet* removed);
NoiseSyncWarningDialog* noise_sync_warning_dialog_construct (GType object_type,
                                                             NoiseDevice* d,
                                                             GeeTreeSet* to_sync,
                                                             GeeTreeSet* removed);
void noise_sync_warning_dialog_file_operations_done (NoiseSyncWarningDialog* self);
void noise_sync_warning_dialog_file_operations_started (NoiseSyncWarningDialog* self);
NoiseDevice* noise_sync_warning_dialog_get_device (NoiseSyncWarningDialog* self);
static void noise_sync_warning_dialog_set_device (NoiseSyncWarningDialog* self,
                                           NoiseDevice* value);
GeeTreeSet* noise_sync_warning_dialog_get_to_sync (NoiseSyncWarningDialog* self);
static void noise_sync_warning_dialog_set_to_sync (NoiseSyncWarningDialog* self,
                                            GeeTreeSet* value);
GeeTreeSet* noise_sync_warning_dialog_get_to_remove (NoiseSyncWarningDialog* self);
static void noise_sync_warning_dialog_set_to_remove (NoiseSyncWarningDialog* self,
                                              GeeTreeSet* value);
static GObject * noise_sync_warning_dialog_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
static void noise_sync_warning_dialog_finalize (GObject * obj);
static void _vala_noise_sync_warning_dialog_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_noise_sync_warning_dialog_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);


static inline gpointer
noise_sync_warning_dialog_get_instance_private (NoiseSyncWarningDialog* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSyncWarningDialog_private_offset);
}


GType
noise_sync_warning_dialog_response_id_get_type (void)
{
	static volatile gsize noise_sync_warning_dialog_response_id_type_id__volatile = 0;
	if (g_once_init_enter (&noise_sync_warning_dialog_response_id_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA, "NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA", "import-media"}, {NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE, "NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE", "continue"}, {NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP, "NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP", "stop"}, {0, NULL, NULL}};
		GType noise_sync_warning_dialog_response_id_type_id;
		noise_sync_warning_dialog_response_id_type_id = g_enum_register_static ("NoiseSyncWarningDialogResponseId", values);
		g_once_init_leave (&noise_sync_warning_dialog_response_id_type_id__volatile, noise_sync_warning_dialog_response_id_type_id);
	}
	return noise_sync_warning_dialog_response_id_type_id__volatile;
}


NoiseSyncWarningDialog*
noise_sync_warning_dialog_construct (GType object_type,
                                     NoiseDevice* d,
                                     GeeTreeSet* to_sync,
                                     GeeTreeSet* removed)
{
	NoiseSyncWarningDialog * self = NULL;
#line 71 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 71 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (to_sync != NULL, NULL);
#line 71 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (removed != NULL, NULL);
#line 72 "../src/Dialogs/SyncWarningDialog.vala"
	self = (NoiseSyncWarningDialog*) g_object_new (object_type, "device", d, "to-sync", to_sync, "to-remove", removed, NULL);
#line 71 "../src/Dialogs/SyncWarningDialog.vala"
	return self;
#line 180 "SyncWarningDialog.c"
}


NoiseSyncWarningDialog*
noise_sync_warning_dialog_new (NoiseDevice* d,
                               GeeTreeSet* to_sync,
                               GeeTreeSet* removed)
{
#line 71 "../src/Dialogs/SyncWarningDialog.vala"
	return noise_sync_warning_dialog_construct (NOISE_TYPE_SYNC_WARNING_DIALOG, d, to_sync, removed);
#line 191 "SyncWarningDialog.c"
}


void
noise_sync_warning_dialog_file_operations_done (NoiseSyncWarningDialog* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 75 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->import_media_button;
#line 76 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive (_tmp0_, TRUE);
#line 77 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = self->priv->continue_button;
#line 77 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive (_tmp1_, TRUE);
#line 210 "SyncWarningDialog.c"
}


void
noise_sync_warning_dialog_file_operations_started (NoiseSyncWarningDialog* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 80 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->import_media_button;
#line 81 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive (_tmp0_, FALSE);
#line 82 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = self->priv->continue_button;
#line 82 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive (_tmp1_, FALSE);
#line 229 "SyncWarningDialog.c"
}


NoiseDevice*
noise_sync_warning_dialog_get_device (NoiseSyncWarningDialog* self)
{
	NoiseDevice* result;
	NoiseDevice* _tmp0_;
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->_device;
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	result = _tmp0_;
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	return result;
#line 246 "SyncWarningDialog.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 255 "SyncWarningDialog.c"
}


static void
noise_sync_warning_dialog_set_device (NoiseSyncWarningDialog* self,
                                      NoiseDevice* value)
{
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	if (noise_sync_warning_dialog_get_device (self) != value) {
#line 267 "SyncWarningDialog.c"
		NoiseDevice* _tmp0_;
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
		_g_object_unref0 (self->priv->_device);
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
		self->priv->_device = _tmp0_;
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_DEVICE_PROPERTY]);
#line 277 "SyncWarningDialog.c"
	}
}


GeeTreeSet*
noise_sync_warning_dialog_get_to_sync (NoiseSyncWarningDialog* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->_to_sync;
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	result = _tmp0_;
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	return result;
#line 295 "SyncWarningDialog.c"
}


static void
noise_sync_warning_dialog_set_to_sync (NoiseSyncWarningDialog* self,
                                       GeeTreeSet* value)
{
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	if (noise_sync_warning_dialog_get_to_sync (self) != value) {
#line 307 "SyncWarningDialog.c"
		GeeTreeSet* _tmp0_;
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
		_g_object_unref0 (self->priv->_to_sync);
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
		self->priv->_to_sync = _tmp0_;
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY]);
#line 317 "SyncWarningDialog.c"
	}
}


GeeTreeSet*
noise_sync_warning_dialog_get_to_remove (NoiseSyncWarningDialog* self)
{
	GeeTreeSet* result;
	GeeTreeSet* _tmp0_;
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = self->priv->_to_remove;
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	result = _tmp0_;
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	return result;
#line 335 "SyncWarningDialog.c"
}


static void
noise_sync_warning_dialog_set_to_remove (NoiseSyncWarningDialog* self,
                                         GeeTreeSet* value)
{
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	if (noise_sync_warning_dialog_get_to_remove (self) != value) {
#line 347 "SyncWarningDialog.c"
		GeeTreeSet* _tmp0_;
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
		_g_object_unref0 (self->priv->_to_remove);
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
		self->priv->_to_remove = _tmp0_;
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY]);
#line 357 "SyncWarningDialog.c"
	}
}


static GObject *
noise_sync_warning_dialog_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseSyncWarningDialog * self;
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	GThemedIcon* _tmp2_;
	GThemedIcon* _tmp3_;
	GeeTreeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GeeTreeSet* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	NoiseDevice* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	NoiseDevice* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkWidget* stop_button = NULL;
	GtkWidget* _tmp30_;
	GtkWidget* _tmp31_;
	GtkWidget* _tmp32_;
	GtkWidget* _tmp33_;
	GtkWidget* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkWidget* _tmp36_;
	NoiseLibrariesManager* _tmp37_;
	NoiseLibrary* _tmp38_;
	GtkWidget* _tmp39_;
	NoiseLibrariesManager* _tmp40_;
	NoiseLibrary* _tmp41_;
#line 43 "../src/Dialogs/SyncWarningDialog.vala"
	parent_class = G_OBJECT_CLASS (noise_sync_warning_dialog_parent_class);
#line 43 "../src/Dialogs/SyncWarningDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../src/Dialogs/SyncWarningDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog);
#line 44 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 45 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_destroy_with_parent ((GtkWindow*) self, TRUE);
#line 46 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 47 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 47 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) _tmp1_);
#line 49 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp2_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 49 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp3_ = _tmp2_;
#line 49 "../src/Dialogs/SyncWarningDialog.vala"
	granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp3_);
#line 49 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (_tmp3_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp4_ = self->priv->_to_remove;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp6_ = _tmp5_;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp7_ = self->priv->_to_remove;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp9_ = _tmp8_;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp10_ = self->priv->_device;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp11_ = noise_device_get_display_name (_tmp10_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp12_ = _tmp11_;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp13_ = g_strdup_printf (ngettext ("Sync will remove %i item from %s", "Sync will remove %i items from %s", (gulong) _tmp6_), _tmp9_, _tmp12_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp14_ = _tmp13_;
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	granite_message_dialog_set_primary_text ((GraniteMessageDialog*) self, _tmp14_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp14_);
#line 52 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp12_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp15_ = self->priv->_device;
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp16_ = noise_device_get_display_name (_tmp15_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp17_ = _tmp16_;
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp18_ = g_markup_escape_text (_tmp17_, (gssize) -1);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp19_ = _tmp18_;
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp20_ = g_strconcat ("<b>", _tmp19_, NULL);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp21_ = _tmp20_;
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp22_ = g_strconcat (_tmp21_, "</b>", NULL);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp23_ = _tmp22_;
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp24_ = g_strdup_printf (_ ("If you continue to sync, media will be removed from %s since they are " \
"not on the sync list. Would you like to import them to your library fi" \
"rst?"), _tmp23_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp25_ = _tmp24_;
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp25_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp25_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp23_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp21_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp19_);
#line 55 "../src/Dialogs/SyncWarningDialog.vala"
	_g_free0 (_tmp17_);
#line 57 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp26_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Continue Syncing"), (gint) NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE);
#line 57 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp27_ = _g_object_ref0 (_tmp26_);
#line 57 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->continue_button);
#line 57 "../src/Dialogs/SyncWarningDialog.vala"
	self->priv->continue_button = _tmp27_;
#line 58 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp28_ = self->priv->continue_button;
#line 58 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp29_ = gtk_widget_get_style_context (_tmp28_);
#line 58 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_style_context_add_class (_tmp29_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 60 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp30_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP);
#line 60 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp31_ = _g_object_ref0 (_tmp30_);
#line 60 "../src/Dialogs/SyncWarningDialog.vala"
	stop_button = _tmp31_;
#line 62 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp32_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Import"), (gint) NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA);
#line 62 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp33_ = _g_object_ref0 (_tmp32_);
#line 62 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->import_media_button);
#line 62 "../src/Dialogs/SyncWarningDialog.vala"
	self->priv->import_media_button = _tmp33_;
#line 63 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp34_ = self->priv->import_media_button;
#line 63 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp35_ = gtk_widget_get_style_context (_tmp34_);
#line 63 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_style_context_add_class (_tmp35_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 65 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp36_ = self->priv->import_media_button;
#line 65 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp37_ = noise_libraries_manager;
#line 65 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp38_ = _tmp37_->local_library;
#line 65 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive (_tmp36_, !noise_library_doing_file_operations (_tmp38_));
#line 66 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp39_ = self->priv->continue_button;
#line 66 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp40_ = noise_libraries_manager;
#line 66 "../src/Dialogs/SyncWarningDialog.vala"
	_tmp41_ = _tmp40_->local_library;
#line 66 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_set_sensitive (_tmp39_, !noise_library_doing_file_operations (_tmp41_));
#line 68 "../src/Dialogs/SyncWarningDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 43 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (stop_button);
#line 43 "../src/Dialogs/SyncWarningDialog.vala"
	return obj;
#line 557 "SyncWarningDialog.c"
}


static void
noise_sync_warning_dialog_class_init (NoiseSyncWarningDialogClass * klass)
{
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	noise_sync_warning_dialog_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSyncWarningDialog_private_offset);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_sync_warning_dialog_get_property;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_sync_warning_dialog_set_property;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_sync_warning_dialog_constructor;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_sync_warning_dialog_finalize;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SYNC_WARNING_DIALOG_DEVICE_PROPERTY, noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", NOISE_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY, noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY] = g_param_spec_object ("to-sync", "to-sync", "to-sync", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY, noise_sync_warning_dialog_properties[NOISE_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY] = g_param_spec_object ("to-remove", "to-remove", "to-remove", GEE_TYPE_TREE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 582 "SyncWarningDialog.c"
}


static void
noise_sync_warning_dialog_instance_init (NoiseSyncWarningDialog * self)
{
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	self->priv = noise_sync_warning_dialog_get_instance_private (self);
#line 591 "SyncWarningDialog.c"
}


static void
noise_sync_warning_dialog_finalize (GObject * obj)
{
	NoiseSyncWarningDialog * self;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog);
#line 36 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->_device);
#line 37 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->_to_sync);
#line 38 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->_to_remove);
#line 40 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->import_media_button);
#line 41 "../src/Dialogs/SyncWarningDialog.vala"
	_g_object_unref0 (self->priv->continue_button);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	G_OBJECT_CLASS (noise_sync_warning_dialog_parent_class)->finalize (obj);
#line 613 "SyncWarningDialog.c"
}


GType
noise_sync_warning_dialog_get_type (void)
{
	static volatile gsize noise_sync_warning_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&noise_sync_warning_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSyncWarningDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_sync_warning_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSyncWarningDialog), 0, (GInstanceInitFunc) noise_sync_warning_dialog_instance_init, NULL };
		GType noise_sync_warning_dialog_type_id;
		noise_sync_warning_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "NoiseSyncWarningDialog", &g_define_type_info, 0);
		NoiseSyncWarningDialog_private_offset = g_type_add_instance_private (noise_sync_warning_dialog_type_id, sizeof (NoiseSyncWarningDialogPrivate));
		g_once_init_leave (&noise_sync_warning_dialog_type_id__volatile, noise_sync_warning_dialog_type_id);
	}
	return noise_sync_warning_dialog_type_id__volatile;
}


static void
_vala_noise_sync_warning_dialog_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	NoiseSyncWarningDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	switch (property_id) {
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		case NOISE_SYNC_WARNING_DIALOG_DEVICE_PROPERTY:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		g_value_set_object (value, noise_sync_warning_dialog_get_device (self));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		case NOISE_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		g_value_set_object (value, noise_sync_warning_dialog_get_to_sync (self));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		case NOISE_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		g_value_set_object (value, noise_sync_warning_dialog_get_to_remove (self));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 660 "SyncWarningDialog.c"
		default:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 666 "SyncWarningDialog.c"
	}
}


static void
_vala_noise_sync_warning_dialog_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	NoiseSyncWarningDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
	switch (property_id) {
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		case NOISE_SYNC_WARNING_DIALOG_DEVICE_PROPERTY:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		noise_sync_warning_dialog_set_device (self, g_value_get_object (value));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		case NOISE_SYNC_WARNING_DIALOG_TO_SYNC_PROPERTY:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		noise_sync_warning_dialog_set_to_sync (self, g_value_get_object (value));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		case NOISE_SYNC_WARNING_DIALOG_TO_REMOVE_PROPERTY:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		noise_sync_warning_dialog_set_to_remove (self, g_value_get_object (value));
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 699 "SyncWarningDialog.c"
		default:
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Dialogs/SyncWarningDialog.vala"
		break;
#line 705 "SyncWarningDialog.c"
	}
}



