/* ViewInterface.c generated by valac 0.42.6, the Vala compiler
 * generated from ViewInterface.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"


#define NOISE_TYPE_VIEW_INTERFACE (noise_view_interface_get_type ())
#define NOISE_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterface))
#define NOISE_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_INTERFACE))
#define NOISE_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterfaceIface))

typedef struct _NoiseViewInterface NoiseViewInterface;
typedef struct _NoiseViewInterfaceIface NoiseViewInterfaceIface;
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
enum  {
	NOISE_VIEW_INTERFACE_IMPORT_REQUESTED_SIGNAL,
	NOISE_VIEW_INTERFACE_NUM_SIGNALS
};
static guint noise_view_interface_signals[NOISE_VIEW_INTERFACE_NUM_SIGNALS] = {0};

struct _NoiseViewInterfaceIface {
	GTypeInterface parent_iface;
	NoiseViewWrapperHint (*get_hint) (NoiseViewInterface* self);
	GeeCollection* (*get_media) (NoiseViewInterface* self);
	GeeCollection* (*get_visible_media) (NoiseViewInterface* self);
	void (*refilter) (NoiseViewInterface* self);
	void (*set_media) (NoiseViewInterface* self, GeeCollection* new_media);
	void (*add_media) (NoiseViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (NoiseViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (NoiseViewInterface* self, GeeCollection* to_update);
};



GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
GType noise_view_interface_get_type (void) G_GNUC_CONST;
NoiseViewWrapperHint noise_view_interface_get_hint (NoiseViewInterface* self);
GeeCollection* noise_view_interface_get_media (NoiseViewInterface* self);
GeeCollection* noise_view_interface_get_visible_media (NoiseViewInterface* self);
void noise_view_interface_refilter (NoiseViewInterface* self);
void noise_view_interface_set_media (NoiseViewInterface* self,
                                     GeeCollection* new_media);
void noise_view_interface_add_media (NoiseViewInterface* self,
                                     GeeCollection* to_add);
void noise_view_interface_remove_media (NoiseViewInterface* self,
                                        GeeCollection* to_remove);
void noise_view_interface_update_media (NoiseViewInterface* self,
                                        GeeCollection* to_update);


NoiseViewWrapperHint
noise_view_interface_get_hint (NoiseViewInterface* self)
{
#line 36 "../src/Interfaces/ViewInterface.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/Interfaces/ViewInterface.vala"
	return NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->get_hint (self);
#line 110 "ViewInterface.c"
}


/**
     * For some views, get_media() and get_visible_media() return the same contents, since
     * the view doesn't have any kind of built-in filters. For other views, they don't return
     * the same since the view has some kind of internal browsing mechanism (e.g. Miller Columns).
     */
GeeCollection*
noise_view_interface_get_media (NoiseViewInterface* self)
{
#line 43 "../src/Interfaces/ViewInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/Interfaces/ViewInterface.vala"
	return NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->get_media (self);
#line 126 "ViewInterface.c"
}


GeeCollection*
noise_view_interface_get_visible_media (NoiseViewInterface* self)
{
#line 44 "../src/Interfaces/ViewInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/Interfaces/ViewInterface.vala"
	return NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->get_visible_media (self);
#line 137 "ViewInterface.c"
}


/**
     * Requests the view to apply a filter to only show the media matching the
     * search string.
     *
     * @param search Search string; pass null to use the previous search string.
     */
void
noise_view_interface_refilter (NoiseViewInterface* self)
{
#line 52 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Interfaces/ViewInterface.vala"
	NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->refilter (self);
#line 154 "ViewInterface.c"
}


void
noise_view_interface_set_media (NoiseViewInterface* self,
                                GeeCollection* new_media)
{
#line 54 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Interfaces/ViewInterface.vala"
	NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->set_media (self, new_media);
#line 166 "ViewInterface.c"
}


void
noise_view_interface_add_media (NoiseViewInterface* self,
                                GeeCollection* to_add)
{
#line 55 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Interfaces/ViewInterface.vala"
	NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->add_media (self, to_add);
#line 178 "ViewInterface.c"
}


void
noise_view_interface_remove_media (NoiseViewInterface* self,
                                   GeeCollection* to_remove)
{
#line 56 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Interfaces/ViewInterface.vala"
	NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->remove_media (self, to_remove);
#line 190 "ViewInterface.c"
}


void
noise_view_interface_update_media (NoiseViewInterface* self,
                                   GeeCollection* to_update)
{
#line 57 "../src/Interfaces/ViewInterface.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Interfaces/ViewInterface.vala"
	NOISE_VIEW_INTERFACE_GET_INTERFACE (self)->update_media (self, to_update);
#line 202 "ViewInterface.c"
}


static void
noise_view_interface_default_init (NoiseViewInterfaceIface * iface)
{
	/**
	     * Used for device syncing.
	     */
#line 30 "../src/Interfaces/ViewInterface.vala"
	noise_view_interface_signals[NOISE_VIEW_INTERFACE_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", NOISE_TYPE_VIEW_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 214 "ViewInterface.c"
}


GType
noise_view_interface_get_type (void)
{
	static volatile gsize noise_view_interface_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseViewInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_view_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_view_interface_type_id;
		noise_view_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseViewInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_view_interface_type_id, gtk_widget_get_type ());
		g_once_init_leave (&noise_view_interface_type_id__volatile, noise_view_interface_type_id);
	}
	return noise_view_interface_type_id__volatile;
}



