/* DevicePreferences.c generated by valac 0.42.6, the Vala compiler
 * generated from DevicePreferences.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libgda/libgda.h>
#include "io.elementary.music-core.h"


#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;
typedef struct _NoiseDevicePreferencesPrivate NoiseDevicePreferencesPrivate;
enum  {
	NOISE_DEVICE_PREFERENCES_0_PROPERTY,
	NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY,
	NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY,
	NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY,
	NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY,
	NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY,
	NOISE_DEVICE_PREFERENCES_NUM_PROPERTIES
};
static GParamSpec* noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _NoiseDevicePreferences {
	GObject parent_instance;
	NoiseDevicePreferencesPrivate * priv;
	gboolean* _sync_when_mounted;
	guint* _last_sync_time;
	gboolean* _sync_music;
	gboolean* _sync_all_music;
};

struct _NoiseDevicePreferencesClass {
	GObjectClass parent_class;
};

struct _NoiseDevicePreferencesPrivate {
	gchar* id;
	GdaConnection* connection;
};


static gint NoiseDevicePreferences_private_offset;
static gpointer noise_device_preferences_parent_class = NULL;

GType noise_device_preferences_get_type (void) G_GNUC_CONST;
NoiseDevicePreferences* noise_device_preferences_new (NoiseDevice* device,
                                                      GdaConnection* connection);
NoiseDevicePreferences* noise_device_preferences_construct (GType object_type,
                                                            NoiseDevice* device,
                                                            GdaConnection* connection);
static GValue* noise_device_preferences_query_field (NoiseDevicePreferences* self,
                                              const gchar* field);
static void _vala_GValue_free (GValue* self);
#define NOISE_DATABASE_DEVICES_TABLE_NAME "devices"
static guint noise_device_preferences_common_uint_getter (NoiseDevicePreferences* self,
                                                   const gchar* field,
                                                   guint** temp);
static guint* _uint_dup (guint* self);
static void noise_device_preferences_common_uint_setter (NoiseDevicePreferences* self,
                                                  const gchar* field,
                                                  guint value,
                                                  guint** temp);
static void noise_device_preferences_set_field (NoiseDevicePreferences* self,
                                         const gchar* field,
                                         GValue* value);
static gboolean noise_device_preferences_common_bool_getter (NoiseDevicePreferences* self,
                                                      const gchar* field,
                                                      gboolean** temp);
static gboolean* _bool_dup (gboolean* self);
static void noise_device_preferences_common_bool_setter (NoiseDevicePreferences* self,
                                                  const gchar* field,
                                                  gboolean value,
                                                  gboolean** temp);
static GValue* _g_value_dup (GValue* self);
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self,
                                                     gboolean value);
guint noise_device_preferences_get_last_sync_time (NoiseDevicePreferences* self);
void noise_device_preferences_set_last_sync_time (NoiseDevicePreferences* self,
                                                  guint value);
gboolean noise_device_preferences_get_sync_music (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_music (NoiseDevicePreferences* self,
                                              gboolean value);
gboolean noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self);
void noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self,
                                                  gboolean value);
NoisePlaylist* noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self);
void noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self,
                                                  NoisePlaylist* value);
static void noise_device_preferences_finalize (GObject * obj);
static void _vala_noise_device_preferences_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_noise_device_preferences_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);


static inline gpointer
noise_device_preferences_get_instance_private (NoiseDevicePreferences* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseDevicePreferences_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/LocalBackend/DevicePreferences.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "DevicePreferences.c"
}


static void
_vala_GValue_free (GValue* self)
{
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	g_value_unset (self);
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	g_free (self);
#line 174 "DevicePreferences.c"
}


NoiseDevicePreferences*
noise_device_preferences_construct (GType object_type,
                                    NoiseDevice* device,
                                    GdaConnection* connection)
{
	NoiseDevicePreferences * self = NULL;
	gchar* _tmp0_;
	GdaConnection* _tmp1_;
	GValue* _tmp2_;
	GValue* _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_ = NULL;
#line 111 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 111 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 111 "../src/LocalBackend/DevicePreferences.vala"
	self = (NoiseDevicePreferences*) g_object_new (object_type, NULL);
#line 112 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = noise_device_get_unique_identifier (device);
#line 112 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (self->priv->id);
#line 112 "../src/LocalBackend/DevicePreferences.vala"
	self->priv->id = _tmp0_;
#line 113 "../src/LocalBackend/DevicePreferences.vala"
	_tmp1_ = _g_object_ref0 (connection);
#line 113 "../src/LocalBackend/DevicePreferences.vala"
	_g_object_unref0 (self->priv->connection);
#line 113 "../src/LocalBackend/DevicePreferences.vala"
	self->priv->connection = _tmp1_;
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	_tmp2_ = noise_device_preferences_query_field (self, "sync_music");
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	_tmp3_ = _tmp2_;
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	__vala_GValue_free0 (_tmp3_);
#line 114 "../src/LocalBackend/DevicePreferences.vala"
	if (_tmp4_) {
#line 218 "DevicePreferences.c"
		{
			GdaSqlBuilder* builder = NULL;
			GdaSqlBuilder* _tmp5_;
			GdaSqlBuilder* _tmp6_;
			GdaSqlBuilder* _tmp7_;
			const gchar* _tmp8_;
			GValue* _tmp9_ = NULL;
			GdaStatement* _tmp10_ = NULL;
			GdaSqlBuilder* _tmp11_;
			GdaStatement* _tmp12_;
#line 116 "../src/LocalBackend/DevicePreferences.vala"
			_tmp5_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
#line 116 "../src/LocalBackend/DevicePreferences.vala"
			builder = _tmp5_;
#line 117 "../src/LocalBackend/DevicePreferences.vala"
			_tmp6_ = builder;
#line 117 "../src/LocalBackend/DevicePreferences.vala"
			gda_sql_builder_set_table (_tmp6_, NOISE_DATABASE_DEVICES_TABLE_NAME);
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			_tmp7_ = builder;
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			_tmp8_ = self->priv->id;
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			_tmp9_ = g_new0 (GValue, 1);
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			g_value_init (_tmp9_, G_TYPE_STRING);
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			g_value_set_string (_tmp9_, _tmp8_);
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			gda_sql_builder_add_field_value_as_gvalue (_tmp7_, "unique_id", _tmp9_);
#line 118 "../src/LocalBackend/DevicePreferences.vala"
			__vala_GValue_free0 (_tmp9_);
#line 119 "../src/LocalBackend/DevicePreferences.vala"
			_tmp11_ = builder;
#line 119 "../src/LocalBackend/DevicePreferences.vala"
			_tmp12_ = gda_sql_builder_get_statement (_tmp11_, &_inner_error0_);
#line 119 "../src/LocalBackend/DevicePreferences.vala"
			_tmp10_ = _tmp12_;
#line 119 "../src/LocalBackend/DevicePreferences.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../src/LocalBackend/DevicePreferences.vala"
				_g_object_unref0 (builder);
#line 261 "DevicePreferences.c"
				goto __catch32_g_error;
			}
#line 119 "../src/LocalBackend/DevicePreferences.vala"
			gda_connection_statement_execute_non_select (connection, _tmp10_, NULL, NULL, &_inner_error0_);
#line 119 "../src/LocalBackend/DevicePreferences.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../src/LocalBackend/DevicePreferences.vala"
				_g_object_unref0 (_tmp10_);
#line 119 "../src/LocalBackend/DevicePreferences.vala"
				_g_object_unref0 (builder);
#line 272 "DevicePreferences.c"
				goto __catch32_g_error;
			}
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (_tmp10_);
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (builder);
#line 279 "DevicePreferences.c"
		}
		goto __finally32;
		__catch32_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			e = _inner_error0_;
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			_inner_error0_ = NULL;
#line 121 "../src/LocalBackend/DevicePreferences.vala"
			_tmp13_ = e;
#line 121 "../src/LocalBackend/DevicePreferences.vala"
			_tmp14_ = _tmp13_->message;
#line 121 "../src/LocalBackend/DevicePreferences.vala"
			g_warning ("DevicePreferences.vala:121: Could not save media: %s", _tmp14_);
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			_g_error_free0 (e);
#line 299 "DevicePreferences.c"
		}
		__finally32:
#line 115 "../src/LocalBackend/DevicePreferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			g_clear_error (&_inner_error0_);
#line 115 "../src/LocalBackend/DevicePreferences.vala"
			return NULL;
#line 310 "DevicePreferences.c"
		}
	}
#line 111 "../src/LocalBackend/DevicePreferences.vala"
	return self;
#line 315 "DevicePreferences.c"
}


NoiseDevicePreferences*
noise_device_preferences_new (NoiseDevice* device,
                              GdaConnection* connection)
{
#line 111 "../src/LocalBackend/DevicePreferences.vala"
	return noise_device_preferences_construct (NOISE_TYPE_DEVICE_PREFERENCES, device, connection);
#line 325 "DevicePreferences.c"
}


static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 132 "../src/LocalBackend/DevicePreferences.vala"
	dup = g_new0 (guint, 1);
#line 132 "../src/LocalBackend/DevicePreferences.vala"
	memcpy (dup, self, sizeof (guint));
#line 132 "../src/LocalBackend/DevicePreferences.vala"
	return dup;
#line 339 "DevicePreferences.c"
}


static gpointer
__uint_dup0 (gpointer self)
{
#line 132 "../src/LocalBackend/DevicePreferences.vala"
	return self ? _uint_dup (self) : NULL;
#line 348 "DevicePreferences.c"
}


static guint
noise_device_preferences_common_uint_getter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             guint** temp)
{
	guint result = 0U;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	GValue* _tmp4_;
	guint _tmp5_;
	guint* _tmp6_;
#line 126 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 126 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (field != NULL, 0U);
#line 127 "../src/LocalBackend/DevicePreferences.vala"
	if ((*temp) != NULL) {
#line 128 "../src/LocalBackend/DevicePreferences.vala"
		result = *(*temp);
#line 128 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 374 "DevicePreferences.c"
	}
#line 130 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = noise_device_preferences_query_field (self, field);
#line 130 "../src/LocalBackend/DevicePreferences.vala"
	_result_ = _tmp0_;
#line 131 "../src/LocalBackend/DevicePreferences.vala"
	_tmp1_ = _result_;
#line 131 "../src/LocalBackend/DevicePreferences.vala"
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
#line 384 "DevicePreferences.c"
		guint _tmp2_;
		guint* _tmp3_;
#line 132 "../src/LocalBackend/DevicePreferences.vala"
		_tmp2_ = (guint) 0;
#line 132 "../src/LocalBackend/DevicePreferences.vala"
		_tmp3_ = __uint_dup0 (&_tmp2_);
#line 132 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (*temp);
#line 132 "../src/LocalBackend/DevicePreferences.vala"
		*temp = _tmp3_;
#line 133 "../src/LocalBackend/DevicePreferences.vala"
		result = *(*temp);
#line 133 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_result_);
#line 133 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 401 "DevicePreferences.c"
	}
#line 136 "../src/LocalBackend/DevicePreferences.vala"
	_tmp4_ = _result_;
#line 136 "../src/LocalBackend/DevicePreferences.vala"
	_tmp5_ = (guint) g_value_get_int (_tmp4_);
#line 136 "../src/LocalBackend/DevicePreferences.vala"
	_tmp6_ = __uint_dup0 (&_tmp5_);
#line 136 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (*temp);
#line 136 "../src/LocalBackend/DevicePreferences.vala"
	*temp = _tmp6_;
#line 137 "../src/LocalBackend/DevicePreferences.vala"
	result = *(*temp);
#line 137 "../src/LocalBackend/DevicePreferences.vala"
	__vala_GValue_free0 (_result_);
#line 137 "../src/LocalBackend/DevicePreferences.vala"
	return result;
#line 419 "DevicePreferences.c"
}


static void
noise_device_preferences_common_uint_setter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             guint value,
                                             guint** temp)
{
	guint* _tmp0_;
	GValue _tmp1_ = {0};
#line 140 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (field != NULL);
#line 141 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = __uint_dup0 (&value);
#line 141 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (*temp);
#line 141 "../src/LocalBackend/DevicePreferences.vala"
	*temp = _tmp0_;
#line 142 "../src/LocalBackend/DevicePreferences.vala"
	g_value_init (&_tmp1_, G_TYPE_UINT);
#line 142 "../src/LocalBackend/DevicePreferences.vala"
	g_value_set_uint (&_tmp1_, value);
#line 142 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_set_field (self, field, &_tmp1_);
#line 142 "../src/LocalBackend/DevicePreferences.vala"
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
#line 449 "DevicePreferences.c"
}


static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 151 "../src/LocalBackend/DevicePreferences.vala"
	dup = g_new0 (gboolean, 1);
#line 151 "../src/LocalBackend/DevicePreferences.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 151 "../src/LocalBackend/DevicePreferences.vala"
	return dup;
#line 463 "DevicePreferences.c"
}


static gpointer
__bool_dup0 (gpointer self)
{
#line 151 "../src/LocalBackend/DevicePreferences.vala"
	return self ? _bool_dup (self) : NULL;
#line 472 "DevicePreferences.c"
}


static gboolean
noise_device_preferences_common_bool_getter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             gboolean** temp)
{
	gboolean result = FALSE;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	GValue* _tmp4_;
	gboolean _tmp5_;
	gboolean* _tmp6_;
#line 145 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (field != NULL, FALSE);
#line 146 "../src/LocalBackend/DevicePreferences.vala"
	if ((*temp) != NULL) {
#line 147 "../src/LocalBackend/DevicePreferences.vala"
		result = *(*temp);
#line 147 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 498 "DevicePreferences.c"
	}
#line 149 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = noise_device_preferences_query_field (self, field);
#line 149 "../src/LocalBackend/DevicePreferences.vala"
	_result_ = _tmp0_;
#line 150 "../src/LocalBackend/DevicePreferences.vala"
	_tmp1_ = _result_;
#line 150 "../src/LocalBackend/DevicePreferences.vala"
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
#line 508 "DevicePreferences.c"
		gboolean _tmp2_;
		gboolean* _tmp3_;
#line 151 "../src/LocalBackend/DevicePreferences.vala"
		_tmp2_ = FALSE;
#line 151 "../src/LocalBackend/DevicePreferences.vala"
		_tmp3_ = __bool_dup0 (&_tmp2_);
#line 151 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (*temp);
#line 151 "../src/LocalBackend/DevicePreferences.vala"
		*temp = _tmp3_;
#line 152 "../src/LocalBackend/DevicePreferences.vala"
		result = *(*temp);
#line 152 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_result_);
#line 152 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 525 "DevicePreferences.c"
	}
#line 155 "../src/LocalBackend/DevicePreferences.vala"
	_tmp4_ = _result_;
#line 155 "../src/LocalBackend/DevicePreferences.vala"
	_tmp5_ = g_value_get_int (_tmp4_) == 1;
#line 155 "../src/LocalBackend/DevicePreferences.vala"
	_tmp6_ = __bool_dup0 (&_tmp5_);
#line 155 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (*temp);
#line 155 "../src/LocalBackend/DevicePreferences.vala"
	*temp = _tmp6_;
#line 156 "../src/LocalBackend/DevicePreferences.vala"
	result = *(*temp);
#line 156 "../src/LocalBackend/DevicePreferences.vala"
	__vala_GValue_free0 (_result_);
#line 156 "../src/LocalBackend/DevicePreferences.vala"
	return result;
#line 543 "DevicePreferences.c"
}


static void
noise_device_preferences_common_bool_setter (NoiseDevicePreferences* self,
                                             const gchar* field,
                                             gboolean value,
                                             gboolean** temp)
{
	gboolean* _tmp0_;
	GValue _tmp1_ = {0};
#line 159 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (field != NULL);
#line 160 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = __bool_dup0 (&value);
#line 160 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (*temp);
#line 160 "../src/LocalBackend/DevicePreferences.vala"
	*temp = _tmp0_;
#line 161 "../src/LocalBackend/DevicePreferences.vala"
	g_value_init (&_tmp1_, G_TYPE_BOOLEAN);
#line 161 "../src/LocalBackend/DevicePreferences.vala"
	g_value_set_boolean (&_tmp1_, value);
#line 161 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_set_field (self, field, &_tmp1_);
#line 161 "../src/LocalBackend/DevicePreferences.vala"
	G_IS_VALUE (&_tmp1_) ? (g_value_unset (&_tmp1_), NULL) : NULL;
#line 573 "DevicePreferences.c"
}


static GValue*
_g_value_dup (GValue* self)
{
#line 174 "../src/LocalBackend/DevicePreferences.vala"
	return g_boxed_copy (G_TYPE_VALUE, self);
#line 582 "DevicePreferences.c"
}


static gpointer
__g_value_dup0 (gpointer self)
{
#line 174 "../src/LocalBackend/DevicePreferences.vala"
	return self ? _g_value_dup (self) : NULL;
#line 591 "DevicePreferences.c"
}


static GValue*
noise_device_preferences_query_field (NoiseDevicePreferences* self,
                                      const gchar* field)
{
	GValue* result = NULL;
	GError* _inner_error0_ = NULL;
#line 164 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (field != NULL, NULL);
#line 605 "DevicePreferences.c"
	{
		GdaSqlBuilder* sql = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		GdaSqlBuilder* _tmp3_;
		GdaSqlBuilderId id_field = 0U;
		GdaSqlBuilder* _tmp4_;
		GdaSqlBuilderId id_param = 0U;
		GdaSqlBuilder* _tmp5_;
		const gchar* _tmp6_;
		GValue* _tmp7_ = NULL;
		GdaSqlBuilderId _tmp8_;
		GdaSqlBuilderId id_cond = 0U;
		GdaSqlBuilder* _tmp9_;
		GdaSqlBuilderId _tmp10_;
		GdaSqlBuilderId _tmp11_;
		GdaSqlBuilder* _tmp12_;
		GdaSqlBuilderId _tmp13_;
		GdaStatement* _tmp14_ = NULL;
		GdaSqlBuilder* _tmp15_;
		GdaStatement* _tmp16_;
		GdaDataModel* data_model = NULL;
		GdaConnection* _tmp17_;
		GdaDataModel* _tmp18_;
		GValue* _tmp19_ = NULL;
		GdaDataModel* _tmp20_;
		GdaDataModel* _tmp21_;
		GValue* _tmp22_;
#line 166 "../src/LocalBackend/DevicePreferences.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_SELECT);
#line 166 "../src/LocalBackend/DevicePreferences.vala"
		sql = _tmp0_;
#line 167 "../src/LocalBackend/DevicePreferences.vala"
		_tmp1_ = sql;
#line 167 "../src/LocalBackend/DevicePreferences.vala"
		gda_sql_builder_select_add_target (_tmp1_, NOISE_DATABASE_DEVICES_TABLE_NAME, NULL);
#line 168 "../src/LocalBackend/DevicePreferences.vala"
		_tmp2_ = sql;
#line 168 "../src/LocalBackend/DevicePreferences.vala"
		_tmp3_ = sql;
#line 168 "../src/LocalBackend/DevicePreferences.vala"
		gda_sql_builder_add_field_value_id (_tmp2_, gda_sql_builder_add_id (_tmp3_, field), (GdaSqlBuilderId) 0);
#line 169 "../src/LocalBackend/DevicePreferences.vala"
		_tmp4_ = sql;
#line 169 "../src/LocalBackend/DevicePreferences.vala"
		id_field = gda_sql_builder_add_id (_tmp4_, "unique_id");
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		_tmp5_ = sql;
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		_tmp6_ = self->priv->id;
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		_tmp7_ = g_new0 (GValue, 1);
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		g_value_init (_tmp7_, G_TYPE_STRING);
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		g_value_set_string (_tmp7_, _tmp6_);
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		_tmp8_ = gda_sql_builder_add_expr_value (_tmp5_, NULL, _tmp7_);
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_tmp7_);
#line 170 "../src/LocalBackend/DevicePreferences.vala"
		id_param = _tmp8_;
#line 171 "../src/LocalBackend/DevicePreferences.vala"
		_tmp9_ = sql;
#line 171 "../src/LocalBackend/DevicePreferences.vala"
		_tmp10_ = id_field;
#line 171 "../src/LocalBackend/DevicePreferences.vala"
		_tmp11_ = id_param;
#line 171 "../src/LocalBackend/DevicePreferences.vala"
		id_cond = gda_sql_builder_add_cond (_tmp9_, GDA_SQL_OPERATOR_TYPE_EQ, _tmp10_, _tmp11_, (GdaSqlBuilderId) 0);
#line 172 "../src/LocalBackend/DevicePreferences.vala"
		_tmp12_ = sql;
#line 172 "../src/LocalBackend/DevicePreferences.vala"
		_tmp13_ = id_cond;
#line 172 "../src/LocalBackend/DevicePreferences.vala"
		gda_sql_builder_set_where (_tmp12_, _tmp13_);
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		_tmp15_ = sql;
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		_tmp16_ = gda_sql_builder_get_statement (_tmp15_, &_inner_error0_);
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		_tmp14_ = _tmp16_;
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (sql);
#line 693 "DevicePreferences.c"
			goto __catch33_g_error;
		}
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		_tmp17_ = self->priv->connection;
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		_tmp18_ = gda_connection_statement_execute_select (_tmp17_, _tmp14_, NULL, &_inner_error0_);
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		data_model = _tmp18_;
#line 173 "../src/LocalBackend/DevicePreferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (_tmp14_);
#line 173 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (sql);
#line 708 "DevicePreferences.c"
			goto __catch33_g_error;
		}
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_tmp20_ = data_model;
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_tmp21_ = data_model;
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_tmp19_ = gda_data_model_get_value_at (_tmp20_, gda_data_model_get_column_index (_tmp21_, field), 0, &_inner_error0_);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (data_model);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (_tmp14_);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
			_g_object_unref0 (sql);
#line 725 "DevicePreferences.c"
			goto __catch33_g_error;
		}
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_tmp22_ = __g_value_dup0 (_tmp19_);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		result = _tmp22_;
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_g_object_unref0 (data_model);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_g_object_unref0 (_tmp14_);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		_g_object_unref0 (sql);
#line 174 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 740 "DevicePreferences.c"
	}
	goto __finally33;
	__catch33_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 165 "../src/LocalBackend/DevicePreferences.vala"
		e = _inner_error0_;
#line 165 "../src/LocalBackend/DevicePreferences.vala"
		_inner_error0_ = NULL;
#line 176 "../src/LocalBackend/DevicePreferences.vala"
		_tmp23_ = e;
#line 176 "../src/LocalBackend/DevicePreferences.vala"
		_tmp24_ = _tmp23_->message;
#line 176 "../src/LocalBackend/DevicePreferences.vala"
		g_critical ("DevicePreferences.vala:176: Could not query field %s: %s", field, _tmp24_);
#line 177 "../src/LocalBackend/DevicePreferences.vala"
		result = NULL;
#line 177 "../src/LocalBackend/DevicePreferences.vala"
		_g_error_free0 (e);
#line 177 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 764 "DevicePreferences.c"
	}
	__finally33:
#line 165 "../src/LocalBackend/DevicePreferences.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/LocalBackend/DevicePreferences.vala"
	g_clear_error (&_inner_error0_);
#line 165 "../src/LocalBackend/DevicePreferences.vala"
	return NULL;
#line 773 "DevicePreferences.c"
}


static void
__vala_GValue_free0_ (gpointer var)
{
#line 187 "../src/LocalBackend/DevicePreferences.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 782 "DevicePreferences.c"
}


static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 187 "../src/LocalBackend/DevicePreferences.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 791 "DevicePreferences.c"
}


static void
_g_free0_ (gpointer var)
{
#line 187 "../src/LocalBackend/DevicePreferences.vala"
	var = (g_free (var), NULL);
#line 800 "DevicePreferences.c"
}


static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 187 "../src/LocalBackend/DevicePreferences.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 809 "DevicePreferences.c"
}


static void
noise_device_preferences_set_field (NoiseDevicePreferences* self,
                                    const gchar* field,
                                    GValue* value)
{
	GError* _inner_error0_ = NULL;
#line 181 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (field != NULL);
#line 181 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (value != NULL);
#line 825 "DevicePreferences.c"
	{
		GSList* col_names = NULL;
		gchar* _tmp0_;
		GSList* values = NULL;
		GValue _tmp1_;
		GValue _tmp2_;
		GValue* _tmp3_;
		GdaConnection* _tmp4_;
		const gchar* _tmp5_;
		GValue _tmp6_ = {0};
#line 183 "../src/LocalBackend/DevicePreferences.vala"
		col_names = NULL;
#line 184 "../src/LocalBackend/DevicePreferences.vala"
		_tmp0_ = g_strdup (field);
#line 184 "../src/LocalBackend/DevicePreferences.vala"
		col_names = g_slist_append (col_names, _tmp0_);
#line 185 "../src/LocalBackend/DevicePreferences.vala"
		values = NULL;
#line 186 "../src/LocalBackend/DevicePreferences.vala"
		_tmp1_ = *value;
#line 186 "../src/LocalBackend/DevicePreferences.vala"
		_tmp2_ = _tmp1_;
#line 186 "../src/LocalBackend/DevicePreferences.vala"
		_tmp3_ = __g_value_dup0 (&_tmp2_);
#line 186 "../src/LocalBackend/DevicePreferences.vala"
		values = g_slist_append (values, _tmp3_);
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		_tmp4_ = self->priv->connection;
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		_tmp5_ = self->priv->id;
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		g_value_init (&_tmp6_, G_TYPE_STRING);
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		g_value_set_string (&_tmp6_, _tmp5_);
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		gda_connection_update_row_in_table_v (_tmp4_, NOISE_DATABASE_DEVICES_TABLE_NAME, "unique_id", &_tmp6_, col_names, values, &_inner_error0_);
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
#line 187 "../src/LocalBackend/DevicePreferences.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "../src/LocalBackend/DevicePreferences.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 187 "../src/LocalBackend/DevicePreferences.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 870 "DevicePreferences.c"
			goto __catch34_g_error;
		}
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 877 "DevicePreferences.c"
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		e = _inner_error0_;
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		_inner_error0_ = NULL;
#line 189 "../src/LocalBackend/DevicePreferences.vala"
		_tmp7_ = e;
#line 189 "../src/LocalBackend/DevicePreferences.vala"
		_tmp8_ = _tmp7_->message;
#line 189 "../src/LocalBackend/DevicePreferences.vala"
		g_critical ("DevicePreferences.vala:189: Could not set field %s: %s", field, _tmp8_);
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		_g_error_free0 (e);
#line 897 "DevicePreferences.c"
	}
	__finally34:
#line 182 "../src/LocalBackend/DevicePreferences.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		g_clear_error (&_inner_error0_);
#line 182 "../src/LocalBackend/DevicePreferences.vala"
		return;
#line 908 "DevicePreferences.c"
	}
}


gboolean
noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
#line 35 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_bool_getter (self, "sync_when_mounted", &self->_sync_when_mounted);
#line 37 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = self->_sync_when_mounted;
#line 37 "../src/LocalBackend/DevicePreferences.vala"
	result = *_tmp0_;
#line 37 "../src/LocalBackend/DevicePreferences.vala"
	return result;
#line 928 "DevicePreferences.c"
}


void
noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self,
                                                gboolean value)
{
#line 39 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_bool_setter (self, "sync_when_mounted", value, &self->_sync_when_mounted);
#line 39 "../src/LocalBackend/DevicePreferences.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY]);
#line 942 "DevicePreferences.c"
}


guint
noise_device_preferences_get_last_sync_time (NoiseDevicePreferences* self)
{
	guint result;
	guint* _tmp0_;
#line 46 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 47 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_uint_getter (self, "last_sync_time", &self->_last_sync_time);
#line 48 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = self->_last_sync_time;
#line 48 "../src/LocalBackend/DevicePreferences.vala"
	result = *_tmp0_;
#line 48 "../src/LocalBackend/DevicePreferences.vala"
	return result;
#line 961 "DevicePreferences.c"
}


void
noise_device_preferences_set_last_sync_time (NoiseDevicePreferences* self,
                                             guint value)
{
#line 50 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_uint_setter (self, "last_sync_time", value, &self->_last_sync_time);
#line 50 "../src/LocalBackend/DevicePreferences.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY]);
#line 975 "DevicePreferences.c"
}


gboolean
noise_device_preferences_get_sync_music (NoiseDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
#line 57 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_bool_getter (self, "sync_music", &self->_sync_music);
#line 59 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = self->_sync_music;
#line 59 "../src/LocalBackend/DevicePreferences.vala"
	result = *_tmp0_;
#line 59 "../src/LocalBackend/DevicePreferences.vala"
	return result;
#line 994 "DevicePreferences.c"
}


void
noise_device_preferences_set_sync_music (NoiseDevicePreferences* self,
                                         gboolean value)
{
#line 61 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_bool_setter (self, "sync_music", value, &self->_sync_music);
#line 61 "../src/LocalBackend/DevicePreferences.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY]);
#line 1008 "DevicePreferences.c"
}


gboolean
noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self)
{
	gboolean result;
	gboolean* _tmp0_;
#line 68 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_bool_getter (self, "sync_all_music", &self->_sync_all_music);
#line 70 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = self->_sync_all_music;
#line 70 "../src/LocalBackend/DevicePreferences.vala"
	result = *_tmp0_;
#line 70 "../src/LocalBackend/DevicePreferences.vala"
	return result;
#line 1027 "DevicePreferences.c"
}


void
noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self,
                                             gboolean value)
{
#line 72 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_common_bool_setter (self, "sync_all_music", value, &self->_sync_all_music);
#line 72 "../src/LocalBackend/DevicePreferences.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY]);
#line 1041 "DevicePreferences.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 1061 "DevicePreferences.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1084 "DevicePreferences.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1088 "DevicePreferences.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1094 "DevicePreferences.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1098 "DevicePreferences.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1102 "DevicePreferences.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 1110 "DevicePreferences.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1138 "DevicePreferences.c"
				goto __catch35_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 1147 "DevicePreferences.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1161 "DevicePreferences.c"
				goto __catch35_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 1172 "DevicePreferences.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 1186 "DevicePreferences.c"
	}
	goto __finally35;
	__catch35_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1200 "DevicePreferences.c"
	}
	__finally35:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 1211 "DevicePreferences.c"
	}
}


static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
#line 722 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 723 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, (guint) 0);
#line 723 "glib-2.0.vapi"
	return result;
#line 1226 "DevicePreferences.c"
}


NoisePlaylist*
noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self)
{
	NoisePlaylist* result;
	GValue* _result_ = NULL;
	GValue* _tmp0_;
	GValue* _tmp1_;
	gchar* playlist_string = NULL;
	GValue* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	const gchar* _tmp8_;
#line 78 "../src/LocalBackend/DevicePreferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = noise_device_preferences_query_field (self, "music_playlist");
#line 79 "../src/LocalBackend/DevicePreferences.vala"
	_result_ = _tmp0_;
#line 80 "../src/LocalBackend/DevicePreferences.vala"
	_tmp1_ = _result_;
#line 80 "../src/LocalBackend/DevicePreferences.vala"
	if (G_VALUE_TYPE (_tmp1_) == gda_null_get_type ()) {
#line 81 "../src/LocalBackend/DevicePreferences.vala"
		result = NULL;
#line 81 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_result_);
#line 81 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 1260 "DevicePreferences.c"
	}
#line 84 "../src/LocalBackend/DevicePreferences.vala"
	_tmp2_ = _result_;
#line 84 "../src/LocalBackend/DevicePreferences.vala"
	_tmp3_ = g_value_get_string (_tmp2_);
#line 84 "../src/LocalBackend/DevicePreferences.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 84 "../src/LocalBackend/DevicePreferences.vala"
	playlist_string = _tmp4_;
#line 85 "../src/LocalBackend/DevicePreferences.vala"
	_tmp6_ = playlist_string;
#line 85 "../src/LocalBackend/DevicePreferences.vala"
	if (g_strcmp0 (_tmp6_, "") == 0) {
#line 85 "../src/LocalBackend/DevicePreferences.vala"
		_tmp5_ = TRUE;
#line 1276 "DevicePreferences.c"
	} else {
		const gchar* _tmp7_;
#line 85 "../src/LocalBackend/DevicePreferences.vala"
		_tmp7_ = playlist_string;
#line 85 "../src/LocalBackend/DevicePreferences.vala"
		_tmp5_ = _tmp7_ == NULL;
#line 1283 "DevicePreferences.c"
	}
#line 85 "../src/LocalBackend/DevicePreferences.vala"
	if (_tmp5_) {
#line 86 "../src/LocalBackend/DevicePreferences.vala"
		result = NULL;
#line 86 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (playlist_string);
#line 86 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_result_);
#line 86 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 1295 "DevicePreferences.c"
	}
#line 87 "../src/LocalBackend/DevicePreferences.vala"
	_tmp8_ = playlist_string;
#line 87 "../src/LocalBackend/DevicePreferences.vala"
	if (string_contains (_tmp8_, "p")) {
#line 1301 "DevicePreferences.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		NoiseLibrariesManager* _tmp11_;
		NoiseLibrary* _tmp12_;
		const gchar* _tmp13_;
		NoiseStaticPlaylist* _tmp14_;
#line 88 "../src/LocalBackend/DevicePreferences.vala"
		_tmp9_ = playlist_string;
#line 88 "../src/LocalBackend/DevicePreferences.vala"
		_tmp10_ = string_replace (_tmp9_, "p", "");
#line 88 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (playlist_string);
#line 88 "../src/LocalBackend/DevicePreferences.vala"
		playlist_string = _tmp10_;
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		_tmp11_ = noise_libraries_manager;
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		_tmp12_ = _tmp11_->local_library;
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		_tmp13_ = playlist_string;
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		_tmp14_ = noise_library_playlist_from_id (_tmp12_, int64_parse (_tmp13_));
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		result = (NoisePlaylist*) _tmp14_;
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (playlist_string);
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_result_);
#line 89 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 1332 "DevicePreferences.c"
	} else {
		const gchar* _tmp15_;
		gchar* _tmp16_;
		NoiseLibrariesManager* _tmp17_;
		NoiseLibrary* _tmp18_;
		const gchar* _tmp19_;
		NoiseSmartPlaylist* _tmp20_;
#line 91 "../src/LocalBackend/DevicePreferences.vala"
		_tmp15_ = playlist_string;
#line 91 "../src/LocalBackend/DevicePreferences.vala"
		_tmp16_ = string_replace (_tmp15_, "s", "");
#line 91 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (playlist_string);
#line 91 "../src/LocalBackend/DevicePreferences.vala"
		playlist_string = _tmp16_;
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		_tmp17_ = noise_libraries_manager;
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		_tmp18_ = _tmp17_->local_library;
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		_tmp19_ = playlist_string;
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		_tmp20_ = noise_library_smart_playlist_from_id (_tmp18_, int64_parse (_tmp19_));
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		result = (NoisePlaylist*) _tmp20_;
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		_g_free0 (playlist_string);
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		__vala_GValue_free0 (_result_);
#line 92 "../src/LocalBackend/DevicePreferences.vala"
		return result;
#line 1364 "DevicePreferences.c"
	}
#line 78 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (playlist_string);
#line 78 "../src/LocalBackend/DevicePreferences.vala"
	__vala_GValue_free0 (_result_);
#line 1370 "DevicePreferences.c"
}


void
noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self,
                                             NoisePlaylist* value)
{
	gchar* playlist_string = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	GValue _tmp8_ = {0};
#line 95 "../src/LocalBackend/DevicePreferences.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/LocalBackend/DevicePreferences.vala"
	_tmp0_ = g_strdup ("");
#line 96 "../src/LocalBackend/DevicePreferences.vala"
	playlist_string = _tmp0_;
#line 97 "../src/LocalBackend/DevicePreferences.vala"
	if (value != NULL) {
#line 98 "../src/LocalBackend/DevicePreferences.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (value, NOISE_TYPE_STATIC_PLAYLIST)) {
#line 1392 "DevicePreferences.c"
			gint64 _tmp1_;
			gint64 _tmp2_;
			gchar* _tmp3_;
#line 99 "../src/LocalBackend/DevicePreferences.vala"
			_tmp1_ = noise_playlist_get_rowid (value);
#line 99 "../src/LocalBackend/DevicePreferences.vala"
			_tmp2_ = _tmp1_;
#line 99 "../src/LocalBackend/DevicePreferences.vala"
			_tmp3_ = g_strdup_printf ("p%lld", _tmp2_);
#line 99 "../src/LocalBackend/DevicePreferences.vala"
			_g_free0 (playlist_string);
#line 99 "../src/LocalBackend/DevicePreferences.vala"
			playlist_string = _tmp3_;
#line 1406 "DevicePreferences.c"
		} else {
			gint64 _tmp4_;
			gint64 _tmp5_;
			gchar* _tmp6_;
#line 101 "../src/LocalBackend/DevicePreferences.vala"
			_tmp4_ = noise_playlist_get_rowid (value);
#line 101 "../src/LocalBackend/DevicePreferences.vala"
			_tmp5_ = _tmp4_;
#line 101 "../src/LocalBackend/DevicePreferences.vala"
			_tmp6_ = g_strdup_printf ("s%lld", _tmp5_);
#line 101 "../src/LocalBackend/DevicePreferences.vala"
			_g_free0 (playlist_string);
#line 101 "../src/LocalBackend/DevicePreferences.vala"
			playlist_string = _tmp6_;
#line 1421 "DevicePreferences.c"
		}
	}
#line 105 "../src/LocalBackend/DevicePreferences.vala"
	_tmp7_ = playlist_string;
#line 105 "../src/LocalBackend/DevicePreferences.vala"
	g_value_init (&_tmp8_, G_TYPE_STRING);
#line 105 "../src/LocalBackend/DevicePreferences.vala"
	g_value_set_string (&_tmp8_, _tmp7_);
#line 105 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_set_field (self, "music_playlist", &_tmp8_);
#line 105 "../src/LocalBackend/DevicePreferences.vala"
	G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
#line 95 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (playlist_string);
#line 95 "../src/LocalBackend/DevicePreferences.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY]);
#line 1438 "DevicePreferences.c"
}


static void
noise_device_preferences_class_init (NoiseDevicePreferencesClass * klass)
{
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	noise_device_preferences_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	g_type_class_adjust_private_offset (klass, &NoiseDevicePreferences_private_offset);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_device_preferences_get_property;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_device_preferences_set_property;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_device_preferences_finalize;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY] = g_param_spec_boolean ("sync-when-mounted", "sync-when-mounted", "sync-when-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY] = g_param_spec_uint ("last-sync-time", "last-sync-time", "last-sync-time", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY] = g_param_spec_boolean ("sync-music", "sync-music", "sync-music", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY] = g_param_spec_boolean ("sync-all-music", "sync-all-music", "sync-all-music", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY, noise_device_preferences_properties[NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY] = g_param_spec_object ("music-playlist", "music-playlist", "music-playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1465 "DevicePreferences.c"
}


static void
noise_device_preferences_instance_init (NoiseDevicePreferences * self)
{
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	self->priv = noise_device_preferences_get_instance_private (self);
#line 33 "../src/LocalBackend/DevicePreferences.vala"
	self->_sync_when_mounted = NULL;
#line 44 "../src/LocalBackend/DevicePreferences.vala"
	self->_last_sync_time = NULL;
#line 55 "../src/LocalBackend/DevicePreferences.vala"
	self->_sync_music = NULL;
#line 66 "../src/LocalBackend/DevicePreferences.vala"
	self->_sync_all_music = NULL;
#line 1482 "DevicePreferences.c"
}


static void
noise_device_preferences_finalize (GObject * obj)
{
	NoiseDevicePreferences * self;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
#line 31 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (self->priv->id);
#line 33 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (self->_sync_when_mounted);
#line 44 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (self->_last_sync_time);
#line 55 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (self->_sync_music);
#line 66 "../src/LocalBackend/DevicePreferences.vala"
	_g_free0 (self->_sync_all_music);
#line 109 "../src/LocalBackend/DevicePreferences.vala"
	_g_object_unref0 (self->priv->connection);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	G_OBJECT_CLASS (noise_device_preferences_parent_class)->finalize (obj);
#line 1506 "DevicePreferences.c"
}


GType
noise_device_preferences_get_type (void)
{
	static volatile gsize noise_device_preferences_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_preferences_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDevicePreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseDevicePreferences), 0, (GInstanceInitFunc) noise_device_preferences_instance_init, NULL };
		GType noise_device_preferences_type_id;
		noise_device_preferences_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseDevicePreferences", &g_define_type_info, 0);
		NoiseDevicePreferences_private_offset = g_type_add_instance_private (noise_device_preferences_type_id, sizeof (NoiseDevicePreferencesPrivate));
		g_once_init_leave (&noise_device_preferences_type_id__volatile, noise_device_preferences_type_id);
	}
	return noise_device_preferences_type_id__volatile;
}


static void
_vala_noise_device_preferences_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	switch (property_id) {
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_when_mounted (self));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		g_value_set_uint (value, noise_device_preferences_get_last_sync_time (self));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_music (self));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		g_value_set_boolean (value, noise_device_preferences_get_sync_all_music (self));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		g_value_take_object (value, noise_device_preferences_get_music_playlist (self));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 1565 "DevicePreferences.c"
		default:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 1571 "DevicePreferences.c"
	}
}


static void
_vala_noise_device_preferences_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NoiseDevicePreferences * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
	switch (property_id) {
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_WHEN_MOUNTED_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		noise_device_preferences_set_sync_when_mounted (self, g_value_get_boolean (value));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_LAST_SYNC_TIME_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		noise_device_preferences_set_last_sync_time (self, g_value_get_uint (value));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_MUSIC_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		noise_device_preferences_set_sync_music (self, g_value_get_boolean (value));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_SYNC_ALL_MUSIC_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		noise_device_preferences_set_sync_all_music (self, g_value_get_boolean (value));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		case NOISE_DEVICE_PREFERENCES_MUSIC_PLAYLIST_PROPERTY:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		noise_device_preferences_set_music_playlist (self, g_value_get_object (value));
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 1616 "DevicePreferences.c"
		default:
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/LocalBackend/DevicePreferences.vala"
		break;
#line 1622 "DevicePreferences.c"
	}
}



