/* DeviceSummaryWidget.c generated by valac 0.42.6, the Vala compiler
 * generated from DeviceSummaryWidget.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "io.elementary.music-core.h"
#include <granite.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <pango/pango.h>


#define NOISE_TYPE_DEVICE_SUMMARY_WIDGET (noise_device_summary_widget_get_type ())
#define NOISE_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget))
#define NOISE_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidgetClass))
#define NOISE_IS_DEVICE_SUMMARY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET))
#define NOISE_IS_DEVICE_SUMMARY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_SUMMARY_WIDGET))
#define NOISE_DEVICE_SUMMARY_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidgetClass))

typedef struct _NoiseDeviceSummaryWidget NoiseDeviceSummaryWidget;
typedef struct _NoiseDeviceSummaryWidgetClass NoiseDeviceSummaryWidgetClass;
typedef struct _NoiseDeviceSummaryWidgetPrivate NoiseDeviceSummaryWidgetPrivate;

#define NOISE_TYPE_DEVICE_PREFERENCES (noise_device_preferences_get_type ())
#define NOISE_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferences))
#define NOISE_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))
#define NOISE_IS_DEVICE_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_IS_DEVICE_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_PREFERENCES))
#define NOISE_DEVICE_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_PREFERENCES, NoiseDevicePreferencesClass))

typedef struct _NoiseDevicePreferences NoiseDevicePreferences;
typedef struct _NoiseDevicePreferencesClass NoiseDevicePreferencesClass;
enum  {
	NOISE_DEVICE_SUMMARY_WIDGET_0_PROPERTY,
	NOISE_DEVICE_SUMMARY_WIDGET_DEVICE_PROPERTY,
	NOISE_DEVICE_SUMMARY_WIDGET_PREFERENCES_PROPERTY,
	NOISE_DEVICE_SUMMARY_WIDGET_NUM_PROPERTIES
};
static GParamSpec* noise_device_summary_widget_properties[NOISE_DEVICE_SUMMARY_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block18Data Block18Data;

#define NOISE_TYPE_SYNC_WARNING_DIALOG (noise_sync_warning_dialog_get_type ())
#define NOISE_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialog))
#define NOISE_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogClass))
#define NOISE_IS_SYNC_WARNING_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG))
#define NOISE_IS_SYNC_WARNING_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SYNC_WARNING_DIALOG))
#define NOISE_SYNC_WARNING_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SYNC_WARNING_DIALOG, NoiseSyncWarningDialogClass))

typedef struct _NoiseSyncWarningDialog NoiseSyncWarningDialog;
typedef struct _NoiseSyncWarningDialogClass NoiseSyncWarningDialogClass;
typedef struct _Block19Data Block19Data;
typedef enum  {
	NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA = 1,
	NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE,
	NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP
} NoiseSyncWarningDialogResponseId;


#define NOISE_SYNC_WARNING_DIALOG_TYPE_RESPONSE_ID (noise_sync_warning_dialog_response_id_get_type ())
typedef struct _Block20Data Block20Data;

struct _NoiseDeviceSummaryWidget {
	GtkEventBox parent_instance;
	NoiseDeviceSummaryWidgetPrivate * priv;
};

struct _NoiseDeviceSummaryWidgetClass {
	GtkEventBoxClass parent_class;
};

struct _NoiseDeviceSummaryWidgetPrivate {
	NoiseDevice* _device;
	NoiseDevicePreferences* _preferences;
	GtkButton* sync_button;
	GtkCheckButton* sync_music_check;
	GtkComboBox* sync_music_combobox;
	GtkListStore* music_list;
	GtkSwitch* auto_sync_switch;
	GraniteWidgetsStorageBar* storagebar;
};

struct _Block18Data {
	int _ref_count_;
	NoiseDeviceSummaryWidget* self;
	GeeTreeSet* not_found;
};

struct _Block19Data {
	int _ref_count_;
	Block18Data * _data18_;
	NoiseSyncWarningDialog* swd;
};

struct _Block20Data {
	int _ref_count_;
	NoiseDeviceSummaryWidget* self;
	GtkEntry* device_name_entry;
};


static gint NoiseDeviceSummaryWidget_private_offset;
static gpointer noise_device_summary_widget_parent_class = NULL;

GType noise_device_summary_widget_get_type (void) G_GNUC_CONST;
GType noise_device_preferences_get_type (void) G_GNUC_CONST;
NoiseDeviceSummaryWidget* noise_device_summary_widget_new (NoiseDevice* device,
                                                           NoiseDevicePreferences* preferences);
NoiseDeviceSummaryWidget* noise_device_summary_widget_construct (GType object_type,
                                                                 NoiseDevice* device,
                                                                 NoiseDevicePreferences* preferences);
static void noise_device_summary_widget_refresh_space_widget (NoiseDeviceSummaryWidget* self);
NoiseDevice* noise_device_summary_widget_get_device (NoiseDeviceSummaryWidget* self);
static gboolean noise_device_summary_widget_rowSeparatorFunc (NoiseDeviceSummaryWidget* self,
                                                       GtkTreeModel* model,
                                                       GtkTreeIter* iter);
static void noise_device_summary_widget_save_preferences (NoiseDeviceSummaryWidget* self);
NoiseDevicePreferences* noise_device_summary_widget_get_preferences (NoiseDeviceSummaryWidget* self);
void noise_device_preferences_set_sync_when_mounted (NoiseDevicePreferences* self,
                                                     gboolean value);
void noise_device_preferences_set_sync_music (NoiseDevicePreferences* self,
                                              gboolean value);
void noise_device_preferences_set_sync_all_music (NoiseDevicePreferences* self,
                                                  gboolean value);
void noise_device_preferences_set_music_playlist (NoiseDevicePreferences* self,
                                                  NoisePlaylist* value);
static void noise_device_summary_widget_refresh_lists (NoiseDeviceSummaryWidget* self);
gboolean noise_device_preferences_get_sync_music (NoiseDevicePreferences* self);
void noise_device_summary_widget_sync_clicked (NoiseDeviceSummaryWidget* self);
gboolean noise_device_preferences_get_sync_all_music (NoiseDevicePreferences* self);
NoisePlaylist* noise_device_preferences_get_music_playlist (NoiseDevicePreferences* self);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
GType noise_sync_warning_dialog_get_type (void) G_GNUC_CONST;
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
NoiseSyncWarningDialog* noise_sync_warning_dialog_new (NoiseDevice* d,
                                                       GeeTreeSet* to_sync,
                                                       GeeTreeSet* removed);
NoiseSyncWarningDialog* noise_sync_warning_dialog_construct (GType object_type,
                                                             NoiseDevice* d,
                                                             GeeTreeSet* to_sync,
                                                             GeeTreeSet* removed);
static void _____lambda106_ (Block19Data* _data19_,
                      GtkDialog* src,
                      gint id);
GType noise_sync_warning_dialog_response_id_get_type (void) G_GNUC_CONST;
static void ______lambda106__gtk_dialog_response (GtkDialog* _sender,
                                           gint response_id,
                                           gpointer self);
static void noise_device_summary_widget_set_device (NoiseDeviceSummaryWidget* self,
                                             NoiseDevice* value);
static void noise_device_summary_widget_set_preferences (NoiseDeviceSummaryWidget* self,
                                                  NoiseDevicePreferences* value);
static GObject * noise_device_summary_widget_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static gboolean _noise_device_summary_widget_rowSeparatorFunc_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                         GtkTreeIter* iter,
                                                                                         gpointer self);
static void _noise_device_summary_widget_refresh_lists_gtk_combo_box_popup (GtkComboBox* _sender,
                                                                     gpointer self);
gboolean noise_device_preferences_get_sync_when_mounted (NoiseDevicePreferences* self);
static void _noise_device_summary_widget_save_preferences_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void _noise_device_summary_widget_save_preferences_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                              gpointer self);
static void _noise_device_summary_widget_save_preferences_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                          gpointer self);
static void _noise_device_summary_widget___lambda107_ (Block20Data* _data20_);
static void __noise_device_summary_widget___lambda107__gtk_editable_changed (GtkEditable* _sender,
                                                                      gpointer self);
static void _noise_device_summary_widget_sync_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _noise_device_summary_widget___lambda108_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda108__noise_library_file_operations_done (NoiseLibrary* _sender,
                                                                                    gpointer self);
static void _noise_device_summary_widget___lambda109_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda109__noise_library_playlist_added (NoiseLibrary* _sender,
                                                                              NoiseStaticPlaylist* playlist,
                                                                              gpointer self);
static void _noise_device_summary_widget___lambda110_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda110__noise_library_playlist_name_updated (NoiseLibrary* _sender,
                                                                                     NoiseStaticPlaylist* playlist,
                                                                                     gpointer self);
static void _noise_device_summary_widget___lambda111_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda111__noise_library_playlist_removed (NoiseLibrary* _sender,
                                                                                NoiseStaticPlaylist* playlist,
                                                                                gpointer self);
static void _noise_device_summary_widget___lambda112_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda112__noise_library_smartplaylist_added (NoiseLibrary* _sender,
                                                                                   NoiseSmartPlaylist* smartplaylist,
                                                                                   gpointer self);
static void _noise_device_summary_widget___lambda113_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda113__noise_library_smartplaylist_name_updated (NoiseLibrary* _sender,
                                                                                          NoiseSmartPlaylist* smartplaylist,
                                                                                          gpointer self);
static void _noise_device_summary_widget___lambda114_ (NoiseDeviceSummaryWidget* self);
static void __noise_device_summary_widget___lambda114__noise_library_smartplaylist_removed (NoiseLibrary* _sender,
                                                                                     NoiseSmartPlaylist* smartplaylist,
                                                                                     gpointer self);
static void noise_device_summary_widget_finalize (GObject * obj);
static void _vala_noise_device_summary_widget_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_device_summary_widget_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);


static inline gpointer
noise_device_summary_widget_get_instance_private (NoiseDeviceSummaryWidget* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseDeviceSummaryWidget_private_offset);
}


NoiseDeviceSummaryWidget*
noise_device_summary_widget_construct (GType object_type,
                                       NoiseDevice* device,
                                       NoiseDevicePreferences* preferences)
{
	NoiseDeviceSummaryWidget * self = NULL;
#line 40 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 40 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (preferences != NULL, NULL);
#line 41 "../src/Views/DeviceSummaryWidget.vala"
	self = (NoiseDeviceSummaryWidget*) g_object_new (object_type, "device", device, "preferences", preferences, NULL);
#line 40 "../src/Views/DeviceSummaryWidget.vala"
	return self;
#line 272 "DeviceSummaryWidget.c"
}


NoiseDeviceSummaryWidget*
noise_device_summary_widget_new (NoiseDevice* device,
                                 NoiseDevicePreferences* preferences)
{
#line 40 "../src/Views/DeviceSummaryWidget.vala"
	return noise_device_summary_widget_construct (NOISE_TYPE_DEVICE_SUMMARY_WIDGET, device, preferences);
#line 282 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_refresh_space_widget (NoiseDeviceSummaryWidget* self)
{
	guint64 other_files_size = 0ULL;
	guint64 music_size = 0ULL;
	NoiseDevice* _tmp15_;
	guint64 _tmp16_;
	GraniteWidgetsStorageBar* _tmp17_;
	guint64 _tmp18_;
	GraniteWidgetsStorageBar* _tmp19_;
	guint64 _tmp20_;
#line 193 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/Views/DeviceSummaryWidget.vala"
	other_files_size = (guint64) 0;
#line 195 "../src/Views/DeviceSummaryWidget.vala"
	music_size = (guint64) 0;
#line 303 "DeviceSummaryWidget.c"
	{
		GeeIterator* _m_it = NULL;
		NoiseDevice* _tmp0_;
		NoiseLibrary* _tmp1_;
		NoiseLibrary* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp0_ = self->priv->_device;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp1_ = noise_device_get_library (_tmp0_);
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp2_ = _tmp1_;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp3_ = noise_library_get_medias (_tmp2_);
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp4_ = _tmp3_;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_tmp6_ = _tmp5_;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp4_);
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp2_);
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_m_it = _tmp6_;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		while (TRUE) {
#line 335 "DeviceSummaryWidget.c"
			GeeIterator* _tmp7_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			NoiseMedia* _tmp10_;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
			_tmp7_ = _m_it;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 196 "../src/Views/DeviceSummaryWidget.vala"
				break;
#line 347 "DeviceSummaryWidget.c"
			}
#line 196 "../src/Views/DeviceSummaryWidget.vala"
			_tmp8_ = _m_it;
#line 196 "../src/Views/DeviceSummaryWidget.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 196 "../src/Views/DeviceSummaryWidget.vala"
			m = (NoiseMedia*) _tmp9_;
#line 197 "../src/Views/DeviceSummaryWidget.vala"
			_tmp10_ = m;
#line 197 "../src/Views/DeviceSummaryWidget.vala"
			if (_tmp10_ != NULL) {
#line 359 "DeviceSummaryWidget.c"
				guint64 _tmp11_;
				NoiseMedia* _tmp12_;
				guint64 _tmp13_;
				guint64 _tmp14_;
#line 198 "../src/Views/DeviceSummaryWidget.vala"
				_tmp11_ = music_size;
#line 198 "../src/Views/DeviceSummaryWidget.vala"
				_tmp12_ = m;
#line 198 "../src/Views/DeviceSummaryWidget.vala"
				_tmp13_ = noise_media_get_file_size (_tmp12_);
#line 198 "../src/Views/DeviceSummaryWidget.vala"
				_tmp14_ = _tmp13_;
#line 198 "../src/Views/DeviceSummaryWidget.vala"
				music_size = _tmp11_ + _tmp14_;
#line 374 "DeviceSummaryWidget.c"
			}
#line 196 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (m);
#line 378 "DeviceSummaryWidget.c"
		}
#line 196 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_m_it);
#line 382 "DeviceSummaryWidget.c"
	}
#line 201 "../src/Views/DeviceSummaryWidget.vala"
	_tmp15_ = self->priv->_device;
#line 201 "../src/Views/DeviceSummaryWidget.vala"
	_tmp16_ = music_size;
#line 201 "../src/Views/DeviceSummaryWidget.vala"
	other_files_size = noise_device_get_used_space (_tmp15_) - _tmp16_;
#line 203 "../src/Views/DeviceSummaryWidget.vala"
	_tmp17_ = self->priv->storagebar;
#line 203 "../src/Views/DeviceSummaryWidget.vala"
	_tmp18_ = other_files_size;
#line 203 "../src/Views/DeviceSummaryWidget.vala"
	granite_widgets_storage_bar_update_block_size (_tmp17_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_OTHER, _tmp18_);
#line 204 "../src/Views/DeviceSummaryWidget.vala"
	_tmp19_ = self->priv->storagebar;
#line 204 "../src/Views/DeviceSummaryWidget.vala"
	_tmp20_ = music_size;
#line 204 "../src/Views/DeviceSummaryWidget.vala"
	granite_widgets_storage_bar_update_block_size (_tmp19_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_AUDIO, _tmp20_);
#line 402 "DeviceSummaryWidget.c"
}


static gboolean
noise_device_summary_widget_rowSeparatorFunc (NoiseDeviceSummaryWidget* self,
                                              GtkTreeModel* model,
                                              GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gchar* sep = NULL;
	gchar* _tmp0_;
	GtkTreeIter _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
#line 207 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 207 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 208 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = g_strdup ("");
#line 208 "../src/Views/DeviceSummaryWidget.vala"
	sep = _tmp0_;
#line 209 "../src/Views/DeviceSummaryWidget.vala"
	_tmp1_ = *iter;
#line 209 "../src/Views/DeviceSummaryWidget.vala"
	gtk_tree_model_get (model, &_tmp1_, 1, &_tmp2_, -1);
#line 209 "../src/Views/DeviceSummaryWidget.vala"
	_g_free0 (sep);
#line 209 "../src/Views/DeviceSummaryWidget.vala"
	sep = _tmp2_;
#line 210 "../src/Views/DeviceSummaryWidget.vala"
	_tmp3_ = sep;
#line 210 "../src/Views/DeviceSummaryWidget.vala"
	result = g_strcmp0 (_tmp3_, "<separator_item_unique_name>") == 0;
#line 210 "../src/Views/DeviceSummaryWidget.vala"
	_g_free0 (sep);
#line 210 "../src/Views/DeviceSummaryWidget.vala"
	return result;
#line 443 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_save_preferences (NoiseDeviceSummaryWidget* self)
{
	NoiseDevicePreferences* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NoiseDevicePreferences* _tmp4_;
	GtkCheckButton* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	NoiseDevicePreferences* _tmp8_;
	GtkComboBox* _tmp9_;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp10_;
	GtkComboBox* _tmp19_;
	GtkCheckButton* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
#line 213 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = self->priv->_preferences;
#line 214 "../src/Views/DeviceSummaryWidget.vala"
	_tmp1_ = self->priv->auto_sync_switch;
#line 214 "../src/Views/DeviceSummaryWidget.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 214 "../src/Views/DeviceSummaryWidget.vala"
	_tmp3_ = _tmp2_;
#line 214 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_preferences_set_sync_when_mounted (_tmp0_, _tmp3_);
#line 215 "../src/Views/DeviceSummaryWidget.vala"
	_tmp4_ = self->priv->_preferences;
#line 215 "../src/Views/DeviceSummaryWidget.vala"
	_tmp5_ = self->priv->sync_music_check;
#line 215 "../src/Views/DeviceSummaryWidget.vala"
	_tmp6_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp5_);
#line 215 "../src/Views/DeviceSummaryWidget.vala"
	_tmp7_ = _tmp6_;
#line 215 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_preferences_set_sync_music (_tmp4_, _tmp7_);
#line 216 "../src/Views/DeviceSummaryWidget.vala"
	_tmp8_ = self->priv->_preferences;
#line 216 "../src/Views/DeviceSummaryWidget.vala"
	_tmp9_ = self->priv->sync_music_combobox;
#line 216 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_preferences_set_sync_all_music (_tmp8_, gtk_combo_box_get_active (_tmp9_) == 0);
#line 218 "../src/Views/DeviceSummaryWidget.vala"
	_tmp10_ = self->priv->sync_music_combobox;
#line 218 "../src/Views/DeviceSummaryWidget.vala"
	if ((gtk_combo_box_get_active (_tmp10_) - 2) >= 0) {
#line 498 "DeviceSummaryWidget.c"
		GtkComboBox* _tmp11_;
		GtkTreeIter _tmp12_ = {0};
		GValue value = {0};
		GtkListStore* _tmp13_;
		GtkTreeIter _tmp14_;
		GValue _tmp15_ = {0};
		NoiseDevicePreferences* _tmp16_;
		GObject* _tmp17_;
		NoisePlaylist* _tmp18_;
#line 219 "../src/Views/DeviceSummaryWidget.vala"
		_tmp11_ = self->priv->sync_music_combobox;
#line 219 "../src/Views/DeviceSummaryWidget.vala"
		gtk_combo_box_get_active_iter (_tmp11_, &_tmp12_);
#line 219 "../src/Views/DeviceSummaryWidget.vala"
		iter = _tmp12_;
#line 221 "../src/Views/DeviceSummaryWidget.vala"
		_tmp13_ = self->priv->music_list;
#line 221 "../src/Views/DeviceSummaryWidget.vala"
		_tmp14_ = iter;
#line 221 "../src/Views/DeviceSummaryWidget.vala"
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp13_, &_tmp14_, 0, &_tmp15_);
#line 221 "../src/Views/DeviceSummaryWidget.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 221 "../src/Views/DeviceSummaryWidget.vala"
		value = _tmp15_;
#line 222 "../src/Views/DeviceSummaryWidget.vala"
		_tmp16_ = self->priv->_preferences;
#line 222 "../src/Views/DeviceSummaryWidget.vala"
		_tmp17_ = g_value_dup_object (&value);
#line 222 "../src/Views/DeviceSummaryWidget.vala"
		_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, NOISE_TYPE_PLAYLIST, NoisePlaylist);
#line 222 "../src/Views/DeviceSummaryWidget.vala"
		noise_device_preferences_set_music_playlist (_tmp16_, _tmp18_);
#line 222 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp18_);
#line 218 "../src/Views/DeviceSummaryWidget.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 536 "DeviceSummaryWidget.c"
	}
#line 225 "../src/Views/DeviceSummaryWidget.vala"
	_tmp19_ = self->priv->sync_music_combobox;
#line 225 "../src/Views/DeviceSummaryWidget.vala"
	_tmp20_ = self->priv->sync_music_check;
#line 225 "../src/Views/DeviceSummaryWidget.vala"
	_tmp21_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp20_);
#line 225 "../src/Views/DeviceSummaryWidget.vala"
	_tmp22_ = _tmp21_;
#line 225 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, _tmp22_);
#line 548 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_refresh_lists (NoiseDeviceSummaryWidget* self)
{
	GtkTreeIter iter = {0};
	NoisePlaylist* selected_playlist = NULL;
	GtkComboBox* _tmp0_;
	GtkListStore* _tmp7_;
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_ = {0};
	GtkListStore* _tmp10_;
	GtkTreeIter _tmp11_;
	GThemedIcon* _tmp12_;
	GThemedIcon* _tmp13_;
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_ = {0};
	GtkListStore* _tmp16_;
	GtkTreeIter _tmp17_;
	NoisePlaylist* _tmp67_;
	GtkComboBox* _tmp69_;
	NoiseDevicePreferences* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
#line 228 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/Views/DeviceSummaryWidget.vala"
	g_message ("DeviceSummaryWidget.vala:229: refreshing lists\n");
#line 232 "../src/Views/DeviceSummaryWidget.vala"
	selected_playlist = NULL;
#line 233 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = self->priv->sync_music_combobox;
#line 233 "../src/Views/DeviceSummaryWidget.vala"
	if ((gtk_combo_box_get_active (_tmp0_) - 2) >= 0) {
#line 584 "DeviceSummaryWidget.c"
		GtkComboBox* _tmp1_;
		GtkTreeIter _tmp2_ = {0};
		GValue value = {0};
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		GValue _tmp5_ = {0};
		GObject* _tmp6_;
#line 234 "../src/Views/DeviceSummaryWidget.vala"
		_tmp1_ = self->priv->sync_music_combobox;
#line 234 "../src/Views/DeviceSummaryWidget.vala"
		gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
#line 234 "../src/Views/DeviceSummaryWidget.vala"
		iter = _tmp2_;
#line 236 "../src/Views/DeviceSummaryWidget.vala"
		_tmp3_ = self->priv->music_list;
#line 236 "../src/Views/DeviceSummaryWidget.vala"
		_tmp4_ = iter;
#line 236 "../src/Views/DeviceSummaryWidget.vala"
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_);
#line 236 "../src/Views/DeviceSummaryWidget.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 236 "../src/Views/DeviceSummaryWidget.vala"
		value = _tmp5_;
#line 237 "../src/Views/DeviceSummaryWidget.vala"
		_tmp6_ = g_value_dup_object (&value);
#line 237 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (selected_playlist);
#line 237 "../src/Views/DeviceSummaryWidget.vala"
		selected_playlist = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, NOISE_TYPE_PLAYLIST, NoisePlaylist);
#line 233 "../src/Views/DeviceSummaryWidget.vala"
		G_IS_VALUE (&value) ? (g_value_unset (&value), NULL) : NULL;
#line 616 "DeviceSummaryWidget.c"
	}
#line 240 "../src/Views/DeviceSummaryWidget.vala"
	_tmp7_ = self->priv->music_list;
#line 240 "../src/Views/DeviceSummaryWidget.vala"
	gtk_list_store_clear (_tmp7_);
#line 243 "../src/Views/DeviceSummaryWidget.vala"
	_tmp8_ = self->priv->music_list;
#line 243 "../src/Views/DeviceSummaryWidget.vala"
	gtk_list_store_append (_tmp8_, &_tmp9_);
#line 243 "../src/Views/DeviceSummaryWidget.vala"
	iter = _tmp9_;
#line 244 "../src/Views/DeviceSummaryWidget.vala"
	_tmp10_ = self->priv->music_list;
#line 244 "../src/Views/DeviceSummaryWidget.vala"
	_tmp11_ = iter;
#line 244 "../src/Views/DeviceSummaryWidget.vala"
	_tmp12_ = (GThemedIcon*) g_themed_icon_new ("library-music");
#line 244 "../src/Views/DeviceSummaryWidget.vala"
	_tmp13_ = _tmp12_;
#line 244 "../src/Views/DeviceSummaryWidget.vala"
	gtk_list_store_set (_tmp10_, &_tmp11_, 0, NULL, 1, _ ("All Music"), 2, _tmp13_, -1);
#line 244 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (_tmp13_);
#line 247 "../src/Views/DeviceSummaryWidget.vala"
	_tmp14_ = self->priv->music_list;
#line 247 "../src/Views/DeviceSummaryWidget.vala"
	gtk_list_store_append (_tmp14_, &_tmp15_);
#line 247 "../src/Views/DeviceSummaryWidget.vala"
	iter = _tmp15_;
#line 248 "../src/Views/DeviceSummaryWidget.vala"
	_tmp16_ = self->priv->music_list;
#line 248 "../src/Views/DeviceSummaryWidget.vala"
	_tmp17_ = iter;
#line 248 "../src/Views/DeviceSummaryWidget.vala"
	gtk_list_store_set (_tmp16_, &_tmp17_, 0, NULL, 1, "<separator_item_unique_name>", -1);
#line 652 "DeviceSummaryWidget.c"
	{
		GeeIterator* _p_it = NULL;
		NoiseLibrariesManager* _tmp18_;
		NoiseLibrary* _tmp19_;
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
		GeeIterator* _tmp22_;
		GeeIterator* _tmp23_;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_tmp18_ = noise_libraries_manager;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_tmp19_ = _tmp18_->local_library;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_tmp20_ = noise_library_get_smart_playlists (_tmp19_);
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_tmp21_ = _tmp20_;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_tmp23_ = _tmp22_;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp21_);
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_p_it = _tmp23_;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		while (TRUE) {
#line 679 "DeviceSummaryWidget.c"
			GeeIterator* _tmp24_;
			NoiseSmartPlaylist* p = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			GtkListStore* _tmp27_;
			GtkTreeIter _tmp28_ = {0};
			GtkListStore* _tmp29_;
			GtkTreeIter _tmp30_;
			NoiseSmartPlaylist* _tmp31_;
			NoiseSmartPlaylist* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			NoiseSmartPlaylist* _tmp35_;
			GIcon* _tmp36_;
			NoisePlaylist* _tmp37_;
			NoiseSmartPlaylist* _tmp38_;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
			_tmp24_ = _p_it;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 251 "../src/Views/DeviceSummaryWidget.vala"
				break;
#line 702 "DeviceSummaryWidget.c"
			}
#line 251 "../src/Views/DeviceSummaryWidget.vala"
			_tmp25_ = _p_it;
#line 251 "../src/Views/DeviceSummaryWidget.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 251 "../src/Views/DeviceSummaryWidget.vala"
			p = (NoiseSmartPlaylist*) _tmp26_;
#line 252 "../src/Views/DeviceSummaryWidget.vala"
			_tmp27_ = self->priv->music_list;
#line 252 "../src/Views/DeviceSummaryWidget.vala"
			gtk_list_store_append (_tmp27_, &_tmp28_);
#line 252 "../src/Views/DeviceSummaryWidget.vala"
			iter = _tmp28_;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp29_ = self->priv->music_list;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp30_ = iter;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp31_ = p;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp32_ = p;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp33_ = noise_playlist_get_name ((NoisePlaylist*) _tmp32_);
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp34_ = _tmp33_;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp35_ = p;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			_tmp36_ = ((NoisePlaylist*) _tmp35_)->icon;
#line 253 "../src/Views/DeviceSummaryWidget.vala"
			gtk_list_store_set (_tmp29_, &_tmp30_, 0, _tmp31_, 1, _tmp34_, 2, _tmp36_, -1);
#line 254 "../src/Views/DeviceSummaryWidget.vala"
			_tmp37_ = selected_playlist;
#line 254 "../src/Views/DeviceSummaryWidget.vala"
			_tmp38_ = p;
#line 254 "../src/Views/DeviceSummaryWidget.vala"
			if (_tmp37_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, NOISE_TYPE_PLAYLIST, NoisePlaylist)) {
#line 740 "DeviceSummaryWidget.c"
				GtkComboBox* _tmp39_;
				GtkTreeIter _tmp40_;
#line 255 "../src/Views/DeviceSummaryWidget.vala"
				_tmp39_ = self->priv->sync_music_combobox;
#line 255 "../src/Views/DeviceSummaryWidget.vala"
				_tmp40_ = iter;
#line 255 "../src/Views/DeviceSummaryWidget.vala"
				gtk_combo_box_set_active_iter (_tmp39_, &_tmp40_);
#line 749 "DeviceSummaryWidget.c"
			}
#line 251 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (p);
#line 753 "DeviceSummaryWidget.c"
		}
#line 251 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_p_it);
#line 757 "DeviceSummaryWidget.c"
	}
	{
		GeeIterator* _p_it = NULL;
		NoiseLibrariesManager* _tmp41_;
		NoiseLibrary* _tmp42_;
		GeeCollection* _tmp43_;
		GeeCollection* _tmp44_;
		GeeIterator* _tmp45_;
		GeeIterator* _tmp46_;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_tmp41_ = noise_libraries_manager;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_tmp42_ = _tmp41_->local_library;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_tmp43_ = noise_library_get_playlists (_tmp42_);
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_tmp44_ = _tmp43_;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_tmp45_ = gee_iterable_iterator ((GeeIterable*) _tmp44_);
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_tmp46_ = _tmp45_;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp44_);
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_p_it = _tmp46_;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		while (TRUE) {
#line 785 "DeviceSummaryWidget.c"
			GeeIterator* _tmp47_;
			NoiseStaticPlaylist* p = NULL;
			GeeIterator* _tmp48_;
			gpointer _tmp49_;
			NoiseStaticPlaylist* _tmp50_;
			gboolean _tmp51_;
			gboolean _tmp52_;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
			_tmp47_ = _p_it;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
			if (!gee_iterator_next (_tmp47_)) {
#line 259 "../src/Views/DeviceSummaryWidget.vala"
				break;
#line 799 "DeviceSummaryWidget.c"
			}
#line 259 "../src/Views/DeviceSummaryWidget.vala"
			_tmp48_ = _p_it;
#line 259 "../src/Views/DeviceSummaryWidget.vala"
			_tmp49_ = gee_iterator_get (_tmp48_);
#line 259 "../src/Views/DeviceSummaryWidget.vala"
			p = (NoiseStaticPlaylist*) _tmp49_;
#line 260 "../src/Views/DeviceSummaryWidget.vala"
			_tmp50_ = p;
#line 260 "../src/Views/DeviceSummaryWidget.vala"
			_tmp51_ = noise_static_playlist_get_read_only (_tmp50_);
#line 260 "../src/Views/DeviceSummaryWidget.vala"
			_tmp52_ = _tmp51_;
#line 260 "../src/Views/DeviceSummaryWidget.vala"
			if (_tmp52_ == FALSE) {
#line 815 "DeviceSummaryWidget.c"
				GtkListStore* _tmp53_;
				GtkTreeIter _tmp54_ = {0};
				GtkListStore* _tmp55_;
				GtkTreeIter _tmp56_;
				NoiseStaticPlaylist* _tmp57_;
				NoiseStaticPlaylist* _tmp58_;
				const gchar* _tmp59_;
				const gchar* _tmp60_;
				NoiseStaticPlaylist* _tmp61_;
				GIcon* _tmp62_;
				NoisePlaylist* _tmp63_;
				NoiseStaticPlaylist* _tmp64_;
#line 261 "../src/Views/DeviceSummaryWidget.vala"
				_tmp53_ = self->priv->music_list;
#line 261 "../src/Views/DeviceSummaryWidget.vala"
				gtk_list_store_append (_tmp53_, &_tmp54_);
#line 261 "../src/Views/DeviceSummaryWidget.vala"
				iter = _tmp54_;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp55_ = self->priv->music_list;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp56_ = iter;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp57_ = p;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp58_ = p;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp59_ = noise_playlist_get_name ((NoisePlaylist*) _tmp58_);
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp60_ = _tmp59_;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp61_ = p;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				_tmp62_ = ((NoisePlaylist*) _tmp61_)->icon;
#line 262 "../src/Views/DeviceSummaryWidget.vala"
				gtk_list_store_set (_tmp55_, &_tmp56_, 0, _tmp57_, 1, _tmp60_, 2, _tmp62_, -1);
#line 263 "../src/Views/DeviceSummaryWidget.vala"
				_tmp63_ = selected_playlist;
#line 263 "../src/Views/DeviceSummaryWidget.vala"
				_tmp64_ = p;
#line 263 "../src/Views/DeviceSummaryWidget.vala"
				if (_tmp63_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, NOISE_TYPE_PLAYLIST, NoisePlaylist)) {
#line 858 "DeviceSummaryWidget.c"
					GtkComboBox* _tmp65_;
					GtkTreeIter _tmp66_;
#line 264 "../src/Views/DeviceSummaryWidget.vala"
					_tmp65_ = self->priv->sync_music_combobox;
#line 264 "../src/Views/DeviceSummaryWidget.vala"
					_tmp66_ = iter;
#line 264 "../src/Views/DeviceSummaryWidget.vala"
					gtk_combo_box_set_active_iter (_tmp65_, &_tmp66_);
#line 867 "DeviceSummaryWidget.c"
				}
			}
#line 259 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (p);
#line 872 "DeviceSummaryWidget.c"
		}
#line 259 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_p_it);
#line 876 "DeviceSummaryWidget.c"
	}
#line 269 "../src/Views/DeviceSummaryWidget.vala"
	_tmp67_ = selected_playlist;
#line 269 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp67_ == NULL) {
#line 882 "DeviceSummaryWidget.c"
		GtkComboBox* _tmp68_;
#line 270 "../src/Views/DeviceSummaryWidget.vala"
		_tmp68_ = self->priv->sync_music_combobox;
#line 270 "../src/Views/DeviceSummaryWidget.vala"
		gtk_combo_box_set_active (_tmp68_, 0);
#line 888 "DeviceSummaryWidget.c"
	}
#line 273 "../src/Views/DeviceSummaryWidget.vala"
	g_message ("DeviceSummaryWidget.vala:273: setting sensitivity\n");
#line 274 "../src/Views/DeviceSummaryWidget.vala"
	_tmp69_ = self->priv->sync_music_combobox;
#line 274 "../src/Views/DeviceSummaryWidget.vala"
	_tmp70_ = self->priv->_preferences;
#line 274 "../src/Views/DeviceSummaryWidget.vala"
	_tmp71_ = noise_device_preferences_get_sync_music (_tmp70_);
#line 274 "../src/Views/DeviceSummaryWidget.vala"
	_tmp72_ = _tmp71_;
#line 274 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp69_, _tmp72_);
#line 228 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (selected_playlist);
#line 904 "DeviceSummaryWidget.c"
}


static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 319 "../src/Views/DeviceSummaryWidget.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
	return _data18_;
#line 915 "DeviceSummaryWidget.c"
}


static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 926 "DeviceSummaryWidget.c"
		NoiseDeviceSummaryWidget* self;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		self = _data18_->self;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_data18_->not_found);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (self);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		g_slice_free (Block18Data, _data18_);
#line 936 "DeviceSummaryWidget.c"
	}
}


static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 329 "../src/Views/DeviceSummaryWidget.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
	return _data19_;
#line 948 "DeviceSummaryWidget.c"
}


static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 959 "DeviceSummaryWidget.c"
		NoiseDeviceSummaryWidget* self;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
		self = _data19_->_data18_->self;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_data19_->swd);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
		block18_data_unref (_data19_->_data18_);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
		_data19_->_data18_ = NULL;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
		g_slice_free (Block19Data, _data19_);
#line 971 "DeviceSummaryWidget.c"
	}
}


static void
_____lambda106_ (Block19Data* _data19_,
                 GtkDialog* src,
                 gint id)
{
	Block18Data* _data18_;
	NoiseDeviceSummaryWidget* self;
#line 331 "../src/Views/DeviceSummaryWidget.vala"
	_data18_ = _data19_->_data18_;
#line 331 "../src/Views/DeviceSummaryWidget.vala"
	self = _data18_->self;
#line 331 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (src != NULL);
#line 332 "../src/Views/DeviceSummaryWidget.vala"
	switch (id) {
#line 332 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_IMPORT_MEDIA:
#line 993 "DeviceSummaryWidget.c"
		{
			NoiseLibrariesManager* _tmp0_;
			GeeTreeSet* _tmp1_;
			NoiseSyncWarningDialog* _tmp2_;
#line 334 "../src/Views/DeviceSummaryWidget.vala"
			_tmp0_ = noise_libraries_manager;
#line 334 "../src/Views/DeviceSummaryWidget.vala"
			_tmp1_ = _data18_->not_found;
#line 334 "../src/Views/DeviceSummaryWidget.vala"
			noise_libraries_manager_transfer_to_local_library (_tmp0_, (GeeCollection*) _tmp1_);
#line 337 "../src/Views/DeviceSummaryWidget.vala"
			_tmp2_ = _data19_->swd;
#line 337 "../src/Views/DeviceSummaryWidget.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp2_);
#line 338 "../src/Views/DeviceSummaryWidget.vala"
			break;
#line 1010 "DeviceSummaryWidget.c"
		}
#line 332 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_CONTINUE:
#line 1014 "DeviceSummaryWidget.c"
		{
			NoiseDevice* _tmp3_;
			NoiseSyncWarningDialog* _tmp4_;
#line 340 "../src/Views/DeviceSummaryWidget.vala"
			_tmp3_ = self->priv->_device;
#line 340 "../src/Views/DeviceSummaryWidget.vala"
			noise_device_synchronize (_tmp3_);
#line 341 "../src/Views/DeviceSummaryWidget.vala"
			_tmp4_ = _data19_->swd;
#line 341 "../src/Views/DeviceSummaryWidget.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp4_);
#line 342 "../src/Views/DeviceSummaryWidget.vala"
			break;
#line 1028 "DeviceSummaryWidget.c"
		}
#line 332 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_SYNC_WARNING_DIALOG_RESPONSE_ID_STOP:
#line 1032 "DeviceSummaryWidget.c"
		{
			NoiseSyncWarningDialog* _tmp5_;
#line 344 "../src/Views/DeviceSummaryWidget.vala"
			_tmp5_ = _data19_->swd;
#line 344 "../src/Views/DeviceSummaryWidget.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp5_);
#line 345 "../src/Views/DeviceSummaryWidget.vala"
			break;
#line 1041 "DeviceSummaryWidget.c"
		}
		default:
#line 332 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 1046 "DeviceSummaryWidget.c"
	}
}


static void
______lambda106__gtk_dialog_response (GtkDialog* _sender,
                                      gint response_id,
                                      gpointer self)
{
#line 331 "../src/Views/DeviceSummaryWidget.vala"
	_____lambda106_ (self, _sender, response_id);
#line 1058 "DeviceSummaryWidget.c"
}


void
noise_device_summary_widget_sync_clicked (NoiseDeviceSummaryWidget* self)
{
	GeeTreeSet* list = NULL;
	GeeTreeSet* _tmp0_;
	NoiseDevicePreferences* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean fits = FALSE;
	NoiseDevice* _tmp57_;
	GeeTreeSet* _tmp58_;
	gboolean _tmp59_;
#line 277 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 278 "../src/Views/DeviceSummaryWidget.vala"
	list = _tmp0_;
#line 280 "../src/Views/DeviceSummaryWidget.vala"
	_tmp1_ = self->priv->_preferences;
#line 280 "../src/Views/DeviceSummaryWidget.vala"
	_tmp2_ = noise_device_preferences_get_sync_music (_tmp1_);
#line 280 "../src/Views/DeviceSummaryWidget.vala"
	_tmp3_ = _tmp2_;
#line 280 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp3_) {
#line 1088 "DeviceSummaryWidget.c"
		NoiseDevicePreferences* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 281 "../src/Views/DeviceSummaryWidget.vala"
		_tmp4_ = self->priv->_preferences;
#line 281 "../src/Views/DeviceSummaryWidget.vala"
		_tmp5_ = noise_device_preferences_get_sync_all_music (_tmp4_);
#line 281 "../src/Views/DeviceSummaryWidget.vala"
		_tmp6_ = _tmp5_;
#line 281 "../src/Views/DeviceSummaryWidget.vala"
		if (_tmp6_) {
#line 1100 "DeviceSummaryWidget.c"
			{
				GeeIterator* _s_it = NULL;
				NoiseLibrariesManager* _tmp7_;
				NoiseLibrary* _tmp8_;
				GeeCollection* _tmp9_;
				GeeCollection* _tmp10_;
				GeeIterator* _tmp11_;
				GeeIterator* _tmp12_;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_tmp7_ = noise_libraries_manager;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_tmp8_ = _tmp7_->local_library;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_tmp9_ = noise_library_get_medias (_tmp8_);
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_tmp10_ = _tmp9_;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_tmp12_ = _tmp11_;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_g_object_unref0 (_tmp10_);
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_s_it = _tmp12_;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				while (TRUE) {
#line 1127 "DeviceSummaryWidget.c"
					GeeIterator* _tmp13_;
					NoiseMedia* s = NULL;
					GeeIterator* _tmp14_;
					gpointer _tmp15_;
					NoiseMedia* _tmp16_;
					gboolean _tmp17_;
					gboolean _tmp18_;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
					_tmp13_ = _s_it;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
					if (!gee_iterator_next (_tmp13_)) {
#line 282 "../src/Views/DeviceSummaryWidget.vala"
						break;
#line 1141 "DeviceSummaryWidget.c"
					}
#line 282 "../src/Views/DeviceSummaryWidget.vala"
					_tmp14_ = _s_it;
#line 282 "../src/Views/DeviceSummaryWidget.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 282 "../src/Views/DeviceSummaryWidget.vala"
					s = (NoiseMedia*) _tmp15_;
#line 283 "../src/Views/DeviceSummaryWidget.vala"
					_tmp16_ = s;
#line 283 "../src/Views/DeviceSummaryWidget.vala"
					_tmp17_ = noise_media_get_isTemporary (_tmp16_);
#line 283 "../src/Views/DeviceSummaryWidget.vala"
					_tmp18_ = _tmp17_;
#line 283 "../src/Views/DeviceSummaryWidget.vala"
					if (_tmp18_ == FALSE) {
#line 1157 "DeviceSummaryWidget.c"
						GeeTreeSet* _tmp19_;
						NoiseMedia* _tmp20_;
#line 284 "../src/Views/DeviceSummaryWidget.vala"
						_tmp19_ = list;
#line 284 "../src/Views/DeviceSummaryWidget.vala"
						_tmp20_ = s;
#line 284 "../src/Views/DeviceSummaryWidget.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 1166 "DeviceSummaryWidget.c"
					}
#line 282 "../src/Views/DeviceSummaryWidget.vala"
					_g_object_unref0 (s);
#line 1170 "DeviceSummaryWidget.c"
				}
#line 282 "../src/Views/DeviceSummaryWidget.vala"
				_g_object_unref0 (_s_it);
#line 1174 "DeviceSummaryWidget.c"
			}
		} else {
			NoisePlaylist* p = NULL;
			NoiseDevicePreferences* _tmp21_;
			NoisePlaylist* _tmp22_;
			NoisePlaylist* _tmp23_;
			NoisePlaylist* _tmp24_;
#line 288 "../src/Views/DeviceSummaryWidget.vala"
			_tmp21_ = self->priv->_preferences;
#line 288 "../src/Views/DeviceSummaryWidget.vala"
			_tmp22_ = noise_device_preferences_get_music_playlist (_tmp21_);
#line 288 "../src/Views/DeviceSummaryWidget.vala"
			_tmp23_ = _tmp22_;
#line 288 "../src/Views/DeviceSummaryWidget.vala"
			p = _tmp23_;
#line 290 "../src/Views/DeviceSummaryWidget.vala"
			_tmp24_ = p;
#line 290 "../src/Views/DeviceSummaryWidget.vala"
			if (_tmp24_ != NULL) {
#line 1194 "DeviceSummaryWidget.c"
				{
					GeeIterator* _m_it = NULL;
					NoisePlaylist* _tmp25_;
					GeeIterator* _tmp26_;
#line 291 "../src/Views/DeviceSummaryWidget.vala"
					_tmp25_ = p;
#line 291 "../src/Views/DeviceSummaryWidget.vala"
					_tmp26_ = noise_playlist_iterator (_tmp25_);
#line 291 "../src/Views/DeviceSummaryWidget.vala"
					_m_it = _tmp26_;
#line 291 "../src/Views/DeviceSummaryWidget.vala"
					while (TRUE) {
#line 1207 "DeviceSummaryWidget.c"
						GeeIterator* _tmp27_;
						NoiseMedia* m = NULL;
						GeeIterator* _tmp28_;
						gpointer _tmp29_;
						NoiseMedia* _tmp30_;
#line 291 "../src/Views/DeviceSummaryWidget.vala"
						_tmp27_ = _m_it;
#line 291 "../src/Views/DeviceSummaryWidget.vala"
						if (!gee_iterator_next (_tmp27_)) {
#line 291 "../src/Views/DeviceSummaryWidget.vala"
							break;
#line 1219 "DeviceSummaryWidget.c"
						}
#line 291 "../src/Views/DeviceSummaryWidget.vala"
						_tmp28_ = _m_it;
#line 291 "../src/Views/DeviceSummaryWidget.vala"
						_tmp29_ = gee_iterator_get (_tmp28_);
#line 291 "../src/Views/DeviceSummaryWidget.vala"
						m = (NoiseMedia*) _tmp29_;
#line 292 "../src/Views/DeviceSummaryWidget.vala"
						_tmp30_ = m;
#line 292 "../src/Views/DeviceSummaryWidget.vala"
						if (_tmp30_ != NULL) {
#line 1231 "DeviceSummaryWidget.c"
							GeeTreeSet* _tmp31_;
							NoiseMedia* _tmp32_;
#line 293 "../src/Views/DeviceSummaryWidget.vala"
							_tmp31_ = list;
#line 293 "../src/Views/DeviceSummaryWidget.vala"
							_tmp32_ = m;
#line 293 "../src/Views/DeviceSummaryWidget.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 1240 "DeviceSummaryWidget.c"
						}
#line 291 "../src/Views/DeviceSummaryWidget.vala"
						_g_object_unref0 (m);
#line 1244 "DeviceSummaryWidget.c"
					}
#line 291 "../src/Views/DeviceSummaryWidget.vala"
					_g_object_unref0 (_m_it);
#line 1248 "DeviceSummaryWidget.c"
				}
			} else {
				NoiseNotificationManager* _tmp33_;
				NoiseNotificationManager* _tmp34_;
				NoiseDevicePreferences* _tmp35_;
				NoisePlaylist* _tmp36_;
				NoisePlaylist* _tmp37_;
				NoisePlaylist* _tmp38_;
				const gchar* _tmp39_;
				const gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				NoiseDevice* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				NoiseDevicePreferences* _tmp54_;
				NoiseDevicePreferences* _tmp55_;
				GtkComboBox* _tmp56_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp33_ = noise_notification_manager_get_default ();
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp34_ = _tmp33_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp35_ = self->priv->_preferences;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp36_ = noise_device_preferences_get_music_playlist (_tmp35_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp37_ = _tmp36_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp38_ = _tmp37_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp39_ = noise_playlist_get_name (_tmp38_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp40_ = _tmp39_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp41_ = g_strconcat ("<b>", _tmp40_, NULL);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp42_ = _tmp41_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp43_ = g_strconcat (_tmp42_, "</b>", NULL);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp44_ = _tmp43_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp45_ = self->priv->_device;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp46_ = noise_device_get_display_name (_tmp45_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp47_ = _tmp46_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp48_ = g_strconcat ("<b>", _tmp47_, NULL);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp49_ = _tmp48_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp50_ = g_strconcat (_tmp49_, "</b>", NULL);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp51_ = _tmp50_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp52_ = g_strdup_printf (_ ("The playlist named %s is used to sync device %s, but could not be foun" \
"d."), _tmp44_, _tmp51_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_tmp53_ = _tmp52_;
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				g_signal_emit_by_name (_tmp34_, "show-alert", _ ("Sync Failed"), _tmp53_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_free0 (_tmp53_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_free0 (_tmp51_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_free0 (_tmp49_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_free0 (_tmp47_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_free0 (_tmp44_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_free0 (_tmp42_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_object_unref0 (_tmp38_);
#line 297 "../src/Views/DeviceSummaryWidget.vala"
				_g_object_unref0 (_tmp34_);
#line 305 "../src/Views/DeviceSummaryWidget.vala"
				_tmp54_ = self->priv->_preferences;
#line 305 "../src/Views/DeviceSummaryWidget.vala"
				noise_device_preferences_set_music_playlist (_tmp54_, NULL);
#line 306 "../src/Views/DeviceSummaryWidget.vala"
				_tmp55_ = self->priv->_preferences;
#line 306 "../src/Views/DeviceSummaryWidget.vala"
				noise_device_preferences_set_sync_all_music (_tmp55_, TRUE);
#line 307 "../src/Views/DeviceSummaryWidget.vala"
				_tmp56_ = self->priv->sync_music_combobox;
#line 307 "../src/Views/DeviceSummaryWidget.vala"
				gtk_combo_box_set_active (_tmp56_, 0);
#line 308 "../src/Views/DeviceSummaryWidget.vala"
				_g_object_unref0 (p);
#line 308 "../src/Views/DeviceSummaryWidget.vala"
				_g_object_unref0 (list);
#line 308 "../src/Views/DeviceSummaryWidget.vala"
				return;
#line 1353 "DeviceSummaryWidget.c"
			}
#line 281 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (p);
#line 1357 "DeviceSummaryWidget.c"
		}
	}
#line 313 "../src/Views/DeviceSummaryWidget.vala"
	_tmp57_ = self->priv->_device;
#line 313 "../src/Views/DeviceSummaryWidget.vala"
	_tmp58_ = list;
#line 313 "../src/Views/DeviceSummaryWidget.vala"
	fits = noise_device_will_fit (_tmp57_, (GeeCollection*) _tmp58_);
#line 314 "../src/Views/DeviceSummaryWidget.vala"
	_tmp59_ = fits;
#line 314 "../src/Views/DeviceSummaryWidget.vala"
	if (!_tmp59_) {
#line 1370 "DeviceSummaryWidget.c"
		NoiseNotificationManager* _tmp60_;
		NoiseNotificationManager* _tmp61_;
#line 315 "../src/Views/DeviceSummaryWidget.vala"
		_tmp60_ = noise_notification_manager_get_default ();
#line 315 "../src/Views/DeviceSummaryWidget.vala"
		_tmp61_ = _tmp60_;
#line 315 "../src/Views/DeviceSummaryWidget.vala"
		g_signal_emit_by_name (_tmp61_, "show-alert", _ ("Cannot Sync"), _ ("Cannot sync device with selected sync settings. Not enough space on di" \
"sk"));
#line 315 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp61_);
#line 1381 "DeviceSummaryWidget.c"
	} else {
		NoiseDevice* _tmp62_;
		NoiseLibrary* _tmp63_;
		NoiseLibrary* _tmp64_;
		gboolean _tmp65_;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_tmp62_ = self->priv->_device;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_tmp63_ = noise_device_get_library (_tmp62_);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_tmp64_ = _tmp63_;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_tmp65_ = noise_library_doing_file_operations (_tmp64_);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp64_);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
		if (_tmp65_) {
#line 1399 "DeviceSummaryWidget.c"
			NoiseNotificationManager* _tmp66_;
			NoiseNotificationManager* _tmp67_;
#line 320 "../src/Views/DeviceSummaryWidget.vala"
			_tmp66_ = noise_notification_manager_get_default ();
#line 320 "../src/Views/DeviceSummaryWidget.vala"
			_tmp67_ = _tmp66_;
#line 320 "../src/Views/DeviceSummaryWidget.vala"
			g_signal_emit_by_name (_tmp67_, "show-alert", _ ("Cannot Sync"), _ ("Device is already doing an operation."));
#line 320 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (_tmp67_);
#line 1410 "DeviceSummaryWidget.c"
		} else {
			Block18Data* _data18_;
			GeeTreeSet* found = NULL;
			GeeTreeSet* _tmp68_;
			GeeTreeSet* _tmp69_;
			NoiseLibrariesManager* _tmp70_;
			NoiseLibrary* _tmp71_;
			NoiseDevice* _tmp72_;
			NoiseLibrary* _tmp73_;
			NoiseLibrary* _tmp74_;
			GeeCollection* _tmp75_;
			GeeCollection* _tmp76_;
			GeeTreeSet* _tmp77_;
			GeeTreeSet* _tmp78_;
			GeeTreeSet* _tmp79_;
			gint _tmp80_;
			gint _tmp81_;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
			_data18_ = g_slice_new0 (Block18Data);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
			_data18_->_ref_count_ = 1;
#line 319 "../src/Views/DeviceSummaryWidget.vala"
			_data18_->self = g_object_ref (self);
#line 325 "../src/Views/DeviceSummaryWidget.vala"
			_tmp68_ = gee_tree_set_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 325 "../src/Views/DeviceSummaryWidget.vala"
			found = _tmp68_;
#line 326 "../src/Views/DeviceSummaryWidget.vala"
			_tmp69_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 326 "../src/Views/DeviceSummaryWidget.vala"
			_data18_->not_found = _tmp69_;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp70_ = noise_libraries_manager;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp71_ = _tmp70_->local_library;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp72_ = self->priv->_device;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp73_ = noise_device_get_library (_tmp72_);
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp74_ = _tmp73_;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp75_ = noise_library_get_medias (_tmp74_);
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp76_ = _tmp75_;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp77_ = found;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_tmp78_ = _data18_->not_found;
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			noise_library_media_from_name (_tmp71_, _tmp76_, (GeeCollection*) _tmp77_, (GeeCollection*) _tmp78_);
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (_tmp76_);
#line 327 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (_tmp74_);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
			_tmp79_ = _data18_->not_found;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
			_tmp80_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp79_);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
			_tmp81_ = _tmp80_;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
			if (_tmp81_ > 0) {
#line 1474 "DeviceSummaryWidget.c"
				Block19Data* _data19_;
				NoiseDevice* _tmp82_;
				GeeTreeSet* _tmp83_;
				GeeTreeSet* _tmp84_;
				NoiseSyncWarningDialog* _tmp85_;
				NoiseSyncWarningDialog* _tmp86_;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
				_data19_ = g_slice_new0 (Block19Data);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
				_data19_->_ref_count_ = 1;
#line 329 "../src/Views/DeviceSummaryWidget.vala"
				_data19_->_data18_ = block18_data_ref (_data18_);
#line 330 "../src/Views/DeviceSummaryWidget.vala"
				_tmp82_ = self->priv->_device;
#line 330 "../src/Views/DeviceSummaryWidget.vala"
				_tmp83_ = list;
#line 330 "../src/Views/DeviceSummaryWidget.vala"
				_tmp84_ = _data18_->not_found;
#line 330 "../src/Views/DeviceSummaryWidget.vala"
				_tmp85_ = noise_sync_warning_dialog_new (_tmp82_, _tmp83_, _tmp84_);
#line 330 "../src/Views/DeviceSummaryWidget.vala"
				g_object_ref_sink (_tmp85_);
#line 330 "../src/Views/DeviceSummaryWidget.vala"
				_data19_->swd = _tmp85_;
#line 331 "../src/Views/DeviceSummaryWidget.vala"
				_tmp86_ = _data19_->swd;
#line 331 "../src/Views/DeviceSummaryWidget.vala"
				g_signal_connect_data ((GtkDialog*) _tmp86_, "response", (GCallback) ______lambda106__gtk_dialog_response, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
				block19_data_unref (_data19_);
#line 329 "../src/Views/DeviceSummaryWidget.vala"
				_data19_ = NULL;
#line 1507 "DeviceSummaryWidget.c"
			} else {
				GtkButton* _tmp87_;
				NoiseDevice* _tmp88_;
#line 349 "../src/Views/DeviceSummaryWidget.vala"
				_tmp87_ = self->priv->sync_button;
#line 349 "../src/Views/DeviceSummaryWidget.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp87_, FALSE);
#line 350 "../src/Views/DeviceSummaryWidget.vala"
				_tmp88_ = self->priv->_device;
#line 350 "../src/Views/DeviceSummaryWidget.vala"
				noise_device_synchronize (_tmp88_);
#line 1519 "DeviceSummaryWidget.c"
			}
#line 319 "../src/Views/DeviceSummaryWidget.vala"
			_g_object_unref0 (found);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
			block18_data_unref (_data18_);
#line 319 "../src/Views/DeviceSummaryWidget.vala"
			_data18_ = NULL;
#line 1527 "DeviceSummaryWidget.c"
		}
	}
#line 277 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (list);
#line 1532 "DeviceSummaryWidget.c"
}


NoiseDevice*
noise_device_summary_widget_get_device (NoiseDeviceSummaryWidget* self)
{
	NoiseDevice* result;
	NoiseDevice* _tmp0_;
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = self->priv->_device;
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	result = _tmp0_;
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	return result;
#line 1549 "DeviceSummaryWidget.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 1558 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_set_device (NoiseDeviceSummaryWidget* self,
                                        NoiseDevice* value)
{
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	if (noise_device_summary_widget_get_device (self) != value) {
#line 1570 "DeviceSummaryWidget.c"
		NoiseDevice* _tmp0_;
#line 30 "../src/Views/DeviceSummaryWidget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (self->priv->_device);
#line 30 "../src/Views/DeviceSummaryWidget.vala"
		self->priv->_device = _tmp0_;
#line 30 "../src/Views/DeviceSummaryWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_device_summary_widget_properties[NOISE_DEVICE_SUMMARY_WIDGET_DEVICE_PROPERTY]);
#line 1580 "DeviceSummaryWidget.c"
	}
}


NoiseDevicePreferences*
noise_device_summary_widget_get_preferences (NoiseDeviceSummaryWidget* self)
{
	NoiseDevicePreferences* result;
	NoiseDevicePreferences* _tmp0_;
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = self->priv->_preferences;
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	result = _tmp0_;
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	return result;
#line 1598 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_set_preferences (NoiseDeviceSummaryWidget* self,
                                             NoiseDevicePreferences* value)
{
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	if (noise_device_summary_widget_get_preferences (self) != value) {
#line 1610 "DeviceSummaryWidget.c"
		NoiseDevicePreferences* _tmp0_;
#line 31 "../src/Views/DeviceSummaryWidget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (self->priv->_preferences);
#line 31 "../src/Views/DeviceSummaryWidget.vala"
		self->priv->_preferences = _tmp0_;
#line 31 "../src/Views/DeviceSummaryWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_device_summary_widget_properties[NOISE_DEVICE_SUMMARY_WIDGET_PREFERENCES_PROPERTY]);
#line 1620 "DeviceSummaryWidget.c"
	}
}


static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	return _data20_;
#line 1632 "DeviceSummaryWidget.c"
}


static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 1643 "DeviceSummaryWidget.c"
		NoiseDeviceSummaryWidget* self;
#line 47 "../src/Views/DeviceSummaryWidget.vala"
		self = _data20_->self;
#line 47 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_data20_->device_name_entry);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (self);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
		g_slice_free (Block20Data, _data20_);
#line 1653 "DeviceSummaryWidget.c"
	}
}


static gboolean
_noise_device_summary_widget_rowSeparatorFunc_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                GtkTreeIter* iter,
                                                                                gpointer self)
{
	gboolean result;
	result = noise_device_summary_widget_rowSeparatorFunc ((NoiseDeviceSummaryWidget*) self, model, iter);
#line 88 "../src/Views/DeviceSummaryWidget.vala"
	return result;
#line 1667 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget_refresh_lists_gtk_combo_box_popup (GtkComboBox* _sender,
                                                                gpointer self)
{
#line 93 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists ((NoiseDeviceSummaryWidget*) self);
#line 1677 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget_save_preferences_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 169 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_save_preferences ((NoiseDeviceSummaryWidget*) self);
#line 1688 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget_save_preferences_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                         gpointer self)
{
#line 170 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_save_preferences ((NoiseDeviceSummaryWidget*) self);
#line 1698 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget_save_preferences_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self)
{
#line 171 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_save_preferences ((NoiseDeviceSummaryWidget*) self);
#line 1708 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda107_ (Block20Data* _data20_)
{
	NoiseDeviceSummaryWidget* self;
	NoiseDevice* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 173 "../src/Views/DeviceSummaryWidget.vala"
	self = _data20_->self;
#line 174 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = self->priv->_device;
#line 174 "../src/Views/DeviceSummaryWidget.vala"
	_tmp1_ = _data20_->device_name_entry;
#line 174 "../src/Views/DeviceSummaryWidget.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 174 "../src/Views/DeviceSummaryWidget.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_set_display_name (_tmp0_, _tmp3_);
#line 1732 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda107__gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self)
{
#line 173 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda107_ (self);
#line 1742 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget_sync_clicked_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 177 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_sync_clicked ((NoiseDeviceSummaryWidget*) self);
#line 1752 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda108_ (NoiseDeviceSummaryWidget* self)
{
	GtkButton* _tmp0_;
#line 180 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_space_widget (self);
#line 181 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = self->priv->sync_button;
#line 181 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 1766 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda108__noise_library_file_operations_done (NoiseLibrary* _sender,
                                                                               gpointer self)
{
#line 179 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda108_ ((NoiseDeviceSummaryWidget*) self);
#line 1776 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda109_ (NoiseDeviceSummaryWidget* self)
{
#line 184 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 1785 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda109__noise_library_playlist_added (NoiseLibrary* _sender,
                                                                         NoiseStaticPlaylist* playlist,
                                                                         gpointer self)
{
#line 184 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda109_ ((NoiseDeviceSummaryWidget*) self);
#line 1796 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda110_ (NoiseDeviceSummaryWidget* self)
{
#line 185 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 1805 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda110__noise_library_playlist_name_updated (NoiseLibrary* _sender,
                                                                                NoiseStaticPlaylist* playlist,
                                                                                gpointer self)
{
#line 185 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda110_ ((NoiseDeviceSummaryWidget*) self);
#line 1816 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda111_ (NoiseDeviceSummaryWidget* self)
{
#line 186 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 1825 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda111__noise_library_playlist_removed (NoiseLibrary* _sender,
                                                                           NoiseStaticPlaylist* playlist,
                                                                           gpointer self)
{
#line 186 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda111_ ((NoiseDeviceSummaryWidget*) self);
#line 1836 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda112_ (NoiseDeviceSummaryWidget* self)
{
#line 187 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 1845 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda112__noise_library_smartplaylist_added (NoiseLibrary* _sender,
                                                                              NoiseSmartPlaylist* smartplaylist,
                                                                              gpointer self)
{
#line 187 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda112_ ((NoiseDeviceSummaryWidget*) self);
#line 1856 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda113_ (NoiseDeviceSummaryWidget* self)
{
#line 188 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 1865 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda113__noise_library_smartplaylist_name_updated (NoiseLibrary* _sender,
                                                                                     NoiseSmartPlaylist* smartplaylist,
                                                                                     gpointer self)
{
#line 188 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda113_ ((NoiseDeviceSummaryWidget*) self);
#line 1876 "DeviceSummaryWidget.c"
}


static void
_noise_device_summary_widget___lambda114_ (NoiseDeviceSummaryWidget* self)
{
#line 189 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 1885 "DeviceSummaryWidget.c"
}


static void
__noise_device_summary_widget___lambda114__noise_library_smartplaylist_removed (NoiseLibrary* _sender,
                                                                                NoiseSmartPlaylist* smartplaylist,
                                                                                gpointer self)
{
#line 189 "../src/Views/DeviceSummaryWidget.vala"
	_noise_device_summary_widget___lambda114_ ((NoiseDeviceSummaryWidget*) self);
#line 1896 "DeviceSummaryWidget.c"
}


static GObject *
noise_device_summary_widget_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseDeviceSummaryWidget * self;
	Block20Data* _data20_;
	GtkStyleContext* _tmp0_;
	gchar* _tmp1_ = NULL;
	NoiseDevice* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* device_name_title_label = NULL;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkStyleContext* _tmp10_;
	gchar* _tmp11_ = NULL;
	NoiseDevice* _tmp12_;
	gchar* _tmp13_;
	GtkLabel* device_name_description_label = NULL;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkLabel* device_name_label = NULL;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkLabel* auto_sync_label = NULL;
	GtkLabel* _tmp23_;
	GtkLabel* _tmp24_;
	GtkSwitch* _tmp25_;
	GtkSwitch* _tmp26_;
	GtkLabel* sync_options_label = NULL;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkCheckButton* _tmp29_;
	GtkListStore* _tmp30_;
	GtkCellRendererPixbuf* music_cell = NULL;
	GtkCellRendererPixbuf* _tmp31_;
	GtkCellRendererPixbuf* _tmp32_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp33_;
	GtkCellRendererText* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkListStore* _tmp37_;
	GtkComboBox* _tmp38_;
	GtkComboBox* _tmp39_;
	GtkComboBox* _tmp40_;
	GtkCellRendererPixbuf* _tmp41_;
	GtkComboBox* _tmp42_;
	GtkCellRendererPixbuf* _tmp43_;
	GtkComboBox* _tmp44_;
	GtkCellRendererText* _tmp45_;
	GtkComboBox* _tmp46_;
	GtkCellRendererText* _tmp47_;
	GtkComboBox* _tmp48_;
	GtkComboBox* _tmp49_;
	NoiseDevice* _tmp50_;
	GraniteWidgetsStorageBar* _tmp51_;
	GraniteWidgetsStorageBar* _tmp52_;
	GraniteWidgetsStorageBar* _tmp53_;
	GtkButton* _tmp54_;
	GtkButton* _tmp55_;
	GtkButton* _tmp56_;
	GtkGrid* storage_grid = NULL;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GraniteWidgetsStorageBar* _tmp61_;
	GtkGrid* _tmp62_;
	GtkButton* _tmp63_;
	GtkGrid* storage_toolbar = NULL;
	GtkGrid* _tmp64_;
	GtkGrid* _tmp65_;
	GtkGrid* _tmp66_;
	GtkGrid* _tmp67_;
	GtkGrid* _tmp68_;
	GtkStyleContext* _tmp69_;
	GtkGrid* content_grid = NULL;
	GtkGrid* _tmp70_;
	GtkGrid* _tmp71_;
	GtkGrid* _tmp72_;
	GtkGrid* _tmp73_;
	GtkGrid* _tmp74_;
	GtkGrid* _tmp75_;
	GtkLabel* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	GtkGrid* _tmp84_;
	GtkLabel* _tmp85_;
	GtkGrid* _tmp86_;
	GtkLabel* _tmp87_;
	GtkGrid* _tmp88_;
	GtkEntry* _tmp89_;
	GtkGrid* _tmp90_;
	GtkLabel* _tmp91_;
	GtkGrid* _tmp92_;
	GtkSwitch* _tmp93_;
	GtkGrid* _tmp94_;
	GtkLabel* _tmp95_;
	GtkGrid* _tmp96_;
	GtkCheckButton* _tmp97_;
	GtkGrid* _tmp98_;
	GtkComboBox* _tmp99_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp100_;
	GtkGrid* _tmp101_;
	GtkGrid* _tmp102_;
	GtkGrid* _tmp103_;
	GtkGrid* _tmp104_;
	GtkGrid* _tmp105_;
	NoiseDevice* _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	gboolean _tmp109_;
	GtkSwitch* _tmp114_;
	NoiseDevicePreferences* _tmp115_;
	gboolean _tmp116_;
	gboolean _tmp117_;
	GtkCheckButton* _tmp118_;
	NoiseDevicePreferences* _tmp119_;
	gboolean _tmp120_;
	gboolean _tmp121_;
	gboolean _tmp122_ = FALSE;
	NoiseDevicePreferences* _tmp123_;
	gboolean _tmp124_;
	gboolean _tmp125_;
	GtkSwitch* _tmp143_;
	GtkCheckButton* _tmp144_;
	GtkComboBox* _tmp145_;
	GtkEntry* _tmp146_;
	GtkButton* _tmp147_;
	NoiseDevice* _tmp148_;
	NoiseLibrary* _tmp149_;
	NoiseLibrary* _tmp150_;
	NoiseLibrariesManager* _tmp151_;
	NoiseLibrary* _tmp152_;
	NoiseLibrariesManager* _tmp153_;
	NoiseLibrary* _tmp154_;
	NoiseLibrariesManager* _tmp155_;
	NoiseLibrary* _tmp156_;
	NoiseLibrariesManager* _tmp157_;
	NoiseLibrary* _tmp158_;
	NoiseLibrariesManager* _tmp159_;
	NoiseLibrary* _tmp160_;
	NoiseLibrariesManager* _tmp161_;
	NoiseLibrary* _tmp162_;
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	parent_class = G_OBJECT_CLASS (noise_device_summary_widget_parent_class);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_data20_->_ref_count_ = 1;
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_data20_->self = g_object_ref (self);
#line 48 "../src/Views/DeviceSummaryWidget.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 48 "../src/Views/DeviceSummaryWidget.vala"
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_VIEW);
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	_tmp2_ = self->priv->_device;
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	_tmp3_ = noise_device_get_display_name (_tmp2_);
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	_tmp1_ = _tmp3_;
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp1_ == NULL) {
#line 2079 "DeviceSummaryWidget.c"
		gchar* _tmp4_;
#line 50 "../src/Views/DeviceSummaryWidget.vala"
		_tmp4_ = g_strdup ("");
#line 50 "../src/Views/DeviceSummaryWidget.vala"
		_g_free0 (_tmp1_);
#line 50 "../src/Views/DeviceSummaryWidget.vala"
		_tmp1_ = _tmp4_;
#line 2087 "DeviceSummaryWidget.c"
	}
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp1_);
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp5_);
#line 50 "../src/Views/DeviceSummaryWidget.vala"
	device_name_title_label = _tmp5_;
#line 51 "../src/Views/DeviceSummaryWidget.vala"
	_tmp6_ = device_name_title_label;
#line 51 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
#line 52 "../src/Views/DeviceSummaryWidget.vala"
	_tmp7_ = device_name_title_label;
#line 52 "../src/Views/DeviceSummaryWidget.vala"
	g_object_set ((GtkWidget*) _tmp7_, "margin", 20, NULL);
#line 53 "../src/Views/DeviceSummaryWidget.vala"
	_tmp8_ = device_name_title_label;
#line 53 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp8_, 0);
#line 54 "../src/Views/DeviceSummaryWidget.vala"
	_tmp9_ = device_name_title_label;
#line 54 "../src/Views/DeviceSummaryWidget.vala"
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
#line 54 "../src/Views/DeviceSummaryWidget.vala"
	gtk_style_context_add_class (_tmp10_, GRANITE_STYLE_CLASS_H1_LABEL);
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	_tmp12_ = self->priv->_device;
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	_tmp13_ = noise_device_get_fancy_description (_tmp12_);
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	_tmp11_ = _tmp13_;
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp11_ == NULL) {
#line 2121 "DeviceSummaryWidget.c"
		gchar* _tmp14_;
#line 56 "../src/Views/DeviceSummaryWidget.vala"
		_tmp14_ = g_strdup ("");
#line 56 "../src/Views/DeviceSummaryWidget.vala"
		_g_free0 (_tmp11_);
#line 56 "../src/Views/DeviceSummaryWidget.vala"
		_tmp11_ = _tmp14_;
#line 2129 "DeviceSummaryWidget.c"
	}
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	_tmp15_ = (GtkLabel*) gtk_label_new (_tmp11_);
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp15_);
#line 56 "../src/Views/DeviceSummaryWidget.vala"
	device_name_description_label = _tmp15_;
#line 57 "../src/Views/DeviceSummaryWidget.vala"
	_tmp16_ = device_name_description_label;
#line 57 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 58 "../src/Views/DeviceSummaryWidget.vala"
	_tmp17_ = device_name_description_label;
#line 58 "../src/Views/DeviceSummaryWidget.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 58 "../src/Views/DeviceSummaryWidget.vala"
	gtk_style_context_add_class (_tmp18_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 60 "../src/Views/DeviceSummaryWidget.vala"
	_tmp19_ = (GtkLabel*) gtk_label_new (_ ("Device Name:"));
#line 60 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp19_);
#line 60 "../src/Views/DeviceSummaryWidget.vala"
	device_name_label = _tmp19_;
#line 61 "../src/Views/DeviceSummaryWidget.vala"
	_tmp20_ = device_name_label;
#line 61 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_END);
#line 63 "../src/Views/DeviceSummaryWidget.vala"
	_tmp21_ = (GtkEntry*) gtk_entry_new ();
#line 63 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp21_);
#line 63 "../src/Views/DeviceSummaryWidget.vala"
	_data20_->device_name_entry = _tmp21_;
#line 64 "../src/Views/DeviceSummaryWidget.vala"
	_tmp22_ = _data20_->device_name_entry;
#line 64 "../src/Views/DeviceSummaryWidget.vala"
	gtk_entry_set_placeholder_text (_tmp22_, _ ("Device Name"));
#line 66 "../src/Views/DeviceSummaryWidget.vala"
	_tmp23_ = (GtkLabel*) gtk_label_new (_ ("Automatically sync when plugged in:"));
#line 66 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp23_);
#line 66 "../src/Views/DeviceSummaryWidget.vala"
	auto_sync_label = _tmp23_;
#line 67 "../src/Views/DeviceSummaryWidget.vala"
	_tmp24_ = auto_sync_label;
#line 67 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp24_, GTK_ALIGN_END);
#line 69 "../src/Views/DeviceSummaryWidget.vala"
	_tmp25_ = (GtkSwitch*) gtk_switch_new ();
#line 69 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp25_);
#line 69 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->auto_sync_switch);
#line 69 "../src/Views/DeviceSummaryWidget.vala"
	self->priv->auto_sync_switch = _tmp25_;
#line 70 "../src/Views/DeviceSummaryWidget.vala"
	_tmp26_ = self->priv->auto_sync_switch;
#line 70 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp26_, GTK_ALIGN_START);
#line 72 "../src/Views/DeviceSummaryWidget.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Sync:"));
#line 72 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp27_);
#line 72 "../src/Views/DeviceSummaryWidget.vala"
	sync_options_label = _tmp27_;
#line 73 "../src/Views/DeviceSummaryWidget.vala"
	_tmp28_ = sync_options_label;
#line 73 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_END);
#line 75 "../src/Views/DeviceSummaryWidget.vala"
	_tmp29_ = (GtkCheckButton*) gtk_check_button_new ();
#line 75 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp29_);
#line 75 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->sync_music_check);
#line 75 "../src/Views/DeviceSummaryWidget.vala"
	self->priv->sync_music_check = _tmp29_;
#line 77 "../src/Views/DeviceSummaryWidget.vala"
	_tmp30_ = gtk_list_store_new (3, G_TYPE_OBJECT, G_TYPE_STRING, g_icon_get_type (), -1);
#line 77 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->music_list);
#line 77 "../src/Views/DeviceSummaryWidget.vala"
	self->priv->music_list = _tmp30_;
#line 79 "../src/Views/DeviceSummaryWidget.vala"
	_tmp31_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 79 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp31_);
#line 79 "../src/Views/DeviceSummaryWidget.vala"
	music_cell = _tmp31_;
#line 80 "../src/Views/DeviceSummaryWidget.vala"
	_tmp32_ = music_cell;
#line 80 "../src/Views/DeviceSummaryWidget.vala"
	g_object_set (_tmp32_, "stock-size", (guint) GTK_ICON_SIZE_MENU, NULL);
#line 82 "../src/Views/DeviceSummaryWidget.vala"
	_tmp33_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 82 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp33_);
#line 82 "../src/Views/DeviceSummaryWidget.vala"
	cell = _tmp33_;
#line 83 "../src/Views/DeviceSummaryWidget.vala"
	_tmp34_ = cell;
#line 83 "../src/Views/DeviceSummaryWidget.vala"
	g_object_set (_tmp34_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 85 "../src/Views/DeviceSummaryWidget.vala"
	_tmp35_ = (GtkComboBox*) gtk_combo_box_new ();
#line 85 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp35_);
#line 85 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->sync_music_combobox);
#line 85 "../src/Views/DeviceSummaryWidget.vala"
	self->priv->sync_music_combobox = _tmp35_;
#line 86 "../src/Views/DeviceSummaryWidget.vala"
	_tmp36_ = self->priv->sync_music_combobox;
#line 86 "../src/Views/DeviceSummaryWidget.vala"
	_tmp37_ = self->priv->music_list;
#line 86 "../src/Views/DeviceSummaryWidget.vala"
	gtk_combo_box_set_model (_tmp36_, (GtkTreeModel*) _tmp37_);
#line 87 "../src/Views/DeviceSummaryWidget.vala"
	_tmp38_ = self->priv->sync_music_combobox;
#line 87 "../src/Views/DeviceSummaryWidget.vala"
	gtk_combo_box_set_id_column (_tmp38_, 1);
#line 88 "../src/Views/DeviceSummaryWidget.vala"
	_tmp39_ = self->priv->sync_music_combobox;
#line 88 "../src/Views/DeviceSummaryWidget.vala"
	gtk_combo_box_set_row_separator_func (_tmp39_, _noise_device_summary_widget_rowSeparatorFunc_gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
#line 89 "../src/Views/DeviceSummaryWidget.vala"
	_tmp40_ = self->priv->sync_music_combobox;
#line 89 "../src/Views/DeviceSummaryWidget.vala"
	_tmp41_ = music_cell;
#line 89 "../src/Views/DeviceSummaryWidget.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp40_, (GtkCellRenderer*) _tmp41_, FALSE);
#line 90 "../src/Views/DeviceSummaryWidget.vala"
	_tmp42_ = self->priv->sync_music_combobox;
#line 90 "../src/Views/DeviceSummaryWidget.vala"
	_tmp43_ = music_cell;
#line 90 "../src/Views/DeviceSummaryWidget.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp42_, (GtkCellRenderer*) _tmp43_, "gicon", 2);
#line 91 "../src/Views/DeviceSummaryWidget.vala"
	_tmp44_ = self->priv->sync_music_combobox;
#line 91 "../src/Views/DeviceSummaryWidget.vala"
	_tmp45_ = cell;
#line 91 "../src/Views/DeviceSummaryWidget.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp44_, (GtkCellRenderer*) _tmp45_, TRUE);
#line 92 "../src/Views/DeviceSummaryWidget.vala"
	_tmp46_ = self->priv->sync_music_combobox;
#line 92 "../src/Views/DeviceSummaryWidget.vala"
	_tmp47_ = cell;
#line 92 "../src/Views/DeviceSummaryWidget.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp46_, (GtkCellRenderer*) _tmp47_, "text", 1);
#line 93 "../src/Views/DeviceSummaryWidget.vala"
	_tmp48_ = self->priv->sync_music_combobox;
#line 93 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp48_, "popup", (GCallback) _noise_device_summary_widget_refresh_lists_gtk_combo_box_popup, self, 0);
#line 94 "../src/Views/DeviceSummaryWidget.vala"
	_tmp49_ = self->priv->sync_music_combobox;
#line 94 "../src/Views/DeviceSummaryWidget.vala"
	gtk_combo_box_set_button_sensitivity (_tmp49_, GTK_SENSITIVITY_ON);
#line 96 "../src/Views/DeviceSummaryWidget.vala"
	_tmp50_ = self->priv->_device;
#line 96 "../src/Views/DeviceSummaryWidget.vala"
	_tmp51_ = granite_widgets_storage_bar_new (noise_device_get_capacity (_tmp50_));
#line 96 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp51_);
#line 96 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->storagebar);
#line 96 "../src/Views/DeviceSummaryWidget.vala"
	self->priv->storagebar = _tmp51_;
#line 97 "../src/Views/DeviceSummaryWidget.vala"
	_tmp52_ = self->priv->storagebar;
#line 97 "../src/Views/DeviceSummaryWidget.vala"
	granite_widgets_storage_bar_update_block_size (_tmp52_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_OTHER, (guint64) 0);
#line 98 "../src/Views/DeviceSummaryWidget.vala"
	_tmp53_ = self->priv->storagebar;
#line 98 "../src/Views/DeviceSummaryWidget.vala"
	granite_widgets_storage_bar_update_block_size (_tmp53_, GRANITE_WIDGETS_STORAGE_BAR_ITEM_DESCRIPTION_AUDIO, (guint64) 0);
#line 100 "../src/Views/DeviceSummaryWidget.vala"
	_tmp54_ = (GtkButton*) gtk_button_new_with_label (_ ("Sync"));
#line 100 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp54_);
#line 100 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->sync_button);
#line 100 "../src/Views/DeviceSummaryWidget.vala"
	self->priv->sync_button = _tmp54_;
#line 101 "../src/Views/DeviceSummaryWidget.vala"
	_tmp55_ = self->priv->sync_button;
#line 101 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
#line 102 "../src/Views/DeviceSummaryWidget.vala"
	_tmp56_ = self->priv->sync_button;
#line 102 "../src/Views/DeviceSummaryWidget.vala"
	g_object_set ((GtkWidget*) _tmp56_, "width-request", 80, NULL);
#line 104 "../src/Views/DeviceSummaryWidget.vala"
	_tmp57_ = (GtkGrid*) gtk_grid_new ();
#line 104 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp57_);
#line 104 "../src/Views/DeviceSummaryWidget.vala"
	storage_grid = _tmp57_;
#line 105 "../src/Views/DeviceSummaryWidget.vala"
	_tmp58_ = storage_grid;
#line 105 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_set_column_spacing (_tmp58_, 6);
#line 106 "../src/Views/DeviceSummaryWidget.vala"
	_tmp59_ = storage_grid;
#line 106 "../src/Views/DeviceSummaryWidget.vala"
	g_object_set ((GtkWidget*) _tmp59_, "margin", 24, NULL);
#line 107 "../src/Views/DeviceSummaryWidget.vala"
	_tmp60_ = storage_grid;
#line 107 "../src/Views/DeviceSummaryWidget.vala"
	_tmp61_ = self->priv->storagebar;
#line 107 "../src/Views/DeviceSummaryWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp60_, (GtkWidget*) _tmp61_);
#line 108 "../src/Views/DeviceSummaryWidget.vala"
	_tmp62_ = storage_grid;
#line 108 "../src/Views/DeviceSummaryWidget.vala"
	_tmp63_ = self->priv->sync_button;
#line 108 "../src/Views/DeviceSummaryWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
#line 110 "../src/Views/DeviceSummaryWidget.vala"
	_tmp64_ = (GtkGrid*) gtk_grid_new ();
#line 110 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp64_);
#line 110 "../src/Views/DeviceSummaryWidget.vala"
	storage_toolbar = _tmp64_;
#line 111 "../src/Views/DeviceSummaryWidget.vala"
	_tmp65_ = storage_toolbar;
#line 111 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp65_, GTK_ALIGN_END);
#line 112 "../src/Views/DeviceSummaryWidget.vala"
	_tmp66_ = storage_toolbar;
#line 112 "../src/Views/DeviceSummaryWidget.vala"
	_tmp67_ = storage_grid;
#line 112 "../src/Views/DeviceSummaryWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp66_, (GtkWidget*) _tmp67_);
#line 113 "../src/Views/DeviceSummaryWidget.vala"
	_tmp68_ = storage_toolbar;
#line 113 "../src/Views/DeviceSummaryWidget.vala"
	_tmp69_ = gtk_widget_get_style_context ((GtkWidget*) _tmp68_);
#line 113 "../src/Views/DeviceSummaryWidget.vala"
	gtk_style_context_add_class (_tmp69_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
#line 115 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_space_widget (self);
#line 117 "../src/Views/DeviceSummaryWidget.vala"
	_tmp70_ = (GtkGrid*) gtk_grid_new ();
#line 117 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp70_);
#line 117 "../src/Views/DeviceSummaryWidget.vala"
	content_grid = _tmp70_;
#line 118 "../src/Views/DeviceSummaryWidget.vala"
	_tmp71_ = content_grid;
#line 118 "../src/Views/DeviceSummaryWidget.vala"
	g_object_set ((GtkWidget*) _tmp71_, "expand", TRUE, NULL);
#line 119 "../src/Views/DeviceSummaryWidget.vala"
	_tmp72_ = content_grid;
#line 119 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp72_, GTK_ALIGN_CENTER);
#line 120 "../src/Views/DeviceSummaryWidget.vala"
	_tmp73_ = content_grid;
#line 120 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_set_row_spacing (_tmp73_, 6);
#line 121 "../src/Views/DeviceSummaryWidget.vala"
	_tmp74_ = content_grid;
#line 121 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_set_column_spacing (_tmp74_, 12);
#line 122 "../src/Views/DeviceSummaryWidget.vala"
	_tmp75_ = content_grid;
#line 122 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp75_, 12);
#line 125 "../src/Views/DeviceSummaryWidget.vala"
	_tmp76_ = device_name_description_label;
#line 125 "../src/Views/DeviceSummaryWidget.vala"
	_tmp77_ = gtk_label_get_label (_tmp76_);
#line 125 "../src/Views/DeviceSummaryWidget.vala"
	_tmp78_ = _tmp77_;
#line 125 "../src/Views/DeviceSummaryWidget.vala"
	if (g_strcmp0 (_tmp78_, "") == 0) {
#line 2405 "DeviceSummaryWidget.c"
		GtkGrid* _tmp79_;
		GtkLabel* _tmp80_;
		GtkLabel* _tmp81_;
#line 126 "../src/Views/DeviceSummaryWidget.vala"
		_tmp79_ = content_grid;
#line 126 "../src/Views/DeviceSummaryWidget.vala"
		_tmp80_ = device_name_title_label;
#line 126 "../src/Views/DeviceSummaryWidget.vala"
		gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 0, 0, 5, 1);
#line 127 "../src/Views/DeviceSummaryWidget.vala"
		_tmp81_ = device_name_title_label;
#line 127 "../src/Views/DeviceSummaryWidget.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp81_, GTK_ALIGN_FILL);
#line 2419 "DeviceSummaryWidget.c"
	} else {
		GtkGrid* _tmp82_;
		GtkLabel* _tmp83_;
#line 129 "../src/Views/DeviceSummaryWidget.vala"
		_tmp82_ = content_grid;
#line 129 "../src/Views/DeviceSummaryWidget.vala"
		_tmp83_ = device_name_title_label;
#line 129 "../src/Views/DeviceSummaryWidget.vala"
		gtk_grid_attach (_tmp82_, (GtkWidget*) _tmp83_, 0, 0, 2, 1);
#line 2429 "DeviceSummaryWidget.c"
	}
#line 132 "../src/Views/DeviceSummaryWidget.vala"
	_tmp84_ = content_grid;
#line 132 "../src/Views/DeviceSummaryWidget.vala"
	_tmp85_ = device_name_description_label;
#line 132 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 2, 0, 3, 1);
#line 133 "../src/Views/DeviceSummaryWidget.vala"
	_tmp86_ = content_grid;
#line 133 "../src/Views/DeviceSummaryWidget.vala"
	_tmp87_ = device_name_label;
#line 133 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp87_, 1, 1, 1, 1);
#line 134 "../src/Views/DeviceSummaryWidget.vala"
	_tmp88_ = content_grid;
#line 134 "../src/Views/DeviceSummaryWidget.vala"
	_tmp89_ = _data20_->device_name_entry;
#line 134 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp88_, (GtkWidget*) _tmp89_, 2, 1, 2, 1);
#line 135 "../src/Views/DeviceSummaryWidget.vala"
	_tmp90_ = content_grid;
#line 135 "../src/Views/DeviceSummaryWidget.vala"
	_tmp91_ = auto_sync_label;
#line 135 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp90_, (GtkWidget*) _tmp91_, 1, 2, 1, 1);
#line 136 "../src/Views/DeviceSummaryWidget.vala"
	_tmp92_ = content_grid;
#line 136 "../src/Views/DeviceSummaryWidget.vala"
	_tmp93_ = self->priv->auto_sync_switch;
#line 136 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp92_, (GtkWidget*) _tmp93_, 2, 2, 2, 1);
#line 137 "../src/Views/DeviceSummaryWidget.vala"
	_tmp94_ = content_grid;
#line 137 "../src/Views/DeviceSummaryWidget.vala"
	_tmp95_ = sync_options_label;
#line 137 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 1, 3, 1, 1);
#line 138 "../src/Views/DeviceSummaryWidget.vala"
	_tmp96_ = content_grid;
#line 138 "../src/Views/DeviceSummaryWidget.vala"
	_tmp97_ = self->priv->sync_music_check;
#line 138 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp96_, (GtkWidget*) _tmp97_, 2, 3, 1, 1);
#line 139 "../src/Views/DeviceSummaryWidget.vala"
	_tmp98_ = content_grid;
#line 139 "../src/Views/DeviceSummaryWidget.vala"
	_tmp99_ = self->priv->sync_music_combobox;
#line 139 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp98_, (GtkWidget*) _tmp99_, 3, 3, 1, 1);
#line 141 "../src/Views/DeviceSummaryWidget.vala"
	_tmp100_ = (GtkGrid*) gtk_grid_new ();
#line 141 "../src/Views/DeviceSummaryWidget.vala"
	g_object_ref_sink (_tmp100_);
#line 141 "../src/Views/DeviceSummaryWidget.vala"
	main_grid = _tmp100_;
#line 142 "../src/Views/DeviceSummaryWidget.vala"
	_tmp101_ = main_grid;
#line 142 "../src/Views/DeviceSummaryWidget.vala"
	_tmp102_ = content_grid;
#line 142 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp101_, (GtkWidget*) _tmp102_, 0, 0, 1, 1);
#line 143 "../src/Views/DeviceSummaryWidget.vala"
	_tmp103_ = main_grid;
#line 143 "../src/Views/DeviceSummaryWidget.vala"
	_tmp104_ = storage_toolbar;
#line 143 "../src/Views/DeviceSummaryWidget.vala"
	gtk_grid_attach (_tmp103_, (GtkWidget*) _tmp104_, 0, 1, 1, 1);
#line 145 "../src/Views/DeviceSummaryWidget.vala"
	_tmp105_ = main_grid;
#line 145 "../src/Views/DeviceSummaryWidget.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp105_);
#line 147 "../src/Views/DeviceSummaryWidget.vala"
	_tmp106_ = self->priv->_device;
#line 147 "../src/Views/DeviceSummaryWidget.vala"
	_tmp107_ = noise_device_get_display_name (_tmp106_);
#line 147 "../src/Views/DeviceSummaryWidget.vala"
	_tmp108_ = _tmp107_;
#line 147 "../src/Views/DeviceSummaryWidget.vala"
	_tmp109_ = g_strcmp0 (_tmp108_, "") != 0;
#line 147 "../src/Views/DeviceSummaryWidget.vala"
	_g_free0 (_tmp108_);
#line 147 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp109_) {
#line 2513 "DeviceSummaryWidget.c"
		GtkEntry* _tmp110_;
		NoiseDevice* _tmp111_;
		gchar* _tmp112_;
		gchar* _tmp113_;
#line 148 "../src/Views/DeviceSummaryWidget.vala"
		_tmp110_ = _data20_->device_name_entry;
#line 148 "../src/Views/DeviceSummaryWidget.vala"
		_tmp111_ = self->priv->_device;
#line 148 "../src/Views/DeviceSummaryWidget.vala"
		_tmp112_ = noise_device_get_display_name (_tmp111_);
#line 148 "../src/Views/DeviceSummaryWidget.vala"
		_tmp113_ = _tmp112_;
#line 148 "../src/Views/DeviceSummaryWidget.vala"
		gtk_entry_set_text (_tmp110_, _tmp113_);
#line 148 "../src/Views/DeviceSummaryWidget.vala"
		_g_free0 (_tmp113_);
#line 2530 "DeviceSummaryWidget.c"
	}
#line 151 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_refresh_lists (self);
#line 154 "../src/Views/DeviceSummaryWidget.vala"
	_tmp114_ = self->priv->auto_sync_switch;
#line 154 "../src/Views/DeviceSummaryWidget.vala"
	_tmp115_ = self->priv->_preferences;
#line 154 "../src/Views/DeviceSummaryWidget.vala"
	_tmp116_ = noise_device_preferences_get_sync_when_mounted (_tmp115_);
#line 154 "../src/Views/DeviceSummaryWidget.vala"
	_tmp117_ = _tmp116_;
#line 154 "../src/Views/DeviceSummaryWidget.vala"
	gtk_switch_set_active (_tmp114_, _tmp117_);
#line 155 "../src/Views/DeviceSummaryWidget.vala"
	_tmp118_ = self->priv->sync_music_check;
#line 155 "../src/Views/DeviceSummaryWidget.vala"
	_tmp119_ = self->priv->_preferences;
#line 155 "../src/Views/DeviceSummaryWidget.vala"
	_tmp120_ = noise_device_preferences_get_sync_music (_tmp119_);
#line 155 "../src/Views/DeviceSummaryWidget.vala"
	_tmp121_ = _tmp120_;
#line 155 "../src/Views/DeviceSummaryWidget.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp118_, _tmp121_);
#line 157 "../src/Views/DeviceSummaryWidget.vala"
	_tmp123_ = self->priv->_preferences;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
	_tmp124_ = noise_device_preferences_get_sync_all_music (_tmp123_);
#line 157 "../src/Views/DeviceSummaryWidget.vala"
	_tmp125_ = _tmp124_;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp125_) {
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_tmp122_ = TRUE;
#line 2564 "DeviceSummaryWidget.c"
	} else {
		NoiseDevicePreferences* _tmp126_;
		NoisePlaylist* _tmp127_;
		NoisePlaylist* _tmp128_;
		NoisePlaylist* _tmp129_;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_tmp126_ = self->priv->_preferences;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_tmp127_ = noise_device_preferences_get_music_playlist (_tmp126_);
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_tmp128_ = _tmp127_;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_tmp129_ = _tmp128_;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_tmp122_ = _tmp129_ == NULL;
#line 157 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp129_);
#line 2582 "DeviceSummaryWidget.c"
	}
#line 157 "../src/Views/DeviceSummaryWidget.vala"
	if (_tmp122_) {
#line 2586 "DeviceSummaryWidget.c"
		GtkComboBox* _tmp130_;
#line 158 "../src/Views/DeviceSummaryWidget.vala"
		_tmp130_ = self->priv->sync_music_combobox;
#line 158 "../src/Views/DeviceSummaryWidget.vala"
		gtk_combo_box_set_active (_tmp130_, 0);
#line 2592 "DeviceSummaryWidget.c"
	} else {
		gboolean success = FALSE;
		GtkComboBox* _tmp131_;
		NoiseDevicePreferences* _tmp132_;
		NoisePlaylist* _tmp133_;
		NoisePlaylist* _tmp134_;
		NoisePlaylist* _tmp135_;
		const gchar* _tmp136_;
		const gchar* _tmp137_;
		gboolean _tmp138_;
		gboolean _tmp139_;
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp131_ = self->priv->sync_music_combobox;
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp132_ = self->priv->_preferences;
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp133_ = noise_device_preferences_get_music_playlist (_tmp132_);
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp134_ = _tmp133_;
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp135_ = _tmp134_;
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp136_ = noise_playlist_get_name (_tmp135_);
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp137_ = _tmp136_;
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_tmp138_ = gtk_combo_box_set_active_id (_tmp131_, _tmp137_);
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		_g_object_unref0 (_tmp135_);
#line 160 "../src/Views/DeviceSummaryWidget.vala"
		success = _tmp138_;
#line 161 "../src/Views/DeviceSummaryWidget.vala"
		_tmp139_ = success;
#line 161 "../src/Views/DeviceSummaryWidget.vala"
		if (!_tmp139_) {
#line 2628 "DeviceSummaryWidget.c"
			NoiseDevicePreferences* _tmp140_;
			NoiseDevicePreferences* _tmp141_;
			GtkComboBox* _tmp142_;
#line 162 "../src/Views/DeviceSummaryWidget.vala"
			_tmp140_ = self->priv->_preferences;
#line 162 "../src/Views/DeviceSummaryWidget.vala"
			noise_device_preferences_set_music_playlist (_tmp140_, NULL);
#line 163 "../src/Views/DeviceSummaryWidget.vala"
			_tmp141_ = self->priv->_preferences;
#line 163 "../src/Views/DeviceSummaryWidget.vala"
			noise_device_preferences_set_sync_all_music (_tmp141_, TRUE);
#line 164 "../src/Views/DeviceSummaryWidget.vala"
			_tmp142_ = self->priv->sync_music_combobox;
#line 164 "../src/Views/DeviceSummaryWidget.vala"
			gtk_combo_box_set_active (_tmp142_, 0);
#line 2644 "DeviceSummaryWidget.c"
		}
	}
#line 169 "../src/Views/DeviceSummaryWidget.vala"
	_tmp143_ = self->priv->auto_sync_switch;
#line 169 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object ((GObject*) _tmp143_, "notify::active", (GCallback) _noise_device_summary_widget_save_preferences_g_object_notify, self, 0);
#line 170 "../src/Views/DeviceSummaryWidget.vala"
	_tmp144_ = self->priv->sync_music_check;
#line 170 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp144_, "toggled", (GCallback) _noise_device_summary_widget_save_preferences_gtk_toggle_button_toggled, self, 0);
#line 171 "../src/Views/DeviceSummaryWidget.vala"
	_tmp145_ = self->priv->sync_music_combobox;
#line 171 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp145_, "changed", (GCallback) _noise_device_summary_widget_save_preferences_gtk_combo_box_changed, self, 0);
#line 173 "../src/Views/DeviceSummaryWidget.vala"
	_tmp146_ = _data20_->device_name_entry;
#line 173 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_data ((GtkEditable*) _tmp146_, "changed", (GCallback) __noise_device_summary_widget___lambda107__gtk_editable_changed, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
#line 177 "../src/Views/DeviceSummaryWidget.vala"
	_tmp147_ = self->priv->sync_button;
#line 177 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp147_, "clicked", (GCallback) _noise_device_summary_widget_sync_clicked_gtk_button_clicked, self, 0);
#line 179 "../src/Views/DeviceSummaryWidget.vala"
	_tmp148_ = self->priv->_device;
#line 179 "../src/Views/DeviceSummaryWidget.vala"
	_tmp149_ = noise_device_get_library (_tmp148_);
#line 179 "../src/Views/DeviceSummaryWidget.vala"
	_tmp150_ = _tmp149_;
#line 179 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp150_, "file-operations-done", (GCallback) __noise_device_summary_widget___lambda108__noise_library_file_operations_done, self, 0);
#line 179 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (_tmp150_);
#line 184 "../src/Views/DeviceSummaryWidget.vala"
	_tmp151_ = noise_libraries_manager;
#line 184 "../src/Views/DeviceSummaryWidget.vala"
	_tmp152_ = _tmp151_->local_library;
#line 184 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp152_, "playlist-added", (GCallback) __noise_device_summary_widget___lambda109__noise_library_playlist_added, self, 0);
#line 185 "../src/Views/DeviceSummaryWidget.vala"
	_tmp153_ = noise_libraries_manager;
#line 185 "../src/Views/DeviceSummaryWidget.vala"
	_tmp154_ = _tmp153_->local_library;
#line 185 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp154_, "playlist-name-updated", (GCallback) __noise_device_summary_widget___lambda110__noise_library_playlist_name_updated, self, 0);
#line 186 "../src/Views/DeviceSummaryWidget.vala"
	_tmp155_ = noise_libraries_manager;
#line 186 "../src/Views/DeviceSummaryWidget.vala"
	_tmp156_ = _tmp155_->local_library;
#line 186 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp156_, "playlist-removed", (GCallback) __noise_device_summary_widget___lambda111__noise_library_playlist_removed, self, 0);
#line 187 "../src/Views/DeviceSummaryWidget.vala"
	_tmp157_ = noise_libraries_manager;
#line 187 "../src/Views/DeviceSummaryWidget.vala"
	_tmp158_ = _tmp157_->local_library;
#line 187 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp158_, "smartplaylist-added", (GCallback) __noise_device_summary_widget___lambda112__noise_library_smartplaylist_added, self, 0);
#line 188 "../src/Views/DeviceSummaryWidget.vala"
	_tmp159_ = noise_libraries_manager;
#line 188 "../src/Views/DeviceSummaryWidget.vala"
	_tmp160_ = _tmp159_->local_library;
#line 188 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp160_, "smartplaylist-name-updated", (GCallback) __noise_device_summary_widget___lambda113__noise_library_smartplaylist_name_updated, self, 0);
#line 189 "../src/Views/DeviceSummaryWidget.vala"
	_tmp161_ = noise_libraries_manager;
#line 189 "../src/Views/DeviceSummaryWidget.vala"
	_tmp162_ = _tmp161_->local_library;
#line 189 "../src/Views/DeviceSummaryWidget.vala"
	g_signal_connect_object (_tmp162_, "smartplaylist-removed", (GCallback) __noise_device_summary_widget___lambda114__noise_library_smartplaylist_removed, self, 0);
#line 190 "../src/Views/DeviceSummaryWidget.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (main_grid);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (content_grid);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (storage_toolbar);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (storage_grid);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (cell);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (music_cell);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (sync_options_label);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (auto_sync_label);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (device_name_label);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (device_name_description_label);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_free0 (_tmp11_);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (device_name_title_label);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_g_free0 (_tmp1_);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	block20_data_unref (_data20_);
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	_data20_ = NULL;
#line 47 "../src/Views/DeviceSummaryWidget.vala"
	return obj;
#line 2747 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_class_init (NoiseDeviceSummaryWidgetClass * klass)
{
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	noise_device_summary_widget_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	g_type_class_adjust_private_offset (klass, &NoiseDeviceSummaryWidget_private_offset);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_device_summary_widget_get_property;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_device_summary_widget_set_property;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_device_summary_widget_constructor;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_device_summary_widget_finalize;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_SUMMARY_WIDGET_DEVICE_PROPERTY, noise_device_summary_widget_properties[NOISE_DEVICE_SUMMARY_WIDGET_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", NOISE_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_DEVICE_SUMMARY_WIDGET_PREFERENCES_PROPERTY, noise_device_summary_widget_properties[NOISE_DEVICE_SUMMARY_WIDGET_PREFERENCES_PROPERTY] = g_param_spec_object ("preferences", "preferences", "preferences", NOISE_TYPE_DEVICE_PREFERENCES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2770 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_instance_init (NoiseDeviceSummaryWidget * self)
{
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	self->priv = noise_device_summary_widget_get_instance_private (self);
#line 2779 "DeviceSummaryWidget.c"
}


static void
noise_device_summary_widget_finalize (GObject * obj)
{
	NoiseDeviceSummaryWidget * self;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget);
#line 30 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->_device);
#line 31 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->_preferences);
#line 33 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->sync_button);
#line 34 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->sync_music_check);
#line 35 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->sync_music_combobox);
#line 36 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->music_list);
#line 37 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->auto_sync_switch);
#line 38 "../src/Views/DeviceSummaryWidget.vala"
	_g_object_unref0 (self->priv->storagebar);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	G_OBJECT_CLASS (noise_device_summary_widget_parent_class)->finalize (obj);
#line 2807 "DeviceSummaryWidget.c"
}


GType
noise_device_summary_widget_get_type (void)
{
	static volatile gsize noise_device_summary_widget_type_id__volatile = 0;
	if (g_once_init_enter (&noise_device_summary_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseDeviceSummaryWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_device_summary_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseDeviceSummaryWidget), 0, (GInstanceInitFunc) noise_device_summary_widget_instance_init, NULL };
		GType noise_device_summary_widget_type_id;
		noise_device_summary_widget_type_id = g_type_register_static (gtk_event_box_get_type (), "NoiseDeviceSummaryWidget", &g_define_type_info, 0);
		NoiseDeviceSummaryWidget_private_offset = g_type_add_instance_private (noise_device_summary_widget_type_id, sizeof (NoiseDeviceSummaryWidgetPrivate));
		g_once_init_leave (&noise_device_summary_widget_type_id__volatile, noise_device_summary_widget_type_id);
	}
	return noise_device_summary_widget_type_id__volatile;
}


static void
_vala_noise_device_summary_widget_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseDeviceSummaryWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	switch (property_id) {
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_DEVICE_SUMMARY_WIDGET_DEVICE_PROPERTY:
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		g_value_set_object (value, noise_device_summary_widget_get_device (self));
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_DEVICE_SUMMARY_WIDGET_PREFERENCES_PROPERTY:
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		g_value_set_object (value, noise_device_summary_widget_get_preferences (self));
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 2848 "DeviceSummaryWidget.c"
		default:
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 2854 "DeviceSummaryWidget.c"
	}
}


static void
_vala_noise_device_summary_widget_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseDeviceSummaryWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_DEVICE_SUMMARY_WIDGET, NoiseDeviceSummaryWidget);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
	switch (property_id) {
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_DEVICE_SUMMARY_WIDGET_DEVICE_PROPERTY:
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		noise_device_summary_widget_set_device (self, g_value_get_object (value));
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		case NOISE_DEVICE_SUMMARY_WIDGET_PREFERENCES_PROPERTY:
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		noise_device_summary_widget_set_preferences (self, g_value_get_object (value));
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 2881 "DeviceSummaryWidget.c"
		default:
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Views/DeviceSummaryWidget.vala"
		break;
#line 2887 "DeviceSummaryWidget.c"
	}
}



