/* BrowserColumnModel.c generated by valac 0.42.6, the Vala compiler
 * generated from BrowserColumnModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>
#include "io.elementary.music-core.h"


#define NOISE_TYPE_BROWSER_COLUMN_MODEL (noise_browser_column_model_get_type ())
#define NOISE_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel))
#define NOISE_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelClass))
#define NOISE_IS_BROWSER_COLUMN_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL))
#define NOISE_IS_BROWSER_COLUMN_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_BROWSER_COLUMN_MODEL))
#define NOISE_BROWSER_COLUMN_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModelClass))

typedef struct _NoiseBrowserColumnModel NoiseBrowserColumnModel;
typedef struct _NoiseBrowserColumnModelClass NoiseBrowserColumnModelClass;
typedef struct _NoiseBrowserColumnModelPrivate NoiseBrowserColumnModelPrivate;
typedef enum  {
	NOISE_BROWSER_COLUMN_CATEGORY_RATING,
	NOISE_BROWSER_COLUMN_CATEGORY_GROUPING,
	NOISE_BROWSER_COLUMN_CATEGORY_YEAR,
	NOISE_BROWSER_COLUMN_CATEGORY_GENRE,
	NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER,
	NOISE_BROWSER_COLUMN_CATEGORY_ARTIST,
	NOISE_BROWSER_COLUMN_CATEGORY_ALBUM,
	NOISE_BROWSER_COLUMN_CATEGORY_N_CATEGORIES
} NoiseBrowserColumnCategory;


#define NOISE_BROWSER_COLUMN_TYPE_CATEGORY (noise_browser_column_category_get_type ())
enum  {
	NOISE_BROWSER_COLUMN_MODEL_0_PROPERTY,
	NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY,
	NOISE_BROWSER_COLUMN_MODEL_NUM_PROPERTIES
};
static GParamSpec* noise_browser_column_model_properties[NOISE_BROWSER_COLUMN_MODEL_NUM_PROPERTIES];
#define _g_sequence_free0(var) ((var == NULL) ? NULL : (var = (g_sequence_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NoiseBrowserColumnModel {
	GObject parent_instance;
	NoiseBrowserColumnModelPrivate * priv;
};

struct _NoiseBrowserColumnModelClass {
	GObjectClass parent_class;
};

struct _NoiseBrowserColumnModelPrivate {
	gint stamp;
	GSequence* rows;
	GtkTreeIter* first_iter;
	gint sort_column_id;
	GtkSortType sort_direction;
	GtkTreeIterCompareFunc default_sort_func;
	gpointer default_sort_func_target;
	NoiseBrowserColumnCategory category;
};


static gint NoiseBrowserColumnModel_private_offset;
static gpointer noise_browser_column_model_parent_class = NULL;
static GtkTreeModelIface * noise_browser_column_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * noise_browser_column_model_gtk_tree_sortable_parent_iface = NULL;

GType noise_browser_column_model_get_type (void) G_GNUC_CONST;
GType noise_browser_column_category_get_type (void) G_GNUC_CONST;
NoiseBrowserColumnModel* noise_browser_column_model_new (NoiseBrowserColumnCategory category);
NoiseBrowserColumnModel* noise_browser_column_model_construct (GType object_type,
                                                               NoiseBrowserColumnCategory category);
static void _g_free0_ (gpointer var);
static GtkTreeModelFlags noise_browser_column_model_real_get_flags (GtkTreeModel* base);
static gboolean noise_browser_column_model_real_get_iter (GtkTreeModel* base,
                                                   GtkTreeIter* iter,
                                                   GtkTreePath* path);
static gint noise_browser_column_model_real_get_n_columns (GtkTreeModel* base);
static GType noise_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                       gint col);
static GtkTreePath* noise_browser_column_model_real_get_path (GtkTreeModel* base,
                                                       GtkTreeIter* iter);
static void noise_browser_column_model_real_get_value (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                gint column,
                                                GValue* val);
static gboolean noise_browser_column_model_real_iter_children (GtkTreeModel* base,
                                                        GtkTreeIter* iter,
                                                        GtkTreeIter* parent);
static gboolean noise_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter);
static gint noise_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                      GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_iter_next (GtkTreeModel* base,
                                                    GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                         GtkTreeIter* iter,
                                                         GtkTreeIter* parent,
                                                         gint n);
static gboolean noise_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                                      GtkTreeIter* iter,
                                                      GtkTreeIter* child);
static void noise_browser_column_model_real_ref_node (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static void noise_browser_column_model_real_unref_node (GtkTreeModel* base,
                                                 GtkTreeIter* iter);
void noise_browser_column_model_append (NoiseBrowserColumnModel* self,
                                        GtkTreeIter* iter);
void noise_browser_column_model_append_items (NoiseBrowserColumnModel* self,
                                              GeeCollection* strings,
                                              gboolean emit);
static void noise_browser_column_model_add_first_element (NoiseBrowserColumnModel* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void noise_browser_column_model_update_first_item (NoiseBrowserColumnModel* self);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static gchar* noise_browser_column_model_get_first_item_text (NoiseBrowserColumnModel* self,
                                                       gint n_items);
gint noise_browser_column_model_get_n_items (NoiseBrowserColumnModel* self);
void noise_browser_column_model_set (NoiseBrowserColumnModel* self,
                                     GtkTreeIter* iter,
                                     ...);
void noise_browser_column_model_remove (NoiseBrowserColumnModel* self,
                                        GtkTreeIter* iter);
static gboolean noise_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                             gint* sort_column_id,
                                                             GtkSortType* order);
static gboolean noise_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base);
static void noise_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                            GtkTreeIterCompareFunc sort_func,
                                                            gpointer sort_func_target,
                                                            GDestroyNotify sort_func_target_destroy_notify);
static void noise_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                         gint sort_column_id,
                                                         GtkSortType order);
gint noise_browser_column_model_sequenceIterCompareFunc (NoiseBrowserColumnModel* self,
                                                         GSequenceIter* a,
                                                         GSequenceIter* b);
static gint _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                      GSequenceIter* b,
                                                                                      gpointer self);
static void noise_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkTreeIterCompareFunc sort_func,
                                                    gpointer sort_func_target,
                                                    GDestroyNotify sort_func_target_destroy_notify);
static void noise_browser_column_model_finalize (GObject * obj);
static void _vala_noise_browser_column_model_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);


static inline gpointer
noise_browser_column_model_get_instance_private (NoiseBrowserColumnModel* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseBrowserColumnModel_private_offset);
}


/** Initialize data storage, columns, etc. **/
static void
_g_free0_ (gpointer var)
{
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	var = (g_free (var), NULL);
#line 204 "BrowserColumnModel.c"
}


NoiseBrowserColumnModel*
noise_browser_column_model_construct (GType object_type,
                                      NoiseBrowserColumnCategory category)
{
	NoiseBrowserColumnModel * self = NULL;
	GSequence* _tmp0_;
#line 50 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) g_object_new (object_type, NULL);
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_sequence_new (_g_free0_);
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_sequence_free0 (self->priv->rows);
#line 51 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->rows = _tmp0_;
#line 53 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->category = category;
#line 55 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_column_id = -2;
#line 56 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_direction = GTK_SORT_ASCENDING;
#line 50 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return self;
#line 230 "BrowserColumnModel.c"
}


NoiseBrowserColumnModel*
noise_browser_column_model_new (NoiseBrowserColumnCategory category)
{
#line 50 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return noise_browser_column_model_construct (NOISE_TYPE_BROWSER_COLUMN_MODEL, category);
#line 239 "BrowserColumnModel.c"
}


/** Returns a set of flags supported by this interface **/
static GtkTreeModelFlags
noise_browser_column_model_real_get_flags (GtkTreeModel* base)
{
	NoiseBrowserColumnModel * self;
	GtkTreeModelFlags result = 0;
#line 60 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 61 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = GTK_TREE_MODEL_LIST_ONLY;
#line 61 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 255 "BrowserColumnModel.c"
}


/** Sets iter to a valid iterator pointing to path **/
static gboolean
noise_browser_column_model_real_get_iter (GtkTreeModel* base,
                                          GtkTreeIter* iter,
                                          GtkTreePath* path)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gint path_index = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GSequence* _tmp5_;
	GSequenceIter* seq_iter = NULL;
	GSequence* _tmp9_;
	gint _tmp10_;
	GSequenceIter* _tmp11_;
	GSequenceIter* _tmp12_;
	gint _tmp13_;
	GSequenceIter* _tmp14_;
#line 65 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 65 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 66 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 67 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
#line 67 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = _tmp1_[0];
#line 67 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	path_index = _tmp2_;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = self->priv->rows;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (g_sequence_get_length (_tmp5_) == 0) {
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = TRUE;
#line 300 "BrowserColumnModel.c"
	} else {
		gint _tmp6_;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp6_ = path_index;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = _tmp6_ < 0;
#line 307 "BrowserColumnModel.c"
	}
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp4_) {
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = TRUE;
#line 313 "BrowserColumnModel.c"
	} else {
		gint _tmp7_;
		GSequence* _tmp8_;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp7_ = path_index;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp8_ = self->priv->rows;
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = _tmp7_ >= g_sequence_get_length (_tmp8_);
#line 323 "BrowserColumnModel.c"
	}
#line 69 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp3_) {
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 333 "BrowserColumnModel.c"
		}
#line 70 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 337 "BrowserColumnModel.c"
	}
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = self->priv->rows;
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp10_ = path_index;
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp11_ = g_sequence_get_iter_at_pos (_tmp9_, _tmp10_);
#line 72 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	seq_iter = _tmp11_;
#line 73 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp12_ = seq_iter;
#line 73 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp12_ == NULL) {
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 357 "BrowserColumnModel.c"
		}
#line 74 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 361 "BrowserColumnModel.c"
	}
#line 76 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp13_ = self->priv->stamp;
#line 76 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = _tmp13_;
#line 77 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp14_ = seq_iter;
#line 77 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = _tmp14_;
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 377 "BrowserColumnModel.c"
	}
#line 79 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 381 "BrowserColumnModel.c"
}


/** Returns the number of columns supported by tree_model. **/
static gint
noise_browser_column_model_real_get_n_columns (GtkTreeModel* base)
{
	NoiseBrowserColumnModel * self;
	gint result = 0;
#line 83 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 84 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = 1;
#line 84 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 397 "BrowserColumnModel.c"
}


static GType
noise_browser_column_model_real_get_column_type (GtkTreeModel* base,
                                                 gint col)
{
	NoiseBrowserColumnModel * self;
	GType result = 0UL;
#line 87 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 88 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = G_TYPE_STRING;
#line 88 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 413 "BrowserColumnModel.c"
}


/** Returns a newly-created Gtk.TreePath referenced by iter. **/
static GtkTreePath*
noise_browser_column_model_real_get_path (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	GtkTreePath* result = NULL;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
#line 92 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 92 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.user_data;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_strdup_printf ("%i", g_sequence_iter_get_position ((GSequenceIter*) _tmp1_));
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = _tmp2_;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = _tmp4_;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (_tmp3_);
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp5_;
#line 93 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 452 "BrowserColumnModel.c"
}


/** Initializes and sets value to that at column. **/
static void
noise_browser_column_model_real_get_value (GtkTreeModel* base,
                                           GtkTreeIter* iter,
                                           gint column,
                                           GValue* val)
{
	NoiseBrowserColumnModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkTreeIter _tmp6_;
	void* _tmp7_;
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 98 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_value_init (&_tmp0_, G_TYPE_STRING);
#line 98 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 98 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_val = _tmp0_;
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = *iter;
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = _tmp3_.stamp;
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = self->priv->stamp;
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp4_ != _tmp5_) {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = TRUE;
#line 493 "BrowserColumnModel.c"
	} else {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = column < 0;
#line 497 "BrowserColumnModel.c"
	}
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp2_) {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = TRUE;
#line 503 "BrowserColumnModel.c"
	} else {
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = column >= 1;
#line 507 "BrowserColumnModel.c"
	}
#line 99 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_) {
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (val) {
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*val = _vala_val;
#line 515 "BrowserColumnModel.c"
		} else {
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 519 "BrowserColumnModel.c"
		}
#line 100 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 523 "BrowserColumnModel.c"
	}
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = *iter;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = _tmp6_.user_data;
#line 102 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (!g_sequence_iter_is_end ((GSequenceIter*) _tmp7_)) {
#line 531 "BrowserColumnModel.c"
		GtkTreeIter _tmp8_;
		void* _tmp9_;
		gconstpointer _tmp10_;
		GValue _tmp11_ = {0};
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp8_ = *iter;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp9_ = _tmp8_.user_data;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp10_ = g_sequence_get ((GSequenceIter*) _tmp9_);
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_init (&_tmp11_, G_TYPE_STRING);
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_set_string (&_tmp11_, (const gchar*) _tmp10_);
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 103 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_vala_val = _tmp11_;
#line 550 "BrowserColumnModel.c"
	}
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (val) {
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*val = _vala_val;
#line 556 "BrowserColumnModel.c"
	} else {
#line 97 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 560 "BrowserColumnModel.c"
	}
}


/** Sets iter to point to the first child of parent. **/
static gboolean
noise_browser_column_model_real_iter_children (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
#line 108 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 109 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 584 "BrowserColumnModel.c"
	}
#line 111 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 588 "BrowserColumnModel.c"
}


/** Returns true if iter has children, false otherwise. **/
static gboolean
noise_browser_column_model_real_iter_has_child (GtkTreeModel* base,
                                                GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
#line 115 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 115 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 117 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 607 "BrowserColumnModel.c"
}


/** Returns the number of children that iter has. **/
static gint
noise_browser_column_model_real_iter_n_children (GtkTreeModel* base,
                                                 GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	gint result = 0;
#line 121 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 122 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter == NULL) {
#line 622 "BrowserColumnModel.c"
		GSequence* _tmp0_;
#line 123 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = self->priv->rows;
#line 123 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = g_sequence_get_length (_tmp0_);
#line 123 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 630 "BrowserColumnModel.c"
	}
#line 125 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = 0;
#line 125 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 636 "BrowserColumnModel.c"
}


/** Sets iter to point to the node following it at the current level. **/
static gboolean
noise_browser_column_model_real_iter_next (GtkTreeModel* base,
                                           GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GSequenceIter* _tmp5_;
	GtkTreeIter _tmp6_;
	void* _tmp7_;
#line 129 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 129 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = self->priv->stamp;
#line 130 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 131 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 671 "BrowserColumnModel.c"
	}
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = *iter;
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = _tmp3_.user_data;
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = g_sequence_iter_next ((GSequenceIter*) _tmp4_);
#line 133 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*iter).user_data = _tmp5_;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = *iter;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = _tmp6_.user_data;
#line 135 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (g_sequence_iter_is_end ((GSequenceIter*) _tmp7_)) {
#line 136 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 136 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 691 "BrowserColumnModel.c"
	}
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 138 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 697 "BrowserColumnModel.c"
}


/** Sets iter to be the child of parent, using the given index. **/
static gboolean
noise_browser_column_model_real_iter_nth_child (GtkTreeModel* base,
                                                GtkTreeIter* iter,
                                                GtkTreeIter* parent,
                                                gint n)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp3_;
	GSequence* _tmp4_;
	GSequenceIter* _tmp5_;
#line 142 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 143 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (n < 0) {
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = TRUE;
#line 724 "BrowserColumnModel.c"
	} else {
		GSequence* _tmp2_;
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = self->priv->rows;
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = n >= g_sequence_get_length (_tmp2_);
#line 731 "BrowserColumnModel.c"
	}
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_) {
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = TRUE;
#line 737 "BrowserColumnModel.c"
	} else {
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = parent != NULL;
#line 741 "BrowserColumnModel.c"
	}
#line 144 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_) {
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = FALSE;
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (iter) {
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			*iter = _vala_iter;
#line 751 "BrowserColumnModel.c"
		}
#line 145 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 755 "BrowserColumnModel.c"
	}
#line 147 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = self->priv->stamp;
#line 147 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = _tmp3_;
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = self->priv->rows;
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = g_sequence_get_iter_at_pos (_tmp4_, n);
#line 148 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = _tmp5_;
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 773 "BrowserColumnModel.c"
	}
#line 150 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 777 "BrowserColumnModel.c"
}


/** Sets iter to be the parent of child. **/
static gboolean
noise_browser_column_model_real_iter_parent (GtkTreeModel* base,
                                             GtkTreeIter* iter,
                                             GtkTreeIter* child)
{
	NoiseBrowserColumnModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 154 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (child != NULL, FALSE);
#line 155 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = FALSE;
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 802 "BrowserColumnModel.c"
	}
#line 157 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 806 "BrowserColumnModel.c"
}


/** Lets the tree ref the node. **/
static void
noise_browser_column_model_real_ref_node (GtkTreeModel* base,
                                          GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
#line 161 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 161 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 820 "BrowserColumnModel.c"
}


/** Lets the tree unref the node. **/
static void
noise_browser_column_model_real_unref_node (GtkTreeModel* base,
                                            GtkTreeIter* iter)
{
	NoiseBrowserColumnModel * self;
#line 164 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 164 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 834 "BrowserColumnModel.c"
}


/** simply adds iter to the model **/
void
noise_browser_column_model_append (NoiseBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	gint _tmp3_;
#line 167 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_strdup ("");
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
#line 169 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	added = _tmp2_;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = self->priv->stamp;
#line 170 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.stamp = _tmp3_;
#line 171 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_iter.user_data = added;
#line 167 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (iter) {
#line 167 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*iter = _vala_iter;
#line 871 "BrowserColumnModel.c"
	}
}


/** convenience method to insert strings into the model. No iters returned. **/
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 882 "BrowserColumnModel.c"
}


void
noise_browser_column_model_append_items (NoiseBrowserColumnModel* self,
                                         GeeCollection* strings,
                                         gboolean emit)
{
	GtkTreeIter* _tmp0_;
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (strings != NULL);
#line 176 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->first_iter;
#line 176 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_ == NULL) {
#line 177 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		noise_browser_column_model_add_first_element (self);
#line 902 "BrowserColumnModel.c"
	}
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) strings);
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_s_it = _tmp1_;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		while (TRUE) {
#line 913 "BrowserColumnModel.c"
			GeeIterator* _tmp2_;
			gchar* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GSequenceIter* added = NULL;
			GSequence* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			GSequenceIter* _tmp8_;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp2_ = _s_it;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				break;
#line 929 "BrowserColumnModel.c"
			}
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp3_ = _s_it;
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			s = (gchar*) _tmp4_;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp5_ = self->priv->rows;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp6_ = s;
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp8_ = g_sequence_append (_tmp5_, _tmp7_);
#line 180 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			added = _tmp8_;
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (emit) {
#line 949 "BrowserColumnModel.c"
				GtkTreePath* path = NULL;
				GSequenceIter* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				GtkTreePath* _tmp12_;
				GtkTreePath* _tmp13_;
				GtkTreeIter iter = {0};
				gint _tmp14_;
				GSequenceIter* _tmp15_;
				GtkTreePath* _tmp16_;
				GtkTreeIter _tmp17_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp9_ = added;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp10_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp9_));
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp11_ = _tmp10_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp12_ = gtk_tree_path_new_from_string (_tmp11_);
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp13_ = _tmp12_;
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (_tmp11_);
#line 183 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				path = _tmp13_;
#line 184 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				memset (&iter, 0, sizeof (GtkTreeIter));
#line 186 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp14_ = self->priv->stamp;
#line 186 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				iter.stamp = _tmp14_;
#line 187 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp15_ = added;
#line 187 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				iter.user_data = _tmp15_;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp16_ = path;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp17_ = iter;
#line 189 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				gtk_tree_model_row_inserted ((GtkTreeModel*) self, _tmp16_, &_tmp17_);
#line 182 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				__vala_GtkTreePath_free0 (path);
#line 993 "BrowserColumnModel.c"
			}
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_g_free0 (s);
#line 997 "BrowserColumnModel.c"
		}
#line 179 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_g_object_unref0 (_s_it);
#line 1001 "BrowserColumnModel.c"
	}
#line 193 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_update_first_item (self);
#line 1005 "BrowserColumnModel.c"
}


static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return dup;
#line 1019 "BrowserColumnModel.c"
}


static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 1028 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_add_first_element (NoiseBrowserColumnModel* self)
{
	GSequenceIter* added = NULL;
	GSequence* _tmp0_;
	gchar* _tmp1_;
	GSequenceIter* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeIter* _tmp4_;
	GtkTreeIter* _tmp5_;
	gint _tmp6_;
	GtkTreeIter* _tmp7_;
#line 197 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = g_strdup ("All");
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = g_sequence_append (_tmp0_, _tmp1_);
#line 198 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	added = _tmp2_;
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	memset (&_tmp3_, 0, sizeof (GtkTreeIter));
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = __gtk_tree_iter_dup0 (&_tmp3_);
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (self->priv->first_iter);
#line 200 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->first_iter = _tmp4_;
#line 202 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = self->priv->first_iter;
#line 202 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = self->priv->stamp;
#line 202 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*_tmp5_).stamp = _tmp6_;
#line 203 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = self->priv->first_iter;
#line 203 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(*_tmp7_).user_data = added;
#line 1072 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_update_first_item (NoiseBrowserColumnModel* self)
{
	GtkTreeIter* _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
#line 207 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->first_iter;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = (*_tmp0_).user_data;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = noise_browser_column_model_get_n_items (self);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = _tmp2_;
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = noise_browser_column_model_get_first_item_text (self, _tmp3_);
#line 208 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_sequence_set ((GSequenceIter*) _tmp1_, _tmp4_);
#line 1098 "BrowserColumnModel.c"
}


static gchar*
noise_browser_column_model_get_first_item_text (NoiseBrowserColumnModel* self,
                                                gint n_items)
{
	gchar* result = NULL;
	gchar* rv = NULL;
	gchar* _tmp0_;
	NoiseBrowserColumnCategory _tmp1_;
#line 213 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 214 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = g_strdup ("");
#line 214 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	rv = _tmp0_;
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->category;
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	switch (_tmp1_) {
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_GENRE:
#line 1122 "BrowserColumnModel.c"
		{
#line 218 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1126 "BrowserColumnModel.c"
				gchar* _tmp2_;
#line 219 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp2_ = g_strdup (_ ("All Genres"));
#line 219 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 219 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp2_;
#line 1134 "BrowserColumnModel.c"
			} else {
#line 220 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1138 "BrowserColumnModel.c"
					gchar* _tmp3_;
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp3_ = g_strdup_printf (_ ("All %i Genres"), n_items);
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 221 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp3_;
#line 1146 "BrowserColumnModel.c"
				} else {
					gchar* _tmp4_;
#line 223 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp4_ = g_strdup (_ ("No Genres"));
#line 223 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 223 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp4_;
#line 1155 "BrowserColumnModel.c"
				}
			}
#line 224 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1160 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_ARTIST:
#line 1164 "BrowserColumnModel.c"
		{
#line 227 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1168 "BrowserColumnModel.c"
				gchar* _tmp5_;
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp5_ = g_strdup (_ ("All Artists"));
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 228 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp5_;
#line 1176 "BrowserColumnModel.c"
			} else {
#line 229 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1180 "BrowserColumnModel.c"
					gchar* _tmp6_;
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp6_ = g_strdup_printf (_ ("All %i Artists"), n_items);
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 230 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp6_;
#line 1188 "BrowserColumnModel.c"
				} else {
					gchar* _tmp7_;
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp7_ = g_strdup (_ ("No Artists"));
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 232 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp7_;
#line 1197 "BrowserColumnModel.c"
				}
			}
#line 233 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1202 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_ALBUM:
#line 1206 "BrowserColumnModel.c"
		{
#line 236 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1210 "BrowserColumnModel.c"
				gchar* _tmp8_;
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp8_ = g_strdup (_ ("All Albums"));
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 237 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp8_;
#line 1218 "BrowserColumnModel.c"
			} else {
#line 238 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1222 "BrowserColumnModel.c"
					gchar* _tmp9_;
#line 239 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp9_ = g_strdup_printf (_ ("All %i Albums"), n_items);
#line 239 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 239 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp9_;
#line 1230 "BrowserColumnModel.c"
				} else {
					gchar* _tmp10_;
#line 241 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp10_ = g_strdup (_ ("No Albums"));
#line 241 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 241 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp10_;
#line 1239 "BrowserColumnModel.c"
				}
			}
#line 242 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1244 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_YEAR:
#line 1248 "BrowserColumnModel.c"
		{
#line 245 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1252 "BrowserColumnModel.c"
				gchar* _tmp11_;
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp11_ = g_strdup (_ ("All Years"));
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 246 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp11_;
#line 1260 "BrowserColumnModel.c"
			} else {
#line 247 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1264 "BrowserColumnModel.c"
					gchar* _tmp12_;
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp12_ = g_strdup_printf (_ ("All %i Years"), n_items);
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 248 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp12_;
#line 1272 "BrowserColumnModel.c"
				} else {
					gchar* _tmp13_;
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp13_ = g_strdup (_ ("No Years"));
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 250 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp13_;
#line 1281 "BrowserColumnModel.c"
				}
			}
#line 251 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1286 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_RATING:
#line 1290 "BrowserColumnModel.c"
		{
#line 254 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items >= 1) {
#line 1294 "BrowserColumnModel.c"
				gchar* _tmp14_;
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp14_ = g_strdup (_ ("All Ratings"));
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 255 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp14_;
#line 1302 "BrowserColumnModel.c"
			} else {
				gchar* _tmp15_;
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp15_ = g_strdup (_ ("No Ratings"));
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 257 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp15_;
#line 1311 "BrowserColumnModel.c"
			}
#line 258 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1315 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_GROUPING:
#line 1319 "BrowserColumnModel.c"
		{
#line 261 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1323 "BrowserColumnModel.c"
				gchar* _tmp16_;
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp16_ = g_strdup (_ ("All Groupings"));
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 262 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp16_;
#line 1331 "BrowserColumnModel.c"
			} else {
#line 263 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1335 "BrowserColumnModel.c"
					gchar* _tmp17_;
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp17_ = g_strdup_printf (_ ("All %i Groupings"), n_items);
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 264 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp17_;
#line 1343 "BrowserColumnModel.c"
				} else {
					gchar* _tmp18_;
#line 266 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp18_ = g_strdup (_ ("No Groupings"));
#line 266 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 266 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp18_;
#line 1352 "BrowserColumnModel.c"
				}
			}
#line 267 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1357 "BrowserColumnModel.c"
		}
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_CATEGORY_COMPOSER:
#line 1361 "BrowserColumnModel.c"
		{
#line 270 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (n_items == 1) {
#line 1365 "BrowserColumnModel.c"
				gchar* _tmp19_;
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp19_ = g_strdup (_ ("All Composers"));
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (rv);
#line 271 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = _tmp19_;
#line 1373 "BrowserColumnModel.c"
			} else {
#line 272 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (n_items > 1) {
#line 1377 "BrowserColumnModel.c"
					gchar* _tmp20_;
#line 273 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp20_ = g_strdup_printf (_ ("All %i Composers"), n_items);
#line 273 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 273 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp20_;
#line 1385 "BrowserColumnModel.c"
				} else {
					gchar* _tmp21_;
#line 275 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp21_ = g_strdup (_ ("No Composers"));
#line 275 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_g_free0 (rv);
#line 275 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = _tmp21_;
#line 1394 "BrowserColumnModel.c"
				}
			}
#line 276 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			break;
#line 1399 "BrowserColumnModel.c"
		}
		default:
#line 216 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 1404 "BrowserColumnModel.c"
	}
#line 279 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = rv;
#line 279 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1410 "BrowserColumnModel.c"
}


void
noise_browser_column_model_set (NoiseBrowserColumnModel* self,
                                GtkTreeIter* iter,
                                ...)
{
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	va_list args = {0};
#line 283 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 284 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 284 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 284 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = self->priv->stamp;
#line 284 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 285 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 1437 "BrowserColumnModel.c"
	}
#line 287 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	va_start (args, iter);
#line 289 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	while (TRUE) {
#line 1443 "BrowserColumnModel.c"
		gint col = 0;
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
#line 290 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		col = va_arg (args, gint);
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = col;
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp4_ < 0) {
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp3_ = TRUE;
#line 1455 "BrowserColumnModel.c"
		} else {
			gint _tmp5_;
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp5_ = col;
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp3_ = _tmp5_ >= 1;
#line 1462 "BrowserColumnModel.c"
		}
#line 291 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp3_) {
#line 292 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			va_end (args);
#line 292 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			return;
#line 1470 "BrowserColumnModel.c"
		} else {
			gint _tmp6_;
#line 293 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp6_ = col;
#line 293 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (_tmp6_ == 0) {
#line 1477 "BrowserColumnModel.c"
				gchar* val = NULL;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				GtkTreeIter _tmp9_;
				void* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
#line 294 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp7_ = va_arg (args, gchar*);
#line 294 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 294 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				val = _tmp8_;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp9_ = *iter;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp10_ = _tmp9_.user_data;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp11_ = val;
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 295 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				g_sequence_set ((GSequenceIter*) _tmp10_, _tmp12_);
#line 293 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_g_free0 (val);
#line 1503 "BrowserColumnModel.c"
			}
		}
	}
#line 283 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	va_end (args);
#line 1509 "BrowserColumnModel.c"
}


void
noise_browser_column_model_remove (NoiseBrowserColumnModel* self,
                                   GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GSequenceIter* sequence_iter = NULL;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreePath* path = NULL;
	GSequenceIter* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* _tmp9_;
	GSequenceIter* _tmp10_;
	GtkTreePath* _tmp11_;
#line 300 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_if_fail (iter != NULL);
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = *iter;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp2_ = self->priv->stamp;
#line 301 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 302 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return;
#line 1545 "BrowserColumnModel.c"
	}
#line 304 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp3_ = *iter;
#line 304 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = _tmp3_.user_data;
#line 304 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sequence_iter = (GSequenceIter*) _tmp4_;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp5_ = sequence_iter;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp6_ = g_strdup_printf ("%i", g_sequence_iter_get_position (_tmp5_));
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp7_ = _tmp6_;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp8_ = gtk_tree_path_new_from_string (_tmp7_);
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp9_ = _tmp8_;
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (_tmp7_);
#line 305 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	path = _tmp9_;
#line 306 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp10_ = sequence_iter;
#line 306 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_sequence_remove (_tmp10_);
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp11_ = path;
#line 307 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp11_);
#line 300 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	__vala_GtkTreePath_free0 (path);
#line 1577 "BrowserColumnModel.c"
}


/** Fills in sort_column_id and order with the current sort column and the order. **/
static gboolean
noise_browser_column_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                    gint* sort_column_id,
                                                    GtkSortType* order)
{
	NoiseBrowserColumnModel * self;
	gint _vala_sort_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	GtkSortType _tmp1_;
#line 311 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->sort_column_id;
#line 312 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_sort_column_id = _tmp0_;
#line 313 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->sort_direction;
#line 313 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_vala_order = _tmp1_;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = TRUE;
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (sort_column_id) {
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*sort_column_id = _vala_sort_column_id;
#line 1609 "BrowserColumnModel.c"
	}
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (order) {
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		*order = _vala_order;
#line 1615 "BrowserColumnModel.c"
	}
#line 315 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1619 "BrowserColumnModel.c"
}


/** Returns true if the model has a default sort function. **/
static gboolean
noise_browser_column_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	NoiseBrowserColumnModel * self;
	gboolean result = FALSE;
	GtkTreeIterCompareFunc _tmp0_;
	void* _tmp0__target;
#line 319 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->default_sort_func;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0__target = self->priv->default_sort_func_target;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = _tmp0_ != NULL;
#line 320 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1641 "BrowserColumnModel.c"
}


/** Sets the default comparison function used when sorting to be sort_func. **/
static void
noise_browser_column_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                       GtkTreeIterCompareFunc sort_func,
                                                       gpointer sort_func_target,
                                                       GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseBrowserColumnModel * self;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 325 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->default_sort_func = sort_func;
#line 325 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->default_sort_func_target = sort_func_target;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func = NULL;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target = NULL;
#line 324 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1667 "BrowserColumnModel.c"
}


/** Sets the current sort column to be sort_column_id. **/
static gint
_noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func (GSequenceIter* a,
                                                                                 GSequenceIter* b,
                                                                                 gpointer self)
{
	gint result;
	result = noise_browser_column_model_sequenceIterCompareFunc ((NoiseBrowserColumnModel*) self, a, b);
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1681 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_real_set_sort_column_id (GtkTreeSortable* base,
                                                    gint sort_column_id,
                                                    GtkSortType order)
{
	NoiseBrowserColumnModel * self;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean changed = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
#line 329 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->sort_column_id;
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ != sort_column_id) {
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = TRUE;
#line 1704 "BrowserColumnModel.c"
	} else {
		GtkSortType _tmp2_;
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = self->priv->sort_direction;
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp0_ = order != _tmp2_;
#line 1711 "BrowserColumnModel.c"
	}
#line 330 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	changed = _tmp0_;
#line 332 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_column_id = sort_column_id;
#line 333 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->sort_direction = order;
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp4_ = changed;
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp4_) {
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = sort_column_id >= 0;
#line 1725 "BrowserColumnModel.c"
	} else {
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = FALSE;
#line 1729 "BrowserColumnModel.c"
	}
#line 335 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp3_) {
#line 1733 "BrowserColumnModel.c"
		GSequence* _tmp5_;
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp5_ = self->priv->rows;
#line 337 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_sequence_sort_iter (_tmp5_, _noise_browser_column_model_sequenceIterCompareFunc_gsequence_iter_compare_func, self);
#line 339 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
#line 1741 "BrowserColumnModel.c"
	}
}


static void
noise_browser_column_model_real_set_sort_func (GtkTreeSortable* base,
                                               gint sort_column_id,
                                               GtkTreeIterCompareFunc sort_func,
                                               gpointer sort_func_target,
                                               GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseBrowserColumnModel * self;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = (NoiseBrowserColumnModel*) base;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func = NULL;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target = NULL;
#line 343 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1764 "BrowserColumnModel.c"
}


/** Custom function to use built in sort in Sequence to our advantage **/
gint
noise_browser_column_model_sequenceIterCompareFunc (NoiseBrowserColumnModel* self,
                                                    GSequenceIter* a,
                                                    GSequenceIter* b)
{
	gint result = 0;
	gint rv = 0;
	gint _tmp0_;
	gint _tmp1_;
	GtkSortType _tmp13_;
#line 349 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 349 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 349 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 350 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	rv = 1;
#line 352 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->sort_column_id;
#line 352 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp0_ < 0) {
#line 353 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		result = 0;
#line 353 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		return result;
#line 1795 "BrowserColumnModel.c"
	}
#line 355 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp1_ = self->priv->sort_column_id;
#line 355 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp1_ == 0) {
#line 1801 "BrowserColumnModel.c"
		GSequenceIter* first_sequence_iter = NULL;
		GtkTreeIter* _tmp2_;
		void* _tmp3_;
		GSequenceIter* _tmp4_;
#line 356 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp2_ = self->priv->first_iter;
#line 356 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp3_ = (*_tmp2_).user_data;
#line 356 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		first_sequence_iter = (GSequenceIter*) _tmp3_;
#line 359 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp4_ = first_sequence_iter;
#line 359 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (a == _tmp4_) {
#line 360 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			rv = -1;
#line 1818 "BrowserColumnModel.c"
		} else {
			GSequenceIter* _tmp5_;
#line 362 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp5_ = first_sequence_iter;
#line 362 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			if (b == _tmp5_) {
#line 363 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				rv = 1;
#line 1827 "BrowserColumnModel.c"
			} else {
				gboolean _tmp6_ = FALSE;
				NoiseBrowserColumnCategory _tmp7_;
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				_tmp7_ = self->priv->category;
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp7_ == NOISE_BROWSER_COLUMN_CATEGORY_ARTIST) {
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp6_ = TRUE;
#line 1837 "BrowserColumnModel.c"
				} else {
					NoiseBrowserColumnCategory _tmp8_;
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp8_ = self->priv->category;
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp6_ = _tmp8_ == NOISE_BROWSER_COLUMN_CATEGORY_ALBUM;
#line 1844 "BrowserColumnModel.c"
				}
#line 366 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
				if (_tmp6_) {
#line 1848 "BrowserColumnModel.c"
					gconstpointer _tmp9_;
					gconstpointer _tmp10_;
#line 367 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp9_ = g_sequence_get (a);
#line 367 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp10_ = g_sequence_get (b);
#line 367 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = noise_string_compare ((const gchar*) _tmp9_, (const gchar*) _tmp10_);
#line 1857 "BrowserColumnModel.c"
				} else {
					gconstpointer _tmp11_;
					gconstpointer _tmp12_;
#line 369 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp11_ = g_sequence_get (a);
#line 369 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					_tmp12_ = g_sequence_get (b);
#line 369 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
					rv = noise_string_compare ((const gchar*) _tmp11_, (const gchar*) _tmp12_);
#line 1867 "BrowserColumnModel.c"
				}
			}
		}
	}
#line 373 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp13_ = self->priv->sort_direction;
#line 373 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	if (_tmp13_ == GTK_SORT_DESCENDING) {
#line 1876 "BrowserColumnModel.c"
		gint _tmp14_ = 0;
		gint _tmp15_;
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		_tmp15_ = rv;
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		if (_tmp15_ > 0) {
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp14_ = -1;
#line 1885 "BrowserColumnModel.c"
		} else {
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
			_tmp14_ = 1;
#line 1889 "BrowserColumnModel.c"
		}
#line 374 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		rv = _tmp14_;
#line 1893 "BrowserColumnModel.c"
	}
#line 376 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = rv;
#line 376 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1899 "BrowserColumnModel.c"
}


gint
noise_browser_column_model_get_n_items (NoiseBrowserColumnModel* self)
{
	gint result;
	GSequence* _tmp0_;
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_tmp0_ = self->priv->rows;
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	result = g_sequence_get_length (_tmp0_) - 1;
#line 34 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	return result;
#line 1916 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_class_init (NoiseBrowserColumnModelClass * klass)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_type_class_adjust_private_offset (klass, &NoiseBrowserColumnModel_private_offset);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_browser_column_model_get_property;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_browser_column_model_finalize;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY, noise_browser_column_model_properties[NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY] = g_param_spec_int ("n-items", "n-items", "n-items", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1933 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) noise_browser_column_model_real_get_flags;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) noise_browser_column_model_real_get_iter;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) noise_browser_column_model_real_get_n_columns;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) noise_browser_column_model_real_get_column_type;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) noise_browser_column_model_real_get_path;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) noise_browser_column_model_real_get_value;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) noise_browser_column_model_real_iter_children;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) noise_browser_column_model_real_iter_has_child;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) noise_browser_column_model_real_iter_n_children;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) noise_browser_column_model_real_iter_next;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) noise_browser_column_model_real_iter_nth_child;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) noise_browser_column_model_real_iter_parent;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->ref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) noise_browser_column_model_real_ref_node;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->unref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) noise_browser_column_model_real_unref_node;
#line 1970 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	noise_browser_column_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable*, gint*, GtkSortType*)) noise_browser_column_model_real_get_sort_column_id;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable*)) noise_browser_column_model_real_has_default_sort_func;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_default_sort_func = (void (*) (GtkTreeSortable*, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_browser_column_model_real_set_default_sort_func;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_sort_column_id = (void (*) (GtkTreeSortable*, gint, GtkSortType)) noise_browser_column_model_real_set_sort_column_id;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	iface->set_sort_func = (void (*) (GtkTreeSortable*, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_browser_column_model_real_set_sort_func;
#line 1989 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_instance_init (NoiseBrowserColumnModel * self)
{
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv = noise_browser_column_model_get_instance_private (self);
#line 32 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self->priv->stamp = (gint) g_random_int ();
#line 2000 "BrowserColumnModel.c"
}


static void
noise_browser_column_model_finalize (GObject * obj)
{
	NoiseBrowserColumnModel * self;
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel);
#line 37 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_sequence_free0 (self->priv->rows);
#line 40 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	_g_free0 (self->priv->first_iter);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	G_OBJECT_CLASS (noise_browser_column_model_parent_class)->finalize (obj);
#line 2016 "BrowserColumnModel.c"
}


GType
noise_browser_column_model_get_type (void)
{
	static volatile gsize noise_browser_column_model_type_id__volatile = 0;
	if (g_once_init_enter (&noise_browser_column_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseBrowserColumnModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_browser_column_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseBrowserColumnModel), 0, (GInstanceInitFunc) noise_browser_column_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) noise_browser_column_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) noise_browser_column_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_browser_column_model_type_id;
		noise_browser_column_model_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseBrowserColumnModel", &g_define_type_info, 0);
		g_type_add_interface_static (noise_browser_column_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
		g_type_add_interface_static (noise_browser_column_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
		NoiseBrowserColumnModel_private_offset = g_type_add_instance_private (noise_browser_column_model_type_id, sizeof (NoiseBrowserColumnModelPrivate));
		g_once_init_leave (&noise_browser_column_model_type_id__volatile, noise_browser_column_model_type_id);
	}
	return noise_browser_column_model_type_id__volatile;
}


static void
_vala_noise_browser_column_model_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	NoiseBrowserColumnModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_BROWSER_COLUMN_MODEL, NoiseBrowserColumnModel);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		case NOISE_BROWSER_COLUMN_MODEL_N_ITEMS_PROPERTY:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		g_value_set_int (value, noise_browser_column_model_get_n_items (self));
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 2055 "BrowserColumnModel.c"
		default:
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/ColumnBrowser/BrowserColumnModel.vala"
		break;
#line 2061 "BrowserColumnModel.c"
	}
}



