/* ListView.c generated by valac 0.42.6, the Vala compiler
 * generated from ListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define NOISE_TYPE_VIEW_INTERFACE (noise_view_interface_get_type ())
#define NOISE_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterface))
#define NOISE_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_INTERFACE))
#define NOISE_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterfaceIface))

typedef struct _NoiseViewInterface NoiseViewInterface;
typedef struct _NoiseViewInterfaceIface NoiseViewInterfaceIface;
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())

#define NOISE_TYPE_LIST_VIEW (noise_list_view_get_type ())
#define NOISE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIST_VIEW, NoiseListView))
#define NOISE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))
#define NOISE_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIST_VIEW))
#define NOISE_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIST_VIEW))
#define NOISE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))

typedef struct _NoiseListView NoiseListView;
typedef struct _NoiseListViewClass NoiseListViewClass;
typedef struct _NoiseListViewPrivate NoiseListViewPrivate;

#define NOISE_TYPE_COLUMN_BROWSER (noise_column_browser_get_type ())
#define NOISE_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser))
#define NOISE_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))
#define NOISE_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))

typedef struct _NoiseColumnBrowser NoiseColumnBrowser;
typedef struct _NoiseColumnBrowserClass NoiseColumnBrowserClass;

#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;
enum  {
	NOISE_LIST_VIEW_0_PROPERTY,
	NOISE_LIST_VIEW_COLUMN_BROWSER_PROPERTY,
	NOISE_LIST_VIEW_LIST_VIEW_PROPERTY,
	NOISE_LIST_VIEW_VIEW_WRAPPER_PROPERTY,
	NOISE_LIST_VIEW_N_MEDIA_PROPERTY,
	NOISE_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY,
	NOISE_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY,
	NOISE_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_list_view_properties[NOISE_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_TREE_VIEW_SETUP (noise_tree_view_setup_get_type ())
#define NOISE_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup))
#define NOISE_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))
#define NOISE_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))

typedef struct _NoiseTreeViewSetup NoiseTreeViewSetup;
typedef struct _NoiseTreeViewSetupClass NoiseTreeViewSetupClass;
typedef enum  {
	NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC,
	NOISE_COLUMN_BROWSER_POSITION_LEFT,
	NOISE_COLUMN_BROWSER_POSITION_TOP
} NoiseColumnBrowserPosition;


#define NOISE_COLUMN_BROWSER_TYPE_POSITION (noise_column_browser_position_get_type ())

#define NOISE_TYPE_BROWSER_COLUMN (noise_browser_column_get_type ())
#define NOISE_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_BROWSER_COLUMN, NoiseBrowserColumn))
#define NOISE_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_BROWSER_COLUMN, NoiseBrowserColumnClass))
#define NOISE_IS_BROWSER_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_BROWSER_COLUMN))
#define NOISE_IS_BROWSER_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_BROWSER_COLUMN))
#define NOISE_BROWSER_COLUMN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_BROWSER_COLUMN, NoiseBrowserColumnClass))

typedef struct _NoiseBrowserColumn NoiseBrowserColumn;
typedef struct _NoiseBrowserColumnClass NoiseBrowserColumnClass;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;

#define NOISE_WIDGETS_TYPE_VIEW_SELECTOR (noise_widgets_view_selector_get_type ())
#define NOISE_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector))
#define NOISE_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))

typedef struct _NoiseWidgetsViewSelector NoiseWidgetsViewSelector;
typedef struct _NoiseWidgetsViewSelectorClass NoiseWidgetsViewSelectorClass;

#define NOISE_TYPE_VIEW_STACK (noise_view_stack_get_type ())
#define NOISE_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_STACK, NoiseViewStack))
#define NOISE_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_STACK, NoiseViewStackClass))
#define NOISE_IS_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_STACK))
#define NOISE_IS_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_STACK))
#define NOISE_VIEW_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_STACK, NoiseViewStackClass))

typedef struct _NoiseViewStack NoiseViewStack;
typedef struct _NoiseViewStackClass NoiseViewStackClass;
typedef void (*NoiseGenericListViewSearchFunc) (const gchar* search, GeeArrayList* table, GeeArrayList* showing, gpointer user_data);
enum  {
	NOISE_LIST_VIEW_REORDERED_SIGNAL,
	NOISE_LIST_VIEW_NUM_SIGNALS
};
static guint noise_list_view_signals[NOISE_LIST_VIEW_NUM_SIGNALS] = {0};

struct _NoiseViewInterfaceIface {
	GTypeInterface parent_iface;
	NoiseViewWrapperHint (*get_hint) (NoiseViewInterface* self);
	GeeCollection* (*get_media) (NoiseViewInterface* self);
	GeeCollection* (*get_visible_media) (NoiseViewInterface* self);
	void (*refilter) (NoiseViewInterface* self);
	void (*set_media) (NoiseViewInterface* self, GeeCollection* new_media);
	void (*add_media) (NoiseViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (NoiseViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (NoiseViewInterface* self, GeeCollection* to_update);
};

struct _NoiseListView {
	GtkBox parent_instance;
	NoiseListViewPrivate * priv;
};

struct _NoiseListViewClass {
	GtkBoxClass parent_class;
};

struct _NoiseListViewPrivate {
	GtkPaned* browser_pane;
	NoiseColumnBrowser* _column_browser;
	NoiseMusicListView* _list_view;
	NoiseViewWrapper* _view_wrapper;
	gboolean obey_column_browser;
};


static gint NoiseListView_private_offset;
static gpointer noise_list_view_parent_class = NULL;
static NoiseViewInterfaceIface * noise_list_view_noise_view_interface_parent_iface = NULL;

GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
GType noise_view_interface_get_type (void) G_GNUC_CONST;
GType noise_list_view_get_type (void) G_GNUC_CONST;
GType noise_column_browser_get_type (void) G_GNUC_CONST;
GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
GType noise_tree_view_setup_get_type (void) G_GNUC_CONST;
NoiseListView* noise_list_view_new (NoiseViewWrapper* view_wrapper,
                                    NoiseTreeViewSetup* tvs,
                                    gboolean add_browser);
NoiseListView* noise_list_view_construct (GType object_type,
                                          NoiseViewWrapper* view_wrapper,
                                          NoiseTreeViewSetup* tvs,
                                          gboolean add_browser);
NoiseColumnBrowser* noise_column_browser_new (NoiseViewWrapper* view_wrapper);
NoiseColumnBrowser* noise_column_browser_construct (GType object_type,
                                                    NoiseViewWrapper* view_wrapper);
NoiseMusicListView* noise_music_list_view_new (NoiseViewWrapper* view_wrapper,
                                               NoiseTreeViewSetup* tvs);
NoiseMusicListView* noise_music_list_view_construct (GType object_type,
                                                     NoiseViewWrapper* view_wrapper,
                                                     NoiseTreeViewSetup* tvs);
GType noise_column_browser_position_get_type (void) G_GNUC_CONST;
static void noise_list_view_set_column_browser_position (NoiseListView* self,
                                                  NoiseColumnBrowserPosition position);
GType noise_browser_column_get_type (void) G_GNUC_CONST;
NoiseColumnBrowser* noise_list_view_get_column_browser (NoiseListView* self);
GeeTreeSet* noise_column_browser_get_columns (NoiseColumnBrowser* self);
gboolean noise_browser_column_get_visible (NoiseBrowserColumn* self);
NoiseMusicListView* noise_list_view_get_list_view (NoiseListView* self);
void noise_column_browser_set_actual_position (NoiseColumnBrowser* self,
                                               NoiseColumnBrowserPosition value);
GSettings* noise_app_get_saved_state (void);
static void noise_list_view_connect_column_browser_ui_signals (NoiseListView* self);
gboolean noise_list_view_get_has_column_browser (NoiseListView* self);
static void __lambda70_ (NoiseListView* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
gboolean noise_library_window_get_initialization_finished (NoiseLibraryWindow* self);
NoiseColumnBrowserPosition noise_column_browser_get_position (NoiseColumnBrowser* self);
static void ___lambda70__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void __lambda71_ (NoiseListView* self);
gboolean noise_list_view_get_column_browser_enabled (NoiseListView* self);
static void ___lambda71__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
GType noise_widgets_view_selector_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelector* noise_library_window_get_view_selector (NoiseLibraryWindow* self);
static void __lambda72_ (NoiseListView* self,
                  gboolean enabled);
static void noise_list_view_set_column_browser_enabled (NoiseListView* self,
                                                 gboolean value);
static void ___lambda72__noise_widgets_view_selector_column_browser_toggled (NoiseWidgetsViewSelector* _sender,
                                                                      gboolean new_value,
                                                                      gpointer self);
static void _noise_list_view_set_column_browser_position_noise_column_browser_position_changed (NoiseColumnBrowser* _sender,
                                                                                         NoiseColumnBrowserPosition p,
                                                                                         gpointer self);
static void noise_list_view_save_column_browser_settings (NoiseListView* self);
static void _noise_list_view_save_column_browser_settings_gtk_widget_destroy (GtkWidget* _sender,
                                                                       gpointer self);
static NoiseViewWrapperHint noise_list_view_real_get_hint (NoiseViewInterface* base);
NoiseViewWrapperHint noise_generic_list_get_hint (NoiseGenericList* self);
NoisePlaylist* noise_list_view_get_playlist (NoiseListView* self);
NoisePlaylist* noise_generic_list_get_playlist (NoiseGenericList* self);
static GeeCollection* noise_list_view_real_get_media (NoiseViewInterface* base);
GeeBidirList* noise_generic_list_get_table (NoiseGenericList* self);
static GeeCollection* noise_list_view_real_get_visible_media (NoiseViewInterface* base);
GeeBidirList* noise_generic_list_get_visible_table (NoiseGenericList* self);
static void noise_list_view_column_browser_changed (NoiseListView* self);
void noise_generic_list_do_search (NoiseGenericList* self,
                                   const gchar* search);
void noise_list_view_set_as_current_list (NoiseListView* self,
                                          gint media_id);
void noise_generic_list_set_as_current_list (NoiseGenericList* self,
                                             NoiseMedia* m);
NoiseViewWrapper* noise_list_view_get_view_wrapper (NoiseListView* self);
NoiseLibrary* noise_view_wrapper_get_library (NoiseViewWrapper* self);
gboolean noise_list_view_get_is_current_list (NoiseListView* self);
gboolean noise_generic_list_get_is_current_list (NoiseGenericList* self);
static void noise_list_view_real_add_media (NoiseViewInterface* base,
                                     GeeCollection* to_add);
void noise_music_list_view_add_media (NoiseMusicListView* self,
                                      GeeCollection* to_add);
void noise_generic_list_set_research_needed (NoiseGenericList* self,
                                             gboolean value);
void noise_view_interface_refilter (NoiseViewInterface* self);
static void noise_list_view_real_remove_media (NoiseViewInterface* base,
                                        GeeCollection* to_remove);
void noise_music_list_view_remove_media (NoiseMusicListView* self,
                                         GeeCollection* to_remove);
static void noise_list_view_real_set_media (NoiseViewInterface* base,
                                     GeeCollection* media);
void noise_generic_list_set_media (NoiseGenericList* self,
                                   GeeCollection* to_add);
void noise_column_browser_set_media (NoiseColumnBrowser* self,
                                     GeeCollection* media);
static void noise_list_view_real_update_media (NoiseViewInterface* base,
                                        GeeCollection* media);
static void noise_list_view_real_refilter (NoiseViewInterface* base);
static void noise_list_view_view_search_func (NoiseListView* self,
                                       const gchar* search,
                                       GeeArrayList* table,
                                       GeeArrayList* showing);
gboolean noise_column_browser_match_media (NoiseColumnBrowser* self,
                                           NoiseMedia* m);
GType noise_view_stack_get_type (void) G_GNUC_CONST;
NoiseViewStack* noise_library_window_get_view_stack (NoiseLibraryWindow* self);
void noise_view_stack_show_alert (NoiseViewStack* self);
void noise_list_view_set_column_browser (NoiseListView* self,
                                         NoiseColumnBrowser* value);
void noise_list_view_set_list_view (NoiseListView* self,
                                    NoiseMusicListView* value);
void noise_list_view_set_view_wrapper (NoiseListView* self,
                                       NoiseViewWrapper* value);
guint noise_list_view_get_n_media (NoiseListView* self);
gboolean noise_column_browser_get_initialized (NoiseColumnBrowser* self);
GeeCollection* noise_view_interface_get_visible_media (NoiseViewInterface* self);
void noise_column_browser_reset_filters (NoiseColumnBrowser* self);
static GObject * noise_list_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _noise_list_view___lambda73_ (NoiseListView* self);
static void __noise_list_view___lambda73__noise_generic_list_rows_reordered (NoiseGenericList* _sender,
                                                                      gpointer self);
static void _noise_list_view___lambda74_ (NoiseListView* self,
                                   GeeCollection* to_import);
static void __noise_list_view___lambda74__noise_generic_list_import_requested (NoiseGenericList* _sender,
                                                                        GeeCollection* to_import,
                                                                        gpointer self);
void noise_generic_list_set_search_func (NoiseGenericList* self,
                                         NoiseGenericListViewSearchFunc func,
                                         gpointer func_target);
static void _noise_list_view_view_search_func_noise_generic_list_view_search_func (const gchar* search,
                                                                            GeeArrayList* table,
                                                                            GeeArrayList* showing,
                                                                            gpointer self);
static void _noise_list_view___lambda75_ (NoiseListView* self);
static void __noise_list_view___lambda75__noise_library_search_finished (NoiseLibrary* _sender,
                                                                  gpointer self);
static void _noise_list_view_connect_column_browser_ui_signals_gtk_widget_realize (GtkWidget* _sender,
                                                                            gpointer self);
static void _noise_list_view_column_browser_changed_noise_column_browser_changed (NoiseColumnBrowser* _sender,
                                                                           gpointer self);
static void noise_list_view_finalize (GObject * obj);
static void _vala_noise_list_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_noise_list_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);


static inline gpointer
noise_list_view_get_instance_private (NoiseListView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseListView_private_offset);
}


NoiseListView*
noise_list_view_construct (GType object_type,
                           NoiseViewWrapper* view_wrapper,
                           NoiseTreeViewSetup* tvs,
                           gboolean add_browser)
{
	NoiseListView * self = NULL;
	NoiseColumnBrowser* _tmp0_ = NULL;
	NoiseMusicListView* _tmp2_;
	NoiseMusicListView* _tmp3_;
#line 78 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 78 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 81 "../src/Views/ListView/ListView.vala"
	if (add_browser) {
#line 412 "ListView.c"
		NoiseColumnBrowser* _tmp1_;
#line 81 "../src/Views/ListView/ListView.vala"
		_tmp1_ = noise_column_browser_new (view_wrapper);
#line 81 "../src/Views/ListView/ListView.vala"
		g_object_ref_sink (_tmp1_);
#line 81 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (_tmp0_);
#line 81 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _tmp1_;
#line 422 "ListView.c"
	} else {
#line 81 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (_tmp0_);
#line 81 "../src/Views/ListView/ListView.vala"
		_tmp0_ = NULL;
#line 428 "ListView.c"
	}
#line 79 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_music_list_view_new (view_wrapper, tvs);
#line 79 "../src/Views/ListView/ListView.vala"
	g_object_ref_sink (_tmp2_);
#line 79 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 79 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) g_object_new (object_type, "view-wrapper", view_wrapper, "list-view", _tmp3_, "column-browser", _tmp0_, NULL);
#line 79 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp3_);
#line 78 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp0_);
#line 78 "../src/Views/ListView/ListView.vala"
	return self;
#line 444 "ListView.c"
}


NoiseListView*
noise_list_view_new (NoiseViewWrapper* view_wrapper,
                     NoiseTreeViewSetup* tvs,
                     gboolean add_browser)
{
#line 78 "../src/Views/ListView/ListView.vala"
	return noise_list_view_construct (NOISE_TYPE_LIST_VIEW, view_wrapper, tvs, add_browser);
#line 455 "ListView.c"
}


static void
noise_list_view_set_column_browser_position (NoiseListView* self,
                                             NoiseColumnBrowserPosition position)
{
	NoiseColumnBrowserPosition actual_position = 0;
	NoiseColumnBrowserPosition _tmp0_;
	NoiseColumnBrowser* _tmp26_;
	NoiseColumnBrowserPosition _tmp27_;
	NoiseColumnBrowserPosition _tmp28_;
#line 123 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/Views/ListView/ListView.vala"
	actual_position = position;
#line 126 "../src/Views/ListView/ListView.vala"
	_tmp0_ = actual_position;
#line 126 "../src/Views/ListView/ListView.vala"
	if (_tmp0_ == NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC) {
#line 476 "ListView.c"
		gint view_width = 0;
#line 130 "../src/Views/ListView/ListView.vala"
		static const gint MIN_RECOMMENDED_COLUMN_WIDTH = 160;
#line 480 "ListView.c"
		gint visible_columns = 0;
		gint required_width = 0;
		gint _tmp12_;
		gint n_cols = 0;
		NoiseMusicListView* _tmp13_;
		GList* _tmp14_;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
		gint _tmp21_;
		gint _tmp22_;
		NoiseMusicListView* _tmp23_;
#line 129 "../src/Views/ListView/ListView.vala"
		view_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 132 "../src/Views/ListView/ListView.vala"
		visible_columns = 0;
#line 496 "ListView.c"
		{
			GeeIterator* _column_it = NULL;
			NoiseColumnBrowser* _tmp1_;
			GeeTreeSet* _tmp2_;
			GeeTreeSet* _tmp3_;
			GeeIterator* _tmp4_;
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp1_ = self->priv->_column_browser;
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp2_ = noise_column_browser_get_columns (_tmp1_);
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp3_ = _tmp2_;
#line 133 "../src/Views/ListView/ListView.vala"
			_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
#line 133 "../src/Views/ListView/ListView.vala"
			_column_it = _tmp4_;
#line 133 "../src/Views/ListView/ListView.vala"
			while (TRUE) {
#line 515 "ListView.c"
				GeeIterator* _tmp5_;
				NoiseBrowserColumn* column = NULL;
				GeeIterator* _tmp6_;
				gpointer _tmp7_;
				NoiseBrowserColumn* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
#line 133 "../src/Views/ListView/ListView.vala"
				_tmp5_ = _column_it;
#line 133 "../src/Views/ListView/ListView.vala"
				if (!gee_iterator_next (_tmp5_)) {
#line 133 "../src/Views/ListView/ListView.vala"
					break;
#line 529 "ListView.c"
				}
#line 133 "../src/Views/ListView/ListView.vala"
				_tmp6_ = _column_it;
#line 133 "../src/Views/ListView/ListView.vala"
				_tmp7_ = gee_iterator_get (_tmp6_);
#line 133 "../src/Views/ListView/ListView.vala"
				column = (NoiseBrowserColumn*) _tmp7_;
#line 134 "../src/Views/ListView/ListView.vala"
				_tmp8_ = column;
#line 134 "../src/Views/ListView/ListView.vala"
				_tmp9_ = noise_browser_column_get_visible (_tmp8_);
#line 134 "../src/Views/ListView/ListView.vala"
				_tmp10_ = _tmp9_;
#line 134 "../src/Views/ListView/ListView.vala"
				if (_tmp10_) {
#line 545 "ListView.c"
					gint _tmp11_;
#line 135 "../src/Views/ListView/ListView.vala"
					_tmp11_ = visible_columns;
#line 135 "../src/Views/ListView/ListView.vala"
					visible_columns = _tmp11_ + 1;
#line 551 "ListView.c"
				}
#line 133 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (column);
#line 555 "ListView.c"
			}
#line 133 "../src/Views/ListView/ListView.vala"
			_g_object_unref0 (_column_it);
#line 559 "ListView.c"
		}
#line 141 "../src/Views/ListView/ListView.vala"
		_tmp12_ = visible_columns;
#line 141 "../src/Views/ListView/ListView.vala"
		required_width = MIN_RECOMMENDED_COLUMN_WIDTH * _tmp12_;
#line 142 "../src/Views/ListView/ListView.vala"
		n_cols = 0;
#line 143 "../src/Views/ListView/ListView.vala"
		_tmp13_ = self->priv->_list_view;
#line 143 "../src/Views/ListView/ListView.vala"
		_tmp14_ = gtk_tree_view_get_columns ((GtkTreeView*) _tmp13_);
#line 571 "ListView.c"
		{
			GList* column_collection = NULL;
			GList* column_it = NULL;
#line 143 "../src/Views/ListView/ListView.vala"
			column_collection = _tmp14_;
#line 143 "../src/Views/ListView/ListView.vala"
			for (column_it = column_collection; column_it != NULL; column_it = column_it->next) {
#line 579 "ListView.c"
				GtkTreeViewColumn* column = NULL;
#line 143 "../src/Views/ListView/ListView.vala"
				column = (GtkTreeViewColumn*) column_it->data;
#line 583 "ListView.c"
				{
					GtkTreeViewColumn* _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
#line 144 "../src/Views/ListView/ListView.vala"
					_tmp15_ = column;
#line 144 "../src/Views/ListView/ListView.vala"
					_tmp16_ = gtk_tree_view_column_get_visible (_tmp15_);
#line 144 "../src/Views/ListView/ListView.vala"
					_tmp17_ = _tmp16_;
#line 144 "../src/Views/ListView/ListView.vala"
					if (_tmp17_) {
#line 596 "ListView.c"
						gint _tmp18_;
#line 145 "../src/Views/ListView/ListView.vala"
						_tmp18_ = n_cols;
#line 145 "../src/Views/ListView/ListView.vala"
						n_cols = _tmp18_ + 1;
#line 602 "ListView.c"
					}
				}
			}
#line 143 "../src/Views/ListView/ListView.vala"
			(column_collection == NULL) ? NULL : (column_collection = (g_list_free (column_collection), NULL));
#line 608 "ListView.c"
		}
#line 149 "../src/Views/ListView/ListView.vala"
		_tmp21_ = view_width;
#line 149 "../src/Views/ListView/ListView.vala"
		_tmp22_ = required_width;
#line 149 "../src/Views/ListView/ListView.vala"
		_tmp23_ = self->priv->_list_view;
#line 149 "../src/Views/ListView/ListView.vala"
		if ((_tmp21_ - _tmp22_) < gtk_widget_get_allocated_width ((GtkWidget*) _tmp23_)) {
#line 618 "ListView.c"
			gint _tmp24_;
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp24_ = n_cols;
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp20_ = _tmp24_ > 2;
#line 624 "ListView.c"
		} else {
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp20_ = FALSE;
#line 628 "ListView.c"
		}
#line 149 "../src/Views/ListView/ListView.vala"
		if (_tmp20_) {
#line 632 "ListView.c"
			gint _tmp25_;
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp25_ = visible_columns;
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp19_ = _tmp25_ > 2;
#line 638 "ListView.c"
		} else {
#line 149 "../src/Views/ListView/ListView.vala"
			_tmp19_ = FALSE;
#line 642 "ListView.c"
		}
#line 149 "../src/Views/ListView/ListView.vala"
		if (_tmp19_) {
#line 150 "../src/Views/ListView/ListView.vala"
			actual_position = NOISE_COLUMN_BROWSER_POSITION_TOP;
#line 648 "ListView.c"
		} else {
#line 152 "../src/Views/ListView/ListView.vala"
			actual_position = NOISE_COLUMN_BROWSER_POSITION_LEFT;
#line 652 "ListView.c"
		}
	}
#line 156 "../src/Views/ListView/ListView.vala"
	_tmp26_ = self->priv->_column_browser;
#line 156 "../src/Views/ListView/ListView.vala"
	_tmp27_ = actual_position;
#line 156 "../src/Views/ListView/ListView.vala"
	noise_column_browser_set_actual_position (_tmp26_, _tmp27_);
#line 158 "../src/Views/ListView/ListView.vala"
	_tmp28_ = actual_position;
#line 158 "../src/Views/ListView/ListView.vala"
	if (_tmp28_ == NOISE_COLUMN_BROWSER_POSITION_LEFT) {
#line 665 "ListView.c"
		GtkPaned* _tmp29_;
		GtkPaned* _tmp30_;
		GSettings* _tmp31_;
		GSettings* _tmp32_;
		GtkPaned* _tmp33_;
#line 159 "../src/Views/ListView/ListView.vala"
		_tmp29_ = self->priv->browser_pane;
#line 159 "../src/Views/ListView/ListView.vala"
		g_settings_unbind ((GObject*) _tmp29_, "position");
#line 160 "../src/Views/ListView/ListView.vala"
		_tmp30_ = self->priv->browser_pane;
#line 160 "../src/Views/ListView/ListView.vala"
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp30_, GTK_ORIENTATION_HORIZONTAL);
#line 161 "../src/Views/ListView/ListView.vala"
		_tmp31_ = noise_app_get_saved_state ();
#line 161 "../src/Views/ListView/ListView.vala"
		_tmp32_ = _tmp31_;
#line 161 "../src/Views/ListView/ListView.vala"
		_tmp33_ = self->priv->browser_pane;
#line 161 "../src/Views/ListView/ListView.vala"
		g_settings_bind (_tmp32_, "column-browser-width", (GObject*) _tmp33_, "position", G_SETTINGS_BIND_DEFAULT);
#line 687 "ListView.c"
	} else {
		NoiseColumnBrowserPosition _tmp34_;
#line 162 "../src/Views/ListView/ListView.vala"
		_tmp34_ = actual_position;
#line 162 "../src/Views/ListView/ListView.vala"
		if (_tmp34_ == NOISE_COLUMN_BROWSER_POSITION_TOP) {
#line 694 "ListView.c"
			GtkPaned* _tmp35_;
			GtkPaned* _tmp36_;
			GSettings* _tmp37_;
			GSettings* _tmp38_;
			GtkPaned* _tmp39_;
#line 163 "../src/Views/ListView/ListView.vala"
			_tmp35_ = self->priv->browser_pane;
#line 163 "../src/Views/ListView/ListView.vala"
			g_settings_unbind ((GObject*) _tmp35_, "position");
#line 164 "../src/Views/ListView/ListView.vala"
			_tmp36_ = self->priv->browser_pane;
#line 164 "../src/Views/ListView/ListView.vala"
			gtk_orientable_set_orientation ((GtkOrientable*) _tmp36_, GTK_ORIENTATION_VERTICAL);
#line 165 "../src/Views/ListView/ListView.vala"
			_tmp37_ = noise_app_get_saved_state ();
#line 165 "../src/Views/ListView/ListView.vala"
			_tmp38_ = _tmp37_;
#line 165 "../src/Views/ListView/ListView.vala"
			_tmp39_ = self->priv->browser_pane;
#line 165 "../src/Views/ListView/ListView.vala"
			g_settings_bind (_tmp38_, "column-browser-height", (GObject*) _tmp39_, "position", G_SETTINGS_BIND_DEFAULT);
#line 716 "ListView.c"
		}
	}
}


static void
__lambda70_ (NoiseListView* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NoiseColumnBrowser* _tmp4_;
	NoiseColumnBrowserPosition _tmp5_;
	NoiseColumnBrowserPosition _tmp6_;
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_library_window_get_initialization_finished (_tmp1_);
#line 176 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 176 "../src/Views/ListView/ListView.vala"
	if (!_tmp3_) {
#line 177 "../src/Views/ListView/ListView.vala"
		return;
#line 744 "ListView.c"
	}
#line 180 "../src/Views/ListView/ListView.vala"
	_tmp4_ = self->priv->_column_browser;
#line 180 "../src/Views/ListView/ListView.vala"
	_tmp5_ = noise_column_browser_get_position (_tmp4_);
#line 180 "../src/Views/ListView/ListView.vala"
	_tmp6_ = _tmp5_;
#line 180 "../src/Views/ListView/ListView.vala"
	if (_tmp6_ == NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC) {
#line 181 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_column_browser_position (self, NOISE_COLUMN_BROWSER_POSITION_AUTOMATIC);
#line 756 "ListView.c"
	}
}


static void
___lambda70__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 175 "../src/Views/ListView/ListView.vala"
	__lambda70_ ((NoiseListView*) self);
#line 768 "ListView.c"
}


static void
__lambda71_ (NoiseListView* self)
{
	gboolean _tmp0_ = FALSE;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp3_ = noise_library_window_get_initialization_finished (_tmp2_);
#line 186 "../src/Views/ListView/ListView.vala"
	_tmp4_ = _tmp3_;
#line 186 "../src/Views/ListView/ListView.vala"
	if (!_tmp4_) {
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp0_ = TRUE;
#line 792 "ListView.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp5_ = noise_list_view_get_column_browser_enabled (self);
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp6_ = _tmp5_;
#line 186 "../src/Views/ListView/ListView.vala"
		_tmp0_ = !_tmp6_;
#line 802 "ListView.c"
	}
#line 186 "../src/Views/ListView/ListView.vala"
	if (_tmp0_) {
#line 187 "../src/Views/ListView/ListView.vala"
		return;
#line 808 "ListView.c"
	}
}


static void
___lambda71__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 185 "../src/Views/ListView/ListView.vala"
	__lambda71_ ((NoiseListView*) self);
#line 820 "ListView.c"
}


static void
__lambda72_ (NoiseListView* self,
             gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 192 "../src/Views/ListView/ListView.vala"
	_tmp0_ = noise_list_view_get_column_browser_enabled (self);
#line 192 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 192 "../src/Views/ListView/ListView.vala"
	if (enabled != _tmp1_) {
#line 193 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_column_browser_enabled (self, enabled);
#line 838 "ListView.c"
	}
}


static void
___lambda72__noise_widgets_view_selector_column_browser_toggled (NoiseWidgetsViewSelector* _sender,
                                                                 gboolean new_value,
                                                                 gpointer self)
{
#line 191 "../src/Views/ListView/ListView.vala"
	__lambda72_ ((NoiseListView*) self, new_value);
#line 850 "ListView.c"
}


static void
_noise_list_view_set_column_browser_position_noise_column_browser_position_changed (NoiseColumnBrowser* _sender,
                                                                                    NoiseColumnBrowserPosition p,
                                                                                    gpointer self)
{
#line 197 "../src/Views/ListView/ListView.vala"
	noise_list_view_set_column_browser_position ((NoiseListView*) self, p);
#line 861 "ListView.c"
}


static void
_noise_list_view_save_column_browser_settings_gtk_widget_destroy (GtkWidget* _sender,
                                                                  gpointer self)
{
#line 201 "../src/Views/ListView/ListView.vala"
	noise_list_view_save_column_browser_settings ((NoiseListView*) self);
#line 871 "ListView.c"
}


static void
noise_list_view_connect_column_browser_ui_signals (NoiseListView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	NoiseColumnBrowser* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	NoiseWidgetsViewSelector* _tmp5_;
	NoiseWidgetsViewSelector* _tmp6_;
	NoiseColumnBrowser* _tmp7_;
#line 169 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Views/ListView/ListView.vala"
	_tmp0_ = noise_list_view_get_has_column_browser (self);
#line 170 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 170 "../src/Views/ListView/ListView.vala"
	if (!_tmp1_) {
#line 171 "../src/Views/ListView/ListView.vala"
		return;
#line 896 "ListView.c"
	}
#line 175 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda70__gtk_widget_size_allocate, self, 0);
#line 185 "../src/Views/ListView/ListView.vala"
	_tmp2_ = self->priv->_column_browser;
#line 185 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((GtkWidget*) _tmp2_, "size-allocate", (GCallback) ___lambda71__gtk_widget_size_allocate, self, 0);
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp3_ = noise_app_get_main_window ();
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp4_ = _tmp3_;
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp5_ = noise_library_window_get_view_selector (_tmp4_);
#line 191 "../src/Views/ListView/ListView.vala"
	_tmp6_ = _tmp5_;
#line 191 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object (_tmp6_, "column-browser-toggled", (GCallback) ___lambda72__noise_widgets_view_selector_column_browser_toggled, self, 0);
#line 197 "../src/Views/ListView/ListView.vala"
	_tmp7_ = self->priv->_column_browser;
#line 197 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object (_tmp7_, "position-changed", (GCallback) _noise_list_view_set_column_browser_position_noise_column_browser_position_changed, self, 0);
#line 201 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) _noise_list_view_save_column_browser_settings_gtk_widget_destroy, self, 0);
#line 920 "ListView.c"
}


static void
noise_list_view_save_column_browser_settings (NoiseListView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 204 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Views/ListView/ListView.vala"
	_tmp0_ = noise_list_view_get_has_column_browser (self);
#line 206 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 206 "../src/Views/ListView/ListView.vala"
	if (_tmp1_) {
#line 937 "ListView.c"
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp2_ = noise_app_get_saved_state ();
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp3_ = _tmp2_;
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp4_ = noise_list_view_get_column_browser_enabled (self);
#line 207 "../src/Views/ListView/ListView.vala"
		_tmp5_ = _tmp4_;
#line 207 "../src/Views/ListView/ListView.vala"
		g_settings_set_boolean (_tmp3_, "column-browser-enabled", _tmp5_);
#line 952 "ListView.c"
	}
}


/**
     * ContentView interface methods
     */
static NoiseViewWrapperHint
noise_list_view_real_get_hint (NoiseViewInterface* base)
{
	NoiseListView * self;
	NoiseViewWrapperHint result = 0;
	NoiseMusicListView* _tmp0_;
	NoiseViewWrapperHint _tmp1_;
	NoiseViewWrapperHint _tmp2_;
#line 215 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_generic_list_get_hint ((NoiseGenericList*) _tmp0_);
#line 216 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 216 "../src/Views/ListView/ListView.vala"
	result = _tmp2_;
#line 216 "../src/Views/ListView/ListView.vala"
	return result;
#line 980 "ListView.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 220 "../src/Views/ListView/ListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 989 "ListView.c"
}


NoisePlaylist*
noise_list_view_get_playlist (NoiseListView* self)
{
	NoisePlaylist* result = NULL;
	NoiseMusicListView* _tmp0_;
	NoisePlaylist* _tmp1_;
	NoisePlaylist* _tmp2_;
	NoisePlaylist* _tmp3_;
#line 219 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 220 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 220 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_generic_list_get_playlist ((NoiseGenericList*) _tmp0_);
#line 220 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 220 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 220 "../src/Views/ListView/ListView.vala"
	result = _tmp3_;
#line 220 "../src/Views/ListView/ListView.vala"
	return result;
#line 1015 "ListView.c"
}


static GeeCollection*
noise_list_view_real_get_media (NoiseViewInterface* base)
{
	NoiseListView * self;
	GeeCollection* result = NULL;
	GeeArrayList* media = NULL;
	GeeArrayList* _tmp0_;
	NoiseMusicListView* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* _tmp3_;
#line 223 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 224 "../src/Views/ListView/ListView.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 224 "../src/Views/ListView/ListView.vala"
	media = _tmp0_;
#line 225 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 225 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_generic_list_get_table ((NoiseGenericList*) _tmp1_);
#line 225 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 225 "../src/Views/ListView/ListView.vala"
	gee_array_list_add_all (media, (GeeCollection*) _tmp3_);
#line 225 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp3_);
#line 226 "../src/Views/ListView/ListView.vala"
	result = (GeeCollection*) media;
#line 226 "../src/Views/ListView/ListView.vala"
	return result;
#line 1049 "ListView.c"
}


static GeeCollection*
noise_list_view_real_get_visible_media (NoiseViewInterface* base)
{
	NoiseListView * self;
	GeeCollection* result = NULL;
	GeeArrayList* media = NULL;
	GeeArrayList* _tmp0_;
	NoiseMusicListView* _tmp1_;
	GeeBidirList* _tmp2_;
	GeeBidirList* _tmp3_;
#line 229 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 230 "../src/Views/ListView/ListView.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 230 "../src/Views/ListView/ListView.vala"
	media = _tmp0_;
#line 231 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 231 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_generic_list_get_visible_table ((NoiseGenericList*) _tmp1_);
#line 231 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 231 "../src/Views/ListView/ListView.vala"
	gee_array_list_add_all (media, (GeeCollection*) _tmp3_);
#line 231 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp3_);
#line 232 "../src/Views/ListView/ListView.vala"
	result = (GeeCollection*) media;
#line 232 "../src/Views/ListView/ListView.vala"
	return result;
#line 1083 "ListView.c"
}


static void
noise_list_view_column_browser_changed (NoiseListView* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 235 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/Views/ListView/ListView.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 236 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 236 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_library_window_get_initialization_finished (_tmp1_);
#line 236 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 236 "../src/Views/ListView/ListView.vala"
	if (_tmp3_) {
#line 1106 "ListView.c"
		NoiseMusicListView* _tmp4_;
#line 238 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->_list_view;
#line 238 "../src/Views/ListView/ListView.vala"
		noise_generic_list_do_search ((NoiseGenericList*) _tmp4_, NULL);
#line 1112 "ListView.c"
	}
}


void
noise_list_view_set_as_current_list (NoiseListView* self,
                                     gint media_id)
{
	NoiseMusicListView* _tmp0_;
	NoiseViewWrapper* _tmp1_;
	NoiseLibrary* _tmp2_;
	NoiseLibrary* _tmp3_;
	NoiseMedia* _tmp4_;
	NoiseMedia* _tmp5_;
#line 242 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_view_wrapper;
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_view_wrapper_get_library (_tmp1_);
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp4_ = noise_library_media_from_id (_tmp3_, (gint64) media_id);
#line 243 "../src/Views/ListView/ListView.vala"
	_tmp5_ = _tmp4_;
#line 243 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_as_current_list ((NoiseGenericList*) _tmp0_, _tmp5_);
#line 243 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp5_);
#line 1145 "ListView.c"
}


gboolean
noise_list_view_get_is_current_list (NoiseListView* self)
{
	gboolean result = FALSE;
	NoiseMusicListView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 246 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 247 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_generic_list_get_is_current_list ((NoiseGenericList*) _tmp0_);
#line 247 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 247 "../src/Views/ListView/ListView.vala"
	result = _tmp2_;
#line 247 "../src/Views/ListView/ListView.vala"
	return result;
#line 1168 "ListView.c"
}


static void
noise_list_view_real_add_media (NoiseViewInterface* base,
                                GeeCollection* to_add)
{
	NoiseListView * self;
	NoiseMusicListView* _tmp0_;
	NoiseMusicListView* _tmp1_;
#line 250 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 250 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (to_add != NULL);
#line 251 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 251 "../src/Views/ListView/ListView.vala"
	noise_music_list_view_add_media (_tmp0_, to_add);
#line 252 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 252 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_research_needed ((NoiseGenericList*) _tmp1_, TRUE);
#line 253 "../src/Views/ListView/ListView.vala"
	noise_view_interface_refilter ((NoiseViewInterface*) self);
#line 1193 "ListView.c"
}


static void
noise_list_view_real_remove_media (NoiseViewInterface* base,
                                   GeeCollection* to_remove)
{
	NoiseListView * self;
	NoiseMusicListView* _tmp0_;
	NoiseMusicListView* _tmp1_;
#line 256 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 256 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (to_remove != NULL);
#line 257 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 257 "../src/Views/ListView/ListView.vala"
	noise_music_list_view_remove_media (_tmp0_, to_remove);
#line 258 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 258 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_research_needed ((NoiseGenericList*) _tmp1_, TRUE);
#line 259 "../src/Views/ListView/ListView.vala"
	noise_view_interface_refilter ((NoiseViewInterface*) self);
#line 1218 "ListView.c"
}


static void
noise_list_view_real_set_media (NoiseViewInterface* base,
                                GeeCollection* media)
{
	NoiseListView * self;
	NoiseMusicListView* _tmp0_;
	NoiseMusicListView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 262 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 262 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (media != NULL);
#line 263 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = FALSE;
#line 265 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 265 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_media ((NoiseGenericList*) _tmp0_, media);
#line 266 "../src/Views/ListView/ListView.vala"
	_tmp1_ = self->priv->_list_view;
#line 266 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_research_needed ((NoiseGenericList*) _tmp1_, TRUE);
#line 268 "../src/Views/ListView/ListView.vala"
	_tmp2_ = noise_list_view_get_has_column_browser (self);
#line 268 "../src/Views/ListView/ListView.vala"
	_tmp3_ = _tmp2_;
#line 268 "../src/Views/ListView/ListView.vala"
	if (_tmp3_) {
#line 1251 "ListView.c"
		NoiseColumnBrowser* _tmp4_;
#line 269 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->_column_browser;
#line 269 "../src/Views/ListView/ListView.vala"
		noise_column_browser_set_media (_tmp4_, media);
#line 1257 "ListView.c"
	}
#line 272 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = TRUE;
#line 1261 "ListView.c"
}


static void
noise_list_view_real_update_media (NoiseViewInterface* base,
                                   GeeCollection* media)
{
	NoiseListView * self;
#line 275 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 275 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (media != NULL);
#line 276 "../src/Views/ListView/ListView.vala"
	noise_view_interface_refilter ((NoiseViewInterface*) self);
#line 1276 "ListView.c"
}


static void
noise_list_view_real_refilter (NoiseViewInterface* base)
{
	NoiseListView * self;
	NoiseMusicListView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 279 "../src/Views/ListView/ListView.vala"
	self = (NoiseListView*) base;
#line 290 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = FALSE;
#line 291 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 291 "../src/Views/ListView/ListView.vala"
	noise_generic_list_do_search ((NoiseGenericList*) _tmp0_, NULL);
#line 292 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = TRUE;
#line 294 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_list_view_get_has_column_browser (self);
#line 294 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 294 "../src/Views/ListView/ListView.vala"
	if (_tmp2_) {
#line 1303 "ListView.c"
		NoiseColumnBrowser* _tmp3_;
		NoiseViewWrapper* _tmp4_;
		NoiseLibrary* _tmp5_;
		NoiseLibrary* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
#line 295 "../src/Views/ListView/ListView.vala"
		_tmp3_ = self->priv->_column_browser;
#line 295 "../src/Views/ListView/ListView.vala"
		_tmp4_ = self->priv->_view_wrapper;
#line 295 "../src/Views/ListView/ListView.vala"
		_tmp5_ = noise_view_wrapper_get_library (_tmp4_);
#line 295 "../src/Views/ListView/ListView.vala"
		_tmp6_ = _tmp5_;
#line 295 "../src/Views/ListView/ListView.vala"
		_tmp7_ = noise_library_get_search_result (_tmp6_);
#line 295 "../src/Views/ListView/ListView.vala"
		_tmp8_ = _tmp7_;
#line 295 "../src/Views/ListView/ListView.vala"
		noise_column_browser_set_media (_tmp3_, _tmp8_);
#line 295 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (_tmp8_);
#line 1326 "ListView.c"
	}
}


static void
noise_list_view_view_search_func (NoiseListView* self,
                                  const gchar* search,
                                  GeeArrayList* table,
                                  GeeArrayList* showing)
{
	GeeCollection* _result_ = NULL;
	NoiseViewWrapper* _tmp0_;
	NoiseLibrary* _tmp1_;
	NoiseLibrary* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean obey_column_browser = FALSE;
	GeeCollection* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	NoiseViewWrapper* _tmp11_;
	NoiseLibrary* _tmp12_;
	NoiseLibrary* _tmp13_;
	GeeCollection* _tmp14_;
	GeeCollection* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp51_ = FALSE;
	gint _tmp52_;
	gint _tmp53_;
#line 298 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (search != NULL);
#line 298 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (table != NULL);
#line 298 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (showing != NULL);
#line 299 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 299 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_view_wrapper_get_library (_tmp0_);
#line 299 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 299 "../src/Views/ListView/ListView.vala"
	_tmp3_ = noise_library_get_search_result (_tmp2_);
#line 299 "../src/Views/ListView/ListView.vala"
	_result_ = _tmp3_;
#line 304 "../src/Views/ListView/ListView.vala"
	_tmp5_ = noise_list_view_get_column_browser_enabled (self);
#line 304 "../src/Views/ListView/ListView.vala"
	_tmp6_ = _tmp5_;
#line 304 "../src/Views/ListView/ListView.vala"
	if (_tmp6_) {
#line 1384 "ListView.c"
		gboolean _tmp7_;
#line 304 "../src/Views/ListView/ListView.vala"
		_tmp7_ = self->priv->obey_column_browser;
#line 304 "../src/Views/ListView/ListView.vala"
		_tmp4_ = _tmp7_;
#line 1390 "ListView.c"
	} else {
#line 304 "../src/Views/ListView/ListView.vala"
		_tmp4_ = FALSE;
#line 1394 "ListView.c"
	}
#line 304 "../src/Views/ListView/ListView.vala"
	obey_column_browser = _tmp4_;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp8_ = _result_;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp9_ = gee_collection_get_size (_tmp8_);
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp10_ = _tmp9_;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp11_ = self->priv->_view_wrapper;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp12_ = noise_view_wrapper_get_library (_tmp11_);
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp13_ = _tmp12_;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp14_ = noise_library_get_medias (_tmp13_);
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp15_ = _tmp14_;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp16_ = gee_collection_get_size (_tmp15_);
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp17_ = _tmp16_;
#line 306 "../src/Views/ListView/ListView.vala"
	_tmp18_ = _tmp10_ != _tmp17_;
#line 306 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp15_);
#line 306 "../src/Views/ListView/ListView.vala"
	if (_tmp18_) {
#line 1424 "ListView.c"
		{
			GeeArrayList* _m_list = NULL;
			GeeArrayList* _tmp19_;
			gint _m_size = 0;
			GeeArrayList* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gint _m_index = 0;
#line 307 "../src/Views/ListView/ListView.vala"
			_tmp19_ = _g_object_ref0 (table);
#line 307 "../src/Views/ListView/ListView.vala"
			_m_list = _tmp19_;
#line 307 "../src/Views/ListView/ListView.vala"
			_tmp20_ = _m_list;
#line 307 "../src/Views/ListView/ListView.vala"
			_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 307 "../src/Views/ListView/ListView.vala"
			_tmp22_ = _tmp21_;
#line 307 "../src/Views/ListView/ListView.vala"
			_m_size = _tmp22_;
#line 307 "../src/Views/ListView/ListView.vala"
			_m_index = -1;
#line 307 "../src/Views/ListView/ListView.vala"
			while (TRUE) {
#line 1449 "ListView.c"
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				NoiseMedia* m = NULL;
				GeeArrayList* _tmp26_;
				gint _tmp27_;
				gpointer _tmp28_;
				gboolean _tmp29_ = FALSE;
				gboolean _tmp30_;
				GeeCollection* _tmp33_;
				NoiseMedia* _tmp34_;
#line 307 "../src/Views/ListView/ListView.vala"
				_tmp23_ = _m_index;
#line 307 "../src/Views/ListView/ListView.vala"
				_m_index = _tmp23_ + 1;
#line 307 "../src/Views/ListView/ListView.vala"
				_tmp24_ = _m_index;
#line 307 "../src/Views/ListView/ListView.vala"
				_tmp25_ = _m_size;
#line 307 "../src/Views/ListView/ListView.vala"
				if (!(_tmp24_ < _tmp25_)) {
#line 307 "../src/Views/ListView/ListView.vala"
					break;
#line 1473 "ListView.c"
				}
#line 307 "../src/Views/ListView/ListView.vala"
				_tmp26_ = _m_list;
#line 307 "../src/Views/ListView/ListView.vala"
				_tmp27_ = _m_index;
#line 307 "../src/Views/ListView/ListView.vala"
				_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _tmp27_);
#line 307 "../src/Views/ListView/ListView.vala"
				m = (NoiseMedia*) _tmp28_;
#line 308 "../src/Views/ListView/ListView.vala"
				_tmp30_ = obey_column_browser;
#line 308 "../src/Views/ListView/ListView.vala"
				if (_tmp30_) {
#line 1487 "ListView.c"
					NoiseColumnBrowser* _tmp31_;
					NoiseMedia* _tmp32_;
#line 308 "../src/Views/ListView/ListView.vala"
					_tmp31_ = self->priv->_column_browser;
#line 308 "../src/Views/ListView/ListView.vala"
					_tmp32_ = m;
#line 308 "../src/Views/ListView/ListView.vala"
					_tmp29_ = !noise_column_browser_match_media (_tmp31_, _tmp32_);
#line 1496 "ListView.c"
				} else {
#line 308 "../src/Views/ListView/ListView.vala"
					_tmp29_ = FALSE;
#line 1500 "ListView.c"
				}
#line 308 "../src/Views/ListView/ListView.vala"
				if (_tmp29_) {
#line 309 "../src/Views/ListView/ListView.vala"
					_g_object_unref0 (m);
#line 309 "../src/Views/ListView/ListView.vala"
					continue;
#line 1508 "ListView.c"
				}
#line 312 "../src/Views/ListView/ListView.vala"
				_tmp33_ = _result_;
#line 312 "../src/Views/ListView/ListView.vala"
				_tmp34_ = m;
#line 312 "../src/Views/ListView/ListView.vala"
				if (gee_collection_contains (_tmp33_, _tmp34_)) {
#line 1516 "ListView.c"
					NoiseMedia* _tmp35_;
#line 313 "../src/Views/ListView/ListView.vala"
					_tmp35_ = m;
#line 313 "../src/Views/ListView/ListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) showing, _tmp35_);
#line 1522 "ListView.c"
				}
#line 307 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (m);
#line 1526 "ListView.c"
			}
#line 307 "../src/Views/ListView/ListView.vala"
			_g_object_unref0 (_m_list);
#line 1530 "ListView.c"
		}
	} else {
		{
			GeeArrayList* _m_list = NULL;
			GeeArrayList* _tmp36_;
			gint _m_size = 0;
			GeeArrayList* _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gint _m_index = 0;
#line 317 "../src/Views/ListView/ListView.vala"
			_tmp36_ = _g_object_ref0 (table);
#line 317 "../src/Views/ListView/ListView.vala"
			_m_list = _tmp36_;
#line 317 "../src/Views/ListView/ListView.vala"
			_tmp37_ = _m_list;
#line 317 "../src/Views/ListView/ListView.vala"
			_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
#line 317 "../src/Views/ListView/ListView.vala"
			_tmp39_ = _tmp38_;
#line 317 "../src/Views/ListView/ListView.vala"
			_m_size = _tmp39_;
#line 317 "../src/Views/ListView/ListView.vala"
			_m_index = -1;
#line 317 "../src/Views/ListView/ListView.vala"
			while (TRUE) {
#line 1557 "ListView.c"
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				NoiseMedia* m = NULL;
				GeeArrayList* _tmp43_;
				gint _tmp44_;
				gpointer _tmp45_;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_;
				NoiseMedia* _tmp50_;
#line 317 "../src/Views/ListView/ListView.vala"
				_tmp40_ = _m_index;
#line 317 "../src/Views/ListView/ListView.vala"
				_m_index = _tmp40_ + 1;
#line 317 "../src/Views/ListView/ListView.vala"
				_tmp41_ = _m_index;
#line 317 "../src/Views/ListView/ListView.vala"
				_tmp42_ = _m_size;
#line 317 "../src/Views/ListView/ListView.vala"
				if (!(_tmp41_ < _tmp42_)) {
#line 317 "../src/Views/ListView/ListView.vala"
					break;
#line 1580 "ListView.c"
				}
#line 317 "../src/Views/ListView/ListView.vala"
				_tmp43_ = _m_list;
#line 317 "../src/Views/ListView/ListView.vala"
				_tmp44_ = _m_index;
#line 317 "../src/Views/ListView/ListView.vala"
				_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, _tmp44_);
#line 317 "../src/Views/ListView/ListView.vala"
				m = (NoiseMedia*) _tmp45_;
#line 318 "../src/Views/ListView/ListView.vala"
				_tmp47_ = obey_column_browser;
#line 318 "../src/Views/ListView/ListView.vala"
				if (_tmp47_) {
#line 1594 "ListView.c"
					NoiseColumnBrowser* _tmp48_;
					NoiseMedia* _tmp49_;
#line 318 "../src/Views/ListView/ListView.vala"
					_tmp48_ = self->priv->_column_browser;
#line 318 "../src/Views/ListView/ListView.vala"
					_tmp49_ = m;
#line 318 "../src/Views/ListView/ListView.vala"
					_tmp46_ = !noise_column_browser_match_media (_tmp48_, _tmp49_);
#line 1603 "ListView.c"
				} else {
#line 318 "../src/Views/ListView/ListView.vala"
					_tmp46_ = FALSE;
#line 1607 "ListView.c"
				}
#line 318 "../src/Views/ListView/ListView.vala"
				if (_tmp46_) {
#line 319 "../src/Views/ListView/ListView.vala"
					_g_object_unref0 (m);
#line 319 "../src/Views/ListView/ListView.vala"
					continue;
#line 1615 "ListView.c"
				}
#line 322 "../src/Views/ListView/ListView.vala"
				_tmp50_ = m;
#line 322 "../src/Views/ListView/ListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) showing, _tmp50_);
#line 317 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (m);
#line 1623 "ListView.c"
			}
#line 317 "../src/Views/ListView/ListView.vala"
			_g_object_unref0 (_m_list);
#line 1627 "ListView.c"
		}
	}
#line 327 "../src/Views/ListView/ListView.vala"
	_tmp52_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) showing);
#line 327 "../src/Views/ListView/ListView.vala"
	_tmp53_ = _tmp52_;
#line 327 "../src/Views/ListView/ListView.vala"
	if (_tmp53_ < 1) {
#line 327 "../src/Views/ListView/ListView.vala"
		_tmp51_ = g_strcmp0 (search, "") != 0;
#line 1638 "ListView.c"
	} else {
#line 327 "../src/Views/ListView/ListView.vala"
		_tmp51_ = FALSE;
#line 1642 "ListView.c"
	}
#line 327 "../src/Views/ListView/ListView.vala"
	if (_tmp51_) {
#line 1646 "ListView.c"
		NoiseLibraryWindow* _tmp54_;
		NoiseLibraryWindow* _tmp55_;
		NoiseViewStack* _tmp56_;
		NoiseViewStack* _tmp57_;
#line 328 "../src/Views/ListView/ListView.vala"
		_tmp54_ = noise_app_get_main_window ();
#line 328 "../src/Views/ListView/ListView.vala"
		_tmp55_ = _tmp54_;
#line 328 "../src/Views/ListView/ListView.vala"
		_tmp56_ = noise_library_window_get_view_stack (_tmp55_);
#line 328 "../src/Views/ListView/ListView.vala"
		_tmp57_ = _tmp56_;
#line 328 "../src/Views/ListView/ListView.vala"
		noise_view_stack_show_alert (_tmp57_);
#line 1661 "ListView.c"
	}
#line 298 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_result_);
#line 1665 "ListView.c"
}


NoiseColumnBrowser*
noise_list_view_get_column_browser (NoiseListView* self)
{
	NoiseColumnBrowser* result;
	NoiseColumnBrowser* _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_column_browser;
#line 38 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
	return result;
#line 1682 "ListView.c"
}


void
noise_list_view_set_column_browser (NoiseListView* self,
                                    NoiseColumnBrowser* value)
{
#line 38 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Views/ListView/ListView.vala"
	if (noise_list_view_get_column_browser (self) != value) {
#line 1694 "ListView.c"
		NoiseColumnBrowser* _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->_column_browser);
#line 38 "../src/Views/ListView/ListView.vala"
		self->priv->_column_browser = _tmp0_;
#line 38 "../src/Views/ListView/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_list_view_properties[NOISE_LIST_VIEW_COLUMN_BROWSER_PROPERTY]);
#line 1704 "ListView.c"
	}
}


NoiseMusicListView*
noise_list_view_get_list_view (NoiseListView* self)
{
	NoiseMusicListView* result;
	NoiseMusicListView* _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 39 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
	return result;
#line 1722 "ListView.c"
}


void
noise_list_view_set_list_view (NoiseListView* self,
                               NoiseMusicListView* value)
{
#line 39 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Views/ListView/ListView.vala"
	if (noise_list_view_get_list_view (self) != value) {
#line 1734 "ListView.c"
		NoiseMusicListView* _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->_list_view);
#line 39 "../src/Views/ListView/ListView.vala"
		self->priv->_list_view = _tmp0_;
#line 39 "../src/Views/ListView/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_list_view_properties[NOISE_LIST_VIEW_LIST_VIEW_PROPERTY]);
#line 1744 "ListView.c"
	}
}


NoiseViewWrapper*
noise_list_view_get_view_wrapper (NoiseListView* self)
{
	NoiseViewWrapper* result;
	NoiseViewWrapper* _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_view_wrapper;
#line 41 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
	return result;
#line 1762 "ListView.c"
}


void
noise_list_view_set_view_wrapper (NoiseListView* self,
                                  NoiseViewWrapper* value)
{
#line 41 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Views/ListView/ListView.vala"
	if (noise_list_view_get_view_wrapper (self) != value) {
#line 1774 "ListView.c"
		NoiseViewWrapper* _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->_view_wrapper);
#line 41 "../src/Views/ListView/ListView.vala"
		self->priv->_view_wrapper = _tmp0_;
#line 41 "../src/Views/ListView/ListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_list_view_properties[NOISE_LIST_VIEW_VIEW_WRAPPER_PROPERTY]);
#line 1784 "ListView.c"
	}
}


guint
noise_list_view_get_n_media (NoiseListView* self)
{
	guint result;
	NoiseMusicListView* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
#line 46 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_generic_list_get_table ((NoiseGenericList*) _tmp0_);
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp4_ = _tmp3_;
#line 46 "../src/Views/ListView/ListView.vala"
	_tmp5_ = (guint) _tmp4_;
#line 46 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (_tmp2_);
#line 46 "../src/Views/ListView/ListView.vala"
	result = _tmp5_;
#line 46 "../src/Views/ListView/ListView.vala"
	return result;
#line 1819 "ListView.c"
}


gboolean
noise_list_view_get_has_column_browser (NoiseListView* self)
{
	gboolean result;
	NoiseColumnBrowser* _tmp0_;
#line 51 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_column_browser;
#line 51 "../src/Views/ListView/ListView.vala"
	result = _tmp0_ != NULL;
#line 51 "../src/Views/ListView/ListView.vala"
	return result;
#line 1836 "ListView.c"
}


gboolean
noise_list_view_get_column_browser_enabled (NoiseListView* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 54 "../src/Views/ListView/ListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/Views/ListView/ListView.vala"
	_tmp1_ = noise_list_view_get_has_column_browser (self);
#line 55 "../src/Views/ListView/ListView.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/Views/ListView/ListView.vala"
	if (_tmp2_) {
#line 1855 "ListView.c"
		NoiseColumnBrowser* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp3_ = self->priv->_column_browser;
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp4_ = gtk_widget_get_no_show_all ((GtkWidget*) _tmp3_);
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp5_ = _tmp4_;
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp0_ = !_tmp5_;
#line 1867 "ListView.c"
	} else {
#line 55 "../src/Views/ListView/ListView.vala"
		_tmp0_ = FALSE;
#line 1871 "ListView.c"
	}
#line 55 "../src/Views/ListView/ListView.vala"
	result = _tmp0_;
#line 55 "../src/Views/ListView/ListView.vala"
	return result;
#line 1877 "ListView.c"
}


static void
noise_list_view_set_column_browser_enabled (NoiseListView* self,
                                            gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 57 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Views/ListView/ListView.vala"
	_tmp0_ = noise_list_view_get_has_column_browser (self);
#line 58 "../src/Views/ListView/ListView.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Views/ListView/ListView.vala"
	if (_tmp1_) {
#line 1895 "ListView.c"
		NoiseColumnBrowser* _tmp2_;
#line 59 "../src/Views/ListView/ListView.vala"
		_tmp2_ = self->priv->_column_browser;
#line 59 "../src/Views/ListView/ListView.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp2_, !value);
#line 60 "../src/Views/ListView/ListView.vala"
		if (value) {
#line 1903 "ListView.c"
			NoiseColumnBrowser* _tmp3_;
			NoiseColumnBrowser* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 62 "../src/Views/ListView/ListView.vala"
			_tmp3_ = self->priv->_column_browser;
#line 62 "../src/Views/ListView/ListView.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 64 "../src/Views/ListView/ListView.vala"
			_tmp4_ = self->priv->_column_browser;
#line 64 "../src/Views/ListView/ListView.vala"
			_tmp5_ = noise_column_browser_get_initialized (_tmp4_);
#line 64 "../src/Views/ListView/ListView.vala"
			_tmp6_ = _tmp5_;
#line 64 "../src/Views/ListView/ListView.vala"
			if (!_tmp6_) {
#line 1920 "ListView.c"
				NoiseColumnBrowser* _tmp7_;
				GeeCollection* _tmp8_;
				GeeCollection* _tmp9_;
#line 65 "../src/Views/ListView/ListView.vala"
				_tmp7_ = self->priv->_column_browser;
#line 65 "../src/Views/ListView/ListView.vala"
				_tmp8_ = noise_view_interface_get_visible_media ((NoiseViewInterface*) self);
#line 65 "../src/Views/ListView/ListView.vala"
				_tmp9_ = _tmp8_;
#line 65 "../src/Views/ListView/ListView.vala"
				noise_column_browser_set_media (_tmp7_, _tmp9_);
#line 65 "../src/Views/ListView/ListView.vala"
				_g_object_unref0 (_tmp9_);
#line 1934 "ListView.c"
			}
		} else {
			NoiseColumnBrowser* _tmp10_;
			NoiseColumnBrowser* _tmp11_;
#line 71 "../src/Views/ListView/ListView.vala"
			_tmp10_ = self->priv->_column_browser;
#line 71 "../src/Views/ListView/ListView.vala"
			gtk_widget_hide ((GtkWidget*) _tmp10_);
#line 72 "../src/Views/ListView/ListView.vala"
			_tmp11_ = self->priv->_column_browser;
#line 72 "../src/Views/ListView/ListView.vala"
			noise_column_browser_reset_filters (_tmp11_);
#line 1947 "ListView.c"
		}
	}
#line 57 "../src/Views/ListView/ListView.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_list_view_properties[NOISE_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY]);
#line 1952 "ListView.c"
}


static void
_noise_list_view___lambda73_ (NoiseListView* self)
{
#line 90 "../src/Views/ListView/ListView.vala"
	g_signal_emit (self, noise_list_view_signals[NOISE_LIST_VIEW_REORDERED_SIGNAL], 0);
#line 1961 "ListView.c"
}


static void
__noise_list_view___lambda73__noise_generic_list_rows_reordered (NoiseGenericList* _sender,
                                                                 gpointer self)
{
#line 89 "../src/Views/ListView/ListView.vala"
	_noise_list_view___lambda73_ ((NoiseListView*) self);
#line 1971 "ListView.c"
}


static void
_noise_list_view___lambda74_ (NoiseListView* self,
                              GeeCollection* to_import)
{
#line 93 "../src/Views/ListView/ListView.vala"
	g_return_if_fail (to_import != NULL);
#line 94 "../src/Views/ListView/ListView.vala"
	g_signal_emit_by_name ((NoiseViewInterface*) self, "import-requested", to_import);
#line 1983 "ListView.c"
}


static void
__noise_list_view___lambda74__noise_generic_list_import_requested (NoiseGenericList* _sender,
                                                                   GeeCollection* to_import,
                                                                   gpointer self)
{
#line 93 "../src/Views/ListView/ListView.vala"
	_noise_list_view___lambda74_ ((NoiseListView*) self, to_import);
#line 1994 "ListView.c"
}


static void
_noise_list_view_view_search_func_noise_generic_list_view_search_func (const gchar* search,
                                                                       GeeArrayList* table,
                                                                       GeeArrayList* showing,
                                                                       gpointer self)
{
#line 97 "../src/Views/ListView/ListView.vala"
	noise_list_view_view_search_func ((NoiseListView*) self, search, table, showing);
#line 2006 "ListView.c"
}


static void
_noise_list_view___lambda75_ (NoiseListView* self)
{
	NoiseMusicListView* _tmp0_;
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp0_ = self->priv->_list_view;
#line 98 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_research_needed ((NoiseGenericList*) _tmp0_, TRUE);
#line 2018 "ListView.c"
}


static void
__noise_list_view___lambda75__noise_library_search_finished (NoiseLibrary* _sender,
                                                             gpointer self)
{
#line 98 "../src/Views/ListView/ListView.vala"
	_noise_list_view___lambda75_ ((NoiseListView*) self);
#line 2028 "ListView.c"
}


static void
_noise_list_view_connect_column_browser_ui_signals_gtk_widget_realize (GtkWidget* _sender,
                                                                       gpointer self)
{
#line 112 "../src/Views/ListView/ListView.vala"
	noise_list_view_connect_column_browser_ui_signals ((NoiseListView*) self);
#line 2038 "ListView.c"
}


static void
_noise_list_view_column_browser_changed_noise_column_browser_changed (NoiseColumnBrowser* _sender,
                                                                      gpointer self)
{
#line 117 "../src/Views/ListView/ListView.vala"
	noise_list_view_column_browser_changed ((NoiseListView*) self);
#line 2048 "ListView.c"
}


static GObject *
noise_list_view_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseListView * self;
	GtkScrolledWindow* list_scrolled = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkScrolledWindow* _tmp1_;
	NoiseMusicListView* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	NoiseMusicListView* _tmp4_;
	NoiseMusicListView* _tmp5_;
	NoiseMusicListView* _tmp6_;
	NoiseViewWrapper* _tmp7_;
	NoiseLibrary* _tmp8_;
	NoiseLibrary* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 84 "../src/Views/ListView/ListView.vala"
	parent_class = G_OBJECT_CLASS (noise_list_view_parent_class);
#line 84 "../src/Views/ListView/ListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 84 "../src/Views/ListView/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LIST_VIEW, NoiseListView);
#line 85 "../src/Views/ListView/ListView.vala"
	_tmp0_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 85 "../src/Views/ListView/ListView.vala"
	g_object_ref_sink (_tmp0_);
#line 85 "../src/Views/ListView/ListView.vala"
	list_scrolled = _tmp0_;
#line 86 "../src/Views/ListView/ListView.vala"
	_tmp1_ = list_scrolled;
#line 86 "../src/Views/ListView/ListView.vala"
	_tmp2_ = self->priv->_list_view;
#line 86 "../src/Views/ListView/ListView.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp2_);
#line 87 "../src/Views/ListView/ListView.vala"
	_tmp3_ = list_scrolled;
#line 87 "../src/Views/ListView/ListView.vala"
	g_object_set ((GtkWidget*) _tmp3_, "expand", TRUE, NULL);
#line 89 "../src/Views/ListView/ListView.vala"
	_tmp4_ = self->priv->_list_view;
#line 89 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((NoiseGenericList*) _tmp4_, "rows-reordered", (GCallback) __noise_list_view___lambda73__noise_generic_list_rows_reordered, self, 0);
#line 93 "../src/Views/ListView/ListView.vala"
	_tmp5_ = self->priv->_list_view;
#line 93 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object ((NoiseGenericList*) _tmp5_, "import-requested", (GCallback) __noise_list_view___lambda74__noise_generic_list_import_requested, self, 0);
#line 97 "../src/Views/ListView/ListView.vala"
	_tmp6_ = self->priv->_list_view;
#line 97 "../src/Views/ListView/ListView.vala"
	noise_generic_list_set_search_func ((NoiseGenericList*) _tmp6_, _noise_list_view_view_search_func_noise_generic_list_view_search_func, self);
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp7_ = self->priv->_view_wrapper;
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp8_ = noise_view_wrapper_get_library (_tmp7_);
#line 98 "../src/Views/ListView/ListView.vala"
	_tmp9_ = _tmp8_;
#line 98 "../src/Views/ListView/ListView.vala"
	g_signal_connect_object (_tmp9_, "search-finished", (GCallback) __noise_list_view___lambda75__noise_library_search_finished, self, 0);
#line 100 "../src/Views/ListView/ListView.vala"
	_tmp10_ = noise_list_view_get_has_column_browser (self);
#line 100 "../src/Views/ListView/ListView.vala"
	_tmp11_ = _tmp10_;
#line 100 "../src/Views/ListView/ListView.vala"
	if (_tmp11_) {
#line 2121 "ListView.c"
		GtkPaned* _tmp12_;
		GtkPaned* _tmp13_;
		GtkPaned* _tmp14_;
		NoiseColumnBrowser* _tmp15_;
		GtkPaned* _tmp16_;
		GtkScrolledWindow* _tmp17_;
		GtkPaned* _tmp18_;
		NoiseColumnBrowser* _tmp19_;
		NoiseColumnBrowserPosition _tmp20_;
		NoiseColumnBrowserPosition _tmp21_;
		GSettings* _tmp22_;
		GSettings* _tmp23_;
		NoiseColumnBrowser* _tmp24_;
#line 101 "../src/Views/ListView/ListView.vala"
		_tmp12_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 101 "../src/Views/ListView/ListView.vala"
		g_object_ref_sink (_tmp12_);
#line 101 "../src/Views/ListView/ListView.vala"
		_g_object_unref0 (self->priv->browser_pane);
#line 101 "../src/Views/ListView/ListView.vala"
		self->priv->browser_pane = _tmp12_;
#line 102 "../src/Views/ListView/ListView.vala"
		_tmp13_ = self->priv->browser_pane;
#line 102 "../src/Views/ListView/ListView.vala"
		g_object_set ((GtkWidget*) _tmp13_, "expand", TRUE, NULL);
#line 103 "../src/Views/ListView/ListView.vala"
		_tmp14_ = self->priv->browser_pane;
#line 103 "../src/Views/ListView/ListView.vala"
		_tmp15_ = self->priv->_column_browser;
#line 103 "../src/Views/ListView/ListView.vala"
		gtk_paned_pack1 (_tmp14_, (GtkWidget*) _tmp15_, FALSE, FALSE);
#line 104 "../src/Views/ListView/ListView.vala"
		_tmp16_ = self->priv->browser_pane;
#line 104 "../src/Views/ListView/ListView.vala"
		_tmp17_ = list_scrolled;
#line 104 "../src/Views/ListView/ListView.vala"
		gtk_paned_pack2 (_tmp16_, (GtkWidget*) _tmp17_, TRUE, FALSE);
#line 106 "../src/Views/ListView/ListView.vala"
		_tmp18_ = self->priv->browser_pane;
#line 106 "../src/Views/ListView/ListView.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
#line 108 "../src/Views/ListView/ListView.vala"
		_tmp19_ = self->priv->_column_browser;
#line 108 "../src/Views/ListView/ListView.vala"
		_tmp20_ = noise_column_browser_get_position (_tmp19_);
#line 108 "../src/Views/ListView/ListView.vala"
		_tmp21_ = _tmp20_;
#line 108 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_column_browser_position (self, _tmp21_);
#line 112 "../src/Views/ListView/ListView.vala"
		g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) _noise_list_view_connect_column_browser_ui_signals_gtk_widget_realize, self, 0);
#line 114 "../src/Views/ListView/ListView.vala"
		_tmp22_ = noise_app_get_saved_state ();
#line 114 "../src/Views/ListView/ListView.vala"
		_tmp23_ = _tmp22_;
#line 114 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_column_browser_enabled (self, g_settings_get_boolean (_tmp23_, "column-browser-enabled"));
#line 117 "../src/Views/ListView/ListView.vala"
		_tmp24_ = self->priv->_column_browser;
#line 117 "../src/Views/ListView/ListView.vala"
		g_signal_connect_object (_tmp24_, "changed", (GCallback) _noise_list_view_column_browser_changed_noise_column_browser_changed, self, 0);
#line 2183 "ListView.c"
	} else {
		GtkScrolledWindow* _tmp25_;
#line 119 "../src/Views/ListView/ListView.vala"
		_tmp25_ = list_scrolled;
#line 119 "../src/Views/ListView/ListView.vala"
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp25_);
#line 2190 "ListView.c"
	}
#line 84 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (list_scrolled);
#line 84 "../src/Views/ListView/ListView.vala"
	return obj;
#line 2196 "ListView.c"
}


static void
noise_list_view_class_init (NoiseListViewClass * klass)
{
#line 32 "../src/Views/ListView/ListView.vala"
	noise_list_view_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/Views/ListView/ListView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseListView_private_offset);
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_list_view_get_property;
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_list_view_set_property;
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_list_view_constructor;
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_list_view_finalize;
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LIST_VIEW_COLUMN_BROWSER_PROPERTY, noise_list_view_properties[NOISE_LIST_VIEW_COLUMN_BROWSER_PROPERTY] = g_param_spec_object ("column-browser", "column-browser", "column-browser", NOISE_TYPE_COLUMN_BROWSER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LIST_VIEW_LIST_VIEW_PROPERTY, noise_list_view_properties[NOISE_LIST_VIEW_LIST_VIEW_PROPERTY] = g_param_spec_object ("list-view", "list-view", "list-view", NOISE_TYPE_MUSIC_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LIST_VIEW_VIEW_WRAPPER_PROPERTY, noise_list_view_properties[NOISE_LIST_VIEW_VIEW_WRAPPER_PROPERTY] = g_param_spec_object ("view-wrapper", "view-wrapper", "view-wrapper", NOISE_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LIST_VIEW_N_MEDIA_PROPERTY, noise_list_view_properties[NOISE_LIST_VIEW_N_MEDIA_PROPERTY] = g_param_spec_uint ("n-media", "n-media", "n-media", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY, noise_list_view_properties[NOISE_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY] = g_param_spec_boolean ("has-column-browser", "has-column-browser", "has-column-browser", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Views/ListView/ListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY, noise_list_view_properties[NOISE_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY] = g_param_spec_boolean ("column-browser-enabled", "column-browser-enabled", "column-browser-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../src/Views/ListView/ListView.vala"
	noise_list_view_signals[NOISE_LIST_VIEW_REORDERED_SIGNAL] = g_signal_new ("reordered", NOISE_TYPE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2229 "ListView.c"
}


static void
noise_list_view_noise_view_interface_interface_init (NoiseViewInterfaceIface * iface)
{
#line 32 "../src/Views/ListView/ListView.vala"
	noise_list_view_noise_view_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../src/Views/ListView/ListView.vala"
	iface->get_hint = (NoiseViewWrapperHint (*) (NoiseViewInterface*)) noise_list_view_real_get_hint;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->get_media = (GeeCollection* (*) (NoiseViewInterface*)) noise_list_view_real_get_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->get_visible_media = (GeeCollection* (*) (NoiseViewInterface*)) noise_list_view_real_get_visible_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->add_media = (void (*) (NoiseViewInterface*, GeeCollection*)) noise_list_view_real_add_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->remove_media = (void (*) (NoiseViewInterface*, GeeCollection*)) noise_list_view_real_remove_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->set_media = (void (*) (NoiseViewInterface*, GeeCollection*)) noise_list_view_real_set_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->update_media = (void (*) (NoiseViewInterface*, GeeCollection*)) noise_list_view_real_update_media;
#line 32 "../src/Views/ListView/ListView.vala"
	iface->refilter = (void (*) (NoiseViewInterface*)) noise_list_view_real_refilter;
#line 2254 "ListView.c"
}


static void
noise_list_view_instance_init (NoiseListView * self)
{
#line 32 "../src/Views/ListView/ListView.vala"
	self->priv = noise_list_view_get_instance_private (self);
#line 43 "../src/Views/ListView/ListView.vala"
	self->priv->obey_column_browser = FALSE;
#line 2265 "ListView.c"
}


static void
noise_list_view_finalize (GObject * obj)
{
	NoiseListView * self;
#line 32 "../src/Views/ListView/ListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LIST_VIEW, NoiseListView);
#line 36 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->browser_pane);
#line 38 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->_column_browser);
#line 39 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->_list_view);
#line 41 "../src/Views/ListView/ListView.vala"
	_g_object_unref0 (self->priv->_view_wrapper);
#line 32 "../src/Views/ListView/ListView.vala"
	G_OBJECT_CLASS (noise_list_view_parent_class)->finalize (obj);
#line 2285 "ListView.c"
}


/**
 * Contains the column browser and list view.
 */
GType
noise_list_view_get_type (void)
{
	static volatile gsize noise_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseListView), 0, (GInstanceInitFunc) noise_list_view_instance_init, NULL };
		static const GInterfaceInfo noise_view_interface_info = { (GInterfaceInitFunc) noise_list_view_noise_view_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_list_view_type_id;
		noise_list_view_type_id = g_type_register_static (gtk_box_get_type (), "NoiseListView", &g_define_type_info, 0);
		g_type_add_interface_static (noise_list_view_type_id, NOISE_TYPE_VIEW_INTERFACE, &noise_view_interface_info);
		NoiseListView_private_offset = g_type_add_instance_private (noise_list_view_type_id, sizeof (NoiseListViewPrivate));
		g_once_init_leave (&noise_list_view_type_id__volatile, noise_list_view_type_id);
	}
	return noise_list_view_type_id__volatile;
}


static void
_vala_noise_list_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	NoiseListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LIST_VIEW, NoiseListView);
#line 32 "../src/Views/ListView/ListView.vala"
	switch (property_id) {
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_COLUMN_BROWSER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_object (value, noise_list_view_get_column_browser (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_LIST_VIEW_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_object (value, noise_list_view_get_list_view (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_VIEW_WRAPPER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_object (value, noise_list_view_get_view_wrapper (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_N_MEDIA_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_uint (value, noise_list_view_get_n_media (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_HAS_COLUMN_BROWSER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_boolean (value, noise_list_view_get_has_column_browser (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		g_value_set_boolean (value, noise_list_view_get_column_browser_enabled (self));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 2355 "ListView.c"
		default:
#line 32 "../src/Views/ListView/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 2361 "ListView.c"
	}
}


static void
_vala_noise_list_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	NoiseListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LIST_VIEW, NoiseListView);
#line 32 "../src/Views/ListView/ListView.vala"
	switch (property_id) {
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_COLUMN_BROWSER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_column_browser (self, g_value_get_object (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_LIST_VIEW_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_list_view (self, g_value_get_object (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_VIEW_WRAPPER_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_view_wrapper (self, g_value_get_object (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 32 "../src/Views/ListView/ListView.vala"
		case NOISE_LIST_VIEW_COLUMN_BROWSER_ENABLED_PROPERTY:
#line 32 "../src/Views/ListView/ListView.vala"
		noise_list_view_set_column_browser_enabled (self, g_value_get_boolean (value));
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 2400 "ListView.c"
		default:
#line 32 "../src/Views/ListView/ListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Views/ListView/ListView.vala"
		break;
#line 2406 "ListView.c"
	}
}



