/* MusicListView.c generated by valac 0.42.6, the Vala compiler
 * generated from MusicListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Corentin Noël <corentin@elementary.io>,
 *              Lucas Baudin <xapantu@gmail.com>,
 *              ammonkey <am.monkeyd@gmail.com>,
 *              Victor Martinez <victoreduardm@gmail.com>,
 *              Sergey Davidoff <shnatsel@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>


#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;
typedef struct _NoiseGenericListPrivate NoiseGenericListPrivate;
typedef enum  {
	NOISE_LIST_COLUMN_ICON = 0,
	NOISE_LIST_COLUMN_NUMBER,
	NOISE_LIST_COLUMN_TRACK,
	NOISE_LIST_COLUMN_TITLE,
	NOISE_LIST_COLUMN_LENGTH,
	NOISE_LIST_COLUMN_ARTIST,
	NOISE_LIST_COLUMN_ALBUM,
	NOISE_LIST_COLUMN_ALBUM_ARTIST,
	NOISE_LIST_COLUMN_COMPOSER,
	NOISE_LIST_COLUMN_GENRE,
	NOISE_LIST_COLUMN_YEAR,
	NOISE_LIST_COLUMN_GROUPING,
	NOISE_LIST_COLUMN_BITRATE,
	NOISE_LIST_COLUMN_RATING,
	NOISE_LIST_COLUMN_PLAY_COUNT,
	NOISE_LIST_COLUMN_SKIP_COUNT,
	NOISE_LIST_COLUMN_DATE_ADDED,
	NOISE_LIST_COLUMN_LAST_PLAYED,
	NOISE_LIST_COLUMN_BPM,
	NOISE_LIST_COLUMN_FILE_LOCATION,
	NOISE_LIST_COLUMN_FILE_SIZE,
	NOISE_LIST_COLUMN_N_COLUMNS
} NoiseListColumn;


#define NOISE_TYPE_LIST_COLUMN (noise_list_column_get_type ())

#define NOISE_TYPE_FAST_MODEL (noise_fast_model_get_type ())
#define NOISE_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModel))
#define NOISE_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))
#define NOISE_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_MODEL))
#define NOISE_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_MODEL))
#define NOISE_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))

typedef struct _NoiseFastModel NoiseFastModel;
typedef struct _NoiseFastModelClass NoiseFastModelClass;

#define NOISE_TYPE_CELL_DATA_FUNCTION_HELPER (noise_cell_data_function_helper_get_type ())
#define NOISE_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelper))
#define NOISE_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelperClass))
#define NOISE_IS_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER))
#define NOISE_IS_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER))
#define NOISE_CELL_DATA_FUNCTION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelperClass))

typedef struct _NoiseCellDataFunctionHelper NoiseCellDataFunctionHelper;
typedef struct _NoiseCellDataFunctionHelperClass NoiseCellDataFunctionHelperClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;
typedef struct _NoiseMusicListViewPrivate NoiseMusicListViewPrivate;

#define NOISE_TYPE_MEDIA_MENU (noise_media_menu_get_type ())
#define NOISE_MEDIA_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA_MENU, NoiseMediaMenu))
#define NOISE_MEDIA_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA_MENU, NoiseMediaMenuClass))
#define NOISE_IS_MEDIA_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA_MENU))
#define NOISE_IS_MEDIA_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA_MENU))
#define NOISE_MEDIA_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA_MENU, NoiseMediaMenuClass))

typedef struct _NoiseMediaMenu NoiseMediaMenu;
typedef struct _NoiseMediaMenuClass NoiseMediaMenuClass;
enum  {
	NOISE_MUSIC_LIST_VIEW_0_PROPERTY,
	NOISE_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY,
	NOISE_MUSIC_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_music_list_view_properties[NOISE_MUSIC_LIST_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;

#define NOISE_TYPE_TREE_VIEW_SETUP (noise_tree_view_setup_get_type ())
#define NOISE_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup))
#define NOISE_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))
#define NOISE_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))

typedef struct _NoiseTreeViewSetup NoiseTreeViewSetup;
typedef struct _NoiseTreeViewSetupClass NoiseTreeViewSetupClass;
typedef struct _Block23Data Block23Data;
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block24Data Block24Data;

#define NOISE_TYPE_REMOVE_FILES_DIALOG (noise_remove_files_dialog_get_type ())
#define NOISE_REMOVE_FILES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_REMOVE_FILES_DIALOG, NoiseRemoveFilesDialog))
#define NOISE_REMOVE_FILES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_REMOVE_FILES_DIALOG, NoiseRemoveFilesDialogClass))
#define NOISE_IS_REMOVE_FILES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_REMOVE_FILES_DIALOG))
#define NOISE_IS_REMOVE_FILES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_REMOVE_FILES_DIALOG))
#define NOISE_REMOVE_FILES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_REMOVE_FILES_DIALOG, NoiseRemoveFilesDialogClass))

typedef struct _NoiseRemoveFilesDialog NoiseRemoveFilesDialog;
typedef struct _NoiseRemoveFilesDialogClass NoiseRemoveFilesDialogClass;

#define NOISE_TYPE_DEVICE_VIEW_WRAPPER (noise_device_view_wrapper_get_type ())
#define NOISE_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_VIEW_WRAPPER, NoiseDeviceViewWrapper))
#define NOISE_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_VIEW_WRAPPER, NoiseDeviceViewWrapperClass))
#define NOISE_IS_DEVICE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_VIEW_WRAPPER))
#define NOISE_IS_DEVICE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_VIEW_WRAPPER))
#define NOISE_DEVICE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_VIEW_WRAPPER, NoiseDeviceViewWrapperClass))

typedef struct _NoiseDeviceViewWrapper NoiseDeviceViewWrapper;
typedef struct _NoiseDeviceViewWrapperClass NoiseDeviceViewWrapperClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;

#define MUSIC_TYPE_RATING_CELL_RENDERER (music_rating_cell_renderer_get_type ())
#define MUSIC_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRenderer))
#define MUSIC_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))
#define MUSIC_IS_RATING_CELL_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_IS_RATING_CELL_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_CELL_RENDERER))
#define MUSIC_RATING_CELL_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_CELL_RENDERER, MusicRatingCellRendererClass))

typedef struct _MusicRatingCellRenderer MusicRatingCellRenderer;
typedef struct _MusicRatingCellRendererClass MusicRatingCellRendererClass;
typedef GValue* (*NoiseFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
typedef gint (*NoiseGenericListSortCompareFunc) (gint sort_column_id, GtkSortType sort_direction, NoiseMedia* a, NoiseMedia* b, gint index_a, gint index_b, gpointer user_data);
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NoiseGenericList {
	GtkTreeView parent_instance;
	NoiseGenericListPrivate * priv;
	NoiseFastModel* fm;
	GeeArrayList* table;
	GeeArrayList* showing;
	gint sort_column_id;
	GtkSortType sort_direction;
	gboolean dragging;
	NoiseCellDataFunctionHelper* cell_data_helper;
};

struct _NoiseGenericListClass {
	GtkTreeViewClass parent_class;
	void (*add_column) (NoiseGenericList* self, GtkTreeViewColumn* column, NoiseListColumn type);
	void (*mediaRemoveClicked) (NoiseGenericList* self);
};

struct _NoiseMusicListView {
	NoiseGenericList parent_instance;
	NoiseMusicListViewPrivate * priv;
	GtkMenu* column_chooser_menu;
};

struct _NoiseMusicListViewClass {
	NoiseGenericListClass parent_class;
	void (*onDragDataGet) (NoiseMusicListView* self, GdkDragContext* context, GtkSelectionData* selection_data, guint info, guint time_);
};

struct _NoiseMusicListViewPrivate {
	NoiseMediaMenu* _media_action_menu;
	GtkMenuItem* autosize_menu_item;
};

struct _Block23Data {
	int _ref_count_;
	NoiseMusicListView* self;
	GtkCheckMenuItem* menu_item;
	GtkTreeViewColumn* tvc;
};

struct _Block24Data {
	int _ref_count_;
	NoiseMusicListView* self;
	GeeCollection* selected_media;
};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};


static gint NoiseMusicListView_private_offset;
static gpointer noise_music_list_view_parent_class = NULL;

GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_list_column_get_type (void) G_GNUC_CONST;
GType noise_fast_model_get_type (void) G_GNUC_CONST;
gpointer noise_cell_data_function_helper_ref (gpointer instance);
void noise_cell_data_function_helper_unref (gpointer instance);
GParamSpec* noise_param_spec_cell_data_function_helper (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
void noise_value_set_cell_data_function_helper (GValue* value,
                                                gpointer v_object);
void noise_value_take_cell_data_function_helper (GValue* value,
                                                 gpointer v_object);
gpointer noise_value_get_cell_data_function_helper (const GValue* value);
GType noise_cell_data_function_helper_get_type (void) G_GNUC_CONST;
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
GType noise_media_menu_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
GType noise_tree_view_setup_get_type (void) G_GNUC_CONST;
NoiseMusicListView* noise_music_list_view_new (NoiseViewWrapper* view_wrapper,
                                               NoiseTreeViewSetup* tvs);
NoiseMusicListView* noise_music_list_view_construct (GType object_type,
                                                     NoiseViewWrapper* view_wrapper,
                                                     NoiseTreeViewSetup* tvs);
static void noise_music_list_view_add_column_chooser_menu_item (NoiseMusicListView* self,
                                                         GtkTreeViewColumn* tvc,
                                                         NoiseListColumn type);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
NoiseViewWrapperHint noise_generic_list_get_hint (NoiseGenericList* self);
static void noise_music_list_view_columns_autosize (NoiseMusicListView* self);
static void _noise_music_list_view_columns_autosize_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void __lambda62_ (Block23Data* _data23_);
static void ___lambda62__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                               gpointer self);
void noise_music_list_view_add_media (NoiseMusicListView* self,
                                      GeeCollection* to_add);
void noise_generic_list_resort (NoiseGenericList* self);
void noise_music_list_view_remove_media (NoiseMusicListView* self,
                                         GeeCollection* to_remove);
void noise_generic_list_set_table (NoiseGenericList* self,
                                   GeeArrayList* table,
                                   gboolean do_resort);
static gboolean noise_music_list_view_real_button_press_event (GtkWidget* base,
                                                        GdkEventButton* event);
static gboolean noise_music_list_view_check_selection_event (NoiseMusicListView* self,
                                                      GdkEventButton* event);
NoiseMediaMenu* noise_music_list_view_get_media_action_menu (NoiseMusicListView* self);
void noise_media_menu_popup_media_menu (NoiseMediaMenu* self,
                                        GeeCollection* selection);
GeeCollection* noise_generic_list_get_selected_medias (NoiseGenericList* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void noise_music_list_view_reset_column_widths (NoiseMusicListView* self);
static gboolean noise_music_list_view_view_click_release (NoiseMusicListView* self,
                                                   GtkWidget* sender,
                                                   GdkEventButton* event);
static gboolean noise_music_list_view_view_header_click (NoiseMusicListView* self,
                                                  GdkEventButton* e,
                                                  gboolean is_selector_col);
static void noise_music_list_view_real_mediaRemoveClicked (NoiseGenericList* base);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
GType noise_remove_files_dialog_get_type (void) G_GNUC_CONST;
NoiseRemoveFilesDialog* noise_remove_files_dialog_new (GeeCollection* to_remove);
NoiseRemoveFilesDialog* noise_remove_files_dialog_construct (GType object_type,
                                                             GeeCollection* to_remove);
static void ___lambda63_ (Block24Data* _data24_,
                   gboolean delete_files);
NoiseViewWrapper* noise_generic_list_get_parent_wrapper (NoiseGenericList* self);
NoiseLibrary* noise_view_wrapper_get_library (NoiseViewWrapper* self);
static void ____lambda63__noise_remove_files_dialog_remove_media (NoiseRemoveFilesDialog* _sender,
                                                           gboolean response,
                                                           gpointer self);
GType noise_device_view_wrapper_get_type (void) G_GNUC_CONST;
NoisePlaylist* noise_generic_list_get_playlist (NoiseGenericList* self);
void noise_music_list_view_onDragDataGet (NoiseMusicListView* self,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time_);
static void noise_music_list_view_real_onDragDataGet (NoiseMusicListView* self,
                                               GdkDragContext* context,
                                               GtkSelectionData* selection_data,
                                               guint info,
                                               guint time_);
static void _vala_array_add14 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
gint noise_music_list_view_view_compare_func (NoiseMusicListView* self,
                                              gint column,
                                              GtkSortType dir,
                                              NoiseMedia* media_a,
                                              NoiseMedia* media_b,
                                              gint a_pos,
                                              gint b_pos);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
GValue* noise_music_list_view_view_value_func (NoiseMusicListView* self,
                                               gint row,
                                               gint column,
                                               GObject* o);
GValue* noise_list_column_get_value_for_media (NoiseListColumn self,
                                               NoiseMedia* m,
                                               gint media_row_index);
static void noise_music_list_view_real_add_column (NoiseGenericList* base,
                                            GtkTreeViewColumn* tvc,
                                            NoiseListColumn type);
void noise_cell_data_function_helper_icon_func (NoiseCellDataFunctionHelper* self,
                                                GtkCellLayout* layout,
                                                GtkCellRenderer* renderer,
                                                GtkTreeModel* model,
                                                GtkTreeIter* iter);
static void _noise_cell_data_function_helper_icon_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
void noise_cell_data_function_helper_spinner_func (NoiseCellDataFunctionHelper* self,
                                                   GtkCellLayout* layout,
                                                   GtkCellRenderer* renderer,
                                                   GtkTreeModel* model,
                                                   GtkTreeIter* iter);
static void _noise_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                              GtkCellRenderer* cell,
                                                                              GtkTreeModel* tree_model,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
void noise_cell_data_function_helper_bitrate_func (GtkCellLayout* layout,
                                                   GtkCellRenderer* cell,
                                                   GtkTreeModel* tree_model,
                                                   GtkTreeIter* iter);
static void _noise_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                              GtkCellRenderer* cell,
                                                                              GtkTreeModel* tree_model,
                                                                              GtkTreeIter* iter,
                                                                              gpointer self);
static void _vala_array_add15 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void noise_cell_data_function_helper_length_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _noise_cell_data_function_helper_length_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add16 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void noise_cell_data_function_helper_date_func (GtkCellLayout* layout,
                                                GtkCellRenderer* cell,
                                                GtkTreeModel* tree_model,
                                                GtkTreeIter* iter);
static void _noise_cell_data_function_helper_date_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self);
gchar* noise_cell_data_function_helper_get_date_string (guint n);
static void _vala_array_add17 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add18 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
GType music_rating_cell_renderer_get_type (void) G_GNUC_CONST;
MusicRatingCellRenderer* music_rating_cell_renderer_new (GtkIconSize icon_size);
MusicRatingCellRenderer* music_rating_cell_renderer_construct (GType object_type,
                                                               GtkIconSize icon_size);
void noise_generic_list_on_rating_cell_changed (NoiseGenericList* self,
                                                gint new_rating,
                                                GtkWidget* widget,
                                                const gchar* path);
static void _noise_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed (MusicRatingCellRenderer* _sender,
                                                                                           gint new_rating,
                                                                                           GtkWidget* widget,
                                                                                           const gchar* path,
                                                                                           gpointer self);
void noise_cell_data_function_helper_rating_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _noise_cell_data_function_helper_rating_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
void noise_cell_data_function_helper_number_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _noise_cell_data_function_helper_number_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add19 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void noise_cell_data_function_helper_intelligent_func (GtkCellLayout* layout,
                                                       GtkCellRenderer* cell,
                                                       GtkTreeModel* tree_model,
                                                       GtkTreeIter* iter);
static void _noise_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                  GtkCellRenderer* cell,
                                                                                  GtkTreeModel* tree_model,
                                                                                  GtkTreeIter* iter,
                                                                                  gpointer self);
static void _vala_array_add20 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add21 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void noise_cell_data_function_helper_string_func (GtkCellLayout* layout,
                                                  GtkCellRenderer* cell,
                                                  GtkTreeModel* tree_model,
                                                  GtkTreeIter* iter);
static void _noise_cell_data_function_helper_string_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self);
static void _vala_array_add22 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add23 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void noise_cell_data_function_helper_file_size_func (GtkCellLayout* layout,
                                                     GtkCellRenderer* cell,
                                                     GtkTreeModel* tree_model,
                                                     GtkTreeIter* iter);
static void _noise_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                GtkCellRenderer* cell,
                                                                                GtkTreeModel* tree_model,
                                                                                GtkTreeIter* iter,
                                                                                gpointer self);
static void _vala_array_add24 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void noise_generic_list_set_fixed_column_width (NoiseGenericList* self,
                                                GtkWidget* treeview,
                                                GtkTreeViewColumn* column,
                                                GtkCellRendererText* renderer,
                                                gchar** strings,
                                                int strings_length1,
                                                gint padding);
static gboolean ___lambda64_ (NoiseMusicListView* self,
                       GdkEventButton* e);
static gboolean ____lambda64__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static gboolean ___lambda65_ (NoiseMusicListView* self,
                       GdkEventButton* e);
static gboolean ____lambda65__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void noise_music_list_view_set_media_action_menu (NoiseMusicListView* self,
                                                  NoiseMediaMenu* value);
static GObject * noise_music_list_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
void noise_generic_list_set_value_func (NoiseGenericList* self,
                                        NoiseFastModelValueReturnFunc func,
                                        gpointer func_target);
static GValue* _noise_music_list_view_view_value_func_noise_fast_model_value_return_func (gint row,
                                                                                   gint column,
                                                                                   GObject* o,
                                                                                   gpointer self);
void noise_generic_list_set_compare_func (NoiseGenericList* self,
                                          NoiseGenericListSortCompareFunc func,
                                          gpointer func_target);
static gint _noise_music_list_view_view_compare_func_noise_generic_list_sort_compare_func (gint sort_column_id,
                                                                                    GtkSortType sort_direction,
                                                                                    NoiseMedia* a,
                                                                                    NoiseMedia* b,
                                                                                    gint index_a,
                                                                                    gint index_b,
                                                                                    gpointer self);
static gboolean _noise_music_list_view_view_click_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self);
NoiseMediaMenu* noise_media_menu_new (NoiseGenericList* generic_list);
NoiseMediaMenu* noise_media_menu_construct (GType object_type,
                                            NoiseGenericList* generic_list);
static void noise_music_list_view_finalize (GObject * obj);
static void _vala_noise_music_list_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_noise_music_list_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
noise_music_list_view_get_instance_private (NoiseMusicListView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseMusicListView_private_offset);
}


NoiseMusicListView*
noise_music_list_view_construct (GType object_type,
                                 NoiseViewWrapper* view_wrapper,
                                 NoiseTreeViewSetup* tvs)
{
	NoiseMusicListView * self = NULL;
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 42 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (NoiseMusicListView*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	return self;
#line 653 "MusicListView.c"
}


NoiseMusicListView*
noise_music_list_view_new (NoiseViewWrapper* view_wrapper,
                           NoiseTreeViewSetup* tvs)
{
#line 41 "../src/Views/ListView/Lists/MusicListView.vala"
	return noise_music_list_view_construct (NOISE_TYPE_MUSIC_LIST_VIEW, view_wrapper, tvs);
#line 663 "MusicListView.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 672 "MusicListView.c"
}


static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	return _data23_;
#line 683 "MusicListView.c"
}


static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 694 "MusicListView.c"
		NoiseMusicListView* self;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		self = _data23_->self;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_data23_->menu_item);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_data23_->tvc);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
		g_slice_free (Block23Data, _data23_);
#line 706 "MusicListView.c"
	}
}


static void
_noise_music_list_view_columns_autosize_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
#line 75 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_music_list_view_columns_autosize ((NoiseMusicListView*) self);
#line 717 "MusicListView.c"
}


static void
__lambda62_ (Block23Data* _data23_)
{
	NoiseMusicListView* self;
	GtkCheckMenuItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	self = _data23_->self;
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = _data23_->menu_item;
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = gtk_check_menu_item_get_active (_tmp0_);
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = _tmp1_;
#line 91 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_visible (_data23_->tvc, _tmp2_);
#line 93 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_music_list_view_columns_autosize (self);
#line 740 "MusicListView.c"
}


static void
___lambda62__gtk_check_menu_item_toggled (GtkCheckMenuItem* _sender,
                                          gpointer self)
{
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	__lambda62_ (self);
#line 750 "MusicListView.c"
}


static void
noise_music_list_view_add_column_chooser_menu_item (NoiseMusicListView* self,
                                                    GtkTreeViewColumn* tvc,
                                                    NoiseListColumn type)
{
	Block23Data* _data23_;
	GtkTreeViewColumn* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	NoiseViewWrapperHint _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	GtkMenu* _tmp5_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GtkCheckMenuItem* _tmp17_;
	GtkCheckMenuItem* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkMenu* _tmp21_;
	GtkCheckMenuItem* _tmp22_;
	GtkMenu* _tmp23_;
	GtkCheckMenuItem* _tmp24_;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (tvc != NULL);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data23_->_ref_count_ = 1;
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data23_->self = g_object_ref (self);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = _g_object_ref0 (tvc);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (_data23_->tvc);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data23_->tvc = _tmp0_;
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
	if (type == NOISE_LIST_COLUMN_TITLE) {
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = TRUE;
#line 796 "MusicListView.c"
	} else {
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = type == NOISE_LIST_COLUMN_ICON;
#line 800 "MusicListView.c"
	}
#line 65 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp1_) {
#line 66 "../src/Views/ListView/Lists/MusicListView.vala"
		block23_data_unref (_data23_);
#line 66 "../src/Views/ListView/Lists/MusicListView.vala"
		_data23_ = NULL;
#line 66 "../src/Views/ListView/Lists/MusicListView.vala"
		return;
#line 810 "MusicListView.c"
	}
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = noise_generic_list_get_hint ((NoiseGenericList*) self);
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_;
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp4_ == NOISE_VIEW_WRAPPER_HINT_MUSIC) {
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = type == NOISE_LIST_COLUMN_NUMBER;
#line 820 "MusicListView.c"
	} else {
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = FALSE;
#line 824 "MusicListView.c"
	}
#line 69 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp2_) {
#line 70 "../src/Views/ListView/Lists/MusicListView.vala"
		block23_data_unref (_data23_);
#line 70 "../src/Views/ListView/Lists/MusicListView.vala"
		_data23_ = NULL;
#line 70 "../src/Views/ListView/Lists/MusicListView.vala"
		return;
#line 834 "MusicListView.c"
	}
#line 73 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp5_ = self->column_chooser_menu;
#line 73 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp5_ == NULL) {
#line 840 "MusicListView.c"
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenuItem* _tmp10_;
		GtkMenu* _tmp11_;
		GtkSeparatorMenuItem* _tmp12_;
		GtkSeparatorMenuItem* _tmp13_;
		GtkMenu* _tmp14_;
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Autosize Columns"));
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_ref_sink (_tmp6_);
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self->priv->autosize_menu_item);
#line 74 "../src/Views/ListView/Lists/MusicListView.vala"
		self->priv->autosize_menu_item = _tmp6_;
#line 75 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp7_ = self->priv->autosize_menu_item;
#line 75 "../src/Views/ListView/Lists/MusicListView.vala"
		g_signal_connect_object (_tmp7_, "activate", (GCallback) _noise_music_list_view_columns_autosize_gtk_menu_item_activate, self, 0);
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp8_ = (GtkMenu*) gtk_menu_new ();
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_ref_sink (_tmp8_);
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self->column_chooser_menu);
#line 77 "../src/Views/ListView/Lists/MusicListView.vala"
		self->column_chooser_menu = _tmp8_;
#line 78 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp9_ = self->column_chooser_menu;
#line 78 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp10_ = self->priv->autosize_menu_item;
#line 78 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp9_, _tmp10_);
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp11_ = self->column_chooser_menu;
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp12_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_ref_sink (_tmp12_);
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp13_ = _tmp12_;
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, (GtkMenuItem*) _tmp13_);
#line 79 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_tmp13_);
#line 80 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp14_ = self->column_chooser_menu;
#line 80 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp14_);
#line 892 "MusicListView.c"
	}
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp15_ = gtk_tree_view_column_get_title (_data23_->tvc);
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp16_ = _tmp15_;
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp17_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_tmp16_);
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	g_object_ref_sink (_tmp17_);
#line 83 "../src/Views/ListView/Lists/MusicListView.vala"
	_data23_->menu_item = _tmp17_;
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp18_ = _data23_->menu_item;
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp19_ = gtk_tree_view_column_get_visible (_data23_->tvc);
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp20_ = _tmp19_;
#line 84 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_check_menu_item_set_active (_tmp18_, _tmp20_);
#line 86 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp21_ = self->column_chooser_menu;
#line 86 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp22_ = _data23_->menu_item;
#line 86 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp21_, (GtkMenuItem*) _tmp22_);
#line 87 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp23_ = self->column_chooser_menu;
#line 87 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp23_);
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp24_ = _data23_->menu_item;
#line 90 "../src/Views/ListView/Lists/MusicListView.vala"
	g_signal_connect_data (_tmp24_, "toggled", (GCallback) ___lambda62__gtk_check_menu_item_toggled, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	block23_data_unref (_data23_);
#line 64 "../src/Views/ListView/Lists/MusicListView.vala"
	_data23_ = NULL;
#line 930 "MusicListView.c"
}


void
noise_music_list_view_add_media (NoiseMusicListView* self,
                                 GeeCollection* to_add)
{
	GeeArrayList* _tmp0_;
#line 97 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (to_add != NULL);
#line 99 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = ((NoiseGenericList*) self)->table;
#line 99 "../src/Views/ListView/Lists/MusicListView.vala"
	gee_array_list_add_all (_tmp0_, to_add);
#line 102 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_generic_list_resort ((NoiseGenericList*) self);
#line 949 "MusicListView.c"
}


void
noise_music_list_view_remove_media (NoiseMusicListView* self,
                                    GeeCollection* to_remove)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp15_;
#line 106 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (to_remove != NULL);
#line 107 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 107 "../src/Views/ListView/Lists/MusicListView.vala"
	new_table = _tmp0_;
#line 968 "MusicListView.c"
	{
		GeeArrayList* _m_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _m_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _m_index = 0;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = ((NoiseGenericList*) self)->table;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_list = _tmp2_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = _m_list;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = _tmp4_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_size = _tmp5_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_index = -1;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		while (TRUE) {
#line 996 "MusicListView.c"
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			NoiseMedia* m = NULL;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			NoiseMedia* _tmp12_;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = _m_index;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_m_index = _tmp6_ + 1;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _m_index;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = _m_size;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
				break;
#line 1017 "MusicListView.c"
			}
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = _m_list;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = _m_index;
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			m = (NoiseMedia*) _tmp11_;
#line 110 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = m;
#line 110 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!gee_collection_contains (to_remove, _tmp12_)) {
#line 1031 "MusicListView.c"
				GeeArrayList* _tmp13_;
				NoiseMedia* _tmp14_;
#line 111 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp13_ = new_table;
#line 111 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp14_ = m;
#line 111 "../src/Views/ListView/Lists/MusicListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 1040 "MusicListView.c"
			}
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (m);
#line 1044 "MusicListView.c"
		}
#line 109 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_m_list);
#line 1048 "MusicListView.c"
	}
#line 116 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp15_ = new_table;
#line 116 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_generic_list_set_table ((NoiseGenericList*) self, _tmp15_, FALSE);
#line 106 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (new_table);
#line 1056 "MusicListView.c"
}


static gboolean
noise_music_list_view_real_button_press_event (GtkWidget* base,
                                               GdkEventButton* event)
{
	NoiseMusicListView * self;
	gboolean result = FALSE;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	guint _tmp2_;
#line 119 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (NoiseMusicListView*) base;
#line 119 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 120 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = event->window;
#line 120 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 120 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp0_ != _tmp1_) {
#line 121 "../src/Views/ListView/Lists/MusicListView.vala"
		result = GTK_WIDGET_CLASS (noise_music_list_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_GENERIC_LIST, NoiseGenericList), event);
#line 121 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1083 "MusicListView.c"
	}
#line 124 "../src/Views/ListView/Lists/MusicListView.vala"
	if (noise_music_list_view_check_selection_event (self, event)) {
#line 125 "../src/Views/ListView/Lists/MusicListView.vala"
		GTK_WIDGET_CLASS (noise_music_list_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_GENERIC_LIST, NoiseGenericList), event);
#line 1089 "MusicListView.c"
	}
#line 127 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = event->button;
#line 127 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp2_ == ((guint) GDK_BUTTON_SECONDARY)) {
#line 1095 "MusicListView.c"
		NoiseMediaMenu* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = self->priv->_media_action_menu;
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp4_ = noise_generic_list_get_selected_medias ((NoiseGenericList*) self);
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = _tmp4_;
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		noise_media_menu_popup_media_menu (_tmp3_, _tmp5_);
#line 128 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_tmp5_);
#line 129 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 129 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1113 "MusicListView.c"
	}
#line 132 "../src/Views/ListView/Lists/MusicListView.vala"
	result = FALSE;
#line 132 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 1119 "MusicListView.c"
}


/**
     * Checks whether a Gdk.EventButton resulting in a selection change should be sent
     * to the default handler or not. This is useful to prevent the default handler from
     * destroying the user's previous selection in case there was a multiple selection.
     *
     * @param event the Gdk.EventButton to check
     * @return //true// if the event should be passed to the default handler; false otherwise.
     */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1136 "MusicListView.c"
}


static gboolean
noise_music_list_view_check_selection_event (NoiseMusicListView* self,
                                             GdkEventButton* event)
{
	gboolean result = FALSE;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GdkModifierType _tmp3_;
	GdkModifierType _tmp4_;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	gint cell_x = 0;
	gint cell_y = 0;
	gdouble _tmp7_;
	gdouble _tmp8_;
	GtkTreePath* _tmp9_ = NULL;
	GtkTreeViewColumn* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gboolean _tmp13_;
	GtkTreeViewColumn* _tmp14_;
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = event->window;
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 143 "../src/Views/ListView/Lists/MusicListView.vala"
	_vala_return_val_if_fail (_tmp0_ == _tmp1_, "event.window == get_bin_window ()", FALSE);
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = event->state;
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = event->state;
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((_tmp3_ & GDK_CONTROL_MASK) == _tmp4_) {
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = TRUE;
#line 1180 "MusicListView.c"
	} else {
		GdkModifierType _tmp5_;
		GdkModifierType _tmp6_;
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = event->state;
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp6_ = event->state;
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = (_tmp5_ & GDK_SHIFT_MASK) == _tmp6_;
#line 1190 "MusicListView.c"
	}
#line 144 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp2_) {
#line 145 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 145 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1198 "MusicListView.c"
	}
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp7_ = event->x;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp8_ = event->y;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp13_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, (gint) _tmp7_, (gint) _tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	__vala_GtkTreePath_free0 (path);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	path = _tmp9_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (column);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp14_ = _g_object_ref0 (_tmp10_);
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	column = _tmp14_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	cell_x = _tmp11_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	cell_y = _tmp12_;
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp13_) {
#line 1222 "MusicListView.c"
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp15_;
		GtkTreeSelection* _tmp16_;
		gboolean _tmp17_ = FALSE;
		GtkTreeSelection* _tmp18_;
#line 153 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp15_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 153 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 153 "../src/Views/ListView/Lists/MusicListView.vala"
		selection = _tmp16_;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp18_ = selection;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
		if (gtk_tree_selection_count_selected_rows (_tmp18_) > 1) {
#line 1238 "MusicListView.c"
			GtkTreeSelection* _tmp19_;
			GtkTreePath* _tmp20_;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = selection;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = path;
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = gtk_tree_selection_path_is_selected (_tmp19_, _tmp20_);
#line 1247 "MusicListView.c"
		} else {
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = FALSE;
#line 1251 "MusicListView.c"
		}
#line 158 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp17_) {
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			result = FALSE;
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (selection);
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (column);
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			__vala_GtkTreePath_free0 (path);
#line 159 "../src/Views/ListView/Lists/MusicListView.vala"
			return result;
#line 1265 "MusicListView.c"
		}
#line 152 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (selection);
#line 1269 "MusicListView.c"
	}
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	result = TRUE;
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (column);
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	__vala_GtkTreePath_free0 (path);
#line 162 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 1279 "MusicListView.c"
}


static void
noise_music_list_view_columns_autosize (NoiseMusicListView* self)
{
#line 165 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_music_list_view_reset_column_widths (self);
#line 167 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_columns_autosize ((GtkTreeView*) G_TYPE_CHECK_INSTANCE_CAST (self, NOISE_TYPE_GENERIC_LIST, NoiseGenericList));
#line 1292 "MusicListView.c"
}


static gboolean
noise_music_list_view_view_click_release (NoiseMusicListView* self,
                                          GtkWidget* sender,
                                          GdkEventButton* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 171 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 171 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = ((NoiseGenericList*) self)->dragging;
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp1_) {
#line 1314 "MusicListView.c"
		guint _tmp2_;
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = event->button;
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = _tmp2_ == ((guint) 1);
#line 1320 "MusicListView.c"
	} else {
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = FALSE;
#line 1324 "MusicListView.c"
	}
#line 173 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp0_) {
#line 174 "../src/Views/ListView/Lists/MusicListView.vala"
		((NoiseGenericList*) self)->dragging = FALSE;
#line 175 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 175 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1334 "MusicListView.c"
	} else {
		GdkModifierType _tmp3_;
		GdkModifierType _tmp4_;
#line 176 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = event->state;
#line 176 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp4_ = event->state;
#line 176 "../src/Views/ListView/Lists/MusicListView.vala"
		if (((_tmp3_ & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) | ((_tmp4_ & GDK_CONTROL_MASK) == GDK_CONTROL_MASK)) {
#line 177 "../src/Views/ListView/Lists/MusicListView.vala"
			result = TRUE;
#line 177 "../src/Views/ListView/Lists/MusicListView.vala"
			return result;
#line 1348 "MusicListView.c"
		} else {
			GtkTreePath* path = NULL;
			GtkTreeViewColumn* tvc = NULL;
			gint cell_x = 0;
			gint cell_y = 0;
			gint x = 0;
			gdouble _tmp5_;
			gint y = 0;
			gdouble _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			GtkTreePath* _tmp9_ = NULL;
			GtkTreeViewColumn* _tmp10_ = NULL;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gboolean _tmp13_;
			GtkTreeViewColumn* _tmp14_;
			GtkTreeSelection* _tmp15_;
			GtkTreeSelection* _tmp16_;
			GtkTreePath* _tmp17_;
#line 183 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = event->x;
#line 183 "../src/Views/ListView/Lists/MusicListView.vala"
			x = (gint) _tmp5_;
#line 184 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = event->y;
#line 184 "../src/Views/ListView/Lists/MusicListView.vala"
			y = (gint) _tmp6_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = x;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = y;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp7_, _tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			__vala_GtkTreePath_free0 (path);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			path = _tmp9_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (tvc);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = _g_object_ref0 (_tmp10_);
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			tvc = _tmp14_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			cell_x = _tmp11_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			cell_y = _tmp12_;
#line 186 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!_tmp13_) {
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				result = FALSE;
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				_g_object_unref0 (tvc);
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				__vala_GtkTreePath_free0 (path);
#line 187 "../src/Views/ListView/Lists/MusicListView.vala"
				return result;
#line 1407 "MusicListView.c"
			}
#line 188 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 188 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_selection_unselect_all (_tmp15_);
#line 189 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 189 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = path;
#line 189 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_selection_select_path (_tmp16_, _tmp17_);
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			result = FALSE;
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (tvc);
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			__vala_GtkTreePath_free0 (path);
#line 190 "../src/Views/ListView/Lists/MusicListView.vala"
			return result;
#line 1427 "MusicListView.c"
		}
	}
}


static gboolean
noise_music_list_view_view_header_click (NoiseMusicListView* self,
                                         GdkEventButton* e,
                                         gboolean is_selector_col)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
#line 194 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = e->button;
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp1_ == ((guint) GDK_BUTTON_SECONDARY)) {
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = TRUE;
#line 1451 "MusicListView.c"
	} else {
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = is_selector_col;
#line 1455 "MusicListView.c"
	}
#line 195 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp0_) {
#line 1459 "MusicListView.c"
		GtkMenu* _tmp2_;
#line 196 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = self->column_chooser_menu;
#line 196 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_menu_popup_at_pointer (_tmp2_, (GdkEvent*) e);
#line 197 "../src/Views/ListView/Lists/MusicListView.vala"
		result = TRUE;
#line 197 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1469 "MusicListView.c"
	}
#line 200 "../src/Views/ListView/Lists/MusicListView.vala"
	result = FALSE;
#line 200 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 1475 "MusicListView.c"
}


static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	return _data24_;
#line 1486 "MusicListView.c"
}


static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 1497 "MusicListView.c"
		NoiseMusicListView* self;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		self = _data24_->self;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_data24_->selected_media);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
		g_slice_free (Block24Data, _data24_);
#line 1507 "MusicListView.c"
	}
}


static void
___lambda63_ (Block24Data* _data24_,
              gboolean delete_files)
{
	NoiseMusicListView* self;
	NoiseViewWrapper* _tmp0_;
	NoiseViewWrapper* _tmp1_;
	NoiseLibrary* _tmp2_;
	NoiseLibrary* _tmp3_;
	GeeCollection* _tmp4_;
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
	self = _data24_->self;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = noise_generic_list_get_parent_wrapper ((NoiseGenericList*) self);
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = noise_view_wrapper_get_library (_tmp1_);
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = _tmp2_;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _data24_->selected_media;
#line 211 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_library_remove_medias (_tmp3_, _tmp4_, delete_files);
#line 1536 "MusicListView.c"
}


static void
____lambda63__noise_remove_files_dialog_remove_media (NoiseRemoveFilesDialog* _sender,
                                                      gboolean response,
                                                      gpointer self)
{
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
	___lambda63_ (self, response);
#line 1547 "MusicListView.c"
}


static void
noise_music_list_view_real_mediaRemoveClicked (NoiseGenericList* base)
{
	NoiseMusicListView * self;
	Block24Data* _data24_;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	NoiseViewWrapperHint _tmp5_;
	NoiseViewWrapperHint _tmp6_;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (NoiseMusicListView*) base;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->_ref_count_ = 1;
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->self = g_object_ref (self);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = noise_generic_list_get_selected_medias ((NoiseGenericList*) self);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = gee_collection_get_read_only_view (_tmp1_);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = _tmp2_;
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_;
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (_tmp1_);
#line 204 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_->selected_media = _tmp4_;
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp5_ = noise_generic_list_get_hint ((NoiseGenericList*) self);
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp6_ = _tmp5_;
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (_tmp6_) {
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST:
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_MUSIC:
#line 1595 "MusicListView.c"
		{
			NoiseRemoveFilesDialog* dialog = NULL;
			GeeCollection* _tmp7_;
			NoiseRemoveFilesDialog* _tmp8_;
			NoiseRemoveFilesDialog* _tmp9_;
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _data24_->selected_media;
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = noise_remove_files_dialog_new (_tmp7_);
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp8_);
#line 209 "../src/Views/ListView/Lists/MusicListView.vala"
			dialog = _tmp8_;
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = dialog;
#line 210 "../src/Views/ListView/Lists/MusicListView.vala"
			g_signal_connect_data (_tmp9_, "remove-media", (GCallback) ____lambda63__noise_remove_files_dialog_remove_media, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
#line 213 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (dialog);
#line 213 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1617 "MusicListView.c"
		}
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 1621 "MusicListView.c"
		{
			NoiseDeviceViewWrapper* dvw = NULL;
			NoiseViewWrapper* _tmp10_;
			NoiseViewWrapper* _tmp11_;
			NoiseDeviceViewWrapper* _tmp12_;
			NoiseDeviceViewWrapper* _tmp13_;
			NoiseLibrary* _tmp14_;
			NoiseLibrary* _tmp15_;
			GeeCollection* _tmp16_;
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = noise_generic_list_get_parent_wrapper ((NoiseGenericList*) self);
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = _tmp10_;
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, NOISE_TYPE_DEVICE_VIEW_WRAPPER, NoiseDeviceViewWrapper));
#line 215 "../src/Views/ListView/Lists/MusicListView.vala"
			dvw = _tmp12_;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = dvw;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = noise_view_wrapper_get_library ((NoiseViewWrapper*) _tmp13_);
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = _tmp14_;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = _data24_->selected_media;
#line 216 "../src/Views/ListView/Lists/MusicListView.vala"
			noise_library_remove_medias (_tmp15_, _tmp16_, TRUE);
#line 217 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (dvw);
#line 217 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1653 "MusicListView.c"
		}
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
#line 1657 "MusicListView.c"
		{
			NoisePlaylist* _tmp17_;
			NoisePlaylist* _tmp18_;
			GeeCollection* _tmp19_;
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = noise_generic_list_get_playlist ((NoiseGenericList*) self);
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp18_ = _tmp17_;
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = _data24_->selected_media;
#line 219 "../src/Views/ListView/Lists/MusicListView.vala"
			noise_playlist_remove_medias (_tmp18_, _tmp19_);
#line 220 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1672 "MusicListView.c"
		}
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_QUEUE:
#line 1676 "MusicListView.c"
		{
			NoisePlaylist* _tmp20_;
			NoisePlaylist* _tmp21_;
			GeeCollection* _tmp22_;
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = noise_generic_list_get_playlist ((NoiseGenericList*) self);
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21_ = _tmp20_;
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp22_ = _data24_->selected_media;
#line 222 "../src/Views/ListView/Lists/MusicListView.vala"
			noise_playlist_remove_medias (_tmp21_, _tmp22_);
#line 223 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 1691 "MusicListView.c"
		}
		default:
#line 206 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 1696 "MusicListView.c"
	}
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	block24_data_unref (_data24_);
#line 203 "../src/Views/ListView/Lists/MusicListView.vala"
	_data24_ = NULL;
#line 1702 "MusicListView.c"
}


static void
_vala_array_add14 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1718 "MusicListView.c"
	}
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 1724 "MusicListView.c"
}


static void
noise_music_list_view_real_onDragDataGet (NoiseMusicListView* self,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp15_;
	gint _tmp15__length1;
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (context != NULL);
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (selection_data != NULL);
#line 228 "../src/Views/ListView/Lists/MusicListView.vala"
	uris = NULL;
#line 228 "../src/Views/ListView/Lists/MusicListView.vala"
	uris_length1 = 0;
#line 228 "../src/Views/ListView/Lists/MusicListView.vala"
	_uris_size_ = uris_length1;
#line 1750 "MusicListView.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = noise_generic_list_get_selected_medias ((NoiseGenericList*) self);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp1_ = _tmp0_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp3_ = _tmp2_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_tmp1_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_m_it = _tmp3_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		while (TRUE) {
#line 1771 "MusicListView.c"
			GeeIterator* _tmp4_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			NoiseMedia* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar** _tmp11_;
			gint _tmp11__length1;
			NoiseMedia* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp4_ = _m_it;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
				break;
#line 1791 "MusicListView.c"
			}
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = _m_it;
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			m = (NoiseMedia*) _tmp6_;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = m;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = noise_media_get_uri (_tmp7_);
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = _tmp8_;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = _tmp9_;
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			g_debug ("MusicListView.vala:231: adding %s", _tmp10_);
#line 231 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp10_);
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = uris;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11__length1 = uris_length1;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = m;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = noise_media_get_uri (_tmp12_);
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = _tmp13_;
#line 232 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add14 (&uris, &uris_length1, &_uris_size_, _tmp14_);
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (m);
#line 1825 "MusicListView.c"
		}
#line 230 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (_m_it);
#line 1829 "MusicListView.c"
	}
#line 235 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp15_ = uris;
#line 235 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp15__length1 = uris_length1;
#line 235 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp15_ != NULL) {
#line 1837 "MusicListView.c"
		gchar** _tmp16_;
		gint _tmp16__length1;
#line 236 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp16_ = uris;
#line 236 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp16__length1 = uris_length1;
#line 236 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_selection_data_set_uris (selection_data, _tmp16_);
#line 1846 "MusicListView.c"
	}
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 1850 "MusicListView.c"
}


void
noise_music_list_view_onDragDataGet (NoiseMusicListView* self,
                                     GdkDragContext* context,
                                     GtkSelectionData* selection_data,
                                     guint info,
                                     guint time_)
{
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/Views/ListView/Lists/MusicListView.vala"
	NOISE_MUSIC_LIST_VIEW_GET_CLASS (self)->onDragDataGet (self, context, selection_data, info, time_);
#line 1865 "MusicListView.c"
}


static void
noise_music_list_view_reset_column_widths (NoiseMusicListView* self)
{
	GList* _tmp0_;
#line 239 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = gtk_tree_view_get_columns ((GtkTreeView*) self);
#line 1877 "MusicListView.c"
	{
		GList* column_collection = NULL;
		GList* column_it = NULL;
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
		column_collection = _tmp0_;
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
		for (column_it = column_collection; column_it != NULL; column_it = column_it->next) {
#line 1885 "MusicListView.c"
			GtkTreeViewColumn* column = NULL;
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
			column = (GtkTreeViewColumn*) column_it->data;
#line 1889 "MusicListView.c"
			{
				GtkTreeViewColumn* _tmp1_;
				gint _tmp2_;
				gint _tmp3_;
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp1_ = column;
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp2_ = gtk_tree_view_column_get_min_width (_tmp1_);
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp3_ = _tmp2_;
#line 241 "../src/Views/ListView/Lists/MusicListView.vala"
				if (_tmp3_ > 0) {
#line 1902 "MusicListView.c"
					GtkTreeViewColumn* _tmp4_;
					GtkTreeViewColumn* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp4_ = column;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp5_ = column;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp6_ = gtk_tree_view_column_get_min_width (_tmp5_);
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					_tmp7_ = _tmp6_;
#line 242 "../src/Views/ListView/Lists/MusicListView.vala"
					gtk_tree_view_column_set_fixed_width (_tmp4_, _tmp7_);
#line 1917 "MusicListView.c"
				}
			}
		}
#line 240 "../src/Views/ListView/Lists/MusicListView.vala"
		(column_collection == NULL) ? NULL : (column_collection = (g_list_free (column_collection), NULL));
#line 1923 "MusicListView.c"
	}
}


/**
     * Compares the two given objects based on the sort column.
     */
gint
noise_music_list_view_view_compare_func (NoiseMusicListView* self,
                                         gint column,
                                         GtkSortType dir,
                                         NoiseMedia* media_a,
                                         NoiseMedia* media_b,
                                         gint a_pos,
                                         gint b_pos)
{
	gint result = 0;
	NoisePlaylist* _tmp0_;
	NoisePlaylist* _tmp1_;
	NoisePlaybackManager* _tmp2_;
	NoisePlaybackManager* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	gint order = 0;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gboolean _tmp60_ = FALSE;
	gboolean _tmp61_ = FALSE;
	gint _tmp62_;
	gint _tmp63_;
	gboolean _tmp70_ = FALSE;
#line 250 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 250 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (media_a != NULL, 0);
#line 250 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (media_b != NULL, 0);
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = noise_generic_list_get_playlist ((NoiseGenericList*) self);
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = noise_app_get_player ();
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = _tmp2_;
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_->queue_playlist;
#line 251 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, NOISE_TYPE_PLAYLIST, NoisePlaylist)) {
#line 252 "../src/Views/ListView/Lists/MusicListView.vala"
		result = a_pos - b_pos;
#line 252 "../src/Views/ListView/Lists/MusicListView.vala"
		return result;
#line 1976 "MusicListView.c"
	}
#line 255 "../src/Views/ListView/Lists/MusicListView.vala"
	order = 0;
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
	if (column >= 0) {
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = column < ((gint) NOISE_LIST_COLUMN_N_COLUMNS);
#line 1984 "MusicListView.c"
	} else {
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp5_ = FALSE;
#line 1988 "MusicListView.c"
	}
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp6_ = order;
#line 256 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (_tmp5_, _tmp6_);
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (column) {
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_NUMBER:
#line 1998 "MusicListView.c"
		{
#line 260 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard (a_pos, b_pos);
#line 261 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2004 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_TITLE:
#line 2008 "MusicListView.c"
		{
#line 264 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_titles (media_a, media_b);
#line 265 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2014 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_LENGTH:
#line 2018 "MusicListView.c"
		{
			guint _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
			guint _tmp10_;
			gint _tmp11_;
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = noise_media_get_length (media_a);
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp8_ = _tmp7_;
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp9_ = noise_media_get_length (media_b);
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = _tmp9_;
#line 268 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp8_, _tmp10_);
#line 269 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = order;
#line 269 "../src/Views/ListView/Lists/MusicListView.vala"
			if (_tmp11_ == 0) {
#line 270 "../src/Views/ListView/Lists/MusicListView.vala"
				noise_compare_titles (media_a, media_b);
#line 2041 "MusicListView.c"
			}
#line 272 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2045 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ARTIST:
#line 2049 "MusicListView.c"
		{
#line 275 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_artists (media_a, media_b);
#line 276 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2055 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ALBUM:
#line 2059 "MusicListView.c"
		{
#line 279 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_albums (media_a, media_b);
#line 280 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2065 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_TRACK:
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ALBUM_ARTIST:
#line 2071 "MusicListView.c"
		{
#line 288 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_album_artists (media_a, media_b);
#line 289 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2077 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_COMPOSER:
#line 2081 "MusicListView.c"
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = noise_media_get_display_composer (media_a);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = _tmp12_;
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = noise_media_get_display_composer (media_b);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = _tmp14_;
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_string_compare (_tmp13_, _tmp15_);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp15_);
#line 292 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp13_);
#line 293 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2103 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_GROUPING:
#line 2107 "MusicListView.c"
		{
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = noise_media_get_grouping (media_a);
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = _tmp16_;
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp18_ = noise_media_get_grouping (media_b);
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = _tmp18_;
#line 296 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_string_compare (_tmp17_, _tmp19_);
#line 297 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2125 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_GENRE:
#line 2129 "MusicListView.c"
		{
#line 299 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_genres (media_a, media_b);
#line 300 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2135 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_YEAR:
#line 2139 "MusicListView.c"
		{
			guint _tmp20_;
			guint _tmp21_;
			guint _tmp22_;
			guint _tmp23_;
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = noise_media_get_year (media_a);
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21_ = _tmp20_;
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp22_ = noise_media_get_year (media_b);
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp23_ = _tmp22_;
#line 303 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp21_, _tmp23_);
#line 304 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2157 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_BITRATE:
#line 2161 "MusicListView.c"
		{
			guint _tmp24_;
			guint _tmp25_;
			guint _tmp26_;
			guint _tmp27_;
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp24_ = noise_media_get_bitrate (media_a);
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp25_ = _tmp24_;
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp26_ = noise_media_get_bitrate (media_b);
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp27_ = _tmp26_;
#line 307 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp25_, _tmp27_);
#line 308 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2179 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_RATING:
#line 2183 "MusicListView.c"
		{
			guint _tmp28_;
			guint _tmp29_;
			guint _tmp30_;
			guint _tmp31_;
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp28_ = noise_media_get_rating (media_a);
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp29_ = _tmp28_;
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp30_ = noise_media_get_rating (media_b);
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp31_ = _tmp30_;
#line 311 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp29_, _tmp31_);
#line 312 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2201 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_PLAY_COUNT:
#line 2205 "MusicListView.c"
		{
			guint _tmp32_;
			guint _tmp33_;
			guint _tmp34_;
			guint _tmp35_;
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp32_ = noise_media_get_play_count (media_a);
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp33_ = _tmp32_;
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp34_ = noise_media_get_play_count (media_b);
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp35_ = _tmp34_;
#line 315 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp33_, _tmp35_);
#line 316 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2223 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_SKIP_COUNT:
#line 2227 "MusicListView.c"
		{
			guint _tmp36_;
			guint _tmp37_;
			guint _tmp38_;
			guint _tmp39_;
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp36_ = noise_media_get_skip_count (media_a);
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp37_ = _tmp36_;
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp38_ = noise_media_get_skip_count (media_b);
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp39_ = _tmp38_;
#line 319 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp37_, _tmp39_);
#line 320 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2245 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_DATE_ADDED:
#line 2249 "MusicListView.c"
		{
			guint _tmp40_;
			guint _tmp41_;
			guint _tmp42_;
			guint _tmp43_;
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp40_ = noise_media_get_date_added (media_a);
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp41_ = _tmp40_;
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp42_ = noise_media_get_date_added (media_b);
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp43_ = _tmp42_;
#line 323 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp41_, _tmp43_);
#line 324 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2267 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_LAST_PLAYED:
#line 2271 "MusicListView.c"
		{
			guint _tmp44_;
			guint _tmp45_;
			guint _tmp46_;
			guint _tmp47_;
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp44_ = noise_media_get_last_played (media_a);
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp45_ = _tmp44_;
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp46_ = noise_media_get_last_played (media_b);
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp47_ = _tmp46_;
#line 327 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp45_, _tmp47_);
#line 328 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2289 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_BPM:
#line 2293 "MusicListView.c"
		{
			guint _tmp48_;
			guint _tmp49_;
			guint _tmp50_;
			guint _tmp51_;
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp48_ = noise_media_get_bpm (media_a);
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp49_ = _tmp48_;
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp50_ = noise_media_get_bpm (media_b);
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp51_ = _tmp50_;
#line 331 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_unsigned (_tmp49_, _tmp51_);
#line 332 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2311 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_FILE_SIZE:
#line 2315 "MusicListView.c"
		{
			guint64 _tmp52_;
			guint64 _tmp53_;
			guint64 _tmp54_;
			guint64 _tmp55_;
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp52_ = noise_media_get_file_size (media_a);
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp53_ = _tmp52_;
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp54_ = noise_media_get_file_size (media_b);
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp55_ = _tmp54_;
#line 335 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_compare_standard_64 ((gint64) _tmp53_, (gint64) _tmp55_);
#line 336 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2333 "MusicListView.c"
		}
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_FILE_LOCATION:
#line 2337 "MusicListView.c"
		{
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp56_ = noise_media_get_display_location (media_a);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp57_ = _tmp56_;
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp58_ = noise_media_get_display_location (media_b);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp59_ = _tmp58_;
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			order = noise_string_compare (_tmp57_, _tmp59_);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp59_);
#line 339 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_free0 (_tmp57_);
#line 340 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 2359 "MusicListView.c"
		}
		default:
#line 258 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 2364 "MusicListView.c"
	}
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp62_ = order;
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp62_ == 0) {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp61_ = column != ((gint) NOISE_LIST_COLUMN_GENRE);
#line 2372 "MusicListView.c"
	} else {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp61_ = FALSE;
#line 2376 "MusicListView.c"
	}
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp61_) {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp60_ = column != ((gint) NOISE_LIST_COLUMN_ARTIST);
#line 2382 "MusicListView.c"
	} else {
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp60_ = FALSE;
#line 2386 "MusicListView.c"
	}
#line 345 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp60_) {
#line 346 "../src/Views/ListView/Lists/MusicListView.vala"
		order = noise_compare_titles (media_a, media_b);
#line 2392 "MusicListView.c"
	}
#line 349 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp63_ = order;
#line 349 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp63_ == 0) {
#line 2398 "MusicListView.c"
		gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp64_ = noise_media_get_uri (media_a);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp65_ = _tmp64_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp66_ = _tmp65_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp67_ = noise_media_get_uri (media_b);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp68_ = _tmp67_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp69_ = _tmp68_;
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		order = noise_string_compare (_tmp66_, _tmp69_);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_free0 (_tmp69_);
#line 350 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_free0 (_tmp66_);
#line 2423 "MusicListView.c"
	}
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
	if (dir == GTK_SORT_DESCENDING) {
#line 2427 "MusicListView.c"
		gint _tmp71_;
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp71_ = order;
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp70_ = _tmp71_ != 0;
#line 2433 "MusicListView.c"
	} else {
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp70_ = FALSE;
#line 2437 "MusicListView.c"
	}
#line 353 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp70_) {
#line 2441 "MusicListView.c"
		gint _tmp72_ = 0;
		gint _tmp73_;
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp73_ = order;
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp73_ > 0) {
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp72_ = -1;
#line 2450 "MusicListView.c"
		} else {
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp72_ = 1;
#line 2454 "MusicListView.c"
		}
#line 354 "../src/Views/ListView/Lists/MusicListView.vala"
		order = _tmp72_;
#line 2458 "MusicListView.c"
	}
#line 356 "../src/Views/ListView/Lists/MusicListView.vala"
	result = order;
#line 356 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2464 "MusicListView.c"
}


GValue*
noise_music_list_view_view_value_func (NoiseMusicListView* self,
                                       gint row,
                                       gint column,
                                       GObject* o)
{
	GValue* result = NULL;
	NoiseMedia* m = NULL;
	NoiseMedia* _tmp0_;
	NoiseListColumn list_column = 0;
	GValue* _tmp1_;
#line 359 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (o != NULL, NULL);
#line 360 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (o, NOISE_TYPE_MEDIA) ? ((NoiseMedia*) o) : NULL);
#line 360 "../src/Views/ListView/Lists/MusicListView.vala"
	m = _tmp0_;
#line 361 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 363 "../src/Views/ListView/Lists/MusicListView.vala"
	list_column = (NoiseListColumn) column;
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = noise_list_column_get_value_for_media (list_column, m, row);
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	result = _tmp1_;
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (m);
#line 364 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2499 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_icon_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                      GtkCellRenderer* cell,
                                                                      GtkTreeModel* tree_model,
                                                                      GtkTreeIter* iter,
                                                                      gpointer self)
{
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_icon_func ((NoiseCellDataFunctionHelper*) self, cell_layout, cell, tree_model, iter);
#line 2512 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self)
{
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_spinner_func ((NoiseCellDataFunctionHelper*) self, cell_layout, cell, tree_model, iter);
#line 2525 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                         GtkCellRenderer* cell,
                                                                         GtkTreeModel* tree_model,
                                                                         GtkTreeIter* iter,
                                                                         gpointer self)
{
#line 408 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_bitrate_func (cell_layout, cell, tree_model, iter);
#line 2538 "MusicListView.c"
}


static void
_vala_array_add15 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2554 "MusicListView.c"
	}
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2560 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_length_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 415 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_length_func (cell_layout, cell, tree_model, iter);
#line 2573 "MusicListView.c"
}


static void
_vala_array_add16 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2589 "MusicListView.c"
	}
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2595 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_date_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                      GtkCellRenderer* cell,
                                                                      GtkTreeModel* tree_model,
                                                                      GtkTreeIter* iter,
                                                                      gpointer self)
{
#line 423 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_date_func (cell_layout, cell, tree_model, iter);
#line 2608 "MusicListView.c"
}


static void
_vala_array_add17 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2624 "MusicListView.c"
	}
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2630 "MusicListView.c"
}


static void
_vala_array_add18 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2646 "MusicListView.c"
	}
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2652 "MusicListView.c"
}


static void
_noise_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed (MusicRatingCellRenderer* _sender,
                                                                                      gint new_rating,
                                                                                      GtkWidget* widget,
                                                                                      const gchar* path,
                                                                                      gpointer self)
{
#line 430 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_generic_list_on_rating_cell_changed ((NoiseGenericList*) self, new_rating, widget, path);
#line 2665 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_rating_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 433 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_rating_func (cell_layout, cell, tree_model, iter);
#line 2678 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_number_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 443 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_number_func (cell_layout, cell, tree_model, iter);
#line 2691 "MusicListView.c"
}


static void
_vala_array_add19 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2707 "MusicListView.c"
	}
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2713 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                             GtkCellRenderer* cell,
                                                                             GtkTreeModel* tree_model,
                                                                             GtkTreeIter* iter,
                                                                             gpointer self)
{
#line 450 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_intelligent_func (cell_layout, cell, tree_model, iter);
#line 2726 "MusicListView.c"
}


static void
_vala_array_add20 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2742 "MusicListView.c"
	}
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2748 "MusicListView.c"
}


static void
_vala_array_add21 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2764 "MusicListView.c"
	}
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2770 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_string_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                        GtkCellRenderer* cell,
                                                                        GtkTreeModel* tree_model,
                                                                        GtkTreeIter* iter,
                                                                        gpointer self)
{
#line 473 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_string_func (cell_layout, cell, tree_model, iter);
#line 2783 "MusicListView.c"
}


static void
_vala_array_add22 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2799 "MusicListView.c"
	}
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2805 "MusicListView.c"
}


static void
_vala_array_add23 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2821 "MusicListView.c"
	}
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2827 "MusicListView.c"
}


static void
_noise_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                           GtkCellRenderer* cell,
                                                                           GtkTreeModel* tree_model,
                                                                           GtkTreeIter* iter,
                                                                           gpointer self)
{
#line 493 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_cell_data_function_helper_file_size_func (cell_layout, cell, tree_model, iter);
#line 2840 "MusicListView.c"
}


static void
_vala_array_add24 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
	if ((*length) == (*size)) {
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2856 "MusicListView.c"
	}
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[(*length)++] = value;
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
	(*array)[*length] = NULL;
#line 2862 "MusicListView.c"
}


static gboolean
___lambda64_ (NoiseMusicListView* self,
              GdkEventButton* e)
{
	gboolean result = FALSE;
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 552 "../src/Views/ListView/Lists/MusicListView.vala"
	result = noise_music_list_view_view_header_click (self, e, TRUE);
#line 552 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2877 "MusicListView.c"
}


static gboolean
____lambda64__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda64_ ((NoiseMusicListView*) self, event);
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2890 "MusicListView.c"
}


static gboolean
___lambda65_ (NoiseMusicListView* self,
              GdkEventButton* e)
{
	gboolean result = FALSE;
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 556 "../src/Views/ListView/Lists/MusicListView.vala"
	result = noise_music_list_view_view_header_click (self, e, FALSE);
#line 556 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2905 "MusicListView.c"
}


static gboolean
____lambda65__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda65_ ((NoiseMusicListView*) self, event);
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 2918 "MusicListView.c"
}


static void
noise_music_list_view_real_add_column (NoiseGenericList* base,
                                       GtkTreeViewColumn* tvc,
                                       NoiseListColumn type)
{
	NoiseMusicListView * self;
	gboolean column_resizable = FALSE;
	gboolean column_reorderable = FALSE;
	gint column_width = 0;
	gint insert_index = 0;
	gchar** test_strings = NULL;
	gchar** _tmp0_;
	gint test_strings_length1;
	gint _test_strings_size_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRenderer* _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	gboolean _tmp78_;
	gboolean _tmp79_;
	gboolean _tmp80_ = FALSE;
	gboolean sortable = FALSE;
	gint _tmp81_ = 0;
	gboolean _tmp82_;
	gboolean _tmp83_;
	GtkWidget* header_button = NULL;
	GtkWidget* _tmp84_;
	GtkWidget* _tmp85_;
	gboolean _tmp86_;
	gboolean _tmp87_;
	gint _tmp100_;
	gint _tmp101_;
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	self = (NoiseMusicListView*) base;
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (tvc != NULL);
#line 368 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_sizing (tvc, GTK_TREE_VIEW_COLUMN_FIXED);
#line 370 "../src/Views/ListView/Lists/MusicListView.vala"
	column_resizable = TRUE;
#line 371 "../src/Views/ListView/Lists/MusicListView.vala"
	column_reorderable = TRUE;
#line 372 "../src/Views/ListView/Lists/MusicListView.vala"
	column_width = -1;
#line 373 "../src/Views/ListView/Lists/MusicListView.vala"
	insert_index = -1;
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	test_strings = _tmp0_;
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	test_strings_length1 = 0;
#line 374 "../src/Views/ListView/Lists/MusicListView.vala"
	_test_strings_size_ = test_strings_length1;
#line 376 "../src/Views/ListView/Lists/MusicListView.vala"
	renderer = NULL;
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (type) {
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ICON:
#line 2982 "MusicListView.c"
		{
			GtkCellRendererPixbuf* icon_renderer = NULL;
			GtkCellRendererPixbuf* _tmp1_;
			GtkCellRendererSpinner* spinner_renderer = NULL;
			GtkCellRendererSpinner* _tmp2_;
			GtkCellRendererPixbuf* _tmp3_;
			GtkCellRendererSpinner* _tmp4_;
			gint width = 0;
			gint height = 0;
			GtkCellRendererPixbuf* _tmp5_;
			guint _tmp6_;
			guint _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			gint _tmp10_;
			gint _tmp11_;
			GtkCellRendererPixbuf* _tmp12_;
			NoiseCellDataFunctionHelper* _tmp13_;
			GtkCellRendererSpinner* _tmp14_;
			NoiseCellDataFunctionHelper* _tmp15_;
			GtkCellRendererSpinner* _tmp16_;
			GtkCellRendererPixbuf* _tmp17_;
			GtkCellRenderer* _tmp18_;
#line 381 "../src/Views/ListView/Lists/MusicListView.vala"
			insert_index = (gint) type;
#line 383 "../src/Views/ListView/Lists/MusicListView.vala"
			column_reorderable = FALSE;
#line 384 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 386 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp1_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 386 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp1_);
#line 386 "../src/Views/ListView/Lists/MusicListView.vala"
			icon_renderer = _tmp1_;
#line 388 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp2_ = (GtkCellRendererSpinner*) gtk_cell_renderer_spinner_new ();
#line 388 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp2_);
#line 388 "../src/Views/ListView/Lists/MusicListView.vala"
			spinner_renderer = _tmp2_;
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp3_ = icon_renderer;
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp4_ = spinner_renderer;
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_set (_tmp4_, "size", GTK_ICON_SIZE_MENU, NULL);
#line 390 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_set (_tmp3_, "stock-size", (guint) GTK_ICON_SIZE_MENU, NULL);
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp5_ = icon_renderer;
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_get (_tmp5_, "stock-size", &_tmp6_, NULL);
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp7_ = _tmp6_;
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_icon_size_lookup ((GtkIconSize) _tmp7_, &_tmp8_, &_tmp9_);
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			width = _tmp8_;
#line 393 "../src/Views/ListView/Lists/MusicListView.vala"
			height = _tmp9_;
#line 394 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp10_ = width;
#line 394 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp11_ = height;
#line 394 "../src/Views/ListView/Lists/MusicListView.vala"
			column_width = MAX (_tmp10_, _tmp11_) + 7;
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp12_ = icon_renderer;
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp13_ = ((NoiseGenericList*) self)->cell_data_helper;
#line 396 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp12_, _noise_cell_data_function_helper_icon_func_gtk_cell_layout_data_func, noise_cell_data_function_helper_ref (_tmp13_), noise_cell_data_function_helper_unref);
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp14_ = spinner_renderer;
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp15_ = ((NoiseGenericList*) self)->cell_data_helper;
#line 397 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp14_, _noise_cell_data_function_helper_spinner_func_gtk_cell_layout_data_func, noise_cell_data_function_helper_ref (_tmp15_), noise_cell_data_function_helper_unref);
#line 400 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp16_ = spinner_renderer;
#line 400 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_pack_start ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp16_, TRUE);
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp17_ = icon_renderer;
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp18_ = _g_object_ref0 ((GtkCellRenderer*) _tmp17_);
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 403 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = _tmp18_;
#line 404 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (spinner_renderer);
#line 404 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (icon_renderer);
#line 404 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3080 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_BITRATE:
#line 3084 "MusicListView.c"
		{
			GtkCellRendererText* _tmp19_;
			GtkCellRenderer* _tmp20_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			gchar* _tmp22_;
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp19_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp19_);
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 407 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp19_;
#line 408 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp20_ = renderer;
#line 408 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp20_, _noise_cell_data_function_helper_bitrate_func_gtk_cell_layout_data_func, NULL, NULL);
#line 409 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21_ = test_strings;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp21__length1 = test_strings_length1;
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp22_ = g_strdup (_ ("1234 kbps"));
#line 410 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add15 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp22_);
#line 411 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3115 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_LENGTH:
#line 3119 "MusicListView.c"
		{
			GtkCellRendererText* _tmp23_;
			GtkCellRenderer* _tmp24_;
			gchar** _tmp25_;
			gint _tmp25__length1;
			gchar* _tmp26_;
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp23_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp23_);
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 414 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp23_;
#line 415 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp24_ = renderer;
#line 415 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp24_, _noise_cell_data_function_helper_length_func_gtk_cell_layout_data_func, NULL, NULL);
#line 416 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp25_ = test_strings;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp25__length1 = test_strings_length1;
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp26_ = g_strdup ("0000:00");
#line 417 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add16 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp26_);
#line 418 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3150 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_DATE_ADDED:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_LAST_PLAYED:
#line 3156 "MusicListView.c"
		{
			GtkCellRendererText* _tmp27_;
			GtkCellRenderer* _tmp28_;
			gchar** _tmp29_;
			gint _tmp29__length1;
			gchar* _tmp30_;
			gchar** _tmp31_;
			gint _tmp31__length1;
			gchar* _tmp32_;
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp27_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp27_);
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 422 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp27_;
#line 423 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp28_ = renderer;
#line 423 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp28_, _noise_cell_data_function_helper_date_func_gtk_cell_layout_data_func, NULL, NULL);
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp29_ = test_strings;
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp29__length1 = test_strings_length1;
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp30_ = noise_cell_data_function_helper_get_date_string ((guint) 1324512000);
#line 424 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add17 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp30_);
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp31_ = test_strings;
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp31__length1 = test_strings_length1;
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp32_ = g_strdup (_ ("Never"));
#line 425 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add18 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp32_);
#line 426 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3196 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_RATING:
#line 3200 "MusicListView.c"
		{
			MusicRatingCellRenderer* rating_renderer = NULL;
			MusicRatingCellRenderer* _tmp33_;
			MusicRatingCellRenderer* _tmp34_;
			MusicRatingCellRenderer* _tmp35_;
			GtkCellRenderer* _tmp36_;
			MusicRatingCellRenderer* _tmp37_;
			MusicRatingCellRenderer* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
#line 429 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp33_ = music_rating_cell_renderer_new (GTK_ICON_SIZE_MENU);
#line 429 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp33_);
#line 429 "../src/Views/ListView/Lists/MusicListView.vala"
			rating_renderer = _tmp33_;
#line 430 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp34_ = rating_renderer;
#line 430 "../src/Views/ListView/Lists/MusicListView.vala"
			g_signal_connect_object (_tmp34_, "rating-changed", (GCallback) _noise_generic_list_on_rating_cell_changed_music_rating_cell_renderer_rating_changed, (NoiseGenericList*) self, 0);
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp35_ = rating_renderer;
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp36_ = _g_object_ref0 ((GtkCellRenderer*) _tmp35_);
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 432 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = _tmp36_;
#line 433 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp37_ = rating_renderer;
#line 433 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, (GtkCellRenderer*) _tmp37_, _noise_cell_data_function_helper_rating_func_gtk_cell_layout_data_func, NULL, NULL);
#line 435 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp38_ = rating_renderer;
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_get ((GtkCellRenderer*) _tmp38_, "width", &_tmp39_, NULL);
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp40_ = _tmp39_;
#line 436 "../src/Views/ListView/Lists/MusicListView.vala"
			column_width = _tmp40_ + 5;
#line 437 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (rating_renderer);
#line 437 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3247 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_NUMBER:
#line 3251 "MusicListView.c"
		{
			GtkCellRendererText* text_renderer = NULL;
			GtkCellRendererText* _tmp41_;
			GtkCellRendererText* _tmp42_;
			GtkCellRendererText* _tmp43_;
			GtkCellRenderer* _tmp44_;
			GtkCellRenderer* _tmp45_;
			gchar** _tmp46_;
			gint _tmp46__length1;
			gchar* _tmp47_;
#line 440 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp41_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 440 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp41_);
#line 440 "../src/Views/ListView/Lists/MusicListView.vala"
			text_renderer = _tmp41_;
#line 441 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp42_ = text_renderer;
#line 441 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_set (_tmp42_, "style", PANGO_STYLE_ITALIC, NULL);
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp43_ = text_renderer;
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp44_ = _g_object_ref0 ((GtkCellRenderer*) _tmp43_);
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 442 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = _tmp44_;
#line 443 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp45_ = renderer;
#line 443 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp45_, _noise_cell_data_function_helper_number_func_gtk_cell_layout_data_func, NULL, NULL);
#line 444 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp46_ = test_strings;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp46__length1 = test_strings_length1;
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp47_ = g_strdup ("00000");
#line 445 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add19 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp47_);
#line 446 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (text_renderer);
#line 446 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3298 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_YEAR:
#line 3302 "MusicListView.c"
		{
			GtkCellRendererText* _tmp48_;
			GtkCellRenderer* _tmp49_;
			gchar** _tmp50_;
			gint _tmp50__length1;
			gchar* _tmp51_;
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp48_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp48_);
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 449 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp48_;
#line 450 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp49_ = renderer;
#line 450 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp49_, _noise_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
#line 451 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp50_ = test_strings;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp50__length1 = test_strings_length1;
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp51_ = g_strdup ("0000");
#line 452 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add20 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp51_);
#line 453 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3333 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_TRACK:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_PLAY_COUNT:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_SKIP_COUNT:
#line 3341 "MusicListView.c"
		{
			GtkCellRendererText* _tmp52_;
			GtkCellRenderer* _tmp53_;
			gchar** _tmp54_;
			gint _tmp54__length1;
			gchar* _tmp55_;
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp52_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp52_);
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 458 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp52_;
#line 459 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp53_ = renderer;
#line 459 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp53_, _noise_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
#line 460 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp54_ = test_strings;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp54__length1 = test_strings_length1;
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp55_ = g_strdup ("9999");
#line 461 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add21 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp55_);
#line 462 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3372 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ALBUM:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_TITLE:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ARTIST:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_ALBUM_ARTIST:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_COMPOSER:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_GENRE:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_GROUPING:
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_FILE_LOCATION:
#line 3390 "MusicListView.c"
		{
			GtkCellRendererText* _tmp56_;
			GtkCellRenderer* _tmp57_;
			gchar** _tmp58_;
			gint _tmp58__length1;
			gchar* _tmp59_;
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp56_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp56_);
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 472 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp56_;
#line 473 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp57_ = renderer;
#line 473 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp57_, _noise_cell_data_function_helper_string_func_gtk_cell_layout_data_func, NULL, NULL);
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp58_ = test_strings;
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp58__length1 = test_strings_length1;
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp59_ = g_strdup (_ ("Sample List String"));
#line 481 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add22 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp59_);
#line 482 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3419 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_BPM:
#line 3423 "MusicListView.c"
		{
			GtkCellRendererText* _tmp60_;
			GtkCellRenderer* _tmp61_;
			gchar** _tmp62_;
			gint _tmp62__length1;
			gchar* _tmp63_;
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp60_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp60_);
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 485 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp60_;
#line 486 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp61_ = renderer;
#line 486 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp61_, _noise_cell_data_function_helper_intelligent_func_gtk_cell_layout_data_func, NULL, NULL);
#line 487 "../src/Views/ListView/Lists/MusicListView.vala"
			column_resizable = FALSE;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp62_ = test_strings;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp62__length1 = test_strings_length1;
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp63_ = g_strdup ("9999");
#line 488 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add23 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp63_);
#line 489 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3454 "MusicListView.c"
		}
#line 378 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_LIST_COLUMN_FILE_SIZE:
#line 3458 "MusicListView.c"
		{
			GtkCellRendererText* _tmp64_;
			GtkCellRenderer* _tmp65_;
			gchar** _tmp66_;
			gint _tmp66__length1;
			gchar* _tmp67_;
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp64_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			g_object_ref_sink (_tmp64_);
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (renderer);
#line 492 "../src/Views/ListView/Lists/MusicListView.vala"
			renderer = (GtkCellRenderer*) _tmp64_;
#line 493 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp65_ = renderer;
#line 493 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) tvc, _tmp65_, _noise_cell_data_function_helper_file_size_func_gtk_cell_layout_data_func, NULL, NULL);
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp66_ = test_strings;
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp66__length1 = test_strings_length1;
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp67_ = g_format_size_full ((guint64) ((1024 * 1024) * 932), G_FORMAT_SIZE_DEFAULT);
#line 494 "../src/Views/ListView/Lists/MusicListView.vala"
			_vala_array_add24 (&test_strings, &test_strings_length1, &_test_strings_size_, _tmp67_);
#line 495 "../src/Views/ListView/Lists/MusicListView.vala"
			break;
#line 3487 "MusicListView.c"
		}
		default:
		{
#line 499 "../src/Views/ListView/Lists/MusicListView.vala"
			g_return_if_reached ();
#line 3493 "MusicListView.c"
		}
	}
#line 502 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp68_ = renderer;
#line 502 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) tvc, _tmp68_, TRUE);
#line 505 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp69_ = insert_index;
#line 505 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_insert_column ((GtkTreeView*) self, tvc, _tmp69_);
#line 507 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp70_ = column_width;
#line 507 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp70_ > 0) {
#line 3508 "MusicListView.c"
		gint _tmp71_;
#line 508 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp71_ = column_width;
#line 508 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_tree_view_column_set_fixed_width (tvc, _tmp71_);
#line 3514 "MusicListView.c"
	} else {
		GtkCellRenderer* _tmp72_;
#line 509 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp72_ = renderer;
#line 509 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp72_ != NULL) {
#line 3521 "MusicListView.c"
			GtkCellRendererText* text_renderer = NULL;
			GtkCellRenderer* _tmp73_;
			GtkCellRendererText* _tmp74_;
			GtkCellRendererText* _tmp75_;
#line 510 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp73_ = renderer;
#line 510 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp74_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp73_, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) _tmp73_) : NULL);
#line 510 "../src/Views/ListView/Lists/MusicListView.vala"
			text_renderer = _tmp74_;
#line 511 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp75_ = text_renderer;
#line 511 "../src/Views/ListView/Lists/MusicListView.vala"
			if (_tmp75_ != NULL) {
#line 3536 "MusicListView.c"
				GtkCellRendererText* _tmp76_;
				gchar** _tmp77_;
				gint _tmp77__length1;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp76_ = text_renderer;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp77_ = test_strings;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				_tmp77__length1 = test_strings_length1;
#line 512 "../src/Views/ListView/Lists/MusicListView.vala"
				noise_generic_list_set_fixed_column_width ((NoiseGenericList*) self, (GtkWidget*) self, tvc, _tmp76_, _tmp77_, _tmp77__length1, 5);
#line 3548 "MusicListView.c"
			}
#line 509 "../src/Views/ListView/Lists/MusicListView.vala"
			_g_object_unref0 (text_renderer);
#line 3552 "MusicListView.c"
		}
	}
#line 515 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_reorderable (tvc, FALSE);
#line 516 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_clickable (tvc, TRUE);
#line 518 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp78_ = column_resizable;
#line 518 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_resizable (tvc, _tmp78_);
#line 519 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp79_ = column_resizable;
#line 519 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_expand (tvc, _tmp79_);
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
	if (type != NOISE_LIST_COLUMN_NUMBER) {
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp80_ = type != NOISE_LIST_COLUMN_ICON;
#line 3571 "MusicListView.c"
	} else {
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp80_ = FALSE;
#line 3575 "MusicListView.c"
	}
#line 521 "../src/Views/ListView/Lists/MusicListView.vala"
	sortable = _tmp80_;
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp82_ = sortable;
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp82_) {
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp81_ = (gint) type;
#line 3585 "MusicListView.c"
	} else {
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp81_ = -1;
#line 3589 "MusicListView.c"
	}
#line 527 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_sort_column_id (tvc, _tmp81_);
#line 528 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp83_ = sortable;
#line 528 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_sort_indicator (tvc, _tmp83_);
#line 530 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp84_ = gtk_tree_view_column_get_button (tvc);
#line 530 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp85_ = _g_object_ref0 (_tmp84_);
#line 530 "../src/Views/ListView/Lists/MusicListView.vala"
	header_button = _tmp85_;
#line 533 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp86_ = gtk_tree_view_get_headers_visible ((GtkTreeView*) self);
#line 533 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp87_ = _tmp86_;
#line 533 "../src/Views/ListView/Lists/MusicListView.vala"
	if (_tmp87_) {
#line 3609 "MusicListView.c"
		GtkRequisition natural_size = {0};
		GtkWidget* _tmp88_;
		GtkRequisition _tmp89_ = {0};
		GtkRequisition _tmp90_;
		gint _tmp91_;
		gint _tmp92_;
		gint _tmp93_;
		gboolean _tmp96_;
		gboolean _tmp97_;
#line 535 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp88_ = header_button;
#line 535 "../src/Views/ListView/Lists/MusicListView.vala"
		gtk_widget_get_preferred_size (_tmp88_, NULL, &_tmp89_);
#line 535 "../src/Views/ListView/Lists/MusicListView.vala"
		natural_size = _tmp89_;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp90_ = natural_size;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp91_ = _tmp90_.width;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp92_ = gtk_tree_view_column_get_fixed_width (tvc);
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp93_ = _tmp92_;
#line 537 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp91_ > _tmp93_) {
#line 3635 "MusicListView.c"
			GtkRequisition _tmp94_;
			gint _tmp95_;
#line 538 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp94_ = natural_size;
#line 538 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp95_ = _tmp94_.width;
#line 538 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_view_column_set_fixed_width (tvc, _tmp95_);
#line 3644 "MusicListView.c"
		}
#line 541 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp96_ = gtk_tree_view_column_get_sort_indicator (tvc);
#line 541 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp97_ = _tmp96_;
#line 541 "../src/Views/ListView/Lists/MusicListView.vala"
		if (_tmp97_) {
#line 3652 "MusicListView.c"
			gint _tmp98_;
			gint _tmp99_;
#line 542 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp98_ = gtk_tree_view_column_get_fixed_width (tvc);
#line 542 "../src/Views/ListView/Lists/MusicListView.vala"
			_tmp99_ = _tmp98_;
#line 542 "../src/Views/ListView/Lists/MusicListView.vala"
			gtk_tree_view_column_set_fixed_width (tvc, _tmp99_ + 5);
#line 3661 "MusicListView.c"
		}
	}
#line 545 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp100_ = gtk_tree_view_column_get_fixed_width (tvc);
#line 545 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp101_ = _tmp100_;
#line 545 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_column_set_min_width (tvc, _tmp101_);
#line 548 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_music_list_view_add_column_chooser_menu_item (self, tvc, type);
#line 550 "../src/Views/ListView/Lists/MusicListView.vala"
	if (type == NOISE_LIST_COLUMN_ICON) {
#line 3674 "MusicListView.c"
		GtkWidget* _tmp102_;
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp102_ = header_button;
#line 551 "../src/Views/ListView/Lists/MusicListView.vala"
		g_signal_connect_object (_tmp102_, "button-press-event", (GCallback) ____lambda64__gtk_widget_button_press_event, self, 0);
#line 3680 "MusicListView.c"
	} else {
		GtkWidget* _tmp103_;
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp103_ = header_button;
#line 555 "../src/Views/ListView/Lists/MusicListView.vala"
		g_signal_connect_object (_tmp103_, "button-press-event", (GCallback) ____lambda65__gtk_widget_button_press_event, self, 0);
#line 3687 "MusicListView.c"
	}
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (header_button);
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (renderer);
#line 367 "../src/Views/ListView/Lists/MusicListView.vala"
	test_strings = (_vala_array_free (test_strings, test_strings_length1, (GDestroyNotify) g_free), NULL);
#line 3695 "MusicListView.c"
}


NoiseMediaMenu*
noise_music_list_view_get_media_action_menu (NoiseMusicListView* self)
{
	NoiseMediaMenu* result;
	NoiseMediaMenu* _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = self->priv->_media_action_menu;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	result = _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3712 "MusicListView.c"
}


static void
noise_music_list_view_set_media_action_menu (NoiseMusicListView* self,
                                             NoiseMediaMenu* value)
{
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	if (noise_music_list_view_get_media_action_menu (self) != value) {
#line 3724 "MusicListView.c"
		NoiseMediaMenu* _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		_g_object_unref0 (self->priv->_media_action_menu);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		self->priv->_media_action_menu = _tmp0_;
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_music_list_view_properties[NOISE_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY]);
#line 3734 "MusicListView.c"
	}
}


static GValue*
_noise_music_list_view_view_value_func_noise_fast_model_value_return_func (gint row,
                                                                           gint column,
                                                                           GObject* o,
                                                                           gpointer self)
{
	GValue* result;
	result = noise_music_list_view_view_value_func ((NoiseMusicListView*) self, row, column, o);
#line 53 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3749 "MusicListView.c"
}


static gint
_noise_music_list_view_view_compare_func_noise_generic_list_sort_compare_func (gint sort_column_id,
                                                                               GtkSortType sort_direction,
                                                                               NoiseMedia* a,
                                                                               NoiseMedia* b,
                                                                               gint index_a,
                                                                               gint index_b,
                                                                               gpointer self)
{
	gint result;
	result = noise_music_list_view_view_compare_func ((NoiseMusicListView*) self, sort_column_id, sort_direction, a, b, index_a, index_b);
#line 54 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3766 "MusicListView.c"
}


static gboolean
_noise_music_list_view_view_click_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self)
{
	gboolean result;
	result = noise_music_list_view_view_click_release ((NoiseMusicListView*) self, _sender, event);
#line 56 "../src/Views/ListView/Lists/MusicListView.vala"
	return result;
#line 3779 "MusicListView.c"
}


static GObject *
noise_music_list_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseMusicListView * self;
	NoiseMediaMenu* _tmp0_;
	NoiseMediaMenu* _tmp1_;
	NoiseMediaMenu* _tmp2_;
	NoisePlaylist* _tmp3_;
	NoisePlaylist* _tmp4_;
	NoisePlaybackManager* _tmp5_;
	NoisePlaybackManager* _tmp6_;
	NoiseStaticPlaylist* _tmp7_;
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	parent_class = G_OBJECT_CLASS (noise_music_list_view_parent_class);
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView);
#line 49 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_set_headers_clickable ((GtkTreeView*) self, TRUE);
#line 50 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, TRUE);
#line 53 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_generic_list_set_value_func ((NoiseGenericList*) self, _noise_music_list_view_view_value_func_noise_fast_model_value_return_func, self);
#line 54 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_generic_list_set_compare_func ((NoiseGenericList*) self, _noise_music_list_view_view_compare_func_noise_generic_list_sort_compare_func, self);
#line 56 "../src/Views/ListView/Lists/MusicListView.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _noise_music_list_view_view_click_release_gtk_widget_button_release_event, self, 0);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp0_ = noise_media_menu_new ((NoiseGenericList*) self);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	g_object_ref_sink (_tmp0_);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_music_list_view_set_media_action_menu (self, _tmp1_);
#line 58 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (_tmp1_);
#line 59 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp2_ = self->priv->_media_action_menu;
#line 59 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_menu_attach_to_widget ((GtkMenu*) _tmp2_, (GtkWidget*) self, NULL);
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp3_ = noise_generic_list_get_playlist ((NoiseGenericList*) self);
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp4_ = _tmp3_;
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp5_ = noise_app_get_player ();
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp6_ = _tmp5_;
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	_tmp7_ = _tmp6_->queue_playlist;
#line 61 "../src/Views/ListView/Lists/MusicListView.vala"
	gtk_tree_view_set_headers_clickable ((GtkTreeView*) self, _tmp4_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, NOISE_TYPE_PLAYLIST, NoisePlaylist));
#line 48 "../src/Views/ListView/Lists/MusicListView.vala"
	return obj;
#line 3843 "MusicListView.c"
}


static void
noise_music_list_view_class_init (NoiseMusicListViewClass * klass)
{
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	noise_music_list_view_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseMusicListView_private_offset);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) noise_music_list_view_real_button_press_event;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((NoiseGenericListClass *) klass)->mediaRemoveClicked = (void (*) (NoiseGenericList*)) noise_music_list_view_real_mediaRemoveClicked;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((NoiseMusicListViewClass *) klass)->onDragDataGet = (void (*) (NoiseMusicListView*, GdkDragContext*, GtkSelectionData*, guint, guint)) noise_music_list_view_real_onDragDataGet;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	((NoiseGenericListClass *) klass)->add_column = (void (*) (NoiseGenericList*, GtkTreeViewColumn*, NoiseListColumn)) noise_music_list_view_real_add_column;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_music_list_view_get_property;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_music_list_view_set_property;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_music_list_view_constructor;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_music_list_view_finalize;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY, noise_music_list_view_properties[NOISE_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY] = g_param_spec_object ("media-action-menu", "media-action-menu", "media-action-menu", NOISE_TYPE_MEDIA_MENU, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3872 "MusicListView.c"
}


static void
noise_music_list_view_instance_init (NoiseMusicListView * self)
{
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	self->priv = noise_music_list_view_get_instance_private (self);
#line 3881 "MusicListView.c"
}


static void
noise_music_list_view_finalize (GObject * obj)
{
	NoiseMusicListView * self;
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView);
#line 35 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (self->priv->_media_action_menu);
#line 38 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (self->column_chooser_menu);
#line 39 "../src/Views/ListView/Lists/MusicListView.vala"
	_g_object_unref0 (self->priv->autosize_menu_item);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	G_OBJECT_CLASS (noise_music_list_view_parent_class)->finalize (obj);
#line 3899 "MusicListView.c"
}


GType
noise_music_list_view_get_type (void)
{
	static volatile gsize noise_music_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_music_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseMusicListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_music_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseMusicListView), 0, (GInstanceInitFunc) noise_music_list_view_instance_init, NULL };
		GType noise_music_list_view_type_id;
		noise_music_list_view_type_id = g_type_register_static (NOISE_TYPE_GENERIC_LIST, "NoiseMusicListView", &g_define_type_info, 0);
		NoiseMusicListView_private_offset = g_type_add_instance_private (noise_music_list_view_type_id, sizeof (NoiseMusicListViewPrivate));
		g_once_init_leave (&noise_music_list_view_type_id__volatile, noise_music_list_view_type_id);
	}
	return noise_music_list_view_type_id__volatile;
}


static void
_vala_noise_music_list_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NoiseMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (property_id) {
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		g_value_set_object (value, noise_music_list_view_get_media_action_menu (self));
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3934 "MusicListView.c"
		default:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3940 "MusicListView.c"
	}
}


static void
_vala_noise_music_list_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NoiseMusicListView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
	switch (property_id) {
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		case NOISE_MUSIC_LIST_VIEW_MEDIA_ACTION_MENU_PROPERTY:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		noise_music_list_view_set_media_action_menu (self, g_value_get_object (value));
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3961 "MusicListView.c"
		default:
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/Views/ListView/Lists/MusicListView.vala"
		break;
#line 3967 "MusicListView.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



