/* FastListModel.c generated by valac 0.42.6, the Vala compiler
 * generated from FastListModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Since this class is not publicly facing (the FastView is public part),
 * this model is low level and optimized. We are not worried about stupid
 * users here.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <string.h>


#define NOISE_TYPE_FAST_MODEL (noise_fast_model_get_type ())
#define NOISE_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModel))
#define NOISE_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))
#define NOISE_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_MODEL))
#define NOISE_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_MODEL))
#define NOISE_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))

typedef struct _NoiseFastModel NoiseFastModel;
typedef struct _NoiseFastModelClass NoiseFastModelClass;
typedef struct _NoiseFastModelPrivate NoiseFastModelPrivate;
typedef GValue* (*NoiseFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
enum  {
	NOISE_FAST_MODEL_0_PROPERTY,
	NOISE_FAST_MODEL_COLUMNS_PROPERTY,
	NOISE_FAST_MODEL_NUM_PROPERTIES
};
static GParamSpec* noise_fast_model_properties[NOISE_FAST_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
enum  {
	NOISE_FAST_MODEL_REORDER_REQUESTED_SIGNAL,
	NOISE_FAST_MODEL_NUM_SIGNALS
};
static guint noise_fast_model_signals[NOISE_FAST_MODEL_NUM_SIGNALS] = {0};

struct _NoiseFastModel {
	GObject parent_instance;
	NoiseFastModelPrivate * priv;
};

struct _NoiseFastModelClass {
	GObjectClass parent_class;
};

struct _NoiseFastModelPrivate {
	gint stamp;
	GeeArrayList* rows;
	GeeList* _columns;
	gint sort_column_id;
	GtkSortType sort_direction;
	NoiseFastModelValueReturnFunc value_func;
	gpointer value_func_target;
};


static gint NoiseFastModel_private_offset;
static gpointer noise_fast_model_parent_class = NULL;
static GtkTreeModelIface * noise_fast_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * noise_fast_model_gtk_tree_sortable_parent_iface = NULL;

GType noise_fast_model_get_type (void) G_GNUC_CONST;
NoiseFastModel* noise_fast_model_new (GeeList* column_types);
NoiseFastModel* noise_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static GType noise_fast_model_real_get_column_type (GtkTreeModel* base,
                                             gint col);
GeeList* noise_fast_model_get_columns (NoiseFastModel* self);
static GtkTreeModelFlags noise_fast_model_real_get_flags (GtkTreeModel* base);
static gboolean noise_fast_model_real_get_iter (GtkTreeModel* base,
                                         GtkTreeIter* iter,
                                         GtkTreePath* path);
static gint noise_fast_model_real_get_n_columns (GtkTreeModel* base);
static GtkTreePath* noise_fast_model_real_get_path (GtkTreeModel* base,
                                             GtkTreeIter* iter);
static void noise_fast_model_real_get_value (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      gint column,
                                      GValue* val);
static void _vala_GValue_free (GValue* self);
GObject* noise_fast_model_get_object (NoiseFastModel* self,
                                      GtkTreeIter* iter);
static gboolean noise_fast_model_real_iter_children (GtkTreeModel* base,
                                              GtkTreeIter* iter,
                                              GtkTreeIter* parent);
static gboolean noise_fast_model_real_iter_has_child (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static gint noise_fast_model_real_iter_n_children (GtkTreeModel* base,
                                            GtkTreeIter* iter);
static gboolean noise_fast_model_real_iter_next (GtkTreeModel* base,
                                          GtkTreeIter* iter);
static gboolean noise_fast_model_real_iter_nth_child (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent,
                                               gint n);
static gboolean noise_fast_model_real_iter_parent (GtkTreeModel* base,
                                            GtkTreeIter* iter,
                                            GtkTreeIter* child);
void noise_fast_model_append (NoiseFastModel* self,
                              GtkTreeIter* iter);
static void _vala_GtkTreePath_free (GtkTreePath* self);
void noise_fast_model_remove (NoiseFastModel* self,
                              GtkTreeIter* iter);
void noise_fast_model_set (NoiseFastModel* self,
                           GtkTreeIter* iter,
                           ...);
static void noise_fast_model_real_ref_node (GtkTreeModel* base,
                                     GtkTreeIter* iter);
static void noise_fast_model_real_unref_node (GtkTreeModel* base,
                                       GtkTreeIter* iter);
void noise_fast_model_set_table (NoiseFastModel* self,
                                 GeeArrayList* table);
void noise_fast_model_set_value_func (NoiseFastModel* self,
                                      NoiseFastModelValueReturnFunc func,
                                      gpointer func_target);
void noise_fast_model_update_row (NoiseFastModel* self,
                                  gint index);
static gboolean noise_fast_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                   gint* column_id,
                                                   GtkSortType* order);
static void noise_fast_model_real_set_sort_column_id (GtkTreeSortable* base,
                                               gint column,
                                               GtkSortType order);
static gboolean noise_fast_model_real_has_default_sort_func (GtkTreeSortable* base);
static void noise_fast_model_real_set_sort_func (GtkTreeSortable* base,
                                          gint sort_column_id,
                                          GtkTreeIterCompareFunc sort_func,
                                          gpointer sort_func_target,
                                          GDestroyNotify sort_func_target_destroy_notify);
static void noise_fast_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                  GtkTreeIterCompareFunc sort_func,
                                                  gpointer sort_func_target,
                                                  GDestroyNotify sort_func_target_destroy_notify);
void noise_fast_model_set_columns (NoiseFastModel* self,
                                   GeeList* value);
static void g_cclosure_user_marshal_VOID__INT_ENUM (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static GObject * noise_fast_model_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void noise_fast_model_finalize (GObject * obj);
static void _vala_noise_fast_model_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_noise_fast_model_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);


static inline gpointer
noise_fast_model_get_instance_private (NoiseFastModel* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseFastModel_private_offset);
}


/** Initialize data storage, columns, etc. **/
NoiseFastModel*
noise_fast_model_construct (GType object_type,
                            GeeList* column_types)
{
	NoiseFastModel * self = NULL;
#line 51 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (column_types != NULL, NULL);
#line 52 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) g_object_new (object_type, "columns", column_types, NULL);
#line 51 "../src/Widgets/FastView/FastListModel.vala"
	return self;
#line 211 "FastListModel.c"
}


NoiseFastModel*
noise_fast_model_new (GeeList* column_types)
{
#line 51 "../src/Widgets/FastView/FastListModel.vala"
	return noise_fast_model_construct (NOISE_TYPE_FAST_MODEL, column_types);
#line 220 "FastListModel.c"
}


static GType
noise_fast_model_real_get_column_type (GtkTreeModel* base,
                                       gint col)
{
	NoiseFastModel * self;
	GType result = 0UL;
	GeeList* _tmp0_;
	gpointer _tmp1_;
#line 62 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 63 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->_columns;
#line 63 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = gee_list_get (_tmp0_, col);
#line 63 "../src/Widgets/FastView/FastListModel.vala"
	result = (GType) ((gintptr) _tmp1_);
#line 63 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 242 "FastListModel.c"
}


static GtkTreeModelFlags
noise_fast_model_real_get_flags (GtkTreeModel* base)
{
	NoiseFastModel * self;
	GtkTreeModelFlags result = 0;
#line 66 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 67 "../src/Widgets/FastView/FastListModel.vala"
	result = GTK_TREE_MODEL_LIST_ONLY;
#line 67 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 257 "FastListModel.c"
}


static gboolean
noise_fast_model_real_get_iter (GtkTreeModel* base,
                                GtkTreeIter* iter,
                                GtkTreePath* path)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gint path_index = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint _tmp2_;
	guint size = 0U;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	guint _tmp9_;
	gint _tmp17_;
	gint _tmp18_;
#line 70 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 70 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 71 "../src/Widgets/FastView/FastListModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 72 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
#line 72 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = _tmp1_[0];
#line 72 "../src/Widgets/FastView/FastListModel.vala"
	path_index = _tmp2_;
#line 73 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = self->priv->rows;
#line 73 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 73 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = _tmp4_;
#line 73 "../src/Widgets/FastView/FastListModel.vala"
	size = (guint) _tmp5_;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
	_tmp9_ = size;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp9_ == ((guint) 0)) {
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp8_ = TRUE;
#line 309 "FastListModel.c"
	} else {
		gint _tmp10_;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp10_ = path_index;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp8_ = _tmp10_ < 0;
#line 316 "FastListModel.c"
	}
#line 75 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp8_) {
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp7_ = TRUE;
#line 322 "FastListModel.c"
	} else {
		gint _tmp11_;
		guint _tmp12_;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp11_ = path_index;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp12_ = size;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp7_ = ((guint) _tmp11_) >= _tmp12_;
#line 332 "FastListModel.c"
	}
#line 75 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp7_) {
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp6_ = TRUE;
#line 338 "FastListModel.c"
	} else {
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gpointer _tmp15_;
		GObject* _tmp16_;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp13_ = self->priv->rows;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp14_ = path_index;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _tmp14_);
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp16_ = (GObject*) _tmp15_;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_tmp6_ = _tmp16_ == NULL;
#line 75 "../src/Widgets/FastView/FastListModel.vala"
		_g_object_unref0 (_tmp16_);
#line 356 "FastListModel.c"
	}
#line 75 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp6_) {
#line 76 "../src/Widgets/FastView/FastListModel.vala"
		result = FALSE;
#line 76 "../src/Widgets/FastView/FastListModel.vala"
		if (iter) {
#line 76 "../src/Widgets/FastView/FastListModel.vala"
			*iter = _vala_iter;
#line 366 "FastListModel.c"
		}
#line 76 "../src/Widgets/FastView/FastListModel.vala"
		return result;
#line 370 "FastListModel.c"
	}
#line 78 "../src/Widgets/FastView/FastListModel.vala"
	_tmp17_ = self->priv->stamp;
#line 78 "../src/Widgets/FastView/FastListModel.vala"
	_vala_iter.stamp = _tmp17_;
#line 79 "../src/Widgets/FastView/FastListModel.vala"
	_tmp18_ = path_index;
#line 79 "../src/Widgets/FastView/FastListModel.vala"
	_vala_iter.user_data = (void*) _tmp18_;
#line 81 "../src/Widgets/FastView/FastListModel.vala"
	result = TRUE;
#line 81 "../src/Widgets/FastView/FastListModel.vala"
	if (iter) {
#line 81 "../src/Widgets/FastView/FastListModel.vala"
		*iter = _vala_iter;
#line 386 "FastListModel.c"
	}
#line 81 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 390 "FastListModel.c"
}


static gint
noise_fast_model_real_get_n_columns (GtkTreeModel* base)
{
	NoiseFastModel * self;
	gint result = 0;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 84 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 85 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->_columns;
#line 85 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 85 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = _tmp1_;
#line 85 "../src/Widgets/FastView/FastListModel.vala"
	result = _tmp2_;
#line 85 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 414 "FastListModel.c"
}


static GtkTreePath*
noise_fast_model_real_get_path (GtkTreeModel* base,
                                GtkTreeIter* iter)
{
	NoiseFastModel * self;
	GtkTreePath* result = NULL;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
#line 88 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 88 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = *iter;
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = _tmp0_.user_data;
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = g_strdup_printf ("%i", (gint) _tmp1_);
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = _tmp2_;
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = _tmp4_;
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	_g_free0 (_tmp3_);
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	result = _tmp5_;
#line 89 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 452 "FastListModel.c"
}


static void
_vala_GValue_free (GValue* self)
{
#line 105 "../src/Widgets/FastView/FastListModel.vala"
	g_value_unset (self);
#line 105 "../src/Widgets/FastView/FastListModel.vala"
	g_free (self);
#line 463 "FastListModel.c"
}


static void
noise_fast_model_real_get_value (GtkTreeModel* base,
                                 GtkTreeIter* iter,
                                 gint column,
                                 GValue* val)
{
	NoiseFastModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GValue _tmp6_ = {0};
	gint row = 0;
	GtkTreeIter _tmp7_;
	void* _tmp8_;
	GObject* object = NULL;
	GeeArrayList* _tmp9_;
	gint _tmp10_;
	gpointer _tmp11_;
	GObject* _tmp12_;
#line 92 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 92 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (iter != NULL);
#line 93 "../src/Widgets/FastView/FastListModel.vala"
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 93 "../src/Widgets/FastView/FastListModel.vala"
	_vala_val = _tmp0_;
#line 95 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = *iter;
#line 95 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = _tmp3_.stamp;
#line 95 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = self->priv->stamp;
#line 95 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp4_ != _tmp5_) {
#line 95 "../src/Widgets/FastView/FastListModel.vala"
		_tmp2_ = TRUE;
#line 508 "FastListModel.c"
	} else {
#line 95 "../src/Widgets/FastView/FastListModel.vala"
		_tmp2_ = column < 0;
#line 512 "FastListModel.c"
	}
#line 95 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp2_) {
#line 95 "../src/Widgets/FastView/FastListModel.vala"
		_tmp1_ = TRUE;
#line 518 "FastListModel.c"
	} else {
#line 95 "../src/Widgets/FastView/FastListModel.vala"
		_tmp1_ = column >= gtk_tree_model_get_n_columns ((GtkTreeModel*) self);
#line 522 "FastListModel.c"
	}
#line 95 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp1_) {
#line 96 "../src/Widgets/FastView/FastListModel.vala"
		if (val) {
#line 96 "../src/Widgets/FastView/FastListModel.vala"
			*val = _vala_val;
#line 530 "FastListModel.c"
		} else {
#line 96 "../src/Widgets/FastView/FastListModel.vala"
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 534 "FastListModel.c"
		}
#line 96 "../src/Widgets/FastView/FastListModel.vala"
		return;
#line 538 "FastListModel.c"
	}
#line 99 "../src/Widgets/FastView/FastListModel.vala"
	g_value_init (&_tmp6_, gtk_tree_model_get_column_type ((GtkTreeModel*) self, column));
#line 99 "../src/Widgets/FastView/FastListModel.vala"
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 99 "../src/Widgets/FastView/FastListModel.vala"
	_vala_val = _tmp6_;
#line 101 "../src/Widgets/FastView/FastListModel.vala"
	_tmp7_ = *iter;
#line 101 "../src/Widgets/FastView/FastListModel.vala"
	_tmp8_ = _tmp7_.user_data;
#line 101 "../src/Widgets/FastView/FastListModel.vala"
	row = (gint) _tmp8_;
#line 102 "../src/Widgets/FastView/FastListModel.vala"
	_tmp9_ = self->priv->rows;
#line 102 "../src/Widgets/FastView/FastListModel.vala"
	_tmp10_ = row;
#line 102 "../src/Widgets/FastView/FastListModel.vala"
	_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 102 "../src/Widgets/FastView/FastListModel.vala"
	object = (GObject*) _tmp11_;
#line 104 "../src/Widgets/FastView/FastListModel.vala"
	_tmp12_ = object;
#line 104 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp12_ != NULL) {
#line 564 "FastListModel.c"
		NoiseFastModelValueReturnFunc _tmp13_;
		void* _tmp13__target;
		gint _tmp14_;
		GObject* _tmp15_;
		GValue* _tmp16_;
		GValue* _tmp17_;
		GValue _tmp18_ = {0};
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_tmp13_ = self->priv->value_func;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_tmp13__target = self->priv->value_func_target;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_tmp14_ = row;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_tmp15_ = object;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_tmp16_ = _tmp13_ (_tmp14_, column, _tmp15_, _tmp13__target);
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_tmp17_ = _tmp16_;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		if (G_IS_VALUE (_tmp17_)) {
#line 105 "../src/Widgets/FastView/FastListModel.vala"
			g_value_init (&_tmp18_, G_VALUE_TYPE (_tmp17_));
#line 105 "../src/Widgets/FastView/FastListModel.vala"
			g_value_copy (_tmp17_, &_tmp18_);
#line 590 "FastListModel.c"
		} else {
#line 105 "../src/Widgets/FastView/FastListModel.vala"
			_tmp18_ = *_tmp17_;
#line 594 "FastListModel.c"
		}
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		_vala_val = _tmp18_;
#line 105 "../src/Widgets/FastView/FastListModel.vala"
		__vala_GValue_free0 (_tmp17_);
#line 602 "FastListModel.c"
	}
#line 92 "../src/Widgets/FastView/FastListModel.vala"
	_g_object_unref0 (object);
#line 92 "../src/Widgets/FastView/FastListModel.vala"
	if (val) {
#line 92 "../src/Widgets/FastView/FastListModel.vala"
		*val = _vala_val;
#line 610 "FastListModel.c"
	} else {
#line 92 "../src/Widgets/FastView/FastListModel.vala"
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
#line 614 "FastListModel.c"
	}
}


GObject*
noise_fast_model_get_object (NoiseFastModel* self,
                             GtkTreeIter* iter)
{
	GObject* result = NULL;
	GeeArrayList* _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gpointer _tmp3_;
#line 109 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 110 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->rows;
#line 110 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = *iter;
#line 110 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = _tmp1_.user_data;
#line 110 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, (gint) _tmp2_);
#line 110 "../src/Widgets/FastView/FastListModel.vala"
	result = (GObject*) _tmp3_;
#line 110 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 644 "FastListModel.c"
}


static gboolean
noise_fast_model_real_iter_children (GtkTreeModel* base,
                                     GtkTreeIter* iter,
                                     GtkTreeIter* parent)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
#line 113 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 114 "../src/Widgets/FastView/FastListModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 115 "../src/Widgets/FastView/FastListModel.vala"
	result = FALSE;
#line 115 "../src/Widgets/FastView/FastListModel.vala"
	if (iter) {
#line 115 "../src/Widgets/FastView/FastListModel.vala"
		*iter = _vala_iter;
#line 666 "FastListModel.c"
	}
#line 115 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 670 "FastListModel.c"
}


static gboolean
noise_fast_model_real_iter_has_child (GtkTreeModel* base,
                                      GtkTreeIter* iter)
{
	NoiseFastModel * self;
	gboolean result = FALSE;
#line 118 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 118 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 119 "../src/Widgets/FastView/FastListModel.vala"
	result = FALSE;
#line 119 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 688 "FastListModel.c"
}


static gint
noise_fast_model_real_iter_n_children (GtkTreeModel* base,
                                       GtkTreeIter* iter)
{
	NoiseFastModel * self;
	gint result = 0;
	gint _tmp0_ = 0;
#line 122 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 123 "../src/Widgets/FastView/FastListModel.vala"
	if (iter == NULL) {
#line 703 "FastListModel.c"
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 123 "../src/Widgets/FastView/FastListModel.vala"
		_tmp1_ = self->priv->rows;
#line 123 "../src/Widgets/FastView/FastListModel.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 123 "../src/Widgets/FastView/FastListModel.vala"
		_tmp3_ = _tmp2_;
#line 123 "../src/Widgets/FastView/FastListModel.vala"
		_tmp0_ = (gint) _tmp3_;
#line 715 "FastListModel.c"
	} else {
#line 123 "../src/Widgets/FastView/FastListModel.vala"
		_tmp0_ = 0;
#line 719 "FastListModel.c"
	}
#line 123 "../src/Widgets/FastView/FastListModel.vala"
	result = _tmp0_;
#line 123 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 725 "FastListModel.c"
}


static gboolean
noise_fast_model_real_iter_next (GtkTreeModel* base,
                                 GtkTreeIter* iter)
{
	NoiseFastModel * self;
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint index = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
#line 126 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 126 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 127 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = *iter;
#line 127 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 127 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = self->priv->stamp;
#line 127 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 128 "../src/Widgets/FastView/FastListModel.vala"
		result = FALSE;
#line 128 "../src/Widgets/FastView/FastListModel.vala"
		return result;
#line 763 "FastListModel.c"
	}
#line 131 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = *iter;
#line 131 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = _tmp3_.user_data;
#line 131 "../src/Widgets/FastView/FastListModel.vala"
	index = (gint) _tmp4_;
#line 132 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = index;
#line 132 "../src/Widgets/FastView/FastListModel.vala"
	index = _tmp5_ + 1;
#line 132 "../src/Widgets/FastView/FastListModel.vala"
	_tmp6_ = index;
#line 132 "../src/Widgets/FastView/FastListModel.vala"
	(*iter).user_data = (void*) _tmp6_;
#line 134 "../src/Widgets/FastView/FastListModel.vala"
	_tmp7_ = index;
#line 134 "../src/Widgets/FastView/FastListModel.vala"
	_tmp8_ = self->priv->rows;
#line 134 "../src/Widgets/FastView/FastListModel.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 134 "../src/Widgets/FastView/FastListModel.vala"
	_tmp10_ = _tmp9_;
#line 134 "../src/Widgets/FastView/FastListModel.vala"
	result = _tmp7_ < _tmp10_;
#line 134 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 791 "FastListModel.c"
}


static gboolean
noise_fast_model_real_iter_nth_child (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      GtkTreeIter* parent,
                                      gint n)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp5_;
#line 137 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 138 "../src/Widgets/FastView/FastListModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 140 "../src/Widgets/FastView/FastListModel.vala"
	if (n < 0) {
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp1_ = TRUE;
#line 815 "FastListModel.c"
	} else {
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp2_ = self->priv->rows;
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp4_ = _tmp3_;
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp1_ = n >= _tmp4_;
#line 828 "FastListModel.c"
	}
#line 140 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp1_) {
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp0_ = TRUE;
#line 834 "FastListModel.c"
	} else {
#line 140 "../src/Widgets/FastView/FastListModel.vala"
		_tmp0_ = parent != NULL;
#line 838 "FastListModel.c"
	}
#line 140 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp0_) {
#line 141 "../src/Widgets/FastView/FastListModel.vala"
		result = FALSE;
#line 141 "../src/Widgets/FastView/FastListModel.vala"
		if (iter) {
#line 141 "../src/Widgets/FastView/FastListModel.vala"
			*iter = _vala_iter;
#line 848 "FastListModel.c"
		}
#line 141 "../src/Widgets/FastView/FastListModel.vala"
		return result;
#line 852 "FastListModel.c"
	}
#line 143 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = self->priv->stamp;
#line 143 "../src/Widgets/FastView/FastListModel.vala"
	_vala_iter.stamp = _tmp5_;
#line 144 "../src/Widgets/FastView/FastListModel.vala"
	_vala_iter.user_data = (void*) n;
#line 146 "../src/Widgets/FastView/FastListModel.vala"
	result = TRUE;
#line 146 "../src/Widgets/FastView/FastListModel.vala"
	if (iter) {
#line 146 "../src/Widgets/FastView/FastListModel.vala"
		*iter = _vala_iter;
#line 866 "FastListModel.c"
	}
#line 146 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 870 "FastListModel.c"
}


static gboolean
noise_fast_model_real_iter_parent (GtkTreeModel* base,
                                   GtkTreeIter* iter,
                                   GtkTreeIter* child)
{
	NoiseFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
#line 149 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 149 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (child != NULL, FALSE);
#line 150 "../src/Widgets/FastView/FastListModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 152 "../src/Widgets/FastView/FastListModel.vala"
	result = FALSE;
#line 152 "../src/Widgets/FastView/FastListModel.vala"
	if (iter) {
#line 152 "../src/Widgets/FastView/FastListModel.vala"
		*iter = _vala_iter;
#line 894 "FastListModel.c"
	}
#line 152 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 898 "FastListModel.c"
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 155 "../src/Widgets/FastView/FastListModel.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 907 "FastListModel.c"
}


void
noise_fast_model_append (NoiseFastModel* self,
                         GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	gint index = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp3_;
	GeeArrayList* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	gint _tmp7_;
	GeeArrayList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkTreeIter _tmp11_;
#line 155 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Widgets/FastView/FastListModel.vala"
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
#line 158 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->rows;
#line 158 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 158 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = _tmp1_;
#line 158 "../src/Widgets/FastView/FastListModel.vala"
	index = (gint) _tmp2_;
#line 160 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = gtk_tree_path_new_from_indices (index, -1, -1);
#line 160 "../src/Widgets/FastView/FastListModel.vala"
	path = _tmp3_;
#line 161 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = self->priv->rows;
#line 161 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = g_object_new (G_TYPE_OBJECT, NULL);
#line 161 "../src/Widgets/FastView/FastListModel.vala"
	_tmp6_ = _tmp5_;
#line 161 "../src/Widgets/FastView/FastListModel.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp6_);
#line 161 "../src/Widgets/FastView/FastListModel.vala"
	_g_object_unref0 (_tmp6_);
#line 163 "../src/Widgets/FastView/FastListModel.vala"
	_tmp7_ = self->priv->stamp;
#line 163 "../src/Widgets/FastView/FastListModel.vala"
	_vala_iter.stamp = _tmp7_;
#line 164 "../src/Widgets/FastView/FastListModel.vala"
	_tmp8_ = self->priv->rows;
#line 164 "../src/Widgets/FastView/FastListModel.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 164 "../src/Widgets/FastView/FastListModel.vala"
	_tmp10_ = _tmp9_;
#line 164 "../src/Widgets/FastView/FastListModel.vala"
	_vala_iter.user_data = (void*) _tmp10_;
#line 166 "../src/Widgets/FastView/FastListModel.vala"
	_tmp11_ = _vala_iter;
#line 166 "../src/Widgets/FastView/FastListModel.vala"
	gtk_tree_model_row_inserted ((GtkTreeModel*) self, path, &_tmp11_);
#line 155 "../src/Widgets/FastView/FastListModel.vala"
	__vala_GtkTreePath_free0 (path);
#line 155 "../src/Widgets/FastView/FastListModel.vala"
	if (iter) {
#line 155 "../src/Widgets/FastView/FastListModel.vala"
		*iter = _vala_iter;
#line 978 "FastListModel.c"
	}
}


void
noise_fast_model_remove (NoiseFastModel* self,
                         GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint index = 0;
	GtkTreeIter _tmp3_;
	void* _tmp4_;
	GtkTreePath* path = NULL;
	gint _tmp5_;
	GtkTreePath* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gpointer _tmp9_;
	GObject* _tmp10_;
	GtkTreePath* _tmp11_;
#line 169 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (iter != NULL);
#line 170 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = *iter;
#line 170 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = _tmp0_.stamp;
#line 170 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = self->priv->stamp;
#line 170 "../src/Widgets/FastView/FastListModel.vala"
	if (_tmp1_ != _tmp2_) {
#line 171 "../src/Widgets/FastView/FastListModel.vala"
		return;
#line 1015 "FastListModel.c"
	}
#line 174 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = *iter;
#line 174 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = _tmp3_.user_data;
#line 174 "../src/Widgets/FastView/FastListModel.vala"
	index = (gint) _tmp4_;
#line 176 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = index;
#line 176 "../src/Widgets/FastView/FastListModel.vala"
	_tmp6_ = gtk_tree_path_new_from_indices (_tmp5_, -1, -1);
#line 176 "../src/Widgets/FastView/FastListModel.vala"
	path = _tmp6_;
#line 177 "../src/Widgets/FastView/FastListModel.vala"
	_tmp7_ = self->priv->rows;
#line 177 "../src/Widgets/FastView/FastListModel.vala"
	_tmp8_ = index;
#line 177 "../src/Widgets/FastView/FastListModel.vala"
	_tmp9_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 177 "../src/Widgets/FastView/FastListModel.vala"
	_tmp10_ = (GObject*) _tmp9_;
#line 177 "../src/Widgets/FastView/FastListModel.vala"
	_g_object_unref0 (_tmp10_);
#line 179 "../src/Widgets/FastView/FastListModel.vala"
	_tmp11_ = path;
#line 179 "../src/Widgets/FastView/FastListModel.vala"
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp11_);
#line 169 "../src/Widgets/FastView/FastListModel.vala"
	__vala_GtkTreePath_free0 (path);
#line 1045 "FastListModel.c"
}


void
noise_fast_model_set (NoiseFastModel* self,
                      GtkTreeIter* iter,
                      ...)
{
#line 186 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (iter != NULL);
#line 187 "../src/Widgets/FastView/FastListModel.vala"
	return;
#line 1060 "FastListModel.c"
}


static void
noise_fast_model_real_ref_node (GtkTreeModel* base,
                                GtkTreeIter* iter)
{
	NoiseFastModel * self;
#line 190 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 190 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (iter != NULL);
#line 1073 "FastListModel.c"
}


static void
noise_fast_model_real_unref_node (GtkTreeModel* base,
                                  GtkTreeIter* iter)
{
	NoiseFastModel * self;
#line 191 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 191 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (iter != NULL);
#line 1086 "FastListModel.c"
}


void
noise_fast_model_set_table (NoiseFastModel* self,
                            GeeArrayList* table)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkTreeIter iter = {0};
#line 203 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (table != NULL);
#line 204 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->rows;
#line 204 "../src/Widgets/FastView/FastListModel.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 205 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = self->priv->rows;
#line 205 "../src/Widgets/FastView/FastListModel.vala"
	gee_array_list_add_all (_tmp1_, (GeeCollection*) table);
#line 1109 "FastListModel.c"
	{
		gboolean valid = FALSE;
		GtkTreeIter _tmp2_ = {0};
		gboolean _tmp3_;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
		_tmp3_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) self, &_tmp2_);
#line 208 "../src/Widgets/FastView/FastListModel.vala"
		iter = _tmp2_;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
		valid = _tmp3_;
#line 1120 "FastListModel.c"
		{
			gboolean _tmp4_ = FALSE;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
			_tmp4_ = TRUE;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
			while (TRUE) {
#line 1127 "FastListModel.c"
				gboolean _tmp6_;
				GtkTreeIter _tmp7_;
				GtkTreePath* _tmp8_;
				GtkTreePath* _tmp9_;
				GtkTreeIter _tmp10_;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
				if (!_tmp4_) {
#line 1135 "FastListModel.c"
					gboolean _tmp5_;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
					_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) self, &iter);
#line 208 "../src/Widgets/FastView/FastListModel.vala"
					valid = _tmp5_;
#line 1141 "FastListModel.c"
				}
#line 208 "../src/Widgets/FastView/FastListModel.vala"
				_tmp4_ = FALSE;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
				_tmp6_ = valid;
#line 208 "../src/Widgets/FastView/FastListModel.vala"
				if (!_tmp6_) {
#line 208 "../src/Widgets/FastView/FastListModel.vala"
					break;
#line 1151 "FastListModel.c"
				}
#line 209 "../src/Widgets/FastView/FastListModel.vala"
				_tmp7_ = iter;
#line 209 "../src/Widgets/FastView/FastListModel.vala"
				_tmp8_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp7_);
#line 209 "../src/Widgets/FastView/FastListModel.vala"
				_tmp9_ = _tmp8_;
#line 209 "../src/Widgets/FastView/FastListModel.vala"
				_tmp10_ = iter;
#line 209 "../src/Widgets/FastView/FastListModel.vala"
				gtk_tree_model_row_changed ((GtkTreeModel*) self, _tmp9_, &_tmp10_);
#line 209 "../src/Widgets/FastView/FastListModel.vala"
				__vala_GtkTreePath_free0 (_tmp9_);
#line 1165 "FastListModel.c"
			}
		}
	}
}


void
noise_fast_model_set_value_func (NoiseFastModel* self,
                                 NoiseFastModelValueReturnFunc func,
                                 gpointer func_target)
{
#line 216 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->value_func = func;
#line 217 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->value_func_target = func_target;
#line 1183 "FastListModel.c"
}


void
noise_fast_model_update_row (NoiseFastModel* self,
                             gint index)
{
	GtkTreePath* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter iter = {0};
	gint _tmp4_;
	GtkTreeIter _tmp5_;
#line 220 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = g_strdup_printf ("%i", index);
#line 221 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = _tmp0_;
#line 221 "../src/Widgets/FastView/FastListModel.vala"
	_tmp2_ = gtk_tree_path_new_from_string (_tmp1_);
#line 221 "../src/Widgets/FastView/FastListModel.vala"
	_tmp3_ = _tmp2_;
#line 221 "../src/Widgets/FastView/FastListModel.vala"
	_g_free0 (_tmp1_);
#line 221 "../src/Widgets/FastView/FastListModel.vala"
	path = _tmp3_;
#line 222 "../src/Widgets/FastView/FastListModel.vala"
	memset (&iter, 0, sizeof (GtkTreeIter));
#line 223 "../src/Widgets/FastView/FastListModel.vala"
	_tmp4_ = self->priv->stamp;
#line 223 "../src/Widgets/FastView/FastListModel.vala"
	iter.stamp = _tmp4_;
#line 224 "../src/Widgets/FastView/FastListModel.vala"
	iter.user_data = (void*) index;
#line 226 "../src/Widgets/FastView/FastListModel.vala"
	_tmp5_ = iter;
#line 226 "../src/Widgets/FastView/FastListModel.vala"
	gtk_tree_model_row_changed ((GtkTreeModel*) self, path, &_tmp5_);
#line 220 "../src/Widgets/FastView/FastListModel.vala"
	__vala_GtkTreePath_free0 (path);
#line 1227 "FastListModel.c"
}


static gboolean
noise_fast_model_real_get_sort_column_id (GtkTreeSortable* base,
                                          gint* column_id,
                                          GtkSortType* order)
{
	NoiseFastModel * self;
	gint _vala_column_id = 0;
	GtkSortType _vala_order = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	GtkSortType _tmp1_;
#line 232 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 233 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->sort_column_id;
#line 233 "../src/Widgets/FastView/FastListModel.vala"
	_vala_column_id = _tmp0_;
#line 234 "../src/Widgets/FastView/FastListModel.vala"
	_tmp1_ = self->priv->sort_direction;
#line 234 "../src/Widgets/FastView/FastListModel.vala"
	_vala_order = _tmp1_;
#line 236 "../src/Widgets/FastView/FastListModel.vala"
	result = TRUE;
#line 236 "../src/Widgets/FastView/FastListModel.vala"
	if (column_id) {
#line 236 "../src/Widgets/FastView/FastListModel.vala"
		*column_id = _vala_column_id;
#line 1258 "FastListModel.c"
	}
#line 236 "../src/Widgets/FastView/FastListModel.vala"
	if (order) {
#line 236 "../src/Widgets/FastView/FastListModel.vala"
		*order = _vala_order;
#line 1264 "FastListModel.c"
	}
#line 236 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 1268 "FastListModel.c"
}


static void
noise_fast_model_real_set_sort_column_id (GtkTreeSortable* base,
                                          gint column,
                                          GtkSortType order)
{
	NoiseFastModel * self;
#line 239 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 240 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->sort_column_id = column;
#line 241 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->sort_direction = order;
#line 243 "../src/Widgets/FastView/FastListModel.vala"
	if (column != -1) {
#line 244 "../src/Widgets/FastView/FastListModel.vala"
		g_signal_emit (self, noise_fast_model_signals[NOISE_FAST_MODEL_REORDER_REQUESTED_SIGNAL], 0, column, order);
#line 245 "../src/Widgets/FastView/FastListModel.vala"
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
#line 1290 "FastListModel.c"
	}
}


/** The following functions are only here to implement TreeSortable **/
static gboolean
noise_fast_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	NoiseFastModel * self;
	gboolean result = FALSE;
#line 250 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 251 "../src/Widgets/FastView/FastListModel.vala"
	result = TRUE;
#line 251 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 1307 "FastListModel.c"
}


static void
noise_fast_model_real_set_sort_func (GtkTreeSortable* base,
                                     gint sort_column_id,
                                     GtkTreeIterCompareFunc sort_func,
                                     gpointer sort_func_target,
                                     GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseFastModel * self;
#line 254 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 254 "../src/Widgets/FastView/FastListModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 254 "../src/Widgets/FastView/FastListModel.vala"
	sort_func = NULL;
#line 254 "../src/Widgets/FastView/FastListModel.vala"
	sort_func_target = NULL;
#line 254 "../src/Widgets/FastView/FastListModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1329 "FastListModel.c"
}


static void
noise_fast_model_real_set_default_sort_func (GtkTreeSortable* base,
                                             GtkTreeIterCompareFunc sort_func,
                                             gpointer sort_func_target,
                                             GDestroyNotify sort_func_target_destroy_notify)
{
	NoiseFastModel * self;
#line 258 "../src/Widgets/FastView/FastListModel.vala"
	self = (NoiseFastModel*) base;
#line 258 "../src/Widgets/FastView/FastListModel.vala"
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
#line 258 "../src/Widgets/FastView/FastListModel.vala"
	sort_func = NULL;
#line 258 "../src/Widgets/FastView/FastListModel.vala"
	sort_func_target = NULL;
#line 258 "../src/Widgets/FastView/FastListModel.vala"
	sort_func_target_destroy_notify = NULL;
#line 1350 "FastListModel.c"
}


GeeList*
noise_fast_model_get_columns (NoiseFastModel* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = self->priv->_columns;
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	result = _tmp0_;
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	return result;
#line 1367 "FastListModel.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	return self ? g_object_ref (self) : NULL;
#line 1376 "FastListModel.c"
}


void
noise_fast_model_set_columns (NoiseFastModel* self,
                              GeeList* value)
{
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	if (noise_fast_model_get_columns (self) != value) {
#line 1388 "FastListModel.c"
		GeeList* _tmp0_;
#line 39 "../src/Widgets/FastView/FastListModel.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/Widgets/FastView/FastListModel.vala"
		_g_object_unref0 (self->priv->_columns);
#line 39 "../src/Widgets/FastView/FastListModel.vala"
		self->priv->_columns = _tmp0_;
#line 39 "../src/Widgets/FastView/FastListModel.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_fast_model_properties[NOISE_FAST_MODEL_COLUMNS_PROPERTY]);
#line 1398 "FastListModel.c"
	}
}


static void
g_cclosure_user_marshal_VOID__INT_ENUM (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_ENUM) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	g_return_if_fail (n_param_values == 3);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		data1 = closure->data;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		data2 = param_values->data[0].v_pointer;
#line 1425 "FastListModel.c"
	} else {
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		data1 = param_values->data[0].v_pointer;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		data2 = closure->data;
#line 1431 "FastListModel.c"
	}
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	callback = (GMarshalFunc_VOID__INT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 1437 "FastListModel.c"
}


static GObject *
noise_fast_model_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseFastModel * self;
#line 55 "../src/Widgets/FastView/FastListModel.vala"
	parent_class = G_OBJECT_CLASS (noise_fast_model_parent_class);
#line 55 "../src/Widgets/FastView/FastListModel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 55 "../src/Widgets/FastView/FastListModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
#line 56 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->sort_column_id = -2;
#line 57 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->sort_direction = GTK_SORT_ASCENDING;
#line 59 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->stamp = (gint) g_random_int ();
#line 55 "../src/Widgets/FastView/FastListModel.vala"
	return obj;
#line 1463 "FastListModel.c"
}


static void
noise_fast_model_class_init (NoiseFastModelClass * klass)
{
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	noise_fast_model_parent_class = g_type_class_peek_parent (klass);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	g_type_class_adjust_private_offset (klass, &NoiseFastModel_private_offset);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_fast_model_get_property;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_fast_model_set_property;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_fast_model_constructor;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_fast_model_finalize;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_FAST_MODEL_COLUMNS_PROPERTY, noise_fast_model_properties[NOISE_FAST_MODEL_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	noise_fast_model_signals[NOISE_FAST_MODEL_REORDER_REQUESTED_SIGNAL] = g_signal_new ("reorder-requested", NOISE_TYPE_FAST_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_ENUM, G_TYPE_NONE, 2, G_TYPE_INT, gtk_sort_type_get_type ());
#line 1486 "FastListModel.c"
}


static void
noise_fast_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface)
{
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	noise_fast_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) noise_fast_model_real_get_column_type;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) noise_fast_model_real_get_flags;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) noise_fast_model_real_get_iter;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) noise_fast_model_real_get_n_columns;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) noise_fast_model_real_get_path;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) noise_fast_model_real_get_value;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) noise_fast_model_real_iter_children;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) noise_fast_model_real_iter_has_child;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) noise_fast_model_real_iter_n_children;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) noise_fast_model_real_iter_next;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) noise_fast_model_real_iter_nth_child;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) noise_fast_model_real_iter_parent;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->ref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) noise_fast_model_real_ref_node;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->unref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) noise_fast_model_real_unref_node;
#line 1523 "FastListModel.c"
}


static void
noise_fast_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface)
{
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	noise_fast_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable*, gint*, GtkSortType*)) noise_fast_model_real_get_sort_column_id;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->set_sort_column_id = (void (*) (GtkTreeSortable*, gint, GtkSortType)) noise_fast_model_real_set_sort_column_id;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable*)) noise_fast_model_real_has_default_sort_func;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->set_sort_func = (void (*) (GtkTreeSortable*, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_fast_model_real_set_sort_func;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	iface->set_default_sort_func = (void (*) (GtkTreeSortable*, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) noise_fast_model_real_set_default_sort_func;
#line 1542 "FastListModel.c"
}


static void
noise_fast_model_instance_init (NoiseFastModel * self)
{
	GeeArrayList* _tmp0_;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	self->priv = noise_fast_model_get_instance_private (self);
#line 38 "../src/Widgets/FastView/FastListModel.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 38 "../src/Widgets/FastView/FastListModel.vala"
	self->priv->rows = _tmp0_;
#line 1556 "FastListModel.c"
}


static void
noise_fast_model_finalize (GObject * obj)
{
	NoiseFastModel * self;
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
#line 38 "../src/Widgets/FastView/FastListModel.vala"
	_g_object_unref0 (self->priv->rows);
#line 39 "../src/Widgets/FastView/FastListModel.vala"
	_g_object_unref0 (self->priv->_columns);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	G_OBJECT_CLASS (noise_fast_model_parent_class)->finalize (obj);
#line 1572 "FastListModel.c"
}


GType
noise_fast_model_get_type (void)
{
	static volatile gsize noise_fast_model_type_id__volatile = 0;
	if (g_once_init_enter (&noise_fast_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseFastModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_fast_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseFastModel), 0, (GInstanceInitFunc) noise_fast_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) noise_fast_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) noise_fast_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_fast_model_type_id;
		noise_fast_model_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseFastModel", &g_define_type_info, 0);
		g_type_add_interface_static (noise_fast_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
		g_type_add_interface_static (noise_fast_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
		NoiseFastModel_private_offset = g_type_add_instance_private (noise_fast_model_type_id, sizeof (NoiseFastModelPrivate));
		g_once_init_leave (&noise_fast_model_type_id__volatile, noise_fast_model_type_id);
	}
	return noise_fast_model_type_id__volatile;
}


static void
_vala_noise_fast_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	NoiseFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	switch (property_id) {
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		case NOISE_FAST_MODEL_COLUMNS_PROPERTY:
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		g_value_set_object (value, noise_fast_model_get_columns (self));
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		break;
#line 1611 "FastListModel.c"
		default:
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		break;
#line 1617 "FastListModel.c"
	}
}


static void
_vala_noise_fast_model_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	NoiseFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_MODEL, NoiseFastModel);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
	switch (property_id) {
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		case NOISE_FAST_MODEL_COLUMNS_PROPERTY:
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		noise_fast_model_set_columns (self, g_value_get_object (value));
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		break;
#line 1638 "FastListModel.c"
		default:
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 34 "../src/Widgets/FastView/FastListModel.vala"
		break;
#line 1644 "FastListModel.c"
	}
}



