/* RatingMenuItem.c generated by valac 0.42.6, the Vala compiler
 * generated from RatingMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Lucas Baudin <xapantu@gmail.com>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define MUSIC_TYPE_RATING_MENU_ITEM (music_rating_menu_item_get_type ())
#define MUSIC_RATING_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItem))
#define MUSIC_RATING_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItemClass))
#define MUSIC_IS_RATING_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_MENU_ITEM))
#define MUSIC_IS_RATING_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_MENU_ITEM))
#define MUSIC_RATING_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItemClass))

typedef struct _MusicRatingMenuItem MusicRatingMenuItem;
typedef struct _MusicRatingMenuItemClass MusicRatingMenuItemClass;
typedef struct _MusicRatingMenuItemPrivate MusicRatingMenuItemPrivate;

#define MUSIC_TYPE_RATING_WIDGET (music_rating_widget_get_type ())
#define MUSIC_RATING_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_RATING_WIDGET, MusicRatingWidget))
#define MUSIC_RATING_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_RATING_WIDGET, MusicRatingWidgetClass))
#define MUSIC_IS_RATING_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_RATING_WIDGET))
#define MUSIC_IS_RATING_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_RATING_WIDGET))
#define MUSIC_RATING_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_RATING_WIDGET, MusicRatingWidgetClass))

typedef struct _MusicRatingWidget MusicRatingWidget;
typedef struct _MusicRatingWidgetClass MusicRatingWidgetClass;
enum  {
	MUSIC_RATING_MENU_ITEM_0_PROPERTY,
	MUSIC_RATING_MENU_ITEM_RATING_PROPERTY,
	MUSIC_RATING_MENU_ITEM_RATING_VALUE_PROPERTY,
	MUSIC_RATING_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* music_rating_menu_item_properties[MUSIC_RATING_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicRatingMenuItem {
	GtkMenuItem parent_instance;
	MusicRatingMenuItemPrivate * priv;
};

struct _MusicRatingMenuItemClass {
	GtkMenuItemClass parent_class;
};

struct _MusicRatingMenuItemPrivate {
	MusicRatingWidget* _rating;
};


static gint MusicRatingMenuItem_private_offset;
static gpointer music_rating_menu_item_parent_class = NULL;

GType music_rating_menu_item_get_type (void) G_GNUC_CONST;
GType music_rating_widget_get_type (void) G_GNUC_CONST;
MusicRatingMenuItem* music_rating_menu_item_new (void);
MusicRatingMenuItem* music_rating_menu_item_construct (GType object_type);
MusicRatingWidget* music_rating_widget_new (gboolean centered,
                                            GtkIconSize size,
                                            gboolean symbolic);
MusicRatingWidget* music_rating_widget_construct (GType object_type,
                                                  gboolean centered,
                                                  GtkIconSize size,
                                                  gboolean symbolic);
static void music_rating_menu_item_set_rating (MusicRatingMenuItem* self,
                                        MusicRatingWidget* value);
MusicRatingWidget* music_rating_menu_item_get_rating (MusicRatingMenuItem* self);
gint music_rating_widget_get_item_width (MusicRatingWidget* self);
gint music_rating_widget_get_star_spacing (MusicRatingWidget* self);
void music_rating_widget_set_rating_offset (MusicRatingWidget* self,
                                            gdouble value);
static void __lambda41_ (MusicRatingMenuItem* self);
static void ___lambda41__gtk_widget_state_flags_changed (GtkWidget* _sender,
                                                  GtkStateFlags previous_state_flags,
                                                  gpointer self);
static gboolean music_rating_menu_item_real_motion_notify_event (GtkWidget* base,
                                                          GdkEventMotion* ev);
static gboolean music_rating_menu_item_real_button_press_event (GtkWidget* base,
                                                         GdkEventButton* ev);
static gboolean music_rating_menu_item_real_leave_notify_event (GtkWidget* base,
                                                         GdkEventCrossing* ev);
void music_rating_widget_update_rating (MusicRatingWidget* self,
                                        gint fake_rating);
gint music_rating_menu_item_get_rating_value (MusicRatingMenuItem* self);
gint music_rating_widget_get_rating (MusicRatingWidget* self);
void music_rating_menu_item_set_rating_value (MusicRatingMenuItem* self,
                                              gint value);
void music_rating_widget_set_rating (MusicRatingWidget* self,
                                     gint value);
static void music_rating_menu_item_finalize (GObject * obj);
static void _vala_music_rating_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_rating_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static inline gpointer
music_rating_menu_item_get_instance_private (MusicRatingMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, MusicRatingMenuItem_private_offset);
}


static void
__lambda41_ (MusicRatingMenuItem* self)
{
	GtkStateFlags selected_flags = 0;
	GtkStateFlags _tmp0_;
#line 46 "../src/Widgets/Rating/RatingMenuItem.vala"
	selected_flags = GTK_STATE_FLAG_SELECTED | GTK_STATE_FLAG_PRELIGHT;
#line 47 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = selected_flags;
#line 47 "../src/Widgets/Rating/RatingMenuItem.vala"
	if ((gtk_widget_get_state_flags ((GtkWidget*) self) & _tmp0_) != 0) {
#line 153 "RatingMenuItem.c"
		GtkStateFlags _tmp1_;
#line 48 "../src/Widgets/Rating/RatingMenuItem.vala"
		_tmp1_ = selected_flags;
#line 48 "../src/Widgets/Rating/RatingMenuItem.vala"
		gtk_widget_unset_state_flags ((GtkWidget*) self, _tmp1_);
#line 159 "RatingMenuItem.c"
	}
}


static void
___lambda41__gtk_widget_state_flags_changed (GtkWidget* _sender,
                                             GtkStateFlags previous_state_flags,
                                             gpointer self)
{
#line 44 "../src/Widgets/Rating/RatingMenuItem.vala"
	__lambda41_ ((MusicRatingMenuItem*) self);
#line 171 "RatingMenuItem.c"
}


MusicRatingMenuItem*
music_rating_menu_item_construct (GType object_type)
{
	MusicRatingMenuItem * self = NULL;
	MusicRatingWidget* _tmp0_;
	MusicRatingWidget* _tmp1_;
	MusicRatingWidget* _tmp2_;
	MusicRatingWidget* _tmp3_;
	MusicRatingWidget* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	MusicRatingWidget* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 37 "../src/Widgets/Rating/RatingMenuItem.vala"
	self = (MusicRatingMenuItem*) g_object_new (object_type, NULL);
#line 38 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = music_rating_widget_new (FALSE, GTK_ICON_SIZE_MENU, FALSE);
#line 38 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/Widgets/Rating/RatingMenuItem.vala"
	music_rating_menu_item_set_rating (self, _tmp1_);
#line 38 "../src/Widgets/Rating/RatingMenuItem.vala"
	_g_object_unref0 (_tmp1_);
#line 39 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp2_ = self->priv->_rating;
#line 39 "../src/Widgets/Rating/RatingMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp3_ = self->priv->_rating;
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp4_ = self->priv->_rating;
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp5_ = music_rating_widget_get_item_width (_tmp4_);
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp6_ = _tmp5_;
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp7_ = self->priv->_rating;
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp8_ = music_rating_widget_get_star_spacing (_tmp7_);
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp9_ = _tmp8_;
#line 42 "../src/Widgets/Rating/RatingMenuItem.vala"
	music_rating_widget_set_rating_offset (_tmp3_, (-((gdouble) _tmp6_)) - ((gdouble) _tmp9_));
#line 44 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) self, "state-flags-changed", (GCallback) ___lambda41__gtk_widget_state_flags_changed, self, 0);
#line 37 "../src/Widgets/Rating/RatingMenuItem.vala"
	return self;
#line 225 "RatingMenuItem.c"
}


MusicRatingMenuItem*
music_rating_menu_item_new (void)
{
#line 37 "../src/Widgets/Rating/RatingMenuItem.vala"
	return music_rating_menu_item_construct (MUSIC_TYPE_RATING_MENU_ITEM);
#line 234 "RatingMenuItem.c"
}


static gboolean
music_rating_menu_item_real_motion_notify_event (GtkWidget* base,
                                                 GdkEventMotion* ev)
{
	MusicRatingMenuItem * self;
	gboolean result = FALSE;
	MusicRatingWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MusicRatingWidget* _tmp2_;
#line 53 "../src/Widgets/Rating/RatingMenuItem.vala"
	self = (MusicRatingMenuItem*) base;
#line 53 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 54 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = self->priv->_rating;
#line 54 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_signal_emit_by_name ((GtkWidget*) _tmp0_, "motion-notify-event", ev, &_tmp1_);
#line 55 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp2_ = self->priv->_rating;
#line 55 "../src/Widgets/Rating/RatingMenuItem.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp2_);
#line 56 "../src/Widgets/Rating/RatingMenuItem.vala"
	result = TRUE;
#line 56 "../src/Widgets/Rating/RatingMenuItem.vala"
	return result;
#line 263 "RatingMenuItem.c"
}


static gboolean
music_rating_menu_item_real_button_press_event (GtkWidget* base,
                                                GdkEventButton* ev)
{
	MusicRatingMenuItem * self;
	gboolean result = FALSE;
	MusicRatingWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 59 "../src/Widgets/Rating/RatingMenuItem.vala"
	self = (MusicRatingMenuItem*) base;
#line 59 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 60 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = self->priv->_rating;
#line 60 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_signal_emit_by_name ((GtkWidget*) _tmp0_, "button-press-event", ev, &_tmp1_);
#line 61 "../src/Widgets/Rating/RatingMenuItem.vala"
	gtk_menu_item_activate ((GtkMenuItem*) self);
#line 62 "../src/Widgets/Rating/RatingMenuItem.vala"
	result = TRUE;
#line 62 "../src/Widgets/Rating/RatingMenuItem.vala"
	return result;
#line 289 "RatingMenuItem.c"
}


static gboolean
music_rating_menu_item_real_leave_notify_event (GtkWidget* base,
                                                GdkEventCrossing* ev)
{
	MusicRatingMenuItem * self;
	gboolean result = FALSE;
	MusicRatingWidget* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 65 "../src/Widgets/Rating/RatingMenuItem.vala"
	self = (MusicRatingMenuItem*) base;
#line 65 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 66 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = self->priv->_rating;
#line 66 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp1_ = music_rating_menu_item_get_rating_value (self);
#line 66 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/Widgets/Rating/RatingMenuItem.vala"
	music_rating_widget_update_rating (_tmp0_, _tmp2_);
#line 67 "../src/Widgets/Rating/RatingMenuItem.vala"
	result = TRUE;
#line 67 "../src/Widgets/Rating/RatingMenuItem.vala"
	return result;
#line 318 "RatingMenuItem.c"
}


MusicRatingWidget*
music_rating_menu_item_get_rating (MusicRatingMenuItem* self)
{
	MusicRatingWidget* result;
	MusicRatingWidget* _tmp0_;
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = self->priv->_rating;
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	return result;
#line 335 "RatingMenuItem.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 344 "RatingMenuItem.c"
}


static void
music_rating_menu_item_set_rating (MusicRatingMenuItem* self,
                                   MusicRatingWidget* value)
{
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	if (music_rating_menu_item_get_rating (self) != value) {
#line 356 "RatingMenuItem.c"
		MusicRatingWidget* _tmp0_;
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
		_g_object_unref0 (self->priv->_rating);
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
		self->priv->_rating = _tmp0_;
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, music_rating_menu_item_properties[MUSIC_RATING_MENU_ITEM_RATING_PROPERTY]);
#line 366 "RatingMenuItem.c"
	}
}


gint
music_rating_menu_item_get_rating_value (MusicRatingMenuItem* self)
{
	gint result;
	MusicRatingWidget* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 33 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = self->priv->_rating;
#line 33 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp1_ = music_rating_widget_get_rating (_tmp0_);
#line 33 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp2_ = _tmp1_;
#line 33 "../src/Widgets/Rating/RatingMenuItem.vala"
	result = _tmp2_;
#line 33 "../src/Widgets/Rating/RatingMenuItem.vala"
	return result;
#line 390 "RatingMenuItem.c"
}


void
music_rating_menu_item_set_rating_value (MusicRatingMenuItem* self,
                                         gint value)
{
	MusicRatingWidget* _tmp0_;
#line 34 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/Rating/RatingMenuItem.vala"
	_tmp0_ = self->priv->_rating;
#line 34 "../src/Widgets/Rating/RatingMenuItem.vala"
	music_rating_widget_set_rating (_tmp0_, value);
#line 34 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_object_notify_by_pspec ((GObject *) self, music_rating_menu_item_properties[MUSIC_RATING_MENU_ITEM_RATING_VALUE_PROPERTY]);
#line 407 "RatingMenuItem.c"
}


static void
music_rating_menu_item_class_init (MusicRatingMenuItemClass * klass)
{
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	music_rating_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &MusicRatingMenuItem_private_offset);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*) (GtkWidget*, GdkEventMotion*)) music_rating_menu_item_real_motion_notify_event;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) music_rating_menu_item_real_button_press_event;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) music_rating_menu_item_real_leave_notify_event;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_rating_menu_item_get_property;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_rating_menu_item_set_property;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = music_rating_menu_item_finalize;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_MENU_ITEM_RATING_PROPERTY, music_rating_menu_item_properties[MUSIC_RATING_MENU_ITEM_RATING_PROPERTY] = g_param_spec_object ("rating", "rating", "rating", MUSIC_TYPE_RATING_WIDGET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_RATING_MENU_ITEM_RATING_VALUE_PROPERTY, music_rating_menu_item_properties[MUSIC_RATING_MENU_ITEM_RATING_VALUE_PROPERTY] = g_param_spec_int ("rating-value", "rating-value", "rating-value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 434 "RatingMenuItem.c"
}


static void
music_rating_menu_item_instance_init (MusicRatingMenuItem * self)
{
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	self->priv = music_rating_menu_item_get_instance_private (self);
#line 443 "RatingMenuItem.c"
}


static void
music_rating_menu_item_finalize (GObject * obj)
{
	MusicRatingMenuItem * self;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItem);
#line 30 "../src/Widgets/Rating/RatingMenuItem.vala"
	_g_object_unref0 (self->priv->_rating);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	G_OBJECT_CLASS (music_rating_menu_item_parent_class)->finalize (obj);
#line 457 "RatingMenuItem.c"
}


GType
music_rating_menu_item_get_type (void)
{
	static volatile gsize music_rating_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&music_rating_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MusicRatingMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_rating_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicRatingMenuItem), 0, (GInstanceInitFunc) music_rating_menu_item_instance_init, NULL };
		GType music_rating_menu_item_type_id;
		music_rating_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "MusicRatingMenuItem", &g_define_type_info, 0);
		MusicRatingMenuItem_private_offset = g_type_add_instance_private (music_rating_menu_item_type_id, sizeof (MusicRatingMenuItemPrivate));
		g_once_init_leave (&music_rating_menu_item_type_id__volatile, music_rating_menu_item_type_id);
	}
	return music_rating_menu_item_type_id__volatile;
}


static void
_vala_music_rating_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicRatingMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItem);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	switch (property_id) {
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		case MUSIC_RATING_MENU_ITEM_RATING_PROPERTY:
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		g_value_set_object (value, music_rating_menu_item_get_rating (self));
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		break;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		case MUSIC_RATING_MENU_ITEM_RATING_VALUE_PROPERTY:
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		g_value_set_int (value, music_rating_menu_item_get_rating_value (self));
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		break;
#line 498 "RatingMenuItem.c"
		default:
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		break;
#line 504 "RatingMenuItem.c"
	}
}


static void
_vala_music_rating_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicRatingMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_RATING_MENU_ITEM, MusicRatingMenuItem);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
	switch (property_id) {
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		case MUSIC_RATING_MENU_ITEM_RATING_PROPERTY:
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		music_rating_menu_item_set_rating (self, g_value_get_object (value));
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		break;
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		case MUSIC_RATING_MENU_ITEM_RATING_VALUE_PROPERTY:
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		music_rating_menu_item_set_rating_value (self, g_value_get_int (value));
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		break;
#line 531 "RatingMenuItem.c"
		default:
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/Rating/RatingMenuItem.vala"
		break;
#line 537 "RatingMenuItem.c"
	}
}



