/* AudioPlayerDevice.c generated by valac 0.42.6, the Vala compiler
 * generated from AudioPlayerDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "music-lib.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>


#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (noise_plugins_audio_player_device_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))

typedef struct _NoisePluginsAudioPlayerDevice NoisePluginsAudioPlayerDevice;
typedef struct _NoisePluginsAudioPlayerDeviceClass NoisePluginsAudioPlayerDeviceClass;
typedef struct _NoisePluginsAudioPlayerDevicePrivate NoisePluginsAudioPlayerDevicePrivate;

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (noise_plugins_audio_player_library_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))

typedef struct _NoisePluginsAudioPlayerLibrary NoisePluginsAudioPlayerLibrary;
typedef struct _NoisePluginsAudioPlayerLibraryClass NoisePluginsAudioPlayerLibraryClass;
enum  {
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_0_PROPERTY,
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_audio_player_device_properties[NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NoisePluginsAudioPlayerLibraryPrivate NoisePluginsAudioPlayerLibraryPrivate;
typedef struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData;

struct _NoisePluginsAudioPlayerDevice {
	GObject parent_instance;
	NoisePluginsAudioPlayerDevicePrivate * priv;
};

struct _NoisePluginsAudioPlayerDeviceClass {
	GObjectClass parent_class;
};

struct _NoisePluginsAudioPlayerDevicePrivate {
	GMount* mount;
	GIcon* icon;
	gboolean is_androphone;
	GeeLinkedList* music_folders;
	NoisePluginsAudioPlayerLibrary* library;
};

struct _NoisePluginsAudioPlayerLibrary {
	NoiseLibrary parent_instance;
	NoisePluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	NoiseGStreamerTagger* tagger;
};

struct _NoisePluginsAudioPlayerLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoisePluginsAudioPlayerDevice* self;
	gboolean _tmp0_;
	GeeLinkedList* _tmp1_;
	GMount* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* file;
	GMount* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GFileInputStream* _tmp19_;
	GFile* _tmp20_;
	GFileInputStream* _tmp21_;
	GDataInputStream* dis;
	GDataInputStream* _tmp22_;
	gchar* line;
	gchar* _tmp23_;
	GDataInputStream* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* folders_unparsed;
	const gchar* _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar** _tmp37_;
	gchar** _tmp38_;
	gchar** folder_collection;
	gint folder_collection_length1;
	gint _folder_collection_size_;
	gint folder_it;
	gchar* _tmp39_;
	gchar* folder;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GeeLinkedList* _tmp42_;
	GMount* _tmp43_;
	GFile* _tmp44_;
	GFile* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GError* e;
	FILE* _tmp53_;
	GError* _tmp54_;
	const gchar* _tmp55_;
	GeeLinkedList* files;
	GeeLinkedList* _tmp56_;
	gint items;
	GeeLinkedList* _folder_list;
	GeeLinkedList* _tmp57_;
	GeeLinkedList* _tmp58_;
	gint _folder_size;
	GeeLinkedList* _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _folder_index;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	gchar* _vala1_folder;
	GeeLinkedList* _tmp65_;
	gint _tmp66_;
	gpointer _tmp67_;
	GFile* music_folder_file;
	const gchar* _tmp68_;
	GFile* _tmp69_;
	gint _tmp70_;
	GFile* _tmp71_;
	GeeLinkedList* _tmp72_;
	gint _tmp73_;
	NoisePluginsAudioPlayerLibrary* _tmp74_;
	NoiseGStreamerTagger* _tmp75_;
	GeeLinkedList* _tmp76_;
	GeeLinkedList* _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	NoisePluginsAudioPlayerLibrary* _tmp80_;
	GError* _inner_error0_;
};


static gint NoisePluginsAudioPlayerDevice_private_offset;
static gpointer noise_plugins_audio_player_device_parent_class = NULL;
static NoiseDeviceIface * noise_plugins_audio_player_device_noise_device_parent_iface = NULL;
static GType noise_plugins_audio_player_device_type_id = 0;

GType noise_plugins_audio_player_device_register_type (GTypeModule * module);
GType noise_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
GType noise_plugins_audio_player_library_register_type (GTypeModule * module);
GType noise_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_new (GMount* mount,
                                                                      gboolean is_androphone);
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_construct (GType object_type,
                                                                            GMount* mount,
                                                                            gboolean is_androphone);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_construct (GType object_type,
                                                                              NoisePluginsAudioPlayerDevice* device);
static void noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base);
static void __lambda8_ (NoisePluginsAudioPlayerDevice* self);
static void ___lambda8__noise_device_device_unmounted (NoiseDevice* _sender,
                                                gpointer self);
static void noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self,
                                                                     GAsyncResult* _res_);
static gboolean noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base);
static void noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data);
static void noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                        GAsyncResult *res,
                                                                                        void *user_data);
static gboolean noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_);
void noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self);
static gboolean __lambda9_ (NoisePluginsAudioPlayerDevice* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static NoiseLibrary* noise_plugins_audio_player_device_real_get_library (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_empty_device_title (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_empty_device_description (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_content_type (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_display_name (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_display_name (NoiseDevice* base,
                                                              const gchar* name);
static gchar* noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base,
                                                       GMount* mount);
static GMount* noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base,
                                                      GIcon* icon);
static GIcon* noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base);
gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self);
static guint64 noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_unmount (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_eject (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base);
static GtkWidget* noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_read_only (NoiseDevice* base);
static void noise_plugins_audio_player_device_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
noise_plugins_audio_player_device_get_instance_private (NoisePluginsAudioPlayerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsAudioPlayerDevice_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self ? g_object_ref (self) : NULL;
#line 303 "AudioPlayerDevice.c"
}


NoisePluginsAudioPlayerDevice*
noise_plugins_audio_player_device_construct (GType object_type,
                                             GMount* mount,
                                             gboolean is_androphone)
{
	NoisePluginsAudioPlayerDevice * self = NULL;
	GMount* _tmp0_;
	GeeLinkedList* _tmp1_;
	NoisePluginsAudioPlayerLibrary* _tmp2_;
	NoiseLibrariesManager* _tmp3_;
	NoisePluginsAudioPlayerLibrary* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) g_object_new (object_type, NULL);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp0_;
#line 40 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = is_androphone;
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->music_folders = _tmp1_;
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = noise_plugins_audio_player_library_new (self);
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->library = _tmp2_;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = noise_libraries_manager;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = self->priv->library;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_libraries_manager_add_library (_tmp3_, (NoiseLibrary*) _tmp4_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (is_androphone) {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = "phone";
#line 354 "AudioPlayerDevice.c"
	} else {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = "music-player";
#line 358 "AudioPlayerDevice.c"
	}
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = (GIcon*) _tmp6_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self;
#line 368 "AudioPlayerDevice.c"
}


NoisePluginsAudioPlayerDevice*
noise_plugins_audio_player_device_new (GMount* mount,
                                       gboolean is_androphone)
{
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return noise_plugins_audio_player_device_construct (NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, mount, is_androphone);
#line 378 "AudioPlayerDevice.c"
}


static void
__lambda8_ (NoisePluginsAudioPlayerDevice* self)
{
}


static void
___lambda8__noise_device_device_unmounted (NoiseDevice* _sender,
                                           gpointer self)
{
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	__lambda8_ ((NoisePluginsAudioPlayerDevice*) self);
#line 394 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_signal_connect_object ((NoiseDevice*) self, "device-unmounted", (GCallback) ___lambda8__noise_device_device_unmounted, self, 0);
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_finish_initialization_async (self, NULL, NULL);
#line 408 "AudioPlayerDevice.c"
}


static gboolean
noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 54 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = TRUE;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 423 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = _data;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_slice_free (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData, _data_);
#line 436 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                   GAsyncResult *res,
                                                                                   void *user_data)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _task_data_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 452 "AudioPlayerDevice.c"
	}
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_task_data_->_task_complete_ = TRUE;
#line 456 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	NoisePluginsAudioPlayerDevice* _tmp0_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_slice_new0 (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_callback_ = _callback_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper, _user_data_);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_callback_ == NULL) {
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_task_complete_ = TRUE;
#line 477 "AudioPlayerDevice.c"
	}
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_plugins_audio_player_device_finish_initialization_async_data_free);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->self = _tmp0_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_finish_initialization_async_co (_data_);
#line 487 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self,
                                                                GAsyncResult* _res_)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 498 "AudioPlayerDevice.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 518 "AudioPlayerDevice.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 541 "AudioPlayerDevice.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 545 "AudioPlayerDevice.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 551 "AudioPlayerDevice.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 555 "AudioPlayerDevice.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 559 "AudioPlayerDevice.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 567 "AudioPlayerDevice.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 595 "AudioPlayerDevice.c"
				goto __catch1_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 604 "AudioPlayerDevice.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 618 "AudioPlayerDevice.c"
				goto __catch1_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 629 "AudioPlayerDevice.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 643 "AudioPlayerDevice.c"
	}
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 657 "AudioPlayerDevice.c"
	}
	__finally1:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 668 "AudioPlayerDevice.c"
	}
}


static gboolean
__lambda9_ (NoisePluginsAudioPlayerDevice* self)
{
	gboolean result = FALSE;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 681 "AudioPlayerDevice.c"
}


static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((NoisePluginsAudioPlayerDevice*) self);
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 692 "AudioPlayerDevice.c"
}


static gboolean
noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_)
{
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	switch (_data_->_state_) {
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		case 0:
#line 703 "AudioPlayerDevice.c"
		goto _state_0;
		default:
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_assert_not_reached ();
#line 708 "AudioPlayerDevice.c"
	}
	_state_0:
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp0_ = _data_->self->priv->is_androphone;
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_tmp0_) {
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp1_ = _data_->self->priv->music_folders;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp2_ = _data_->self->priv->mount;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp3_ = g_mount_get_root (_data_->_tmp2_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp5_ = g_file_get_uri (_data_->_tmp4_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp7_ = g_strconcat (_data_->_tmp6_, "/Music/", NULL);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp1_, _data_->_tmp8_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp8_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp6_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 739 "AudioPlayerDevice.c"
	} else {
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp9_ = _data_->self->priv->mount;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp10_ = g_mount_get_root (_data_->_tmp9_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp12_ = g_file_get_uri (_data_->_tmp11_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp14_ = g_strconcat (_data_->_tmp13_, "/.is_audio_player", NULL);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp16_ = g_file_new_for_uri (_data_->_tmp15_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp15_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp13_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp11_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->file = _data_->_tmp17_;
#line 767 "AudioPlayerDevice.c"
		{
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp18_ = _data_->file;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (g_file_query_exists (_data_->_tmp18_, NULL) == TRUE) {
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp20_ = _data_->file;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp21_ = g_file_read (_data_->_tmp20_, NULL, &_data_->_inner_error0_);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp19_ = _data_->_tmp21_;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 781 "AudioPlayerDevice.c"
					goto __catch0_g_error;
				}
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp22_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp19_);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->dis = _data_->_tmp22_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp24_ = _data_->dis;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp25_ = g_data_input_stream_read_line (_data_->_tmp24_, NULL, NULL, &_data_->_inner_error0_);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp23_ = _data_->_tmp25_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->line);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->dis);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->_tmp19_);
#line 804 "AudioPlayerDevice.c"
						goto __catch0_g_error;
					}
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp26_ = _data_->_tmp23_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp23_ = NULL;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->line);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->line = _data_->_tmp26_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp27_ = _data_->line;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_data_->_tmp27_ != NULL)) {
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->_tmp23_);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 823 "AudioPlayerDevice.c"
					}
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp28_ = _data_->line;
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (string_contains (_data_->_tmp28_, "audio_folders=")) {
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp29_ = _data_->line;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31_ = _data_->_tmp30_ = g_strsplit (_data_->_tmp29_, "audio_folders=", 2);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp32_ = _data_->_tmp31_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp32__length1 = _vala_array_length (_data_->_tmp30_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp33_ = _data_->_tmp32_[1];
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp34_ = g_strdup (_data_->_tmp33_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp35_ = _data_->_tmp34_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp32_ = (_vala_array_free (_data_->_tmp32_, _data_->_tmp32__length1, (GDestroyNotify) g_free), NULL);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->folders_unparsed = _data_->_tmp35_;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp36_ = _data_->folders_unparsed;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp38_ = _data_->_tmp37_ = g_strsplit (_data_->_tmp36_, ",", 0);
#line 851 "AudioPlayerDevice.c"
						{
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = 0;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->_folder_collection_size_ = 0;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = _data_->_tmp38_;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = _vala_array_length (_data_->_tmp37_);
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (_data_->folder_it = 0; _data_->folder_it < _vala_array_length (_data_->_tmp37_); _data_->folder_it = _data_->folder_it + 1) {
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->_tmp39_ = g_strdup (_data_->folder_collection[_data_->folder_it]);
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->folder = _data_->_tmp39_;
#line 867 "AudioPlayerDevice.c"
								{
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp40_ = _data_->folder;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp41_ = string_replace (_data_->_tmp40_, " ", "");
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->folder = _data_->_tmp41_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp42_ = _data_->self->priv->music_folders;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp43_ = _data_->self->priv->mount;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp44_ = g_mount_get_root (_data_->_tmp43_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp45_ = _data_->_tmp44_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp46_ = g_file_get_uri (_data_->_tmp45_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp47_ = _data_->_tmp46_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp48_ = g_strconcat (_data_->_tmp47_, "/", NULL);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp49_ = _data_->_tmp48_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp50_ = _data_->folder;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp51_ = g_strconcat (_data_->_tmp49_, _data_->_tmp50_, NULL);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp52_ = _data_->_tmp51_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp42_, _data_->_tmp52_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp52_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp49_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp47_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_object_unref0 (_data_->_tmp45_);
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 911 "AudioPlayerDevice.c"
								}
							}
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = (_vala_array_free (_data_->folder_collection, _data_->folder_collection_length1, (GDestroyNotify) g_free), NULL);
#line 916 "AudioPlayerDevice.c"
						}
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->folders_unparsed);
#line 920 "AudioPlayerDevice.c"
					}
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->_tmp23_);
#line 924 "AudioPlayerDevice.c"
				}
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (_data_->line);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->dis);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->_tmp19_);
#line 932 "AudioPlayerDevice.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->e = _data_->_inner_error0_;
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_inner_error0_ = NULL;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp53_ = stderr;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp54_ = _data_->e;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp55_ = _data_->_tmp54_->message;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_data_->_tmp53_, "Error: %s\n", _data_->_tmp55_);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (_data_->e);
#line 952 "AudioPlayerDevice.c"
		}
		__finally0:
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->file);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_object_unref (_data_->_async_result);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return FALSE;
#line 967 "AudioPlayerDevice.c"
		}
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->file);
#line 971 "AudioPlayerDevice.c"
	}
#line 82 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp56_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 82 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->files = _data_->_tmp56_;
#line 83 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->items = 0;
#line 979 "AudioPlayerDevice.c"
	{
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp57_ = _data_->self->priv->music_folders;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp58_ = _g_object_ref0 (_data_->_tmp57_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_list = _data_->_tmp58_;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp59_ = _data_->_folder_list;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp60_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp59_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp61_ = _data_->_tmp60_;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_size = _data_->_tmp61_;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_index = -1;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (TRUE) {
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp62_ = _data_->_folder_index;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_folder_index = _data_->_tmp62_ + 1;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp63_ = _data_->_folder_index;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp64_ = _data_->_folder_size;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (!(_data_->_tmp63_ < _data_->_tmp64_)) {
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				break;
#line 1011 "AudioPlayerDevice.c"
			}
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp65_ = _data_->_folder_list;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp66_ = _data_->_folder_index;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp67_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp65_, _data_->_tmp66_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_vala1_folder = (gchar*) _data_->_tmp67_;
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp68_ = _data_->_vala1_folder;
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp69_ = g_file_new_for_uri (_data_->_tmp68_);
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->music_folder_file = _data_->_tmp69_;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp70_ = _data_->items;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp71_ = _data_->music_folder_file;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp72_ = _data_->files;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->items = _data_->_tmp70_ + noise_file_utils_count_music_files (_data_->_tmp71_, (GeeCollection*) _data_->_tmp72_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->music_folder_file);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (_data_->_vala1_folder);
#line 1039 "AudioPlayerDevice.c"
		}
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_folder_list);
#line 1043 "AudioPlayerDevice.c"
	}
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp73_ = _data_->items;
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_debug ("AudioPlayerDevice.vala:89: found %d items to import\n", _data_->_tmp73_);
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp74_ = _data_->self->priv->library;
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp75_ = _data_->_tmp74_->tagger;
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp76_ = _data_->files;
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_gstreamer_tagger_discoverer_import_media (_data_->_tmp75_, (GeeCollection*) _data_->_tmp76_);
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp77_ = _data_->files;
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp78_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp77_);
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp79_ = _data_->_tmp78_;
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_tmp79_ == 0) {
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp80_ = _data_->self->priv->library;
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		noise_plugins_audio_player_library_queue_finished (_data_->_tmp80_);
#line 1069 "AudioPlayerDevice.c"
	}
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->files);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_state_ != 0) {
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (!_data_->_task_complete_) {
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1083 "AudioPlayerDevice.c"
		}
	}
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_object_unref (_data_->_async_result);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return FALSE;
#line 1090 "AudioPlayerDevice.c"
}


static NoiseLibrary*
noise_plugins_audio_player_device_real_get_library (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	NoiseLibrary* result = NULL;
	NoisePluginsAudioPlayerLibrary* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 100 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->library;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 ((NoiseLibrary*) _tmp0_);
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1111 "AudioPlayerDevice.c"
}


static gchar*
noise_plugins_audio_player_device_real_get_empty_device_title (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 104 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("Empty device!"));
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1129 "AudioPlayerDevice.c"
}


static gchar*
noise_plugins_audio_player_device_real_get_empty_device_description (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 108 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1147 "AudioPlayerDevice.c"
}


static gchar*
noise_plugins_audio_player_device_real_get_content_type (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->is_androphone;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp0_) {
#line 1163 "AudioPlayerDevice.c"
		gchar* _tmp1_;
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup ("android");
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1171 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp2_;
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_strdup ("audioplayer");
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp2_;
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1180 "AudioPlayerDevice.c"
	}
}


static gchar*
noise_plugins_audio_player_device_real_get_display_name (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
	GError* _inner_error0_ = NULL;
#line 119 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->is_androphone;
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp0_) {
#line 1198 "AudioPlayerDevice.c"
		GMount* _tmp1_;
		gchar* _tmp2_;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = self->priv->mount;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_mount_get_name (_tmp1_);
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp2_;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1209 "AudioPlayerDevice.c"
	} else {
		GFile* file = NULL;
		GMount* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* name = NULL;
		GMount* _tmp12_;
		gchar* _tmp13_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = self->priv->mount;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_mount_get_root (_tmp3_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = _tmp6_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = g_strconcat (_tmp7_, "/.is_audio_player", NULL);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp9_ = _tmp8_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp10_ = g_file_new_for_path (_tmp9_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp11_ = _tmp10_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp9_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp7_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file = _tmp11_;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp12_ = self->priv->mount;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp13_ = g_mount_get_name (_tmp12_);
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		name = _tmp13_;
#line 1256 "AudioPlayerDevice.c"
		{
			GFile* _tmp14_;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp14_ = file;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (g_file_query_exists (_tmp14_, NULL) == TRUE) {
#line 1263 "AudioPlayerDevice.c"
				GFileInputStream* _tmp15_ = NULL;
				GFile* _tmp16_;
				GFileInputStream* _tmp17_;
				GDataInputStream* dis = NULL;
				GDataInputStream* _tmp18_;
				gchar* line = NULL;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp16_ = file;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp17_ = g_file_read (_tmp16_, NULL, &_inner_error0_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp15_ = _tmp17_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1278 "AudioPlayerDevice.c"
					goto __catch2_g_error;
				}
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp18_ = g_data_input_stream_new ((GInputStream*) _tmp15_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				dis = _tmp18_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 1287 "AudioPlayerDevice.c"
					gchar* _tmp19_ = NULL;
					GDataInputStream* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp20_ = dis;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp21_ = g_data_input_stream_read_line (_tmp20_, NULL, NULL, &_inner_error0_);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp19_ = _tmp21_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (line);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (dis);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_tmp15_);
#line 1308 "AudioPlayerDevice.c"
						goto __catch2_g_error;
					}
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp22_ = _tmp19_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp19_ = NULL;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (line);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					line = _tmp22_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp23_ = line;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_tmp23_ != NULL)) {
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_tmp19_);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 1327 "AudioPlayerDevice.c"
					}
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp24_ = line;
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (string_contains (_tmp24_, "name=")) {
#line 1333 "AudioPlayerDevice.c"
						gchar* names_unparsed = NULL;
						const gchar* _tmp25_;
						gchar** _tmp26_;
						gchar** _tmp27_;
						gchar** _tmp28_;
						gint _tmp28__length1;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						gchar* _tmp31_;
						const gchar* _tmp32_;
						gchar** _tmp33_;
						gchar** _tmp34_;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp25_ = line;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, "name=", 2);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp28_ = _tmp27_;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp28__length1 = _vala_array_length (_tmp26_);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp29_ = _tmp28_[1];
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp30_ = g_strdup (_tmp29_);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp31_ = _tmp30_;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						names_unparsed = _tmp31_;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp32_ = names_unparsed;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, "\"", 0);
#line 1368 "AudioPlayerDevice.c"
						{
							gchar** names_collection = NULL;
							gint names_collection_length1 = 0;
							gint _names_collection_size_ = 0;
							gint names_it = 0;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = _tmp34_;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection_length1 = _vala_array_length (_tmp33_);
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (names_it = 0; names_it < _vala_array_length (_tmp33_); names_it = names_it + 1) {
#line 1380 "AudioPlayerDevice.c"
								gchar* _tmp35_;
								gchar* names = NULL;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_tmp35_ = g_strdup (names_collection[names_it]);
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								names = _tmp35_;
#line 1387 "AudioPlayerDevice.c"
								{
									gboolean _tmp36_ = FALSE;
									const gchar* _tmp37_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_tmp37_ = names;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp37_ != NULL) {
#line 1395 "AudioPlayerDevice.c"
										const gchar* _tmp38_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp38_ = names;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp36_ = g_strcmp0 (_tmp38_, "") != 0;
#line 1401 "AudioPlayerDevice.c"
									} else {
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp36_ = FALSE;
#line 1405 "AudioPlayerDevice.c"
									}
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp36_) {
#line 1409 "AudioPlayerDevice.c"
										const gchar* _tmp39_;
										gchar* _tmp40_;
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp39_ = names;
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp40_ = g_strdup (_tmp39_);
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_g_free0 (name);
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										name = _tmp40_;
#line 1420 "AudioPlayerDevice.c"
									}
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (names);
#line 1424 "AudioPlayerDevice.c"
								}
							}
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = (_vala_array_free (names_collection, names_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1429 "AudioPlayerDevice.c"
						}
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (names_unparsed);
#line 1433 "AudioPlayerDevice.c"
					}
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_tmp19_);
#line 1437 "AudioPlayerDevice.c"
				}
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (line);
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (dis);
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_tmp15_);
#line 1445 "AudioPlayerDevice.c"
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			FILE* _tmp41_;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			e = _inner_error0_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_inner_error0_ = NULL;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp41_ = stderr;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp42_ = e;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp43_ = _tmp42_->message;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_tmp41_, "Error: %s\n", _tmp43_);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (e);
#line 1469 "AudioPlayerDevice.c"
		}
		__finally2:
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (name);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (file);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_inner_error0_);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return NULL;
#line 1484 "AudioPlayerDevice.c"
		}
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = name;
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file);
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1492 "AudioPlayerDevice.c"
	}
}


static void
noise_plugins_audio_player_device_real_set_display_name (NoiseDevice* base,
                                                         const gchar* name)
{
	NoisePluginsAudioPlayerDevice * self;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (name != NULL);
#line 1506 "AudioPlayerDevice.c"
}


static gchar*
noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gboolean _tmp0_;
#line 151 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->is_androphone;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_tmp0_) {
#line 1522 "AudioPlayerDevice.c"
		gchar* _tmp1_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup (_ ("Android Phone"));
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1530 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp2_;
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_strdup (_ ("Audio Player"));
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp2_;
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1539 "AudioPlayerDevice.c"
	}
}


static void
noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base,
                                                  GMount* mount)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (mount != NULL);
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp0_;
#line 1560 "AudioPlayerDevice.c"
}


static GMount*
noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* result = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
#line 163 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1581 "AudioPlayerDevice.c"
}


static gchar*
noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 167 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = g_mount_get_default_location (_tmp0_);
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = _tmp1_;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = g_file_get_uri (_tmp2_);
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = _tmp3_;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_tmp2_);
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp4_;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1613 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base,
                                                 GIcon* icon)
{
	NoisePluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (icon != NULL);
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (icon);
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = _tmp0_;
#line 1633 "AudioPlayerDevice.c"
}


static GIcon*
noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GIcon* result = NULL;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
#line 175 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->icon;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1654 "AudioPlayerDevice.c"
}


static guint64
noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	guint64 _tmp10_;
	GError* _inner_error0_ = NULL;
#line 179 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1670 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1699 "AudioPlayerDevice.c"
			goto __catch3_g_error;
		}
#line 184 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1706 "AudioPlayerDevice.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error0_;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error0_ = NULL;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = stdout;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = err;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_->message;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp6_, "Error calculating capacity of iPod: %s\n", _tmp8_);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1729 "AudioPlayerDevice.c"
	}
	__finally3:
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1734 "AudioPlayerDevice.c"
		guint64 _tmp9_ = 0ULL;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error0_);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp9_;
#line 1742 "AudioPlayerDevice.c"
	}
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp10_ = rv;
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (guint64) _tmp10_;
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1750 "AudioPlayerDevice.c"
}


static gchar*
noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 192 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 193 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_format_size_full (noise_device_get_capacity ((NoiseDevice*) self), G_FORMAT_SIZE_DEFAULT);
#line 193 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 193 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1768 "AudioPlayerDevice.c"
}


static guint64
noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
#line 196 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 197 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = noise_device_get_capacity ((NoiseDevice*) self) - noise_device_get_free_space ((NoiseDevice*) self);
#line 197 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1783 "AudioPlayerDevice.c"
}


gchar*
noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self)
{
	gchar* result = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->music_folders;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (gchar*) _tmp1_;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1803 "AudioPlayerDevice.c"
}


static guint64
noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
#line 204 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 205 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1818 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1847 "AudioPlayerDevice.c"
			goto __catch4_g_error;
		}
#line 209 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1854 "AudioPlayerDevice.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error0_;
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error0_ = NULL;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = stdout;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = err;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_->message;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp6_, "Error calculating free space on iPod: %s\n", _tmp8_);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1877 "AudioPlayerDevice.c"
	}
	__finally4:
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1882 "AudioPlayerDevice.c"
		guint64 _tmp9_ = 0ULL;
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error0_);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp9_;
#line 1890 "AudioPlayerDevice.c"
	}
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = rv;
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1896 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_real_unmount (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 217 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 218 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 218 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 1911 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_real_eject (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 221 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 222 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 222 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (g_mount_can_eject (_tmp0_)) {
#line 1926 "AudioPlayerDevice.c"
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = self->priv->mount;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_mount_get_volume (_tmp1_);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_volume_get_drive (_tmp3_);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 1948 "AudioPlayerDevice.c"
	}
}


static void
noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 1959 "AudioPlayerDevice.c"
}


static gboolean
noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1974 "AudioPlayerDevice.c"
}


static GtkWidget*
noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GtkWidget* result = NULL;
#line 235 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = NULL;
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1989 "AudioPlayerDevice.c"
}


static gboolean
noise_plugins_audio_player_device_real_read_only (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 239 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 240 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 240 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 2004 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_class_init (NoisePluginsAudioPlayerDeviceClass * klass)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_type_class_adjust_private_offset (klass, &NoisePluginsAudioPlayerDevice_private_offset);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_audio_player_device_finalize;
#line 2017 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_noise_device_interface_init (NoiseDeviceIface * iface)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_noise_device_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->finish_initialization = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_finish_initialization;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->start_initialization = (gboolean (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_start_initialization;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_library = (NoiseLibrary* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_library;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_empty_device_title = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_empty_device_title;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_empty_device_description = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_empty_device_description;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_content_type = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_content_type;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_display_name = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_display_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_display_name = (void (*) (NoiseDevice*, const gchar*)) noise_plugins_audio_player_device_real_set_display_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_description = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_fancy_description;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_mount = (void (*) (NoiseDevice*, GMount*)) noise_plugins_audio_player_device_real_set_mount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_mount = (GMount* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_mount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_uri = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_uri;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_icon = (void (*) (NoiseDevice*, GIcon*)) noise_plugins_audio_player_device_real_set_icon;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_icon = (GIcon* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_icon;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_capacity = (guint64 (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_capacity;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_capacity = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_fancy_capacity;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_used_space = (guint64 (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_used_space;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_free_space = (guint64 (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_free_space;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->unmount = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_unmount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->eject = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_eject;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->synchronize = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_synchronize;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->only_use_custom_view = (gboolean (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_only_use_custom_view;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_custom_view = (GtkWidget* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_custom_view;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->read_only = (gboolean (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_read_only;
#line 2074 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_instance_init (NoisePluginsAudioPlayerDevice * self)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv = noise_plugins_audio_player_device_get_instance_private (self);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = FALSE;
#line 2085 "AudioPlayerDevice.c"
}


static void
noise_plugins_audio_player_device_finalize (GObject * obj)
{
	NoisePluginsAudioPlayerDevice * self;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice);
#line 31 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 34 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (noise_plugins_audio_player_device_parent_class)->finalize (obj);
#line 2105 "AudioPlayerDevice.c"
}


GType
noise_plugins_audio_player_device_get_type (void)
{
	return noise_plugins_audio_player_device_type_id;
}


GType
noise_plugins_audio_player_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsAudioPlayerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_audio_player_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsAudioPlayerDevice), 0, (GInstanceInitFunc) noise_plugins_audio_player_device_instance_init, NULL };
	static const GInterfaceInfo noise_device_info = { (GInterfaceInitFunc) noise_plugins_audio_player_device_noise_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_audio_player_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsAudioPlayerDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_audio_player_device_type_id, NOISE_TYPE_DEVICE, &noise_device_info);
	NoisePluginsAudioPlayerDevice_private_offset = sizeof (NoisePluginsAudioPlayerDevicePrivate);
	return noise_plugins_audio_player_device_type_id;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



