/* CDDA.c generated by valac 0.42.6, the Vala compiler
 * generated from CDDA.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include "io.elementary.music-core.h"


#define NOISE_TYPE_CDDA (noise_cdda_get_type ())
#define NOISE_CDDA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CDDA, NoiseCDDA))
#define NOISE_CDDA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CDDA, NoiseCDDAClass))
#define NOISE_IS_CDDA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CDDA))
#define NOISE_IS_CDDA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CDDA))
#define NOISE_CDDA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CDDA, NoiseCDDAClass))

typedef struct _NoiseCDDA NoiseCDDA;
typedef struct _NoiseCDDAClass NoiseCDDAClass;
typedef struct _NoiseCDDAPrivate NoiseCDDAPrivate;
enum  {
	NOISE_CDDA_0_PROPERTY,
	NOISE_CDDA_NUM_PROPERTIES
};
static GParamSpec* noise_cdda_properties[NOISE_CDDA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseCDDA {
	GObject parent_instance;
	NoiseCDDAPrivate * priv;
};

struct _NoiseCDDAClass {
	GObjectClass parent_class;
};


static gpointer noise_cdda_parent_class = NULL;
static GType noise_cdda_type_id = 0;

GType noise_cdda_register_type (GTypeModule * module);
GType noise_cdda_get_type (void) G_GNUC_CONST;
#define NOISE_CDDA_FILE_ATTRIBUTE_TITLE "xattr::org.gnome.audio.title"
#define NOISE_CDDA_FILE_ATTRIBUTE_ARTIST "xattr::org.gnome.audio.artist"
#define NOISE_CDDA_FILE_ATTRIBUTE_GENRE "xattr::org.gnome.audio.genre"
#define NOISE_CDDA_FILE_ATTRIBUTE_DURATION "xattr::org.gnome.audio.duration"
GeeLinkedList* noise_cdda_getMediaList (GFile* device_file);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add6 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
NoiseCDDA* noise_cdda_new (void);
NoiseCDDA* noise_cdda_construct (GType object_type);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
	if ((*length) == (*size)) {
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 129 "CDDA.c"
	}
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[(*length)++] = value;
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[*length] = NULL;
#line 135 "CDDA.c"
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
	if ((*length) == (*size)) {
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 151 "CDDA.c"
	}
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[(*length)++] = value;
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[*length] = NULL;
#line 157 "CDDA.c"
}


static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
	if ((*length) == (*size)) {
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 173 "CDDA.c"
	}
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[(*length)++] = value;
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[*length] = NULL;
#line 179 "CDDA.c"
}


static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
	if ((*length) == (*size)) {
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 195 "CDDA.c"
	}
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[(*length)++] = value;
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[*length] = NULL;
#line 201 "CDDA.c"
}


static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
	if ((*length) == (*size)) {
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 217 "CDDA.c"
	}
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[(*length)++] = value;
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[*length] = NULL;
#line 223 "CDDA.c"
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 238 "CDDA.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 242 "CDDA.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 248 "CDDA.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 253 "CDDA.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 259 "CDDA.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 263 "CDDA.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 267 "CDDA.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 271 "CDDA.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 275 "CDDA.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 279 "CDDA.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gsize _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		const gchar* res = NULL;
		gsize _tmp27_;
		void* _tmp28_;
		void* ptr = NULL;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		void* _tmp31_;
		const gchar* _tmp44_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 298 "CDDA.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 307 "CDDA.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 316 "CDDA.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 322 "CDDA.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 328 "CDDA.c"
					gint _tmp8_;
#line 1154 "glib-2.0.vapi"
					_tmp8_ = i;
#line 1154 "glib-2.0.vapi"
					_tmp7_ = _tmp8_ < str_array_length1;
#line 334 "CDDA.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 338 "CDDA.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 344 "CDDA.c"
				} else {
					gboolean _tmp9_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 349 "CDDA.c"
						gint _tmp10_;
						const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
						_tmp10_ = i;
#line 1154 "glib-2.0.vapi"
						_tmp11_ = str_array[_tmp10_];
#line 1154 "glib-2.0.vapi"
						_tmp9_ = _tmp11_ != NULL;
#line 358 "CDDA.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp9_ = FALSE;
#line 362 "CDDA.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp9_;
#line 366 "CDDA.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 372 "CDDA.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp13_ = i;
#line 1155 "glib-2.0.vapi"
				_tmp14_ = str_array[_tmp13_];
#line 1155 "glib-2.0.vapi"
				if (_tmp14_ != NULL) {
#line 380 "CDDA.c"
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
#line 1155 "glib-2.0.vapi"
					_tmp15_ = i;
#line 1155 "glib-2.0.vapi"
					_tmp16_ = str_array[_tmp15_];
#line 1155 "glib-2.0.vapi"
					_tmp17_ = strlen ((const gchar*) _tmp16_);
#line 1155 "glib-2.0.vapi"
					_tmp18_ = _tmp17_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = _tmp18_;
#line 395 "CDDA.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp12_ = 0;
#line 399 "CDDA.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp19_ = len;
#line 1155 "glib-2.0.vapi"
				len = _tmp19_ + _tmp12_;
#line 405 "CDDA.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		_tmp20_ = i;
#line 1157 "glib-2.0.vapi"
		if (_tmp20_ == 0) {
#line 412 "CDDA.c"
			gchar* _tmp21_;
#line 1158 "glib-2.0.vapi"
			_tmp21_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp21_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 420 "CDDA.c"
		}
#line 1160 "glib-2.0.vapi"
		_tmp22_ = i;
#line 1160 "glib-2.0.vapi"
		str_array_length1 = _tmp22_;
#line 1161 "glib-2.0.vapi"
		_tmp23_ = len;
#line 1161 "glib-2.0.vapi"
		_tmp24_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp25_ = _tmp24_;
#line 1161 "glib-2.0.vapi"
		_tmp26_ = i;
#line 1161 "glib-2.0.vapi"
		len = _tmp23_ + (_tmp25_ * (_tmp26_ - 1));
#line 1163 "glib-2.0.vapi"
		_tmp27_ = len;
#line 1163 "glib-2.0.vapi"
		_tmp28_ = g_malloc (_tmp27_);
#line 1163 "glib-2.0.vapi"
		res = _tmp28_;
#line 1164 "glib-2.0.vapi"
		_tmp29_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp30_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp31_ = g_stpcpy ((void*) _tmp29_, (const gchar*) _tmp30_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp31_;
#line 450 "CDDA.c"
		{
			gboolean _tmp32_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp32_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 459 "CDDA.c"
				gint _tmp34_;
				void* _tmp35_;
				void* _tmp36_;
				const gchar* _tmp37_ = NULL;
				gint _tmp38_;
				const gchar* _tmp39_;
				void* _tmp42_;
				void* _tmp43_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp32_) {
#line 470 "CDDA.c"
					gint _tmp33_;
#line 1165 "glib-2.0.vapi"
					_tmp33_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp33_ + 1;
#line 476 "CDDA.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp32_ = FALSE;
#line 1165 "glib-2.0.vapi"
				_tmp34_ = i;
#line 1165 "glib-2.0.vapi"
				if (!(_tmp34_ < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 486 "CDDA.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp35_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp36_ = g_stpcpy (_tmp35_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp36_;
#line 1167 "glib-2.0.vapi"
				_tmp38_ = i;
#line 1167 "glib-2.0.vapi"
				_tmp39_ = str_array[_tmp38_];
#line 1167 "glib-2.0.vapi"
				if (_tmp39_ != NULL) {
#line 500 "CDDA.c"
					gint _tmp40_;
					const gchar* _tmp41_;
#line 1167 "glib-2.0.vapi"
					_tmp40_ = i;
#line 1167 "glib-2.0.vapi"
					_tmp41_ = str_array[_tmp40_];
#line 1167 "glib-2.0.vapi"
					_tmp37_ = (const gchar*) _tmp41_;
#line 509 "CDDA.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp37_ = "";
#line 513 "CDDA.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp42_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp43_ = g_stpcpy (_tmp42_, _tmp37_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp43_;
#line 521 "CDDA.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp44_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp44_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 532 "CDDA.c"
	} else {
		gchar* _tmp45_;
#line 1172 "glib-2.0.vapi"
		_tmp45_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp45_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 541 "CDDA.c"
	}
}


static void
_vala_array_add6 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
	if ((*length) == (*size)) {
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 558 "CDDA.c"
	}
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[(*length)++] = value;
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
	(*array)[*length] = NULL;
#line 564 "CDDA.c"
}


GeeLinkedList*
noise_cdda_getMediaList (GFile* device_file)
{
	GeeLinkedList* result = NULL;
	GeeLinkedList* rv = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 36 "../plugins/Devices/CDRom/CDDA.vala"
	g_return_val_if_fail (device_file != NULL, NULL);
#line 37 "../plugins/Devices/CDRom/CDDA.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 37 "../plugins/Devices/CDRom/CDDA.vala"
	rv = _tmp0_;
#line 581 "CDDA.c"
	{
		gchar** query_attributes = NULL;
		gchar** _tmp1_;
		gint query_attributes_length1;
		gint _query_attributes_size_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar* _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar* _tmp11_;
		GFileInfo* device_info = NULL;
		gchar** _tmp12_;
		gint _tmp12__length1;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GFileInfo* _tmp15_;
		GFileInfo* _tmp16_;
		GFileInfo* _tmp17_;
		gchar* album_name = NULL;
		GFileInfo* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* album_artist = NULL;
		GFileInfo* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* album_genre = NULL;
		GFileInfo* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gboolean valid_album_artist = FALSE;
		const gchar* _tmp30_;
		gboolean valid_album_name = FALSE;
		const gchar* _tmp31_;
		gboolean valid_album_genre = FALSE;
		const gchar* _tmp32_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		gchar* _tmp34_;
		GFileEnumerator* enumerator = NULL;
		gchar** _tmp35_;
		gint _tmp35__length1;
		gchar* _tmp36_;
		gchar* _tmp37_;
		GFileEnumerator* _tmp38_;
		GFileEnumerator* _tmp39_;
		gint index = 0;
		GFileInfo* track_info = NULL;
#line 40 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 40 "../plugins/Devices/CDRom/CDDA.vala"
		query_attributes = _tmp1_;
#line 40 "../plugins/Devices/CDRom/CDDA.vala"
		query_attributes_length1 = 0;
#line 40 "../plugins/Devices/CDRom/CDDA.vala"
		_query_attributes_size_ = query_attributes_length1;
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp2_ = query_attributes;
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp2__length1 = query_attributes_length1;
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp3_ = g_strdup (NOISE_CDDA_FILE_ATTRIBUTE_TITLE);
#line 41 "../plugins/Devices/CDRom/CDDA.vala"
		_vala_array_add1 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp3_);
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp4_ = query_attributes;
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp4__length1 = query_attributes_length1;
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp5_ = g_strdup (NOISE_CDDA_FILE_ATTRIBUTE_ARTIST);
#line 42 "../plugins/Devices/CDRom/CDDA.vala"
		_vala_array_add2 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp5_);
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp6_ = query_attributes;
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp6__length1 = query_attributes_length1;
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp7_ = g_strdup (NOISE_CDDA_FILE_ATTRIBUTE_GENRE);
#line 43 "../plugins/Devices/CDRom/CDDA.vala"
		_vala_array_add3 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp7_);
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp8_ = query_attributes;
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp8__length1 = query_attributes_length1;
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp9_ = g_strdup (NOISE_CDDA_FILE_ATTRIBUTE_DURATION);
#line 44 "../plugins/Devices/CDRom/CDDA.vala"
		_vala_array_add4 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp9_);
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp10_ = query_attributes;
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp10__length1 = query_attributes_length1;
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp11_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 45 "../plugins/Devices/CDRom/CDDA.vala"
		_vala_array_add5 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp11_);
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp12_ = query_attributes;
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp12__length1 = query_attributes_length1;
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp13_ = _vala_g_strjoinv (",", _tmp12_, _tmp12__length1);
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp14_ = _tmp13_;
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp15_ = g_file_query_info (device_file, _tmp14_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp16_ = _tmp15_;
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		_g_free0 (_tmp14_);
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		device_info = _tmp16_;
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../plugins/Devices/CDRom/CDDA.vala"
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
#line 711 "CDDA.c"
			goto __catch0_g_error;
		}
#line 50 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp17_ = device_info;
#line 50 "../plugins/Devices/CDRom/CDDA.vala"
		if (_tmp17_ == NULL) {
#line 51 "../plugins/Devices/CDRom/CDDA.vala"
			g_warning ("CDDA.vala:51: Could not query device attributes");
#line 52 "../plugins/Devices/CDRom/CDDA.vala"
			result = rv;
#line 52 "../plugins/Devices/CDRom/CDDA.vala"
			_g_object_unref0 (device_info);
#line 52 "../plugins/Devices/CDRom/CDDA.vala"
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
#line 52 "../plugins/Devices/CDRom/CDDA.vala"
			return result;
#line 728 "CDDA.c"
		}
#line 55 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp18_ = device_info;
#line 55 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp19_ = g_file_info_get_attribute_string (_tmp18_, NOISE_CDDA_FILE_ATTRIBUTE_TITLE);
#line 55 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 55 "../plugins/Devices/CDRom/CDDA.vala"
		album_name = _tmp20_;
#line 56 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp21_ = device_info;
#line 56 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp22_ = g_file_info_get_attribute_string (_tmp21_, NOISE_CDDA_FILE_ATTRIBUTE_ARTIST);
#line 56 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 56 "../plugins/Devices/CDRom/CDDA.vala"
		album_artist = _tmp23_;
#line 57 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp24_ = device_info;
#line 57 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp25_ = g_file_info_get_attribute_string (_tmp24_, NOISE_CDDA_FILE_ATTRIBUTE_GENRE);
#line 57 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp26_ = g_strdup (_tmp25_);
#line 57 "../plugins/Devices/CDRom/CDDA.vala"
		album_genre = _tmp26_;
#line 59 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp27_ = album_name;
#line 59 "../plugins/Devices/CDRom/CDDA.vala"
		g_message ("CDDA.vala:59: CD ALBUM_NAME: %s", _tmp27_);
#line 60 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp28_ = album_artist;
#line 60 "../plugins/Devices/CDRom/CDDA.vala"
		g_message ("CDDA.vala:60: CD ALBUM_ARTIST: %s", _tmp28_);
#line 61 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp29_ = album_genre;
#line 61 "../plugins/Devices/CDRom/CDDA.vala"
		g_message ("CDDA.vala:61: CD ALBUM_GENRE: %s", _tmp29_);
#line 63 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp30_ = album_artist;
#line 63 "../plugins/Devices/CDRom/CDDA.vala"
		valid_album_artist = noise_media_is_valid_string_field (_tmp30_);
#line 64 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp31_ = album_name;
#line 64 "../plugins/Devices/CDRom/CDDA.vala"
		valid_album_name = noise_media_is_valid_string_field (_tmp31_);
#line 65 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp32_ = album_genre;
#line 65 "../plugins/Devices/CDRom/CDDA.vala"
		valid_album_genre = noise_media_is_valid_string_field (_tmp32_);
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp33_ = query_attributes;
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp33__length1 = query_attributes_length1;
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp34_ = g_strdup (NOISE_CDDA_FILE_ATTRIBUTE_DURATION);
#line 67 "../plugins/Devices/CDRom/CDDA.vala"
		_vala_array_add6 (&query_attributes, &query_attributes_length1, &_query_attributes_size_, _tmp34_);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp35_ = query_attributes;
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp35__length1 = query_attributes_length1;
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp36_ = _vala_g_strjoinv (",", _tmp35_, _tmp35__length1);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp37_ = _tmp36_;
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp38_ = g_file_enumerate_children (device_file, _tmp37_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp39_ = _tmp38_;
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		_g_free0 (_tmp37_);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		enumerator = _tmp39_;
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
			_g_free0 (album_genre);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
			_g_free0 (album_artist);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
			_g_free0 (album_name);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
			_g_object_unref0 (device_info);
#line 68 "../plugins/Devices/CDRom/CDDA.vala"
			query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
#line 814 "CDDA.c"
			goto __catch0_g_error;
		}
#line 71 "../plugins/Devices/CDRom/CDDA.vala"
		index = 1;
#line 819 "CDDA.c"
		{
			GFileInfo* _tmp40_ = NULL;
			GFileEnumerator* _tmp41_;
			GFileInfo* _tmp42_;
			GFileInfo* _tmp43_;
			gboolean _tmp44_ = FALSE;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_tmp41_ = enumerator;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_tmp42_ = g_file_enumerator_next_file (_tmp41_, NULL, &_inner_error0_);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_tmp40_ = _tmp42_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_object_unref0 (track_info);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_object_unref0 (enumerator);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (album_genre);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (album_artist);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (album_name);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_object_unref0 (device_info);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
#line 848 "CDDA.c"
				goto __catch0_g_error;
			}
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_tmp43_ = _tmp40_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_tmp40_ = NULL;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_g_object_unref0 (track_info);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			track_info = _tmp43_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_tmp44_ = TRUE;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			while (TRUE) {
#line 863 "CDDA.c"
				GFileInfo* _tmp49_;
				NoiseMedia* s = NULL;
				GFileEnumerator* _tmp50_;
				GFile* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				GFileInfo* _tmp54_;
				const gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				NoiseMedia* _tmp58_;
				NoiseMedia* _tmp59_;
				NoiseMedia* _tmp60_;
				gboolean _tmp61_;
				gboolean _tmp64_;
				gboolean _tmp67_;
				gchar* title = NULL;
				GFileInfo* _tmp70_;
				const gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* artist = NULL;
				GFileInfo* _tmp73_;
				const gchar* _tmp74_;
				gchar* _tmp75_;
				gchar* genre = NULL;
				GFileInfo* _tmp76_;
				const gchar* _tmp77_;
				gchar* _tmp78_;
				guint64 length = 0ULL;
				GFileInfo* _tmp79_;
				gint _tmp80_;
				NoiseMedia* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
				const gchar* _tmp85_;
				const gchar* _tmp86_;
				const gchar* _tmp87_;
				guint64 _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				NoiseMedia* _tmp91_;
				gint _tmp92_;
				NoiseMedia* _tmp93_;
				guint64 _tmp94_;
				const gchar* _tmp95_;
				const gchar* _tmp98_;
				const gchar* _tmp101_;
				GeeLinkedList* _tmp104_;
				NoiseMedia* _tmp105_;
				gint _tmp106_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				if (!_tmp44_) {
#line 917 "CDDA.c"
					GFileInfo* _tmp45_ = NULL;
					GFileEnumerator* _tmp46_;
					GFileInfo* _tmp47_;
					GFileInfo* _tmp48_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp46_ = enumerator;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp47_ = g_file_enumerator_next_file (_tmp46_, NULL, &_inner_error0_);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp45_ = _tmp47_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_object_unref0 (_tmp40_);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_object_unref0 (track_info);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_object_unref0 (enumerator);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_free0 (album_genre);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_free0 (album_artist);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_free0 (album_name);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						_g_object_unref0 (device_info);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
						query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
#line 946 "CDDA.c"
						goto __catch0_g_error;
					}
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp48_ = _tmp45_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp45_ = NULL;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_g_object_unref0 (track_info);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					track_info = _tmp48_;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					_g_object_unref0 (_tmp45_);
#line 959 "CDDA.c"
				}
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp44_ = FALSE;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp49_ = track_info;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				if (!(_tmp49_ != NULL)) {
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
					break;
#line 969 "CDDA.c"
				}
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp50_ = enumerator;
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp51_ = g_file_enumerator_get_container (_tmp50_);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp52_ = g_file_get_uri (_tmp51_);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp53_ = _tmp52_;
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp54_ = track_info;
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp55_ = g_file_info_get_name (_tmp54_);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp56_ = g_strconcat (_tmp53_, _tmp55_, NULL);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp57_ = _tmp56_;
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp58_ = noise_media_new (_tmp57_);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp59_ = _tmp58_;
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (_tmp57_);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (_tmp53_);
#line 76 "../plugins/Devices/CDRom/CDDA.vala"
				s = _tmp59_;
#line 78 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp60_ = s;
#line 78 "../plugins/Devices/CDRom/CDDA.vala"
				noise_media_set_isTemporary (_tmp60_, TRUE);
#line 80 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp61_ = valid_album_artist;
#line 80 "../plugins/Devices/CDRom/CDDA.vala"
				if (_tmp61_) {
#line 1005 "CDDA.c"
					NoiseMedia* _tmp62_;
					const gchar* _tmp63_;
#line 81 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp62_ = s;
#line 81 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp63_ = album_artist;
#line 81 "../plugins/Devices/CDRom/CDDA.vala"
					noise_media_set_album_artist (_tmp62_, _tmp63_);
#line 1014 "CDDA.c"
				}
#line 83 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp64_ = valid_album_name;
#line 83 "../plugins/Devices/CDRom/CDDA.vala"
				if (_tmp64_) {
#line 1020 "CDDA.c"
					NoiseMedia* _tmp65_;
					const gchar* _tmp66_;
#line 84 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp65_ = s;
#line 84 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp66_ = album_name;
#line 84 "../plugins/Devices/CDRom/CDDA.vala"
					noise_media_set_album (_tmp65_, _tmp66_);
#line 1029 "CDDA.c"
				}
#line 86 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp67_ = valid_album_genre;
#line 86 "../plugins/Devices/CDRom/CDDA.vala"
				if (_tmp67_) {
#line 1035 "CDDA.c"
					NoiseMedia* _tmp68_;
					const gchar* _tmp69_;
#line 87 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp68_ = s;
#line 87 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp69_ = album_genre;
#line 87 "../plugins/Devices/CDRom/CDDA.vala"
					noise_media_set_genre (_tmp68_, _tmp69_);
#line 1044 "CDDA.c"
				}
#line 89 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp70_ = track_info;
#line 89 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp71_ = g_file_info_get_attribute_string (_tmp70_, NOISE_CDDA_FILE_ATTRIBUTE_TITLE);
#line 89 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp72_ = g_strdup (_tmp71_);
#line 89 "../plugins/Devices/CDRom/CDDA.vala"
				title = _tmp72_;
#line 90 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp73_ = track_info;
#line 90 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp74_ = g_file_info_get_attribute_string (_tmp73_, NOISE_CDDA_FILE_ATTRIBUTE_ARTIST);
#line 90 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp75_ = g_strdup (_tmp74_);
#line 90 "../plugins/Devices/CDRom/CDDA.vala"
				artist = _tmp75_;
#line 91 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp76_ = track_info;
#line 91 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp77_ = g_file_info_get_attribute_string (_tmp76_, NOISE_CDDA_FILE_ATTRIBUTE_GENRE);
#line 91 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp78_ = g_strdup (_tmp77_);
#line 91 "../plugins/Devices/CDRom/CDDA.vala"
				genre = _tmp78_;
#line 92 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp79_ = track_info;
#line 92 "../plugins/Devices/CDRom/CDDA.vala"
				length = g_file_info_get_attribute_uint64 (_tmp79_, NOISE_CDDA_FILE_ATTRIBUTE_DURATION);
#line 94 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp80_ = index;
#line 94 "../plugins/Devices/CDRom/CDDA.vala"
				g_debug ("CDDA.vala:94: TRACK #%d\t:", _tmp80_);
#line 95 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp81_ = s;
#line 95 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp82_ = noise_media_get_uri (_tmp81_);
#line 95 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp83_ = _tmp82_;
#line 95 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp84_ = _tmp83_;
#line 95 "../plugins/Devices/CDRom/CDDA.vala"
				g_debug ("CDDA.vala:95:   - TRACK_URI:      %s", _tmp84_);
#line 95 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (_tmp84_);
#line 96 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp85_ = title;
#line 96 "../plugins/Devices/CDRom/CDDA.vala"
				g_debug ("CDDA.vala:96:   - TRACK_TITLE:    %s", _tmp85_);
#line 97 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp86_ = artist;
#line 97 "../plugins/Devices/CDRom/CDDA.vala"
				g_debug ("CDDA.vala:97:   - TRACK_ARTIST:   %s", _tmp86_);
#line 98 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp87_ = genre;
#line 98 "../plugins/Devices/CDRom/CDDA.vala"
				g_debug ("CDDA.vala:98:   - TRACK_GENRE:    %s", _tmp87_);
#line 99 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp88_ = length;
#line 99 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp89_ = g_strdup_printf ("%" G_GUINT64_FORMAT, _tmp88_);
#line 99 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp90_ = _tmp89_;
#line 99 "../plugins/Devices/CDRom/CDDA.vala"
				g_debug ("CDDA.vala:99:   - TRACK_DURATION: %s secs\n", _tmp90_);
#line 99 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (_tmp90_);
#line 101 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp91_ = s;
#line 101 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp92_ = index;
#line 101 "../plugins/Devices/CDRom/CDDA.vala"
				noise_media_set_track (_tmp91_, (guint) _tmp92_);
#line 102 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp93_ = s;
#line 102 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp94_ = length;
#line 102 "../plugins/Devices/CDRom/CDDA.vala"
				noise_media_set_length (_tmp93_, (guint) (_tmp94_ * NOISE_TIME_UTILS_MILI_INV));
#line 104 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp95_ = title;
#line 104 "../plugins/Devices/CDRom/CDDA.vala"
				if (noise_media_is_valid_string_field (_tmp95_)) {
#line 1128 "CDDA.c"
					NoiseMedia* _tmp96_;
					const gchar* _tmp97_;
#line 105 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp96_ = s;
#line 105 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp97_ = title;
#line 105 "../plugins/Devices/CDRom/CDDA.vala"
					noise_media_set_title (_tmp96_, _tmp97_);
#line 1137 "CDDA.c"
				}
#line 107 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp98_ = artist;
#line 107 "../plugins/Devices/CDRom/CDDA.vala"
				if (noise_media_is_valid_string_field (_tmp98_)) {
#line 1143 "CDDA.c"
					NoiseMedia* _tmp99_;
					const gchar* _tmp100_;
#line 108 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp99_ = s;
#line 108 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp100_ = artist;
#line 108 "../plugins/Devices/CDRom/CDDA.vala"
					noise_media_set_artist (_tmp99_, _tmp100_);
#line 1152 "CDDA.c"
				}
#line 110 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp101_ = genre;
#line 110 "../plugins/Devices/CDRom/CDDA.vala"
				if (noise_media_is_valid_string_field (_tmp101_)) {
#line 1158 "CDDA.c"
					NoiseMedia* _tmp102_;
					const gchar* _tmp103_;
#line 111 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp102_ = s;
#line 111 "../plugins/Devices/CDRom/CDDA.vala"
					_tmp103_ = genre;
#line 111 "../plugins/Devices/CDRom/CDDA.vala"
					noise_media_set_genre (_tmp102_, _tmp103_);
#line 1167 "CDDA.c"
				}
#line 125 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp104_ = rv;
#line 125 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp105_ = s;
#line 125 "../plugins/Devices/CDRom/CDDA.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp104_, _tmp105_);
#line 126 "../plugins/Devices/CDRom/CDDA.vala"
				_tmp106_ = index;
#line 126 "../plugins/Devices/CDRom/CDDA.vala"
				index = _tmp106_ + 1;
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (genre);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (artist);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_free0 (title);
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
				_g_object_unref0 (s);
#line 1187 "CDDA.c"
			}
#line 74 "../plugins/Devices/CDRom/CDDA.vala"
			_g_object_unref0 (_tmp40_);
#line 1191 "CDDA.c"
		}
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_object_unref0 (track_info);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_object_unref0 (enumerator);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_free0 (album_genre);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_free0 (album_artist);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_free0 (album_name);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_object_unref0 (device_info);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		query_attributes = (_vala_array_free (query_attributes, query_attributes_length1, (GDestroyNotify) g_free), NULL);
#line 1207 "CDDA.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp107_;
		const gchar* _tmp108_;
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		err = _inner_error0_;
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_inner_error0_ = NULL;
#line 129 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp107_ = err;
#line 129 "../plugins/Devices/CDRom/CDDA.vala"
		_tmp108_ = _tmp107_->message;
#line 129 "../plugins/Devices/CDRom/CDDA.vala"
		g_warning ("CDDA.vala:129: Could not enumerate CD tracks or access album info: %s", _tmp108_);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_error_free0 (err);
#line 1227 "CDDA.c"
	}
	__finally0:
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		_g_object_unref0 (rv);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		g_clear_error (&_inner_error0_);
#line 39 "../plugins/Devices/CDRom/CDDA.vala"
		return NULL;
#line 1240 "CDDA.c"
	}
#line 132 "../plugins/Devices/CDRom/CDDA.vala"
	result = rv;
#line 132 "../plugins/Devices/CDRom/CDDA.vala"
	return result;
#line 1246 "CDDA.c"
}


NoiseCDDA*
noise_cdda_construct (GType object_type)
{
	NoiseCDDA * self = NULL;
#line 30 "../plugins/Devices/CDRom/CDDA.vala"
	self = (NoiseCDDA*) g_object_new (object_type, NULL);
#line 30 "../plugins/Devices/CDRom/CDDA.vala"
	return self;
#line 1258 "CDDA.c"
}


NoiseCDDA*
noise_cdda_new (void)
{
#line 30 "../plugins/Devices/CDRom/CDDA.vala"
	return noise_cdda_construct (NOISE_TYPE_CDDA);
#line 1267 "CDDA.c"
}


static void
noise_cdda_class_init (NoiseCDDAClass * klass)
{
#line 30 "../plugins/Devices/CDRom/CDDA.vala"
	noise_cdda_parent_class = g_type_class_peek_parent (klass);
#line 1276 "CDDA.c"
}


static void
noise_cdda_instance_init (NoiseCDDA * self)
{
}


GType
noise_cdda_get_type (void)
{
	return noise_cdda_type_id;
}


GType
noise_cdda_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoiseCDDAClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_cdda_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseCDDA), 0, (GInstanceInitFunc) noise_cdda_instance_init, NULL };
	noise_cdda_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoiseCDDA", &g_define_type_info, 0);
	return noise_cdda_type_id;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



