/* CDPlayer.c generated by valac 0.42.6, the Vala compiler
 * generated from CDPlayer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gst/gst.h>
#include "music-lib.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gee.h>
#include <gst/pbutils/pbutils.h>
#include <gtk/gtk.h>


#define NOISE_PLUGINS_TYPE_CD_PLAYER (noise_plugins_cd_player_get_type ())
#define NOISE_PLUGINS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayer))
#define NOISE_PLUGINS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerClass))
#define NOISE_PLUGINS_IS_CD_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER))
#define NOISE_PLUGINS_IS_CD_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_PLAYER))
#define NOISE_PLUGINS_CD_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayerClass))

typedef struct _NoisePluginsCDPlayer NoisePluginsCDPlayer;
typedef struct _NoisePluginsCDPlayerClass NoisePluginsCDPlayerClass;
typedef struct _NoisePluginsCDPlayerPrivate NoisePluginsCDPlayerPrivate;
enum  {
	NOISE_PLUGINS_CD_PLAYER_0_PROPERTY,
	NOISE_PLUGINS_CD_PLAYER_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_cd_player_properties[NOISE_PLUGINS_CD_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))

struct _NoisePluginsCDPlayer {
	GObject parent_instance;
	NoisePluginsCDPlayerPrivate * priv;
	NoisePipeline* pipe;
	GstElement* playbin2;
	gboolean first_start;
};

struct _NoisePluginsCDPlayerClass {
	GObjectClass parent_class;
};

struct _NoisePluginsCDPlayerPrivate {
	NoiseInstallGstreamerPluginsDialog* dialog;
	gchar* device;
	gdouble volume;
};


static gint NoisePluginsCDPlayer_private_offset;
static gpointer noise_plugins_cd_player_parent_class = NULL;
static NoisePlaybackIface * noise_plugins_cd_player_noise_playback_parent_iface = NULL;
static GType noise_plugins_cd_player_type_id = 0;

GType noise_plugins_cd_player_register_type (GTypeModule * module);
GType noise_plugins_cd_player_get_type (void) G_GNUC_CONST;
NoisePluginsCDPlayer* noise_plugins_cd_player_new (GMount* mount);
NoisePluginsCDPlayer* noise_plugins_cd_player_construct (GType object_type,
                                                         GMount* mount);
gboolean noise_plugins_cd_player_initialize (NoisePluginsCDPlayer* self);
void noise_plugins_cd_player_pipe_source_setup (NoisePluginsCDPlayer* self,
                                                GstElement* playbin,
                                                GstElement* source);
static void _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                        GstElement* source,
                                                                        gpointer self);
gulong _dynamic_source_setup1_connect (gpointer obj,
                                       const char * signal_name,
                                       GCallback handler,
                                       gpointer data);
static gboolean noise_plugins_cd_player_bus_callback (NoisePluginsCDPlayer* self,
                                               GstBus* bus,
                                               GstMessage* message);
static gboolean _noise_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus,
                                                             GstMessage* message,
                                                             gpointer self);
static gboolean _noise_playback_update_position_gsource_func (gpointer self);
static GeeCollection* noise_plugins_cd_player_real_get_supported_uri (NoisePlayback* base);
static gboolean noise_plugins_cd_player_real_update_position (NoisePlayback* base);
static void noise_plugins_cd_player_real_play (NoisePlayback* base);
static void noise_plugins_cd_player_real_pause (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_state (NoisePlayback* base,
                                             GstState s);
static void noise_plugins_cd_player_real_set_media (NoisePlayback* base,
                                             NoiseMedia* media);
static void noise_plugins_cd_player_real_set_position (NoisePlayback* base,
                                                gint64 pos);
static gint64 noise_plugins_cd_player_real_get_position (NoisePlayback* base);
static gint64 noise_plugins_cd_player_real_get_duration (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_volume (NoisePlayback* base,
                                              gdouble val);
static gdouble noise_plugins_cd_player_real_get_volume (NoisePlayback* base);
static void noise_plugins_cd_player_real_enable_equalizer (NoisePlayback* base);
static void noise_plugins_cd_player_real_disable_equalizer (NoisePlayback* base);
static void noise_plugins_cd_player_real_set_equalizer_gain (NoisePlayback* base,
                                                      gint index,
                                                      gint val);
static void noise_plugins_cd_player_finalize (GObject * obj);


static inline gpointer
noise_plugins_cd_player_get_instance_private (NoisePluginsCDPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsCDPlayer_private_offset);
}


NoisePluginsCDPlayer*
noise_plugins_cd_player_construct (GType object_type,
                                   GMount* mount)
{
	NoisePluginsCDPlayer * self = NULL;
	GVolume* _tmp0_;
	GVolume* _tmp1_;
	gchar* _tmp2_;
#line 40 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 40 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) g_object_new (object_type, NULL);
#line 42 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = g_mount_get_volume (mount);
#line 42 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_;
#line 42 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = g_volume_get_identifier (_tmp1_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
#line 42 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_free0 (self->priv->device);
#line 42 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->priv->device = _tmp2_;
#line 42 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (_tmp1_);
#line 43 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_initialize (self);
#line 40 "../plugins/Devices/CDRom/CDPlayer.vala"
	return self;
#line 174 "CDPlayer.c"
}


NoisePluginsCDPlayer*
noise_plugins_cd_player_new (GMount* mount)
{
#line 40 "../plugins/Devices/CDRom/CDPlayer.vala"
	return noise_plugins_cd_player_construct (NOISE_PLUGINS_TYPE_CD_PLAYER, mount);
#line 183 "CDPlayer.c"
}


static void
_noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_ (GstElement* _sender,
                                                                   GstElement* source,
                                                                   gpointer self)
{
#line 51 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_pipe_source_setup ((NoisePluginsCDPlayer*) self, _sender, source);
#line 194 "CDPlayer.c"
}


gulong
_dynamic_source_setup1_connect (gpointer obj,
                                const char * signal_name,
                                GCallback handler,
                                gpointer data)
{
#line 51 "../plugins/Devices/CDRom/CDPlayer.vala"
	return g_signal_connect_object (obj, signal_name, handler, data, 0);
#line 206 "CDPlayer.c"
}


static gboolean
_noise_plugins_cd_player_bus_callback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self)
{
	gboolean result;
	result = noise_plugins_cd_player_bus_callback ((NoisePluginsCDPlayer*) self, bus, message);
#line 55 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 219 "CDPlayer.c"
}


static gboolean
_noise_playback_update_position_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_playback_update_position ((NoisePlayback*) self);
#line 57 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 230 "CDPlayer.c"
}


gboolean
noise_plugins_cd_player_initialize (NoisePluginsCDPlayer* self)
{
	gboolean result = FALSE;
	NoisePipeline* _tmp0_;
	NoisePipeline* _tmp1_;
	GstElement* _tmp2_;
	GstElement* _tmp3_;
	NoisePipeline* _tmp4_;
	GstElement* _tmp5_;
	NoisePipeline* _tmp6_;
	GstBus* _tmp7_;
	NoisePipeline* _tmp8_;
	GstBus* _tmp9_;
#line 46 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = noise_pipeline_new ();
#line 48 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (self->pipe);
#line 48 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->pipe = _tmp0_;
#line 50 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = self->pipe;
#line 50 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = _tmp1_->playbin;
#line 50 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->playbin2 = _tmp2_;
#line 51 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = self->playbin2;
#line 51 "../plugins/Devices/CDRom/CDPlayer.vala"
	_dynamic_source_setup1_connect (_tmp3_, "source-setup", (GCallback) _noise_plugins_cd_player_pipe_source_setup_dynamic_source_setup0_, self);
#line 52 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp4_ = self->pipe;
#line 52 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp5_ = _tmp4_->playbin;
#line 52 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp5_, "uri", "cdda://1", NULL);
#line 54 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp6_ = self->pipe;
#line 54 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp7_ = _tmp6_->bus;
#line 54 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_bus_add_signal_watch_full (_tmp7_, G_PRIORITY_DEFAULT);
#line 55 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp8_ = self->pipe;
#line 55 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp9_ = _tmp8_->bus;
#line 55 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_bus_add_watch_full (_tmp9_, G_PRIORITY_DEFAULT, _noise_plugins_cd_player_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 57 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, _noise_playback_update_position_gsource_func, g_object_ref ((NoisePlayback*) self), g_object_unref);
#line 58 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = TRUE;
#line 58 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 290 "CDPlayer.c"
}


void
noise_plugins_cd_player_pipe_source_setup (NoisePluginsCDPlayer* self,
                                           GstElement* playbin,
                                           GstElement* source)
{
	const gchar* _tmp0_;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GObjectClass* _tmp3_;
	GParamSpec* _tmp4_;
#line 61 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (self != NULL);
#line 61 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (playbin != NULL);
#line 61 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (source != NULL);
#line 62 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->priv->device;
#line 62 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) source, "device", _tmp0_, NULL);
#line 64 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = G_OBJECT_GET_CLASS ((GObject*) source);
#line 64 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = g_object_class_find_property (_tmp1_, "paranoia-mode");
#line 64 "../plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp2_ != NULL) {
#line 65 "../plugins/Devices/CDRom/CDPlayer.vala"
		g_object_set ((GObject*) source, "paranoia-mode", 0, NULL);
#line 322 "CDPlayer.c"
	}
#line 67 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = G_OBJECT_GET_CLASS ((GObject*) source);
#line 67 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp4_ = g_object_class_find_property (_tmp3_, "read-speed");
#line 67 "../plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp4_ != NULL) {
#line 68 "../plugins/Devices/CDRom/CDPlayer.vala"
		g_object_set ((GObject*) source, "read-speed", 2, NULL);
#line 332 "CDPlayer.c"
	}
}


static GeeCollection*
noise_plugins_cd_player_real_get_supported_uri (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	GeeCollection* result = NULL;
	GeeLinkedList* uris = NULL;
	GeeLinkedList* _tmp0_;
#line 71 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 72 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 72 "../plugins/Devices/CDRom/CDPlayer.vala"
	uris = _tmp0_;
#line 73 "../plugins/Devices/CDRom/CDPlayer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) uris, "cdda://");
#line 74 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = (GeeCollection*) uris;
#line 74 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 356 "CDPlayer.c"
}


static gboolean
noise_plugins_cd_player_real_update_position (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 77 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = self->first_start;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp1_) {
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp0_ = TRUE;
#line 375 "CDPlayer.c"
	} else {
		gboolean _tmp2_ = FALSE;
		NoisePlaybackManager* _tmp3_;
		NoisePlaybackManager* _tmp4_;
		NoiseMedia* _tmp5_;
		NoiseMedia* _tmp6_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp3_ = noise_app_get_player ();
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp4_ = _tmp3_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp5_ = noise_playback_manager_get_current_media (_tmp4_);
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp6_ = _tmp5_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		if (_tmp6_ != NULL) {
#line 392 "CDPlayer.c"
			NoisePlaybackManager* _tmp7_;
			NoisePlaybackManager* _tmp8_;
			NoiseMedia* _tmp9_;
			NoiseMedia* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp7_ = noise_app_get_player ();
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp8_ = _tmp7_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp9_ = noise_playback_manager_get_current_media (_tmp8_);
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp10_ = _tmp9_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp11_ = noise_media_get_resume_pos (_tmp10_);
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp12_ = _tmp11_;
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp2_ = noise_playback_get_position ((NoisePlayback*) self) >= (((gint64) (_tmp12_ - 1)) * 1000000000);
#line 413 "CDPlayer.c"
		} else {
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp2_ = FALSE;
#line 417 "CDPlayer.c"
		}
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp0_ = _tmp2_;
#line 421 "CDPlayer.c"
	}
#line 78 "../plugins/Devices/CDRom/CDPlayer.vala"
	if (_tmp0_) {
#line 79 "../plugins/Devices/CDRom/CDPlayer.vala"
		self->first_start = FALSE;
#line 80 "../plugins/Devices/CDRom/CDPlayer.vala"
		g_signal_emit_by_name ((NoisePlayback*) self, "current-position-update", noise_playback_get_position ((NoisePlayback*) self));
#line 429 "CDPlayer.c"
	} else {
		NoisePlaybackManager* _tmp13_;
		NoisePlaybackManager* _tmp14_;
		NoiseMedia* _tmp15_;
		NoiseMedia* _tmp16_;
#line 81 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp13_ = noise_app_get_player ();
#line 81 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp14_ = _tmp13_;
#line 81 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp15_ = noise_playback_manager_get_current_media (_tmp14_);
#line 81 "../plugins/Devices/CDRom/CDPlayer.vala"
		_tmp16_ = _tmp15_;
#line 81 "../plugins/Devices/CDRom/CDPlayer.vala"
		if (_tmp16_ != NULL) {
#line 445 "CDPlayer.c"
			NoisePipeline* _tmp17_;
			GstElement* _tmp18_;
			NoisePlaybackManager* _tmp19_;
			NoisePlaybackManager* _tmp20_;
			NoiseMedia* _tmp21_;
			NoiseMedia* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp17_ = self->pipe;
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp18_ = _tmp17_->playbin;
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp19_ = noise_app_get_player ();
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp20_ = _tmp19_;
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp21_ = noise_playback_manager_get_current_media (_tmp20_);
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp22_ = _tmp21_;
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp23_ = noise_media_get_resume_pos (_tmp22_);
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp24_ = _tmp23_;
#line 82 "../plugins/Devices/CDRom/CDPlayer.vala"
			gst_element_seek_simple (_tmp18_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp24_) * 1000000000);
#line 472 "CDPlayer.c"
		}
	}
#line 85 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = TRUE;
#line 85 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 479 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_play (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
#line 89 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 90 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
#line 491 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_pause (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
#line 93 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 94 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PAUSED);
#line 503 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_set_state (NoisePlayback* base,
                                        GstState s)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
#line 97 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 98 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 98 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 98 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_set_state (_tmp1_, s);
#line 522 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_set_media (NoisePlayback* base,
                                        NoiseMedia* media)
{
	NoisePluginsCDPlayer * self;
	guint _tmp0_;
	guint _tmp1_;
	NoisePipeline* _tmp2_;
	GstElement* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	NoisePlaybackManager* _tmp8_;
	NoisePlaybackManager* _tmp9_;
	NoiseMedia* _tmp10_;
	NoiseMedia* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	NoisePipeline* _tmp14_;
	GstElement* _tmp15_;
	NoisePlaybackManager* _tmp16_;
	NoisePlaybackManager* _tmp17_;
	NoiseMedia* _tmp18_;
	NoiseMedia* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
#line 101 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 101 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_if_fail (media != NULL);
#line 102 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_READY);
#line 103 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = noise_media_get_track (media);
#line 103 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_;
#line 103 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_debug ("CDPlayer.vala:103: set track number to %u\n", _tmp1_);
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp2_ = self->pipe;
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp3_ = _tmp2_->playbin;
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp4_ = noise_media_get_track (media);
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp5_ = _tmp4_;
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp6_ = g_strdup_printf ("cdda://%u", _tmp5_);
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp7_ = _tmp6_;
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp3_, "uri", _tmp7_, NULL);
#line 104 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_free0 (_tmp7_);
#line 106 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_set_state ((NoisePlayback*) self, GST_STATE_PLAYING);
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp8_ = noise_app_get_player ();
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp9_ = _tmp8_;
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp10_ = noise_playback_manager_get_current_media (_tmp9_);
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp11_ = _tmp10_;
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp12_ = noise_media_get_resume_pos (_tmp11_);
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp13_ = _tmp12_;
#line 108 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_debug ("CDPlayer.vala:108: setURI seeking to %d\n", _tmp13_);
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp14_ = self->pipe;
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp15_ = _tmp14_->playbin;
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp16_ = noise_app_get_player ();
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp17_ = _tmp16_;
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp18_ = noise_playback_manager_get_current_media (_tmp17_);
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp19_ = _tmp18_;
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp20_ = noise_media_get_resume_pos (_tmp19_);
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp21_ = _tmp20_;
#line 109 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_seek_simple (_tmp15_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, ((gint64) _tmp21_) * 1000000000);
#line 111 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_playback_play ((NoisePlayback*) self);
#line 617 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_set_position (NoisePlayback* base,
                                           gint64 pos)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
#line 114 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 115 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 115 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 115 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_seek (_tmp1_, 1.0, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH, GST_SEEK_TYPE_SET, pos, GST_SEEK_TYPE_NONE, noise_playback_get_duration ((NoisePlayback*) self));
#line 636 "CDPlayer.c"
}


static gint64
noise_plugins_cd_player_real_get_position (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
#line 121 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 122 "../plugins/Devices/CDRom/CDPlayer.vala"
	rv = (gint64) 0;
#line 123 "../plugins/Devices/CDRom/CDPlayer.vala"
	f = GST_FORMAT_TIME;
#line 125 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 125 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 125 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_query_position (_tmp1_, f, &_tmp2_);
#line 125 "../plugins/Devices/CDRom/CDPlayer.vala"
	rv = _tmp2_;
#line 127 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = rv;
#line 127 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 668 "CDPlayer.c"
}


static gint64
noise_plugins_cd_player_real_get_duration (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
	gint64 _tmp2_ = 0LL;
#line 130 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 131 "../plugins/Devices/CDRom/CDPlayer.vala"
	rv = (gint64) 0;
#line 132 "../plugins/Devices/CDRom/CDPlayer.vala"
	f = GST_FORMAT_TIME;
#line 134 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 134 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 134 "../plugins/Devices/CDRom/CDPlayer.vala"
	gst_element_query_duration (_tmp1_, f, &_tmp2_);
#line 134 "../plugins/Devices/CDRom/CDPlayer.vala"
	rv = _tmp2_;
#line 136 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = rv;
#line 136 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 700 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_set_volume (NoisePlayback* base,
                                         gdouble val)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	GstElement* _tmp1_;
#line 139 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 140 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 140 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->playbin;
#line 140 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_object_set ((GObject*) _tmp1_, "volume", val, NULL);
#line 141 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->priv->volume = val;
#line 721 "CDPlayer.c"
}


static gdouble
noise_plugins_cd_player_real_get_volume (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 144 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 148 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->priv->volume;
#line 148 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = _tmp0_;
#line 148 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 739 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_enable_equalizer (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
#line 152 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 153 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 153 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_pipeline_enableEqualizer (_tmp0_);
#line 754 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_disable_equalizer (NoisePlayback* base)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
#line 156 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 157 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 157 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_pipeline_disableEqualizer (_tmp0_);
#line 769 "CDPlayer.c"
}


static void
noise_plugins_cd_player_real_set_equalizer_gain (NoisePlayback* base,
                                                 gint index,
                                                 gint val)
{
	NoisePluginsCDPlayer * self;
	NoisePipeline* _tmp0_;
	NoiseEqualizer* _tmp1_;
#line 160 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = (NoisePluginsCDPlayer*) base;
#line 161 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = self->pipe;
#line 161 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp1_ = _tmp0_->eq;
#line 161 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_equalizer_setGain (_tmp1_, index, (gdouble) val);
#line 789 "CDPlayer.c"
}


static gboolean
noise_plugins_cd_player_bus_callback (NoisePluginsCDPlayer* self,
                                      GstBus* bus,
                                      GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
#line 165 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 165 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
	_tmp0_ = message->type;
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
	switch (_tmp0_) {
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_ERROR:
#line 812 "CDPlayer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 170 "../plugins/Devices/CDRom/CDPlayer.vala"
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
#line 170 "../plugins/Devices/CDRom/CDPlayer.vala"
			_g_error_free0 (err);
#line 170 "../plugins/Devices/CDRom/CDPlayer.vala"
			err = _tmp1_;
#line 170 "../plugins/Devices/CDRom/CDPlayer.vala"
			_g_free0 (debug);
#line 170 "../plugins/Devices/CDRom/CDPlayer.vala"
			debug = _tmp2_;
#line 171 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp3_ = err;
#line 171 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp4_ = _tmp3_->message;
#line 171 "../plugins/Devices/CDRom/CDPlayer.vala"
			g_warning ("CDPlayer.vala:171: Error: %s\n", _tmp4_);
#line 172 "../plugins/Devices/CDRom/CDPlayer.vala"
			g_signal_emit_by_name ((NoisePlayback*) self, "error-occured");
#line 173 "../plugins/Devices/CDRom/CDPlayer.vala"
			_g_free0 (debug);
#line 173 "../plugins/Devices/CDRom/CDPlayer.vala"
			_g_error_free0 (err);
#line 173 "../plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 844 "CDPlayer.c"
		}
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_ELEMENT:
#line 848 "CDPlayer.c"
		{
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			GstStructure* _tmp7_;
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp7_ = gst_message_get_structure (message);
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp7_ != NULL) {
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp6_ = gst_is_missing_plugin_message (message);
#line 859 "CDPlayer.c"
			} else {
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp6_ = FALSE;
#line 863 "CDPlayer.c"
			}
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp6_) {
#line 867 "CDPlayer.c"
				gboolean _tmp8_ = FALSE;
				NoiseInstallGstreamerPluginsDialog* _tmp9_;
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp9_ = self->priv->dialog;
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
				if (_tmp9_ == NULL) {
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp8_ = TRUE;
#line 876 "CDPlayer.c"
				} else {
					NoiseInstallGstreamerPluginsDialog* _tmp10_;
					gboolean _tmp11_;
					gboolean _tmp12_;
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp10_ = self->priv->dialog;
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp12_ = _tmp11_;
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp8_ = !_tmp12_;
#line 889 "CDPlayer.c"
				}
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp5_ = _tmp8_;
#line 893 "CDPlayer.c"
			} else {
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp5_ = FALSE;
#line 897 "CDPlayer.c"
			}
#line 175 "../plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp5_) {
#line 901 "CDPlayer.c"
				NoiseInstallGstreamerPluginsDialog* _tmp13_;
#line 176 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp13_ = noise_install_gstreamer_plugins_dialog_new (message);
#line 176 "../plugins/Devices/CDRom/CDPlayer.vala"
				g_object_ref_sink (_tmp13_);
#line 176 "../plugins/Devices/CDRom/CDPlayer.vala"
				_g_object_unref0 (self->priv->dialog);
#line 176 "../plugins/Devices/CDRom/CDPlayer.vala"
				self->priv->dialog = _tmp13_;
#line 911 "CDPlayer.c"
			}
#line 178 "../plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 915 "CDPlayer.c"
		}
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_EOS:
#line 919 "CDPlayer.c"
		{
#line 180 "../plugins/Devices/CDRom/CDPlayer.vala"
			g_signal_emit_by_name ((NoisePlayback*) self, "end-of-stream");
#line 181 "../plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 925 "CDPlayer.c"
		}
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 929 "CDPlayer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp14_ = 0;
			GstState _tmp15_ = 0;
			GstState _tmp16_ = 0;
			GstState _tmp17_;
#line 186 "../plugins/Devices/CDRom/CDPlayer.vala"
			gst_message_parse_state_changed (message, &_tmp14_, &_tmp15_, &_tmp16_);
#line 186 "../plugins/Devices/CDRom/CDPlayer.vala"
			oldstate = _tmp14_;
#line 186 "../plugins/Devices/CDRom/CDPlayer.vala"
			newstate = _tmp15_;
#line 186 "../plugins/Devices/CDRom/CDPlayer.vala"
			pending = _tmp16_;
#line 189 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp17_ = newstate;
#line 189 "../plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp17_ != GST_STATE_PLAYING) {
#line 190 "../plugins/Devices/CDRom/CDPlayer.vala"
				break;
#line 952 "CDPlayer.c"
			}
#line 192 "../plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 956 "CDPlayer.c"
		}
#line 166 "../plugins/Devices/CDRom/CDPlayer.vala"
		case GST_MESSAGE_TAG:
#line 960 "CDPlayer.c"
		{
			GstTagList* tag_list = NULL;
			GstTagList* _tmp18_ = NULL;
			GstTagList* _tmp19_;
#line 196 "../plugins/Devices/CDRom/CDPlayer.vala"
			gst_message_parse_tag (message, &_tmp18_);
#line 196 "../plugins/Devices/CDRom/CDPlayer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 196 "../plugins/Devices/CDRom/CDPlayer.vala"
			tag_list = _tmp18_;
#line 197 "../plugins/Devices/CDRom/CDPlayer.vala"
			_tmp19_ = tag_list;
#line 197 "../plugins/Devices/CDRom/CDPlayer.vala"
			if (_tmp19_ != NULL) {
#line 975 "CDPlayer.c"
				GstTagList* _tmp20_;
#line 198 "../plugins/Devices/CDRom/CDPlayer.vala"
				_tmp20_ = tag_list;
#line 198 "../plugins/Devices/CDRom/CDPlayer.vala"
				if (gst_tag_list_get_tag_size (_tmp20_, GST_TAG_TITLE) > ((guint) 0)) {
#line 981 "CDPlayer.c"
					gchar* title = NULL;
					gchar* _tmp21_;
					GstTagList* _tmp22_;
					gchar* _tmp23_ = NULL;
					NoiseNotificationManager* _tmp24_;
					NoiseNotificationManager* _tmp25_;
					NoisePlaybackManager* _tmp26_;
					NoisePlaybackManager* _tmp27_;
					NoiseMedia* _tmp28_;
					NoiseMedia* _tmp29_;
					const gchar* _tmp30_;
					const gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
#line 199 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp21_ = g_strdup ("");
#line 199 "../plugins/Devices/CDRom/CDPlayer.vala"
					title = _tmp21_;
#line 200 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp22_ = tag_list;
#line 200 "../plugins/Devices/CDRom/CDPlayer.vala"
					gst_tag_list_get_string (_tmp22_, GST_TAG_TITLE, &_tmp23_);
#line 200 "../plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (title);
#line 200 "../plugins/Devices/CDRom/CDPlayer.vala"
					title = _tmp23_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp24_ = noise_notification_manager_get_default ();
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp25_ = _tmp24_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp26_ = noise_app_get_player ();
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp27_ = _tmp26_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp28_ = noise_playback_manager_get_current_media (_tmp27_);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp29_ = _tmp28_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp30_ = noise_media_get_album_artist (_tmp29_);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp31_ = _tmp30_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp33_ = _tmp32_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp34_ = title;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp35_ = g_strconcat (_tmp33_, _tmp34_, NULL);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_tmp36_ = _tmp35_;
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					g_signal_emit_by_name (_tmp25_, "update-track", _tmp36_);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (_tmp36_);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (_tmp33_);
#line 201 "../plugins/Devices/CDRom/CDPlayer.vala"
					_g_object_unref0 (_tmp25_);
#line 198 "../plugins/Devices/CDRom/CDPlayer.vala"
					_g_free0 (title);
#line 1047 "CDPlayer.c"
				}
			}
#line 204 "../plugins/Devices/CDRom/CDPlayer.vala"
			_gst_tag_list_unref0 (tag_list);
#line 204 "../plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 1054 "CDPlayer.c"
		}
		default:
		{
#line 206 "../plugins/Devices/CDRom/CDPlayer.vala"
			break;
#line 1060 "CDPlayer.c"
		}
	}
#line 209 "../plugins/Devices/CDRom/CDPlayer.vala"
	result = TRUE;
#line 209 "../plugins/Devices/CDRom/CDPlayer.vala"
	return result;
#line 1067 "CDPlayer.c"
}


static void
noise_plugins_cd_player_class_init (NoisePluginsCDPlayerClass * klass)
{
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	g_type_class_adjust_private_offset (klass, &NoisePluginsCDPlayer_private_offset);
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_cd_player_finalize;
#line 1080 "CDPlayer.c"
}


static void
noise_plugins_cd_player_noise_playback_interface_init (NoisePlaybackIface * iface)
{
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	noise_plugins_cd_player_noise_playback_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_supported_uri = (GeeCollection* (*) (NoisePlayback*)) noise_plugins_cd_player_real_get_supported_uri;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->update_position = (gboolean (*) (NoisePlayback*)) noise_plugins_cd_player_real_update_position;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->play = (void (*) (NoisePlayback*)) noise_plugins_cd_player_real_play;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->pause = (void (*) (NoisePlayback*)) noise_plugins_cd_player_real_pause;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_state = (void (*) (NoisePlayback*, GstState)) noise_plugins_cd_player_real_set_state;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_media = (void (*) (NoisePlayback*, NoiseMedia*)) noise_plugins_cd_player_real_set_media;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_position = (void (*) (NoisePlayback*, gint64)) noise_plugins_cd_player_real_set_position;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_position = (gint64 (*) (NoisePlayback*)) noise_plugins_cd_player_real_get_position;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_duration = (gint64 (*) (NoisePlayback*)) noise_plugins_cd_player_real_get_duration;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_volume = (void (*) (NoisePlayback*, gdouble)) noise_plugins_cd_player_real_set_volume;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->get_volume = (gdouble (*) (NoisePlayback*)) noise_plugins_cd_player_real_get_volume;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->enable_equalizer = (void (*) (NoisePlayback*)) noise_plugins_cd_player_real_enable_equalizer;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->disable_equalizer = (void (*) (NoisePlayback*)) noise_plugins_cd_player_real_disable_equalizer;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	iface->set_equalizer_gain = (void (*) (NoisePlayback*, gint, gint)) noise_plugins_cd_player_real_set_equalizer_gain;
#line 1117 "CDPlayer.c"
}


static void
noise_plugins_cd_player_instance_init (NoisePluginsCDPlayer * self)
{
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->priv = noise_plugins_cd_player_get_instance_private (self);
#line 37 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->first_start = TRUE;
#line 38 "../plugins/Devices/CDRom/CDPlayer.vala"
	self->priv->volume = (gdouble) 1;
#line 1130 "CDPlayer.c"
}


static void
noise_plugins_cd_player_finalize (GObject * obj)
{
	NoisePluginsCDPlayer * self;
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_CD_PLAYER, NoisePluginsCDPlayer);
#line 31 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (self->priv->dialog);
#line 33 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_free0 (self->priv->device);
#line 35 "../plugins/Devices/CDRom/CDPlayer.vala"
	_g_object_unref0 (self->pipe);
#line 29 "../plugins/Devices/CDRom/CDPlayer.vala"
	G_OBJECT_CLASS (noise_plugins_cd_player_parent_class)->finalize (obj);
#line 1148 "CDPlayer.c"
}


GType
noise_plugins_cd_player_get_type (void)
{
	return noise_plugins_cd_player_type_id;
}


GType
noise_plugins_cd_player_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsCDPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_cd_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsCDPlayer), 0, (GInstanceInitFunc) noise_plugins_cd_player_instance_init, NULL };
	static const GInterfaceInfo noise_playback_info = { (GInterfaceInitFunc) noise_plugins_cd_player_noise_playback_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_cd_player_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsCDPlayer", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_cd_player_type_id, NOISE_TYPE_PLAYBACK, &noise_playback_info);
	NoisePluginsCDPlayer_private_offset = sizeof (NoisePluginsCDPlayerPrivate);
	return noise_plugins_cd_player_type_id;
}



