/* CDRipper.c generated by valac 0.42.6, the Vala compiler
 * generated from CDRipper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gst/gst.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define NOISE_TYPE_CD_RIPPER (noise_cd_ripper_get_type ())
#define NOISE_CD_RIPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CD_RIPPER, NoiseCDRipper))
#define NOISE_CD_RIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CD_RIPPER, NoiseCDRipperClass))
#define NOISE_IS_CD_RIPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CD_RIPPER))
#define NOISE_IS_CD_RIPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CD_RIPPER))
#define NOISE_CD_RIPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CD_RIPPER, NoiseCDRipperClass))

typedef struct _NoiseCDRipper NoiseCDRipper;
typedef struct _NoiseCDRipperClass NoiseCDRipperClass;
typedef struct _NoiseCDRipperPrivate NoiseCDRipperPrivate;
enum  {
	NOISE_CD_RIPPER_0_PROPERTY,
	NOISE_CD_RIPPER_NUM_PROPERTIES
};
static GParamSpec* noise_cd_ripper_properties[NOISE_CD_RIPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	NOISE_CD_RIPPER_MEDIA_RIPPED_SIGNAL,
	NOISE_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL,
	NOISE_CD_RIPPER_ERROR_SIGNAL,
	NOISE_CD_RIPPER_NUM_SIGNALS
};
static guint noise_cd_ripper_signals[NOISE_CD_RIPPER_NUM_SIGNALS] = {0};

struct _NoiseCDRipper {
	GObject parent_instance;
	NoiseCDRipperPrivate * priv;
	GstPipeline* pipeline;
	GstElement* src;
	GstElement* queue;
	GstElement* filter;
	GstElement* sink;
	gint track_count;
	gint track_index;
};

struct _NoiseCDRipperClass {
	GObjectClass parent_class;
};

struct _NoiseCDRipperPrivate {
	NoiseMedia* current_media;
	gchar* _device;
	GstFormat _format;
};


static gint NoiseCDRipper_private_offset;
static gpointer noise_cd_ripper_parent_class = NULL;
static GType noise_cd_ripper_type_id = 0;

GType noise_cd_ripper_register_type (GTypeModule * module);
GType noise_cd_ripper_get_type (void) G_GNUC_CONST;
NoiseCDRipper* noise_cd_ripper_new (GMount* mount,
                                    gint count);
NoiseCDRipper* noise_cd_ripper_construct (GType object_type,
                                          GMount* mount,
                                          gint count);
gboolean noise_cd_ripper_initialize (NoiseCDRipper* self);
static gboolean noise_cd_ripper_bus_callback (NoiseCDRipper* self,
                                       GstBus* bus,
                                       GstMessage* message);
static gboolean _noise_cd_ripper_bus_callback_gst_bus_func (GstBus* bus,
                                                     GstMessage* message,
                                                     gpointer self);
gboolean noise_cd_ripper_do_position_update (NoiseCDRipper* self);
static gboolean _noise_cd_ripper_do_position_update_gsource_func (gpointer self);
gint64 noise_cd_ripper_get_position (NoiseCDRipper* self);
gint64 noise_cd_ripper_get_duration (NoiseCDRipper* self);
static inline const gchar* _dynamic_get_location0 (GstElement* obj);
void noise_cd_ripper_rip_media (NoiseCDRipper* self,
                                guint track,
                                NoiseMedia* s);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void noise_cd_ripper_finalize (GObject * obj);


static inline gpointer
noise_cd_ripper_get_instance_private (NoiseCDRipper* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseCDRipper_private_offset);
}


NoiseCDRipper*
noise_cd_ripper_construct (GType object_type,
                           GMount* mount,
                           gint count)
{
	NoiseCDRipper * self = NULL;
	GVolume* _tmp0_;
	GVolume* _tmp1_;
	gchar* _tmp2_;
#line 46 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 46 "../plugins/Devices/CDRom/CDRipper.vala"
	self = (NoiseCDRipper*) g_object_new (object_type, NULL);
#line 47 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = g_mount_get_volume (mount);
#line 47 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = _tmp0_;
#line 47 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp2_ = g_volume_get_identifier (_tmp1_, G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE);
#line 47 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_free0 (self->priv->_device);
#line 47 "../plugins/Devices/CDRom/CDRipper.vala"
	self->priv->_device = _tmp2_;
#line 47 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (_tmp1_);
#line 48 "../plugins/Devices/CDRom/CDRipper.vala"
	self->track_count = count;
#line 46 "../plugins/Devices/CDRom/CDRipper.vala"
	return self;
#line 171 "CDRipper.c"
}


NoiseCDRipper*
noise_cd_ripper_new (GMount* mount,
                     gint count)
{
#line 46 "../plugins/Devices/CDRom/CDRipper.vala"
	return noise_cd_ripper_construct (NOISE_TYPE_CD_RIPPER, mount, count);
#line 181 "CDRipper.c"
}


static gboolean
_noise_cd_ripper_bus_callback_gst_bus_func (GstBus* bus,
                                            GstMessage* message,
                                            gpointer self)
{
	gboolean result;
	result = noise_cd_ripper_bus_callback ((NoiseCDRipper*) self, bus, message);
#line 89 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 194 "CDRipper.c"
}


static gboolean
_noise_cd_ripper_do_position_update_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_cd_ripper_do_position_update ((NoiseCDRipper*) self);
#line 91 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 205 "CDRipper.c"
}


gboolean
noise_cd_ripper_initialize (NoiseCDRipper* self)
{
	gboolean result = FALSE;
	GstPipeline* _tmp0_;
	GstElement* src = NULL;
	GstElement* _tmp7_;
	const gchar* _tmp8_;
	GValue _tmp9_ = {0};
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	GstElement* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GstElement* _tmp16_;
	GstElement* _tmp20_;
	GObjectClass* _tmp21_;
	GParamSpec* _tmp22_;
	GstElement* _tmp25_;
	GObjectClass* _tmp26_;
	GParamSpec* _tmp27_;
	GstElement* _tmp30_;
	GstPipeline* _tmp31_;
	GstElement* _tmp32_;
	GstElement* _tmp33_;
	GstElement* _tmp34_;
	GstElement* _tmp35_;
	GstElement* _tmp36_;
	GstElement* _tmp37_;
	GstElement* _tmp38_;
	GstElement* _tmp39_;
	GstPipeline* _tmp40_;
	GstBus* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 51 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = (GstPipeline*) gst_pipeline_new ("pipeline");
#line 52 "../plugins/Devices/CDRom/CDRipper.vala"
	g_object_ref_sink (_tmp0_);
#line 52 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->pipeline);
#line 52 "../plugins/Devices/CDRom/CDRipper.vala"
	self->pipeline = _tmp0_;
#line 53 "../plugins/Devices/CDRom/CDRipper.vala"
	src = NULL;
#line 256 "CDRipper.c"
	{
		GstElement* _tmp1_ = NULL;
		GstElement* _tmp2_;
		GstElement* _tmp3_;
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp2_ = gst_element_make_from_uri (GST_URI_SRC, "cdda://", NULL, &_inner_error0_);
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp1_ = _tmp2_;
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "CDRipper.c"
			goto __catch1_g_error;
		}
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp3_ = _tmp1_;
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp1_ = NULL;
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		if (_tmp3_ != NULL) {
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
			g_object_ref_sink (_tmp3_);
#line 278 "CDRipper.c"
		}
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 55 "../plugins/Devices/CDRom/CDRipper.vala"
		src = _tmp3_;
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (_tmp1_);
#line 286 "CDRipper.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		e = _inner_error0_;
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		_inner_error0_ = NULL;
#line 57 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp4_ = e;
#line 57 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp5_ = _tmp4_->message;
#line 57 "../plugins/Devices/CDRom/CDRipper.vala"
		g_warning ("CDRipper.vala:57: %s", _tmp5_);
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_error_free0 (e);
#line 306 "CDRipper.c"
	}
	__finally1:
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 311 "CDRipper.c"
		gboolean _tmp6_ = FALSE;
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		g_clear_error (&_inner_error0_);
#line 54 "../plugins/Devices/CDRom/CDRipper.vala"
		return _tmp6_;
#line 321 "CDRipper.c"
	}
#line 59 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp7_ = src;
#line 59 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp8_ = self->priv->_device;
#line 59 "../plugins/Devices/CDRom/CDRipper.vala"
	g_value_init (&_tmp9_, G_TYPE_STRING);
#line 59 "../plugins/Devices/CDRom/CDRipper.vala"
	g_value_set_string (&_tmp9_, _tmp8_);
#line 59 "../plugins/Devices/CDRom/CDRipper.vala"
	g_object_set_property ((GObject*) _tmp7_, "device", &_tmp9_);
#line 59 "../plugins/Devices/CDRom/CDRipper.vala"
	G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 60 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp10_ = gst_element_factory_make ("queue", "queue");
#line 60 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp10_ != NULL) {
#line 60 "../plugins/Devices/CDRom/CDRipper.vala"
		g_object_ref_sink (_tmp10_);
#line 341 "CDRipper.c"
	}
#line 60 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->queue);
#line 60 "../plugins/Devices/CDRom/CDRipper.vala"
	self->queue = _tmp10_;
#line 61 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp11_ = gst_element_factory_make ("lamemp3enc", "lamemp3enc");
#line 61 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp11_ != NULL) {
#line 61 "../plugins/Devices/CDRom/CDRipper.vala"
		g_object_ref_sink (_tmp11_);
#line 353 "CDRipper.c"
	}
#line 61 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->filter);
#line 61 "../plugins/Devices/CDRom/CDRipper.vala"
	self->filter = _tmp11_;
#line 62 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp12_ = gst_element_factory_make ("filesink", "filesink");
#line 62 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp12_ != NULL) {
#line 62 "../plugins/Devices/CDRom/CDRipper.vala"
		g_object_ref_sink (_tmp12_);
#line 365 "CDRipper.c"
	}
#line 62 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->sink);
#line 62 "../plugins/Devices/CDRom/CDRipper.vala"
	self->sink = _tmp12_;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp16_ = src;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp16_ == NULL) {
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp15_ = TRUE;
#line 377 "CDRipper.c"
	} else {
		GstElement* _tmp17_;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp17_ = self->queue;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp15_ = _tmp17_ == NULL;
#line 384 "CDRipper.c"
	}
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp15_) {
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp14_ = TRUE;
#line 390 "CDRipper.c"
	} else {
		GstElement* _tmp18_;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp18_ = self->filter;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp14_ = _tmp18_ == NULL;
#line 397 "CDRipper.c"
	}
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp14_) {
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp13_ = TRUE;
#line 403 "CDRipper.c"
	} else {
		GstElement* _tmp19_;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp19_ = self->sink;
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp13_ = _tmp19_ == NULL;
#line 410 "CDRipper.c"
	}
#line 64 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp13_) {
#line 65 "../plugins/Devices/CDRom/CDRipper.vala"
		g_critical ("CDRipper.vala:65: Could not create GST Elements for ripping.\n");
#line 66 "../plugins/Devices/CDRom/CDRipper.vala"
		result = FALSE;
#line 66 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 66 "../plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 422 "CDRipper.c"
	}
#line 69 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp20_ = src;
#line 69 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp21_ = G_OBJECT_GET_CLASS ((GObject*) _tmp20_);
#line 69 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp22_ = g_object_class_find_property (_tmp21_, "paranoia-mode");
#line 69 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp22_ != NULL) {
#line 432 "CDRipper.c"
		GstElement* _tmp23_;
		GValue _tmp24_ = {0};
#line 70 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp23_ = src;
#line 70 "../plugins/Devices/CDRom/CDRipper.vala"
		g_value_init (&_tmp24_, G_TYPE_INT);
#line 70 "../plugins/Devices/CDRom/CDRipper.vala"
		g_value_set_int (&_tmp24_, 0xff);
#line 70 "../plugins/Devices/CDRom/CDRipper.vala"
		g_object_set_property ((GObject*) _tmp23_, "paranoia-mode", &_tmp24_);
#line 70 "../plugins/Devices/CDRom/CDRipper.vala"
		G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
#line 445 "CDRipper.c"
	}
#line 75 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp25_ = src;
#line 75 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp26_ = G_OBJECT_GET_CLASS ((GObject*) _tmp25_);
#line 75 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp27_ = g_object_class_find_property (_tmp26_, "read-speed");
#line 75 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp27_ != NULL) {
#line 455 "CDRipper.c"
		GstElement* _tmp28_;
		GValue _tmp29_ = {0};
#line 76 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp28_ = src;
#line 76 "../plugins/Devices/CDRom/CDRipper.vala"
		g_value_init (&_tmp29_, G_TYPE_INT);
#line 76 "../plugins/Devices/CDRom/CDRipper.vala"
		g_value_set_int (&_tmp29_, 0xffff);
#line 76 "../plugins/Devices/CDRom/CDRipper.vala"
		g_object_set_property ((GObject*) _tmp28_, "read-speed", &_tmp29_);
#line 76 "../plugins/Devices/CDRom/CDRipper.vala"
		G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
#line 468 "CDRipper.c"
	}
#line 79 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp30_ = self->queue;
#line 79 "../plugins/Devices/CDRom/CDRipper.vala"
	g_object_set ((GObject*) _tmp30_, "max-size-time", 120 * GST_SECOND, NULL);
#line 81 "../plugins/Devices/CDRom/CDRipper.vala"
	self->priv->_format = gst_format_get_by_nick ("track");
#line 83 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp31_ = self->pipeline;
#line 83 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp32_ = src;
#line 83 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp33_ = self->queue;
#line 83 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp34_ = self->filter;
#line 83 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp35_ = self->sink;
#line 83 "../plugins/Devices/CDRom/CDRipper.vala"
	gst_bin_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gst_bin_get_type (), GstBin), _tmp32_, _tmp33_, _tmp34_, _tmp35_, NULL);
#line 84 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp36_ = src;
#line 84 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp37_ = self->queue;
#line 84 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp38_ = self->filter;
#line 84 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp39_ = self->sink;
#line 84 "../plugins/Devices/CDRom/CDRipper.vala"
	if (!gst_element_link_many (_tmp36_, _tmp37_, _tmp38_, _tmp39_, NULL)) {
#line 85 "../plugins/Devices/CDRom/CDRipper.vala"
		g_critical ("CDRipper.vala:85: CD Ripper link_many failed\n");
#line 86 "../plugins/Devices/CDRom/CDRipper.vala"
		result = FALSE;
#line 86 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (src);
#line 86 "../plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 506 "CDRipper.c"
	}
#line 89 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp40_ = self->pipeline;
#line 89 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp41_ = ((GstElement*) _tmp40_)->bus;
#line 89 "../plugins/Devices/CDRom/CDRipper.vala"
	gst_bus_add_watch_full (_tmp41_, G_PRIORITY_DEFAULT, _noise_cd_ripper_bus_callback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 91 "../plugins/Devices/CDRom/CDRipper.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _noise_cd_ripper_do_position_update_gsource_func, g_object_ref (self), g_object_unref);
#line 93 "../plugins/Devices/CDRom/CDRipper.vala"
	result = TRUE;
#line 93 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (src);
#line 93 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 522 "CDRipper.c"
}


gboolean
noise_cd_ripper_do_position_update (NoiseCDRipper* self)
{
	gboolean result = FALSE;
	gdouble track_position = 0.0;
	gdouble track_number = 0.0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 96 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../plugins/Devices/CDRom/CDRipper.vala"
	track_position = ((gdouble) noise_cd_ripper_get_position (self)) / ((gdouble) noise_cd_ripper_get_duration (self));
#line 98 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = self->track_index;
#line 98 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = self->track_count;
#line 98 "../plugins/Devices/CDRom/CDRipper.vala"
	track_number = ((gdouble) _tmp0_) / ((gdouble) _tmp1_);
#line 99 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp2_ = track_position;
#line 99 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp3_ = track_number;
#line 99 "../plugins/Devices/CDRom/CDRipper.vala"
	g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL], 0, _tmp2_ * _tmp3_);
#line 101 "../plugins/Devices/CDRom/CDRipper.vala"
	if (noise_cd_ripper_get_duration (self) <= ((gint64) 0)) {
#line 102 "../plugins/Devices/CDRom/CDRipper.vala"
		result = FALSE;
#line 102 "../plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 558 "CDRipper.c"
	} else {
#line 104 "../plugins/Devices/CDRom/CDRipper.vala"
		result = TRUE;
#line 104 "../plugins/Devices/CDRom/CDRipper.vala"
		return result;
#line 564 "CDRipper.c"
	}
}


gint64
noise_cd_ripper_get_position (NoiseCDRipper* self)
{
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
#line 107 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 108 "../plugins/Devices/CDRom/CDRipper.vala"
	rv = (gint64) 0;
#line 109 "../plugins/Devices/CDRom/CDRipper.vala"
	f = GST_FORMAT_TIME;
#line 111 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = self->src;
#line 111 "../plugins/Devices/CDRom/CDRipper.vala"
	gst_element_query_position (_tmp0_, f, &_tmp1_);
#line 111 "../plugins/Devices/CDRom/CDRipper.vala"
	rv = _tmp1_;
#line 113 "../plugins/Devices/CDRom/CDRipper.vala"
	result = rv;
#line 113 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 593 "CDRipper.c"
}


gint64
noise_cd_ripper_get_duration (NoiseCDRipper* self)
{
	gint64 result = 0LL;
	gint64 rv = 0LL;
	GstFormat f = 0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
#line 116 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 117 "../plugins/Devices/CDRom/CDRipper.vala"
	rv = (gint64) 0;
#line 118 "../plugins/Devices/CDRom/CDRipper.vala"
	f = GST_FORMAT_TIME;
#line 120 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = self->src;
#line 120 "../plugins/Devices/CDRom/CDRipper.vala"
	gst_element_query_duration (_tmp0_, f, &_tmp1_);
#line 120 "../plugins/Devices/CDRom/CDRipper.vala"
	rv = _tmp1_;
#line 122 "../plugins/Devices/CDRom/CDRipper.vala"
	result = rv;
#line 122 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 621 "CDRipper.c"
}


static inline const gchar*
_dynamic_get_location0 (GstElement* obj)
{
	const gchar* result;
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
	g_object_get (obj, "location", &result, NULL);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 633 "CDRipper.c"
}


static gboolean
noise_cd_ripper_bus_callback (NoiseCDRipper* self,
                              GstBus* bus,
                              GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
#line 125 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 125 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 126 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = message->type;
#line 126 "../plugins/Devices/CDRom/CDRipper.vala"
	switch (_tmp0_) {
#line 126 "../plugins/Devices/CDRom/CDRipper.vala"
		case GST_MESSAGE_ERROR:
#line 656 "CDRipper.c"
		{
#line 146 "../plugins/Devices/CDRom/CDRipper.vala"
			g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_ERROR_SIGNAL], 0, "error", message);
#line 147 "../plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 662 "CDRipper.c"
		}
#line 126 "../plugins/Devices/CDRom/CDRipper.vala"
		case GST_MESSAGE_ELEMENT:
#line 666 "CDRipper.c"
		{
#line 149 "../plugins/Devices/CDRom/CDRipper.vala"
			g_critical ("CDRipper.vala:149: missing element\n");
#line 150 "../plugins/Devices/CDRom/CDRipper.vala"
			g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_ERROR_SIGNAL], 0, "missing element", message);
#line 152 "../plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 674 "CDRipper.c"
		}
#line 126 "../plugins/Devices/CDRom/CDRipper.vala"
		case GST_MESSAGE_EOS:
#line 678 "CDRipper.c"
		{
			GstPipeline* _tmp1_;
			NoiseMedia* _tmp2_;
			GstElement* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			GFile* _tmp6_;
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			NoiseMedia* _tmp10_;
#line 154 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp1_ = self->pipeline;
#line 154 "../plugins/Devices/CDRom/CDRipper.vala"
			gst_element_set_state ((GstElement*) _tmp1_, GST_STATE_NULL);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp2_ = self->priv->current_media;
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp3_ = self->sink;
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp4_ = _dynamic_get_location0 (_tmp3_);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp5_ = _tmp4_;
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp6_ = g_file_new_for_path (_tmp5_);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp7_ = _tmp6_;
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp8_ = g_file_get_uri (_tmp7_);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp9_ = _tmp8_;
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			noise_media_set_uri (_tmp2_, _tmp9_);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_g_free0 (_tmp9_);
#line 155 "../plugins/Devices/CDRom/CDRipper.vala"
			_g_object_unref0 (_tmp7_);
#line 156 "../plugins/Devices/CDRom/CDRipper.vala"
			_tmp10_ = self->priv->current_media;
#line 156 "../plugins/Devices/CDRom/CDRipper.vala"
			g_signal_emit (self, noise_cd_ripper_signals[NOISE_CD_RIPPER_MEDIA_RIPPED_SIGNAL], 0, _tmp10_, TRUE);
#line 158 "../plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 722 "CDRipper.c"
		}
		default:
		{
#line 160 "../plugins/Devices/CDRom/CDRipper.vala"
			break;
#line 728 "CDRipper.c"
		}
	}
#line 163 "../plugins/Devices/CDRom/CDRipper.vala"
	result = TRUE;
#line 163 "../plugins/Devices/CDRom/CDRipper.vala"
	return result;
#line 735 "CDRipper.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 175 "../plugins/Devices/CDRom/CDRipper.vala"
	return self ? g_object_ref (self) : NULL;
#line 744 "CDRipper.c"
}


void
noise_cd_ripper_rip_media (NoiseCDRipper* self,
                           guint track,
                           NoiseMedia* s)
{
	GFile* f = NULL;
	GFile* _tmp0_;
	GstElement* _tmp1_;
	GstElement* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GstElement* _tmp6_;
	NoiseMedia* _tmp7_;
	gint _tmp11_;
	NoiseMedia* _tmp12_;
	NoiseMedia* _tmp13_;
	GThemedIcon* _tmp14_;
	GThemedIcon* _tmp15_;
	GstPipeline* _tmp16_;
#line 166 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (self != NULL);
#line 166 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (s != NULL);
#line 167 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp0_ = noise_file_utils_get_new_destination (s);
#line 167 "../plugins/Devices/CDRom/CDRipper.vala"
	f = _tmp0_;
#line 169 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp1_ = self->sink;
#line 169 "../plugins/Devices/CDRom/CDRipper.vala"
	gst_element_set_state (_tmp1_, GST_STATE_NULL);
#line 170 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp2_ = self->sink;
#line 170 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp3_ = f;
#line 170 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 170 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp5_ = _tmp4_;
#line 170 "../plugins/Devices/CDRom/CDRipper.vala"
	g_object_set ((GObject*) _tmp2_, "location", _tmp5_, NULL);
#line 170 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_free0 (_tmp5_);
#line 171 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp6_ = self->src;
#line 171 "../plugins/Devices/CDRom/CDRipper.vala"
	g_object_set ((GObject*) _tmp6_, "track", track, NULL);
#line 172 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp7_ = self->priv->current_media;
#line 172 "../plugins/Devices/CDRom/CDRipper.vala"
	if (_tmp7_ != NULL) {
#line 800 "CDRipper.c"
		NoiseMedia* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
#line 173 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp8_ = self->priv->current_media;
#line 173 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp9_ = (GThemedIcon*) g_themed_icon_new ("process-completed-symbolic");
#line 173 "../plugins/Devices/CDRom/CDRipper.vala"
		_tmp10_ = _tmp9_;
#line 173 "../plugins/Devices/CDRom/CDRipper.vala"
		noise_media_set_unique_status_image (_tmp8_, (GIcon*) _tmp10_);
#line 173 "../plugins/Devices/CDRom/CDRipper.vala"
		_g_object_unref0 (_tmp10_);
#line 814 "CDRipper.c"
	}
#line 174 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp11_ = self->track_index;
#line 174 "../plugins/Devices/CDRom/CDRipper.vala"
	self->track_index = _tmp11_ + 1;
#line 175 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp12_ = _g_object_ref0 (s);
#line 175 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->priv->current_media);
#line 175 "../plugins/Devices/CDRom/CDRipper.vala"
	self->priv->current_media = _tmp12_;
#line 176 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp13_ = self->priv->current_media;
#line 176 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp14_ = (GThemedIcon*) g_themed_icon_new ("view-refresh-symbolic");
#line 176 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp15_ = _tmp14_;
#line 176 "../plugins/Devices/CDRom/CDRipper.vala"
	noise_media_set_unique_status_image (_tmp13_, (GIcon*) _tmp15_);
#line 176 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (_tmp15_);
#line 178 "../plugins/Devices/CDRom/CDRipper.vala"
	_tmp16_ = self->pipeline;
#line 178 "../plugins/Devices/CDRom/CDRipper.vala"
	gst_element_set_state ((GstElement*) _tmp16_, GST_STATE_PLAYING);
#line 166 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (f);
#line 842 "CDRipper.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data1 = closure->data;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data2 = param_values->data[0].v_pointer;
#line 868 "CDRipper.c"
	} else {
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data2 = closure->data;
#line 874 "CDRipper.c"
	}
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 880 "CDRipper.c"
}


static void
g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	g_return_if_fail (n_param_values == 3);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data1 = closure->data;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data2 = param_values->data[0].v_pointer;
#line 906 "CDRipper.c"
	} else {
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
		data2 = closure->data;
#line 912 "CDRipper.c"
	}
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 918 "CDRipper.c"
}


static void
noise_cd_ripper_class_init (NoiseCDRipperClass * klass)
{
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	g_type_class_adjust_private_offset (klass, &NoiseCDRipper_private_offset);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_cd_ripper_finalize;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_signals[NOISE_CD_RIPPER_MEDIA_RIPPED_SIGNAL] = g_signal_new ("media-ripped", NOISE_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, NOISE_TYPE_MEDIA, G_TYPE_BOOLEAN);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_signals[NOISE_CD_RIPPER_PROGRESS_NOTIFICATION_SIGNAL] = g_signal_new ("progress-notification", NOISE_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	noise_cd_ripper_signals[NOISE_CD_RIPPER_ERROR_SIGNAL] = g_signal_new ("error", NOISE_TYPE_CD_RIPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, gst_message_get_type ());
#line 937 "CDRipper.c"
}


static void
noise_cd_ripper_instance_init (NoiseCDRipper * self)
{
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	self->priv = noise_cd_ripper_get_instance_private (self);
#line 946 "CDRipper.c"
}


static void
noise_cd_ripper_finalize (GObject * obj)
{
	NoiseCDRipper * self;
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_CD_RIPPER, NoiseCDRipper);
#line 30 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->pipeline);
#line 31 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->src);
#line 32 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->queue);
#line 33 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->filter);
#line 34 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->sink);
#line 36 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_object_unref0 (self->priv->current_media);
#line 37 "../plugins/Devices/CDRom/CDRipper.vala"
	_g_free0 (self->priv->_device);
#line 29 "../plugins/Devices/CDRom/CDRipper.vala"
	G_OBJECT_CLASS (noise_cd_ripper_parent_class)->finalize (obj);
#line 972 "CDRipper.c"
}


GType
noise_cd_ripper_get_type (void)
{
	return noise_cd_ripper_type_id;
}


GType
noise_cd_ripper_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoiseCDRipperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_cd_ripper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseCDRipper), 0, (GInstanceInitFunc) noise_cd_ripper_instance_init, NULL };
	noise_cd_ripper_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoiseCDRipper", &g_define_type_info, 0);
	NoiseCDRipper_private_offset = sizeof (NoiseCDRipperPrivate);
	return noise_cd_ripper_type_id;
}



