/* GenericList.c generated by valac 0.42.6, the Vala compiler
 * generated from GenericList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;
typedef struct _NoiseGenericListPrivate NoiseGenericListPrivate;
typedef enum  {
	NOISE_LIST_COLUMN_ICON = 0,
	NOISE_LIST_COLUMN_NUMBER,
	NOISE_LIST_COLUMN_TRACK,
	NOISE_LIST_COLUMN_TITLE,
	NOISE_LIST_COLUMN_LENGTH,
	NOISE_LIST_COLUMN_ARTIST,
	NOISE_LIST_COLUMN_ALBUM,
	NOISE_LIST_COLUMN_ALBUM_ARTIST,
	NOISE_LIST_COLUMN_COMPOSER,
	NOISE_LIST_COLUMN_GENRE,
	NOISE_LIST_COLUMN_YEAR,
	NOISE_LIST_COLUMN_GROUPING,
	NOISE_LIST_COLUMN_BITRATE,
	NOISE_LIST_COLUMN_RATING,
	NOISE_LIST_COLUMN_PLAY_COUNT,
	NOISE_LIST_COLUMN_SKIP_COUNT,
	NOISE_LIST_COLUMN_DATE_ADDED,
	NOISE_LIST_COLUMN_LAST_PLAYED,
	NOISE_LIST_COLUMN_BPM,
	NOISE_LIST_COLUMN_FILE_LOCATION,
	NOISE_LIST_COLUMN_FILE_SIZE,
	NOISE_LIST_COLUMN_N_COLUMNS
} NoiseListColumn;


#define NOISE_TYPE_LIST_COLUMN (noise_list_column_get_type ())

#define NOISE_TYPE_FAST_MODEL (noise_fast_model_get_type ())
#define NOISE_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModel))
#define NOISE_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))
#define NOISE_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_MODEL))
#define NOISE_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_MODEL))
#define NOISE_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))

typedef struct _NoiseFastModel NoiseFastModel;
typedef struct _NoiseFastModelClass NoiseFastModelClass;

#define NOISE_TYPE_CELL_DATA_FUNCTION_HELPER (noise_cell_data_function_helper_get_type ())
#define NOISE_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelper))
#define NOISE_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelperClass))
#define NOISE_IS_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER))
#define NOISE_IS_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER))
#define NOISE_CELL_DATA_FUNCTION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelperClass))

typedef struct _NoiseCellDataFunctionHelper NoiseCellDataFunctionHelper;
typedef struct _NoiseCellDataFunctionHelperClass NoiseCellDataFunctionHelperClass;

#define NOISE_TYPE_TREE_VIEW_SETUP (noise_tree_view_setup_get_type ())
#define NOISE_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup))
#define NOISE_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))
#define NOISE_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))

typedef struct _NoiseTreeViewSetup NoiseTreeViewSetup;
typedef struct _NoiseTreeViewSetupClass NoiseTreeViewSetupClass;

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;
typedef gint (*NoiseGenericListSortCompareFunc) (gint sort_column_id, GtkSortType sort_direction, NoiseMedia* a, NoiseMedia* b, gint index_a, gint index_b, gpointer user_data);
typedef void (*NoiseGenericListViewSearchFunc) (const gchar* search, GeeArrayList* table, GeeArrayList* showing, gpointer user_data);
enum  {
	NOISE_GENERIC_LIST_0_PROPERTY,
	NOISE_GENERIC_LIST_COLUMNS_PROPERTY,
	NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY,
	NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY,
	NOISE_GENERIC_LIST_PLAYLIST_PROPERTY,
	NOISE_GENERIC_LIST_TVS_PROPERTY,
	NOISE_GENERIC_LIST_HINT_PROPERTY,
	NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY,
	NOISE_GENERIC_LIST_NUM_PROPERTIES
};
static GParamSpec* noise_generic_list_properties[NOISE_GENERIC_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _noise_cell_data_function_helper_unref0(var) ((var == NULL) ? NULL : (var = (noise_cell_data_function_helper_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
typedef struct _NoiseGenericListMediaPlayedData NoiseGenericListMediaPlayedData;

#define NOISE_TYPE_LOCAL_LIBRARY (noise_local_library_get_type ())
#define NOISE_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary))
#define NOISE_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))
#define NOISE_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))

typedef struct _NoiseLocalLibrary NoiseLocalLibrary;
typedef struct _NoiseLocalLibraryClass NoiseLocalLibraryClass;
typedef struct _NoiseLocalLibraryPrivate NoiseLocalLibraryPrivate;
typedef struct _NoiseLibraryWindowPrivate NoiseLibraryWindowPrivate;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;

#define NOISE_TYPE_LIST_VIEW (noise_list_view_get_type ())
#define NOISE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIST_VIEW, NoiseListView))
#define NOISE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))
#define NOISE_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIST_VIEW))
#define NOISE_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIST_VIEW))
#define NOISE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))

typedef struct _NoiseListView NoiseListView;
typedef struct _NoiseListViewClass NoiseListViewClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef GValue* (*NoiseFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
enum  {
	NOISE_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL,
	NOISE_GENERIC_LIST_ROWS_REORDERED_SIGNAL,
	NOISE_GENERIC_LIST_NUM_SIGNALS
};
static guint noise_generic_list_signals[NOISE_GENERIC_LIST_NUM_SIGNALS] = {0};

struct _NoiseGenericList {
	GtkTreeView parent_instance;
	NoiseGenericListPrivate * priv;
	NoiseFastModel* fm;
	GeeArrayList* table;
	GeeArrayList* showing;
	gint sort_column_id;
	GtkSortType sort_direction;
	gboolean dragging;
	NoiseCellDataFunctionHelper* cell_data_helper;
};

struct _NoiseGenericListClass {
	GtkTreeViewClass parent_class;
	void (*add_column) (NoiseGenericList* self, GtkTreeViewColumn* column, NoiseListColumn type);
	void (*mediaRemoveClicked) (NoiseGenericList* self);
};

struct _NoiseGenericListPrivate {
	GeeList* _columns;
	gboolean _research_needed;
	gboolean _is_current_list;
	NoisePlaylist* _playlist;
	NoiseTreeViewSetup* _tvs;
	NoiseViewWrapper* _parent_wrapper;
	NoiseGenericListSortCompareFunc compare_func;
	gpointer compare_func_target;
	NoiseGenericListViewSearchFunc search_func;
	gpointer search_func_target;
};

struct _NoiseGenericListMediaPlayedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseGenericList* self;
	NoiseMedia* m;
};

struct _NoiseLocalLibrary {
	NoiseLibrary parent_instance;
	NoiseLocalLibraryPrivate * priv;
	NoiseStaticPlaylist* p_music;
};

struct _NoiseLocalLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoiseLibraryWindow {
	GtkWindow parent_instance;
	NoiseLibraryWindowPrivate * priv;
	GeeHashMap* match_playlists;
};

struct _NoiseLibraryWindowClass {
	GtkWindowClass parent_class;
	void (*playback_stopped) (NoiseLibraryWindow* self, gint64 was_playing);
	void (*play_media) (NoiseLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_next_media) (NoiseLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_previous_media) (NoiseLibraryWindow* self, gboolean inhibit_notifications);
	void (*action_import) (NoiseLibraryWindow* self);
	void (*end_of_stream) (NoiseLibraryWindow* self);
	void (*error_occured) (NoiseLibraryWindow* self);
	void (*current_position_update) (NoiseLibraryWindow* self, gint64 position);
	void (*dragReceived) (NoiseLibraryWindow* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint timestamp);
};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};


static gint NoiseGenericList_private_offset;
static gpointer noise_generic_list_parent_class = NULL;

GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_list_column_get_type (void) G_GNUC_CONST;
GType noise_fast_model_get_type (void) G_GNUC_CONST;
gpointer noise_cell_data_function_helper_ref (gpointer instance);
void noise_cell_data_function_helper_unref (gpointer instance);
GParamSpec* noise_param_spec_cell_data_function_helper (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
void noise_value_set_cell_data_function_helper (GValue* value,
                                                gpointer v_object);
void noise_value_take_cell_data_function_helper (GValue* value,
                                                 gpointer v_object);
gpointer noise_value_get_cell_data_function_helper (const GValue* value);
GType noise_cell_data_function_helper_get_type (void) G_GNUC_CONST;
GType noise_tree_view_setup_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
#define NOISE_GENERIC_LIST_OPTIMAL_COLUMN -2
NoiseGenericList* noise_generic_list_construct (GType object_type,
                                                NoiseViewWrapper* view_wrapper,
                                                NoiseTreeViewSetup* tvs);
void noise_generic_list_add_column (NoiseGenericList* self,
                                    GtkTreeViewColumn* column,
                                    NoiseListColumn type);
static void noise_generic_list_real_add_column (NoiseGenericList* self,
                                         GtkTreeViewColumn* column,
                                         NoiseListColumn type);
void noise_generic_list_mediaRemoveClicked (NoiseGenericList* self);
static void noise_generic_list_real_mediaRemoveClicked (NoiseGenericList* self);
void noise_generic_list_set_media (NoiseGenericList* self,
                                   GeeCollection* to_add);
void noise_generic_list_set_table (NoiseGenericList* self,
                                   GeeArrayList* table,
                                   gboolean do_resort);
void noise_generic_list_scroll_to_current_media (NoiseGenericList* self,
                                                 gboolean unfilter_if_not_found);
void noise_generic_list_set_fixed_column_width (NoiseGenericList* self,
                                                GtkWidget* treeview,
                                                GtkTreeViewColumn* column,
                                                GtkCellRendererText* renderer,
                                                gchar** strings,
                                                int strings_length1,
                                                gint padding);
static NoiseMedia* noise_generic_list_get_media_from_index (NoiseGenericList* self,
                                                     gint index);
NoiseMedia* noise_generic_list_get_object_from_index (NoiseGenericList* self,
                                                      gint index);
void noise_generic_list_on_rating_cell_changed (NoiseGenericList* self,
                                                gint new_rating,
                                                GtkWidget* widget,
                                                const gchar* path);
NoiseViewWrapper* noise_generic_list_get_parent_wrapper (NoiseGenericList* self);
NoiseLibrary* noise_view_wrapper_get_library (NoiseViewWrapper* self);
static void noise_generic_list_on_rows_reordered (NoiseGenericList* self);
gboolean noise_generic_list_get_is_current_list (NoiseGenericList* self);
void noise_generic_list_set_as_current_list (NoiseGenericList* self,
                                             NoiseMedia* m);
static void noise_generic_list_real_row_activated (GtkTreeView* base,
                                            GtkTreePath* path,
                                            GtkTreeViewColumn* column);
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
NoiseViewWrapperHint noise_generic_list_get_hint (NoiseGenericList* self);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_library_window_play_media (NoiseLibraryWindow* self,
                                      gboolean inhibit_notifications);
static void noise_generic_list_media_played_data_free (gpointer _data);
static void noise_generic_list_media_played_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data);
static void noise_generic_list_media_played (NoiseGenericList* self,
                                      NoiseMedia* m,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void noise_generic_list_media_played_finish (NoiseGenericList* self,
                                             GAsyncResult* _res_);
static gboolean noise_generic_list_media_played_co (NoiseGenericListMediaPlayedData* _data_);
static gboolean _noise_generic_list_media_played_co_gsource_func (gpointer self);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
static void noise_generic_list_set_is_current_list (NoiseGenericList* self,
                                             gboolean value);
NoisePlaylist* noise_generic_list_get_playlist (NoiseGenericList* self);
GType noise_local_library_get_type (void) G_GNUC_CONST;
GSettings* noise_app_get_saved_state (void);
static GeeList* noise_generic_list_start_at (NoiseGenericList* self,
                                      NoiseMedia* start,
                                      GeeList* media);
GeeBidirList* noise_generic_list_get_visible_table (NoiseGenericList* self);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                         GeeCollection* to_queue);
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
GType noise_list_view_get_type (void) G_GNUC_CONST;
NoiseListView* noise_view_wrapper_get_list_view (NoiseViewWrapper* self);
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
NoiseMusicListView* noise_list_view_get_list_view (NoiseListView* self);
void noise_generic_list_set_sort_column_id (NoiseGenericList* self,
                                            gint sort_column_id,
                                            GtkSortType order);
NoiseTreeViewSetup* noise_generic_list_get_tvs (NoiseGenericList* self);
NoiseListColumn noise_tree_view_setup_get_sort_column_id (NoiseTreeViewSetup* self);
GtkSortType noise_tree_view_setup_get_sort_direction (NoiseTreeViewSetup* self);
GeeCollection* noise_generic_list_get_selected_medias (NoiseGenericList* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
GeeBidirList* noise_generic_list_get_table (NoiseGenericList* self);
gint noise_generic_list_get_index_from_iter (GtkTreeIter* iter);
void noise_generic_list_set_value_func (NoiseGenericList* self,
                                        NoiseFastModelValueReturnFunc func,
                                        gpointer func_target);
void noise_fast_model_set_value_func (NoiseFastModel* self,
                                      NoiseFastModelValueReturnFunc func,
                                      gpointer func_target);
void noise_generic_list_resort (NoiseGenericList* self);
void noise_generic_list_do_search (NoiseGenericList* self,
                                   const gchar* search);
void noise_generic_list_set_search_func (NoiseGenericList* self,
                                         NoiseGenericListViewSearchFunc func,
                                         gpointer func_target);
gboolean noise_generic_list_get_research_needed (NoiseGenericList* self);
void noise_generic_list_set_research_needed (NoiseGenericList* self,
                                             gboolean value);
void noise_fast_model_set_table (NoiseFastModel* self,
                                 GeeArrayList* table);
void noise_fast_model_remove (NoiseFastModel* self,
                              GtkTreeIter* iter);
void noise_fast_model_append (NoiseFastModel* self,
                              GtkTreeIter* iter);
static void noise_generic_list_reorder_requested (NoiseGenericList* self,
                                           gint column,
                                           GtkSortType direction);
static void noise_generic_list_quicksort (NoiseGenericList* self,
                                   gint start,
                                   gint end);
void noise_generic_list_set_compare_func (NoiseGenericList* self,
                                          NoiseGenericListSortCompareFunc func,
                                          gpointer func_target);
static void noise_generic_list_swap (NoiseGenericList* self,
                              gint a,
                              gint b);
static void noise_generic_list_on_drag_begin (NoiseGenericList* self,
                                       GtkWidget* sender,
                                       GdkDragContext* context);
static void noise_generic_list_on_drag_data_get (NoiseGenericList* self,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time_);
static void _vala_array_add13 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void noise_generic_list_on_drag_end (NoiseGenericList* self,
                                     GtkWidget* sender,
                                     GdkDragContext* context);
GeeList* noise_generic_list_get_columns (NoiseGenericList* self);
void noise_generic_list_set_columns (NoiseGenericList* self,
                                     GeeList* value);
void noise_generic_list_set_playlist (NoiseGenericList* self,
                                      NoisePlaylist* value);
void noise_generic_list_set_tvs (NoiseGenericList* self,
                                 NoiseTreeViewSetup* value);
NoiseViewWrapperHint noise_tree_view_setup_get_hint (NoiseTreeViewSetup* self);
void noise_generic_list_set_hint (NoiseGenericList* self,
                                  NoiseViewWrapperHint value);
void noise_tree_view_setup_set_hint (NoiseTreeViewSetup* self,
                                     NoiseViewWrapperHint value);
void noise_generic_list_set_parent_wrapper (NoiseGenericList* self,
                                            NoiseViewWrapper* value);
NoisePlaylist* noise_view_wrapper_get_playlist (NoiseViewWrapper* self);
static GObject * noise_generic_list_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
GeeCollection* noise_list_column_get_all (void);
GType noise_list_column_get_data_type (NoiseListColumn self);
NoiseFastModel* noise_fast_model_new (GeeList* column_types);
NoiseFastModel* noise_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static void _noise_generic_list_reorder_requested_noise_fast_model_reorder_requested (NoiseFastModel* _sender,
                                                                               gint column,
                                                                               GtkSortType direction,
                                                                               gpointer self);
NoiseCellDataFunctionHelper* noise_cell_data_function_helper_new (NoiseGenericList* view);
NoiseCellDataFunctionHelper* noise_cell_data_function_helper_construct (GType object_type,
                                                                        NoiseGenericList* view);
GeeCollection* noise_tree_view_setup_get_columns (NoiseTreeViewSetup* self);
NoiseListColumn* noise_tree_view_setup_get_column_type (GtkTreeViewColumn* column);
static void _noise_generic_list_on_rows_reordered_noise_generic_list_rows_reordered (NoiseGenericList* _sender,
                                                                              gpointer self);
static gboolean _noise_generic_list___lambda39_ (NoiseGenericList* self,
                                          GdkEventKey* event);
static gboolean __noise_generic_list___lambda39__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void _noise_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self);
static void _noise_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    GtkSelectionData* selection_data,
                                                                    guint info,
                                                                    guint time_,
                                                                    gpointer self);
static void _noise_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gpointer self);
static void _gtk_widget_queue_draw_noise_library_media_updated (NoiseLibrary* _sender,
                                                         GeeCollection* medias,
                                                         gpointer self);
static void _noise_generic_list___lambda40_ (NoiseGenericList* self);
static void __noise_generic_list___lambda40__noise_playback_manager_queue_cleared (NoisePlaybackManager* _sender,
                                                                            gpointer self);
static void _noise_generic_list_media_played_noise_playback_manager_media_played (NoisePlaybackManager* _sender,
                                                                           NoiseMedia* played_media,
                                                                           gpointer self);
static void noise_generic_list_finalize (GObject * obj);
static void _vala_noise_generic_list_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_noise_generic_list_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
noise_generic_list_get_instance_private (NoiseGenericList* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseGenericList_private_offset);
}


NoiseGenericList*
noise_generic_list_construct (GType object_type,
                              NoiseViewWrapper* view_wrapper,
                              NoiseTreeViewSetup* tvs)
{
	NoiseGenericList * self = NULL;
#line 94 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (view_wrapper != NULL, NULL);
#line 94 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (tvs != NULL, NULL);
#line 95 "../src/Views/ListView/Lists/GenericList.vala"
	self = (NoiseGenericList*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
#line 94 "../src/Views/ListView/Lists/GenericList.vala"
	return self;
#line 595 "GenericList.c"
}


static void
noise_generic_list_real_add_column (NoiseGenericList* self,
                                    GtkTreeViewColumn* column,
                                    NoiseListColumn type)
{
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_generic_list_add_column'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	return;
#line 608 "GenericList.c"
}


void
noise_generic_list_add_column (NoiseGenericList* self,
                               GtkTreeViewColumn* column,
                               NoiseListColumn type)
{
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Views/ListView/Lists/GenericList.vala"
	NOISE_GENERIC_LIST_GET_CLASS (self)->add_column (self, column, type);
#line 621 "GenericList.c"
}


static void
noise_generic_list_real_mediaRemoveClicked (NoiseGenericList* self)
{
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	g_critical ("Type `%s' does not implement abstract method `noise_generic_list_mediaRemoveClicked'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	return;
#line 632 "GenericList.c"
}


void
noise_generic_list_mediaRemoveClicked (NoiseGenericList* self)
{
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/Views/ListView/Lists/GenericList.vala"
	NOISE_GENERIC_LIST_GET_CLASS (self)->mediaRemoveClicked (self);
#line 643 "GenericList.c"
}


void
noise_generic_list_set_media (NoiseGenericList* self,
                              GeeCollection* to_add)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
#line 160 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (to_add != NULL);
#line 161 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 161 "../src/Views/ListView/Lists/GenericList.vala"
	new_table = _tmp0_;
#line 162 "../src/Views/ListView/Lists/GenericList.vala"
	gee_array_list_add_all (new_table, to_add);
#line 165 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_table (self, new_table, TRUE);
#line 167 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_scroll_to_current_media (self, FALSE);
#line 160 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (new_table);
#line 669 "GenericList.c"
}


void
noise_generic_list_set_fixed_column_width (NoiseGenericList* self,
                                           GtkWidget* treeview,
                                           GtkTreeViewColumn* column,
                                           GtkCellRendererText* renderer,
                                           gchar** strings,
                                           int strings_length1,
                                           gint padding)
{
	gint max_width = 0;
	gint _tmp7_;
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (treeview != NULL);
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (column != NULL);
#line 170 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (renderer != NULL);
#line 171 "../src/Views/ListView/Lists/GenericList.vala"
	max_width = 0;
#line 694 "GenericList.c"
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
		str_collection = strings;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
		str_collection_length1 = strings_length1;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
		for (str_it = 0; str_it < strings_length1; str_it = str_it + 1) {
#line 706 "GenericList.c"
			const gchar* str = NULL;
#line 173 "../src/Views/ListView/Lists/GenericList.vala"
			str = str_collection[str_it];
#line 710 "GenericList.c"
			{
				const gchar* _tmp0_;
				GtkRequisition natural_size = {0};
				GtkRequisition _tmp1_ = {0};
				GtkRequisition _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
#line 174 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp0_ = str;
#line 174 "../src/Views/ListView/Lists/GenericList.vala"
				g_object_set (renderer, "text", _tmp0_, NULL);
#line 177 "../src/Views/ListView/Lists/GenericList.vala"
				gtk_cell_renderer_get_preferred_size ((GtkCellRenderer*) renderer, treeview, NULL, &_tmp1_);
#line 177 "../src/Views/ListView/Lists/GenericList.vala"
				natural_size = _tmp1_;
#line 179 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp2_ = natural_size;
#line 179 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp3_ = _tmp2_.width;
#line 179 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp4_ = max_width;
#line 179 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp3_ > _tmp4_) {
#line 734 "GenericList.c"
					GtkRequisition _tmp5_;
					gint _tmp6_;
#line 180 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp5_ = natural_size;
#line 180 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp6_ = _tmp5_.width;
#line 180 "../src/Views/ListView/Lists/GenericList.vala"
					max_width = _tmp6_;
#line 743 "GenericList.c"
				}
			}
		}
	}
#line 183 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp7_ = max_width;
#line 183 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_column_set_fixed_width (column, _tmp7_ + padding);
#line 752 "GenericList.c"
}


static NoiseMedia*
noise_generic_list_get_media_from_index (NoiseGenericList* self,
                                         gint index)
{
	NoiseMedia* result = NULL;
	NoiseMedia* _tmp0_;
#line 186 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = noise_generic_list_get_object_from_index (self, index);
#line 187 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 187 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 770 "GenericList.c"
}


void
noise_generic_list_on_rating_cell_changed (NoiseGenericList* self,
                                           gint new_rating,
                                           GtkWidget* widget,
                                           const gchar* path)
{
	NoiseMedia* m = NULL;
	NoiseMedia* _tmp0_;
	GeeTreeSet* to_update = NULL;
	GeeTreeSet* _tmp1_;
	NoiseViewWrapper* _tmp2_;
	NoiseViewWrapper* _tmp3_;
	NoiseLibrary* _tmp4_;
	NoiseLibrary* _tmp5_;
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (widget != NULL);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (path != NULL);
#line 193 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = noise_generic_list_get_media_from_index (self, atoi (path));
#line 193 "../src/Views/ListView/Lists/GenericList.vala"
	m = _tmp0_;
#line 195 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (m != NULL);
#line 197 "../src/Views/ListView/Lists/GenericList.vala"
	noise_media_set_rating (m, (guint) new_rating);
#line 199 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 199 "../src/Views/ListView/Lists/GenericList.vala"
	to_update = _tmp1_;
#line 200 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) to_update, m);
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = noise_generic_list_get_parent_wrapper (self);
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = noise_view_wrapper_get_library (_tmp3_);
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 201 "../src/Views/ListView/Lists/GenericList.vala"
	noise_library_update_medias (_tmp5_, (GeeCollection*) to_update, TRUE, TRUE);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (to_update);
#line 192 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (m);
#line 822 "GenericList.c"
}


static void
noise_generic_list_on_rows_reordered (NoiseGenericList* self)
{
	gboolean _tmp0_;
#line 204 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_scroll_to_current_media (self, FALSE);
#line 206 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_is_current_list;
#line 206 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_) {
#line 207 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_as_current_list (self, NULL);
#line 840 "GenericList.c"
	}
}


static void
noise_generic_list_real_row_activated (GtkTreeView* base,
                                       GtkTreePath* path,
                                       GtkTreeViewColumn* column)
{
	NoiseGenericList * self;
	NoiseMedia* m = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	NoiseViewWrapperHint _tmp5_;
	NoisePlaybackManager* _tmp11_;
	NoisePlaybackManager* _tmp12_;
	NoiseMedia* _tmp13_;
	NoisePlaybackManager* _tmp14_;
	NoisePlaybackManager* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	self = (NoiseGenericList*) base;
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (path != NULL);
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (column != NULL);
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gtk_tree_path_to_string (path);
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = noise_generic_list_get_media_from_index (self, atoi (_tmp1_));
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp1_);
#line 211 "../src/Views/ListView/Lists/GenericList.vala"
	m = _tmp3_;
#line 214 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = noise_generic_list_get_hint (self);
#line 214 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 214 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp5_ == NOISE_VIEW_WRAPPER_HINT_QUEUE) {
#line 889 "GenericList.c"
		NoisePlaybackManager* _tmp6_;
		NoisePlaybackManager* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp6_ = noise_app_get_player ();
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp7_ = _tmp6_;
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp8_ = gtk_tree_path_to_string (path);
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp9_ = _tmp8_;
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		noise_playback_manager_set_current_index (_tmp7_, atoi (_tmp9_));
#line 215 "../src/Views/ListView/Lists/GenericList.vala"
		_g_free0 (_tmp9_);
#line 906 "GenericList.c"
	} else {
		NoiseMedia* _tmp10_;
#line 217 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp10_ = m;
#line 217 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_as_current_list (self, _tmp10_);
#line 913 "GenericList.c"
	}
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = noise_app_get_player ();
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp12_ = _tmp11_;
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = m;
#line 221 "../src/Views/ListView/Lists/GenericList.vala"
	noise_playback_manager_play_media (_tmp12_, _tmp13_);
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp14_ = noise_app_get_player ();
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp15_ = _tmp14_;
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp16_ = noise_playback_manager_get_playing (_tmp15_);
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp17_ = _tmp16_;
#line 223 "../src/Views/ListView/Lists/GenericList.vala"
	if (!_tmp17_) {
#line 933 "GenericList.c"
		NoiseLibraryWindow* _tmp18_;
		NoiseLibraryWindow* _tmp19_;
#line 224 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp18_ = noise_app_get_main_window ();
#line 224 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp19_ = _tmp18_;
#line 224 "../src/Views/ListView/Lists/GenericList.vala"
		noise_library_window_play_media (_tmp19_, FALSE);
#line 942 "GenericList.c"
	}
#line 210 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (m);
#line 946 "GenericList.c"
}


static void
noise_generic_list_media_played_data_free (gpointer _data)
{
	NoiseGenericListMediaPlayedData* _data_;
	_data_ = _data;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_data_->m);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_slice_free (NoiseGenericListMediaPlayedData, _data_);
#line 961 "GenericList.c"
}


static void
noise_generic_list_media_played_async_ready_wrapper (GObject *source_object,
                                                     GAsyncResult *res,
                                                     void *user_data)
{
	NoiseGenericListMediaPlayedData* _task_data_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	if (_task_data_->_callback_ != NULL) {
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 977 "GenericList.c"
	}
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_task_data_->_task_complete_ = TRUE;
#line 981 "GenericList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	return self ? g_object_ref (self) : NULL;
#line 990 "GenericList.c"
}


static void
noise_generic_list_media_played (NoiseGenericList* self,
                                 NoiseMedia* m,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	NoiseGenericListMediaPlayedData* _data_;
	NoiseGenericList* _tmp0_;
	NoiseMedia* _tmp1_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_ = g_slice_new0 (NoiseGenericListMediaPlayedData);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->_callback_ = _callback_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_generic_list_media_played_async_ready_wrapper, _user_data_);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	if (_callback_ == NULL) {
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		_data_->_task_complete_ = TRUE;
#line 1013 "GenericList.c"
	}
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_generic_list_media_played_data_free);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->self = _tmp0_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _g_object_ref0 (m);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_data_->m);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->m = _tmp1_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_media_played_co (_data_);
#line 1029 "GenericList.c"
}


static void
noise_generic_list_media_played_finish (NoiseGenericList* self,
                                        GAsyncResult* _res_)
{
	NoiseGenericListMediaPlayedData* _data_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1040 "GenericList.c"
}


static gboolean
_noise_generic_list_media_played_co_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_generic_list_media_played_co (self);
#line 231 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 1051 "GenericList.c"
}


static gboolean
noise_generic_list_media_played_co (NoiseGenericListMediaPlayedData* _data_)
{
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	switch (_data_->_state_) {
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		case 0:
#line 1062 "GenericList.c"
		goto _state_0;
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		case 1:
#line 1066 "GenericList.c"
		goto _state_1;
		default:
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		g_assert_not_reached ();
#line 1071 "GenericList.c"
	}
	_state_0:
#line 229 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_widget_queue_draw ((GtkWidget*) _data_->self);
#line 231 "../src/Views/ListView/Lists/GenericList.vala"
	g_idle_add_full (G_PRIORITY_HIGH_IDLE + 10, _noise_generic_list_media_played_co_gsource_func, _data_, NULL);
#line 232 "../src/Views/ListView/Lists/GenericList.vala"
	_data_->_state_ = 1;
#line 232 "../src/Views/ListView/Lists/GenericList.vala"
	return FALSE;
#line 1082 "GenericList.c"
	_state_1:
	;
#line 234 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_scroll_to_current_media (_data_->self, FALSE);
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	if (_data_->_state_ != 0) {
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
		while (!_data_->_task_complete_) {
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1095 "GenericList.c"
		}
	}
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_unref (_data_->_async_result);
#line 228 "../src/Views/ListView/Lists/GenericList.vala"
	return FALSE;
#line 1102 "GenericList.c"
}


void
noise_generic_list_set_as_current_list (NoiseGenericList* self,
                                        NoiseMedia* m)
{
	NoiseMedia* _tmp0_ = NULL;
	NoiseMedia* to_set = NULL;
	NoiseMedia* _tmp5_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp6_;
	NoiseSettingsMain* _tmp7_;
	GeeList* queue = NULL;
	NoiseMedia* _tmp43_;
	GeeBidirList* _tmp44_;
	GeeBidirList* _tmp45_;
	GeeList* _tmp46_;
	GeeList* _tmp47_;
	NoisePlaybackManager* _tmp62_;
	NoisePlaybackManager* _tmp63_;
	NoisePlaybackManager* _tmp64_;
	NoisePlaybackManager* _tmp65_;
	GeeList* _tmp66_;
	NoisePlaybackManager* _tmp67_;
	NoisePlaybackManager* _tmp68_;
	NoiseViewWrapper* view = NULL;
	NoiseLibraryWindow* _tmp69_;
	NoiseLibraryWindow* _tmp70_;
	GeeHashMap* _tmp71_;
	NoisePlaybackManager* _tmp72_;
	NoisePlaybackManager* _tmp73_;
	NoiseStaticPlaylist* _tmp74_;
	gpointer _tmp75_;
	NoiseListView* _tmp76_;
	NoiseListView* _tmp77_;
	NoiseMusicListView* _tmp78_;
	NoiseMusicListView* _tmp79_;
	NoiseTreeViewSetup* _tmp80_;
	NoiseListColumn _tmp81_;
	NoiseListColumn _tmp82_;
	NoiseTreeViewSetup* _tmp83_;
	GtkSortType _tmp84_;
	GtkSortType _tmp85_;
	NoisePlaybackManager* _tmp86_;
	NoisePlaybackManager* _tmp87_;
	NoiseMedia* _tmp88_;
	NoiseMedia* _tmp89_;
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
	if (m == NULL) {
#line 1155 "GenericList.c"
		NoisePlaybackManager* _tmp1_;
		NoisePlaybackManager* _tmp2_;
		NoiseMedia* _tmp3_;
		NoiseMedia* _tmp4_;
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp1_ = noise_app_get_player ();
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = _tmp1_;
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp3_ = noise_playback_manager_get_current_media (_tmp2_);
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp4_ = _tmp3_;
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _tmp4_;
#line 1170 "GenericList.c"
	} else {
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = m;
#line 1174 "GenericList.c"
	}
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _g_object_ref0 (_tmp0_);
#line 238 "../src/Views/ListView/Lists/GenericList.vala"
	to_set = _tmp5_;
#line 240 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_is_current_list (self, TRUE);
#line 241 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp6_ = noise_settings_main_get_default ();
#line 241 "../src/Views/ListView/Lists/GenericList.vala"
	main_settings = _tmp6_;
#line 243 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp7_ = main_settings;
#line 243 "../src/Views/ListView/Lists/GenericList.vala"
	if (!noise_settings_main_privacy_mode_enabled (_tmp7_)) {
#line 1190 "GenericList.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		NoisePlaylist* _tmp10_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp10_ = self->priv->_playlist;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp10_ == NULL) {
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = TRUE;
#line 1200 "GenericList.c"
		} else {
			NoisePlaylist* _tmp11_;
			NoiseLibrariesManager* _tmp12_;
			NoiseLibrary* _tmp13_;
			NoiseStaticPlaylist* _tmp14_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp11_ = self->priv->_playlist;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp12_ = noise_libraries_manager;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp13_ = _tmp12_->local_library;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary)->p_music;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = _tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_PLAYLIST, NoisePlaylist);
#line 1216 "GenericList.c"
		}
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp9_) {
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = TRUE;
#line 1222 "GenericList.c"
		} else {
			NoiseViewWrapper* _tmp15_;
			NoiseViewWrapper* _tmp16_;
			NoiseLibrary* _tmp17_;
			NoiseLibrary* _tmp18_;
			NoiseLibrariesManager* _tmp19_;
			NoiseLibrary* _tmp20_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp15_ = noise_generic_list_get_parent_wrapper (self);
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp16_ = _tmp15_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp17_ = noise_view_wrapper_get_library (_tmp16_);
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp18_ = _tmp17_;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp19_ = noise_libraries_manager;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp20_ = _tmp19_->local_library;
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = _tmp18_ != _tmp20_;
#line 1244 "GenericList.c"
		}
#line 244 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp8_) {
#line 1248 "GenericList.c"
			GSettings* _tmp21_;
			GSettings* _tmp22_;
#line 245 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp21_ = noise_app_get_saved_state ();
#line 245 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp22_ = _tmp21_;
#line 245 "../src/Views/ListView/Lists/GenericList.vala"
			g_settings_set_string (_tmp22_, "last-playlist-playing", "");
#line 1257 "GenericList.c"
		} else {
			NoisePlaylist* _tmp23_;
#line 246 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp23_ = self->priv->_playlist;
#line 246 "../src/Views/ListView/Lists/GenericList.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, NOISE_TYPE_SMART_PLAYLIST)) {
#line 1264 "GenericList.c"
				GSettings* _tmp24_;
				GSettings* _tmp25_;
				NoisePlaylist* _tmp26_;
				gint64 _tmp27_;
				gint64 _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp24_ = noise_app_get_saved_state ();
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp25_ = _tmp24_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp26_ = self->priv->_playlist;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp27_ = noise_playlist_get_rowid (_tmp26_);
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp28_ = _tmp27_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp29_ = g_strdup_printf ("s%lld", _tmp28_);
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp30_ = _tmp29_;
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				g_settings_set_string (_tmp25_, "last-playlist-playing", _tmp30_);
#line 247 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp30_);
#line 1290 "GenericList.c"
			} else {
				NoisePlaylist* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp31_ = self->priv->_playlist;
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp32_ = noise_static_playlist_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist));
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp33_ = _tmp32_;
#line 249 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp33_ == FALSE) {
#line 1303 "GenericList.c"
					GSettings* _tmp34_;
					GSettings* _tmp35_;
					NoisePlaylist* _tmp36_;
					gint64 _tmp37_;
					gint64 _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp34_ = noise_app_get_saved_state ();
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp35_ = _tmp34_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp36_ = self->priv->_playlist;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp37_ = noise_playlist_get_rowid (_tmp36_);
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp38_ = _tmp37_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp39_ = g_strdup_printf ("p%lld", _tmp38_);
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp40_ = _tmp39_;
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					g_settings_set_string (_tmp35_, "last-playlist-playing", _tmp40_);
#line 250 "../src/Views/ListView/Lists/GenericList.vala"
					_g_free0 (_tmp40_);
#line 1329 "GenericList.c"
				} else {
					GSettings* _tmp41_;
					GSettings* _tmp42_;
#line 252 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp41_ = noise_app_get_saved_state ();
#line 252 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp42_ = _tmp41_;
#line 252 "../src/Views/ListView/Lists/GenericList.vala"
					g_settings_set_string (_tmp42_, "last-playlist-playing", "");
#line 1339 "GenericList.c"
				}
			}
		}
	}
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp43_ = to_set;
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp44_ = noise_generic_list_get_visible_table (self);
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp45_ = _tmp44_;
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp46_ = noise_generic_list_start_at (self, _tmp43_, (GeeList*) _tmp45_);
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp47_ = _tmp46_;
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp45_);
#line 257 "../src/Views/ListView/Lists/GenericList.vala"
	queue = _tmp47_;
#line 1358 "GenericList.c"
	{
		GeeList* _q_list = NULL;
		GeeList* _tmp48_;
		GeeList* _tmp49_;
		gint _q_size = 0;
		GeeList* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		gint _q_index = 0;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp48_ = queue;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp49_ = _g_object_ref0 (_tmp48_);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_q_list = _tmp49_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp50_ = _q_list;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp51_ = gee_collection_get_size ((GeeCollection*) _tmp50_);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp52_ = _tmp51_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_q_size = _tmp52_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_q_index = -1;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 1386 "GenericList.c"
			gint _tmp53_;
			gint _tmp54_;
			gint _tmp55_;
			NoiseMedia* q = NULL;
			GeeList* _tmp56_;
			gint _tmp57_;
			gpointer _tmp58_;
			NoiseMedia* _tmp59_;
			const gchar* _tmp60_;
			const gchar* _tmp61_;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp53_ = _q_index;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_q_index = _tmp53_ + 1;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp54_ = _q_index;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp55_ = _q_size;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			if (!(_tmp54_ < _tmp55_)) {
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 1409 "GenericList.c"
			}
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp56_ = _q_list;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp57_ = _q_index;
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp58_ = gee_list_get (_tmp56_, _tmp57_);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			q = (NoiseMedia*) _tmp58_;
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp59_ = q;
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp60_ = noise_media_get_title (_tmp59_);
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp61_ = _tmp60_;
#line 259 "../src/Views/ListView/Lists/GenericList.vala"
			g_debug ("GenericList.vala:259: QUEING: %s", _tmp61_);
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
			_g_object_unref0 (q);
#line 1429 "GenericList.c"
		}
#line 258 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_q_list);
#line 1433 "GenericList.c"
	}
#line 261 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp62_ = noise_app_get_player ();
#line 261 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp63_ = _tmp62_;
#line 261 "../src/Views/ListView/Lists/GenericList.vala"
	noise_playback_manager_clear_queue (_tmp63_);
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp64_ = noise_app_get_player ();
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp65_ = _tmp64_;
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp66_ = queue;
#line 262 "../src/Views/ListView/Lists/GenericList.vala"
	noise_playback_manager_queue_media (_tmp65_, (GeeCollection*) _tmp66_);
#line 263 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp67_ = noise_app_get_player ();
#line 263 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp68_ = _tmp67_;
#line 263 "../src/Views/ListView/Lists/GenericList.vala"
	noise_playback_manager_set_current_index (_tmp68_, 0);
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp69_ = noise_app_get_main_window ();
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp70_ = _tmp69_;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp71_ = _tmp70_->match_playlists;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp72_ = noise_app_get_player ();
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp73_ = _tmp72_;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp74_ = _tmp73_->queue_playlist;
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp75_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp71_, (NoisePlaylist*) _tmp74_);
#line 266 "../src/Views/ListView/Lists/GenericList.vala"
	view = (NoiseViewWrapper*) _tmp75_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp76_ = noise_view_wrapper_get_list_view (view);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp77_ = _tmp76_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp78_ = noise_list_view_get_list_view (_tmp77_);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp79_ = _tmp78_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp80_ = self->priv->_tvs;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp81_ = noise_tree_view_setup_get_sort_column_id (_tmp80_);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp82_ = _tmp81_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp83_ = self->priv->_tvs;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp84_ = noise_tree_view_setup_get_sort_direction (_tmp83_);
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp85_ = _tmp84_;
#line 267 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_sort_column_id ((NoiseGenericList*) _tmp79_, (gint) _tmp82_, _tmp85_);
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp86_ = noise_app_get_player ();
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp87_ = _tmp86_;
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp88_ = noise_playback_manager_get_current_media (_tmp87_);
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp89_ = _tmp88_;
#line 269 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_media_played (self, _tmp89_, NULL, NULL);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (view);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (queue);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (main_settings);
#line 237 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (to_set);
#line 1511 "GenericList.c"
}


/**
    * Shift a list (of media) to make it start at a given element
    */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1513 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	result = self;
#line 1514 "glib-2.0.vapi"
	return result;
#line 1528 "GenericList.c"
}


static GeeList*
noise_generic_list_start_at (NoiseGenericList* self,
                             NoiseMedia* start,
                             GeeList* media)
{
	GeeList* result = NULL;
	gint index = 0;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gint _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeArrayList* res = NULL;
	GeeArrayList* _tmp31_;
	GeeArrayList* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	GeeList* _tmp36_;
	GeeList* _tmp37_;
	GeeArrayList* _tmp38_;
	gint _tmp39_;
	GeeList* _tmp40_;
	GeeList* _tmp41_;
#line 275 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 275 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (start != NULL, NULL);
#line 275 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (media != NULL, NULL);
#line 276 "../src/Views/ListView/Lists/GenericList.vala"
	index = 0;
#line 1574 "GenericList.c"
	{
		gboolean _tmp0_ = FALSE;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = TRUE;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 1581 "GenericList.c"
			gboolean _tmp2_ = FALSE;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp0_) {
#line 1588 "GenericList.c"
				gint _tmp1_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp1_ = index;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				index = _tmp1_ + 1;
#line 1594 "GenericList.c"
			}
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp0_ = FALSE;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp3_ = index;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp4_ = gee_collection_get_size ((GeeCollection*) media);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp5_ = _tmp4_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			if (_tmp3_ < _tmp5_) {
#line 1606 "GenericList.c"
				gint _tmp6_;
				gpointer _tmp7_;
				NoiseMedia* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = index;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = gee_list_get (media, _tmp6_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = (NoiseMedia*) _tmp7_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = noise_media_get_uri (_tmp8_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = _tmp9_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = _tmp10_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = noise_media_get_uri (start);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp13_ = _tmp12_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp14_ = _tmp13_;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp2_ = g_strcmp0 (_tmp11_, _tmp14_) != 0;
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp14_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp11_);
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp8_);
#line 1642 "GenericList.c"
			} else {
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp2_ = FALSE;
#line 1646 "GenericList.c"
			}
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp2_) {
#line 277 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 1652 "GenericList.c"
			}
		}
	}
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp15_ = noise_media_get_title (start);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp16_ = _tmp15_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp17_ = string_to_string (_tmp16_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp18_ = gee_collection_get_size ((GeeCollection*) media);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp19_ = _tmp18_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp20_ = g_strdup_printf ("%i", _tmp19_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp21_ = _tmp20_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp22_ = index;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp23_ = g_strdup_printf ("%i", _tmp22_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp24_ = _tmp23_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp25_ = g_strconcat ("TO START: '", _tmp17_, "', size = ", _tmp21_, ", index: ", _tmp24_, NULL);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp26_ = _tmp25_;
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	g_debug ("GenericList.vala:278: %s", _tmp26_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp26_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp24_);
#line 278 "../src/Views/ListView/Lists/GenericList.vala"
	_g_free0 (_tmp21_);
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp27_ = index;
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp28_ = gee_collection_get_size ((GeeCollection*) media);
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp29_ = _tmp28_;
#line 280 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp27_ == _tmp29_) {
#line 1696 "GenericList.c"
		GeeList* _tmp30_;
#line 281 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp30_ = _g_object_ref0 (media);
#line 281 "../src/Views/ListView/Lists/GenericList.vala"
		result = _tmp30_;
#line 281 "../src/Views/ListView/Lists/GenericList.vala"
		return result;
#line 1704 "GenericList.c"
	}
#line 284 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp31_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 284 "../src/Views/ListView/Lists/GenericList.vala"
	res = _tmp31_;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp32_ = res;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp33_ = index;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp34_ = gee_collection_get_size ((GeeCollection*) media);
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp35_ = _tmp34_;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp36_ = gee_list_slice (media, _tmp33_, _tmp35_);
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp37_ = _tmp36_;
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	gee_array_list_add_all (_tmp32_, (GeeCollection*) _tmp37_);
#line 285 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp37_);
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp38_ = res;
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp39_ = index;
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp40_ = gee_list_slice (media, 0, _tmp39_);
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp41_ = _tmp40_;
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	gee_array_list_add_all (_tmp38_, (GeeCollection*) _tmp41_);
#line 286 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp41_);
#line 287 "../src/Views/ListView/Lists/GenericList.vala"
	result = (GeeList*) res;
#line 287 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 1742 "GenericList.c"
}


static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 1751 "GenericList.c"
}


static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 1760 "GenericList.c"
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1769 "GenericList.c"
}


static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 1778 "GenericList.c"
}


static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 1787 "GenericList.c"
}


GeeCollection*
noise_generic_list_get_selected_medias (NoiseGenericList* self)
{
	GeeCollection* result = NULL;
	GeeArrayQueue* rv = NULL;
	GeeArrayQueue* _tmp0_;
	GtkTreeModel* temp = NULL;
	GtkTreeSelection* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GList* _tmp3_;
	GtkTreeModel* _tmp4_;
#line 290 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 291 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_queue_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 291 "../src/Views/ListView/Lists/GenericList.vala"
	rv = _tmp0_;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = gtk_tree_selection_get_selected_rows (_tmp1_, &_tmp2_);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (temp);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = _g_object_ref0 (_tmp2_);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
	temp = _tmp4_;
#line 1818 "GenericList.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
		path_collection = _tmp3_;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 1826 "GenericList.c"
			GtkTreePath* _tmp5_;
			GtkTreePath* path = NULL;
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
			path = _tmp5_;
#line 1833 "GenericList.c"
			{
				NoiseMedia* m = NULL;
				GtkTreePath* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				NoiseMedia* _tmp9_;
				NoiseMedia* _tmp10_;
				GeeArrayQueue* _tmp11_;
				NoiseMedia* _tmp12_;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = path;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = gtk_tree_path_to_string (_tmp6_);
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = _tmp7_;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = noise_generic_list_get_media_from_index (self, atoi (_tmp8_));
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = _tmp9_;
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				_g_free0 (_tmp8_);
#line 295 "../src/Views/ListView/Lists/GenericList.vala"
				m = _tmp10_;
#line 296 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = rv;
#line 296 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = m;
#line 296 "../src/Views/ListView/Lists/GenericList.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (m);
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
				__vala_GtkTreePath_free0 (path);
#line 1867 "GenericList.c"
			}
		}
#line 294 "../src/Views/ListView/Lists/GenericList.vala"
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free___vala_GtkTreePath_free0_ (path_collection), NULL));
#line 1872 "GenericList.c"
	}
#line 299 "../src/Views/ListView/Lists/GenericList.vala"
	result = (GeeCollection*) rv;
#line 299 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (temp);
#line 299 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 1880 "GenericList.c"
}


void
noise_generic_list_scroll_to_current_media (NoiseGenericList* self,
                                            gboolean unfilter_if_not_found)
{
	NoisePlaybackManager* _tmp0_;
	NoisePlaybackManager* _tmp1_;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp3_;
#line 302 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = noise_app_get_player ();
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = noise_playback_manager_get_current_media (_tmp1_);
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 303 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp3_ == NULL) {
#line 304 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 1906 "GenericList.c"
	}
	{
		gint i = 0;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
		i = 0;
#line 1912 "GenericList.c"
		{
			gboolean _tmp4_ = FALSE;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp4_ = TRUE;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
			while (TRUE) {
#line 1919 "GenericList.c"
				gint _tmp6_;
				GeeBidirList* _tmp7_;
				GeeBidirList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gboolean _tmp11_;
				NoiseMedia* m = NULL;
				gint _tmp12_;
				NoiseMedia* _tmp13_;
				NoiseMedia* _tmp14_;
				NoisePlaybackManager* _tmp15_;
				NoisePlaybackManager* _tmp16_;
				NoiseMedia* _tmp17_;
				NoiseMedia* _tmp18_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				if (!_tmp4_) {
#line 1936 "GenericList.c"
					gint _tmp5_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp5_ = i;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
					i = _tmp5_ + 1;
#line 1942 "GenericList.c"
				}
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp4_ = FALSE;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp6_ = i;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp7_ = noise_generic_list_get_visible_table (self);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = _tmp7_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = _tmp9_;
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = !(_tmp6_ < _tmp10_);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp8_);
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp11_) {
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
					break;
#line 1964 "GenericList.c"
				}
#line 307 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = i;
#line 307 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp13_ = noise_generic_list_get_media_from_index (self, _tmp12_);
#line 307 "../src/Views/ListView/Lists/GenericList.vala"
				m = _tmp13_;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp14_ = m;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp15_ = noise_app_get_player ();
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp16_ = _tmp15_;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp17_ = noise_playback_manager_get_current_media (_tmp16_);
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp18_ = _tmp17_;
#line 309 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp14_ == _tmp18_) {
#line 1984 "GenericList.c"
					GtkTreePath* path = NULL;
					gint _tmp19_;
					GtkTreePath* _tmp20_;
					gboolean center_cell = FALSE;
					GtkTreePath* start_path = NULL;
					GtkTreePath* end_path = NULL;
					GtkTreePath* _tmp21_ = NULL;
					GtkTreePath* _tmp22_ = NULL;
					gboolean _tmp23_;
					GtkTreePath* _tmp37_;
					gboolean _tmp38_;
					GtkTreeViewColumn* column = NULL;
					GtkTreeViewColumn* _tmp39_;
					GtkTreeViewColumn* _tmp40_;
					GtkTreePath* _tmp41_;
					GtkTreeViewColumn* _tmp42_;
					GtkTreeViewColumn* _tmp43_;
					GList* _tmp44_;
					GList* _tmp45_;
					gconstpointer _tmp46_;
#line 310 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp19_ = i;
#line 310 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp20_ = gtk_tree_path_new_from_indices (_tmp19_, -1, -1);
#line 310 "../src/Views/ListView/Lists/GenericList.vala"
					path = _tmp20_;
#line 315 "../src/Views/ListView/Lists/GenericList.vala"
					center_cell = FALSE;
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp23_ = gtk_tree_view_get_visible_range ((GtkTreeView*) self, &_tmp21_, &_tmp22_);
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (start_path);
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					start_path = _tmp21_;
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (end_path);
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					end_path = _tmp22_;
#line 319 "../src/Views/ListView/Lists/GenericList.vala"
					if (_tmp23_) {
#line 2025 "GenericList.c"
						gint start_index = 0;
						GtkTreePath* _tmp24_;
						gint _tmp25_ = 0;
						gint* _tmp26_;
						gint _tmp27_;
						gint end_index = 0;
						GtkTreePath* _tmp28_;
						gint _tmp29_ = 0;
						gint* _tmp30_;
						gint _tmp31_;
						gboolean _tmp32_ = FALSE;
						gint _tmp33_;
						gint _tmp34_;
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp24_ = start_path;
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp26_ = gtk_tree_path_get_indices_with_depth (_tmp24_, &_tmp25_);
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp27_ = _tmp26_[0];
#line 320 "../src/Views/ListView/Lists/GenericList.vala"
						start_index = _tmp27_;
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp28_ = end_path;
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp30_ = gtk_tree_path_get_indices_with_depth (_tmp28_, &_tmp29_);
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp31_ = _tmp30_[0];
#line 321 "../src/Views/ListView/Lists/GenericList.vala"
						end_index = _tmp31_;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp33_ = i;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp34_ = start_index;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
						if (_tmp33_ < (_tmp34_ - 1)) {
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
							_tmp32_ = TRUE;
#line 2063 "GenericList.c"
						} else {
							gint _tmp35_;
							gint _tmp36_;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
							_tmp35_ = i;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
							_tmp36_ = end_index;
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
							_tmp32_ = _tmp35_ > (_tmp36_ + 1);
#line 2073 "GenericList.c"
						}
#line 328 "../src/Views/ListView/Lists/GenericList.vala"
						if (_tmp32_) {
#line 329 "../src/Views/ListView/Lists/GenericList.vala"
							center_cell = TRUE;
#line 2079 "GenericList.c"
						}
					}
#line 332 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp37_ = path;
#line 332 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp38_ = center_cell;
#line 332 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp37_, NULL, _tmp38_, 0.5f, (gfloat) 0);
#line 334 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp39_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
#line 334 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp40_ = _g_object_ref0 (_tmp39_);
#line 334 "../src/Views/ListView/Lists/GenericList.vala"
					column = _tmp40_;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp41_ = path;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp42_ = column;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp43_ = column;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp44_ = gtk_cell_layout_get_cells ((GtkCellLayout*) _tmp43_);
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp45_ = _tmp44_;
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp46_ = g_list_nth_data (_tmp45_, (guint) 0);
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp41_, _tmp42_, (GtkCellRenderer*) _tmp46_, FALSE);
#line 335 "../src/Views/ListView/Lists/GenericList.vala"
					(_tmp45_ == NULL) ? NULL : (_tmp45_ = (g_list_free (_tmp45_), NULL));
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					_g_object_unref0 (column);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (end_path);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (start_path);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					__vala_GtkTreePath_free0 (path);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					_g_object_unref0 (m);
#line 337 "../src/Views/ListView/Lists/GenericList.vala"
					break;
#line 2122 "GenericList.c"
				}
#line 306 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (m);
#line 2126 "GenericList.c"
			}
		}
	}
}


/** Should not be manipulated by client */
GeeBidirList*
noise_generic_list_get_table (NoiseGenericList* self)
{
	GeeBidirList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 343 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp2_;
#line 344 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2153 "GenericList.c"
}


/** Should not be manipulated by client */
GeeBidirList*
noise_generic_list_get_visible_table (NoiseGenericList* self)
{
	GeeBidirList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 348 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->showing;
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp2_;
#line 349 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2177 "GenericList.c"
}


gint
noise_generic_list_get_index_from_iter (GtkTreeIter* iter)
{
	gint result = 0;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
#line 352 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (iter != NULL, 0);
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = *iter;
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_.user_data;
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	result = (gint) _tmp1_;
#line 353 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2197 "GenericList.c"
}


NoiseMedia*
noise_generic_list_get_object_from_index (NoiseGenericList* self,
                                          gint index)
{
	NoiseMedia* result = NULL;
	NoiseMedia* _tmp0_ = NULL;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 356 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = self->showing;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = _tmp2_;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	if (index < _tmp3_) {
#line 2220 "GenericList.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp4_ = self->showing;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, index);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp0_);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = (NoiseMedia*) _tmp5_;
#line 2231 "GenericList.c"
	} else {
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp0_);
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = NULL;
#line 2237 "GenericList.c"
	}
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 357 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 2243 "GenericList.c"
}


void
noise_generic_list_set_value_func (NoiseGenericList* self,
                                   NoiseFastModelValueReturnFunc func,
                                   gpointer func_target)
{
	NoiseFastModel* _tmp0_;
#line 360 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->fm;
#line 361 "../src/Views/ListView/Lists/GenericList.vala"
	noise_fast_model_set_value_func (_tmp0_, func, func_target);
#line 2259 "GenericList.c"
}


void
noise_generic_list_set_table (NoiseGenericList* self,
                              GeeArrayList* table,
                              gboolean do_resort)
{
	GeeArrayList* _tmp0_;
#line 364 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 364 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (table != NULL);
#line 365 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = _g_object_ref0 (table);
#line 365 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->table);
#line 365 "../src/Views/ListView/Lists/GenericList.vala"
	self->table = _tmp0_;
#line 367 "../src/Views/ListView/Lists/GenericList.vala"
	if (do_resort) {
#line 368 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_resort (self);
#line 2283 "GenericList.c"
	} else {
#line 370 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_do_search (self, NULL);
#line 2287 "GenericList.c"
	}
}


void
noise_generic_list_set_search_func (NoiseGenericList* self,
                                    NoiseGenericListViewSearchFunc func,
                                    gpointer func_target)
{
#line 374 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->search_func = func;
#line 375 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->search_func_target = func_target;
#line 2303 "GenericList.c"
}


void
noise_generic_list_do_search (NoiseGenericList* self,
                              const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	NoiseGenericListViewSearchFunc _tmp1_;
	void* _tmp1__target;
	gint old_size = 0;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	const gchar* _tmp7_ = NULL;
	NoiseGenericListViewSearchFunc _tmp8_;
	void* _tmp8__target;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 378 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = self->priv->search_func;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1__target = self->priv->search_func_target;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp1_ == NULL) {
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = TRUE;
#line 2338 "GenericList.c"
	} else {
		gboolean _tmp2_;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = self->priv->_research_needed;
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _tmp2_ == FALSE;
#line 2345 "GenericList.c"
	}
#line 379 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_) {
#line 380 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 2351 "GenericList.c"
	}
#line 383 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_research_needed (self, FALSE);
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->showing;
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 384 "../src/Views/ListView/Lists/GenericList.vala"
	old_size = _tmp5_;
#line 386 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp6_ = self->showing;
#line 386 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp6_);
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp7_ = search;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp7_ == NULL) {
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp7_ = "";
#line 2373 "GenericList.c"
	}
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp8_ = self->priv->search_func;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp8__target = self->priv->search_func_target;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp9_ = self->table;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp10_ = self->showing;
#line 387 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp8_ (_tmp7_, _tmp9_, _tmp10_, _tmp8__target);
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = self->showing;
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = _tmp12_;
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp14_ = old_size;
#line 389 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp13_ == _tmp14_) {
#line 2395 "GenericList.c"
		NoiseFastModel* _tmp15_;
		GeeArrayList* _tmp16_;
#line 390 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp15_ = self->fm;
#line 390 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp16_ = self->showing;
#line 390 "../src/Views/ListView/Lists/GenericList.vala"
		noise_fast_model_set_table (_tmp15_, _tmp16_);
#line 391 "../src/Views/ListView/Lists/GenericList.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 2406 "GenericList.c"
	} else {
		gint _tmp17_;
#line 392 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp17_ = old_size;
#line 392 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp17_ == 0) {
#line 2413 "GenericList.c"
			NoiseFastModel* _tmp18_;
			GeeArrayList* _tmp19_;
			NoiseFastModel* _tmp20_;
#line 393 "../src/Views/ListView/Lists/GenericList.vala"
			gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
#line 394 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp18_ = self->fm;
#line 394 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp19_ = self->showing;
#line 394 "../src/Views/ListView/Lists/GenericList.vala"
			noise_fast_model_set_table (_tmp18_, _tmp19_);
#line 395 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp20_ = self->fm;
#line 395 "../src/Views/ListView/Lists/GenericList.vala"
			gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp20_);
#line 2429 "GenericList.c"
		} else {
			gint _tmp21_;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp21_ = old_size;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp22_ = self->showing;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp24_ = _tmp23_;
#line 396 "../src/Views/ListView/Lists/GenericList.vala"
			if (_tmp21_ > _tmp24_) {
#line 2445 "GenericList.c"
				NoiseFastModel* _tmp34_;
				GeeArrayList* _tmp35_;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
				while (TRUE) {
#line 2450 "GenericList.c"
					NoiseFastModel* _tmp25_;
					GeeArrayList* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					GtkTreeIter iter = {0};
					NoiseFastModel* _tmp29_;
					NoiseFastModel* _tmp30_;
					GtkTreeIter _tmp31_ = {0};
					NoiseFastModel* _tmp32_;
					GtkTreeIter _tmp33_;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp25_ = self->fm;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp26_ = self->showing;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp28_ = _tmp27_;
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp25_, NULL) > _tmp28_)) {
#line 397 "../src/Views/ListView/Lists/GenericList.vala"
						break;
#line 2473 "GenericList.c"
					}
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp29_ = self->fm;
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp30_ = self->fm;
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp29_, &_tmp31_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp30_, NULL) - 1);
#line 399 "../src/Views/ListView/Lists/GenericList.vala"
					iter = _tmp31_;
#line 400 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp32_ = self->fm;
#line 400 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp33_ = iter;
#line 400 "../src/Views/ListView/Lists/GenericList.vala"
					noise_fast_model_remove (_tmp32_, &_tmp33_);
#line 2489 "GenericList.c"
				}
#line 403 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp34_ = self->fm;
#line 403 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp35_ = self->showing;
#line 403 "../src/Views/ListView/Lists/GenericList.vala"
				noise_fast_model_set_table (_tmp34_, _tmp35_);
#line 404 "../src/Views/ListView/Lists/GenericList.vala"
				gtk_widget_queue_draw ((GtkWidget*) self);
#line 2499 "GenericList.c"
			} else {
				GeeArrayList* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp36_ = self->showing;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp38_ = _tmp37_;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp39_ = old_size;
#line 405 "../src/Views/ListView/Lists/GenericList.vala"
				if (_tmp38_ > _tmp39_) {
#line 2515 "GenericList.c"
					GtkTreeIter iter = {0};
					NoiseFastModel* _tmp46_;
					GeeArrayList* _tmp47_;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
					while (TRUE) {
#line 2521 "GenericList.c"
						NoiseFastModel* _tmp40_;
						GeeArrayList* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						NoiseFastModel* _tmp44_;
						GtkTreeIter _tmp45_ = {0};
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp40_ = self->fm;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp41_ = self->showing;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp43_ = _tmp42_;
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp40_, NULL) < _tmp43_)) {
#line 408 "../src/Views/ListView/Lists/GenericList.vala"
							break;
#line 2540 "GenericList.c"
						}
#line 409 "../src/Views/ListView/Lists/GenericList.vala"
						_tmp44_ = self->fm;
#line 409 "../src/Views/ListView/Lists/GenericList.vala"
						noise_fast_model_append (_tmp44_, &_tmp45_);
#line 409 "../src/Views/ListView/Lists/GenericList.vala"
						iter = _tmp45_;
#line 2548 "GenericList.c"
					}
#line 412 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp46_ = self->fm;
#line 412 "../src/Views/ListView/Lists/GenericList.vala"
					_tmp47_ = self->showing;
#line 412 "../src/Views/ListView/Lists/GenericList.vala"
					noise_fast_model_set_table (_tmp46_, _tmp47_);
#line 413 "../src/Views/ListView/Lists/GenericList.vala"
					gtk_widget_queue_draw ((GtkWidget*) self);
#line 2558 "GenericList.c"
				}
			}
		}
	}
}


void
noise_generic_list_set_sort_column_id (NoiseGenericList* self,
                                       gint sort_column_id,
                                       GtkSortType order)
{
	NoiseFastModel* _tmp0_;
#line 421 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->fm;
#line 422 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, sort_column_id, order);
#line 2578 "GenericList.c"
}


static void
noise_generic_list_reorder_requested (NoiseGenericList* self,
                                      gint column,
                                      GtkSortType direction)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 425 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = self->sort_column_id;
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
	if (column == _tmp1_) {
#line 2598 "GenericList.c"
		GtkSortType _tmp2_;
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = self->sort_direction;
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = direction == _tmp2_;
#line 2604 "GenericList.c"
	} else {
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = FALSE;
#line 2608 "GenericList.c"
	}
#line 426 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_) {
#line 427 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 2614 "GenericList.c"
	}
#line 430 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_column_id = column;
#line 431 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_direction = direction;
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->table;
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = _tmp4_;
#line 433 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_quicksort (self, 0, _tmp5_ - 1);
#line 434 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_research_needed (self, TRUE);
#line 435 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_do_search (self, NULL);
#line 438 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_emit (self, noise_generic_list_signals[NOISE_GENERIC_LIST_ROWS_REORDERED_SIGNAL], 0);
#line 2634 "GenericList.c"
}


void
noise_generic_list_resort (NoiseGenericList* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 441 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 442 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_quicksort (self, 0, _tmp2_ - 1);
#line 444 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_research_needed (self, TRUE);
#line 445 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_do_search (self, NULL);
#line 2658 "GenericList.c"
}


void
noise_generic_list_set_compare_func (NoiseGenericList* self,
                                     NoiseGenericListSortCompareFunc func,
                                     gpointer func_target)
{
#line 448 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->compare_func = func;
#line 449 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->compare_func_target = func_target;
#line 2673 "GenericList.c"
}


static void
noise_generic_list_swap (NoiseGenericList* self,
                         gint a,
                         gint b)
{
	NoiseMedia* temp = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	NoiseMedia* _tmp5_;
	GeeArrayList* _tmp6_;
#line 452 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 453 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, a);
#line 453 "../src/Views/ListView/Lists/GenericList.vala"
	temp = (NoiseMedia*) _tmp1_;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = self->table;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->table;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, b);
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = (NoiseMedia*) _tmp4_;
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp2_, a, _tmp5_);
#line 454 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp5_);
#line 455 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp6_ = self->table;
#line 455 "../src/Views/ListView/Lists/GenericList.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp6_, b, temp);
#line 452 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (temp);
#line 2716 "GenericList.c"
}


static void
noise_generic_list_quicksort (NoiseGenericList* self,
                              gint start,
                              gint end)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint pivot_index = 0;
	NoiseMedia* pivot = NULL;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gpointer _tmp5_;
	gint i = 0;
	gint j = 0;
	gint _tmp40_;
	gint _tmp42_;
#line 458 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->table;
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 459 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp2_ == 0) {
#line 460 "../src/Views/ListView/Lists/GenericList.vala"
		return;
#line 2749 "GenericList.c"
	}
#line 463 "../src/Views/ListView/Lists/GenericList.vala"
	pivot_index = (start + end) / 2;
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp3_ = self->table;
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp4_ = pivot_index;
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, _tmp4_);
#line 464 "../src/Views/ListView/Lists/GenericList.vala"
	pivot = (NoiseMedia*) _tmp5_;
#line 465 "../src/Views/ListView/Lists/GenericList.vala"
	i = start;
#line 466 "../src/Views/ListView/Lists/GenericList.vala"
	j = end;
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
	while (TRUE) {
#line 2767 "GenericList.c"
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp34_;
		gint _tmp35_;
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp6_ = i;
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp7_ = j;
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
		if (!(_tmp6_ <= _tmp7_)) {
#line 468 "../src/Views/ListView/Lists/GenericList.vala"
			break;
#line 2780 "GenericList.c"
		}
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 2784 "GenericList.c"
			gboolean _tmp8_ = FALSE;
			gint _tmp9_;
			gint _tmp20_;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = i;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			if (_tmp9_ < end) {
#line 2792 "GenericList.c"
				NoiseGenericListSortCompareFunc _tmp10_;
				void* _tmp10__target;
				gint _tmp11_;
				GtkSortType _tmp12_;
				GeeArrayList* _tmp13_;
				gint _tmp14_;
				gpointer _tmp15_;
				NoiseMedia* _tmp16_;
				NoiseMedia* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10_ = self->priv->compare_func;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp10__target = self->priv->compare_func_target;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp11_ = self->sort_column_id;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp12_ = self->sort_direction;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp13_ = self->table;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp14_ = i;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _tmp14_);
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp16_ = (NoiseMedia*) _tmp15_;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp17_ = pivot;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp18_ = i;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp19_ = pivot_index;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = _tmp10_ (_tmp11_, _tmp12_, _tmp16_, _tmp17_, _tmp18_, _tmp19_, _tmp10__target) < 0;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp16_);
#line 2830 "GenericList.c"
			} else {
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp8_ = FALSE;
#line 2834 "GenericList.c"
			}
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp8_) {
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 2840 "GenericList.c"
			}
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp20_ = i;
#line 469 "../src/Views/ListView/Lists/GenericList.vala"
			i = _tmp20_ + 1;
#line 2846 "GenericList.c"
		}
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 2850 "GenericList.c"
			gboolean _tmp21_ = FALSE;
			gint _tmp22_;
			gint _tmp33_;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp22_ = j;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			if (_tmp22_ > start) {
#line 2858 "GenericList.c"
				NoiseGenericListSortCompareFunc _tmp23_;
				void* _tmp23__target;
				gint _tmp24_;
				GtkSortType _tmp25_;
				GeeArrayList* _tmp26_;
				gint _tmp27_;
				gpointer _tmp28_;
				NoiseMedia* _tmp29_;
				NoiseMedia* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp23_ = self->priv->compare_func;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp23__target = self->priv->compare_func_target;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp24_ = self->sort_column_id;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp25_ = self->sort_direction;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp26_ = self->table;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp27_ = j;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp26_, _tmp27_);
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp29_ = (NoiseMedia*) _tmp28_;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp30_ = pivot;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp31_ = j;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp32_ = pivot_index;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp21_ = _tmp23_ (_tmp24_, _tmp25_, _tmp29_, _tmp30_, _tmp31_, _tmp32_, _tmp23__target) > 0;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_g_object_unref0 (_tmp29_);
#line 2896 "GenericList.c"
			} else {
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				_tmp21_ = FALSE;
#line 2900 "GenericList.c"
			}
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			if (!_tmp21_) {
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 2906 "GenericList.c"
			}
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp33_ = j;
#line 470 "../src/Views/ListView/Lists/GenericList.vala"
			j = _tmp33_ - 1;
#line 2912 "GenericList.c"
		}
#line 471 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp34_ = i;
#line 471 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp35_ = j;
#line 471 "../src/Views/ListView/Lists/GenericList.vala"
		if (_tmp34_ <= _tmp35_) {
#line 2920 "GenericList.c"
			gint _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
#line 472 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp36_ = i;
#line 472 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp37_ = j;
#line 472 "../src/Views/ListView/Lists/GenericList.vala"
			noise_generic_list_swap (self, _tmp36_, _tmp37_);
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp38_ = i;
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			i = _tmp38_ + 1;
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp39_ = j;
#line 473 "../src/Views/ListView/Lists/GenericList.vala"
			j = _tmp39_ - 1;
#line 2939 "GenericList.c"
		}
	}
#line 477 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp40_ = j;
#line 477 "../src/Views/ListView/Lists/GenericList.vala"
	if (start < _tmp40_) {
#line 2946 "GenericList.c"
		gint _tmp41_;
#line 478 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp41_ = j;
#line 478 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_quicksort (self, start, _tmp41_);
#line 2952 "GenericList.c"
	}
#line 480 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp42_ = i;
#line 480 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp42_ < end) {
#line 2958 "GenericList.c"
		gint _tmp43_;
#line 481 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp43_ = i;
#line 481 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_quicksort (self, _tmp43_, end);
#line 2964 "GenericList.c"
	}
#line 458 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (pivot);
#line 2968 "GenericList.c"
}


/** **********************************************************
     * Drag and drop support. GenericList is a source for media and can
     * be dragged to a playlist in the sidebar. No support for reordering
     * is implemented yet.
    ***************************************************************/
static void
noise_generic_list_on_drag_begin (NoiseGenericList* self,
                                  GtkWidget* sender,
                                  GdkDragContext* context)
{
	gint selected_rows = 0;
	GtkTreeSelection* _tmp0_;
	gint _tmp1_;
#line 490 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 490 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (sender != NULL);
#line 490 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (context != NULL);
#line 491 "../src/Views/ListView/Lists/GenericList.vala"
	self->dragging = TRUE;
#line 492 "../src/Views/ListView/Lists/GenericList.vala"
	g_debug ("GenericList.vala:492: drag begin");
#line 494 "../src/Views/ListView/Lists/GenericList.vala"
	gdk_drag_abort (context, gtk_get_current_event_time ());
#line 496 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 496 "../src/Views/ListView/Lists/GenericList.vala"
	selected_rows = gtk_tree_selection_count_selected_rows (_tmp0_);
#line 498 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = selected_rows;
#line 498 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp1_ > 0) {
#line 499 "../src/Views/ListView/Lists/GenericList.vala"
		gtk_drag_source_set_icon_name ((GtkWidget*) self, "audio-x-generic");
#line 3007 "GenericList.c"
	}
}


static void
_vala_array_add13 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
	if ((*length) == (*size)) {
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3024 "GenericList.c"
	}
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
	(*array)[(*length)++] = value;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
	(*array)[*length] = NULL;
#line 3030 "GenericList.c"
}


static void
noise_generic_list_on_drag_data_get (NoiseGenericList* self,
                                     GdkDragContext* context,
                                     GtkSelectionData* selection_data,
                                     guint info,
                                     guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (context != NULL);
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (selection_data != NULL);
#line 503 "../src/Views/ListView/Lists/GenericList.vala"
	uris = NULL;
#line 503 "../src/Views/ListView/Lists/GenericList.vala"
	uris_length1 = 0;
#line 503 "../src/Views/ListView/Lists/GenericList.vala"
	_uris_size_ = uris_length1;
#line 3058 "GenericList.c"
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = noise_generic_list_get_selected_medias (self);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp1_ = _tmp0_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp3_ = _tmp2_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp1_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_m_it = _tmp3_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 3079 "GenericList.c"
			GeeIterator* _tmp4_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			NoiseMedia* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp4_ = _m_it;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 3095 "GenericList.c"
			}
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp5_ = _m_it;
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			m = (NoiseMedia*) _tmp6_;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp7_ = uris;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp7__length1 = uris_length1;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = m;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = noise_media_get_uri (_tmp8_);
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp10_ = _tmp9_;
#line 506 "../src/Views/ListView/Lists/GenericList.vala"
			_vala_array_add13 (&uris, &uris_length1, &_uris_size_, _tmp10_);
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
			_g_object_unref0 (m);
#line 3117 "GenericList.c"
		}
#line 505 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_m_it);
#line 3121 "GenericList.c"
	}
#line 508 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = uris;
#line 508 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11__length1 = uris_length1;
#line 508 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp11_ != NULL) {
#line 3129 "GenericList.c"
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 509 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp12_ = uris;
#line 509 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp12__length1 = uris_length1;
#line 509 "../src/Views/ListView/Lists/GenericList.vala"
		gtk_selection_data_set_uris (selection_data, _tmp12_);
#line 3138 "GenericList.c"
	}
#line 502 "../src/Views/ListView/Lists/GenericList.vala"
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
#line 3142 "GenericList.c"
}


static void
noise_generic_list_on_drag_end (NoiseGenericList* self,
                                GtkWidget* sender,
                                GdkDragContext* context)
{
	GtkTargetEntry* _tmp0_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
#line 512 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 512 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (sender != NULL);
#line 512 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (context != NULL);
#line 513 "../src/Views/ListView/Lists/GenericList.vala"
	self->dragging = FALSE;
#line 515 "../src/Views/ListView/Lists/GenericList.vala"
	g_debug ("GenericList.vala:515: drag end\n");
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1__length1 = 0;
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp1_, 0, GDK_ACTION_COPY | GDK_ACTION_MOVE);
#line 518 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 3174 "GenericList.c"
}


GeeList*
noise_generic_list_get_columns (NoiseGenericList* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_columns;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3191 "GenericList.c"
}


void
noise_generic_list_set_columns (NoiseGenericList* self,
                                GeeList* value)
{
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	if (noise_generic_list_get_columns (self) != value) {
#line 3203 "GenericList.c"
		GeeList* _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (self->priv->_columns);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_columns = _tmp0_;
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_COLUMNS_PROPERTY]);
#line 3213 "GenericList.c"
	}
}


gboolean
noise_generic_list_get_research_needed (NoiseGenericList* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_research_needed;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3231 "GenericList.c"
}


void
noise_generic_list_set_research_needed (NoiseGenericList* self,
                                        gboolean value)
{
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	if (noise_generic_list_get_research_needed (self) != value) {
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_research_needed = value;
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY]);
#line 3247 "GenericList.c"
	}
}


gboolean
noise_generic_list_get_is_current_list (NoiseGenericList* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_is_current_list;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3265 "GenericList.c"
}


static void
noise_generic_list_set_is_current_list (NoiseGenericList* self,
                                        gboolean value)
{
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
	if (noise_generic_list_get_is_current_list (self) != value) {
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_is_current_list = value;
#line 36 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY]);
#line 3281 "GenericList.c"
	}
}


NoisePlaylist*
noise_generic_list_get_playlist (NoiseGenericList* self)
{
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_playlist;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3299 "GenericList.c"
}


void
noise_generic_list_set_playlist (NoiseGenericList* self,
                                 NoisePlaylist* value)
{
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	if (noise_generic_list_get_playlist (self) != value) {
#line 3311 "GenericList.c"
		NoisePlaylist* _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (self->priv->_playlist);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_playlist = _tmp0_;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_PLAYLIST_PROPERTY]);
#line 3321 "GenericList.c"
	}
}


NoiseTreeViewSetup*
noise_generic_list_get_tvs (NoiseGenericList* self)
{
	NoiseTreeViewSetup* result;
	NoiseTreeViewSetup* _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_tvs;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3339 "GenericList.c"
}


void
noise_generic_list_set_tvs (NoiseGenericList* self,
                            NoiseTreeViewSetup* value)
{
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	if (noise_generic_list_get_tvs (self) != value) {
#line 3351 "GenericList.c"
		NoiseTreeViewSetup* _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (self->priv->_tvs);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		self->priv->_tvs = _tmp0_;
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_TVS_PROPERTY]);
#line 3361 "GenericList.c"
	}
}


NoiseViewWrapperHint
noise_generic_list_get_hint (NoiseGenericList* self)
{
	NoiseViewWrapperHint result;
	NoiseTreeViewSetup* _tmp0_;
	NoiseViewWrapperHint _tmp1_;
	NoiseViewWrapperHint _tmp2_;
#line 41 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_tvs;
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = noise_tree_view_setup_get_hint (_tmp0_);
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp2_;
#line 42 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3385 "GenericList.c"
}


void
noise_generic_list_set_hint (NoiseGenericList* self,
                             NoiseViewWrapperHint value)
{
	NoiseTreeViewSetup* _tmp0_;
#line 44 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_tvs;
#line 45 "../src/Views/ListView/Lists/GenericList.vala"
	noise_tree_view_setup_set_hint (_tmp0_, value);
#line 44 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_HINT_PROPERTY]);
#line 3402 "GenericList.c"
}


NoiseViewWrapper*
noise_generic_list_get_parent_wrapper (NoiseGenericList* self)
{
	NoiseViewWrapper* result;
	NoiseViewWrapper* _tmp0_;
#line 51 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = self->priv->_parent_wrapper;
#line 52 "../src/Views/ListView/Lists/GenericList.vala"
	result = _tmp0_;
#line 52 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3419 "GenericList.c"
}


void
noise_generic_list_set_parent_wrapper (NoiseGenericList* self,
                                       NoiseViewWrapper* value)
{
	NoiseViewWrapper* _tmp0_;
	NoisePlaylist* _tmp1_;
	NoisePlaylist* _tmp2_;
#line 54 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 55 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_parent_wrapper);
#line 55 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->_parent_wrapper = _tmp0_;
#line 56 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = noise_view_wrapper_get_playlist (value);
#line 56 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_playlist (self, _tmp2_);
#line 54 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY]);
#line 3446 "GenericList.c"
}


static void
_noise_generic_list_reorder_requested_noise_fast_model_reorder_requested (NoiseFastModel* _sender,
                                                                          gint column,
                                                                          GtkSortType direction,
                                                                          gpointer self)
{
#line 108 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_reorder_requested ((NoiseGenericList*) self, column, direction);
#line 3458 "GenericList.c"
}


static void
_noise_generic_list_on_rows_reordered_noise_generic_list_rows_reordered (NoiseGenericList* _sender,
                                                                         gpointer self)
{
#line 130 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_on_rows_reordered ((NoiseGenericList*) self);
#line 3468 "GenericList.c"
}


static gboolean
_noise_generic_list___lambda39_ (NoiseGenericList* self,
                                 GdkEventKey* event)
{
	gboolean result = FALSE;
	guint _tmp0_;
#line 132 "../src/Views/ListView/Lists/GenericList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 133 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = event->keyval;
#line 133 "../src/Views/ListView/Lists/GenericList.vala"
	if (_tmp0_ == GDK_KEY_Delete) {
#line 134 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_mediaRemoveClicked (self);
#line 3486 "GenericList.c"
	}
#line 137 "../src/Views/ListView/Lists/GenericList.vala"
	result = FALSE;
#line 137 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3492 "GenericList.c"
}


static gboolean
__noise_generic_list___lambda39__gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = _noise_generic_list___lambda39_ ((NoiseGenericList*) self, event);
#line 132 "../src/Views/ListView/Lists/GenericList.vala"
	return result;
#line 3505 "GenericList.c"
}


static void
_noise_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                         GdkDragContext* context,
                                                         gpointer self)
{
#line 144 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_on_drag_begin ((NoiseGenericList*) self, _sender, context);
#line 3516 "GenericList.c"
}


static void
_noise_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               GtkSelectionData* selection_data,
                                                               guint info,
                                                               guint time_,
                                                               gpointer self)
{
#line 145 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_on_drag_data_get ((NoiseGenericList*) self, context, selection_data, info, time_);
#line 3530 "GenericList.c"
}


static void
_noise_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                     GdkDragContext* context,
                                                     gpointer self)
{
#line 146 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_on_drag_end ((NoiseGenericList*) self, _sender, context);
#line 3541 "GenericList.c"
}


static void
_gtk_widget_queue_draw_noise_library_media_updated (NoiseLibrary* _sender,
                                                    GeeCollection* medias,
                                                    gpointer self)
{
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3552 "GenericList.c"
}


static void
_noise_generic_list___lambda40_ (NoiseGenericList* self)
{
#line 151 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_is_current_list (self, FALSE);
#line 3561 "GenericList.c"
}


static void
__noise_generic_list___lambda40__noise_playback_manager_queue_cleared (NoisePlaybackManager* _sender,
                                                                       gpointer self)
{
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	_noise_generic_list___lambda40_ ((NoiseGenericList*) self);
#line 3571 "GenericList.c"
}


static void
_noise_generic_list_media_played_noise_playback_manager_media_played (NoisePlaybackManager* _sender,
                                                                      NoiseMedia* played_media,
                                                                      gpointer self)
{
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_media_played ((NoiseGenericList*) self, played_media, NULL, NULL);
#line 3582 "GenericList.c"
}


static GObject *
noise_generic_list_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseGenericList * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeList* _tmp11_;
	NoiseFastModel* _tmp12_;
	NoiseFastModel* _tmp13_;
	GeeArrayList* _tmp14_;
	NoiseFastModel* _tmp15_;
	NoiseCellDataFunctionHelper* _tmp16_;
	NoiseTreeViewSetup* _tmp17_;
	NoiseListColumn _tmp18_;
	NoiseListColumn _tmp19_;
	NoiseTreeViewSetup* _tmp20_;
	GtkSortType _tmp21_;
	GtkSortType _tmp22_;
	GtkTreeSelection* _tmp35_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp36_ = {0};
	GtkTargetEntry _tmp37_;
	GtkTargetEntry* _tmp38_;
	GtkTargetEntry* _tmp39_;
	gint _tmp39__length1;
	NoiseViewWrapper* _tmp40_;
	NoiseViewWrapper* _tmp41_;
	NoiseLibrary* _tmp42_;
	NoiseLibrary* _tmp43_;
	NoisePlaybackManager* _tmp44_;
	NoisePlaybackManager* _tmp45_;
	NoisePlaybackManager* _tmp46_;
	NoisePlaybackManager* _tmp47_;
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	parent_class = G_OBJECT_CLASS (noise_generic_list_parent_class);
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL);
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_columns (self, (GeeList*) _tmp1_);
#line 99 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (_tmp1_);
#line 3637 "GenericList.c"
	{
		GeeIterator* _type_it = NULL;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp2_ = noise_list_column_get_all ();
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp3_ = _tmp2_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp5_ = _tmp4_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp3_);
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_type_it = _tmp5_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 3658 "GenericList.c"
			GeeIterator* _tmp6_;
			NoiseListColumn type = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			NoiseListColumn _tmp10_;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp6_ = _type_it;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 3671 "GenericList.c"
			}
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp7_ = _type_it;
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
			type = (NoiseListColumn) ((gintptr) _tmp8_);
#line 101 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp9_ = self->priv->_columns;
#line 101 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp10_ = type;
#line 101 "../src/Views/ListView/Lists/GenericList.vala"
			gee_collection_add ((GeeCollection*) _tmp9_, (gpointer) ((gintptr) noise_list_column_get_data_type (_tmp10_)));
#line 3685 "GenericList.c"
		}
#line 100 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_type_it);
#line 3689 "GenericList.c"
	}
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp11_ = self->priv->_columns;
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp12_ = noise_fast_model_new (_tmp11_);
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->fm);
#line 104 "../src/Views/ListView/Lists/GenericList.vala"
	self->fm = _tmp12_;
#line 105 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_column_id = NOISE_GENERIC_LIST_OPTIMAL_COLUMN;
#line 106 "../src/Views/ListView/Lists/GenericList.vala"
	self->sort_direction = GTK_SORT_ASCENDING;
#line 108 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp13_ = self->fm;
#line 108 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp13_, "reorder-requested", (GCallback) _noise_generic_list_reorder_requested_noise_fast_model_reorder_requested, self, 0);
#line 110 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp14_ = self->table;
#line 110 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_table (self, _tmp14_, TRUE);
#line 111 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp15_ = self->fm;
#line 111 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp15_);
#line 113 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp16_ = noise_cell_data_function_helper_new (self);
#line 113 "../src/Views/ListView/Lists/GenericList.vala"
	_noise_cell_data_function_helper_unref0 (self->cell_data_helper);
#line 113 "../src/Views/ListView/Lists/GenericList.vala"
	self->cell_data_helper = _tmp16_;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp17_ = self->priv->_tvs;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp18_ = noise_tree_view_setup_get_sort_column_id (_tmp17_);
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp19_ = _tmp18_;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp20_ = self->priv->_tvs;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp21_ = noise_tree_view_setup_get_sort_direction (_tmp20_);
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp22_ = _tmp21_;
#line 116 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_set_sort_column_id (self, (gint) _tmp19_, _tmp22_);
#line 118 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
#line 120 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_fixed_height_mode ((GtkTreeView*) self, TRUE);
#line 121 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_view_set_reorderable ((GtkTreeView*) self, FALSE);
#line 3741 "GenericList.c"
	{
		GeeIterator* _tvc_it = NULL;
		NoiseTreeViewSetup* _tmp23_;
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
		GeeIterator* _tmp26_;
		GeeIterator* _tmp27_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp23_ = self->priv->_tvs;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp24_ = noise_tree_view_setup_get_columns (_tmp23_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp25_ = _tmp24_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tmp27_ = _tmp26_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tmp25_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_tvc_it = _tmp27_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		while (TRUE) {
#line 3765 "GenericList.c"
			GeeIterator* _tmp28_;
			GtkTreeViewColumn* tvc = NULL;
			GeeIterator* _tmp29_;
			gpointer _tmp30_;
			GtkTreeViewColumn* _tmp31_;
			GtkTreeViewColumn* _tmp32_;
			NoiseListColumn* _tmp33_;
			NoiseListColumn* _tmp34_;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp28_ = _tvc_it;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			if (!gee_iterator_next (_tmp28_)) {
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
				break;
#line 3780 "GenericList.c"
			}
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp29_ = _tvc_it;
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp30_ = gee_iterator_get (_tmp29_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			tvc = (GtkTreeViewColumn*) _tmp30_;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp31_ = tvc;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp32_ = tvc;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp33_ = noise_tree_view_setup_get_column_type (_tmp32_);
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_tmp34_ = _tmp33_;
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			noise_generic_list_add_column (self, _tmp31_, *_tmp34_);
#line 124 "../src/Views/ListView/Lists/GenericList.vala"
			_g_free0 (_tmp34_);
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
			_g_object_unref0 (tvc);
#line 3802 "GenericList.c"
		}
#line 123 "../src/Views/ListView/Lists/GenericList.vala"
		_g_object_unref0 (_tvc_it);
#line 3806 "GenericList.c"
	}
#line 128 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp35_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 128 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_tree_selection_set_mode (_tmp35_, GTK_SELECTION_MULTIPLE);
#line 130 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (self, "rows-reordered", (GCallback) _noise_generic_list_on_rows_reordered_noise_generic_list_rows_reordered, self, 0);
#line 132 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __noise_generic_list___lambda39__gtk_widget_key_press_event, self, 0);
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp36_.target = "text/uri-list";
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp36_.flags = (guint) GTK_TARGET_SAME_APP;
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp36_.info = (guint) 0;
#line 141 "../src/Views/ListView/Lists/GenericList.vala"
	te = _tmp36_;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp37_ = te;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp38_ = g_new0 (GtkTargetEntry, 1);
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp38_[0] = _tmp37_;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp39_ = _tmp38_;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp39__length1 = 1;
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, _tmp39_, 1, GDK_ACTION_COPY);
#line 142 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp39_ = (g_free (_tmp39_), NULL);
#line 144 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) _noise_generic_list_on_drag_begin_gtk_widget_drag_begin, self, 0);
#line 145 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) _noise_generic_list_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 146 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) _noise_generic_list_on_drag_end_gtk_widget_drag_end, self, 0);
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp40_ = noise_generic_list_get_parent_wrapper (self);
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp41_ = _tmp40_;
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp42_ = noise_view_wrapper_get_library (_tmp41_);
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp43_ = _tmp42_;
#line 148 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp43_, "media-updated", (GCallback) _gtk_widget_queue_draw_noise_library_media_updated, (GtkWidget*) self, 0);
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp44_ = noise_app_get_player ();
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp45_ = _tmp44_;
#line 150 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp45_, "queue-cleared", (GCallback) __noise_generic_list___lambda40__noise_playback_manager_queue_cleared, self, 0);
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp46_ = noise_app_get_player ();
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp47_ = _tmp46_;
#line 154 "../src/Views/ListView/Lists/GenericList.vala"
	g_signal_connect_object (_tmp47_, "media-played", (GCallback) _noise_generic_list_media_played_noise_playback_manager_media_played, self, 0);
#line 98 "../src/Views/ListView/Lists/GenericList.vala"
	return obj;
#line 3868 "GenericList.c"
}


static void
noise_generic_list_class_init (NoiseGenericListClass * klass)
{
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_type_class_adjust_private_offset (klass, &NoiseGenericList_private_offset);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	((NoiseGenericListClass *) klass)->add_column = (void (*) (NoiseGenericList*, GtkTreeViewColumn*, NoiseListColumn)) noise_generic_list_real_add_column;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	((NoiseGenericListClass *) klass)->mediaRemoveClicked = (void (*) (NoiseGenericList*)) noise_generic_list_real_mediaRemoveClicked;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView*, GtkTreePath*, GtkTreeViewColumn*)) noise_generic_list_real_row_activated;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_generic_list_get_property;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_generic_list_set_property;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_generic_list_constructor;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_generic_list_finalize;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_COLUMNS_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY] = g_param_spec_boolean ("research-needed", "research-needed", "research-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY] = g_param_spec_boolean ("is-current-list", "is-current-list", "is-current-list", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_PLAYLIST_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_TVS_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_TVS_PROPERTY] = g_param_spec_object ("tvs", "tvs", "tvs", NOISE_TYPE_TREE_VIEW_SETUP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_HINT_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY] = g_param_spec_object ("parent-wrapper", "parent-wrapper", "parent-wrapper", NOISE_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_signals[NOISE_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", NOISE_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	noise_generic_list_signals[NOISE_GENERIC_LIST_ROWS_REORDERED_SIGNAL] = g_signal_new ("rows-reordered", NOISE_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3911 "GenericList.c"
}


static void
noise_generic_list_instance_init (NoiseGenericList * self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv = noise_generic_list_get_instance_private (self);
#line 35 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->_research_needed = FALSE;
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	self->priv->_playlist = NULL;
#line 66 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 66 "../src/Views/ListView/Lists/GenericList.vala"
	self->table = _tmp0_;
#line 71 "../src/Views/ListView/Lists/GenericList.vala"
	_tmp1_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 71 "../src/Views/ListView/Lists/GenericList.vala"
	self->showing = _tmp1_;
#line 3934 "GenericList.c"
}


static void
noise_generic_list_finalize (GObject * obj)
{
	NoiseGenericList * self;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
#line 34 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_columns);
#line 37 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_playlist);
#line 38 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_tvs);
#line 49 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->priv->_parent_wrapper);
#line 61 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->fm);
#line 66 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->table);
#line 71 "../src/Views/ListView/Lists/GenericList.vala"
	_g_object_unref0 (self->showing);
#line 92 "../src/Views/ListView/Lists/GenericList.vala"
	_noise_cell_data_function_helper_unref0 (self->cell_data_helper);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	G_OBJECT_CLASS (noise_generic_list_parent_class)->finalize (obj);
#line 3962 "GenericList.c"
}


GType
noise_generic_list_get_type (void)
{
	static volatile gsize noise_generic_list_type_id__volatile = 0;
	if (g_once_init_enter (&noise_generic_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseGenericListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_generic_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseGenericList), 0, (GInstanceInitFunc) noise_generic_list_instance_init, NULL };
		GType noise_generic_list_type_id;
		noise_generic_list_type_id = g_type_register_static (gtk_tree_view_get_type (), "NoiseGenericList", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		NoiseGenericList_private_offset = g_type_add_instance_private (noise_generic_list_type_id, sizeof (NoiseGenericListPrivate));
		g_once_init_leave (&noise_generic_list_type_id__volatile, noise_generic_list_type_id);
	}
	return noise_generic_list_type_id__volatile;
}


static void
_vala_noise_generic_list_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	NoiseGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, noise_generic_list_get_columns (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_boolean (value, noise_generic_list_get_research_needed (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_boolean (value, noise_generic_list_get_is_current_list (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_PLAYLIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, noise_generic_list_get_playlist (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_TVS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, noise_generic_list_get_tvs (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_HINT_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_enum (value, noise_generic_list_get_hint (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		g_value_set_object (value, noise_generic_list_get_parent_wrapper (self));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 4033 "GenericList.c"
		default:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 4039 "GenericList.c"
	}
}


static void
_vala_noise_generic_list_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	NoiseGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
	switch (property_id) {
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_COLUMNS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_columns (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_research_needed (self, g_value_get_boolean (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_is_current_list (self, g_value_get_boolean (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_PLAYLIST_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_playlist (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_TVS_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_tvs (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_HINT_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_hint (self, g_value_get_enum (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		case NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		noise_generic_list_set_parent_wrapper (self, g_value_get_object (value));
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 4096 "GenericList.c"
		default:
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/Views/ListView/Lists/GenericList.vala"
		break;
#line 4102 "GenericList.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



