/* SourceListView.c generated by valac 0.42.6, the Vala compiler
 * generated from SourceListView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* Add an interface so that SourceListItem and SourceListExpandableItem still share a common*/
/* ancestor that is compatible with the SourceList widget.*/


#include <glib.h>
#include <glib-object.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "io.elementary.music-core.h"
#include <gee.h>


#define NOISE_TYPE_SOURCE_LIST_ENTRY (noise_source_list_entry_get_type ())
#define NOISE_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY, NoiseSourceListEntry))
#define NOISE_IS_SOURCE_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY))
#define NOISE_SOURCE_LIST_ENTRY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_SOURCE_LIST_ENTRY, NoiseSourceListEntryIface))

typedef struct _NoiseSourceListEntry NoiseSourceListEntry;
typedef struct _NoiseSourceListEntryIface NoiseSourceListEntryIface;

#define NOISE_TYPE_SOURCE_LIST_ITEM (noise_source_list_item_get_type ())
#define NOISE_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem))
#define NOISE_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemClass))
#define NOISE_IS_SOURCE_LIST_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ITEM))
#define NOISE_IS_SOURCE_LIST_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_ITEM))
#define NOISE_SOURCE_LIST_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItemClass))

typedef struct _NoiseSourceListItem NoiseSourceListItem;
typedef struct _NoiseSourceListItemClass NoiseSourceListItemClass;
typedef struct _NoiseSourceListItemPrivate NoiseSourceListItemPrivate;
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())
enum  {
	NOISE_SOURCE_LIST_ITEM_0_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY,
	NOISE_SOURCE_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_SOURCE_LIST_ITEM_NUM_SIGNALS
};
static guint noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_NUM_SIGNALS] = {0};

#define NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM (noise_source_list_expandable_item_get_type ())
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem))
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemClass))
#define NOISE_IS_SOURCE_LIST_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define NOISE_IS_SOURCE_LIST_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM))
#define NOISE_SOURCE_LIST_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItemClass))

typedef struct _NoiseSourceListExpandableItem NoiseSourceListExpandableItem;
typedef struct _NoiseSourceListExpandableItemClass NoiseSourceListExpandableItemClass;
typedef struct _NoiseSourceListExpandableItemPrivate NoiseSourceListExpandableItemPrivate;
enum  {
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_0_PROPERTY,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_PROPERTIES];
typedef struct _Block31Data Block31Data;
enum  {
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};

#define NOISE_TYPE_PLAY_LIST_CATEGORY (noise_play_list_category_get_type ())
#define NOISE_PLAY_LIST_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory))
#define NOISE_PLAY_LIST_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryClass))
#define NOISE_IS_PLAY_LIST_CATEGORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY))
#define NOISE_IS_PLAY_LIST_CATEGORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAY_LIST_CATEGORY))
#define NOISE_PLAY_LIST_CATEGORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategoryClass))

typedef struct _NoisePlayListCategory NoisePlayListCategory;
typedef struct _NoisePlayListCategoryClass NoisePlayListCategoryClass;
typedef struct _NoisePlayListCategoryPrivate NoisePlayListCategoryPrivate;
enum  {
	NOISE_PLAY_LIST_CATEGORY_0_PROPERTY,
	NOISE_PLAY_LIST_CATEGORY_NUM_PROPERTIES
};
static GParamSpec* noise_play_list_category_properties[NOISE_PLAY_LIST_CATEGORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;

#define NOISE_TYPE_LOCAL_LIBRARY (noise_local_library_get_type ())
#define NOISE_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary))
#define NOISE_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))
#define NOISE_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))

typedef struct _NoiseLocalLibrary NoiseLocalLibrary;
typedef struct _NoiseLocalLibraryClass NoiseLocalLibraryClass;
enum  {
	NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	NOISE_PLAY_LIST_CATEGORY_NUM_SIGNALS
};
static guint noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_NUM_SIGNALS] = {0};

#define NOISE_TYPE_SOURCE_LIST_ROOT (noise_source_list_root_get_type ())
#define NOISE_SOURCE_LIST_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRoot))
#define NOISE_SOURCE_LIST_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRootClass))
#define NOISE_IS_SOURCE_LIST_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_ROOT))
#define NOISE_IS_SOURCE_LIST_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_ROOT))
#define NOISE_SOURCE_LIST_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_ROOT, NoiseSourceListRootClass))

typedef struct _NoiseSourceListRoot NoiseSourceListRoot;
typedef struct _NoiseSourceListRootClass NoiseSourceListRootClass;
typedef struct _NoiseSourceListRootPrivate NoiseSourceListRootPrivate;
enum  {
	NOISE_SOURCE_LIST_ROOT_0_PROPERTY,
	NOISE_SOURCE_LIST_ROOT_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_root_properties[NOISE_SOURCE_LIST_ROOT_NUM_PROPERTIES];

#define NOISE_TYPE_SOURCE_LIST_VIEW (noise_source_list_view_get_type ())
#define NOISE_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListView))
#define NOISE_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewClass))
#define NOISE_IS_SOURCE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SOURCE_LIST_VIEW))
#define NOISE_IS_SOURCE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SOURCE_LIST_VIEW))
#define NOISE_SOURCE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListViewClass))

typedef struct _NoiseSourceListView NoiseSourceListView;
typedef struct _NoiseSourceListViewClass NoiseSourceListViewClass;
typedef struct _NoiseSourceListViewPrivate NoiseSourceListViewPrivate;
enum  {
	NOISE_SOURCE_LIST_VIEW_0_PROPERTY,
	NOISE_SOURCE_LIST_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_source_list_view_properties[NOISE_SOURCE_LIST_VIEW_NUM_PROPERTIES];
typedef struct _Block32Data Block32Data;

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;

#define NOISE_TYPE_DEVICE_VIEW (noise_device_view_get_type ())
#define NOISE_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceView))
#define NOISE_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))
#define NOISE_IS_DEVICE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_IS_DEVICE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_DEVICE_VIEW))
#define NOISE_DEVICE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_DEVICE_VIEW, NoiseDeviceViewClass))

typedef struct _NoiseDeviceView NoiseDeviceView;
typedef struct _NoiseDeviceViewClass NoiseDeviceViewClass;
enum  {
	NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL,
	NOISE_SOURCE_LIST_VIEW_NUM_SIGNALS
};
static guint noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_NUM_SIGNALS] = {0};

struct _NoiseSourceListEntryIface {
	GTypeInterface parent_iface;
};

struct _NoiseSourceListItem {
	GraniteWidgetsSourceListItem parent_instance;
	NoiseSourceListItemPrivate * priv;
};

struct _NoiseSourceListItemClass {
	GraniteWidgetsSourceListItemClass parent_class;
};

struct _NoiseSourceListItemPrivate {
	GtkGrid* _view;
	NoiseViewWrapperHint _hint;
	GIcon* _activatable_icon;
	GtkMenu* playlist_menu;
};

struct _NoiseSourceListExpandableItem {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoiseSourceListExpandableItemPrivate * priv;
	NoiseViewWrapperHint hint;
};

struct _NoiseSourceListExpandableItemClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoiseSourceListExpandableItemPrivate {
	GtkGrid* _view;
	GtkMenu* device_menu;
};

struct _Block31Data {
	int _ref_count_;
	NoiseSourceListExpandableItem* self;
	GtkGrid* view;
};

struct _NoisePlayListCategory {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoisePlayListCategoryPrivate * priv;
};

struct _NoisePlayListCategoryClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoisePlayListCategoryPrivate {
	GtkMenu* playlist_menu;
};

struct _NoiseSourceListRoot {
	GraniteWidgetsSourceListExpandableItem parent_instance;
	NoiseSourceListRootPrivate * priv;
};

struct _NoiseSourceListRootClass {
	GraniteWidgetsSourceListExpandableItemClass parent_class;
};

struct _NoiseSourceListView {
	GraniteWidgetsSourceList parent_instance;
	NoiseSourceListViewPrivate * priv;
};

struct _NoiseSourceListViewClass {
	GraniteWidgetsSourceListClass parent_class;
};

struct _NoiseSourceListViewPrivate {
	GraniteWidgetsSourceListExpandableItem* library_category;
	GraniteWidgetsSourceListExpandableItem* devices_category;
	GraniteWidgetsSourceListExpandableItem* network_category;
	NoisePlayListCategory* playlists_category;
};

struct _Block32Data {
	int _ref_count_;
	NoiseSourceListView* self;
	NoiseSourceListItem* sourcelist_item;
	NoiseSourceListExpandableItem* expandable_item;
};


static gint NoiseSourceListItem_private_offset;
static gpointer noise_source_list_item_parent_class = NULL;
static NoiseSourceListEntryIface * noise_source_list_item_noise_source_list_entry_parent_iface = NULL;
static GraniteWidgetsSourceListDragDestIface * noise_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = NULL;
static gint NoiseSourceListExpandableItem_private_offset;
static gpointer noise_source_list_expandable_item_parent_class = NULL;
static NoiseSourceListEntryIface * noise_source_list_expandable_item_noise_source_list_entry_parent_iface = NULL;
static gint NoisePlayListCategory_private_offset;
static gpointer noise_play_list_category_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * noise_play_list_category_granite_widgets_source_list_sortable_parent_iface = NULL;
static gpointer noise_source_list_root_parent_class = NULL;
static GraniteWidgetsSourceListSortableIface * noise_source_list_root_granite_widgets_source_list_sortable_parent_iface = NULL;
static gint NoiseSourceListView_private_offset;
static gpointer noise_source_list_view_parent_class = NULL;

GType noise_source_list_entry_get_type (void) G_GNUC_CONST;
GType noise_source_list_item_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
NoiseSourceListItem* noise_source_list_item_new (GtkGrid* view,
                                                 const gchar* name,
                                                 NoiseViewWrapperHint hint,
                                                 GIcon* icon,
                                                 GIcon* activatable_icon);
NoiseSourceListItem* noise_source_list_item_construct (GType object_type,
                                                       GtkGrid* view,
                                                       const gchar* name,
                                                       NoiseViewWrapperHint hint,
                                                       GIcon* icon,
                                                       GIcon* activatable_icon);
static GtkMenu* noise_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean noise_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
NoiseViewWrapperHint noise_source_list_item_get_hint (NoiseSourceListItem* self);
static GdkDragAction noise_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                                         GdkDragContext* context,
                                                         GtkSelectionData* data);
GtkGrid* noise_source_list_item_get_view (NoiseSourceListItem* self);
static void noise_source_list_item_set_view (NoiseSourceListItem* self,
                                      GtkGrid* value);
static void noise_source_list_item_set_hint (NoiseSourceListItem* self,
                                      NoiseViewWrapperHint value);
GIcon* noise_source_list_item_get_activatable_icon (NoiseSourceListItem* self);
static void noise_source_list_item_set_activatable_icon (NoiseSourceListItem* self,
                                                  GIcon* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static GObject * noise_source_list_item_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _noise_source_list_item____lambda76_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda76__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda77_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda78_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda79_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda80_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item____lambda81_ (NoiseSourceListItem* self);
static void __noise_source_list_item____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self);
static void _noise_source_list_item___lambda82_ (NoiseSourceListItem* self);
static void __noise_source_list_item___lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                  gpointer self);
static void noise_source_list_item_finalize (GObject * obj);
static void _vala_noise_source_list_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_source_list_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
GType noise_source_list_expandable_item_get_type (void) G_GNUC_CONST;
NoiseSourceListExpandableItem* noise_source_list_expandable_item_new (GtkGrid* view,
                                                                      const gchar* name,
                                                                      NoiseViewWrapperHint hint,
                                                                      GIcon* icon,
                                                                      GIcon* activatable_icon,
                                                                      GObject* give_more_information);
NoiseSourceListExpandableItem* noise_source_list_expandable_item_construct (GType object_type,
                                                                            GtkGrid* view,
                                                                            const gchar* name,
                                                                            NoiseViewWrapperHint hint,
                                                                            GIcon* icon,
                                                                            GIcon* activatable_icon,
                                                                            GObject* give_more_information);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
void noise_source_list_expandable_item_set_view (NoiseSourceListExpandableItem* self,
                                                 GtkGrid* value);
static void ___lambda87_ (Block31Data* _data31_);
static void ____lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda88_ (Block31Data* _data31_);
static void ____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void _____lambda89_ (Block31Data* _data31_);
static void ______lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda90_ (Block31Data* _data31_);
static void ______lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static void _____lambda91_ (Block31Data* _data31_);
static void ______lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                             gpointer self);
static GtkMenu* noise_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base);
GtkGrid* noise_source_list_expandable_item_get_view (NoiseSourceListExpandableItem* self);
static void noise_source_list_expandable_item_finalize (GObject * obj);
static void _vala_noise_source_list_expandable_item_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_noise_source_list_expandable_item_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
GType noise_play_list_category_get_type (void) G_GNUC_CONST;
NoisePlayListCategory* noise_play_list_category_new (const gchar* name);
NoisePlayListCategory* noise_play_list_category_construct (GType object_type,
                                                           const gchar* name);
static GtkMenu* noise_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base);
static gboolean noise_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint noise_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                            GraniteWidgetsSourceListItem* a,
                                            GraniteWidgetsSourceListItem* b);
static GObject * noise_play_list_category_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _noise_play_list_category___lambda83_ (NoisePlayListCategory* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_library_window_create_new_playlist (NoiseLibraryWindow* self,
                                               NoiseLibrary* library);
GType noise_local_library_get_type (void) G_GNUC_CONST;
NoiseLocalLibrary* noise_library_window_get_library_manager (NoiseLibraryWindow* self);
static void __noise_play_list_category___lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _noise_play_list_category___lambda84_ (NoisePlayListCategory* self);
void noise_library_window_show_smart_playlist_dialog (NoiseLibraryWindow* self,
                                                      NoiseSmartPlaylist* smartplaylist);
static void __noise_play_list_category___lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void _noise_play_list_category___lambda85_ (NoisePlayListCategory* self);
static void __noise_play_list_category___lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                    gpointer self);
static void noise_play_list_category_finalize (GObject * obj);
GType noise_source_list_root_get_type (void) G_GNUC_CONST;
NoiseSourceListRoot* noise_source_list_root_new (void);
NoiseSourceListRoot* noise_source_list_root_construct (GType object_type);
static gboolean noise_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base);
static gint noise_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                          GraniteWidgetsSourceListItem* a,
                                          GraniteWidgetsSourceListItem* b);
GType noise_source_list_view_get_type (void) G_GNUC_CONST;
NoiseSourceListView* noise_source_list_view_new (void);
NoiseSourceListView* noise_source_list_view_construct (GType object_type);
static void __lambda86_ (NoiseSourceListView* self);
static void ___lambda86__noise_play_list_category_playlist_import_clicked (NoisePlayListCategory* _sender,
                                                                    gpointer self);
void noise_source_list_view_change_playlist_category_visibility (NoiseSourceListView* self,
                                                                 gboolean visible);
NoiseSourceListEntry* noise_source_list_view_add_item (NoiseSourceListView* self,
                                                       GtkGrid* view,
                                                       const gchar* name,
                                                       NoiseViewWrapperHint hint,
                                                       GIcon* icon,
                                                       GIcon* activatable_icon,
                                                       NoiseSourceListExpandableItem* into_expandable,
                                                       GObject* give_more_information);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void __lambda92_ (NoiseSourceListView* self);
static void ___lambda92__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                              gpointer self);
static void __lambda93_ (Block32Data* _data32_,
                  const gchar* new_name);
static void ___lambda93__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                           const gchar* new_name,
                                                           gpointer self);
static void __lambda94_ (Block32Data* _data32_,
                  GraniteWidgetsSourceListItem* sl);
static void ___lambda94__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                     gpointer self);
static void __lambda95_ (NoiseSourceListView* self,
                  GtkGrid* view,
                  NoiseSourceListItem* item);
static void ___lambda95__noise_source_list_item_playlist_rename_clicked (NoiseSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  NoiseSourceListItem* item,
                                                                  gpointer self);
static void __lambda96_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda96__noise_source_list_item_playlist_edit_clicked (NoiseSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda97_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda97__noise_source_list_item_playlist_remove_clicked (NoiseSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self);
static void __lambda98_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda98__noise_source_list_item_playlist_save_clicked (NoiseSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gpointer self);
static void __lambda99_ (NoiseSourceListView* self,
                  GtkGrid* view);
static void ___lambda99__noise_source_list_item_playlist_export_clicked (NoiseSourceListItem* _sender,
                                                                  GtkGrid* view,
                                                                  gpointer self);
static void __lambda100_ (NoiseSourceListView* self,
                   GtkGrid* view,
                   gchar** uris,
                   int uris_length1);
static void ___lambda100__noise_source_list_item_playlist_media_added (NoiseSourceListItem* _sender,
                                                                GtkGrid* view,
                                                                gchar** media,
                                                                int media_length1,
                                                                gpointer self);
static void __lambda101_ (Block32Data* _data32_,
                   GtkGrid* view);
static GtkGrid* noise_source_list_view_get_device_from_item (NoiseSourceListView* self,
                                                      NoiseSourceListExpandableItem* item);
static void ___lambda101__noise_source_list_expandable_item_device_import_clicked (NoiseSourceListExpandableItem* _sender,
                                                                            GtkGrid* view,
                                                                            gpointer self);
static void __lambda102_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda102__noise_source_list_expandable_item_device_eject_clicked (NoiseSourceListExpandableItem* _sender,
                                                                           GtkGrid* view,
                                                                           gpointer self);
static void __lambda103_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda103__noise_source_list_expandable_item_device_sync_clicked (NoiseSourceListExpandableItem* _sender,
                                                                          GtkGrid* view,
                                                                          gpointer self);
static void __lambda104_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda104__noise_source_list_expandable_item_device_new_playlist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self);
static void __lambda105_ (NoiseSourceListView* self,
                   GtkGrid* view);
static void ___lambda105__noise_source_list_expandable_item_device_new_smartplaylist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                                       GtkGrid* view,
                                                                                       gpointer self);
static void noise_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                                GraniteWidgetsSourceListItem* item);
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
void noise_source_list_view_remove_playlist (NoiseSourceListView* self,
                                             NoiseViewWrapper* view);
static void noise_source_list_view_enumerate_children_items (NoiseSourceListView* self,
                                                      NoiseSourceListExpandableItem* exp_item,
                                                      GeeTreeSet* * pages);
GType noise_device_view_get_type (void) G_GNUC_CONST;
GeeCollection* noise_source_list_view_remove_device (NoiseSourceListView* self,
                                                     NoiseDeviceView* view);
static void noise_source_list_view_enumerate_children_pages (NoiseSourceListView* self,
                                                      NoiseSourceListExpandableItem* exp_item,
                                                      GeeTreeSet* * pages);
void noise_source_list_view_change_playlist_name (NoiseSourceListView* self,
                                                  NoiseViewWrapper* view,
                                                  const gchar* new_name);
void noise_source_list_view_change_device_name (NoiseSourceListView* self,
                                                NoiseDeviceView* view,
                                                const gchar* new_name);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void noise_source_list_view_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void
noise_source_list_entry_default_init (NoiseSourceListEntryIface * iface)
{
}


GType
noise_source_list_entry_get_type (void)
{
	static volatile gsize noise_source_list_entry_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListEntryIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_entry_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType noise_source_list_entry_type_id;
		noise_source_list_entry_type_id = g_type_register_static (G_TYPE_INTERFACE, "NoiseSourceListEntry", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (noise_source_list_entry_type_id, GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM);
		g_once_init_leave (&noise_source_list_entry_type_id__volatile, noise_source_list_entry_type_id);
	}
	return noise_source_list_entry_type_id__volatile;
}


static inline gpointer
noise_source_list_item_get_instance_private (NoiseSourceListItem* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSourceListItem_private_offset);
}


NoiseSourceListItem*
noise_source_list_item_construct (GType object_type,
                                  GtkGrid* view,
                                  const gchar* name,
                                  NoiseViewWrapperHint hint,
                                  GIcon* icon,
                                  GIcon* activatable_icon)
{
	NoiseSourceListItem * self = NULL;
#line 51 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 51 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 51 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 52 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) g_object_new (object_type, "activatable-icon", activatable_icon, "hint", hint, "icon", icon, "name", name, "view", view, NULL);
#line 51 "../src/Widgets/SourceListView.vala"
	return self;
#line 681 "SourceListView.c"
}


NoiseSourceListItem*
noise_source_list_item_new (GtkGrid* view,
                            const gchar* name,
                            NoiseViewWrapperHint hint,
                            GIcon* icon,
                            GIcon* activatable_icon)
{
#line 51 "../src/Widgets/SourceListView.vala"
	return noise_source_list_item_construct (NOISE_TYPE_SOURCE_LIST_ITEM, view, name, hint, icon, activatable_icon);
#line 694 "SourceListView.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 117 "../src/Widgets/SourceListView.vala"
	return self ? g_object_ref (self) : NULL;
#line 703 "SourceListView.c"
}


static GtkMenu*
noise_source_list_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	NoiseSourceListItem * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
#line 112 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) base;
#line 113 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlist_menu;
#line 113 "../src/Widgets/SourceListView.vala"
	if (_tmp0_ != NULL) {
#line 719 "SourceListView.c"
		GtkMenu* _tmp1_;
		GtkWidget* _tmp2_;
		GtkMenu* _tmp4_;
		GtkMenu* _tmp5_;
#line 114 "../src/Widgets/SourceListView.vala"
		_tmp1_ = self->priv->playlist_menu;
#line 114 "../src/Widgets/SourceListView.vala"
		_tmp2_ = gtk_menu_get_attach_widget (_tmp1_);
#line 114 "../src/Widgets/SourceListView.vala"
		if (_tmp2_ != NULL) {
#line 730 "SourceListView.c"
			GtkMenu* _tmp3_;
#line 115 "../src/Widgets/SourceListView.vala"
			_tmp3_ = self->priv->playlist_menu;
#line 115 "../src/Widgets/SourceListView.vala"
			gtk_menu_detach (_tmp3_);
#line 736 "SourceListView.c"
		}
#line 117 "../src/Widgets/SourceListView.vala"
		_tmp4_ = self->priv->playlist_menu;
#line 117 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 117 "../src/Widgets/SourceListView.vala"
		result = _tmp5_;
#line 117 "../src/Widgets/SourceListView.vala"
		return result;
#line 746 "SourceListView.c"
	}
#line 119 "../src/Widgets/SourceListView.vala"
	result = NULL;
#line 119 "../src/Widgets/SourceListView.vala"
	return result;
#line 752 "SourceListView.c"
}


static gboolean
noise_source_list_item_real_data_drop_possible (GraniteWidgetsSourceListDragDest* base,
                                                GdkDragContext* context,
                                                GtkSelectionData* data)
{
	NoiseSourceListItem * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	NoiseViewWrapperHint _tmp1_;
#line 122 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) base;
#line 122 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 122 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (data != NULL, FALSE);
#line 124 "../src/Widgets/SourceListView.vala"
	_tmp1_ = self->priv->_hint;
#line 124 "../src/Widgets/SourceListView.vala"
	if (_tmp1_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 125 "../src/Widgets/SourceListView.vala"
		_tmp0_ = gtk_selection_data_get_target (data) == gdk_atom_intern_static_string ("text/uri-list");
#line 777 "SourceListView.c"
	} else {
#line 124 "../src/Widgets/SourceListView.vala"
		_tmp0_ = FALSE;
#line 781 "SourceListView.c"
	}
#line 124 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 124 "../src/Widgets/SourceListView.vala"
	return result;
#line 787 "SourceListView.c"
}


static GdkDragAction
noise_source_list_item_real_data_received (GraniteWidgetsSourceListDragDest* base,
                                           GdkDragContext* context,
                                           GtkSelectionData* data)
{
	NoiseSourceListItem * self;
	GdkDragAction result = 0;
	GtkGrid* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 128 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListItem*) base;
#line 128 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (context != NULL, 0);
#line 128 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (data != NULL, 0);
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_ = gtk_selection_data_get_uris (data);
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp3_ = _tmp2_;
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 129 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, _tmp0_, _tmp3_, _vala_array_length (_tmp1_));
#line 129 "../src/Widgets/SourceListView.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 130 "../src/Widgets/SourceListView.vala"
	result = GDK_ACTION_COPY;
#line 130 "../src/Widgets/SourceListView.vala"
	return result;
#line 825 "SourceListView.c"
}


GtkGrid*
noise_source_list_item_get_view (NoiseSourceListItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 45 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
	return result;
#line 842 "SourceListView.c"
}


static void
noise_source_list_item_set_view (NoiseSourceListItem* self,
                                 GtkGrid* value)
{
#line 45 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Widgets/SourceListView.vala"
	if (noise_source_list_item_get_view (self) != value) {
#line 854 "SourceListView.c"
		GtkGrid* _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->_view);
#line 45 "../src/Widgets/SourceListView.vala"
		self->priv->_view = _tmp0_;
#line 45 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY]);
#line 864 "SourceListView.c"
	}
}


NoiseViewWrapperHint
noise_source_list_item_get_hint (NoiseSourceListItem* self)
{
	NoiseViewWrapperHint result;
	NoiseViewWrapperHint _tmp0_;
#line 46 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_hint;
#line 46 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 46 "../src/Widgets/SourceListView.vala"
	return result;
#line 882 "SourceListView.c"
}


static void
noise_source_list_item_set_hint (NoiseSourceListItem* self,
                                 NoiseViewWrapperHint value)
{
#line 46 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Widgets/SourceListView.vala"
	if (noise_source_list_item_get_hint (self) != value) {
#line 46 "../src/Widgets/SourceListView.vala"
		self->priv->_hint = value;
#line 46 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY]);
#line 898 "SourceListView.c"
	}
}


GIcon*
noise_source_list_item_get_activatable_icon (NoiseSourceListItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_activatable_icon;
#line 47 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
	return result;
#line 916 "SourceListView.c"
}


static void
noise_source_list_item_set_activatable_icon (NoiseSourceListItem* self,
                                             GIcon* value)
{
#line 47 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Widgets/SourceListView.vala"
	if (noise_source_list_item_get_activatable_icon (self) != value) {
#line 928 "SourceListView.c"
		GIcon* _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 47 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->_activatable_icon);
#line 47 "../src/Widgets/SourceListView.vala"
		self->priv->_activatable_icon = _tmp0_;
#line 47 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY]);
#line 938 "SourceListView.c"
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 3);
#line 37 "../src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 965 "SourceListView.c"
	} else {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 971 "SourceListView.c"
	}
#line 37 "../src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 37 "../src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 977 "SourceListView.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOXED_INT) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOXED_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 4);
#line 37 "../src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 1003 "SourceListView.c"
	} else {
#line 37 "../src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "../src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 1009 "SourceListView.c"
	}
#line 37 "../src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOXED_INT) (marshal_data ? marshal_data : cc->callback);
#line 37 "../src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boxed (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 1015 "SourceListView.c"
}


static void
_noise_source_list_item____lambda76_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 71 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 71 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
#line 1027 "SourceListView.c"
}


static void
__noise_source_list_item____lambda76__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 70 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item____lambda76_ ((NoiseSourceListItem*) self);
#line 1037 "SourceListView.c"
}


static void
_noise_source_list_item____lambda77_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 74 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 74 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 1049 "SourceListView.c"
}


static void
__noise_source_list_item____lambda77__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 73 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item____lambda77_ ((NoiseSourceListItem*) self);
#line 1059 "SourceListView.c"
}


static void
_noise_source_list_item____lambda78_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 85 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 85 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, _tmp0_, self);
#line 1071 "SourceListView.c"
}


static void
__noise_source_list_item____lambda78__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 84 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item____lambda78_ ((NoiseSourceListItem*) self);
#line 1081 "SourceListView.c"
}


static void
_noise_source_list_item____lambda79_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 88 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 88 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, _tmp0_);
#line 1093 "SourceListView.c"
}


static void
__noise_source_list_item____lambda79__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 87 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item____lambda79_ ((NoiseSourceListItem*) self);
#line 1103 "SourceListView.c"
}


static void
_noise_source_list_item____lambda80_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 91 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 91 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 1115 "SourceListView.c"
}


static void
__noise_source_list_item____lambda80__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 90 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item____lambda80_ ((NoiseSourceListItem*) self);
#line 1125 "SourceListView.c"
}


static void
_noise_source_list_item____lambda81_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 98 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 98 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, _tmp0_);
#line 1137 "SourceListView.c"
}


static void
__noise_source_list_item____lambda81__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self)
{
#line 97 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item____lambda81_ ((NoiseSourceListItem*) self);
#line 1147 "SourceListView.c"
}


static void
_noise_source_list_item___lambda82_ (NoiseSourceListItem* self)
{
	GtkGrid* _tmp0_;
#line 105 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 105 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, _tmp0_);
#line 1159 "SourceListView.c"
}


static void
__noise_source_list_item___lambda82__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self)
{
#line 104 "../src/Widgets/SourceListView.vala"
	_noise_source_list_item___lambda82_ ((NoiseSourceListItem*) self);
#line 1169 "SourceListView.c"
}


static GObject *
noise_source_list_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseSourceListItem * self;
	GtkMenu* _tmp0_;
	NoiseViewWrapperHint _tmp1_;
	GtkMenuItem* playlist_export = NULL;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkMenu* _tmp28_;
	GtkMenuItem* _tmp29_;
	GtkMenu* _tmp30_;
#line 61 "../src/Widgets/SourceListView.vala"
	parent_class = G_OBJECT_CLASS (noise_source_list_item_parent_class);
#line 61 "../src/Widgets/SourceListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 62 "../src/Widgets/SourceListView.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 62 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp0_);
#line 62 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 62 "../src/Widgets/SourceListView.vala"
	self->priv->playlist_menu = _tmp0_;
#line 64 "../src/Widgets/SourceListView.vala"
	_tmp1_ = self->priv->_hint;
#line 64 "../src/Widgets/SourceListView.vala"
	switch (_tmp1_) {
#line 64 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
#line 1209 "SourceListView.c"
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp2_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp3_;
			GtkMenu* _tmp4_;
			GtkMenuItem* _tmp5_;
			GtkMenu* _tmp6_;
			GtkMenuItem* _tmp7_;
			GtkMenuItem* _tmp8_;
			GtkMenuItem* _tmp9_;
#line 66 "../src/Widgets/SourceListView.vala"
			_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
#line 66 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp2_);
#line 66 "../src/Widgets/SourceListView.vala"
			playlist_rename = _tmp2_;
#line 67 "../src/Widgets/SourceListView.vala"
			_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 67 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp3_);
#line 67 "../src/Widgets/SourceListView.vala"
			playlist_remove = _tmp3_;
#line 68 "../src/Widgets/SourceListView.vala"
			_tmp4_ = self->priv->playlist_menu;
#line 68 "../src/Widgets/SourceListView.vala"
			_tmp5_ = playlist_rename;
#line 68 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 69 "../src/Widgets/SourceListView.vala"
			_tmp6_ = self->priv->playlist_menu;
#line 69 "../src/Widgets/SourceListView.vala"
			_tmp7_ = playlist_remove;
#line 69 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
#line 70 "../src/Widgets/SourceListView.vala"
			_tmp8_ = playlist_rename;
#line 70 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp8_, "activate", (GCallback) __noise_source_list_item____lambda76__gtk_menu_item_activate, self, 0);
#line 73 "../src/Widgets/SourceListView.vala"
			_tmp9_ = playlist_remove;
#line 73 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp9_, "activate", (GCallback) __noise_source_list_item____lambda77__gtk_menu_item_activate, self, 0);
#line 76 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_remove);
#line 76 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_rename);
#line 76 "../src/Widgets/SourceListView.vala"
			break;
#line 1259 "SourceListView.c"
		}
#line 64 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 1263 "SourceListView.c"
		{
			GtkMenuItem* playlist_rename = NULL;
			GtkMenuItem* _tmp10_;
			GtkMenuItem* playlist_edit = NULL;
			GtkMenuItem* _tmp11_;
			GtkMenuItem* playlist_remove = NULL;
			GtkMenuItem* _tmp12_;
			GtkMenu* _tmp13_;
			GtkMenuItem* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenuItem* _tmp16_;
			GtkMenu* _tmp17_;
			GtkMenuItem* _tmp18_;
			GtkMenuItem* _tmp19_;
			GtkMenuItem* _tmp20_;
			GtkMenuItem* _tmp21_;
#line 78 "../src/Widgets/SourceListView.vala"
			_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Rename"));
#line 78 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp10_);
#line 78 "../src/Widgets/SourceListView.vala"
			playlist_rename = _tmp10_;
#line 79 "../src/Widgets/SourceListView.vala"
			_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
#line 79 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp11_);
#line 79 "../src/Widgets/SourceListView.vala"
			playlist_edit = _tmp11_;
#line 80 "../src/Widgets/SourceListView.vala"
			_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
#line 80 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp12_);
#line 80 "../src/Widgets/SourceListView.vala"
			playlist_remove = _tmp12_;
#line 81 "../src/Widgets/SourceListView.vala"
			_tmp13_ = self->priv->playlist_menu;
#line 81 "../src/Widgets/SourceListView.vala"
			_tmp14_ = playlist_rename;
#line 81 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
#line 82 "../src/Widgets/SourceListView.vala"
			_tmp15_ = self->priv->playlist_menu;
#line 82 "../src/Widgets/SourceListView.vala"
			_tmp16_ = playlist_edit;
#line 82 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp15_, _tmp16_);
#line 83 "../src/Widgets/SourceListView.vala"
			_tmp17_ = self->priv->playlist_menu;
#line 83 "../src/Widgets/SourceListView.vala"
			_tmp18_ = playlist_remove;
#line 83 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp17_, _tmp18_);
#line 84 "../src/Widgets/SourceListView.vala"
			_tmp19_ = playlist_rename;
#line 84 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp19_, "activate", (GCallback) __noise_source_list_item____lambda78__gtk_menu_item_activate, self, 0);
#line 87 "../src/Widgets/SourceListView.vala"
			_tmp20_ = playlist_edit;
#line 87 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp20_, "activate", (GCallback) __noise_source_list_item____lambda79__gtk_menu_item_activate, self, 0);
#line 90 "../src/Widgets/SourceListView.vala"
			_tmp21_ = playlist_remove;
#line 90 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp21_, "activate", (GCallback) __noise_source_list_item____lambda80__gtk_menu_item_activate, self, 0);
#line 93 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_remove);
#line 93 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_edit);
#line 93 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_rename);
#line 93 "../src/Widgets/SourceListView.vala"
			break;
#line 1336 "SourceListView.c"
		}
#line 64 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 1340 "SourceListView.c"
		{
			GtkMenuItem* playlist_save = NULL;
			GtkMenuItem* _tmp22_;
			GtkMenu* _tmp23_;
			GtkMenuItem* _tmp24_;
			GtkMenuItem* _tmp25_;
#line 95 "../src/Widgets/SourceListView.vala"
			_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Save as Playlist"));
#line 95 "../src/Widgets/SourceListView.vala"
			g_object_ref_sink (_tmp22_);
#line 95 "../src/Widgets/SourceListView.vala"
			playlist_save = _tmp22_;
#line 96 "../src/Widgets/SourceListView.vala"
			_tmp23_ = self->priv->playlist_menu;
#line 96 "../src/Widgets/SourceListView.vala"
			_tmp24_ = playlist_save;
#line 96 "../src/Widgets/SourceListView.vala"
			gtk_menu_shell_append ((GtkMenuShell*) _tmp23_, _tmp24_);
#line 97 "../src/Widgets/SourceListView.vala"
			_tmp25_ = playlist_save;
#line 97 "../src/Widgets/SourceListView.vala"
			g_signal_connect_object (_tmp25_, "activate", (GCallback) __noise_source_list_item____lambda81__gtk_menu_item_activate, self, 0);
#line 100 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist_save);
#line 100 "../src/Widgets/SourceListView.vala"
			break;
#line 1367 "SourceListView.c"
		}
		default:
#line 64 "../src/Widgets/SourceListView.vala"
		break;
#line 1372 "SourceListView.c"
	}
#line 103 "../src/Widgets/SourceListView.vala"
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Export…"));
#line 103 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp26_);
#line 103 "../src/Widgets/SourceListView.vala"
	playlist_export = _tmp26_;
#line 104 "../src/Widgets/SourceListView.vala"
	_tmp27_ = playlist_export;
#line 104 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp27_, "activate", (GCallback) __noise_source_list_item___lambda82__gtk_menu_item_activate, self, 0);
#line 108 "../src/Widgets/SourceListView.vala"
	_tmp28_ = self->priv->playlist_menu;
#line 108 "../src/Widgets/SourceListView.vala"
	_tmp29_ = playlist_export;
#line 108 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp28_, _tmp29_);
#line 109 "../src/Widgets/SourceListView.vala"
	_tmp30_ = self->priv->playlist_menu;
#line 109 "../src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp30_);
#line 61 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (playlist_export);
#line 61 "../src/Widgets/SourceListView.vala"
	return obj;
#line 1398 "SourceListView.c"
}


static void
noise_source_list_item_class_init (NoiseSourceListItemClass * klass)
{
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSourceListItem_private_offset);
#line 37 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) noise_source_list_item_real_get_context_menu;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_source_list_item_get_property;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_source_list_item_set_property;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_source_list_item_constructor;
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_item_finalize;
#line 37 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 37 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 37 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY, noise_source_list_item_properties[NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY] = g_param_spec_object ("activatable-icon", "activatable-icon", "activatable-icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, gtk_grid_get_type (), NOISE_TYPE_SOURCE_LIST_ITEM);
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_signals[NOISE_SOURCE_LIST_ITEM_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", NOISE_TYPE_SOURCE_LIST_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
#line 1437 "SourceListView.c"
}


static void
noise_source_list_item_noise_source_list_entry_interface_init (NoiseSourceListEntryIface * iface)
{
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_noise_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
#line 1446 "SourceListView.c"
}


static void
noise_source_list_item_granite_widgets_source_list_drag_dest_interface_init (GraniteWidgetsSourceListDragDestIface * iface)
{
#line 37 "../src/Widgets/SourceListView.vala"
	noise_source_list_item_granite_widgets_source_list_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
#line 37 "../src/Widgets/SourceListView.vala"
	iface->data_drop_possible = (gboolean (*) (GraniteWidgetsSourceListDragDest*, GdkDragContext*, GtkSelectionData*)) noise_source_list_item_real_data_drop_possible;
#line 37 "../src/Widgets/SourceListView.vala"
	iface->data_received = (GdkDragAction (*) (GraniteWidgetsSourceListDragDest*, GdkDragContext*, GtkSelectionData*)) noise_source_list_item_real_data_received;
#line 1459 "SourceListView.c"
}


static void
noise_source_list_item_instance_init (NoiseSourceListItem * self)
{
#line 37 "../src/Widgets/SourceListView.vala"
	self->priv = noise_source_list_item_get_instance_private (self);
#line 1468 "SourceListView.c"
}


static void
noise_source_list_item_finalize (GObject * obj)
{
	NoiseSourceListItem * self;
#line 37 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 45 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->_view);
#line 47 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->_activatable_icon);
#line 49 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 37 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_source_list_item_parent_class)->finalize (obj);
#line 1486 "SourceListView.c"
}


/**
 * SourceList item. It stores the number of the corresponding page in the notebook widget.
 */
GType
noise_source_list_item_get_type (void)
{
	static volatile gsize noise_source_list_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListItem), 0, (GInstanceInitFunc) noise_source_list_item_instance_init, NULL };
		static const GInterfaceInfo noise_source_list_entry_info = { (GInterfaceInitFunc) noise_source_list_item_noise_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo granite_widgets_source_list_drag_dest_info = { (GInterfaceInitFunc) noise_source_list_item_granite_widgets_source_list_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_item_type_id;
		noise_source_list_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_ITEM, "NoiseSourceListItem", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_item_type_id, NOISE_TYPE_SOURCE_LIST_ENTRY, &noise_source_list_entry_info);
		g_type_add_interface_static (noise_source_list_item_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_DRAG_DEST, &granite_widgets_source_list_drag_dest_info);
		NoiseSourceListItem_private_offset = g_type_add_instance_private (noise_source_list_item_type_id, sizeof (NoiseSourceListItemPrivate));
		g_once_init_leave (&noise_source_list_item_type_id__volatile, noise_source_list_item_type_id);
	}
	return noise_source_list_item_type_id__volatile;
}


static void
_vala_noise_source_list_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 37 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 37 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		g_value_set_object (value, noise_source_list_item_get_view (self));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		g_value_set_enum (value, noise_source_list_item_get_hint (self));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		g_value_set_object (value, noise_source_list_item_get_activatable_icon (self));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1540 "SourceListView.c"
		default:
#line 37 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1546 "SourceListView.c"
	}
}


static void
_vala_noise_source_list_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoiseSourceListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem);
#line 37 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 37 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_VIEW_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		noise_source_list_item_set_view (self, g_value_get_object (value));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_HINT_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		noise_source_list_item_set_hint (self, g_value_get_enum (value));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 37 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_ITEM_ACTIVATABLE_ICON_PROPERTY:
#line 37 "../src/Widgets/SourceListView.vala"
		noise_source_list_item_set_activatable_icon (self, g_value_get_object (value));
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1579 "SourceListView.c"
		default:
#line 37 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 37 "../src/Widgets/SourceListView.vala"
		break;
#line 1585 "SourceListView.c"
	}
}


static inline gpointer
noise_source_list_expandable_item_get_instance_private (NoiseSourceListExpandableItem* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSourceListExpandableItem_private_offset);
}


static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 146 "../src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 146 "../src/Widgets/SourceListView.vala"
	return _data31_;
#line 1604 "SourceListView.c"
}


static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 146 "../src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 1615 "SourceListView.c"
		NoiseSourceListExpandableItem* self;
#line 146 "../src/Widgets/SourceListView.vala"
		self = _data31_->self;
#line 146 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data31_->view);
#line 146 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 146 "../src/Widgets/SourceListView.vala"
		g_slice_free (Block31Data, _data31_);
#line 1625 "SourceListView.c"
	}
}


static void
___lambda87_ (Block31Data* _data31_)
{
	NoiseSourceListExpandableItem* self;
#line 158 "../src/Widgets/SourceListView.vala"
	self = _data31_->self;
#line 159 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _data31_->view);
#line 1638 "SourceListView.c"
}


static void
____lambda87__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 158 "../src/Widgets/SourceListView.vala"
	___lambda87_ (self);
#line 1648 "SourceListView.c"
}


static void
___lambda88_ (Block31Data* _data31_)
{
	NoiseSourceListExpandableItem* self;
#line 167 "../src/Widgets/SourceListView.vala"
	self = _data31_->self;
#line 168 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL], 0, _data31_->view);
#line 1660 "SourceListView.c"
}


static void
____lambda88__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 167 "../src/Widgets/SourceListView.vala"
	___lambda88_ (self);
#line 1670 "SourceListView.c"
}


static void
_____lambda89_ (Block31Data* _data31_)
{
	NoiseSourceListExpandableItem* self;
#line 177 "../src/Widgets/SourceListView.vala"
	self = _data31_->self;
#line 178 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, _data31_->view);
#line 1682 "SourceListView.c"
}


static void
______lambda89__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 177 "../src/Widgets/SourceListView.vala"
	_____lambda89_ (self);
#line 1692 "SourceListView.c"
}


static void
_____lambda90_ (Block31Data* _data31_)
{
	NoiseSourceListExpandableItem* self;
#line 185 "../src/Widgets/SourceListView.vala"
	self = _data31_->self;
#line 186 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, _data31_->view);
#line 1704 "SourceListView.c"
}


static void
______lambda90__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 185 "../src/Widgets/SourceListView.vala"
	_____lambda90_ (self);
#line 1714 "SourceListView.c"
}


static void
_____lambda91_ (Block31Data* _data31_)
{
	NoiseSourceListExpandableItem* self;
#line 193 "../src/Widgets/SourceListView.vala"
	self = _data31_->self;
#line 194 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL], 0, _data31_->view);
#line 1726 "SourceListView.c"
}


static void
______lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                        gpointer self)
{
#line 193 "../src/Widgets/SourceListView.vala"
	_____lambda91_ (self);
#line 1736 "SourceListView.c"
}


NoiseSourceListExpandableItem*
noise_source_list_expandable_item_construct (GType object_type,
                                             GtkGrid* view,
                                             const gchar* name,
                                             NoiseViewWrapperHint hint,
                                             GIcon* icon,
                                             GIcon* activatable_icon,
                                             GObject* give_more_information)
{
	NoiseSourceListExpandableItem * self = NULL;
	Block31Data* _data31_;
	GtkGrid* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp28_;
#line 146 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 146 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 146 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 146 "../src/Widgets/SourceListView.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 146 "../src/Widgets/SourceListView.vala"
	_data31_->_ref_count_ = 1;
#line 146 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _g_object_ref0 (view);
#line 146 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (_data31_->view);
#line 146 "../src/Widgets/SourceListView.vala"
	_data31_->view = _tmp0_;
#line 147 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListExpandableItem*) granite_widgets_source_list_expandable_item_construct (object_type, name);
#line 147 "../src/Widgets/SourceListView.vala"
	_data31_->self = g_object_ref (self);
#line 148 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_set_view (self, _data31_->view);
#line 149 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) self, icon);
#line 150 "../src/Widgets/SourceListView.vala"
	self->hint = hint;
#line 151 "../src/Widgets/SourceListView.vala"
	if (activatable_icon != NULL) {
#line 152 "../src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) self, activatable_icon);
#line 1784 "SourceListView.c"
	}
#line 154 "../src/Widgets/SourceListView.vala"
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 154 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp1_);
#line 154 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->device_menu);
#line 154 "../src/Widgets/SourceListView.vala"
	self->priv->device_menu = _tmp1_;
#line 156 "../src/Widgets/SourceListView.vala"
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO) {
#line 1796 "SourceListView.c"
		GtkMenuItem* import_menuitem = NULL;
		GtkMenuItem* _tmp2_;
		GtkMenuItem* _tmp3_;
		GtkMenu* _tmp4_;
		GtkMenuItem* _tmp5_;
#line 157 "../src/Widgets/SourceListView.vala"
		_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import to Library"));
#line 157 "../src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp2_);
#line 157 "../src/Widgets/SourceListView.vala"
		import_menuitem = _tmp2_;
#line 158 "../src/Widgets/SourceListView.vala"
		_tmp3_ = import_menuitem;
#line 158 "../src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp3_, "activate", (GCallback) ____lambda87__gtk_menu_item_activate, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 162 "../src/Widgets/SourceListView.vala"
		_tmp4_ = self->priv->device_menu;
#line 162 "../src/Widgets/SourceListView.vala"
		_tmp5_ = import_menuitem;
#line 162 "../src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 156 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (import_menuitem);
#line 1820 "SourceListView.c"
	}
#line 165 "../src/Widgets/SourceListView.vala"
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
#line 1824 "SourceListView.c"
		GtkMenuItem* eject_menuitem = NULL;
		GtkMenuItem* _tmp6_;
		GtkMenuItem* _tmp7_;
		GtkMenu* _tmp26_;
		GtkMenuItem* _tmp27_;
#line 166 "../src/Widgets/SourceListView.vala"
		_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Eject"));
#line 166 "../src/Widgets/SourceListView.vala"
		g_object_ref_sink (_tmp6_);
#line 166 "../src/Widgets/SourceListView.vala"
		eject_menuitem = _tmp6_;
#line 167 "../src/Widgets/SourceListView.vala"
		_tmp7_ = eject_menuitem;
#line 167 "../src/Widgets/SourceListView.vala"
		g_signal_connect_data (_tmp7_, "activate", (GCallback) ____lambda88__gtk_menu_item_activate, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 171 "../src/Widgets/SourceListView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (give_more_information, NOISE_TYPE_DEVICE)) {
#line 1842 "SourceListView.c"
			NoiseDevice* device = NULL;
			NoiseDevice* _tmp8_;
			NoiseLibrary* device_library = NULL;
			NoiseDevice* _tmp9_;
			NoiseLibrary* _tmp10_;
			NoiseLibrary* _tmp11_;
			NoiseLibrary* _tmp16_;
			NoiseDevice* _tmp21_;
#line 172 "../src/Widgets/SourceListView.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (give_more_information, NOISE_TYPE_DEVICE, NoiseDevice));
#line 172 "../src/Widgets/SourceListView.vala"
			device = _tmp8_;
#line 173 "../src/Widgets/SourceListView.vala"
			_tmp9_ = device;
#line 173 "../src/Widgets/SourceListView.vala"
			_tmp10_ = noise_device_get_library (_tmp9_);
#line 173 "../src/Widgets/SourceListView.vala"
			device_library = _tmp10_;
#line 175 "../src/Widgets/SourceListView.vala"
			_tmp11_ = device_library;
#line 175 "../src/Widgets/SourceListView.vala"
			if (noise_library_support_playlists (_tmp11_)) {
#line 1865 "SourceListView.c"
				GtkMenuItem* add_playlist_menuitem = NULL;
				GtkMenuItem* _tmp12_;
				GtkMenuItem* _tmp13_;
				GtkMenu* _tmp14_;
				GtkMenuItem* _tmp15_;
#line 176 "../src/Widgets/SourceListView.vala"
				_tmp12_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
#line 176 "../src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp12_);
#line 176 "../src/Widgets/SourceListView.vala"
				add_playlist_menuitem = _tmp12_;
#line 177 "../src/Widgets/SourceListView.vala"
				_tmp13_ = add_playlist_menuitem;
#line 177 "../src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp13_, "activate", (GCallback) ______lambda89__gtk_menu_item_activate, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 180 "../src/Widgets/SourceListView.vala"
				_tmp14_ = self->priv->device_menu;
#line 180 "../src/Widgets/SourceListView.vala"
				_tmp15_ = add_playlist_menuitem;
#line 180 "../src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp14_, _tmp15_);
#line 175 "../src/Widgets/SourceListView.vala"
				_g_object_unref0 (add_playlist_menuitem);
#line 1889 "SourceListView.c"
			}
#line 183 "../src/Widgets/SourceListView.vala"
			_tmp16_ = device_library;
#line 183 "../src/Widgets/SourceListView.vala"
			if (noise_library_support_smart_playlists (_tmp16_)) {
#line 1895 "SourceListView.c"
				GtkMenuItem* add_smart_playlist_menuitem = NULL;
				GtkMenuItem* _tmp17_;
				GtkMenuItem* _tmp18_;
				GtkMenu* _tmp19_;
				GtkMenuItem* _tmp20_;
#line 184 "../src/Widgets/SourceListView.vala"
				_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
#line 184 "../src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp17_);
#line 184 "../src/Widgets/SourceListView.vala"
				add_smart_playlist_menuitem = _tmp17_;
#line 185 "../src/Widgets/SourceListView.vala"
				_tmp18_ = add_smart_playlist_menuitem;
#line 185 "../src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp18_, "activate", (GCallback) ______lambda90__gtk_menu_item_activate, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 188 "../src/Widgets/SourceListView.vala"
				_tmp19_ = self->priv->device_menu;
#line 188 "../src/Widgets/SourceListView.vala"
				_tmp20_ = add_smart_playlist_menuitem;
#line 188 "../src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, _tmp20_);
#line 183 "../src/Widgets/SourceListView.vala"
				_g_object_unref0 (add_smart_playlist_menuitem);
#line 1919 "SourceListView.c"
			}
#line 191 "../src/Widgets/SourceListView.vala"
			_tmp21_ = device;
#line 191 "../src/Widgets/SourceListView.vala"
			if (noise_device_read_only (_tmp21_) == FALSE) {
#line 1925 "SourceListView.c"
				GtkMenuItem* sync_menuitem = NULL;
				GtkMenuItem* _tmp22_;
				GtkMenuItem* _tmp23_;
				GtkMenu* _tmp24_;
				GtkMenuItem* _tmp25_;
#line 192 "../src/Widgets/SourceListView.vala"
				_tmp22_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Sync"));
#line 192 "../src/Widgets/SourceListView.vala"
				g_object_ref_sink (_tmp22_);
#line 192 "../src/Widgets/SourceListView.vala"
				sync_menuitem = _tmp22_;
#line 193 "../src/Widgets/SourceListView.vala"
				_tmp23_ = sync_menuitem;
#line 193 "../src/Widgets/SourceListView.vala"
				g_signal_connect_data (_tmp23_, "activate", (GCallback) ______lambda91__gtk_menu_item_activate, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 196 "../src/Widgets/SourceListView.vala"
				_tmp24_ = self->priv->device_menu;
#line 196 "../src/Widgets/SourceListView.vala"
				_tmp25_ = sync_menuitem;
#line 196 "../src/Widgets/SourceListView.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
#line 191 "../src/Widgets/SourceListView.vala"
				_g_object_unref0 (sync_menuitem);
#line 1949 "SourceListView.c"
			}
#line 171 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device_library);
#line 171 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 1955 "SourceListView.c"
		}
#line 199 "../src/Widgets/SourceListView.vala"
		_tmp26_ = self->priv->device_menu;
#line 199 "../src/Widgets/SourceListView.vala"
		_tmp27_ = eject_menuitem;
#line 199 "../src/Widgets/SourceListView.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp26_, _tmp27_);
#line 165 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (eject_menuitem);
#line 1965 "SourceListView.c"
	}
#line 202 "../src/Widgets/SourceListView.vala"
	_tmp28_ = self->priv->device_menu;
#line 202 "../src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp28_);
#line 146 "../src/Widgets/SourceListView.vala"
	block31_data_unref (_data31_);
#line 146 "../src/Widgets/SourceListView.vala"
	_data31_ = NULL;
#line 146 "../src/Widgets/SourceListView.vala"
	return self;
#line 1977 "SourceListView.c"
}


NoiseSourceListExpandableItem*
noise_source_list_expandable_item_new (GtkGrid* view,
                                       const gchar* name,
                                       NoiseViewWrapperHint hint,
                                       GIcon* icon,
                                       GIcon* activatable_icon,
                                       GObject* give_more_information)
{
#line 146 "../src/Widgets/SourceListView.vala"
	return noise_source_list_expandable_item_construct (NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, view, name, hint, icon, activatable_icon, give_more_information);
#line 1991 "SourceListView.c"
}


static GtkMenu*
noise_source_list_expandable_item_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	NoiseSourceListExpandableItem * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
#line 205 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListExpandableItem*) base;
#line 206 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->device_menu;
#line 206 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 206 "../src/Widgets/SourceListView.vala"
	result = _tmp1_;
#line 206 "../src/Widgets/SourceListView.vala"
	return result;
#line 2012 "SourceListView.c"
}


GtkGrid*
noise_source_list_expandable_item_get_view (NoiseSourceListExpandableItem* self)
{
	GtkGrid* result;
	GtkGrid* _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->_view;
#line 135 "../src/Widgets/SourceListView.vala"
	result = _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
	return result;
#line 2029 "SourceListView.c"
}


void
noise_source_list_expandable_item_set_view (NoiseSourceListExpandableItem* self,
                                            GtkGrid* value)
{
#line 135 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/Widgets/SourceListView.vala"
	if (noise_source_list_expandable_item_get_view (self) != value) {
#line 2041 "SourceListView.c"
		GtkGrid* _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 135 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self->priv->_view);
#line 135 "../src/Widgets/SourceListView.vala"
		self->priv->_view = _tmp0_;
#line 135 "../src/Widgets/SourceListView.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY]);
#line 2051 "SourceListView.c"
	}
}


static void
noise_source_list_expandable_item_class_init (NoiseSourceListExpandableItemClass * klass)
{
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_parent_class = g_type_class_peek_parent (klass);
#line 134 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSourceListExpandableItem_private_offset);
#line 134 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) noise_source_list_expandable_item_real_get_context_menu;
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_source_list_expandable_item_get_property;
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_source_list_expandable_item_set_property;
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_expandable_item_finalize;
#line 134 "../src/Widgets/SourceListView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY, noise_source_list_expandable_item_properties[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", gtk_grid_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_signals[NOISE_SOURCE_LIST_EXPANDABLE_ITEM_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 2083 "SourceListView.c"
}


static void
noise_source_list_expandable_item_noise_source_list_entry_interface_init (NoiseSourceListEntryIface * iface)
{
#line 134 "../src/Widgets/SourceListView.vala"
	noise_source_list_expandable_item_noise_source_list_entry_parent_iface = g_type_interface_peek_parent (iface);
#line 2092 "SourceListView.c"
}


static void
noise_source_list_expandable_item_instance_init (NoiseSourceListExpandableItem * self)
{
#line 134 "../src/Widgets/SourceListView.vala"
	self->priv = noise_source_list_expandable_item_get_instance_private (self);
#line 2101 "SourceListView.c"
}


static void
noise_source_list_expandable_item_finalize (GObject * obj)
{
	NoiseSourceListExpandableItem * self;
#line 134 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
#line 135 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->_view);
#line 138 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->device_menu);
#line 134 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_source_list_expandable_item_parent_class)->finalize (obj);
#line 2117 "SourceListView.c"
}


GType
noise_source_list_expandable_item_get_type (void)
{
	static volatile gsize noise_source_list_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListExpandableItem), 0, (GInstanceInitFunc) noise_source_list_expandable_item_instance_init, NULL };
		static const GInterfaceInfo noise_source_list_entry_info = { (GInterfaceInitFunc) noise_source_list_expandable_item_noise_source_list_entry_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_expandable_item_type_id;
		noise_source_list_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoiseSourceListExpandableItem", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_expandable_item_type_id, NOISE_TYPE_SOURCE_LIST_ENTRY, &noise_source_list_entry_info);
		NoiseSourceListExpandableItem_private_offset = g_type_add_instance_private (noise_source_list_expandable_item_type_id, sizeof (NoiseSourceListExpandableItemPrivate));
		g_once_init_leave (&noise_source_list_expandable_item_type_id__volatile, noise_source_list_expandable_item_type_id);
	}
	return noise_source_list_expandable_item_type_id__volatile;
}


static void
_vala_noise_source_list_expandable_item_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
#line 134 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 134 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
#line 134 "../src/Widgets/SourceListView.vala"
		g_value_set_object (value, noise_source_list_expandable_item_get_view (self));
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 2154 "SourceListView.c"
		default:
#line 134 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 2160 "SourceListView.c"
	}
}


static void
_vala_noise_source_list_expandable_item_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	NoiseSourceListExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem);
#line 134 "../src/Widgets/SourceListView.vala"
	switch (property_id) {
#line 134 "../src/Widgets/SourceListView.vala"
		case NOISE_SOURCE_LIST_EXPANDABLE_ITEM_VIEW_PROPERTY:
#line 134 "../src/Widgets/SourceListView.vala"
		noise_source_list_expandable_item_set_view (self, g_value_get_object (value));
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 2181 "SourceListView.c"
		default:
#line 134 "../src/Widgets/SourceListView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 134 "../src/Widgets/SourceListView.vala"
		break;
#line 2187 "SourceListView.c"
	}
}


static inline gpointer
noise_play_list_category_get_instance_private (NoisePlayListCategory* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlayListCategory_private_offset);
}


NoisePlayListCategory*
noise_play_list_category_construct (GType object_type,
                                    const gchar* name)
{
	NoisePlayListCategory * self = NULL;
#line 214 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 215 "../src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) g_object_new (object_type, "name", name, NULL);
#line 214 "../src/Widgets/SourceListView.vala"
	return self;
#line 2210 "SourceListView.c"
}


NoisePlayListCategory*
noise_play_list_category_new (const gchar* name)
{
#line 214 "../src/Widgets/SourceListView.vala"
	return noise_play_list_category_construct (NOISE_TYPE_PLAY_LIST_CATEGORY, name);
#line 2219 "SourceListView.c"
}


static GtkMenu*
noise_play_list_category_real_get_context_menu (GraniteWidgetsSourceListItem* base)
{
	NoisePlayListCategory * self;
	GtkMenu* result = NULL;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
#line 242 "../src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) base;
#line 243 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlist_menu;
#line 243 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 243 "../src/Widgets/SourceListView.vala"
	result = _tmp1_;
#line 243 "../src/Widgets/SourceListView.vala"
	return result;
#line 2240 "SourceListView.c"
}


static gboolean
noise_play_list_category_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	NoisePlayListCategory * self;
	gboolean result = FALSE;
#line 247 "../src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) base;
#line 248 "../src/Widgets/SourceListView.vala"
	result = TRUE;
#line 248 "../src/Widgets/SourceListView.vala"
	return result;
#line 2255 "SourceListView.c"
}


static gint
noise_play_list_category_real_compare (GraniteWidgetsSourceListSortable* base,
                                       GraniteWidgetsSourceListItem* a,
                                       GraniteWidgetsSourceListItem* b)
{
	NoisePlayListCategory * self;
	gint result = 0;
	NoiseSourceListItem* item_a = NULL;
	NoiseSourceListItem* _tmp0_;
	NoiseSourceListItem* item_b = NULL;
	NoiseSourceListItem* _tmp1_;
	gboolean _tmp2_ = FALSE;
	NoiseSourceListItem* _tmp3_;
	NoiseSourceListItem* _tmp5_;
	NoiseViewWrapperHint _tmp6_;
	NoiseViewWrapperHint _tmp7_;
	NoiseSourceListItem* _tmp23_;
	NoiseViewWrapperHint _tmp24_;
	NoiseViewWrapperHint _tmp25_;
	NoiseSourceListItem* _tmp35_;
	NoiseViewWrapperHint _tmp36_;
	NoiseViewWrapperHint _tmp37_;
#line 251 "../src/Widgets/SourceListView.vala"
	self = (NoisePlayListCategory*) base;
#line 251 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 251 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 252 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (a, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) a) : NULL);
#line 252 "../src/Widgets/SourceListView.vala"
	item_a = _tmp0_;
#line 253 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (b, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) b) : NULL);
#line 253 "../src/Widgets/SourceListView.vala"
	item_b = _tmp1_;
#line 255 "../src/Widgets/SourceListView.vala"
	_tmp3_ = item_a;
#line 255 "../src/Widgets/SourceListView.vala"
	if (_tmp3_ == NULL) {
#line 255 "../src/Widgets/SourceListView.vala"
		_tmp2_ = TRUE;
#line 2301 "SourceListView.c"
	} else {
		NoiseSourceListItem* _tmp4_;
#line 255 "../src/Widgets/SourceListView.vala"
		_tmp4_ = item_b;
#line 255 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp4_ == NULL;
#line 2308 "SourceListView.c"
	}
#line 255 "../src/Widgets/SourceListView.vala"
	if (_tmp2_) {
#line 256 "../src/Widgets/SourceListView.vala"
		result = 0;
#line 256 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 256 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 256 "../src/Widgets/SourceListView.vala"
		return result;
#line 2320 "SourceListView.c"
	}
#line 258 "../src/Widgets/SourceListView.vala"
	_tmp5_ = item_a;
#line 258 "../src/Widgets/SourceListView.vala"
	_tmp6_ = noise_source_list_item_get_hint (_tmp5_);
#line 258 "../src/Widgets/SourceListView.vala"
	_tmp7_ = _tmp6_;
#line 258 "../src/Widgets/SourceListView.vala"
	if (_tmp7_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 2330 "SourceListView.c"
		NoiseSourceListItem* _tmp8_;
		NoiseViewWrapperHint _tmp9_;
		NoiseViewWrapperHint _tmp10_;
#line 260 "../src/Widgets/SourceListView.vala"
		_tmp8_ = item_b;
#line 260 "../src/Widgets/SourceListView.vala"
		_tmp9_ = noise_source_list_item_get_hint (_tmp8_);
#line 260 "../src/Widgets/SourceListView.vala"
		_tmp10_ = _tmp9_;
#line 260 "../src/Widgets/SourceListView.vala"
		if (_tmp10_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 2342 "SourceListView.c"
			GCompareFunc _tmp11_;
			NoiseSourceListItem* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			NoiseSourceListItem* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gint _tmp22_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp11_ = ((GCompareFunc) g_strcmp0);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp12_ = item_a;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp13_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp12_);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp14_ = _tmp13_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp15_ = g_utf8_collate_key (_tmp14_, (gssize) -1);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp16_ = _tmp15_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp17_ = item_b;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp18_ = granite_widgets_source_list_item_get_name ((GraniteWidgetsSourceListItem*) _tmp17_);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp19_ = _tmp18_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp20_ = g_utf8_collate_key (_tmp19_, (gssize) -1);
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp21_ = _tmp20_;
#line 261 "../src/Widgets/SourceListView.vala"
			_tmp22_ = _tmp11_ (_tmp16_, _tmp21_);
#line 261 "../src/Widgets/SourceListView.vala"
			_g_free0 (_tmp21_);
#line 261 "../src/Widgets/SourceListView.vala"
			_g_free0 (_tmp16_);
#line 261 "../src/Widgets/SourceListView.vala"
			result = _tmp22_;
#line 261 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 261 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 261 "../src/Widgets/SourceListView.vala"
			return result;
#line 2391 "SourceListView.c"
		}
#line 264 "../src/Widgets/SourceListView.vala"
		result = -1;
#line 264 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 264 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 264 "../src/Widgets/SourceListView.vala"
		return result;
#line 2401 "SourceListView.c"
	}
#line 267 "../src/Widgets/SourceListView.vala"
	_tmp23_ = item_a;
#line 267 "../src/Widgets/SourceListView.vala"
	_tmp24_ = noise_source_list_item_get_hint (_tmp23_);
#line 267 "../src/Widgets/SourceListView.vala"
	_tmp25_ = _tmp24_;
#line 267 "../src/Widgets/SourceListView.vala"
	if (_tmp25_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 2411 "SourceListView.c"
		NoiseSourceListItem* _tmp26_;
		NoiseViewWrapperHint _tmp27_;
		NoiseViewWrapperHint _tmp28_;
		NoiseSourceListItem* _tmp29_;
		NoiseViewWrapperHint _tmp30_;
		NoiseViewWrapperHint _tmp31_;
		NoiseSourceListItem* _tmp32_;
		NoiseViewWrapperHint _tmp33_;
		NoiseViewWrapperHint _tmp34_;
#line 269 "../src/Widgets/SourceListView.vala"
		_tmp26_ = item_b;
#line 269 "../src/Widgets/SourceListView.vala"
		_tmp27_ = noise_source_list_item_get_hint (_tmp26_);
#line 269 "../src/Widgets/SourceListView.vala"
		_tmp28_ = _tmp27_;
#line 269 "../src/Widgets/SourceListView.vala"
		if (_tmp28_ == NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST) {
#line 270 "../src/Widgets/SourceListView.vala"
			result = 1;
#line 270 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 270 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 270 "../src/Widgets/SourceListView.vala"
			return result;
#line 2437 "SourceListView.c"
		}
#line 273 "../src/Widgets/SourceListView.vala"
		_tmp29_ = item_b;
#line 273 "../src/Widgets/SourceListView.vala"
		_tmp30_ = noise_source_list_item_get_hint (_tmp29_);
#line 273 "../src/Widgets/SourceListView.vala"
		_tmp31_ = _tmp30_;
#line 273 "../src/Widgets/SourceListView.vala"
		if (_tmp31_ == NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST) {
#line 274 "../src/Widgets/SourceListView.vala"
			result = 0;
#line 274 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 274 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 274 "../src/Widgets/SourceListView.vala"
			return result;
#line 2455 "SourceListView.c"
		}
#line 277 "../src/Widgets/SourceListView.vala"
		_tmp32_ = item_b;
#line 277 "../src/Widgets/SourceListView.vala"
		_tmp33_ = noise_source_list_item_get_hint (_tmp32_);
#line 277 "../src/Widgets/SourceListView.vala"
		_tmp34_ = _tmp33_;
#line 277 "../src/Widgets/SourceListView.vala"
		if (_tmp34_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 278 "../src/Widgets/SourceListView.vala"
			result = -1;
#line 278 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 278 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 278 "../src/Widgets/SourceListView.vala"
			return result;
#line 2473 "SourceListView.c"
		}
	}
#line 281 "../src/Widgets/SourceListView.vala"
	_tmp35_ = item_a;
#line 281 "../src/Widgets/SourceListView.vala"
	_tmp36_ = noise_source_list_item_get_hint (_tmp35_);
#line 281 "../src/Widgets/SourceListView.vala"
	_tmp37_ = _tmp36_;
#line 281 "../src/Widgets/SourceListView.vala"
	if (_tmp37_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 2484 "SourceListView.c"
		NoiseSourceListItem* _tmp38_;
		NoiseViewWrapperHint _tmp39_;
		NoiseViewWrapperHint _tmp40_;
#line 283 "../src/Widgets/SourceListView.vala"
		_tmp38_ = item_b;
#line 283 "../src/Widgets/SourceListView.vala"
		_tmp39_ = noise_source_list_item_get_hint (_tmp38_);
#line 283 "../src/Widgets/SourceListView.vala"
		_tmp40_ = _tmp39_;
#line 283 "../src/Widgets/SourceListView.vala"
		if (_tmp40_ == NOISE_VIEW_WRAPPER_HINT_PLAYLIST) {
#line 284 "../src/Widgets/SourceListView.vala"
			result = 0;
#line 284 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_b);
#line 284 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (item_a);
#line 284 "../src/Widgets/SourceListView.vala"
			return result;
#line 2504 "SourceListView.c"
		}
#line 287 "../src/Widgets/SourceListView.vala"
		result = 1;
#line 287 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_b);
#line 287 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (item_a);
#line 287 "../src/Widgets/SourceListView.vala"
		return result;
#line 2514 "SourceListView.c"
	}
#line 290 "../src/Widgets/SourceListView.vala"
	result = 0;
#line 290 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (item_b);
#line 290 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (item_a);
#line 290 "../src/Widgets/SourceListView.vala"
	return result;
#line 2524 "SourceListView.c"
}


static void
_noise_play_list_category___lambda83_ (NoisePlayListCategory* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLocalLibrary* _tmp2_;
	NoiseLocalLibrary* _tmp3_;
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp2_ = noise_library_window_get_library_manager (self);
#line 230 "../src/Widgets/SourceListView.vala"
	_tmp3_ = _tmp2_;
#line 230 "../src/Widgets/SourceListView.vala"
	noise_library_window_create_new_playlist (_tmp1_, (NoiseLibrary*) _tmp3_);
#line 2545 "SourceListView.c"
}


static void
__noise_play_list_category___lambda83__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 229 "../src/Widgets/SourceListView.vala"
	_noise_play_list_category___lambda83_ ((NoisePlayListCategory*) self);
#line 2555 "SourceListView.c"
}


static void
_noise_play_list_category___lambda84_ (NoisePlayListCategory* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
#line 234 "../src/Widgets/SourceListView.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 234 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 234 "../src/Widgets/SourceListView.vala"
	noise_library_window_show_smart_playlist_dialog (_tmp1_, NULL);
#line 2570 "SourceListView.c"
}


static void
__noise_play_list_category___lambda84__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 233 "../src/Widgets/SourceListView.vala"
	_noise_play_list_category___lambda84_ ((NoisePlayListCategory*) self);
#line 2580 "SourceListView.c"
}


static void
_noise_play_list_category___lambda85_ (NoisePlayListCategory* self)
{
#line 238 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
#line 2589 "SourceListView.c"
}


static void
__noise_play_list_category___lambda85__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self)
{
#line 237 "../src/Widgets/SourceListView.vala"
	_noise_play_list_category___lambda85_ ((NoisePlayListCategory*) self);
#line 2599 "SourceListView.c"
}


static GObject *
noise_play_list_category_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlayListCategory * self;
	GtkMenuItem* playlist_new = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* smart_playlist_new = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* playlist_import = NULL;
	GtkMenuItem* _tmp2_;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenu* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
#line 218 "../src/Widgets/SourceListView.vala"
	parent_class = G_OBJECT_CLASS (noise_play_list_category_parent_class);
#line 218 "../src/Widgets/SourceListView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 218 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory);
#line 219 "../src/Widgets/SourceListView.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Playlist"));
#line 219 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp0_);
#line 219 "../src/Widgets/SourceListView.vala"
	playlist_new = _tmp0_;
#line 220 "../src/Widgets/SourceListView.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Smart Playlist"));
#line 220 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp1_);
#line 220 "../src/Widgets/SourceListView.vala"
	smart_playlist_new = _tmp1_;
#line 221 "../src/Widgets/SourceListView.vala"
	_tmp2_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Import Playlists"));
#line 221 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp2_);
#line 221 "../src/Widgets/SourceListView.vala"
	playlist_import = _tmp2_;
#line 223 "../src/Widgets/SourceListView.vala"
	_tmp3_ = (GtkMenu*) gtk_menu_new ();
#line 223 "../src/Widgets/SourceListView.vala"
	g_object_ref_sink (_tmp3_);
#line 223 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 223 "../src/Widgets/SourceListView.vala"
	self->priv->playlist_menu = _tmp3_;
#line 224 "../src/Widgets/SourceListView.vala"
	_tmp4_ = self->priv->playlist_menu;
#line 224 "../src/Widgets/SourceListView.vala"
	_tmp5_ = playlist_new;
#line 224 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp4_, _tmp5_);
#line 225 "../src/Widgets/SourceListView.vala"
	_tmp6_ = self->priv->playlist_menu;
#line 225 "../src/Widgets/SourceListView.vala"
	_tmp7_ = smart_playlist_new;
#line 225 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp6_, _tmp7_);
#line 226 "../src/Widgets/SourceListView.vala"
	_tmp8_ = self->priv->playlist_menu;
#line 226 "../src/Widgets/SourceListView.vala"
	_tmp9_ = playlist_import;
#line 226 "../src/Widgets/SourceListView.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, _tmp9_);
#line 227 "../src/Widgets/SourceListView.vala"
	_tmp10_ = self->priv->playlist_menu;
#line 227 "../src/Widgets/SourceListView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 229 "../src/Widgets/SourceListView.vala"
	_tmp11_ = playlist_new;
#line 229 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp11_, "activate", (GCallback) __noise_play_list_category___lambda83__gtk_menu_item_activate, self, 0);
#line 233 "../src/Widgets/SourceListView.vala"
	_tmp12_ = smart_playlist_new;
#line 233 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp12_, "activate", (GCallback) __noise_play_list_category___lambda84__gtk_menu_item_activate, self, 0);
#line 237 "../src/Widgets/SourceListView.vala"
	_tmp13_ = playlist_import;
#line 237 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp13_, "activate", (GCallback) __noise_play_list_category___lambda85__gtk_menu_item_activate, self, 0);
#line 218 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (playlist_import);
#line 218 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (smart_playlist_new);
#line 218 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (playlist_new);
#line 218 "../src/Widgets/SourceListView.vala"
	return obj;
#line 2702 "SourceListView.c"
}


static void
noise_play_list_category_class_init (NoisePlayListCategoryClass * klass)
{
#line 210 "../src/Widgets/SourceListView.vala"
	noise_play_list_category_parent_class = g_type_class_peek_parent (klass);
#line 210 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &NoisePlayListCategory_private_offset);
#line 210 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListItem*)) noise_play_list_category_real_get_context_menu;
#line 210 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_play_list_category_constructor;
#line 210 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_play_list_category_finalize;
#line 210 "../src/Widgets/SourceListView.vala"
	noise_play_list_category_signals[NOISE_PLAY_LIST_CATEGORY_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", NOISE_TYPE_PLAY_LIST_CATEGORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2721 "SourceListView.c"
}


static void
noise_play_list_category_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface)
{
#line 210 "../src/Widgets/SourceListView.vala"
	noise_play_list_category_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 210 "../src/Widgets/SourceListView.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) noise_play_list_category_real_allow_dnd_sorting;
#line 210 "../src/Widgets/SourceListView.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) noise_play_list_category_real_compare;
#line 2734 "SourceListView.c"
}


static void
noise_play_list_category_instance_init (NoisePlayListCategory * self)
{
#line 210 "../src/Widgets/SourceListView.vala"
	self->priv = noise_play_list_category_get_instance_private (self);
#line 2743 "SourceListView.c"
}


static void
noise_play_list_category_finalize (GObject * obj)
{
	NoisePlayListCategory * self;
#line 210 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAY_LIST_CATEGORY, NoisePlayListCategory);
#line 211 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlist_menu);
#line 210 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_play_list_category_parent_class)->finalize (obj);
#line 2757 "SourceListView.c"
}


GType
noise_play_list_category_get_type (void)
{
	static volatile gsize noise_play_list_category_type_id__volatile = 0;
	if (g_once_init_enter (&noise_play_list_category_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlayListCategoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_play_list_category_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlayListCategory), 0, (GInstanceInitFunc) noise_play_list_category_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) noise_play_list_category_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_play_list_category_type_id;
		noise_play_list_category_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoisePlayListCategory", &g_define_type_info, 0);
		g_type_add_interface_static (noise_play_list_category_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		NoisePlayListCategory_private_offset = g_type_add_instance_private (noise_play_list_category_type_id, sizeof (NoisePlayListCategoryPrivate));
		g_once_init_leave (&noise_play_list_category_type_id__volatile, noise_play_list_category_type_id);
	}
	return noise_play_list_category_type_id__volatile;
}


NoiseSourceListRoot*
noise_source_list_root_construct (GType object_type)
{
	NoiseSourceListRoot * self = NULL;
#line 296 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListRoot*) granite_widgets_source_list_expandable_item_construct (object_type, "SourceListRoot");
#line 295 "../src/Widgets/SourceListView.vala"
	return self;
#line 2786 "SourceListView.c"
}


NoiseSourceListRoot*
noise_source_list_root_new (void)
{
#line 295 "../src/Widgets/SourceListView.vala"
	return noise_source_list_root_construct (NOISE_TYPE_SOURCE_LIST_ROOT);
#line 2795 "SourceListView.c"
}


static gboolean
noise_source_list_root_real_allow_dnd_sorting (GraniteWidgetsSourceListSortable* base)
{
	NoiseSourceListRoot * self;
	gboolean result = FALSE;
#line 299 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListRoot*) base;
#line 300 "../src/Widgets/SourceListView.vala"
	result = TRUE;
#line 300 "../src/Widgets/SourceListView.vala"
	return result;
#line 2810 "SourceListView.c"
}


static gint
noise_source_list_root_real_compare (GraniteWidgetsSourceListSortable* base,
                                     GraniteWidgetsSourceListItem* a,
                                     GraniteWidgetsSourceListItem* b)
{
	NoiseSourceListRoot * self;
	gint result = 0;
#line 303 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListRoot*) base;
#line 303 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 303 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 304 "../src/Widgets/SourceListView.vala"
	result = 0;
#line 304 "../src/Widgets/SourceListView.vala"
	return result;
#line 2831 "SourceListView.c"
}


static void
noise_source_list_root_class_init (NoiseSourceListRootClass * klass)
{
#line 294 "../src/Widgets/SourceListView.vala"
	noise_source_list_root_parent_class = g_type_class_peek_parent (klass);
#line 2840 "SourceListView.c"
}


static void
noise_source_list_root_granite_widgets_source_list_sortable_interface_init (GraniteWidgetsSourceListSortableIface * iface)
{
#line 294 "../src/Widgets/SourceListView.vala"
	noise_source_list_root_granite_widgets_source_list_sortable_parent_iface = g_type_interface_peek_parent (iface);
#line 294 "../src/Widgets/SourceListView.vala"
	iface->allow_dnd_sorting = (gboolean (*) (GraniteWidgetsSourceListSortable*)) noise_source_list_root_real_allow_dnd_sorting;
#line 294 "../src/Widgets/SourceListView.vala"
	iface->compare = (gint (*) (GraniteWidgetsSourceListSortable*, GraniteWidgetsSourceListItem*, GraniteWidgetsSourceListItem*)) noise_source_list_root_real_compare;
#line 2853 "SourceListView.c"
}


static void
noise_source_list_root_instance_init (NoiseSourceListRoot * self)
{
}


GType
noise_source_list_root_get_type (void)
{
	static volatile gsize noise_source_list_root_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_root_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListRootClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_root_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListRoot), 0, (GInstanceInitFunc) noise_source_list_root_instance_init, NULL };
		static const GInterfaceInfo granite_widgets_source_list_sortable_info = { (GInterfaceInitFunc) noise_source_list_root_granite_widgets_source_list_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType noise_source_list_root_type_id;
		noise_source_list_root_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, "NoiseSourceListRoot", &g_define_type_info, 0);
		g_type_add_interface_static (noise_source_list_root_type_id, GRANITE_WIDGETS_TYPE_SOURCE_LIST_SORTABLE, &granite_widgets_source_list_sortable_info);
		g_once_init_leave (&noise_source_list_root_type_id__volatile, noise_source_list_root_type_id);
	}
	return noise_source_list_root_type_id__volatile;
}


static inline gpointer
noise_source_list_view_get_instance_private (NoiseSourceListView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSourceListView_private_offset);
}


static void
__lambda86_ (NoiseSourceListView* self)
{
#line 342 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL], 0);
#line 2891 "SourceListView.c"
}


static void
___lambda86__noise_play_list_category_playlist_import_clicked (NoisePlayListCategory* _sender,
                                                               gpointer self)
{
#line 342 "../src/Widgets/SourceListView.vala"
	__lambda86_ ((NoiseSourceListView*) self);
#line 2901 "SourceListView.c"
}


NoiseSourceListView*
noise_source_list_view_construct (GType object_type)
{
	NoiseSourceListView * self = NULL;
	NoiseSourceListRoot* _tmp0_;
	NoiseSourceListRoot* _tmp1_;
	GraniteWidgetsSourceListExpandableItem* _tmp2_;
	GraniteWidgetsSourceListExpandableItem* _tmp3_;
	GraniteWidgetsSourceListExpandableItem* _tmp4_;
	NoisePlayListCategory* _tmp5_;
	NoisePlayListCategory* _tmp6_;
	GraniteWidgetsSourceListExpandableItem* _tmp7_;
	GraniteWidgetsSourceListExpandableItem* _tmp8_;
	GraniteWidgetsSourceListExpandableItem* _tmp9_;
	GraniteWidgetsSourceListExpandableItem* _tmp10_;
	GraniteWidgetsSourceListExpandableItem* _tmp11_;
	GraniteWidgetsSourceListExpandableItem* _tmp12_;
	GraniteWidgetsSourceListExpandableItem* _tmp13_;
	GraniteWidgetsSourceListExpandableItem* _tmp14_;
	GraniteWidgetsSourceListExpandableItem* _tmp15_;
	GraniteWidgetsSourceListExpandableItem* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	NoisePlayListCategory* _tmp18_;
	GraniteWidgetsSourceListExpandableItem* _tmp19_;
	GraniteWidgetsSourceListExpandableItem* _tmp20_;
	GtkTargetEntry uri_list_entry = {0};
	GtkTargetEntry _tmp21_ = {0};
	GtkTargetEntry _tmp22_;
	GtkTargetEntry* _tmp23_;
	GtkTargetEntry* _tmp24_;
	gint _tmp24__length1;
#line 335 "../src/Widgets/SourceListView.vala"
	_tmp0_ = noise_source_list_root_new ();
#line 335 "../src/Widgets/SourceListView.vala"
	_tmp1_ = _tmp0_;
#line 335 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListView*) granite_widgets_source_list_construct (object_type, (GraniteWidgetsSourceListExpandableItem*) _tmp1_);
#line 335 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (_tmp1_);
#line 338 "../src/Widgets/SourceListView.vala"
	_tmp2_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
#line 338 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->library_category);
#line 338 "../src/Widgets/SourceListView.vala"
	self->priv->library_category = _tmp2_;
#line 339 "../src/Widgets/SourceListView.vala"
	_tmp3_ = granite_widgets_source_list_expandable_item_new (_ ("Devices"));
#line 339 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->devices_category);
#line 339 "../src/Widgets/SourceListView.vala"
	self->priv->devices_category = _tmp3_;
#line 340 "../src/Widgets/SourceListView.vala"
	_tmp4_ = granite_widgets_source_list_expandable_item_new (_ ("Network"));
#line 340 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->network_category);
#line 340 "../src/Widgets/SourceListView.vala"
	self->priv->network_category = _tmp4_;
#line 341 "../src/Widgets/SourceListView.vala"
	_tmp5_ = noise_play_list_category_new (_ ("Playlists"));
#line 341 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlists_category);
#line 341 "../src/Widgets/SourceListView.vala"
	self->priv->playlists_category = _tmp5_;
#line 342 "../src/Widgets/SourceListView.vala"
	_tmp6_ = self->priv->playlists_category;
#line 342 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp6_, "playlist-import-clicked", (GCallback) ___lambda86__noise_play_list_category_playlist_import_clicked, self, 0);
#line 343 "../src/Widgets/SourceListView.vala"
	_tmp7_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 343 "../src/Widgets/SourceListView.vala"
	_tmp8_ = _tmp7_;
#line 343 "../src/Widgets/SourceListView.vala"
	_tmp9_ = self->priv->library_category;
#line 343 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp8_, (GraniteWidgetsSourceListItem*) _tmp9_);
#line 344 "../src/Widgets/SourceListView.vala"
	_tmp10_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 344 "../src/Widgets/SourceListView.vala"
	_tmp11_ = _tmp10_;
#line 344 "../src/Widgets/SourceListView.vala"
	_tmp12_ = self->priv->devices_category;
#line 344 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp11_, (GraniteWidgetsSourceListItem*) _tmp12_);
#line 345 "../src/Widgets/SourceListView.vala"
	_tmp13_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 345 "../src/Widgets/SourceListView.vala"
	_tmp14_ = _tmp13_;
#line 345 "../src/Widgets/SourceListView.vala"
	_tmp15_ = self->priv->network_category;
#line 345 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp14_, (GraniteWidgetsSourceListItem*) _tmp15_);
#line 346 "../src/Widgets/SourceListView.vala"
	_tmp16_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 346 "../src/Widgets/SourceListView.vala"
	_tmp17_ = _tmp16_;
#line 346 "../src/Widgets/SourceListView.vala"
	_tmp18_ = self->priv->playlists_category;
#line 346 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_add (_tmp17_, (GraniteWidgetsSourceListItem*) _tmp18_);
#line 347 "../src/Widgets/SourceListView.vala"
	_tmp19_ = granite_widgets_source_list_get_root ((GraniteWidgetsSourceList*) self);
#line 347 "../src/Widgets/SourceListView.vala"
	_tmp20_ = _tmp19_;
#line 347 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_expandable_item_expand_all (_tmp20_, FALSE, FALSE);
#line 349 "../src/Widgets/SourceListView.vala"
	_tmp21_.target = "text/uri-list";
#line 349 "../src/Widgets/SourceListView.vala"
	_tmp21_.flags = (guint) GTK_TARGET_SAME_APP;
#line 349 "../src/Widgets/SourceListView.vala"
	_tmp21_.info = (guint) 0;
#line 349 "../src/Widgets/SourceListView.vala"
	uri_list_entry = _tmp21_;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp22_ = uri_list_entry;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp23_ = g_new0 (GtkTargetEntry, 1);
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp23_[0] = _tmp22_;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp24_ = _tmp23_;
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp24__length1 = 1;
#line 350 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_enable_drag_dest ((GraniteWidgetsSourceList*) self, _tmp24_, 1, GDK_ACTION_COPY);
#line 350 "../src/Widgets/SourceListView.vala"
	_tmp24_ = (g_free (_tmp24_), NULL);
#line 334 "../src/Widgets/SourceListView.vala"
	return self;
#line 3034 "SourceListView.c"
}


NoiseSourceListView*
noise_source_list_view_new (void)
{
#line 334 "../src/Widgets/SourceListView.vala"
	return noise_source_list_view_construct (NOISE_TYPE_SOURCE_LIST_VIEW);
#line 3043 "SourceListView.c"
}


/**
     * Change the visibility of each category
     */
void
noise_source_list_view_change_playlist_category_visibility (NoiseSourceListView* self,
                                                            gboolean visible)
{
	NoisePlayListCategory* _tmp0_;
#line 357 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/Widgets/SourceListView.vala"
	_tmp0_ = self->priv->playlists_category;
#line 358 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_item_set_visible ((GraniteWidgetsSourceListItem*) _tmp0_, visible);
#line 3061 "SourceListView.c"
}


/**
     * Adds an item to the sidebar for the ViewWrapper object.
     * It chooses the appropiate category based on the object's hint property.
     *
     * TODO: Change ViewWrapper.Hint to core values.
     */
static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 367 "../src/Widgets/SourceListView.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 367 "../src/Widgets/SourceListView.vala"
	return _data32_;
#line 3078 "SourceListView.c"
}


static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 367 "../src/Widgets/SourceListView.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 3089 "SourceListView.c"
		NoiseSourceListView* self;
#line 367 "../src/Widgets/SourceListView.vala"
		self = _data32_->self;
#line 367 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data32_->expandable_item);
#line 367 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_data32_->sourcelist_item);
#line 367 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (self);
#line 367 "../src/Widgets/SourceListView.vala"
		g_slice_free (Block32Data, _data32_);
#line 3101 "SourceListView.c"
	}
}


static void
__lambda92_ (NoiseSourceListView* self)
{
#line 386 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL], 0);
#line 3111 "SourceListView.c"
}


static void
___lambda92__granite_widgets_source_list_item_activated (GraniteWidgetsSourceListItem* _sender,
                                                         gpointer self)
{
#line 386 "../src/Widgets/SourceListView.vala"
	__lambda92_ ((NoiseSourceListView*) self);
#line 3121 "SourceListView.c"
}


static void
__lambda93_ (Block32Data* _data32_,
             const gchar* new_name)
{
	NoiseSourceListView* self;
	NoiseSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
#line 387 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 387 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _data32_->sourcelist_item;
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_item_get_view (_tmp0_);
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 387 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL], 0, _tmp2_, new_name);
#line 3145 "SourceListView.c"
}


static void
___lambda93__granite_widgets_source_list_item_edited (GraniteWidgetsSourceListItem* _sender,
                                                      const gchar* new_name,
                                                      gpointer self)
{
#line 387 "../src/Widgets/SourceListView.vala"
	__lambda93_ (self, new_name);
#line 3156 "SourceListView.c"
}


static void
__lambda94_ (Block32Data* _data32_,
             GraniteWidgetsSourceListItem* sl)
{
	NoiseSourceListView* self;
	NoiseSourceListItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
#line 388 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 388 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (sl != NULL);
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _data32_->sourcelist_item;
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_item_get_view (_tmp0_);
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 388 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL], 0, _tmp2_);
#line 3180 "SourceListView.c"
}


static void
___lambda94__granite_widgets_source_list_item_action_activated (GraniteWidgetsSourceListItem* _sender,
                                                                gpointer self)
{
#line 388 "../src/Widgets/SourceListView.vala"
	__lambda94_ (self, _sender);
#line 3190 "SourceListView.c"
}


static void
__lambda95_ (NoiseSourceListView* self,
             GtkGrid* view,
             NoiseSourceListItem* item)
{
#line 389 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 389 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (item != NULL);
#line 390 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL], 0, view);
#line 391 "../src/Widgets/SourceListView.vala"
	granite_widgets_source_list_start_editing_item ((GraniteWidgetsSourceList*) self, (GraniteWidgetsSourceListItem*) item);
#line 3207 "SourceListView.c"
}


static void
___lambda95__noise_source_list_item_playlist_rename_clicked (NoiseSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             NoiseSourceListItem* item,
                                                             gpointer self)
{
#line 389 "../src/Widgets/SourceListView.vala"
	__lambda95_ ((NoiseSourceListView*) self, view, item);
#line 3219 "SourceListView.c"
}


static void
__lambda96_ (NoiseSourceListView* self,
             GtkGrid* view)
{
#line 393 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 393 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL], 0, view);
#line 3231 "SourceListView.c"
}


static void
___lambda96__noise_source_list_item_playlist_edit_clicked (NoiseSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
#line 393 "../src/Widgets/SourceListView.vala"
	__lambda96_ ((NoiseSourceListView*) self, view);
#line 3242 "SourceListView.c"
}


static void
__lambda97_ (NoiseSourceListView* self,
             GtkGrid* view)
{
#line 394 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 394 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL], 0, view);
#line 3254 "SourceListView.c"
}


static void
___lambda97__noise_source_list_item_playlist_remove_clicked (NoiseSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             gpointer self)
{
#line 394 "../src/Widgets/SourceListView.vala"
	__lambda97_ ((NoiseSourceListView*) self, view);
#line 3265 "SourceListView.c"
}


static void
__lambda98_ (NoiseSourceListView* self,
             GtkGrid* view)
{
#line 395 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 395 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL], 0, view);
#line 3277 "SourceListView.c"
}


static void
___lambda98__noise_source_list_item_playlist_save_clicked (NoiseSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gpointer self)
{
#line 395 "../src/Widgets/SourceListView.vala"
	__lambda98_ ((NoiseSourceListView*) self, view);
#line 3288 "SourceListView.c"
}


static void
__lambda99_ (NoiseSourceListView* self,
             GtkGrid* view)
{
#line 396 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 396 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL], 0, view);
#line 3300 "SourceListView.c"
}


static void
___lambda99__noise_source_list_item_playlist_export_clicked (NoiseSourceListItem* _sender,
                                                             GtkGrid* view,
                                                             gpointer self)
{
#line 396 "../src/Widgets/SourceListView.vala"
	__lambda99_ ((NoiseSourceListView*) self, view);
#line 3311 "SourceListView.c"
}


static void
__lambda100_ (NoiseSourceListView* self,
              GtkGrid* view,
              gchar** uris,
              int uris_length1)
{
#line 397 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 397 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL], 0, view, uris, uris_length1);
#line 3325 "SourceListView.c"
}


static void
___lambda100__noise_source_list_item_playlist_media_added (NoiseSourceListItem* _sender,
                                                           GtkGrid* view,
                                                           gchar** media,
                                                           int media_length1,
                                                           gpointer self)
{
#line 397 "../src/Widgets/SourceListView.vala"
	__lambda100_ ((NoiseSourceListView*) self, view, media, media_length1);
#line 3338 "SourceListView.c"
}


static void
__lambda101_ (Block32Data* _data32_,
              GtkGrid* view)
{
	NoiseSourceListView* self;
	NoiseSourceListExpandableItem* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
#line 399 "../src/Widgets/SourceListView.vala"
	self = _data32_->self;
#line 399 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp0_ = _data32_->expandable_item;
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_view_get_device_from_item (self, _tmp0_);
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp2_ = _tmp1_;
#line 399 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL], 0, _tmp2_);
#line 399 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (_tmp2_);
#line 3364 "SourceListView.c"
}


static void
___lambda101__noise_source_list_expandable_item_device_import_clicked (NoiseSourceListExpandableItem* _sender,
                                                                       GtkGrid* view,
                                                                       gpointer self)
{
#line 399 "../src/Widgets/SourceListView.vala"
	__lambda101_ (self, view);
#line 3375 "SourceListView.c"
}


static void
__lambda102_ (NoiseSourceListView* self,
              GtkGrid* view)
{
#line 400 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 400 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL], 0, view);
#line 3387 "SourceListView.c"
}


static void
___lambda102__noise_source_list_expandable_item_device_eject_clicked (NoiseSourceListExpandableItem* _sender,
                                                                      GtkGrid* view,
                                                                      gpointer self)
{
#line 400 "../src/Widgets/SourceListView.vala"
	__lambda102_ ((NoiseSourceListView*) self, view);
#line 3398 "SourceListView.c"
}


static void
__lambda103_ (NoiseSourceListView* self,
              GtkGrid* view)
{
#line 401 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 401 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL], 0, view);
#line 3410 "SourceListView.c"
}


static void
___lambda103__noise_source_list_expandable_item_device_sync_clicked (NoiseSourceListExpandableItem* _sender,
                                                                     GtkGrid* view,
                                                                     gpointer self)
{
#line 401 "../src/Widgets/SourceListView.vala"
	__lambda103_ ((NoiseSourceListView*) self, view);
#line 3421 "SourceListView.c"
}


static void
__lambda104_ (NoiseSourceListView* self,
              GtkGrid* view)
{
#line 402 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 402 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL], 0, view);
#line 3433 "SourceListView.c"
}


static void
___lambda104__noise_source_list_expandable_item_device_new_playlist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                             GtkGrid* view,
                                                                             gpointer self)
{
#line 402 "../src/Widgets/SourceListView.vala"
	__lambda104_ ((NoiseSourceListView*) self, view);
#line 3444 "SourceListView.c"
}


static void
__lambda105_ (NoiseSourceListView* self,
              GtkGrid* view)
{
#line 403 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 403 "../src/Widgets/SourceListView.vala"
	g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL], 0, view);
#line 3456 "SourceListView.c"
}


static void
___lambda105__noise_source_list_expandable_item_device_new_smartplaylist_clicked (NoiseSourceListExpandableItem* _sender,
                                                                                  GtkGrid* view,
                                                                                  gpointer self)
{
#line 403 "../src/Widgets/SourceListView.vala"
	__lambda105_ ((NoiseSourceListView*) self, view);
#line 3467 "SourceListView.c"
}


NoiseSourceListEntry*
noise_source_list_view_add_item (NoiseSourceListView* self,
                                 GtkGrid* view,
                                 const gchar* name,
                                 NoiseViewWrapperHint hint,
                                 GIcon* icon,
                                 GIcon* activatable_icon,
                                 NoiseSourceListExpandableItem* into_expandable,
                                 GObject* give_more_information)
{
	NoiseSourceListEntry* result = NULL;
	Block32Data* _data32_;
	NoiseSourceListItem* _tmp0_;
	NoiseSourceListExpandableItem* _tmp1_;
	NoiseSourceListItem* _tmp5_;
	NoiseSourceListItem* _tmp6_;
	NoiseSourceListExpandableItem* _tmp7_;
	NoiseSourceListItem* _tmp8_;
	NoiseSourceListItem* _tmp9_;
	NoiseSourceListItem* _tmp10_;
	NoiseSourceListItem* _tmp11_;
	NoiseSourceListItem* _tmp12_;
	NoiseSourceListItem* _tmp13_;
	NoiseSourceListExpandableItem* _tmp14_;
	NoiseSourceListExpandableItem* _tmp15_;
	NoiseSourceListExpandableItem* _tmp16_;
	NoiseSourceListExpandableItem* _tmp17_;
	NoiseSourceListExpandableItem* _tmp18_;
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 367 "../src/Widgets/SourceListView.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 367 "../src/Widgets/SourceListView.vala"
	_data32_->_ref_count_ = 1;
#line 367 "../src/Widgets/SourceListView.vala"
	_data32_->self = g_object_ref (self);
#line 375 "../src/Widgets/SourceListView.vala"
	_tmp0_ = noise_source_list_item_new (view, name, hint, icon, activatable_icon);
#line 375 "../src/Widgets/SourceListView.vala"
	_data32_->sourcelist_item = _tmp0_;
#line 376 "../src/Widgets/SourceListView.vala"
	_tmp1_ = noise_source_list_expandable_item_new (view, name, hint, icon, activatable_icon, give_more_information);
#line 376 "../src/Widgets/SourceListView.vala"
	_data32_->expandable_item = _tmp1_;
#line 378 "../src/Widgets/SourceListView.vala"
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
#line 3523 "SourceListView.c"
		NoiseSourceListExpandableItem* _tmp2_;
		NoiseSourceListExpandableItem* _tmp3_;
#line 379 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _data32_->expandable_item;
#line 379 "../src/Widgets/SourceListView.vala"
		granite_widgets_source_list_expandable_item_set_collapsible ((GraniteWidgetsSourceListExpandableItem*) _tmp2_, FALSE);
#line 380 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _data32_->expandable_item;
#line 380 "../src/Widgets/SourceListView.vala"
		granite_widgets_source_list_item_set_icon ((GraniteWidgetsSourceListItem*) _tmp3_, icon);
#line 381 "../src/Widgets/SourceListView.vala"
		if (activatable_icon != NULL) {
#line 3536 "SourceListView.c"
			NoiseSourceListExpandableItem* _tmp4_;
#line 382 "../src/Widgets/SourceListView.vala"
			_tmp4_ = _data32_->expandable_item;
#line 382 "../src/Widgets/SourceListView.vala"
			granite_widgets_source_list_item_set_activatable ((GraniteWidgetsSourceListItem*) _tmp4_, activatable_icon);
#line 3542 "SourceListView.c"
		}
	}
#line 386 "../src/Widgets/SourceListView.vala"
	_tmp5_ = _data32_->sourcelist_item;
#line 386 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object ((GraniteWidgetsSourceListItem*) _tmp5_, "activated", (GCallback) ___lambda92__granite_widgets_source_list_item_activated, self, 0);
#line 387 "../src/Widgets/SourceListView.vala"
	_tmp6_ = _data32_->sourcelist_item;
#line 387 "../src/Widgets/SourceListView.vala"
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp6_, "edited", (GCallback) ___lambda93__granite_widgets_source_list_item_edited, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 388 "../src/Widgets/SourceListView.vala"
	_tmp7_ = _data32_->expandable_item;
#line 388 "../src/Widgets/SourceListView.vala"
	g_signal_connect_data ((GraniteWidgetsSourceListItem*) _tmp7_, "action-activated", (GCallback) ___lambda94__granite_widgets_source_list_item_action_activated, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 389 "../src/Widgets/SourceListView.vala"
	_tmp8_ = _data32_->sourcelist_item;
#line 389 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp8_, "playlist-rename-clicked", (GCallback) ___lambda95__noise_source_list_item_playlist_rename_clicked, self, 0);
#line 393 "../src/Widgets/SourceListView.vala"
	_tmp9_ = _data32_->sourcelist_item;
#line 393 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp9_, "playlist-edit-clicked", (GCallback) ___lambda96__noise_source_list_item_playlist_edit_clicked, self, 0);
#line 394 "../src/Widgets/SourceListView.vala"
	_tmp10_ = _data32_->sourcelist_item;
#line 394 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp10_, "playlist-remove-clicked", (GCallback) ___lambda97__noise_source_list_item_playlist_remove_clicked, self, 0);
#line 395 "../src/Widgets/SourceListView.vala"
	_tmp11_ = _data32_->sourcelist_item;
#line 395 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp11_, "playlist-save-clicked", (GCallback) ___lambda98__noise_source_list_item_playlist_save_clicked, self, 0);
#line 396 "../src/Widgets/SourceListView.vala"
	_tmp12_ = _data32_->sourcelist_item;
#line 396 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp12_, "playlist-export-clicked", (GCallback) ___lambda99__noise_source_list_item_playlist_export_clicked, self, 0);
#line 397 "../src/Widgets/SourceListView.vala"
	_tmp13_ = _data32_->sourcelist_item;
#line 397 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp13_, "playlist-media-added", (GCallback) ___lambda100__noise_source_list_item_playlist_media_added, self, 0);
#line 399 "../src/Widgets/SourceListView.vala"
	_tmp14_ = _data32_->expandable_item;
#line 399 "../src/Widgets/SourceListView.vala"
	g_signal_connect_data (_tmp14_, "device-import-clicked", (GCallback) ___lambda101__noise_source_list_expandable_item_device_import_clicked, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 400 "../src/Widgets/SourceListView.vala"
	_tmp15_ = _data32_->expandable_item;
#line 400 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp15_, "device-eject-clicked", (GCallback) ___lambda102__noise_source_list_expandable_item_device_eject_clicked, self, 0);
#line 401 "../src/Widgets/SourceListView.vala"
	_tmp16_ = _data32_->expandable_item;
#line 401 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp16_, "device-sync-clicked", (GCallback) ___lambda103__noise_source_list_expandable_item_device_sync_clicked, self, 0);
#line 402 "../src/Widgets/SourceListView.vala"
	_tmp17_ = _data32_->expandable_item;
#line 402 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp17_, "device-new-playlist-clicked", (GCallback) ___lambda104__noise_source_list_expandable_item_device_new_playlist_clicked, self, 0);
#line 403 "../src/Widgets/SourceListView.vala"
	_tmp18_ = _data32_->expandable_item;
#line 403 "../src/Widgets/SourceListView.vala"
	g_signal_connect_object (_tmp18_, "device-new-smartplaylist-clicked", (GCallback) ___lambda105__noise_source_list_expandable_item_device_new_smartplaylist_clicked, self, 0);
#line 405 "../src/Widgets/SourceListView.vala"
	switch (hint) {
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_MUSIC:
#line 3605 "SourceListView.c"
		{
#line 407 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3609 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp19_;
				NoiseSourceListItem* _tmp20_;
#line 408 "../src/Widgets/SourceListView.vala"
				_tmp19_ = self->priv->library_category;
#line 408 "../src/Widgets/SourceListView.vala"
				_tmp20_ = _data32_->sourcelist_item;
#line 408 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp19_, (GraniteWidgetsSourceListItem*) _tmp20_);
#line 3618 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp21_;
#line 410 "../src/Widgets/SourceListView.vala"
				_tmp21_ = _data32_->sourcelist_item;
#line 410 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp21_);
#line 3625 "SourceListView.c"
			}
#line 412 "../src/Widgets/SourceListView.vala"
			break;
#line 3629 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_PLAYLIST:
#line 3633 "SourceListView.c"
		{
#line 414 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3637 "SourceListView.c"
				NoiseSourceListItem* _tmp22_;
				NoisePlayListCategory* _tmp23_;
				NoiseSourceListItem* _tmp24_;
#line 415 "../src/Widgets/SourceListView.vala"
				_tmp22_ = _data32_->sourcelist_item;
#line 415 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp22_, TRUE);
#line 416 "../src/Widgets/SourceListView.vala"
				_tmp23_ = self->priv->playlists_category;
#line 416 "../src/Widgets/SourceListView.vala"
				_tmp24_ = _data32_->sourcelist_item;
#line 416 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp23_, (GraniteWidgetsSourceListItem*) _tmp24_);
#line 3651 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp25_;
				NoiseSourceListItem* _tmp26_;
#line 418 "../src/Widgets/SourceListView.vala"
				_tmp25_ = _data32_->sourcelist_item;
#line 418 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp25_, TRUE);
#line 419 "../src/Widgets/SourceListView.vala"
				_tmp26_ = _data32_->sourcelist_item;
#line 419 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp26_);
#line 3663 "SourceListView.c"
			}
#line 421 "../src/Widgets/SourceListView.vala"
			break;
#line 3667 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST:
#line 3671 "SourceListView.c"
		{
#line 423 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3675 "SourceListView.c"
				NoiseSourceListItem* _tmp27_;
				NoisePlayListCategory* _tmp28_;
				NoiseSourceListItem* _tmp29_;
#line 424 "../src/Widgets/SourceListView.vala"
				_tmp27_ = _data32_->sourcelist_item;
#line 424 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp27_, FALSE);
#line 425 "../src/Widgets/SourceListView.vala"
				_tmp28_ = self->priv->playlists_category;
#line 425 "../src/Widgets/SourceListView.vala"
				_tmp29_ = _data32_->sourcelist_item;
#line 425 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp28_, (GraniteWidgetsSourceListItem*) _tmp29_);
#line 3689 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp30_;
				NoiseSourceListItem* _tmp31_;
#line 427 "../src/Widgets/SourceListView.vala"
				_tmp30_ = _data32_->sourcelist_item;
#line 427 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp30_, FALSE);
#line 428 "../src/Widgets/SourceListView.vala"
				_tmp31_ = _data32_->sourcelist_item;
#line 428 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp31_);
#line 3701 "SourceListView.c"
			}
#line 430 "../src/Widgets/SourceListView.vala"
			break;
#line 3705 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST:
#line 3709 "SourceListView.c"
		{
#line 432 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3713 "SourceListView.c"
				NoiseSourceListItem* _tmp32_;
				NoisePlayListCategory* _tmp33_;
				NoiseSourceListItem* _tmp34_;
#line 433 "../src/Widgets/SourceListView.vala"
				_tmp32_ = _data32_->sourcelist_item;
#line 433 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_item_set_editable ((GraniteWidgetsSourceListItem*) _tmp32_, TRUE);
#line 434 "../src/Widgets/SourceListView.vala"
				_tmp33_ = self->priv->playlists_category;
#line 434 "../src/Widgets/SourceListView.vala"
				_tmp34_ = _data32_->sourcelist_item;
#line 434 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) _tmp33_, (GraniteWidgetsSourceListItem*) _tmp34_);
#line 3727 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp35_;
#line 436 "../src/Widgets/SourceListView.vala"
				_tmp35_ = _data32_->sourcelist_item;
#line 436 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp35_);
#line 3734 "SourceListView.c"
			}
#line 438 "../src/Widgets/SourceListView.vala"
			break;
#line 3738 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_DEVICE:
#line 3742 "SourceListView.c"
		{
#line 440 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3746 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp36_;
				NoiseSourceListExpandableItem* _tmp37_;
#line 441 "../src/Widgets/SourceListView.vala"
				_tmp36_ = self->priv->devices_category;
#line 441 "../src/Widgets/SourceListView.vala"
				_tmp37_ = _data32_->expandable_item;
#line 441 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp36_, (GraniteWidgetsSourceListItem*) _tmp37_);
#line 3755 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp38_;
#line 443 "../src/Widgets/SourceListView.vala"
				_tmp38_ = _data32_->expandable_item;
#line 443 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp38_);
#line 3762 "SourceListView.c"
			}
#line 445 "../src/Widgets/SourceListView.vala"
			break;
#line 3766 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO:
#line 3770 "SourceListView.c"
		{
#line 447 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3774 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp39_;
				NoiseSourceListExpandableItem* _tmp40_;
#line 448 "../src/Widgets/SourceListView.vala"
				_tmp39_ = self->priv->devices_category;
#line 448 "../src/Widgets/SourceListView.vala"
				_tmp40_ = _data32_->expandable_item;
#line 448 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp39_, (GraniteWidgetsSourceListItem*) _tmp40_);
#line 3783 "SourceListView.c"
			} else {
				NoiseSourceListExpandableItem* _tmp41_;
#line 450 "../src/Widgets/SourceListView.vala"
				_tmp41_ = _data32_->expandable_item;
#line 450 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp41_);
#line 3790 "SourceListView.c"
			}
#line 452 "../src/Widgets/SourceListView.vala"
			break;
#line 3794 "SourceListView.c"
		}
#line 405 "../src/Widgets/SourceListView.vala"
		case NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE:
#line 3798 "SourceListView.c"
		{
#line 454 "../src/Widgets/SourceListView.vala"
			if (into_expandable == NULL) {
#line 3802 "SourceListView.c"
				GraniteWidgetsSourceListExpandableItem* _tmp42_;
				NoiseSourceListItem* _tmp43_;
#line 455 "../src/Widgets/SourceListView.vala"
				_tmp42_ = self->priv->network_category;
#line 455 "../src/Widgets/SourceListView.vala"
				_tmp43_ = _data32_->sourcelist_item;
#line 455 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add (_tmp42_, (GraniteWidgetsSourceListItem*) _tmp43_);
#line 3811 "SourceListView.c"
			} else {
				NoiseSourceListItem* _tmp44_;
#line 457 "../src/Widgets/SourceListView.vala"
				_tmp44_ = _data32_->sourcelist_item;
#line 457 "../src/Widgets/SourceListView.vala"
				granite_widgets_source_list_expandable_item_add ((GraniteWidgetsSourceListExpandableItem*) into_expandable, (GraniteWidgetsSourceListItem*) _tmp44_);
#line 3818 "SourceListView.c"
			}
#line 459 "../src/Widgets/SourceListView.vala"
			break;
#line 3822 "SourceListView.c"
		}
		default:
		{
#line 461 "../src/Widgets/SourceListView.vala"
			break;
#line 3828 "SourceListView.c"
		}
	}
#line 464 "../src/Widgets/SourceListView.vala"
	if (hint == NOISE_VIEW_WRAPPER_HINT_DEVICE) {
#line 3833 "SourceListView.c"
		NoiseSourceListExpandableItem* _tmp45_;
		NoiseSourceListEntry* _tmp46_;
#line 465 "../src/Widgets/SourceListView.vala"
		_tmp45_ = _data32_->expandable_item;
#line 465 "../src/Widgets/SourceListView.vala"
		_tmp46_ = _g_object_ref0 ((NoiseSourceListEntry*) _tmp45_);
#line 465 "../src/Widgets/SourceListView.vala"
		result = _tmp46_;
#line 465 "../src/Widgets/SourceListView.vala"
		block32_data_unref (_data32_);
#line 465 "../src/Widgets/SourceListView.vala"
		_data32_ = NULL;
#line 465 "../src/Widgets/SourceListView.vala"
		return result;
#line 3848 "SourceListView.c"
	} else {
		NoiseSourceListItem* _tmp47_;
		NoiseSourceListEntry* _tmp48_;
#line 467 "../src/Widgets/SourceListView.vala"
		_tmp47_ = _data32_->sourcelist_item;
#line 467 "../src/Widgets/SourceListView.vala"
		_tmp48_ = _g_object_ref0 ((NoiseSourceListEntry*) _tmp47_);
#line 467 "../src/Widgets/SourceListView.vala"
		result = _tmp48_;
#line 467 "../src/Widgets/SourceListView.vala"
		block32_data_unref (_data32_);
#line 467 "../src/Widgets/SourceListView.vala"
		_data32_ = NULL;
#line 467 "../src/Widgets/SourceListView.vala"
		return result;
#line 3864 "SourceListView.c"
	}
#line 367 "../src/Widgets/SourceListView.vala"
	block32_data_unref (_data32_);
#line 367 "../src/Widgets/SourceListView.vala"
	_data32_ = NULL;
#line 3870 "SourceListView.c"
}


static void
noise_source_list_view_real_item_selected (GraniteWidgetsSourceList* base,
                                           GraniteWidgetsSourceListItem* item)
{
	NoiseSourceListView * self;
#line 471 "../src/Widgets/SourceListView.vala"
	self = (NoiseSourceListView*) base;
#line 472 "../src/Widgets/SourceListView.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 3883 "SourceListView.c"
		NoiseSourceListItem* sidebar_item = NULL;
		NoiseSourceListItem* _tmp0_;
		NoiseSourceListItem* _tmp1_;
		GtkGrid* _tmp2_;
		GtkGrid* _tmp3_;
#line 473 "../src/Widgets/SourceListView.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_ITEM) ? ((NoiseSourceListItem*) item) : NULL);
#line 473 "../src/Widgets/SourceListView.vala"
		sidebar_item = _tmp0_;
#line 474 "../src/Widgets/SourceListView.vala"
		_tmp1_ = sidebar_item;
#line 474 "../src/Widgets/SourceListView.vala"
		_tmp2_ = noise_source_list_item_get_view (_tmp1_);
#line 474 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 474 "../src/Widgets/SourceListView.vala"
		g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp3_);
#line 472 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (sidebar_item);
#line 3903 "SourceListView.c"
	} else {
#line 475 "../src/Widgets/SourceListView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 3907 "SourceListView.c"
			NoiseSourceListExpandableItem* sidebar_item = NULL;
			NoiseSourceListExpandableItem* _tmp4_;
			NoiseSourceListExpandableItem* _tmp5_;
			GtkGrid* _tmp6_;
			GtkGrid* _tmp7_;
#line 476 "../src/Widgets/SourceListView.vala"
			_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM) ? ((NoiseSourceListExpandableItem*) item) : NULL);
#line 476 "../src/Widgets/SourceListView.vala"
			sidebar_item = _tmp4_;
#line 477 "../src/Widgets/SourceListView.vala"
			_tmp5_ = sidebar_item;
#line 477 "../src/Widgets/SourceListView.vala"
			_tmp6_ = noise_source_list_expandable_item_get_view (_tmp5_);
#line 477 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _tmp6_;
#line 477 "../src/Widgets/SourceListView.vala"
			g_signal_emit (self, noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp7_);
#line 475 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (sidebar_item);
#line 3927 "SourceListView.c"
		}
	}
}


void
noise_source_list_view_remove_playlist (NoiseSourceListView* self,
                                        NoiseViewWrapper* view)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp15_;
#line 482 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 3943 "SourceListView.c"
	{
		GeeIterator* _playlist_it = NULL;
		NoisePlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->playlists_category;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 483 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 483 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 483 "../src/Widgets/SourceListView.vala"
		_playlist_it = _tmp5_;
#line 483 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 3970 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
#line 483 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _playlist_it;
#line 483 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 483 "../src/Widgets/SourceListView.vala"
				break;
#line 3982 "SourceListView.c"
			}
#line 483 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _playlist_it;
#line 483 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 483 "../src/Widgets/SourceListView.vala"
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 484 "../src/Widgets/SourceListView.vala"
			_tmp9_ = playlist;
#line 484 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 3994 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
#line 485 "../src/Widgets/SourceListView.vala"
				_tmp10_ = playlist;
#line 485 "../src/Widgets/SourceListView.vala"
				_tmp11_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 485 "../src/Widgets/SourceListView.vala"
				_tmp12_ = _tmp11_;
#line 485 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
#line 4006 "SourceListView.c"
					NoisePlayListCategory* _tmp13_;
					GraniteWidgetsSourceListItem* _tmp14_;
#line 486 "../src/Widgets/SourceListView.vala"
					_tmp13_ = self->priv->playlists_category;
#line 486 "../src/Widgets/SourceListView.vala"
					_tmp14_ = playlist;
#line 486 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_expandable_item_remove ((GraniteWidgetsSourceListExpandableItem*) _tmp13_, _tmp14_);
#line 487 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (playlist);
#line 487 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_playlist_it);
#line 487 "../src/Widgets/SourceListView.vala"
					return;
#line 4021 "SourceListView.c"
				}
			}
#line 483 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist);
#line 4026 "SourceListView.c"
		}
#line 483 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_playlist_it);
#line 4030 "SourceListView.c"
	}
#line 491 "../src/Widgets/SourceListView.vala"
	_tmp15_ = gee_tree_set_new (NOISE_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 491 "../src/Widgets/SourceListView.vala"
	items = _tmp15_;
#line 4036 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
		GeeIterator* _tmp20_;
		GeeIterator* _tmp21_;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp16_ = self->priv->devices_category;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp17_ = granite_widgets_source_list_expandable_item_get_children (_tmp16_);
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp18_ = _tmp17_;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp19_ = _tmp18_;
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 492 "../src/Widgets/SourceListView.vala"
		_tmp21_ = _tmp20_;
#line 492 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp19_);
#line 492 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp21_;
#line 492 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4063 "SourceListView.c"
			GeeIterator* _tmp22_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp23_;
			gpointer _tmp24_;
			GraniteWidgetsSourceListItem* _tmp25_;
#line 492 "../src/Widgets/SourceListView.vala"
			_tmp22_ = _device_it;
#line 492 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp22_)) {
#line 492 "../src/Widgets/SourceListView.vala"
				break;
#line 4075 "SourceListView.c"
			}
#line 492 "../src/Widgets/SourceListView.vala"
			_tmp23_ = _device_it;
#line 492 "../src/Widgets/SourceListView.vala"
			_tmp24_ = gee_iterator_get (_tmp23_);
#line 492 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp24_;
#line 493 "../src/Widgets/SourceListView.vala"
			_tmp25_ = device;
#line 493 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp25_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4087 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp26_;
#line 494 "../src/Widgets/SourceListView.vala"
				_tmp26_ = device;
#line 494 "../src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &items);
#line 4093 "SourceListView.c"
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp27_;
					GeeIterator* _tmp28_;
#line 495 "../src/Widgets/SourceListView.vala"
					_tmp27_ = items;
#line 495 "../src/Widgets/SourceListView.vala"
					_tmp28_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp27_);
#line 495 "../src/Widgets/SourceListView.vala"
					_item_it = _tmp28_;
#line 495 "../src/Widgets/SourceListView.vala"
					while (TRUE) {
#line 4106 "SourceListView.c"
						GeeIterator* _tmp29_;
						NoiseSourceListItem* item = NULL;
						GeeIterator* _tmp30_;
						gpointer _tmp31_;
						NoiseSourceListItem* _tmp32_;
						GtkGrid* _tmp33_;
						GtkGrid* _tmp34_;
#line 495 "../src/Widgets/SourceListView.vala"
						_tmp29_ = _item_it;
#line 495 "../src/Widgets/SourceListView.vala"
						if (!gee_iterator_next (_tmp29_)) {
#line 495 "../src/Widgets/SourceListView.vala"
							break;
#line 4120 "SourceListView.c"
						}
#line 495 "../src/Widgets/SourceListView.vala"
						_tmp30_ = _item_it;
#line 495 "../src/Widgets/SourceListView.vala"
						_tmp31_ = gee_iterator_get (_tmp30_);
#line 495 "../src/Widgets/SourceListView.vala"
						item = (NoiseSourceListItem*) _tmp31_;
#line 496 "../src/Widgets/SourceListView.vala"
						_tmp32_ = item;
#line 496 "../src/Widgets/SourceListView.vala"
						_tmp33_ = noise_source_list_item_get_view (_tmp32_);
#line 496 "../src/Widgets/SourceListView.vala"
						_tmp34_ = _tmp33_;
#line 496 "../src/Widgets/SourceListView.vala"
						if (_tmp34_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
#line 4136 "SourceListView.c"
							NoiseSourceListItem* _tmp35_;
							GraniteWidgetsSourceListExpandableItem* _tmp36_;
							GraniteWidgetsSourceListExpandableItem* _tmp37_;
							NoiseSourceListItem* _tmp38_;
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp35_ = item;
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp36_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) _tmp35_);
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp37_ = _tmp36_;
#line 497 "../src/Widgets/SourceListView.vala"
							_tmp38_ = item;
#line 497 "../src/Widgets/SourceListView.vala"
							granite_widgets_source_list_expandable_item_remove (_tmp37_, (GraniteWidgetsSourceListItem*) _tmp38_);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (item);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_item_it);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (device);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_device_it);
#line 498 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (items);
#line 498 "../src/Widgets/SourceListView.vala"
							return;
#line 4163 "SourceListView.c"
						}
#line 495 "../src/Widgets/SourceListView.vala"
						_g_object_unref0 (item);
#line 4167 "SourceListView.c"
					}
#line 495 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_item_it);
#line 4171 "SourceListView.c"
				}
			}
#line 492 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4176 "SourceListView.c"
		}
#line 492 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4180 "SourceListView.c"
	}
#line 482 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (items);
#line 4184 "SourceListView.c"
}


GeeCollection*
noise_source_list_view_remove_device (NoiseSourceListView* self,
                                      NoiseDeviceView* view)
{
	GeeCollection* result = NULL;
	GeeTreeSet* pages = NULL;
	GeeTreeSet* _tmp0_;
#line 506 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 506 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 507 "../src/Widgets/SourceListView.vala"
	_tmp0_ = gee_tree_set_new (gtk_grid_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 507 "../src/Widgets/SourceListView.vala"
	pages = _tmp0_;
#line 4203 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp1_ = self->priv->devices_category;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp2_ = granite_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 508 "../src/Widgets/SourceListView.vala"
		_tmp6_ = _tmp5_;
#line 508 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp4_);
#line 508 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp6_;
#line 508 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4230 "SourceListView.c"
			GeeIterator* _tmp7_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GraniteWidgetsSourceListItem* _tmp10_;
#line 508 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 508 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 508 "../src/Widgets/SourceListView.vala"
				break;
#line 4242 "SourceListView.c"
			}
#line 508 "../src/Widgets/SourceListView.vala"
			_tmp8_ = _device_it;
#line 508 "../src/Widgets/SourceListView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 508 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp9_;
#line 509 "../src/Widgets/SourceListView.vala"
			_tmp10_ = device;
#line 509 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4254 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp11_;
				GtkGrid* _tmp12_;
				GtkGrid* _tmp13_;
#line 510 "../src/Widgets/SourceListView.vala"
				_tmp11_ = device;
#line 510 "../src/Widgets/SourceListView.vala"
				_tmp12_ = noise_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 510 "../src/Widgets/SourceListView.vala"
				_tmp13_ = _tmp12_;
#line 510 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp13_) {
#line 4266 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp14_;
					GraniteWidgetsSourceListExpandableItem* _tmp15_;
					GraniteWidgetsSourceListItem* _tmp16_;
#line 511 "../src/Widgets/SourceListView.vala"
					_tmp14_ = device;
#line 511 "../src/Widgets/SourceListView.vala"
					noise_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &pages);
#line 512 "../src/Widgets/SourceListView.vala"
					_tmp15_ = self->priv->devices_category;
#line 512 "../src/Widgets/SourceListView.vala"
					_tmp16_ = device;
#line 512 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_expandable_item_remove (_tmp15_, _tmp16_);
#line 513 "../src/Widgets/SourceListView.vala"
					result = (GeeCollection*) pages;
#line 513 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 513 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 513 "../src/Widgets/SourceListView.vala"
					return result;
#line 4288 "SourceListView.c"
				}
			}
#line 508 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4293 "SourceListView.c"
		}
#line 508 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4297 "SourceListView.c"
	}
#line 517 "../src/Widgets/SourceListView.vala"
	result = (GeeCollection*) pages;
#line 517 "../src/Widgets/SourceListView.vala"
	return result;
#line 4303 "SourceListView.c"
}


static GtkGrid*
noise_source_list_view_get_device_from_item (NoiseSourceListView* self,
                                             NoiseSourceListExpandableItem* item)
{
	GtkGrid* result = NULL;
#line 521 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 521 "../src/Widgets/SourceListView.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 4316 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->devices_category;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 522 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 522 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 522 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp5_;
#line 522 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4343 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListExpandableItem* _tmp9_;
			GraniteWidgetsSourceListExpandableItem* _tmp10_;
			GraniteWidgetsSourceListItem* _tmp11_;
#line 522 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _device_it;
#line 522 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 522 "../src/Widgets/SourceListView.vala"
				break;
#line 4357 "SourceListView.c"
			}
#line 522 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 522 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 522 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 523 "../src/Widgets/SourceListView.vala"
			_tmp9_ = granite_widgets_source_list_item_get_parent ((GraniteWidgetsSourceListItem*) item);
#line 523 "../src/Widgets/SourceListView.vala"
			_tmp10_ = _tmp9_;
#line 523 "../src/Widgets/SourceListView.vala"
			_tmp11_ = device;
#line 523 "../src/Widgets/SourceListView.vala"
			if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GRANITE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListExpandableItem)) {
#line 4373 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp12_;
#line 524 "../src/Widgets/SourceListView.vala"
				_tmp12_ = device;
#line 524 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4379 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp13_;
					GtkGrid* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp13_ = device;
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp14_ = noise_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp15_ = _tmp14_;
#line 525 "../src/Widgets/SourceListView.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 525 "../src/Widgets/SourceListView.vala"
					result = _tmp16_;
#line 525 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 525 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 525 "../src/Widgets/SourceListView.vala"
					return result;
#line 4400 "SourceListView.c"
				}
			}
#line 522 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4405 "SourceListView.c"
		}
#line 522 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4409 "SourceListView.c"
	}
#line 529 "../src/Widgets/SourceListView.vala"
	result = NULL;
#line 529 "../src/Widgets/SourceListView.vala"
	return result;
#line 4415 "SourceListView.c"
}


static void
noise_source_list_view_enumerate_children_pages (NoiseSourceListView* self,
                                                 NoiseSourceListExpandableItem* exp_item,
                                                 GeeTreeSet* * pages)
{
#line 532 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (exp_item != NULL);
#line 532 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (*pages != NULL);
#line 4430 "SourceListView.c"
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp1_ = _tmp0_;
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 533 "../src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 533 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp2_);
#line 533 "../src/Widgets/SourceListView.vala"
		_views_it = _tmp4_;
#line 533 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4454 "SourceListView.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 533 "../src/Widgets/SourceListView.vala"
			_tmp5_ = _views_it;
#line 533 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 533 "../src/Widgets/SourceListView.vala"
				break;
#line 4466 "SourceListView.c"
			}
#line 533 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _views_it;
#line 533 "../src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 533 "../src/Widgets/SourceListView.vala"
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 534 "../src/Widgets/SourceListView.vala"
			_tmp8_ = views;
#line 534 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4478 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp9_;
				GtkGrid* _tmp10_;
				GtkGrid* _tmp11_;
				GraniteWidgetsSourceListItem* _tmp12_;
#line 535 "../src/Widgets/SourceListView.vala"
				_tmp9_ = views;
#line 535 "../src/Widgets/SourceListView.vala"
				_tmp10_ = noise_source_list_expandable_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 535 "../src/Widgets/SourceListView.vala"
				_tmp11_ = _tmp10_;
#line 535 "../src/Widgets/SourceListView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp11_);
#line 536 "../src/Widgets/SourceListView.vala"
				_tmp12_ = views;
#line 536 "../src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_pages (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), pages);
#line 4495 "SourceListView.c"
			} else {
				GraniteWidgetsSourceListItem* _tmp13_;
#line 537 "../src/Widgets/SourceListView.vala"
				_tmp13_ = views;
#line 537 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4502 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp14_;
					GtkGrid* _tmp15_;
					GtkGrid* _tmp16_;
#line 538 "../src/Widgets/SourceListView.vala"
					_tmp14_ = views;
#line 538 "../src/Widgets/SourceListView.vala"
					_tmp15_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 538 "../src/Widgets/SourceListView.vala"
					_tmp16_ = _tmp15_;
#line 538 "../src/Widgets/SourceListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), _tmp16_);
#line 4514 "SourceListView.c"
				}
			}
#line 533 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (views);
#line 4519 "SourceListView.c"
		}
#line 533 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_views_it);
#line 4523 "SourceListView.c"
	}
}


static void
noise_source_list_view_enumerate_children_items (NoiseSourceListView* self,
                                                 NoiseSourceListExpandableItem* exp_item,
                                                 GeeTreeSet* * pages)
{
#line 543 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (exp_item != NULL);
#line 543 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (*pages != NULL);
#line 4539 "SourceListView.c"
	{
		GeeIterator* _views_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp0_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (exp_item, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem));
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp1_ = _tmp0_;
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 544 "../src/Widgets/SourceListView.vala"
		_tmp4_ = _tmp3_;
#line 544 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp2_);
#line 544 "../src/Widgets/SourceListView.vala"
		_views_it = _tmp4_;
#line 544 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4563 "SourceListView.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListItem* views = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListItem* _tmp8_;
#line 544 "../src/Widgets/SourceListView.vala"
			_tmp5_ = _views_it;
#line 544 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 544 "../src/Widgets/SourceListView.vala"
				break;
#line 4575 "SourceListView.c"
			}
#line 544 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _views_it;
#line 544 "../src/Widgets/SourceListView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 544 "../src/Widgets/SourceListView.vala"
			views = (GraniteWidgetsSourceListItem*) _tmp7_;
#line 545 "../src/Widgets/SourceListView.vala"
			_tmp8_ = views;
#line 545 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4587 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp9_;
#line 546 "../src/Widgets/SourceListView.vala"
				_tmp9_ = views;
#line 546 "../src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), pages);
#line 4593 "SourceListView.c"
			} else {
				GraniteWidgetsSourceListItem* _tmp10_;
#line 547 "../src/Widgets/SourceListView.vala"
				_tmp10_ = views;
#line 547 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4600 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp11_;
#line 548 "../src/Widgets/SourceListView.vala"
					_tmp11_ = views;
#line 548 "../src/Widgets/SourceListView.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) (*pages), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 4606 "SourceListView.c"
				}
			}
#line 544 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (views);
#line 4611 "SourceListView.c"
		}
#line 544 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_views_it);
#line 4615 "SourceListView.c"
	}
}


void
noise_source_list_view_change_playlist_name (NoiseSourceListView* self,
                                             NoiseViewWrapper* view,
                                             const gchar* new_name)
{
	GeeTreeSet* items = NULL;
	GeeTreeSet* _tmp14_;
#line 554 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 554 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 4633 "SourceListView.c"
	{
		GeeIterator* _playlist_it = NULL;
		NoisePlayListCategory* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->playlists_category;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children ((GraniteWidgetsSourceListExpandableItem*) _tmp0_);
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 555 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 555 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 555 "../src/Widgets/SourceListView.vala"
		_playlist_it = _tmp5_;
#line 555 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4660 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* playlist = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
#line 555 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _playlist_it;
#line 555 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 555 "../src/Widgets/SourceListView.vala"
				break;
#line 4672 "SourceListView.c"
			}
#line 555 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _playlist_it;
#line 555 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 555 "../src/Widgets/SourceListView.vala"
			playlist = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 556 "../src/Widgets/SourceListView.vala"
			_tmp9_ = playlist;
#line 556 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4684 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
#line 557 "../src/Widgets/SourceListView.vala"
				_tmp10_ = playlist;
#line 557 "../src/Widgets/SourceListView.vala"
				_tmp11_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 557 "../src/Widgets/SourceListView.vala"
				_tmp12_ = _tmp11_;
#line 557 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
#line 4696 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp13_;
#line 558 "../src/Widgets/SourceListView.vala"
					_tmp13_ = playlist;
#line 558 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), new_name);
#line 559 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (playlist);
#line 559 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_playlist_it);
#line 559 "../src/Widgets/SourceListView.vala"
					return;
#line 4708 "SourceListView.c"
				}
			}
#line 555 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (playlist);
#line 4713 "SourceListView.c"
		}
#line 555 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_playlist_it);
#line 4717 "SourceListView.c"
	}
#line 563 "../src/Widgets/SourceListView.vala"
	_tmp14_ = gee_tree_set_new (NOISE_TYPE_SOURCE_LIST_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 563 "../src/Widgets/SourceListView.vala"
	items = _tmp14_;
#line 4723 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeCollection* _tmp18_;
		GeeIterator* _tmp19_;
		GeeIterator* _tmp20_;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp15_ = self->priv->devices_category;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp16_ = granite_widgets_source_list_expandable_item_get_children (_tmp15_);
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp17_ = _tmp16_;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp18_ = _tmp17_;
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp19_ = gee_iterable_iterator ((GeeIterable*) _tmp18_);
#line 564 "../src/Widgets/SourceListView.vala"
		_tmp20_ = _tmp19_;
#line 564 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp18_);
#line 564 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp20_;
#line 564 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4750 "SourceListView.c"
			GeeIterator* _tmp21_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp22_;
			gpointer _tmp23_;
			GraniteWidgetsSourceListItem* _tmp24_;
#line 564 "../src/Widgets/SourceListView.vala"
			_tmp21_ = _device_it;
#line 564 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp21_)) {
#line 564 "../src/Widgets/SourceListView.vala"
				break;
#line 4762 "SourceListView.c"
			}
#line 564 "../src/Widgets/SourceListView.vala"
			_tmp22_ = _device_it;
#line 564 "../src/Widgets/SourceListView.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 564 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp23_;
#line 565 "../src/Widgets/SourceListView.vala"
			_tmp24_ = device;
#line 565 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp24_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM)) {
#line 4774 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp25_;
#line 566 "../src/Widgets/SourceListView.vala"
				_tmp25_ = device;
#line 566 "../src/Widgets/SourceListView.vala"
				noise_source_list_view_enumerate_children_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, NOISE_TYPE_SOURCE_LIST_EXPANDABLE_ITEM, NoiseSourceListExpandableItem), &items);
#line 4780 "SourceListView.c"
				{
					GeeIterator* _item_it = NULL;
					GeeTreeSet* _tmp26_;
					GeeIterator* _tmp27_;
#line 567 "../src/Widgets/SourceListView.vala"
					_tmp26_ = items;
#line 567 "../src/Widgets/SourceListView.vala"
					_tmp27_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp26_);
#line 567 "../src/Widgets/SourceListView.vala"
					_item_it = _tmp27_;
#line 567 "../src/Widgets/SourceListView.vala"
					while (TRUE) {
#line 4793 "SourceListView.c"
						GeeIterator* _tmp28_;
						NoiseSourceListItem* item = NULL;
						GeeIterator* _tmp29_;
						gpointer _tmp30_;
						NoiseSourceListItem* _tmp31_;
						GtkGrid* _tmp32_;
						GtkGrid* _tmp33_;
#line 567 "../src/Widgets/SourceListView.vala"
						_tmp28_ = _item_it;
#line 567 "../src/Widgets/SourceListView.vala"
						if (!gee_iterator_next (_tmp28_)) {
#line 567 "../src/Widgets/SourceListView.vala"
							break;
#line 4807 "SourceListView.c"
						}
#line 567 "../src/Widgets/SourceListView.vala"
						_tmp29_ = _item_it;
#line 567 "../src/Widgets/SourceListView.vala"
						_tmp30_ = gee_iterator_get (_tmp29_);
#line 567 "../src/Widgets/SourceListView.vala"
						item = (NoiseSourceListItem*) _tmp30_;
#line 568 "../src/Widgets/SourceListView.vala"
						_tmp31_ = item;
#line 568 "../src/Widgets/SourceListView.vala"
						_tmp32_ = noise_source_list_item_get_view (_tmp31_);
#line 568 "../src/Widgets/SourceListView.vala"
						_tmp33_ = _tmp32_;
#line 568 "../src/Widgets/SourceListView.vala"
						if (_tmp33_ == G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid)) {
#line 4823 "SourceListView.c"
							NoiseSourceListItem* _tmp34_;
#line 569 "../src/Widgets/SourceListView.vala"
							_tmp34_ = item;
#line 569 "../src/Widgets/SourceListView.vala"
							granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), new_name);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (item);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_item_it);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (device);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (_device_it);
#line 570 "../src/Widgets/SourceListView.vala"
							_g_object_unref0 (items);
#line 570 "../src/Widgets/SourceListView.vala"
							return;
#line 4841 "SourceListView.c"
						}
#line 567 "../src/Widgets/SourceListView.vala"
						_g_object_unref0 (item);
#line 4845 "SourceListView.c"
					}
#line 567 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_item_it);
#line 4849 "SourceListView.c"
				}
			}
#line 564 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4854 "SourceListView.c"
		}
#line 564 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4858 "SourceListView.c"
	}
#line 554 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (items);
#line 4862 "SourceListView.c"
}


void
noise_source_list_view_change_device_name (NoiseSourceListView* self,
                                           NoiseDeviceView* view,
                                           const gchar* new_name)
{
#line 578 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (view != NULL);
#line 578 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (new_name != NULL);
#line 4877 "SourceListView.c"
	{
		GeeIterator* _device_it = NULL;
		GraniteWidgetsSourceListExpandableItem* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp0_ = self->priv->devices_category;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp1_ = granite_widgets_source_list_expandable_item_get_children (_tmp0_);
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp2_ = _tmp1_;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp3_ = _tmp2_;
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 579 "../src/Widgets/SourceListView.vala"
		_tmp5_ = _tmp4_;
#line 579 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_tmp3_);
#line 579 "../src/Widgets/SourceListView.vala"
		_device_it = _tmp5_;
#line 579 "../src/Widgets/SourceListView.vala"
		while (TRUE) {
#line 4904 "SourceListView.c"
			GeeIterator* _tmp6_;
			GraniteWidgetsSourceListItem* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GraniteWidgetsSourceListItem* _tmp9_;
#line 579 "../src/Widgets/SourceListView.vala"
			_tmp6_ = _device_it;
#line 579 "../src/Widgets/SourceListView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 579 "../src/Widgets/SourceListView.vala"
				break;
#line 4916 "SourceListView.c"
			}
#line 579 "../src/Widgets/SourceListView.vala"
			_tmp7_ = _device_it;
#line 579 "../src/Widgets/SourceListView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 579 "../src/Widgets/SourceListView.vala"
			device = (GraniteWidgetsSourceListItem*) _tmp8_;
#line 580 "../src/Widgets/SourceListView.vala"
			_tmp9_ = device;
#line 580 "../src/Widgets/SourceListView.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, NOISE_TYPE_SOURCE_LIST_ITEM)) {
#line 4928 "SourceListView.c"
				GraniteWidgetsSourceListItem* _tmp10_;
				GtkGrid* _tmp11_;
				GtkGrid* _tmp12_;
#line 581 "../src/Widgets/SourceListView.vala"
				_tmp10_ = device;
#line 581 "../src/Widgets/SourceListView.vala"
				_tmp11_ = noise_source_list_item_get_view (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem));
#line 581 "../src/Widgets/SourceListView.vala"
				_tmp12_ = _tmp11_;
#line 581 "../src/Widgets/SourceListView.vala"
				if (G_TYPE_CHECK_INSTANCE_CAST (view, gtk_grid_get_type (), GtkGrid) == _tmp12_) {
#line 4940 "SourceListView.c"
					GraniteWidgetsSourceListItem* _tmp13_;
#line 582 "../src/Widgets/SourceListView.vala"
					_tmp13_ = device;
#line 582 "../src/Widgets/SourceListView.vala"
					granite_widgets_source_list_item_set_name ((GraniteWidgetsSourceListItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_SOURCE_LIST_ITEM, NoiseSourceListItem), new_name);
#line 583 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (device);
#line 583 "../src/Widgets/SourceListView.vala"
					_g_object_unref0 (_device_it);
#line 583 "../src/Widgets/SourceListView.vala"
					return;
#line 4952 "SourceListView.c"
				}
			}
#line 579 "../src/Widgets/SourceListView.vala"
			_g_object_unref0 (device);
#line 4957 "SourceListView.c"
		}
#line 579 "../src/Widgets/SourceListView.vala"
		_g_object_unref0 (_device_it);
#line 4961 "SourceListView.c"
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 308 "../src/Widgets/SourceListView.vala"
	g_return_if_fail (n_param_values == 3);
#line 308 "../src/Widgets/SourceListView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 308 "../src/Widgets/SourceListView.vala"
		data1 = closure->data;
#line 308 "../src/Widgets/SourceListView.vala"
		data2 = param_values->data[0].v_pointer;
#line 4988 "SourceListView.c"
	} else {
#line 308 "../src/Widgets/SourceListView.vala"
		data1 = param_values->data[0].v_pointer;
#line 308 "../src/Widgets/SourceListView.vala"
		data2 = closure->data;
#line 4994 "SourceListView.c"
	}
#line 308 "../src/Widgets/SourceListView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 308 "../src/Widgets/SourceListView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 5000 "SourceListView.c"
}


static void
noise_source_list_view_class_init (NoiseSourceListViewClass * klass)
{
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_parent_class = g_type_class_peek_parent (klass);
#line 308 "../src/Widgets/SourceListView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSourceListView_private_offset);
#line 308 "../src/Widgets/SourceListView.vala"
	((GraniteWidgetsSourceListClass *) klass)->item_selected = (void (*) (GraniteWidgetsSourceList*, GraniteWidgetsSourceListItem*)) noise_source_list_view_real_item_selected;
#line 308 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_source_list_view_finalize;
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_EDITED_SIGNAL] = g_signal_new ("edited", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, gtk_grid_get_type (), G_TYPE_STRING);
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("item-action-activated", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_ACTIVATED_SIGNAL] = g_signal_new ("activated", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_RENAME_CLICKED_SIGNAL] = g_signal_new ("playlist-rename-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EDIT_CLICKED_SIGNAL] = g_signal_new ("playlist-edit-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_REMOVE_CLICKED_SIGNAL] = g_signal_new ("playlist-remove-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_SAVE_CLICKED_SIGNAL] = g_signal_new ("playlist-save-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_EXPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-export-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_IMPORT_CLICKED_SIGNAL] = g_signal_new ("playlist-import-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("playlist-media-added", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOXED_INT, G_TYPE_NONE, 3, gtk_grid_get_type (), G_TYPE_STRV, G_TYPE_INT);
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_IMPORT_CLICKED_SIGNAL] = g_signal_new ("device-import-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_EJECT_CLICKED_SIGNAL] = g_signal_new ("device-eject-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_SYNC_CLICKED_SIGNAL] = g_signal_new ("device-sync-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_PLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-playlist-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 308 "../src/Widgets/SourceListView.vala"
	noise_source_list_view_signals[NOISE_SOURCE_LIST_VIEW_DEVICE_NEW_SMARTPLAYLIST_CLICKED_SIGNAL] = g_signal_new ("device-new-smartplaylist-clicked", NOISE_TYPE_SOURCE_LIST_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_grid_get_type ());
#line 5047 "SourceListView.c"
}


static void
noise_source_list_view_instance_init (NoiseSourceListView * self)
{
#line 308 "../src/Widgets/SourceListView.vala"
	self->priv = noise_source_list_view_get_instance_private (self);
#line 5056 "SourceListView.c"
}


static void
noise_source_list_view_finalize (GObject * obj)
{
	NoiseSourceListView * self;
#line 308 "../src/Widgets/SourceListView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SOURCE_LIST_VIEW, NoiseSourceListView);
#line 310 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->library_category);
#line 311 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->devices_category);
#line 312 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->network_category);
#line 313 "../src/Widgets/SourceListView.vala"
	_g_object_unref0 (self->priv->playlists_category);
#line 308 "../src/Widgets/SourceListView.vala"
	G_OBJECT_CLASS (noise_source_list_view_parent_class)->finalize (obj);
#line 5076 "SourceListView.c"
}


GType
noise_source_list_view_get_type (void)
{
	static volatile gsize noise_source_list_view_type_id__volatile = 0;
	if (g_once_init_enter (&noise_source_list_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseSourceListViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_source_list_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSourceListView), 0, (GInstanceInitFunc) noise_source_list_view_instance_init, NULL };
		GType noise_source_list_view_type_id;
		noise_source_list_view_type_id = g_type_register_static (GRANITE_WIDGETS_TYPE_SOURCE_LIST, "NoiseSourceListView", &g_define_type_info, 0);
		NoiseSourceListView_private_offset = g_type_add_instance_private (noise_source_list_view_type_id, sizeof (NoiseSourceListViewPrivate));
		g_once_init_leave (&noise_source_list_view_type_id__volatile, noise_source_list_view_type_id);
	}
	return noise_source_list_view_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



