/* PlaybackManager.c generated by valac 0.42.6, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>


#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
enum  {
	NOISE_PLAYBACK_MANAGER_0_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _NoisePlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	NoiseMedia* _current_media;
};

struct _Block10Data {
	int _ref_count_;
	NoisePlaybackManager* self;
	NoiseMedia* m;
};


static gint NoisePlaybackManager_private_offset;
static gpointer noise_playback_manager_parent_class = NULL;

GType noise_playback_manager_get_type (void) G_GNUC_CONST;
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
void noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                          NoisePlayback* playback);
void noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                         GeeCollection* to_queue);
static void noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                            NoiseMedia* m);
static void noise_playback_manager_reshuffle (NoisePlaybackManager* self);
void noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                           GeeCollection* to_unqueue);
static NoiseMedia* noise_playback_manager_poll_queue (NoisePlaybackManager* self);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self);
void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                             NoiseSettingsRepeat mode);
void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                              NoiseSettingsShuffle mode);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_get_next (NoisePlaybackManager* self,
                                             gboolean play);
static NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self);
void noise_playback_manager_stop_playback (NoisePlaybackManager* self);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
NoiseMedia* noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                                 gboolean play);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                               NoiseMedia* value);
void noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                        gdouble value);
void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GSettings* noise_app_get_saved_state (void);
static gboolean __lambda33_ (Block10Data* _data10_);
static gboolean ___lambda33__gsource_func (gpointer self);
static void noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                         gboolean value);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
#define NOISE_LIBRARY_WINDOW_ACTION_PLAY "action_play"
static GVariant* _variant_new4 (gboolean value);
void noise_playback_manager_pause_playback (NoisePlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
NoisePlaybackManager* noise_playback_manager_new (void);
NoisePlaybackManager* noise_playback_manager_construct (GType object_type);
gint noise_playback_manager_get_current_index (NoisePlaybackManager* self);
gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * noise_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
NoiseHistoryPlaylist* noise_history_playlist_new (void);
NoiseHistoryPlaylist* noise_history_playlist_construct (GType object_type);
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static void noise_playback_manager_finalize (GObject * obj);
static void _vala_noise_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static inline gpointer
noise_playback_manager_get_instance_private (NoisePlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlaybackManager_private_offset);
}


void
noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                     NoisePlayback* playback)
{
	GeeTreeSet* _tmp0_;
#line 116 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/PlaybackManager.vala"
	g_return_if_fail (playback != NULL);
#line 117 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->playbacks;
#line 117 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
#line 251 "PlaybackManager.c"
}


void
noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	NoiseStaticPlaylist* _tmp10_;
#line 120 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/PlaybackManager.vala"
	g_return_if_fail (to_queue != NULL);
#line 121 "../src/PlaybackManager.vala"
	_tmp0_ = gee_collection_get_size (to_queue);
#line 121 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 121 "../src/PlaybackManager.vala"
	if (_tmp1_ < 1) {
#line 122 "../src/PlaybackManager.vala"
		return;
#line 274 "PlaybackManager.c"
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
#line 125 "../src/PlaybackManager.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
#line 125 "../src/PlaybackManager.vala"
		_q_it = _tmp2_;
#line 125 "../src/PlaybackManager.vala"
		while (TRUE) {
#line 285 "PlaybackManager.c"
			GeeIterator* _tmp3_;
			NoiseMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			NoiseMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			NoiseMedia* _tmp9_;
#line 125 "../src/PlaybackManager.vala"
			_tmp3_ = _q_it;
#line 125 "../src/PlaybackManager.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 125 "../src/PlaybackManager.vala"
				break;
#line 300 "PlaybackManager.c"
			}
#line 125 "../src/PlaybackManager.vala"
			_tmp4_ = _q_it;
#line 125 "../src/PlaybackManager.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 125 "../src/PlaybackManager.vala"
			q = (NoiseMedia*) _tmp5_;
#line 126 "../src/PlaybackManager.vala"
			_tmp6_ = q;
#line 126 "../src/PlaybackManager.vala"
			_tmp7_ = noise_media_get_title (_tmp6_);
#line 126 "../src/PlaybackManager.vala"
			_tmp8_ = _tmp7_;
#line 126 "../src/PlaybackManager.vala"
			g_debug ("PlaybackManager.vala:126: QUEUED: %s", _tmp8_);
#line 127 "../src/PlaybackManager.vala"
			_tmp9_ = q;
#line 127 "../src/PlaybackManager.vala"
			noise_playback_manager_add_to_current (self, _tmp9_);
#line 125 "../src/PlaybackManager.vala"
			_g_object_unref0 (q);
#line 322 "PlaybackManager.c"
		}
#line 125 "../src/PlaybackManager.vala"
		_g_object_unref0 (_q_it);
#line 326 "PlaybackManager.c"
	}
#line 130 "../src/PlaybackManager.vala"
	_tmp10_ = self->queue_playlist;
#line 130 "../src/PlaybackManager.vala"
	noise_playlist_add_medias ((NoisePlaylist*) _tmp10_, to_queue);
#line 131 "../src/PlaybackManager.vala"
	noise_playback_manager_reshuffle (self);
#line 334 "PlaybackManager.c"
}


void
noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	NoiseStaticPlaylist* _tmp0_;
#line 134 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/PlaybackManager.vala"
	g_return_if_fail (to_unqueue != NULL);
#line 135 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 135 "../src/PlaybackManager.vala"
	noise_playlist_remove_medias ((NoisePlaylist*) _tmp0_, to_unqueue);
#line 351 "PlaybackManager.c"
}


static NoiseMedia*
noise_playback_manager_poll_queue (NoisePlaybackManager* self)
{
	NoiseMedia* result = NULL;
	NoiseMedia* m = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gpointer _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gpointer _tmp7_;
	NoiseMedia* _tmp8_;
	GeeLinkedList* unqueued = NULL;
	GeeLinkedList* _tmp9_;
	NoiseStaticPlaylist* _tmp10_;
#line 138 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 139 "../src/PlaybackManager.vala"
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
#line 139 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 139 "../src/PlaybackManager.vala"
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
#line 139 "../src/PlaybackManager.vala"
	m = (NoiseMedia*) _tmp3_;
#line 140 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 140 "../src/PlaybackManager.vala"
	_tmp5_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp4_);
#line 140 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 140 "../src/PlaybackManager.vala"
	_tmp7_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp6_, 0);
#line 140 "../src/PlaybackManager.vala"
	_tmp8_ = (NoiseMedia*) _tmp7_;
#line 140 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp8_);
#line 141 "../src/PlaybackManager.vala"
	_tmp9_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 141 "../src/PlaybackManager.vala"
	unqueued = _tmp9_;
#line 142 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) unqueued, m);
#line 143 "../src/PlaybackManager.vala"
	_tmp10_ = self->queue_playlist;
#line 143 "../src/PlaybackManager.vala"
	g_signal_emit_by_name ((NoisePlaylist*) _tmp10_, "media-removed", (GeeCollection*) unqueued);
#line 144 "../src/PlaybackManager.vala"
	result = m;
#line 144 "../src/PlaybackManager.vala"
	_g_object_unref0 (unqueued);
#line 144 "../src/PlaybackManager.vala"
	return result;
#line 412 "PlaybackManager.c"
}


void
noise_playback_manager_clear_queue (NoisePlaybackManager* self)
{
	NoiseStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
#line 147 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/PlaybackManager.vala"
	_tmp0_ = self->queue_playlist;
#line 148 "../src/PlaybackManager.vala"
	noise_playlist_clear ((NoisePlaylist*) _tmp0_);
#line 149 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 149 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
#line 150 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_index (self, 0);
#line 152 "../src/PlaybackManager.vala"
	noise_playback_manager_reshuffle (self);
#line 435 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                 gint index_in_current)
{
	NoiseMedia* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 155 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 156 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 156 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 156 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 156 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 156 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 156 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 156 "../src/PlaybackManager.vala"
	if (_tmp4_) {
#line 465 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
#line 157 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current;
#line 157 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) index_in_current));
#line 157 "../src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp6_;
#line 157 "../src/PlaybackManager.vala"
		return result;
#line 476 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp7_;
		gpointer _tmp8_;
#line 159 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_current_shuffled;
#line 159 "../src/PlaybackManager.vala"
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) index_in_current));
#line 159 "../src/PlaybackManager.vala"
		result = (NoiseMedia*) _tmp8_;
#line 159 "../src/PlaybackManager.vala"
		return result;
#line 488 "PlaybackManager.c"
	}
}


GeeCollection*
noise_playback_manager_get_current_media_list (NoisePlaybackManager* self)
{
	GeeCollection* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
#line 163 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 164 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 164 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_;
#line 164 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 164 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 164 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
#line 164 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp1_);
#line 164 "../src/PlaybackManager.vala"
	if (_tmp4_) {
#line 518 "PlaybackManager.c"
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
#line 165 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_shuffled;
#line 165 "../src/PlaybackManager.vala"
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
#line 165 "../src/PlaybackManager.vala"
		_tmp7_ = _tmp6_;
#line 165 "../src/PlaybackManager.vala"
		result = _tmp7_;
#line 165 "../src/PlaybackManager.vala"
		return result;
#line 532 "PlaybackManager.c"
	} else {
		GeeHashMap* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
#line 167 "../src/PlaybackManager.vala"
		_tmp8_ = self->priv->_current;
#line 167 "../src/PlaybackManager.vala"
		_tmp9_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp8_);
#line 167 "../src/PlaybackManager.vala"
		_tmp10_ = _tmp9_;
#line 167 "../src/PlaybackManager.vala"
		result = _tmp10_;
#line 167 "../src/PlaybackManager.vala"
		return result;
#line 547 "PlaybackManager.c"
	}
}


static void
noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                       NoiseMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 171 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 172 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current;
#line 172 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current;
#line 172 "../src/PlaybackManager.vala"
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
#line 172 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 172 "../src/PlaybackManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
#line 574 "PlaybackManager.c"
}


void
noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                        NoiseSettingsRepeat mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsRepeat _tmp2_;
	NoiseSettingsRepeat _tmp3_;
#line 175 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 176 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 177 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 177 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_repeat_mode (_tmp1_);
#line 177 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 177 "../src/PlaybackManager.vala"
	if (_tmp3_ != mode) {
#line 601 "PlaybackManager.c"
		NoiseSettingsMain* _tmp4_;
#line 178 "../src/PlaybackManager.vala"
		_tmp4_ = main_settings;
#line 178 "../src/PlaybackManager.vala"
		noise_settings_main_set_repeat_mode (_tmp4_, mode);
#line 607 "PlaybackManager.c"
	}
#line 175 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 611 "PlaybackManager.c"
}


void
noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                         NoiseSettingsShuffle mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
#line 182 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 183 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 184 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 184 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 184 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 184 "../src/PlaybackManager.vala"
	if (_tmp3_ != mode) {
#line 638 "PlaybackManager.c"
		NoiseSettingsMain* _tmp4_;
#line 185 "../src/PlaybackManager.vala"
		_tmp4_ = main_settings;
#line 185 "../src/PlaybackManager.vala"
		noise_settings_main_set_shuffle_mode (_tmp4_, mode);
#line 186 "../src/PlaybackManager.vala"
		noise_playback_manager_reshuffle (self);
#line 646 "PlaybackManager.c"
	}
#line 182 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 650 "PlaybackManager.c"
}


/**
    * Regenerate the shuffled queue if needed
    */
static void
noise_playback_manager_reshuffle (NoisePlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseSettingsShuffle _tmp4_;
#line 193 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:194: Reshuffling");
#line 195 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 195 "../src/PlaybackManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 196 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled_index = 0;
#line 198 "../src/PlaybackManager.vala"
	_tmp1_ = noise_settings_main_get_default ();
#line 198 "../src/PlaybackManager.vala"
	main_settings = _tmp1_;
#line 199 "../src/PlaybackManager.vala"
	_tmp2_ = main_settings;
#line 199 "../src/PlaybackManager.vala"
	_tmp3_ = noise_settings_main_get_shuffle_mode (_tmp2_);
#line 199 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 199 "../src/PlaybackManager.vala"
	if (_tmp4_ == NOISE_SETTINGS_SHUFFLE_OFF) {
#line 688 "PlaybackManager.c"
		NoiseMedia* _tmp5_;
#line 200 "../src/PlaybackManager.vala"
		_tmp5_ = self->priv->_current_media;
#line 200 "../src/PlaybackManager.vala"
		if (_tmp5_ != NULL) {
#line 694 "PlaybackManager.c"
			{
				gint i = 0;
#line 202 "../src/PlaybackManager.vala"
				i = 0;
#line 699 "PlaybackManager.c"
				{
					gboolean _tmp6_ = FALSE;
#line 202 "../src/PlaybackManager.vala"
					_tmp6_ = TRUE;
#line 202 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 706 "PlaybackManager.c"
						gint _tmp8_;
						GeeHashMap* _tmp9_;
						gint _tmp10_;
						gint _tmp11_;
						GeeHashMap* _tmp12_;
						gint _tmp13_;
						gpointer _tmp14_;
						NoiseMedia* _tmp15_;
						NoiseMedia* _tmp16_;
						gboolean _tmp17_;
#line 202 "../src/PlaybackManager.vala"
						if (!_tmp6_) {
#line 719 "PlaybackManager.c"
							gint _tmp7_;
#line 202 "../src/PlaybackManager.vala"
							_tmp7_ = i;
#line 202 "../src/PlaybackManager.vala"
							i = _tmp7_ + 1;
#line 725 "PlaybackManager.c"
						}
#line 202 "../src/PlaybackManager.vala"
						_tmp6_ = FALSE;
#line 202 "../src/PlaybackManager.vala"
						_tmp8_ = i;
#line 202 "../src/PlaybackManager.vala"
						_tmp9_ = self->priv->_current;
#line 202 "../src/PlaybackManager.vala"
						_tmp10_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp9_);
#line 202 "../src/PlaybackManager.vala"
						_tmp11_ = _tmp10_;
#line 202 "../src/PlaybackManager.vala"
						if (!(_tmp8_ < _tmp11_)) {
#line 202 "../src/PlaybackManager.vala"
							break;
#line 741 "PlaybackManager.c"
						}
#line 203 "../src/PlaybackManager.vala"
						_tmp12_ = self->priv->_current;
#line 203 "../src/PlaybackManager.vala"
						_tmp13_ = i;
#line 203 "../src/PlaybackManager.vala"
						_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) _tmp13_));
#line 203 "../src/PlaybackManager.vala"
						_tmp15_ = (NoiseMedia*) _tmp14_;
#line 203 "../src/PlaybackManager.vala"
						_tmp16_ = self->priv->_current_media;
#line 203 "../src/PlaybackManager.vala"
						_tmp17_ = _tmp15_ == _tmp16_;
#line 203 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp15_);
#line 203 "../src/PlaybackManager.vala"
						if (_tmp17_) {
#line 759 "PlaybackManager.c"
							gint _tmp18_;
#line 204 "../src/PlaybackManager.vala"
							_tmp18_ = i;
#line 204 "../src/PlaybackManager.vala"
							self->priv->_current_index = _tmp18_;
#line 205 "../src/PlaybackManager.vala"
							_g_object_unref0 (main_settings);
#line 205 "../src/PlaybackManager.vala"
							return;
#line 769 "PlaybackManager.c"
						}
					}
				}
			}
		} else {
#line 209 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 777 "PlaybackManager.c"
		}
	} else {
		NoiseSettingsMain* _tmp19_;
		NoiseSettingsShuffle _tmp20_;
		NoiseSettingsShuffle _tmp21_;
#line 211 "../src/PlaybackManager.vala"
		_tmp19_ = main_settings;
#line 211 "../src/PlaybackManager.vala"
		_tmp20_ = noise_settings_main_get_shuffle_mode (_tmp19_);
#line 211 "../src/PlaybackManager.vala"
		_tmp21_ = _tmp20_;
#line 211 "../src/PlaybackManager.vala"
		if (_tmp21_ == NOISE_SETTINGS_SHUFFLE_ALL) {
#line 791 "PlaybackManager.c"
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp22_;
			gboolean current_media_found = FALSE;
			gboolean _tmp36_ = FALSE;
			NoiseMedia* _tmp37_;
#line 213 "../src/PlaybackManager.vala"
			_tmp22_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 213 "../src/PlaybackManager.vala"
			temp = _tmp22_;
#line 214 "../src/PlaybackManager.vala"
			current_media_found = FALSE;
#line 803 "PlaybackManager.c"
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp23_;
				GeeCollection* _tmp24_;
				GeeCollection* _tmp25_;
				GeeCollection* _tmp26_;
				GeeIterator* _tmp27_;
				GeeIterator* _tmp28_;
#line 215 "../src/PlaybackManager.vala"
				_tmp23_ = self->priv->_current;
#line 215 "../src/PlaybackManager.vala"
				_tmp24_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp23_);
#line 215 "../src/PlaybackManager.vala"
				_tmp25_ = _tmp24_;
#line 215 "../src/PlaybackManager.vala"
				_tmp26_ = _tmp25_;
#line 215 "../src/PlaybackManager.vala"
				_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 215 "../src/PlaybackManager.vala"
				_tmp28_ = _tmp27_;
#line 215 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp26_);
#line 215 "../src/PlaybackManager.vala"
				_m_it = _tmp28_;
#line 215 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 830 "PlaybackManager.c"
					GeeIterator* _tmp29_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp30_;
					gpointer _tmp31_;
					NoiseMedia* _tmp32_;
					NoiseMedia* _tmp33_;
#line 215 "../src/PlaybackManager.vala"
					_tmp29_ = _m_it;
#line 215 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp29_)) {
#line 215 "../src/PlaybackManager.vala"
						break;
#line 843 "PlaybackManager.c"
					}
#line 215 "../src/PlaybackManager.vala"
					_tmp30_ = _m_it;
#line 215 "../src/PlaybackManager.vala"
					_tmp31_ = gee_iterator_get (_tmp30_);
#line 215 "../src/PlaybackManager.vala"
					m = (NoiseMedia*) _tmp31_;
#line 216 "../src/PlaybackManager.vala"
					_tmp32_ = self->priv->_current_media;
#line 216 "../src/PlaybackManager.vala"
					_tmp33_ = m;
#line 216 "../src/PlaybackManager.vala"
					if (_tmp32_ != _tmp33_) {
#line 857 "PlaybackManager.c"
						GeeLinkedList* _tmp34_;
						NoiseMedia* _tmp35_;
#line 217 "../src/PlaybackManager.vala"
						_tmp34_ = temp;
#line 217 "../src/PlaybackManager.vala"
						_tmp35_ = m;
#line 217 "../src/PlaybackManager.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
#line 866 "PlaybackManager.c"
					} else {
#line 219 "../src/PlaybackManager.vala"
						current_media_found = TRUE;
#line 870 "PlaybackManager.c"
					}
#line 215 "../src/PlaybackManager.vala"
					_g_object_unref0 (m);
#line 874 "PlaybackManager.c"
				}
#line 215 "../src/PlaybackManager.vala"
				_g_object_unref0 (_m_it);
#line 878 "PlaybackManager.c"
			}
#line 228 "../src/PlaybackManager.vala"
			_tmp37_ = self->priv->_current_media;
#line 228 "../src/PlaybackManager.vala"
			if (_tmp37_ != NULL) {
#line 884 "PlaybackManager.c"
				gboolean _tmp38_;
#line 228 "../src/PlaybackManager.vala"
				_tmp38_ = current_media_found;
#line 228 "../src/PlaybackManager.vala"
				_tmp36_ = _tmp38_;
#line 890 "PlaybackManager.c"
			} else {
#line 228 "../src/PlaybackManager.vala"
				_tmp36_ = FALSE;
#line 894 "PlaybackManager.c"
			}
#line 228 "../src/PlaybackManager.vala"
			if (_tmp36_) {
#line 898 "PlaybackManager.c"
				GeeHashMap* _tmp39_;
				NoiseMedia* _tmp40_;
#line 229 "../src/PlaybackManager.vala"
				_tmp39_ = self->priv->_current_shuffled;
#line 229 "../src/PlaybackManager.vala"
				_tmp40_ = self->priv->_current_media;
#line 229 "../src/PlaybackManager.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) 0), _tmp40_);
#line 907 "PlaybackManager.c"
			} else {
				gboolean _tmp41_ = FALSE;
				NoiseMedia* _tmp42_;
#line 230 "../src/PlaybackManager.vala"
				_tmp42_ = self->priv->_current_media;
#line 230 "../src/PlaybackManager.vala"
				if (_tmp42_ != NULL) {
#line 915 "PlaybackManager.c"
					GeeHashMap* _tmp43_;
					gint _tmp44_;
					gint _tmp45_;
#line 230 "../src/PlaybackManager.vala"
					_tmp43_ = self->priv->_current;
#line 230 "../src/PlaybackManager.vala"
					_tmp44_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp43_);
#line 230 "../src/PlaybackManager.vala"
					_tmp45_ = _tmp44_;
#line 230 "../src/PlaybackManager.vala"
					_tmp41_ = _tmp45_ != 0;
#line 927 "PlaybackManager.c"
				} else {
#line 230 "../src/PlaybackManager.vala"
					_tmp41_ = FALSE;
#line 931 "PlaybackManager.c"
				}
#line 230 "../src/PlaybackManager.vala"
				if (_tmp41_) {
#line 935 "PlaybackManager.c"
					GeeHashMap* _tmp46_;
					GeeHashMap* _tmp47_;
					gpointer _tmp48_;
					NoiseMedia* _tmp49_;
#line 233 "../src/PlaybackManager.vala"
					_tmp46_ = self->priv->_current_shuffled;
#line 233 "../src/PlaybackManager.vala"
					_tmp47_ = self->priv->_current;
#line 233 "../src/PlaybackManager.vala"
					_tmp48_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp47_, (gpointer) ((gintptr) 0));
#line 233 "../src/PlaybackManager.vala"
					_tmp49_ = (NoiseMedia*) _tmp48_;
#line 233 "../src/PlaybackManager.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) 0), _tmp49_);
#line 233 "../src/PlaybackManager.vala"
					_g_object_unref0 (_tmp49_);
#line 952 "PlaybackManager.c"
				}
			}
			{
				gint _tmp50_ = 0;
				NoiseMedia* _tmp51_;
				gint i = 0;
#line 236 "../src/PlaybackManager.vala"
				_tmp51_ = self->priv->_current_media;
#line 236 "../src/PlaybackManager.vala"
				if (_tmp51_ == NULL) {
#line 236 "../src/PlaybackManager.vala"
					_tmp50_ = 0;
#line 965 "PlaybackManager.c"
				} else {
#line 236 "../src/PlaybackManager.vala"
					_tmp50_ = 1;
#line 969 "PlaybackManager.c"
				}
#line 236 "../src/PlaybackManager.vala"
				i = _tmp50_;
#line 973 "PlaybackManager.c"
				{
					gboolean _tmp52_ = FALSE;
#line 236 "../src/PlaybackManager.vala"
					_tmp52_ = TRUE;
#line 236 "../src/PlaybackManager.vala"
					while (TRUE) {
#line 980 "PlaybackManager.c"
						gint _tmp54_;
						GeeHashMap* _tmp55_;
						gint _tmp56_;
						gint _tmp57_;
						gint n_media = 0;
						GeeLinkedList* _tmp58_;
						gint _tmp59_;
						gint _tmp60_;
						gint _tmp61_;
						gint random = 0;
						gint _tmp62_;
						GeeHashMap* _tmp63_;
						gint _tmp64_;
						GeeLinkedList* _tmp65_;
						gint _tmp66_;
						gpointer _tmp67_;
						NoiseMedia* _tmp68_;
						GeeLinkedList* _tmp69_;
						GeeLinkedList* _tmp70_;
						gint _tmp71_;
						gpointer _tmp72_;
						NoiseMedia* _tmp73_;
#line 236 "../src/PlaybackManager.vala"
						if (!_tmp52_) {
#line 1005 "PlaybackManager.c"
							gint _tmp53_;
#line 236 "../src/PlaybackManager.vala"
							_tmp53_ = i;
#line 236 "../src/PlaybackManager.vala"
							i = _tmp53_ + 1;
#line 1011 "PlaybackManager.c"
						}
#line 236 "../src/PlaybackManager.vala"
						_tmp52_ = FALSE;
#line 236 "../src/PlaybackManager.vala"
						_tmp54_ = i;
#line 236 "../src/PlaybackManager.vala"
						_tmp55_ = self->priv->_current;
#line 236 "../src/PlaybackManager.vala"
						_tmp56_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp55_);
#line 236 "../src/PlaybackManager.vala"
						_tmp57_ = _tmp56_;
#line 236 "../src/PlaybackManager.vala"
						if (!(_tmp54_ < _tmp57_)) {
#line 236 "../src/PlaybackManager.vala"
							break;
#line 1027 "PlaybackManager.c"
						}
#line 237 "../src/PlaybackManager.vala"
						_tmp58_ = temp;
#line 237 "../src/PlaybackManager.vala"
						_tmp59_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp58_);
#line 237 "../src/PlaybackManager.vala"
						_tmp60_ = _tmp59_;
#line 237 "../src/PlaybackManager.vala"
						n_media = _tmp60_;
#line 238 "../src/PlaybackManager.vala"
						_tmp61_ = n_media;
#line 238 "../src/PlaybackManager.vala"
						if (_tmp61_ == 0) {
#line 239 "../src/PlaybackManager.vala"
							break;
#line 1043 "PlaybackManager.c"
						}
#line 242 "../src/PlaybackManager.vala"
						_tmp62_ = n_media;
#line 242 "../src/PlaybackManager.vala"
						random = (gint) g_random_int_range ((gint32) 0, (gint32) _tmp62_);
#line 244 "../src/PlaybackManager.vala"
						_tmp63_ = self->priv->_current_shuffled;
#line 244 "../src/PlaybackManager.vala"
						_tmp64_ = i;
#line 244 "../src/PlaybackManager.vala"
						_tmp65_ = temp;
#line 244 "../src/PlaybackManager.vala"
						_tmp66_ = random;
#line 244 "../src/PlaybackManager.vala"
						_tmp67_ = gee_abstract_list_get ((GeeAbstractList*) _tmp65_, _tmp66_);
#line 244 "../src/PlaybackManager.vala"
						_tmp68_ = (NoiseMedia*) _tmp67_;
#line 244 "../src/PlaybackManager.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp63_, (gpointer) ((gintptr) _tmp64_), _tmp68_);
#line 244 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp68_);
#line 245 "../src/PlaybackManager.vala"
						_tmp69_ = temp;
#line 245 "../src/PlaybackManager.vala"
						_tmp70_ = temp;
#line 245 "../src/PlaybackManager.vala"
						_tmp71_ = random;
#line 245 "../src/PlaybackManager.vala"
						_tmp72_ = gee_abstract_list_get ((GeeAbstractList*) _tmp70_, _tmp71_);
#line 245 "../src/PlaybackManager.vala"
						_tmp73_ = (NoiseMedia*) _tmp72_;
#line 245 "../src/PlaybackManager.vala"
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp69_, _tmp73_);
#line 245 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp73_);
#line 1079 "PlaybackManager.c"
					}
				}
			}
#line 211 "../src/PlaybackManager.vala"
			_g_object_unref0 (temp);
#line 1085 "PlaybackManager.c"
		}
	}
#line 193 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 1090 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_get_next (NoisePlaybackManager* self,
                                 gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseStaticPlaylist* _tmp177_;
	GeeArrayList* _tmp178_;
	GeeArrayList* _tmp179_;
	NoiseMedia* _tmp180_;
#line 250 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 251 "../src/PlaybackManager.vala"
	rv = NULL;
#line 253 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 253 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 254 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 254 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 254 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 254 "../src/PlaybackManager.vala"
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 1125 "PlaybackManager.c"
		GeeHashMap* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GeeHashMap* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		NoiseMedia* _tmp17_;
#line 255 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 255 "../src/PlaybackManager.vala"
		_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
#line 255 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 255 "../src/PlaybackManager.vala"
		g_debug ("PlaybackManager.vala:255: Shuffled size: %d", _tmp6_);
#line 256 "../src/PlaybackManager.vala"
		_tmp7_ = self->priv->_current_shuffled;
#line 256 "../src/PlaybackManager.vala"
		_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
#line 256 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 256 "../src/PlaybackManager.vala"
		if (_tmp9_) {
#line 1149 "PlaybackManager.c"
			GeeHashMap* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 257 "../src/PlaybackManager.vala"
			_tmp10_ = self->priv->_current;
#line 257 "../src/PlaybackManager.vala"
			_tmp11_ = gee_map_get_is_empty ((GeeMap*) _tmp10_);
#line 257 "../src/PlaybackManager.vala"
			_tmp12_ = _tmp11_;
#line 257 "../src/PlaybackManager.vala"
			if (_tmp12_) {
#line 1161 "PlaybackManager.c"
				NoiseLibrary* _tmp13_;
				NoiseLibrary* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
#line 258 "../src/PlaybackManager.vala"
				_tmp13_ = noise_playback_manager_get_library (self);
#line 258 "../src/PlaybackManager.vala"
				_tmp14_ = _tmp13_;
#line 258 "../src/PlaybackManager.vala"
				_tmp15_ = noise_library_get_medias (_tmp14_);
#line 258 "../src/PlaybackManager.vala"
				_tmp16_ = _tmp15_;
#line 258 "../src/PlaybackManager.vala"
				noise_playback_manager_queue_media (self, _tmp16_);
#line 258 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp16_);
#line 1178 "PlaybackManager.c"
			}
#line 261 "../src/PlaybackManager.vala"
			noise_playback_manager_reshuffle (self);
#line 1182 "PlaybackManager.c"
		}
#line 264 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 266 "../src/PlaybackManager.vala"
		_tmp17_ = self->priv->_current_media;
#line 266 "../src/PlaybackManager.vala"
		if (_tmp17_ == NULL) {
#line 1190 "PlaybackManager.c"
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
#line 267 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = 0;
#line 268 "../src/PlaybackManager.vala"
			_tmp18_ = self->priv->_current_shuffled;
#line 268 "../src/PlaybackManager.vala"
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) 0));
#line 268 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 268 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp19_;
#line 1203 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp20_;
			NoiseSettingsRepeat _tmp21_;
			NoiseSettingsRepeat _tmp22_;
#line 269 "../src/PlaybackManager.vala"
			_tmp20_ = main_settings;
#line 269 "../src/PlaybackManager.vala"
			_tmp21_ = noise_settings_main_get_repeat_mode (_tmp20_);
#line 269 "../src/PlaybackManager.vala"
			_tmp22_ = _tmp21_;
#line 269 "../src/PlaybackManager.vala"
			if (_tmp22_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1216 "PlaybackManager.c"
				GeeHashMap* _tmp23_;
				gint _tmp24_;
				gpointer _tmp25_;
#line 270 "../src/PlaybackManager.vala"
				_tmp23_ = self->priv->_current_shuffled;
#line 270 "../src/PlaybackManager.vala"
				_tmp24_ = self->priv->_current_shuffled_index;
#line 270 "../src/PlaybackManager.vala"
				_tmp25_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) _tmp24_));
#line 270 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 270 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp25_;
#line 1230 "PlaybackManager.c"
			} else {
				gint _tmp26_;
				GeeHashMap* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
#line 271 "../src/PlaybackManager.vala"
				_tmp26_ = self->priv->_current_shuffled_index;
#line 271 "../src/PlaybackManager.vala"
				_tmp27_ = self->priv->_current_shuffled;
#line 271 "../src/PlaybackManager.vala"
				_tmp28_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp27_);
#line 271 "../src/PlaybackManager.vala"
				_tmp29_ = _tmp28_;
#line 271 "../src/PlaybackManager.vala"
				if (_tmp26_ == (_tmp29_ - 1)) {
#line 1246 "PlaybackManager.c"
					NoiseSettingsMain* _tmp30_;
					NoiseSettingsRepeat _tmp31_;
					NoiseSettingsRepeat _tmp32_;
					GeeHashMap* _tmp33_;
					gpointer _tmp34_;
#line 272 "../src/PlaybackManager.vala"
					_tmp30_ = main_settings;
#line 272 "../src/PlaybackManager.vala"
					_tmp31_ = noise_settings_main_get_repeat_mode (_tmp30_);
#line 272 "../src/PlaybackManager.vala"
					_tmp32_ = _tmp31_;
#line 272 "../src/PlaybackManager.vala"
					if (_tmp32_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 273 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = 0;
#line 1262 "PlaybackManager.c"
					} else {
#line 276 "../src/PlaybackManager.vala"
						if (play) {
#line 277 "../src/PlaybackManager.vala"
							noise_playback_manager_stop_playback (self);
#line 1268 "PlaybackManager.c"
						}
#line 280 "../src/PlaybackManager.vala"
						result = NULL;
#line 280 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 280 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 280 "../src/PlaybackManager.vala"
						return result;
#line 1278 "PlaybackManager.c"
					}
#line 283 "../src/PlaybackManager.vala"
					_tmp33_ = self->priv->_current_shuffled;
#line 283 "../src/PlaybackManager.vala"
					_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp33_, (gpointer) ((gintptr) 0));
#line 283 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 283 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp34_;
#line 1288 "PlaybackManager.c"
				} else {
					gboolean _tmp35_ = FALSE;
					gint _tmp36_;
#line 284 "../src/PlaybackManager.vala"
					_tmp36_ = self->priv->_current_shuffled_index;
#line 284 "../src/PlaybackManager.vala"
					if (_tmp36_ >= 0) {
#line 1296 "PlaybackManager.c"
						gint _tmp37_;
						GeeHashMap* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
#line 284 "../src/PlaybackManager.vala"
						_tmp37_ = self->priv->_current_shuffled_index;
#line 284 "../src/PlaybackManager.vala"
						_tmp38_ = self->priv->_current_shuffled;
#line 284 "../src/PlaybackManager.vala"
						_tmp39_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp38_);
#line 284 "../src/PlaybackManager.vala"
						_tmp40_ = _tmp39_;
#line 284 "../src/PlaybackManager.vala"
						_tmp35_ = _tmp37_ < (_tmp40_ - 1);
#line 1311 "PlaybackManager.c"
					} else {
#line 284 "../src/PlaybackManager.vala"
						_tmp35_ = FALSE;
#line 1315 "PlaybackManager.c"
					}
#line 284 "../src/PlaybackManager.vala"
					if (_tmp35_) {
#line 1319 "PlaybackManager.c"
						NoiseMedia* next_current = NULL;
						GeeHashMap* _tmp41_;
						gint _tmp42_;
						gpointer _tmp43_;
						NoiseMedia* now_current = NULL;
						GeeHashMap* _tmp44_;
						gint _tmp45_;
						gpointer _tmp46_;
						gboolean _tmp47_ = FALSE;
						NoiseSettingsMain* _tmp48_;
						NoiseSettingsRepeat _tmp49_;
						NoiseSettingsRepeat _tmp50_;
						GeeHashMap* _tmp90_;
						gint _tmp91_;
						gpointer _tmp92_;
#line 286 "../src/PlaybackManager.vala"
						_tmp41_ = self->priv->_current_shuffled;
#line 286 "../src/PlaybackManager.vala"
						_tmp42_ = self->priv->_current_shuffled_index;
#line 286 "../src/PlaybackManager.vala"
						_tmp43_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) (_tmp42_ + 1)));
#line 286 "../src/PlaybackManager.vala"
						next_current = (NoiseMedia*) _tmp43_;
#line 287 "../src/PlaybackManager.vala"
						_tmp44_ = self->priv->_current_shuffled;
#line 287 "../src/PlaybackManager.vala"
						_tmp45_ = self->priv->_current_shuffled_index;
#line 287 "../src/PlaybackManager.vala"
						_tmp46_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp44_, (gpointer) ((gintptr) _tmp45_));
#line 287 "../src/PlaybackManager.vala"
						now_current = (NoiseMedia*) _tmp46_;
#line 289 "../src/PlaybackManager.vala"
						_tmp48_ = main_settings;
#line 289 "../src/PlaybackManager.vala"
						_tmp49_ = noise_settings_main_get_repeat_mode (_tmp48_);
#line 289 "../src/PlaybackManager.vala"
						_tmp50_ = _tmp49_;
#line 289 "../src/PlaybackManager.vala"
						if (_tmp50_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1359 "PlaybackManager.c"
							NoiseMedia* _tmp51_;
							const gchar* _tmp52_;
							const gchar* _tmp53_;
							NoiseMedia* _tmp54_;
							const gchar* _tmp55_;
							const gchar* _tmp56_;
#line 289 "../src/PlaybackManager.vala"
							_tmp51_ = next_current;
#line 289 "../src/PlaybackManager.vala"
							_tmp52_ = noise_media_get_artist (_tmp51_);
#line 289 "../src/PlaybackManager.vala"
							_tmp53_ = _tmp52_;
#line 289 "../src/PlaybackManager.vala"
							_tmp54_ = now_current;
#line 289 "../src/PlaybackManager.vala"
							_tmp55_ = noise_media_get_artist (_tmp54_);
#line 289 "../src/PlaybackManager.vala"
							_tmp56_ = _tmp55_;
#line 289 "../src/PlaybackManager.vala"
							_tmp47_ = g_strcmp0 (_tmp53_, _tmp56_) != 0;
#line 1380 "PlaybackManager.c"
						} else {
#line 289 "../src/PlaybackManager.vala"
							_tmp47_ = FALSE;
#line 1384 "PlaybackManager.c"
						}
#line 289 "../src/PlaybackManager.vala"
						if (_tmp47_) {
#line 290 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 1390 "PlaybackManager.c"
								GeeHashMap* _tmp57_;
								gint _tmp58_;
								gpointer _tmp59_;
								NoiseMedia* _tmp60_;
								const gchar* _tmp61_;
								const gchar* _tmp62_;
								NoiseMedia* _tmp63_;
								const gchar* _tmp64_;
								const gchar* _tmp65_;
								gboolean _tmp66_;
								gint _tmp67_;
#line 290 "../src/PlaybackManager.vala"
								_tmp57_ = self->priv->_current_shuffled;
#line 290 "../src/PlaybackManager.vala"
								_tmp58_ = self->priv->_current_shuffled_index;
#line 290 "../src/PlaybackManager.vala"
								_tmp59_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp57_, (gpointer) ((gintptr) (_tmp58_ - 1)));
#line 290 "../src/PlaybackManager.vala"
								_tmp60_ = (NoiseMedia*) _tmp59_;
#line 290 "../src/PlaybackManager.vala"
								_tmp61_ = noise_media_get_artist (_tmp60_);
#line 290 "../src/PlaybackManager.vala"
								_tmp62_ = _tmp61_;
#line 290 "../src/PlaybackManager.vala"
								_tmp63_ = self->priv->_current_media;
#line 290 "../src/PlaybackManager.vala"
								_tmp64_ = noise_media_get_artist (_tmp63_);
#line 290 "../src/PlaybackManager.vala"
								_tmp65_ = _tmp64_;
#line 290 "../src/PlaybackManager.vala"
								_tmp66_ = !(g_strcmp0 (_tmp62_, _tmp65_) == 0);
#line 290 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp60_);
#line 290 "../src/PlaybackManager.vala"
								if (_tmp66_) {
#line 290 "../src/PlaybackManager.vala"
									break;
#line 1428 "PlaybackManager.c"
								}
#line 291 "../src/PlaybackManager.vala"
								_tmp67_ = self->priv->_current_shuffled_index;
#line 291 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp67_ - 1;
#line 1434 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp68_ = FALSE;
							NoiseSettingsMain* _tmp69_;
							NoiseSettingsRepeat _tmp70_;
							NoiseSettingsRepeat _tmp71_;
#line 293 "../src/PlaybackManager.vala"
							_tmp69_ = main_settings;
#line 293 "../src/PlaybackManager.vala"
							_tmp70_ = noise_settings_main_get_repeat_mode (_tmp69_);
#line 293 "../src/PlaybackManager.vala"
							_tmp71_ = _tmp70_;
#line 293 "../src/PlaybackManager.vala"
							if (_tmp71_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1449 "PlaybackManager.c"
								NoiseMedia* _tmp72_;
								const gchar* _tmp73_;
								const gchar* _tmp74_;
								NoiseMedia* _tmp75_;
								const gchar* _tmp76_;
								const gchar* _tmp77_;
#line 293 "../src/PlaybackManager.vala"
								_tmp72_ = next_current;
#line 293 "../src/PlaybackManager.vala"
								_tmp73_ = noise_media_get_album (_tmp72_);
#line 293 "../src/PlaybackManager.vala"
								_tmp74_ = _tmp73_;
#line 293 "../src/PlaybackManager.vala"
								_tmp75_ = now_current;
#line 293 "../src/PlaybackManager.vala"
								_tmp76_ = noise_media_get_album (_tmp75_);
#line 293 "../src/PlaybackManager.vala"
								_tmp77_ = _tmp76_;
#line 293 "../src/PlaybackManager.vala"
								_tmp68_ = g_strcmp0 (_tmp74_, _tmp77_) != 0;
#line 1470 "PlaybackManager.c"
							} else {
#line 293 "../src/PlaybackManager.vala"
								_tmp68_ = FALSE;
#line 1474 "PlaybackManager.c"
							}
#line 293 "../src/PlaybackManager.vala"
							if (_tmp68_) {
#line 294 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1480 "PlaybackManager.c"
									GeeHashMap* _tmp78_;
									gint _tmp79_;
									gpointer _tmp80_;
									NoiseMedia* _tmp81_;
									const gchar* _tmp82_;
									const gchar* _tmp83_;
									NoiseMedia* _tmp84_;
									const gchar* _tmp85_;
									const gchar* _tmp86_;
									gboolean _tmp87_;
									gint _tmp88_;
#line 294 "../src/PlaybackManager.vala"
									_tmp78_ = self->priv->_current_shuffled;
#line 294 "../src/PlaybackManager.vala"
									_tmp79_ = self->priv->_current_shuffled_index;
#line 294 "../src/PlaybackManager.vala"
									_tmp80_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp78_, (gpointer) ((gintptr) (_tmp79_ - 1)));
#line 294 "../src/PlaybackManager.vala"
									_tmp81_ = (NoiseMedia*) _tmp80_;
#line 294 "../src/PlaybackManager.vala"
									_tmp82_ = noise_media_get_album (_tmp81_);
#line 294 "../src/PlaybackManager.vala"
									_tmp83_ = _tmp82_;
#line 294 "../src/PlaybackManager.vala"
									_tmp84_ = self->priv->_current_media;
#line 294 "../src/PlaybackManager.vala"
									_tmp85_ = noise_media_get_album (_tmp84_);
#line 294 "../src/PlaybackManager.vala"
									_tmp86_ = _tmp85_;
#line 294 "../src/PlaybackManager.vala"
									_tmp87_ = !(g_strcmp0 (_tmp83_, _tmp86_) == 0);
#line 294 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp81_);
#line 294 "../src/PlaybackManager.vala"
									if (_tmp87_) {
#line 294 "../src/PlaybackManager.vala"
										break;
#line 1518 "PlaybackManager.c"
									}
#line 295 "../src/PlaybackManager.vala"
									_tmp88_ = self->priv->_current_shuffled_index;
#line 295 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp88_ - 1;
#line 1524 "PlaybackManager.c"
								}
							} else {
								gint _tmp89_;
#line 298 "../src/PlaybackManager.vala"
								_tmp89_ = self->priv->_current_shuffled_index;
#line 298 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp89_ + 1;
#line 1532 "PlaybackManager.c"
							}
						}
#line 301 "../src/PlaybackManager.vala"
						_tmp90_ = self->priv->_current_shuffled;
#line 301 "../src/PlaybackManager.vala"
						_tmp91_ = self->priv->_current_shuffled_index;
#line 301 "../src/PlaybackManager.vala"
						_tmp92_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp90_, (gpointer) ((gintptr) _tmp91_));
#line 301 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 301 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp92_;
#line 284 "../src/PlaybackManager.vala"
						_g_object_unref0 (now_current);
#line 284 "../src/PlaybackManager.vala"
						_g_object_unref0 (next_current);
#line 1549 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp93_;
						gpointer _tmp94_;
#line 303 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = 0;
#line 304 "../src/PlaybackManager.vala"
						noise_playback_manager_set_shuffle_mode (self, NOISE_SETTINGS_SHUFFLE_ALL);
#line 305 "../src/PlaybackManager.vala"
						_tmp93_ = self->priv->_current_shuffled;
#line 305 "../src/PlaybackManager.vala"
						_tmp94_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp93_, (gpointer) ((gintptr) 0));
#line 305 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 305 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp94_;
#line 1565 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp95_;
#line 308 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 310 "../src/PlaybackManager.vala"
		_tmp95_ = self->priv->_current_media;
#line 310 "../src/PlaybackManager.vala"
		if (_tmp95_ == NULL) {
#line 1578 "PlaybackManager.c"
			GeeHashMap* _tmp96_;
			gpointer _tmp97_;
#line 311 "../src/PlaybackManager.vala"
			self->priv->_current_index = 0;
#line 312 "../src/PlaybackManager.vala"
			_tmp96_ = self->priv->_current;
#line 312 "../src/PlaybackManager.vala"
			_tmp97_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp96_, (gpointer) ((gintptr) 0));
#line 312 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 312 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp97_;
#line 1591 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp98_;
			NoiseSettingsRepeat _tmp99_;
			NoiseSettingsRepeat _tmp100_;
#line 313 "../src/PlaybackManager.vala"
			_tmp98_ = main_settings;
#line 313 "../src/PlaybackManager.vala"
			_tmp99_ = noise_settings_main_get_repeat_mode (_tmp98_);
#line 313 "../src/PlaybackManager.vala"
			_tmp100_ = _tmp99_;
#line 313 "../src/PlaybackManager.vala"
			if (_tmp100_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 1604 "PlaybackManager.c"
				GeeHashMap* _tmp101_;
				gint _tmp102_;
				gpointer _tmp103_;
#line 314 "../src/PlaybackManager.vala"
				_tmp101_ = self->priv->_current;
#line 314 "../src/PlaybackManager.vala"
				_tmp102_ = self->priv->_current_index;
#line 314 "../src/PlaybackManager.vala"
				_tmp103_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp101_, (gpointer) ((gintptr) _tmp102_));
#line 314 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 314 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp103_;
#line 1618 "PlaybackManager.c"
			} else {
				gint _tmp104_;
				GeeHashMap* _tmp105_;
				gint _tmp106_;
				gint _tmp107_;
#line 315 "../src/PlaybackManager.vala"
				_tmp104_ = self->priv->_current_index;
#line 315 "../src/PlaybackManager.vala"
				_tmp105_ = self->priv->_current;
#line 315 "../src/PlaybackManager.vala"
				_tmp106_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp105_);
#line 315 "../src/PlaybackManager.vala"
				_tmp107_ = _tmp106_;
#line 315 "../src/PlaybackManager.vala"
				if (_tmp104_ == (_tmp107_ - 1)) {
#line 1634 "PlaybackManager.c"
					NoiseSettingsMain* _tmp108_;
					NoiseSettingsRepeat _tmp109_;
					NoiseSettingsRepeat _tmp110_;
					GeeHashMap* _tmp111_;
					gpointer _tmp112_;
#line 316 "../src/PlaybackManager.vala"
					_tmp108_ = main_settings;
#line 316 "../src/PlaybackManager.vala"
					_tmp109_ = noise_settings_main_get_repeat_mode (_tmp108_);
#line 316 "../src/PlaybackManager.vala"
					_tmp110_ = _tmp109_;
#line 316 "../src/PlaybackManager.vala"
					if (_tmp110_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 317 "../src/PlaybackManager.vala"
						self->priv->_current_index = 0;
#line 1650 "PlaybackManager.c"
					} else {
#line 319 "../src/PlaybackManager.vala"
						if (play) {
#line 320 "../src/PlaybackManager.vala"
							noise_playback_manager_stop_playback (self);
#line 1656 "PlaybackManager.c"
						}
#line 322 "../src/PlaybackManager.vala"
						result = NULL;
#line 322 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 322 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 322 "../src/PlaybackManager.vala"
						return result;
#line 1666 "PlaybackManager.c"
					}
#line 325 "../src/PlaybackManager.vala"
					_tmp111_ = self->priv->_current;
#line 325 "../src/PlaybackManager.vala"
					_tmp112_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp111_, (gpointer) ((gintptr) 0));
#line 325 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 325 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp112_;
#line 1676 "PlaybackManager.c"
				} else {
					gboolean _tmp113_ = FALSE;
					gint _tmp114_;
#line 326 "../src/PlaybackManager.vala"
					_tmp114_ = self->priv->_current_index;
#line 326 "../src/PlaybackManager.vala"
					if (_tmp114_ >= 0) {
#line 1684 "PlaybackManager.c"
						gint _tmp115_;
						GeeHashMap* _tmp116_;
						gint _tmp117_;
						gint _tmp118_;
#line 326 "../src/PlaybackManager.vala"
						_tmp115_ = self->priv->_current_index;
#line 326 "../src/PlaybackManager.vala"
						_tmp116_ = self->priv->_current;
#line 326 "../src/PlaybackManager.vala"
						_tmp117_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp116_);
#line 326 "../src/PlaybackManager.vala"
						_tmp118_ = _tmp117_;
#line 326 "../src/PlaybackManager.vala"
						_tmp113_ = _tmp115_ < (_tmp118_ - 1);
#line 1699 "PlaybackManager.c"
					} else {
#line 326 "../src/PlaybackManager.vala"
						_tmp113_ = FALSE;
#line 1703 "PlaybackManager.c"
					}
#line 326 "../src/PlaybackManager.vala"
					if (_tmp113_) {
#line 1707 "PlaybackManager.c"
						NoiseMedia* next_current = NULL;
						GeeHashMap* _tmp119_;
						gint _tmp120_;
						gpointer _tmp121_;
						NoiseMedia* now_current = NULL;
						GeeHashMap* _tmp122_;
						gint _tmp123_;
						gpointer _tmp124_;
						gboolean _tmp125_ = FALSE;
						NoiseSettingsMain* _tmp126_;
						NoiseSettingsRepeat _tmp127_;
						NoiseSettingsRepeat _tmp128_;
						GeeHashMap* _tmp168_;
						gint _tmp169_;
						gpointer _tmp170_;
#line 328 "../src/PlaybackManager.vala"
						_tmp119_ = self->priv->_current;
#line 328 "../src/PlaybackManager.vala"
						_tmp120_ = self->priv->_current_index;
#line 328 "../src/PlaybackManager.vala"
						_tmp121_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp119_, (gpointer) ((gintptr) (_tmp120_ + 1)));
#line 328 "../src/PlaybackManager.vala"
						next_current = (NoiseMedia*) _tmp121_;
#line 329 "../src/PlaybackManager.vala"
						_tmp122_ = self->priv->_current;
#line 329 "../src/PlaybackManager.vala"
						_tmp123_ = self->priv->_current_index;
#line 329 "../src/PlaybackManager.vala"
						_tmp124_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp122_, (gpointer) ((gintptr) _tmp123_));
#line 329 "../src/PlaybackManager.vala"
						now_current = (NoiseMedia*) _tmp124_;
#line 331 "../src/PlaybackManager.vala"
						_tmp126_ = main_settings;
#line 331 "../src/PlaybackManager.vala"
						_tmp127_ = noise_settings_main_get_repeat_mode (_tmp126_);
#line 331 "../src/PlaybackManager.vala"
						_tmp128_ = _tmp127_;
#line 331 "../src/PlaybackManager.vala"
						if (_tmp128_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 1747 "PlaybackManager.c"
							NoiseMedia* _tmp129_;
							const gchar* _tmp130_;
							const gchar* _tmp131_;
							NoiseMedia* _tmp132_;
							const gchar* _tmp133_;
							const gchar* _tmp134_;
#line 331 "../src/PlaybackManager.vala"
							_tmp129_ = next_current;
#line 331 "../src/PlaybackManager.vala"
							_tmp130_ = noise_media_get_artist (_tmp129_);
#line 331 "../src/PlaybackManager.vala"
							_tmp131_ = _tmp130_;
#line 331 "../src/PlaybackManager.vala"
							_tmp132_ = now_current;
#line 331 "../src/PlaybackManager.vala"
							_tmp133_ = noise_media_get_artist (_tmp132_);
#line 331 "../src/PlaybackManager.vala"
							_tmp134_ = _tmp133_;
#line 331 "../src/PlaybackManager.vala"
							_tmp125_ = g_strcmp0 (_tmp131_, _tmp134_) != 0;
#line 1768 "PlaybackManager.c"
						} else {
#line 331 "../src/PlaybackManager.vala"
							_tmp125_ = FALSE;
#line 1772 "PlaybackManager.c"
						}
#line 331 "../src/PlaybackManager.vala"
						if (_tmp125_) {
#line 332 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 1778 "PlaybackManager.c"
								GeeHashMap* _tmp135_;
								gint _tmp136_;
								gpointer _tmp137_;
								NoiseMedia* _tmp138_;
								const gchar* _tmp139_;
								const gchar* _tmp140_;
								NoiseMedia* _tmp141_;
								const gchar* _tmp142_;
								const gchar* _tmp143_;
								gboolean _tmp144_;
								gint _tmp145_;
#line 332 "../src/PlaybackManager.vala"
								_tmp135_ = self->priv->_current;
#line 332 "../src/PlaybackManager.vala"
								_tmp136_ = self->priv->_current_index;
#line 332 "../src/PlaybackManager.vala"
								_tmp137_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp135_, (gpointer) ((gintptr) (_tmp136_ - 1)));
#line 332 "../src/PlaybackManager.vala"
								_tmp138_ = (NoiseMedia*) _tmp137_;
#line 332 "../src/PlaybackManager.vala"
								_tmp139_ = noise_media_get_artist (_tmp138_);
#line 332 "../src/PlaybackManager.vala"
								_tmp140_ = _tmp139_;
#line 332 "../src/PlaybackManager.vala"
								_tmp141_ = self->priv->_current_media;
#line 332 "../src/PlaybackManager.vala"
								_tmp142_ = noise_media_get_artist (_tmp141_);
#line 332 "../src/PlaybackManager.vala"
								_tmp143_ = _tmp142_;
#line 332 "../src/PlaybackManager.vala"
								_tmp144_ = !(g_strcmp0 (_tmp140_, _tmp143_) == 0);
#line 332 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp138_);
#line 332 "../src/PlaybackManager.vala"
								if (_tmp144_) {
#line 332 "../src/PlaybackManager.vala"
									break;
#line 1816 "PlaybackManager.c"
								}
#line 333 "../src/PlaybackManager.vala"
								_tmp145_ = self->priv->_current_index;
#line 333 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp145_ - 1;
#line 1822 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp146_ = FALSE;
							NoiseSettingsMain* _tmp147_;
							NoiseSettingsRepeat _tmp148_;
							NoiseSettingsRepeat _tmp149_;
#line 335 "../src/PlaybackManager.vala"
							_tmp147_ = main_settings;
#line 335 "../src/PlaybackManager.vala"
							_tmp148_ = noise_settings_main_get_repeat_mode (_tmp147_);
#line 335 "../src/PlaybackManager.vala"
							_tmp149_ = _tmp148_;
#line 335 "../src/PlaybackManager.vala"
							if (_tmp149_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 1837 "PlaybackManager.c"
								NoiseMedia* _tmp150_;
								const gchar* _tmp151_;
								const gchar* _tmp152_;
								NoiseMedia* _tmp153_;
								const gchar* _tmp154_;
								const gchar* _tmp155_;
#line 335 "../src/PlaybackManager.vala"
								_tmp150_ = next_current;
#line 335 "../src/PlaybackManager.vala"
								_tmp151_ = noise_media_get_album (_tmp150_);
#line 335 "../src/PlaybackManager.vala"
								_tmp152_ = _tmp151_;
#line 335 "../src/PlaybackManager.vala"
								_tmp153_ = now_current;
#line 335 "../src/PlaybackManager.vala"
								_tmp154_ = noise_media_get_album (_tmp153_);
#line 335 "../src/PlaybackManager.vala"
								_tmp155_ = _tmp154_;
#line 335 "../src/PlaybackManager.vala"
								_tmp146_ = g_strcmp0 (_tmp152_, _tmp155_) != 0;
#line 1858 "PlaybackManager.c"
							} else {
#line 335 "../src/PlaybackManager.vala"
								_tmp146_ = FALSE;
#line 1862 "PlaybackManager.c"
							}
#line 335 "../src/PlaybackManager.vala"
							if (_tmp146_) {
#line 336 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 1868 "PlaybackManager.c"
									GeeHashMap* _tmp156_;
									gint _tmp157_;
									gpointer _tmp158_;
									NoiseMedia* _tmp159_;
									const gchar* _tmp160_;
									const gchar* _tmp161_;
									NoiseMedia* _tmp162_;
									const gchar* _tmp163_;
									const gchar* _tmp164_;
									gboolean _tmp165_;
									gint _tmp166_;
#line 336 "../src/PlaybackManager.vala"
									_tmp156_ = self->priv->_current;
#line 336 "../src/PlaybackManager.vala"
									_tmp157_ = self->priv->_current_index;
#line 336 "../src/PlaybackManager.vala"
									_tmp158_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp156_, (gpointer) ((gintptr) (_tmp157_ - 1)));
#line 336 "../src/PlaybackManager.vala"
									_tmp159_ = (NoiseMedia*) _tmp158_;
#line 336 "../src/PlaybackManager.vala"
									_tmp160_ = noise_media_get_album (_tmp159_);
#line 336 "../src/PlaybackManager.vala"
									_tmp161_ = _tmp160_;
#line 336 "../src/PlaybackManager.vala"
									_tmp162_ = self->priv->_current_media;
#line 336 "../src/PlaybackManager.vala"
									_tmp163_ = noise_media_get_album (_tmp162_);
#line 336 "../src/PlaybackManager.vala"
									_tmp164_ = _tmp163_;
#line 336 "../src/PlaybackManager.vala"
									_tmp165_ = !(g_strcmp0 (_tmp161_, _tmp164_) == 0);
#line 336 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp159_);
#line 336 "../src/PlaybackManager.vala"
									if (_tmp165_) {
#line 336 "../src/PlaybackManager.vala"
										break;
#line 1906 "PlaybackManager.c"
									}
#line 337 "../src/PlaybackManager.vala"
									_tmp166_ = self->priv->_current_index;
#line 337 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp166_ - 1;
#line 1912 "PlaybackManager.c"
								}
							} else {
								gint _tmp167_;
#line 340 "../src/PlaybackManager.vala"
								_tmp167_ = self->priv->_current_index;
#line 340 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp167_ + 1;
#line 1920 "PlaybackManager.c"
							}
						}
#line 343 "../src/PlaybackManager.vala"
						_tmp168_ = self->priv->_current;
#line 343 "../src/PlaybackManager.vala"
						_tmp169_ = self->priv->_current_index;
#line 343 "../src/PlaybackManager.vala"
						_tmp170_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp168_, (gpointer) ((gintptr) _tmp169_));
#line 343 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 343 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp170_;
#line 326 "../src/PlaybackManager.vala"
						_g_object_unref0 (now_current);
#line 326 "../src/PlaybackManager.vala"
						_g_object_unref0 (next_current);
#line 1937 "PlaybackManager.c"
					} else {
						NoiseLibrary* _tmp171_;
						NoiseLibrary* _tmp172_;
						GeeCollection* _tmp173_;
						GeeCollection* _tmp174_;
						GeeHashMap* _tmp175_;
						gpointer _tmp176_;
#line 345 "../src/PlaybackManager.vala"
						_tmp171_ = noise_playback_manager_get_library (self);
#line 345 "../src/PlaybackManager.vala"
						_tmp172_ = _tmp171_;
#line 345 "../src/PlaybackManager.vala"
						_tmp173_ = noise_library_get_medias (_tmp172_);
#line 345 "../src/PlaybackManager.vala"
						_tmp174_ = _tmp173_;
#line 345 "../src/PlaybackManager.vala"
						noise_playback_manager_queue_media (self, _tmp174_);
#line 345 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp174_);
#line 347 "../src/PlaybackManager.vala"
						self->priv->_current_index = 0;
#line 348 "../src/PlaybackManager.vala"
						_tmp175_ = self->priv->_current;
#line 348 "../src/PlaybackManager.vala"
						_tmp176_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp175_, (gpointer) ((gintptr) 0));
#line 348 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 348 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp176_;
#line 1967 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 352 "../src/PlaybackManager.vala"
	_tmp177_ = self->queue_playlist;
#line 352 "../src/PlaybackManager.vala"
	_tmp178_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp177_);
#line 352 "../src/PlaybackManager.vala"
	_tmp179_ = _tmp178_;
#line 352 "../src/PlaybackManager.vala"
	_tmp180_ = rv;
#line 352 "../src/PlaybackManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp179_, _tmp180_)) {
#line 353 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 1985 "PlaybackManager.c"
	}
#line 356 "../src/PlaybackManager.vala"
	if (play) {
#line 1989 "PlaybackManager.c"
		NoiseMedia* _tmp181_;
#line 357 "../src/PlaybackManager.vala"
		_tmp181_ = rv;
#line 357 "../src/PlaybackManager.vala"
		noise_playback_manager_play_media (self, _tmp181_);
#line 1995 "PlaybackManager.c"
	}
#line 360 "../src/PlaybackManager.vala"
	result = rv;
#line 360 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 360 "../src/PlaybackManager.vala"
	return result;
#line 2003 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                     gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseStaticPlaylist* _tmp204_;
	GeeArrayList* _tmp205_;
	GeeArrayList* _tmp206_;
	NoiseMedia* _tmp207_;
#line 364 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 365 "../src/PlaybackManager.vala"
	rv = NULL;
#line 367 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_main_get_default ();
#line 367 "../src/PlaybackManager.vala"
	main_settings = _tmp0_;
#line 368 "../src/PlaybackManager.vala"
	_tmp1_ = main_settings;
#line 368 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
#line 368 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 368 "../src/PlaybackManager.vala"
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
#line 2038 "PlaybackManager.c"
		GeeHashMap* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		NoiseMedia* _tmp14_;
#line 369 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled;
#line 369 "../src/PlaybackManager.vala"
		_tmp5_ = gee_map_get_is_empty ((GeeMap*) _tmp4_);
#line 369 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 369 "../src/PlaybackManager.vala"
		if (_tmp6_) {
#line 2051 "PlaybackManager.c"
			GeeHashMap* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 370 "../src/PlaybackManager.vala"
			_tmp7_ = self->priv->_current;
#line 370 "../src/PlaybackManager.vala"
			_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
#line 370 "../src/PlaybackManager.vala"
			_tmp9_ = _tmp8_;
#line 370 "../src/PlaybackManager.vala"
			if (_tmp9_) {
#line 2063 "PlaybackManager.c"
				NoiseLibrary* _tmp10_;
				NoiseLibrary* _tmp11_;
				GeeCollection* _tmp12_;
				GeeCollection* _tmp13_;
#line 371 "../src/PlaybackManager.vala"
				_tmp10_ = noise_playback_manager_get_library (self);
#line 371 "../src/PlaybackManager.vala"
				_tmp11_ = _tmp10_;
#line 371 "../src/PlaybackManager.vala"
				_tmp12_ = noise_library_get_medias (_tmp11_);
#line 371 "../src/PlaybackManager.vala"
				_tmp13_ = _tmp12_;
#line 371 "../src/PlaybackManager.vala"
				noise_playback_manager_queue_media (self, _tmp13_);
#line 371 "../src/PlaybackManager.vala"
				_g_object_unref0 (_tmp13_);
#line 2080 "PlaybackManager.c"
			}
#line 374 "../src/PlaybackManager.vala"
			noise_playback_manager_reshuffle (self);
#line 2084 "PlaybackManager.c"
		}
#line 377 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 379 "../src/PlaybackManager.vala"
		_tmp14_ = self->priv->_current_media;
#line 379 "../src/PlaybackManager.vala"
		if (_tmp14_ == NULL) {
#line 2092 "PlaybackManager.c"
			GeeHashMap* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			GeeHashMap* _tmp18_;
			gint _tmp19_;
			gpointer _tmp20_;
#line 380 "../src/PlaybackManager.vala"
			_tmp15_ = self->priv->_current_shuffled;
#line 380 "../src/PlaybackManager.vala"
			_tmp16_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp15_);
#line 380 "../src/PlaybackManager.vala"
			_tmp17_ = _tmp16_;
#line 380 "../src/PlaybackManager.vala"
			self->priv->_current_shuffled_index = _tmp17_ - 1;
#line 381 "../src/PlaybackManager.vala"
			_tmp18_ = self->priv->_current_shuffled;
#line 381 "../src/PlaybackManager.vala"
			_tmp19_ = self->priv->_current_shuffled_index;
#line 381 "../src/PlaybackManager.vala"
			_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) _tmp19_));
#line 381 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 381 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp20_;
#line 2117 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp21_;
			NoiseSettingsRepeat _tmp22_;
			NoiseSettingsRepeat _tmp23_;
#line 382 "../src/PlaybackManager.vala"
			_tmp21_ = main_settings;
#line 382 "../src/PlaybackManager.vala"
			_tmp22_ = noise_settings_main_get_repeat_mode (_tmp21_);
#line 382 "../src/PlaybackManager.vala"
			_tmp23_ = _tmp22_;
#line 382 "../src/PlaybackManager.vala"
			if (_tmp23_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2130 "PlaybackManager.c"
				GeeHashMap* _tmp24_;
				gint _tmp25_;
				gpointer _tmp26_;
#line 383 "../src/PlaybackManager.vala"
				_tmp24_ = self->priv->_current_shuffled;
#line 383 "../src/PlaybackManager.vala"
				_tmp25_ = self->priv->_current_shuffled_index;
#line 383 "../src/PlaybackManager.vala"
				_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, (gpointer) ((gintptr) _tmp25_));
#line 383 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 383 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp26_;
#line 2144 "PlaybackManager.c"
			} else {
				gint _tmp27_;
#line 384 "../src/PlaybackManager.vala"
				_tmp27_ = self->priv->_current_shuffled_index;
#line 384 "../src/PlaybackManager.vala"
				if (_tmp27_ == 0) {
#line 2151 "PlaybackManager.c"
					NoiseSettingsMain* _tmp28_;
					NoiseSettingsRepeat _tmp29_;
					NoiseSettingsRepeat _tmp30_;
					GeeHashMap* _tmp34_;
					gint _tmp35_;
					gpointer _tmp36_;
#line 385 "../src/PlaybackManager.vala"
					_tmp28_ = main_settings;
#line 385 "../src/PlaybackManager.vala"
					_tmp29_ = noise_settings_main_get_repeat_mode (_tmp28_);
#line 385 "../src/PlaybackManager.vala"
					_tmp30_ = _tmp29_;
#line 385 "../src/PlaybackManager.vala"
					if (_tmp30_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2166 "PlaybackManager.c"
						GeeHashMap* _tmp31_;
						gint _tmp32_;
						gint _tmp33_;
#line 386 "../src/PlaybackManager.vala"
						_tmp31_ = self->priv->_current_shuffled;
#line 386 "../src/PlaybackManager.vala"
						_tmp32_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp31_);
#line 386 "../src/PlaybackManager.vala"
						_tmp33_ = _tmp32_;
#line 386 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp33_ - 1;
#line 2178 "PlaybackManager.c"
					} else {
#line 388 "../src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 389 "../src/PlaybackManager.vala"
						result = NULL;
#line 389 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 389 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 389 "../src/PlaybackManager.vala"
						return result;
#line 2190 "PlaybackManager.c"
					}
#line 392 "../src/PlaybackManager.vala"
					_tmp34_ = self->priv->_current_shuffled;
#line 392 "../src/PlaybackManager.vala"
					_tmp35_ = self->priv->_current_shuffled_index;
#line 392 "../src/PlaybackManager.vala"
					_tmp36_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp34_, (gpointer) ((gintptr) _tmp35_));
#line 392 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 392 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp36_;
#line 2202 "PlaybackManager.c"
				} else {
					gboolean _tmp37_ = FALSE;
					gint _tmp38_;
#line 393 "../src/PlaybackManager.vala"
					_tmp38_ = self->priv->_current_shuffled_index;
#line 393 "../src/PlaybackManager.vala"
					if (_tmp38_ > 0) {
#line 2210 "PlaybackManager.c"
						gint _tmp39_;
						GeeHashMap* _tmp40_;
						gint _tmp41_;
						gint _tmp42_;
#line 393 "../src/PlaybackManager.vala"
						_tmp39_ = self->priv->_current_shuffled_index;
#line 393 "../src/PlaybackManager.vala"
						_tmp40_ = self->priv->_current_shuffled;
#line 393 "../src/PlaybackManager.vala"
						_tmp41_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp40_);
#line 393 "../src/PlaybackManager.vala"
						_tmp42_ = _tmp41_;
#line 393 "../src/PlaybackManager.vala"
						_tmp37_ = _tmp39_ < _tmp42_;
#line 2225 "PlaybackManager.c"
					} else {
#line 393 "../src/PlaybackManager.vala"
						_tmp37_ = FALSE;
#line 2229 "PlaybackManager.c"
					}
#line 393 "../src/PlaybackManager.vala"
					if (_tmp37_) {
#line 2233 "PlaybackManager.c"
						gboolean _tmp43_ = FALSE;
						NoiseSettingsMain* _tmp44_;
						NoiseSettingsRepeat _tmp45_;
						NoiseSettingsRepeat _tmp46_;
						GeeHashMap* _tmp98_;
						gint _tmp99_;
						gpointer _tmp100_;
#line 395 "../src/PlaybackManager.vala"
						_tmp44_ = main_settings;
#line 395 "../src/PlaybackManager.vala"
						_tmp45_ = noise_settings_main_get_repeat_mode (_tmp44_);
#line 395 "../src/PlaybackManager.vala"
						_tmp46_ = _tmp45_;
#line 395 "../src/PlaybackManager.vala"
						if (_tmp46_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2249 "PlaybackManager.c"
							GeeHashMap* _tmp47_;
							gint _tmp48_;
							gpointer _tmp49_;
							NoiseMedia* _tmp50_;
							const gchar* _tmp51_;
							const gchar* _tmp52_;
							GeeHashMap* _tmp53_;
							gint _tmp54_;
							gpointer _tmp55_;
							NoiseMedia* _tmp56_;
							const gchar* _tmp57_;
							const gchar* _tmp58_;
#line 395 "../src/PlaybackManager.vala"
							_tmp47_ = self->priv->_current_shuffled;
#line 395 "../src/PlaybackManager.vala"
							_tmp48_ = self->priv->_current_shuffled_index;
#line 395 "../src/PlaybackManager.vala"
							_tmp49_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp47_, (gpointer) ((gintptr) (_tmp48_ - 1)));
#line 395 "../src/PlaybackManager.vala"
							_tmp50_ = (NoiseMedia*) _tmp49_;
#line 395 "../src/PlaybackManager.vala"
							_tmp51_ = noise_media_get_artist (_tmp50_);
#line 395 "../src/PlaybackManager.vala"
							_tmp52_ = _tmp51_;
#line 395 "../src/PlaybackManager.vala"
							_tmp53_ = self->priv->_current_shuffled;
#line 395 "../src/PlaybackManager.vala"
							_tmp54_ = self->priv->_current_shuffled_index;
#line 395 "../src/PlaybackManager.vala"
							_tmp55_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp53_, (gpointer) ((gintptr) _tmp54_));
#line 395 "../src/PlaybackManager.vala"
							_tmp56_ = (NoiseMedia*) _tmp55_;
#line 395 "../src/PlaybackManager.vala"
							_tmp57_ = noise_media_get_artist (_tmp56_);
#line 395 "../src/PlaybackManager.vala"
							_tmp58_ = _tmp57_;
#line 395 "../src/PlaybackManager.vala"
							_tmp43_ = g_strcmp0 (_tmp52_, _tmp58_) != 0;
#line 395 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp56_);
#line 395 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp50_);
#line 2292 "PlaybackManager.c"
						} else {
#line 395 "../src/PlaybackManager.vala"
							_tmp43_ = FALSE;
#line 2296 "PlaybackManager.c"
						}
#line 395 "../src/PlaybackManager.vala"
						if (_tmp43_) {
#line 396 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2302 "PlaybackManager.c"
								GeeHashMap* _tmp59_;
								gint _tmp60_;
								gpointer _tmp61_;
								NoiseMedia* _tmp62_;
								const gchar* _tmp63_;
								const gchar* _tmp64_;
								NoiseMedia* _tmp65_;
								const gchar* _tmp66_;
								const gchar* _tmp67_;
								gboolean _tmp68_;
								gint _tmp69_;
#line 396 "../src/PlaybackManager.vala"
								_tmp59_ = self->priv->_current_shuffled;
#line 396 "../src/PlaybackManager.vala"
								_tmp60_ = self->priv->_current_shuffled_index;
#line 396 "../src/PlaybackManager.vala"
								_tmp61_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp59_, (gpointer) ((gintptr) (_tmp60_ + 1)));
#line 396 "../src/PlaybackManager.vala"
								_tmp62_ = (NoiseMedia*) _tmp61_;
#line 396 "../src/PlaybackManager.vala"
								_tmp63_ = noise_media_get_artist (_tmp62_);
#line 396 "../src/PlaybackManager.vala"
								_tmp64_ = _tmp63_;
#line 396 "../src/PlaybackManager.vala"
								_tmp65_ = self->priv->_current_media;
#line 396 "../src/PlaybackManager.vala"
								_tmp66_ = noise_media_get_artist (_tmp65_);
#line 396 "../src/PlaybackManager.vala"
								_tmp67_ = _tmp66_;
#line 396 "../src/PlaybackManager.vala"
								_tmp68_ = !(g_strcmp0 (_tmp64_, _tmp67_) == 0);
#line 396 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp62_);
#line 396 "../src/PlaybackManager.vala"
								if (_tmp68_) {
#line 396 "../src/PlaybackManager.vala"
									break;
#line 2340 "PlaybackManager.c"
								}
#line 397 "../src/PlaybackManager.vala"
								_tmp69_ = self->priv->_current_shuffled_index;
#line 397 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp69_ + 1;
#line 2346 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp70_ = FALSE;
							NoiseSettingsMain* _tmp71_;
							NoiseSettingsRepeat _tmp72_;
							NoiseSettingsRepeat _tmp73_;
#line 398 "../src/PlaybackManager.vala"
							_tmp71_ = main_settings;
#line 398 "../src/PlaybackManager.vala"
							_tmp72_ = noise_settings_main_get_repeat_mode (_tmp71_);
#line 398 "../src/PlaybackManager.vala"
							_tmp73_ = _tmp72_;
#line 398 "../src/PlaybackManager.vala"
							if (_tmp73_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2361 "PlaybackManager.c"
								GeeHashMap* _tmp74_;
								gint _tmp75_;
								gpointer _tmp76_;
								NoiseMedia* _tmp77_;
								const gchar* _tmp78_;
								const gchar* _tmp79_;
								GeeHashMap* _tmp80_;
								gint _tmp81_;
								gpointer _tmp82_;
								NoiseMedia* _tmp83_;
								const gchar* _tmp84_;
								const gchar* _tmp85_;
#line 398 "../src/PlaybackManager.vala"
								_tmp74_ = self->priv->_current_shuffled;
#line 398 "../src/PlaybackManager.vala"
								_tmp75_ = self->priv->_current_shuffled_index;
#line 398 "../src/PlaybackManager.vala"
								_tmp76_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp74_, (gpointer) ((gintptr) (_tmp75_ - 1)));
#line 398 "../src/PlaybackManager.vala"
								_tmp77_ = (NoiseMedia*) _tmp76_;
#line 398 "../src/PlaybackManager.vala"
								_tmp78_ = noise_media_get_album (_tmp77_);
#line 398 "../src/PlaybackManager.vala"
								_tmp79_ = _tmp78_;
#line 398 "../src/PlaybackManager.vala"
								_tmp80_ = self->priv->_current_shuffled;
#line 398 "../src/PlaybackManager.vala"
								_tmp81_ = self->priv->_current_shuffled_index;
#line 398 "../src/PlaybackManager.vala"
								_tmp82_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp80_, (gpointer) ((gintptr) _tmp81_));
#line 398 "../src/PlaybackManager.vala"
								_tmp83_ = (NoiseMedia*) _tmp82_;
#line 398 "../src/PlaybackManager.vala"
								_tmp84_ = noise_media_get_album (_tmp83_);
#line 398 "../src/PlaybackManager.vala"
								_tmp85_ = _tmp84_;
#line 398 "../src/PlaybackManager.vala"
								_tmp70_ = g_strcmp0 (_tmp79_, _tmp85_) != 0;
#line 398 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp83_);
#line 398 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp77_);
#line 2404 "PlaybackManager.c"
							} else {
#line 398 "../src/PlaybackManager.vala"
								_tmp70_ = FALSE;
#line 2408 "PlaybackManager.c"
							}
#line 398 "../src/PlaybackManager.vala"
							if (_tmp70_) {
#line 399 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2414 "PlaybackManager.c"
									GeeHashMap* _tmp86_;
									gint _tmp87_;
									gpointer _tmp88_;
									NoiseMedia* _tmp89_;
									const gchar* _tmp90_;
									const gchar* _tmp91_;
									NoiseMedia* _tmp92_;
									const gchar* _tmp93_;
									const gchar* _tmp94_;
									gboolean _tmp95_;
									gint _tmp96_;
#line 399 "../src/PlaybackManager.vala"
									_tmp86_ = self->priv->_current_shuffled;
#line 399 "../src/PlaybackManager.vala"
									_tmp87_ = self->priv->_current_shuffled_index;
#line 399 "../src/PlaybackManager.vala"
									_tmp88_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp86_, (gpointer) ((gintptr) (_tmp87_ + 1)));
#line 399 "../src/PlaybackManager.vala"
									_tmp89_ = (NoiseMedia*) _tmp88_;
#line 399 "../src/PlaybackManager.vala"
									_tmp90_ = noise_media_get_album (_tmp89_);
#line 399 "../src/PlaybackManager.vala"
									_tmp91_ = _tmp90_;
#line 399 "../src/PlaybackManager.vala"
									_tmp92_ = self->priv->_current_media;
#line 399 "../src/PlaybackManager.vala"
									_tmp93_ = noise_media_get_album (_tmp92_);
#line 399 "../src/PlaybackManager.vala"
									_tmp94_ = _tmp93_;
#line 399 "../src/PlaybackManager.vala"
									_tmp95_ = !(g_strcmp0 (_tmp91_, _tmp94_) == 0);
#line 399 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp89_);
#line 399 "../src/PlaybackManager.vala"
									if (_tmp95_) {
#line 399 "../src/PlaybackManager.vala"
										break;
#line 2452 "PlaybackManager.c"
									}
#line 400 "../src/PlaybackManager.vala"
									_tmp96_ = self->priv->_current_shuffled_index;
#line 400 "../src/PlaybackManager.vala"
									self->priv->_current_shuffled_index = _tmp96_ + 1;
#line 2458 "PlaybackManager.c"
								}
							} else {
								gint _tmp97_;
#line 402 "../src/PlaybackManager.vala"
								_tmp97_ = self->priv->_current_shuffled_index;
#line 402 "../src/PlaybackManager.vala"
								self->priv->_current_shuffled_index = _tmp97_ - 1;
#line 2466 "PlaybackManager.c"
							}
						}
#line 404 "../src/PlaybackManager.vala"
						_tmp98_ = self->priv->_current_shuffled;
#line 404 "../src/PlaybackManager.vala"
						_tmp99_ = self->priv->_current_shuffled_index;
#line 404 "../src/PlaybackManager.vala"
						_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp98_, (gpointer) ((gintptr) _tmp99_));
#line 404 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 404 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp100_;
#line 2479 "PlaybackManager.c"
					} else {
						GeeHashMap* _tmp101_;
						gint _tmp102_;
						gint _tmp103_;
						GeeHashMap* _tmp104_;
						gint _tmp105_;
						gpointer _tmp106_;
#line 406 "../src/PlaybackManager.vala"
						_tmp101_ = self->priv->_current_shuffled;
#line 406 "../src/PlaybackManager.vala"
						_tmp102_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp101_);
#line 406 "../src/PlaybackManager.vala"
						_tmp103_ = _tmp102_;
#line 406 "../src/PlaybackManager.vala"
						self->priv->_current_shuffled_index = _tmp103_ - 1;
#line 407 "../src/PlaybackManager.vala"
						_tmp104_ = self->priv->_current_shuffled;
#line 407 "../src/PlaybackManager.vala"
						_tmp105_ = self->priv->_current_shuffled_index;
#line 407 "../src/PlaybackManager.vala"
						_tmp106_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp104_, (gpointer) ((gintptr) _tmp105_));
#line 407 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 407 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp106_;
#line 2505 "PlaybackManager.c"
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp107_;
#line 410 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = FALSE;
#line 412 "../src/PlaybackManager.vala"
		_tmp107_ = self->priv->_current_media;
#line 412 "../src/PlaybackManager.vala"
		if (_tmp107_ == NULL) {
#line 2518 "PlaybackManager.c"
			GeeHashMap* _tmp108_;
			gint _tmp109_;
			gint _tmp110_;
			GeeHashMap* _tmp111_;
			gint _tmp112_;
			gpointer _tmp113_;
#line 413 "../src/PlaybackManager.vala"
			_tmp108_ = self->priv->_current;
#line 413 "../src/PlaybackManager.vala"
			_tmp109_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp108_);
#line 413 "../src/PlaybackManager.vala"
			_tmp110_ = _tmp109_;
#line 413 "../src/PlaybackManager.vala"
			self->priv->_current_index = _tmp110_ - 1;
#line 414 "../src/PlaybackManager.vala"
			_tmp111_ = self->priv->_current;
#line 414 "../src/PlaybackManager.vala"
			_tmp112_ = self->priv->_current_index;
#line 414 "../src/PlaybackManager.vala"
			_tmp113_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp111_, (gpointer) ((gintptr) _tmp112_));
#line 414 "../src/PlaybackManager.vala"
			_g_object_unref0 (rv);
#line 414 "../src/PlaybackManager.vala"
			rv = (NoiseMedia*) _tmp113_;
#line 2543 "PlaybackManager.c"
		} else {
			NoiseSettingsMain* _tmp114_;
			NoiseSettingsRepeat _tmp115_;
			NoiseSettingsRepeat _tmp116_;
#line 415 "../src/PlaybackManager.vala"
			_tmp114_ = main_settings;
#line 415 "../src/PlaybackManager.vala"
			_tmp115_ = noise_settings_main_get_repeat_mode (_tmp114_);
#line 415 "../src/PlaybackManager.vala"
			_tmp116_ = _tmp115_;
#line 415 "../src/PlaybackManager.vala"
			if (_tmp116_ == NOISE_SETTINGS_REPEAT_MEDIA) {
#line 2556 "PlaybackManager.c"
				GeeHashMap* _tmp117_;
				gint _tmp118_;
				gpointer _tmp119_;
#line 416 "../src/PlaybackManager.vala"
				_tmp117_ = self->priv->_current;
#line 416 "../src/PlaybackManager.vala"
				_tmp118_ = self->priv->_current_index;
#line 416 "../src/PlaybackManager.vala"
				_tmp119_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp117_, (gpointer) ((gintptr) _tmp118_));
#line 416 "../src/PlaybackManager.vala"
				_g_object_unref0 (rv);
#line 416 "../src/PlaybackManager.vala"
				rv = (NoiseMedia*) _tmp119_;
#line 2570 "PlaybackManager.c"
			} else {
				gint _tmp120_;
#line 417 "../src/PlaybackManager.vala"
				_tmp120_ = self->priv->_current_index;
#line 417 "../src/PlaybackManager.vala"
				if (_tmp120_ == 0) {
#line 2577 "PlaybackManager.c"
					NoiseSettingsMain* _tmp121_;
					NoiseSettingsRepeat _tmp122_;
					NoiseSettingsRepeat _tmp123_;
					GeeHashMap* _tmp127_;
					gint _tmp128_;
					gpointer _tmp129_;
#line 418 "../src/PlaybackManager.vala"
					_tmp121_ = main_settings;
#line 418 "../src/PlaybackManager.vala"
					_tmp122_ = noise_settings_main_get_repeat_mode (_tmp121_);
#line 418 "../src/PlaybackManager.vala"
					_tmp123_ = _tmp122_;
#line 418 "../src/PlaybackManager.vala"
					if (_tmp123_ == NOISE_SETTINGS_REPEAT_ALL) {
#line 2592 "PlaybackManager.c"
						GeeHashMap* _tmp124_;
						gint _tmp125_;
						gint _tmp126_;
#line 419 "../src/PlaybackManager.vala"
						_tmp124_ = self->priv->_current;
#line 419 "../src/PlaybackManager.vala"
						_tmp125_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp124_);
#line 419 "../src/PlaybackManager.vala"
						_tmp126_ = _tmp125_;
#line 419 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp126_ - 1;
#line 2604 "PlaybackManager.c"
					} else {
#line 421 "../src/PlaybackManager.vala"
						noise_playback_manager_stop_playback (self);
#line 422 "../src/PlaybackManager.vala"
						result = NULL;
#line 422 "../src/PlaybackManager.vala"
						_g_object_unref0 (main_settings);
#line 422 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 422 "../src/PlaybackManager.vala"
						return result;
#line 2616 "PlaybackManager.c"
					}
#line 425 "../src/PlaybackManager.vala"
					_tmp127_ = self->priv->_current;
#line 425 "../src/PlaybackManager.vala"
					_tmp128_ = self->priv->_current_index;
#line 425 "../src/PlaybackManager.vala"
					_tmp129_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp127_, (gpointer) ((gintptr) _tmp128_));
#line 425 "../src/PlaybackManager.vala"
					_g_object_unref0 (rv);
#line 425 "../src/PlaybackManager.vala"
					rv = (NoiseMedia*) _tmp129_;
#line 2628 "PlaybackManager.c"
				} else {
					gboolean _tmp130_ = FALSE;
					gint _tmp131_;
#line 426 "../src/PlaybackManager.vala"
					_tmp131_ = self->priv->_current_index;
#line 426 "../src/PlaybackManager.vala"
					if (_tmp131_ > 0) {
#line 2636 "PlaybackManager.c"
						gint _tmp132_;
						GeeHashMap* _tmp133_;
						gint _tmp134_;
						gint _tmp135_;
#line 426 "../src/PlaybackManager.vala"
						_tmp132_ = self->priv->_current_index;
#line 426 "../src/PlaybackManager.vala"
						_tmp133_ = self->priv->_current;
#line 426 "../src/PlaybackManager.vala"
						_tmp134_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp133_);
#line 426 "../src/PlaybackManager.vala"
						_tmp135_ = _tmp134_;
#line 426 "../src/PlaybackManager.vala"
						_tmp130_ = _tmp132_ < _tmp135_;
#line 2651 "PlaybackManager.c"
					} else {
#line 426 "../src/PlaybackManager.vala"
						_tmp130_ = FALSE;
#line 2655 "PlaybackManager.c"
					}
#line 426 "../src/PlaybackManager.vala"
					if (_tmp130_) {
#line 2659 "PlaybackManager.c"
						gboolean _tmp136_ = FALSE;
						NoiseSettingsMain* _tmp137_;
						NoiseSettingsRepeat _tmp138_;
						NoiseSettingsRepeat _tmp139_;
						GeeHashMap* _tmp191_;
						gint _tmp192_;
						gpointer _tmp193_;
#line 428 "../src/PlaybackManager.vala"
						_tmp137_ = main_settings;
#line 428 "../src/PlaybackManager.vala"
						_tmp138_ = noise_settings_main_get_repeat_mode (_tmp137_);
#line 428 "../src/PlaybackManager.vala"
						_tmp139_ = _tmp138_;
#line 428 "../src/PlaybackManager.vala"
						if (_tmp139_ == NOISE_SETTINGS_REPEAT_ARTIST) {
#line 2675 "PlaybackManager.c"
							GeeHashMap* _tmp140_;
							gint _tmp141_;
							gpointer _tmp142_;
							NoiseMedia* _tmp143_;
							const gchar* _tmp144_;
							const gchar* _tmp145_;
							GeeHashMap* _tmp146_;
							gint _tmp147_;
							gpointer _tmp148_;
							NoiseMedia* _tmp149_;
							const gchar* _tmp150_;
							const gchar* _tmp151_;
#line 428 "../src/PlaybackManager.vala"
							_tmp140_ = self->priv->_current;
#line 428 "../src/PlaybackManager.vala"
							_tmp141_ = self->priv->_current_index;
#line 428 "../src/PlaybackManager.vala"
							_tmp142_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp140_, (gpointer) ((gintptr) (_tmp141_ - 1)));
#line 428 "../src/PlaybackManager.vala"
							_tmp143_ = (NoiseMedia*) _tmp142_;
#line 428 "../src/PlaybackManager.vala"
							_tmp144_ = noise_media_get_artist (_tmp143_);
#line 428 "../src/PlaybackManager.vala"
							_tmp145_ = _tmp144_;
#line 428 "../src/PlaybackManager.vala"
							_tmp146_ = self->priv->_current;
#line 428 "../src/PlaybackManager.vala"
							_tmp147_ = self->priv->_current_index;
#line 428 "../src/PlaybackManager.vala"
							_tmp148_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp146_, (gpointer) ((gintptr) _tmp147_));
#line 428 "../src/PlaybackManager.vala"
							_tmp149_ = (NoiseMedia*) _tmp148_;
#line 428 "../src/PlaybackManager.vala"
							_tmp150_ = noise_media_get_artist (_tmp149_);
#line 428 "../src/PlaybackManager.vala"
							_tmp151_ = _tmp150_;
#line 428 "../src/PlaybackManager.vala"
							_tmp136_ = g_strcmp0 (_tmp145_, _tmp151_) != 0;
#line 428 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp149_);
#line 428 "../src/PlaybackManager.vala"
							_g_object_unref0 (_tmp143_);
#line 2718 "PlaybackManager.c"
						} else {
#line 428 "../src/PlaybackManager.vala"
							_tmp136_ = FALSE;
#line 2722 "PlaybackManager.c"
						}
#line 428 "../src/PlaybackManager.vala"
						if (_tmp136_) {
#line 429 "../src/PlaybackManager.vala"
							while (TRUE) {
#line 2728 "PlaybackManager.c"
								GeeHashMap* _tmp152_;
								gint _tmp153_;
								gpointer _tmp154_;
								NoiseMedia* _tmp155_;
								const gchar* _tmp156_;
								const gchar* _tmp157_;
								NoiseMedia* _tmp158_;
								const gchar* _tmp159_;
								const gchar* _tmp160_;
								gboolean _tmp161_;
								gint _tmp162_;
#line 429 "../src/PlaybackManager.vala"
								_tmp152_ = self->priv->_current;
#line 429 "../src/PlaybackManager.vala"
								_tmp153_ = self->priv->_current_index;
#line 429 "../src/PlaybackManager.vala"
								_tmp154_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp152_, (gpointer) ((gintptr) (_tmp153_ + 1)));
#line 429 "../src/PlaybackManager.vala"
								_tmp155_ = (NoiseMedia*) _tmp154_;
#line 429 "../src/PlaybackManager.vala"
								_tmp156_ = noise_media_get_artist (_tmp155_);
#line 429 "../src/PlaybackManager.vala"
								_tmp157_ = _tmp156_;
#line 429 "../src/PlaybackManager.vala"
								_tmp158_ = self->priv->_current_media;
#line 429 "../src/PlaybackManager.vala"
								_tmp159_ = noise_media_get_artist (_tmp158_);
#line 429 "../src/PlaybackManager.vala"
								_tmp160_ = _tmp159_;
#line 429 "../src/PlaybackManager.vala"
								_tmp161_ = !(g_strcmp0 (_tmp157_, _tmp160_) == 0);
#line 429 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp155_);
#line 429 "../src/PlaybackManager.vala"
								if (_tmp161_) {
#line 429 "../src/PlaybackManager.vala"
									break;
#line 2766 "PlaybackManager.c"
								}
#line 430 "../src/PlaybackManager.vala"
								_tmp162_ = self->priv->_current_index;
#line 430 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp162_ + 1;
#line 2772 "PlaybackManager.c"
							}
						} else {
							gboolean _tmp163_ = FALSE;
							NoiseSettingsMain* _tmp164_;
							NoiseSettingsRepeat _tmp165_;
							NoiseSettingsRepeat _tmp166_;
#line 431 "../src/PlaybackManager.vala"
							_tmp164_ = main_settings;
#line 431 "../src/PlaybackManager.vala"
							_tmp165_ = noise_settings_main_get_repeat_mode (_tmp164_);
#line 431 "../src/PlaybackManager.vala"
							_tmp166_ = _tmp165_;
#line 431 "../src/PlaybackManager.vala"
							if (_tmp166_ == NOISE_SETTINGS_REPEAT_ALBUM) {
#line 2787 "PlaybackManager.c"
								GeeHashMap* _tmp167_;
								gint _tmp168_;
								gpointer _tmp169_;
								NoiseMedia* _tmp170_;
								const gchar* _tmp171_;
								const gchar* _tmp172_;
								GeeHashMap* _tmp173_;
								gint _tmp174_;
								gpointer _tmp175_;
								NoiseMedia* _tmp176_;
								const gchar* _tmp177_;
								const gchar* _tmp178_;
#line 431 "../src/PlaybackManager.vala"
								_tmp167_ = self->priv->_current;
#line 431 "../src/PlaybackManager.vala"
								_tmp168_ = self->priv->_current_index;
#line 431 "../src/PlaybackManager.vala"
								_tmp169_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp167_, (gpointer) ((gintptr) (_tmp168_ - 1)));
#line 431 "../src/PlaybackManager.vala"
								_tmp170_ = (NoiseMedia*) _tmp169_;
#line 431 "../src/PlaybackManager.vala"
								_tmp171_ = noise_media_get_album (_tmp170_);
#line 431 "../src/PlaybackManager.vala"
								_tmp172_ = _tmp171_;
#line 431 "../src/PlaybackManager.vala"
								_tmp173_ = self->priv->_current;
#line 431 "../src/PlaybackManager.vala"
								_tmp174_ = self->priv->_current_index;
#line 431 "../src/PlaybackManager.vala"
								_tmp175_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp173_, (gpointer) ((gintptr) _tmp174_));
#line 431 "../src/PlaybackManager.vala"
								_tmp176_ = (NoiseMedia*) _tmp175_;
#line 431 "../src/PlaybackManager.vala"
								_tmp177_ = noise_media_get_album (_tmp176_);
#line 431 "../src/PlaybackManager.vala"
								_tmp178_ = _tmp177_;
#line 431 "../src/PlaybackManager.vala"
								_tmp163_ = g_strcmp0 (_tmp172_, _tmp178_) != 0;
#line 431 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp176_);
#line 431 "../src/PlaybackManager.vala"
								_g_object_unref0 (_tmp170_);
#line 2830 "PlaybackManager.c"
							} else {
#line 431 "../src/PlaybackManager.vala"
								_tmp163_ = FALSE;
#line 2834 "PlaybackManager.c"
							}
#line 431 "../src/PlaybackManager.vala"
							if (_tmp163_) {
#line 432 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 2840 "PlaybackManager.c"
									GeeHashMap* _tmp179_;
									gint _tmp180_;
									gpointer _tmp181_;
									NoiseMedia* _tmp182_;
									const gchar* _tmp183_;
									const gchar* _tmp184_;
									NoiseMedia* _tmp185_;
									const gchar* _tmp186_;
									const gchar* _tmp187_;
									gboolean _tmp188_;
									gint _tmp189_;
#line 432 "../src/PlaybackManager.vala"
									_tmp179_ = self->priv->_current;
#line 432 "../src/PlaybackManager.vala"
									_tmp180_ = self->priv->_current_index;
#line 432 "../src/PlaybackManager.vala"
									_tmp181_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp179_, (gpointer) ((gintptr) (_tmp180_ + 1)));
#line 432 "../src/PlaybackManager.vala"
									_tmp182_ = (NoiseMedia*) _tmp181_;
#line 432 "../src/PlaybackManager.vala"
									_tmp183_ = noise_media_get_album (_tmp182_);
#line 432 "../src/PlaybackManager.vala"
									_tmp184_ = _tmp183_;
#line 432 "../src/PlaybackManager.vala"
									_tmp185_ = self->priv->_current_media;
#line 432 "../src/PlaybackManager.vala"
									_tmp186_ = noise_media_get_album (_tmp185_);
#line 432 "../src/PlaybackManager.vala"
									_tmp187_ = _tmp186_;
#line 432 "../src/PlaybackManager.vala"
									_tmp188_ = !(g_strcmp0 (_tmp184_, _tmp187_) == 0);
#line 432 "../src/PlaybackManager.vala"
									_g_object_unref0 (_tmp182_);
#line 432 "../src/PlaybackManager.vala"
									if (_tmp188_) {
#line 432 "../src/PlaybackManager.vala"
										break;
#line 2878 "PlaybackManager.c"
									}
#line 433 "../src/PlaybackManager.vala"
									_tmp189_ = self->priv->_current_index;
#line 433 "../src/PlaybackManager.vala"
									self->priv->_current_index = _tmp189_ + 1;
#line 2884 "PlaybackManager.c"
								}
							} else {
								gint _tmp190_;
#line 435 "../src/PlaybackManager.vala"
								_tmp190_ = self->priv->_current_index;
#line 435 "../src/PlaybackManager.vala"
								self->priv->_current_index = _tmp190_ - 1;
#line 2892 "PlaybackManager.c"
							}
						}
#line 438 "../src/PlaybackManager.vala"
						_tmp191_ = self->priv->_current;
#line 438 "../src/PlaybackManager.vala"
						_tmp192_ = self->priv->_current_index;
#line 438 "../src/PlaybackManager.vala"
						_tmp193_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp191_, (gpointer) ((gintptr) _tmp192_));
#line 438 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 438 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp193_;
#line 2905 "PlaybackManager.c"
					} else {
						NoiseLibrary* _tmp194_;
						NoiseLibrary* _tmp195_;
						GeeCollection* _tmp196_;
						GeeCollection* _tmp197_;
						GeeHashMap* _tmp198_;
						gint _tmp199_;
						gint _tmp200_;
						GeeHashMap* _tmp201_;
						gint _tmp202_;
						gpointer _tmp203_;
#line 440 "../src/PlaybackManager.vala"
						_tmp194_ = noise_playback_manager_get_library (self);
#line 440 "../src/PlaybackManager.vala"
						_tmp195_ = _tmp194_;
#line 440 "../src/PlaybackManager.vala"
						_tmp196_ = noise_library_get_medias (_tmp195_);
#line 440 "../src/PlaybackManager.vala"
						_tmp197_ = _tmp196_;
#line 440 "../src/PlaybackManager.vala"
						noise_playback_manager_queue_media (self, _tmp197_);
#line 440 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp197_);
#line 442 "../src/PlaybackManager.vala"
						_tmp198_ = self->priv->_current;
#line 442 "../src/PlaybackManager.vala"
						_tmp199_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp198_);
#line 442 "../src/PlaybackManager.vala"
						_tmp200_ = _tmp199_;
#line 442 "../src/PlaybackManager.vala"
						self->priv->_current_index = _tmp200_ - 1;
#line 443 "../src/PlaybackManager.vala"
						_tmp201_ = self->priv->_current;
#line 443 "../src/PlaybackManager.vala"
						_tmp202_ = self->priv->_current_index;
#line 443 "../src/PlaybackManager.vala"
						_tmp203_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp201_, (gpointer) ((gintptr) _tmp202_));
#line 443 "../src/PlaybackManager.vala"
						_g_object_unref0 (rv);
#line 443 "../src/PlaybackManager.vala"
						rv = (NoiseMedia*) _tmp203_;
#line 2947 "PlaybackManager.c"
					}
				}
			}
		}
	}
#line 447 "../src/PlaybackManager.vala"
	_tmp204_ = self->queue_playlist;
#line 447 "../src/PlaybackManager.vala"
	_tmp205_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp204_);
#line 447 "../src/PlaybackManager.vala"
	_tmp206_ = _tmp205_;
#line 447 "../src/PlaybackManager.vala"
	_tmp207_ = rv;
#line 447 "../src/PlaybackManager.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp206_, _tmp207_)) {
#line 448 "../src/PlaybackManager.vala"
		self->priv->_playing_queued_song = TRUE;
#line 2965 "PlaybackManager.c"
	}
#line 451 "../src/PlaybackManager.vala"
	if (play) {
#line 2969 "PlaybackManager.c"
		NoiseMedia* _tmp208_;
#line 452 "../src/PlaybackManager.vala"
		_tmp208_ = rv;
#line 452 "../src/PlaybackManager.vala"
		noise_playback_manager_play_media (self, _tmp208_);
#line 2975 "PlaybackManager.c"
	}
#line 455 "../src/PlaybackManager.vala"
	result = rv;
#line 455 "../src/PlaybackManager.vala"
	_g_object_unref0 (main_settings);
#line 455 "../src/PlaybackManager.vala"
	return result;
#line 2983 "PlaybackManager.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 458 "../src/PlaybackManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 2992 "PlaybackManager.c"
}


static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 458 "../src/PlaybackManager.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 458 "../src/PlaybackManager.vala"
	return _data10_;
#line 3003 "PlaybackManager.c"
}


static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 458 "../src/PlaybackManager.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 3014 "PlaybackManager.c"
		NoisePlaybackManager* self;
#line 458 "../src/PlaybackManager.vala"
		self = _data10_->self;
#line 458 "../src/PlaybackManager.vala"
		_g_object_unref0 (_data10_->m);
#line 458 "../src/PlaybackManager.vala"
		_g_object_unref0 (self);
#line 458 "../src/PlaybackManager.vala"
		g_slice_free (Block10Data, _data10_);
#line 3024 "PlaybackManager.c"
	}
}


static gboolean
__lambda33_ (Block10Data* _data10_)
{
	NoisePlaybackManager* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 539 "../src/PlaybackManager.vala"
	self = _data10_->self;
#line 540 "../src/PlaybackManager.vala"
	if (_data10_->m != NULL) {
#line 3039 "PlaybackManager.c"
		NoiseMedia* _tmp1_;
#line 540 "../src/PlaybackManager.vala"
		_tmp1_ = self->priv->_current_media;
#line 540 "../src/PlaybackManager.vala"
		_tmp0_ = _tmp1_ == _data10_->m;
#line 3045 "PlaybackManager.c"
	} else {
#line 540 "../src/PlaybackManager.vala"
		_tmp0_ = FALSE;
#line 3049 "PlaybackManager.c"
	}
#line 540 "../src/PlaybackManager.vala"
	if (_tmp0_) {
#line 3053 "PlaybackManager.c"
		NoiseHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		NoisePlayback* _tmp3_;
		guint _tmp4_;
#line 541 "../src/PlaybackManager.vala"
		_tmp2_ = self->history_playlist;
#line 541 "../src/PlaybackManager.vala"
		noise_playlist_add_media ((NoisePlaylist*) _tmp2_, _data10_->m);
#line 543 "../src/PlaybackManager.vala"
		_tmp3_ = self->player;
#line 543 "../src/PlaybackManager.vala"
		player_duration_s = (guint) (noise_playback_get_duration (_tmp3_) / NOISE_TIME_UTILS_NANO_INV);
#line 544 "../src/PlaybackManager.vala"
		_tmp4_ = player_duration_s;
#line 544 "../src/PlaybackManager.vala"
		if (_tmp4_ > ((guint) 1)) {
#line 3070 "PlaybackManager.c"
			gint delta_s = 0;
			guint _tmp5_;
			guint _tmp6_;
			guint _tmp7_;
			gint _tmp8_;
#line 545 "../src/PlaybackManager.vala"
			_tmp5_ = player_duration_s;
#line 545 "../src/PlaybackManager.vala"
			_tmp6_ = noise_media_get_length (_data10_->m);
#line 545 "../src/PlaybackManager.vala"
			_tmp7_ = _tmp6_;
#line 545 "../src/PlaybackManager.vala"
			delta_s = ((gint) _tmp5_) - ((gint) (_tmp7_ / NOISE_TIME_UTILS_MILI_INV));
#line 546 "../src/PlaybackManager.vala"
			_tmp8_ = delta_s;
#line 546 "../src/PlaybackManager.vala"
			if (fabs ((gdouble) _tmp8_) > ((gdouble) 3)) {
#line 3088 "PlaybackManager.c"
				guint _tmp9_;
				NoiseLibrary* _tmp10_;
				NoiseLibrary* _tmp11_;
#line 547 "../src/PlaybackManager.vala"
				_tmp9_ = player_duration_s;
#line 547 "../src/PlaybackManager.vala"
				noise_media_set_length (_data10_->m, (guint) (_tmp9_ * NOISE_TIME_UTILS_MILI_INV));
#line 548 "../src/PlaybackManager.vala"
				_tmp10_ = noise_playback_manager_get_library (self);
#line 548 "../src/PlaybackManager.vala"
				_tmp11_ = _tmp10_;
#line 548 "../src/PlaybackManager.vala"
				noise_library_update_media (_tmp11_, _data10_->m, FALSE, FALSE);
#line 3102 "PlaybackManager.c"
			}
		}
	}
#line 553 "../src/PlaybackManager.vala"
	result = FALSE;
#line 553 "../src/PlaybackManager.vala"
	return result;
#line 3110 "PlaybackManager.c"
}


static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
#line 539 "../src/PlaybackManager.vala"
	return result;
#line 3121 "PlaybackManager.c"
}


void
noise_playback_manager_play_media (NoisePlaybackManager* self,
                                   NoiseMedia* m)
{
	Block10Data* _data10_;
	NoiseMedia* _tmp0_;
	gint64 old_id = 0LL;
	NoiseMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	gboolean _tmp39_;
	GFile* _tmp44_;
	GFile* _tmp45_;
	NoisePlayback* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp58_ = FALSE;
	gint64 _tmp59_;
	gint64 _tmp60_;
	GError* _inner_error0_ = NULL;
#line 458 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/PlaybackManager.vala"
	g_return_if_fail (m != NULL);
#line 458 "../src/PlaybackManager.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 458 "../src/PlaybackManager.vala"
	_data10_->_ref_count_ = 1;
#line 458 "../src/PlaybackManager.vala"
	_data10_->self = g_object_ref (self);
#line 458 "../src/PlaybackManager.vala"
	_tmp0_ = _g_object_ref0 (m);
#line 458 "../src/PlaybackManager.vala"
	_g_object_unref0 (_data10_->m);
#line 458 "../src/PlaybackManager.vala"
	_data10_->m = _tmp0_;
#line 459 "../src/PlaybackManager.vala"
	old_id = (gint64) -1;
#line 462 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 462 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 3167 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 463 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 463 "../src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 463 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 463 "../src/PlaybackManager.vala"
		old_id = _tmp4_;
#line 3179 "PlaybackManager.c"
	}
#line 465 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, _data10_->m);
#line 469 "../src/PlaybackManager.vala"
	_tmp5_ = noise_media_get_location_unknown (_data10_->m);
#line 469 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 469 "../src/PlaybackManager.vala"
	if (_tmp6_) {
#line 3189 "PlaybackManager.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
#line 470 "../src/PlaybackManager.vala"
		_tmp7_ = noise_media_get_uri (_data10_->m);
#line 470 "../src/PlaybackManager.vala"
		_tmp8_ = _tmp7_;
#line 470 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 470 "../src/PlaybackManager.vala"
		_tmp10_ = g_file_new_for_uri (_tmp9_);
#line 470 "../src/PlaybackManager.vala"
		_tmp11_ = _tmp10_;
#line 470 "../src/PlaybackManager.vala"
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
#line 470 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp11_);
#line 470 "../src/PlaybackManager.vala"
		_g_free0 (_tmp9_);
#line 470 "../src/PlaybackManager.vala"
		if (_tmp12_) {
#line 471 "../src/PlaybackManager.vala"
			noise_media_set_location_unknown (_data10_->m, FALSE);
#line 472 "../src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_data10_->m, NULL);
#line 3218 "PlaybackManager.c"
		} else {
#line 475 "../src/PlaybackManager.vala"
			noise_playback_manager_stop_playback (self);
#line 476 "../src/PlaybackManager.vala"
			block10_data_unref (_data10_);
#line 476 "../src/PlaybackManager.vala"
			_data10_ = NULL;
#line 476 "../src/PlaybackManager.vala"
			return;
#line 3228 "PlaybackManager.c"
		}
	}
#line 480 "../src/PlaybackManager.vala"
	found = FALSE;
#line 3233 "PlaybackManager.c"
	{
		GeeTreeSet* _tmp13_;
#line 481 "../src/PlaybackManager.vala"
		_tmp13_ = self->priv->playbacks;
#line 481 "../src/PlaybackManager.vala"
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
#line 3240 "PlaybackManager.c"
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
#line 482 "../src/PlaybackManager.vala"
				_tmp14_ = self->priv->playbacks;
#line 482 "../src/PlaybackManager.vala"
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
#line 482 "../src/PlaybackManager.vala"
				_playback_it = _tmp15_;
#line 482 "../src/PlaybackManager.vala"
				while (TRUE) {
#line 3254 "PlaybackManager.c"
					GeeIterator* _tmp16_;
					NoisePlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					gboolean _tmp37_;
#line 482 "../src/PlaybackManager.vala"
					_tmp16_ = _playback_it;
#line 482 "../src/PlaybackManager.vala"
					if (!gee_iterator_next (_tmp16_)) {
#line 482 "../src/PlaybackManager.vala"
						break;
#line 3266 "PlaybackManager.c"
					}
#line 482 "../src/PlaybackManager.vala"
					_tmp17_ = _playback_it;
#line 482 "../src/PlaybackManager.vala"
					_tmp18_ = gee_iterator_get (_tmp17_);
#line 482 "../src/PlaybackManager.vala"
					playback = (NoisePlayback*) _tmp18_;
#line 3274 "PlaybackManager.c"
					{
						GeeIterator* _supported_uri_it = NULL;
						NoisePlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
#line 483 "../src/PlaybackManager.vala"
						_tmp19_ = playback;
#line 483 "../src/PlaybackManager.vala"
						_tmp20_ = noise_playback_get_supported_uri (_tmp19_);
#line 483 "../src/PlaybackManager.vala"
						_tmp21_ = _tmp20_;
#line 483 "../src/PlaybackManager.vala"
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 483 "../src/PlaybackManager.vala"
						_tmp23_ = _tmp22_;
#line 483 "../src/PlaybackManager.vala"
						_g_object_unref0 (_tmp21_);
#line 483 "../src/PlaybackManager.vala"
						_supported_uri_it = _tmp23_;
#line 483 "../src/PlaybackManager.vala"
						while (TRUE) {
#line 3298 "PlaybackManager.c"
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
#line 483 "../src/PlaybackManager.vala"
							_tmp24_ = _supported_uri_it;
#line 483 "../src/PlaybackManager.vala"
							if (!gee_iterator_next (_tmp24_)) {
#line 483 "../src/PlaybackManager.vala"
								break;
#line 3314 "PlaybackManager.c"
							}
#line 483 "../src/PlaybackManager.vala"
							_tmp25_ = _supported_uri_it;
#line 483 "../src/PlaybackManager.vala"
							_tmp26_ = gee_iterator_get (_tmp25_);
#line 483 "../src/PlaybackManager.vala"
							supported_uri = (gchar*) _tmp26_;
#line 484 "../src/PlaybackManager.vala"
							_tmp27_ = noise_media_get_uri (_data10_->m);
#line 484 "../src/PlaybackManager.vala"
							_tmp28_ = _tmp27_;
#line 484 "../src/PlaybackManager.vala"
							_tmp29_ = _tmp28_;
#line 484 "../src/PlaybackManager.vala"
							_tmp30_ = supported_uri;
#line 484 "../src/PlaybackManager.vala"
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
#line 484 "../src/PlaybackManager.vala"
							_g_free0 (_tmp29_);
#line 484 "../src/PlaybackManager.vala"
							if (_tmp31_) {
#line 3336 "PlaybackManager.c"
								NoisePlayback* _tmp32_;
								NoisePlayback* _tmp33_;
								NoisePlayback* _tmp34_;
								NoisePlayback* _tmp35_;
								gdouble _tmp36_;
#line 485 "../src/PlaybackManager.vala"
								_tmp32_ = self->player;
#line 485 "../src/PlaybackManager.vala"
								self->priv->saved_volume = noise_playback_get_volume (_tmp32_);
#line 486 "../src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
#line 487 "../src/PlaybackManager.vala"
								_tmp33_ = self->player;
#line 487 "../src/PlaybackManager.vala"
								noise_playback_set_state (_tmp33_, GST_STATE_NULL);
#line 488 "../src/PlaybackManager.vala"
								found = TRUE;
#line 489 "../src/PlaybackManager.vala"
								_tmp34_ = playback;
#line 489 "../src/PlaybackManager.vala"
								_tmp35_ = _g_object_ref0 (_tmp34_);
#line 489 "../src/PlaybackManager.vala"
								_g_object_unref0 (self->player);
#line 489 "../src/PlaybackManager.vala"
								self->player = _tmp35_;
#line 490 "../src/PlaybackManager.vala"
								_tmp36_ = self->priv->saved_volume;
#line 490 "../src/PlaybackManager.vala"
								noise_playback_manager_set_volume (self, _tmp36_);
#line 491 "../src/PlaybackManager.vala"
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
#line 492 "../src/PlaybackManager.vala"
								_g_free0 (supported_uri);
#line 492 "../src/PlaybackManager.vala"
								break;
#line 3372 "PlaybackManager.c"
							}
#line 483 "../src/PlaybackManager.vala"
							_g_free0 (supported_uri);
#line 3376 "PlaybackManager.c"
						}
#line 483 "../src/PlaybackManager.vala"
						_g_object_unref0 (_supported_uri_it);
#line 3380 "PlaybackManager.c"
					}
#line 495 "../src/PlaybackManager.vala"
					_tmp37_ = found;
#line 495 "../src/PlaybackManager.vala"
					if (_tmp37_ == TRUE) {
#line 496 "../src/PlaybackManager.vala"
						break;
#line 3388 "PlaybackManager.c"
					}
				}
#line 482 "../src/PlaybackManager.vala"
				_g_object_unref0 (_playback_it);
#line 3393 "PlaybackManager.c"
			}
		}
		__finally19:
		{
			GeeTreeSet* _tmp38_;
#line 481 "../src/PlaybackManager.vala"
			_tmp38_ = self->priv->playbacks;
#line 481 "../src/PlaybackManager.vala"
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
#line 3403 "PlaybackManager.c"
		}
#line 481 "../src/PlaybackManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/PlaybackManager.vala"
			block10_data_unref (_data10_);
#line 481 "../src/PlaybackManager.vala"
			_data10_ = NULL;
#line 481 "../src/PlaybackManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 481 "../src/PlaybackManager.vala"
			g_clear_error (&_inner_error0_);
#line 481 "../src/PlaybackManager.vala"
			return;
#line 3417 "PlaybackManager.c"
		}
	}
#line 500 "../src/PlaybackManager.vala"
	_tmp39_ = found;
#line 500 "../src/PlaybackManager.vala"
	if (!_tmp39_) {
#line 3424 "PlaybackManager.c"
		GThemedIcon* _tmp40_;
		GThemedIcon* _tmp41_;
		NoiseMedia* _tmp42_;
		NoiseMedia* _tmp43_;
#line 501 "../src/PlaybackManager.vala"
		_tmp40_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 501 "../src/PlaybackManager.vala"
		_tmp41_ = _tmp40_;
#line 501 "../src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp41_);
#line 501 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp41_);
#line 502 "../src/PlaybackManager.vala"
		_tmp42_ = noise_playback_manager_get_next (self, TRUE);
#line 502 "../src/PlaybackManager.vala"
		_tmp43_ = _tmp42_;
#line 502 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp43_);
#line 503 "../src/PlaybackManager.vala"
		block10_data_unref (_data10_);
#line 503 "../src/PlaybackManager.vala"
		_data10_ = NULL;
#line 503 "../src/PlaybackManager.vala"
		return;
#line 3449 "PlaybackManager.c"
	}
#line 507 "../src/PlaybackManager.vala"
	_tmp44_ = noise_media_get_file (_data10_->m);
#line 507 "../src/PlaybackManager.vala"
	_tmp45_ = _tmp44_;
#line 507 "../src/PlaybackManager.vala"
	if (!g_file_query_exists (_tmp45_, NULL)) {
#line 3457 "PlaybackManager.c"
		GThemedIcon* _tmp46_;
		GThemedIcon* _tmp47_;
		NoiseMedia* _tmp48_;
		NoiseMedia* _tmp49_;
#line 508 "../src/PlaybackManager.vala"
		_tmp46_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
#line 508 "../src/PlaybackManager.vala"
		_tmp47_ = _tmp46_;
#line 508 "../src/PlaybackManager.vala"
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp47_);
#line 508 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp47_);
#line 509 "../src/PlaybackManager.vala"
		noise_media_set_location_unknown (_data10_->m, TRUE);
#line 511 "../src/PlaybackManager.vala"
		_tmp48_ = noise_playback_manager_get_next (self, TRUE);
#line 511 "../src/PlaybackManager.vala"
		_tmp49_ = _tmp48_;
#line 511 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp49_);
#line 512 "../src/PlaybackManager.vala"
		block10_data_unref (_data10_);
#line 512 "../src/PlaybackManager.vala"
		_data10_ = NULL;
#line 512 "../src/PlaybackManager.vala"
		return;
#line 3484 "PlaybackManager.c"
	} else {
		gboolean _tmp50_ = FALSE;
		gboolean _tmp51_;
		gboolean _tmp52_;
#line 514 "../src/PlaybackManager.vala"
		_tmp51_ = noise_media_get_location_unknown (_data10_->m);
#line 514 "../src/PlaybackManager.vala"
		_tmp52_ = _tmp51_;
#line 514 "../src/PlaybackManager.vala"
		if (_tmp52_) {
#line 3495 "PlaybackManager.c"
			GIcon* _tmp53_;
			GIcon* _tmp54_;
#line 514 "../src/PlaybackManager.vala"
			_tmp53_ = noise_media_get_unique_status_image (_data10_->m);
#line 514 "../src/PlaybackManager.vala"
			_tmp54_ = _tmp53_;
#line 514 "../src/PlaybackManager.vala"
			_tmp50_ = _tmp54_ != NULL;
#line 3504 "PlaybackManager.c"
		} else {
#line 514 "../src/PlaybackManager.vala"
			_tmp50_ = FALSE;
#line 3508 "PlaybackManager.c"
		}
#line 514 "../src/PlaybackManager.vala"
		if (_tmp50_) {
#line 515 "../src/PlaybackManager.vala"
			noise_media_set_unique_status_image (_data10_->m, NULL);
#line 516 "../src/PlaybackManager.vala"
			noise_media_set_location_unknown (_data10_->m, FALSE);
#line 3516 "PlaybackManager.c"
		}
	}
#line 520 "../src/PlaybackManager.vala"
	noise_playback_manager_change_gains_thread (self);
#line 522 "../src/PlaybackManager.vala"
	_tmp55_ = self->player;
#line 522 "../src/PlaybackManager.vala"
	noise_playback_set_media (_tmp55_, _data10_->m);
#line 525 "../src/PlaybackManager.vala"
	_tmp56_ = self->priv->_playing;
#line 525 "../src/PlaybackManager.vala"
	if (!_tmp56_) {
#line 3529 "PlaybackManager.c"
		NoisePlayback* _tmp57_;
#line 526 "../src/PlaybackManager.vala"
		_tmp57_ = self->player;
#line 526 "../src/PlaybackManager.vala"
		noise_playback_pause (_tmp57_);
#line 3535 "PlaybackManager.c"
	}
#line 530 "../src/PlaybackManager.vala"
	_tmp59_ = noise_media_get_rowid (_data10_->m);
#line 530 "../src/PlaybackManager.vala"
	_tmp60_ = _tmp59_;
#line 530 "../src/PlaybackManager.vala"
	if (_tmp60_ >= ((gint64) 0)) {
#line 3543 "PlaybackManager.c"
		NoiseSettingsMain* _tmp61_;
		NoiseSettingsMain* _tmp62_;
#line 530 "../src/PlaybackManager.vala"
		_tmp61_ = noise_settings_main_get_default ();
#line 530 "../src/PlaybackManager.vala"
		_tmp62_ = _tmp61_;
#line 530 "../src/PlaybackManager.vala"
		_tmp58_ = !noise_settings_main_privacy_mode_enabled (_tmp62_);
#line 530 "../src/PlaybackManager.vala"
		_g_object_unref0 (_tmp62_);
#line 3554 "PlaybackManager.c"
	} else {
#line 530 "../src/PlaybackManager.vala"
		_tmp58_ = FALSE;
#line 3558 "PlaybackManager.c"
	}
#line 530 "../src/PlaybackManager.vala"
	if (_tmp58_) {
#line 3562 "PlaybackManager.c"
		GSettings* _tmp63_;
		GSettings* _tmp64_;
		gint64 _tmp65_;
		gint64 _tmp66_;
#line 531 "../src/PlaybackManager.vala"
		_tmp63_ = noise_app_get_saved_state ();
#line 531 "../src/PlaybackManager.vala"
		_tmp64_ = _tmp63_;
#line 531 "../src/PlaybackManager.vala"
		_tmp65_ = noise_media_get_rowid (_data10_->m);
#line 531 "../src/PlaybackManager.vala"
		_tmp66_ = _tmp65_;
#line 531 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp64_, "last-media-playing", _tmp66_);
#line 3577 "PlaybackManager.c"
	}
#line 534 "../src/PlaybackManager.vala"
	if (_data10_->m != NULL) {
#line 535 "../src/PlaybackManager.vala"
		g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data10_->m);
#line 3583 "PlaybackManager.c"
	}
#line 539 "../src/PlaybackManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda33__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 458 "../src/PlaybackManager.vala"
	block10_data_unref (_data10_);
#line 458 "../src/PlaybackManager.vala"
	_data10_ = NULL;
#line 3591 "PlaybackManager.c"
}


static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 3611 "PlaybackManager.c"
}


void
noise_playback_manager_change_gains_thread (NoisePlaybackManager* self)
{
	NoiseSettingsEqualizer* equalizer_settings = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 557 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 558 "../src/PlaybackManager.vala"
	_tmp0_ = noise_settings_equalizer_get_default ();
#line 558 "../src/PlaybackManager.vala"
	equalizer_settings = _tmp0_;
#line 559 "../src/PlaybackManager.vala"
	_tmp1_ = equalizer_settings;
#line 559 "../src/PlaybackManager.vala"
	_tmp2_ = noise_settings_equalizer_get_equalizer_enabled (_tmp1_);
#line 559 "../src/PlaybackManager.vala"
	_tmp3_ = _tmp2_;
#line 559 "../src/PlaybackManager.vala"
	if (_tmp3_) {
#line 3637 "PlaybackManager.c"
		gboolean automatic_enabled = FALSE;
		NoiseSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		NoiseSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 560 "../src/PlaybackManager.vala"
		_tmp4_ = equalizer_settings;
#line 560 "../src/PlaybackManager.vala"
		_tmp5_ = noise_settings_equalizer_get_auto_switch_preset (_tmp4_);
#line 560 "../src/PlaybackManager.vala"
		_tmp6_ = _tmp5_;
#line 560 "../src/PlaybackManager.vala"
		automatic_enabled = _tmp6_;
#line 561 "../src/PlaybackManager.vala"
		_tmp7_ = equalizer_settings;
#line 561 "../src/PlaybackManager.vala"
		_tmp8_ = noise_settings_equalizer_get_selected_preset (_tmp7_);
#line 561 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 561 "../src/PlaybackManager.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 561 "../src/PlaybackManager.vala"
		selected_preset = _tmp10_;
#line 3665 "PlaybackManager.c"
		{
			GeeIterator* _p_it = NULL;
			NoiseSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
#line 563 "../src/PlaybackManager.vala"
			_tmp11_ = equalizer_settings;
#line 563 "../src/PlaybackManager.vala"
			_tmp12_ = noise_settings_equalizer_get_presets (_tmp11_);
#line 563 "../src/PlaybackManager.vala"
			_tmp13_ = _tmp12_;
#line 563 "../src/PlaybackManager.vala"
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
#line 563 "../src/PlaybackManager.vala"
			_tmp15_ = _tmp14_;
#line 563 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp13_);
#line 563 "../src/PlaybackManager.vala"
			_p_it = _tmp15_;
#line 563 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3689 "PlaybackManager.c"
				GeeIterator* _tmp16_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				gboolean _tmp19_ = FALSE;
				NoiseEqualizerPreset* _tmp20_;
#line 563 "../src/PlaybackManager.vala"
				_tmp16_ = _p_it;
#line 563 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp16_)) {
#line 563 "../src/PlaybackManager.vala"
					break;
#line 3702 "PlaybackManager.c"
				}
#line 563 "../src/PlaybackManager.vala"
				_tmp17_ = _p_it;
#line 563 "../src/PlaybackManager.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 563 "../src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp18_;
#line 564 "../src/PlaybackManager.vala"
				_tmp20_ = p;
#line 564 "../src/PlaybackManager.vala"
				if (_tmp20_ != NULL) {
#line 3714 "PlaybackManager.c"
					NoiseMedia* _tmp21_;
#line 564 "../src/PlaybackManager.vala"
					_tmp21_ = self->priv->_current_media;
#line 564 "../src/PlaybackManager.vala"
					_tmp19_ = _tmp21_ != NULL;
#line 3720 "PlaybackManager.c"
				} else {
#line 564 "../src/PlaybackManager.vala"
					_tmp19_ = FALSE;
#line 3724 "PlaybackManager.c"
				}
#line 564 "../src/PlaybackManager.vala"
				if (_tmp19_) {
#line 3728 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean match_genre = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
					gboolean _tmp37_;
#line 565 "../src/PlaybackManager.vala"
					_tmp22_ = p;
#line 565 "../src/PlaybackManager.vala"
					_tmp23_ = noise_equalizer_preset_get_name (_tmp22_);
#line 565 "../src/PlaybackManager.vala"
					_tmp24_ = _tmp23_;
#line 565 "../src/PlaybackManager.vala"
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 565 "../src/PlaybackManager.vala"
					preset_name = _tmp25_;
#line 566 "../src/PlaybackManager.vala"
					_tmp26_ = self->priv->_current_media;
#line 566 "../src/PlaybackManager.vala"
					_tmp27_ = noise_media_get_genre (_tmp26_);
#line 566 "../src/PlaybackManager.vala"
					_tmp28_ = _tmp27_;
#line 566 "../src/PlaybackManager.vala"
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
#line 566 "../src/PlaybackManager.vala"
					media_genre = _tmp29_;
#line 568 "../src/PlaybackManager.vala"
					_tmp31_ = media_genre;
#line 568 "../src/PlaybackManager.vala"
					_tmp32_ = preset_name;
#line 568 "../src/PlaybackManager.vala"
					if (string_contains (_tmp31_, _tmp32_)) {
#line 568 "../src/PlaybackManager.vala"
						_tmp30_ = TRUE;
#line 3774 "PlaybackManager.c"
					} else {
						const gchar* _tmp33_;
						const gchar* _tmp34_;
#line 568 "../src/PlaybackManager.vala"
						_tmp33_ = preset_name;
#line 568 "../src/PlaybackManager.vala"
						_tmp34_ = media_genre;
#line 568 "../src/PlaybackManager.vala"
						_tmp30_ = string_contains (_tmp33_, _tmp34_);
#line 3784 "PlaybackManager.c"
					}
#line 568 "../src/PlaybackManager.vala"
					match_genre = _tmp30_;
#line 570 "../src/PlaybackManager.vala"
					_tmp37_ = automatic_enabled;
#line 570 "../src/PlaybackManager.vala"
					if (_tmp37_) {
#line 3792 "PlaybackManager.c"
						gboolean _tmp38_;
#line 570 "../src/PlaybackManager.vala"
						_tmp38_ = match_genre;
#line 570 "../src/PlaybackManager.vala"
						_tmp36_ = _tmp38_;
#line 3798 "PlaybackManager.c"
					} else {
#line 570 "../src/PlaybackManager.vala"
						_tmp36_ = FALSE;
#line 3802 "PlaybackManager.c"
					}
#line 570 "../src/PlaybackManager.vala"
					if (_tmp36_) {
#line 570 "../src/PlaybackManager.vala"
						_tmp35_ = TRUE;
#line 3808 "PlaybackManager.c"
					} else {
						gboolean _tmp39_ = FALSE;
						gboolean _tmp40_;
#line 571 "../src/PlaybackManager.vala"
						_tmp40_ = automatic_enabled;
#line 571 "../src/PlaybackManager.vala"
						if (!_tmp40_) {
#line 3816 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp41_;
							const gchar* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
#line 571 "../src/PlaybackManager.vala"
							_tmp41_ = p;
#line 571 "../src/PlaybackManager.vala"
							_tmp42_ = noise_equalizer_preset_get_name (_tmp41_);
#line 571 "../src/PlaybackManager.vala"
							_tmp43_ = _tmp42_;
#line 571 "../src/PlaybackManager.vala"
							_tmp44_ = selected_preset;
#line 571 "../src/PlaybackManager.vala"
							_tmp39_ = g_strcmp0 (_tmp43_, _tmp44_) == 0;
#line 3831 "PlaybackManager.c"
						} else {
#line 571 "../src/PlaybackManager.vala"
							_tmp39_ = FALSE;
#line 3835 "PlaybackManager.c"
						}
#line 571 "../src/PlaybackManager.vala"
						_tmp35_ = _tmp39_;
#line 3839 "PlaybackManager.c"
					}
#line 570 "../src/PlaybackManager.vala"
					if (_tmp35_) {
#line 3843 "PlaybackManager.c"
						{
							gint i = 0;
#line 572 "../src/PlaybackManager.vala"
							i = 0;
#line 3848 "PlaybackManager.c"
							{
								gboolean _tmp45_ = FALSE;
#line 572 "../src/PlaybackManager.vala"
								_tmp45_ = TRUE;
#line 572 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 3855 "PlaybackManager.c"
									gint _tmp47_;
									NoisePlayback* _tmp48_;
									gint _tmp49_;
									NoiseEqualizerPreset* _tmp50_;
									gint _tmp51_;
#line 572 "../src/PlaybackManager.vala"
									if (!_tmp45_) {
#line 3863 "PlaybackManager.c"
										gint _tmp46_;
#line 572 "../src/PlaybackManager.vala"
										_tmp46_ = i;
#line 572 "../src/PlaybackManager.vala"
										i = _tmp46_ + 1;
#line 3869 "PlaybackManager.c"
									}
#line 572 "../src/PlaybackManager.vala"
									_tmp45_ = FALSE;
#line 572 "../src/PlaybackManager.vala"
									_tmp47_ = i;
#line 572 "../src/PlaybackManager.vala"
									if (!(_tmp47_ < 10)) {
#line 572 "../src/PlaybackManager.vala"
										break;
#line 3879 "PlaybackManager.c"
									}
#line 573 "../src/PlaybackManager.vala"
									_tmp48_ = self->player;
#line 573 "../src/PlaybackManager.vala"
									_tmp49_ = i;
#line 573 "../src/PlaybackManager.vala"
									_tmp50_ = p;
#line 573 "../src/PlaybackManager.vala"
									_tmp51_ = i;
#line 573 "../src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp48_, _tmp49_, noise_equalizer_preset_get_gain (_tmp50_, _tmp51_));
#line 3891 "PlaybackManager.c"
								}
							}
						}
#line 576 "../src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 576 "../src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 576 "../src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 576 "../src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 576 "../src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 576 "../src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 576 "../src/PlaybackManager.vala"
						return;
#line 3909 "PlaybackManager.c"
					}
#line 564 "../src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 564 "../src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 3915 "PlaybackManager.c"
				}
#line 563 "../src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 3919 "PlaybackManager.c"
			}
#line 563 "../src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 3923 "PlaybackManager.c"
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp52_;
			GeeCollection* _tmp53_;
			GeeIterator* _tmp54_;
			GeeIterator* _tmp55_;
#line 581 "../src/PlaybackManager.vala"
			_tmp52_ = noise_equalizer_get_default_presets ();
#line 581 "../src/PlaybackManager.vala"
			_tmp53_ = _tmp52_;
#line 581 "../src/PlaybackManager.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 581 "../src/PlaybackManager.vala"
			_tmp55_ = _tmp54_;
#line 581 "../src/PlaybackManager.vala"
			_g_object_unref0 (_tmp53_);
#line 581 "../src/PlaybackManager.vala"
			_p_it = _tmp55_;
#line 581 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 3945 "PlaybackManager.c"
				GeeIterator* _tmp56_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp57_;
				gpointer _tmp58_;
				gboolean _tmp59_ = FALSE;
				NoiseEqualizerPreset* _tmp60_;
#line 581 "../src/PlaybackManager.vala"
				_tmp56_ = _p_it;
#line 581 "../src/PlaybackManager.vala"
				if (!gee_iterator_next (_tmp56_)) {
#line 581 "../src/PlaybackManager.vala"
					break;
#line 3958 "PlaybackManager.c"
				}
#line 581 "../src/PlaybackManager.vala"
				_tmp57_ = _p_it;
#line 581 "../src/PlaybackManager.vala"
				_tmp58_ = gee_iterator_get (_tmp57_);
#line 581 "../src/PlaybackManager.vala"
				p = (NoiseEqualizerPreset*) _tmp58_;
#line 582 "../src/PlaybackManager.vala"
				_tmp60_ = p;
#line 582 "../src/PlaybackManager.vala"
				if (_tmp60_ != NULL) {
#line 3970 "PlaybackManager.c"
					NoiseMedia* _tmp61_;
#line 582 "../src/PlaybackManager.vala"
					_tmp61_ = self->priv->_current_media;
#line 582 "../src/PlaybackManager.vala"
					_tmp59_ = _tmp61_ != NULL;
#line 3976 "PlaybackManager.c"
				} else {
#line 582 "../src/PlaybackManager.vala"
					_tmp59_ = FALSE;
#line 3980 "PlaybackManager.c"
				}
#line 582 "../src/PlaybackManager.vala"
				if (_tmp59_) {
#line 3984 "PlaybackManager.c"
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp62_;
					const gchar* _tmp63_;
					const gchar* _tmp64_;
					gchar* _tmp65_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp66_;
					const gchar* _tmp67_;
					const gchar* _tmp68_;
					gchar* _tmp69_;
					gboolean _tmp70_ = FALSE;
					const gchar* _tmp71_;
					const gchar* _tmp72_;
					gboolean match_genre = FALSE;
					gboolean _tmp75_ = FALSE;
					gboolean _tmp76_ = FALSE;
					gboolean _tmp77_;
#line 583 "../src/PlaybackManager.vala"
					_tmp62_ = p;
#line 583 "../src/PlaybackManager.vala"
					_tmp63_ = noise_equalizer_preset_get_name (_tmp62_);
#line 583 "../src/PlaybackManager.vala"
					_tmp64_ = _tmp63_;
#line 583 "../src/PlaybackManager.vala"
					_tmp65_ = g_utf8_strdown (_tmp64_, (gssize) -1);
#line 583 "../src/PlaybackManager.vala"
					preset_name = _tmp65_;
#line 584 "../src/PlaybackManager.vala"
					_tmp66_ = self->priv->_current_media;
#line 584 "../src/PlaybackManager.vala"
					_tmp67_ = noise_media_get_genre (_tmp66_);
#line 584 "../src/PlaybackManager.vala"
					_tmp68_ = _tmp67_;
#line 584 "../src/PlaybackManager.vala"
					_tmp69_ = g_utf8_strdown (_tmp68_, (gssize) -1);
#line 584 "../src/PlaybackManager.vala"
					media_genre = _tmp69_;
#line 586 "../src/PlaybackManager.vala"
					_tmp71_ = media_genre;
#line 586 "../src/PlaybackManager.vala"
					_tmp72_ = preset_name;
#line 586 "../src/PlaybackManager.vala"
					if (string_contains (_tmp71_, _tmp72_)) {
#line 586 "../src/PlaybackManager.vala"
						_tmp70_ = TRUE;
#line 4030 "PlaybackManager.c"
					} else {
						const gchar* _tmp73_;
						const gchar* _tmp74_;
#line 586 "../src/PlaybackManager.vala"
						_tmp73_ = preset_name;
#line 586 "../src/PlaybackManager.vala"
						_tmp74_ = media_genre;
#line 586 "../src/PlaybackManager.vala"
						_tmp70_ = string_contains (_tmp73_, _tmp74_);
#line 4040 "PlaybackManager.c"
					}
#line 586 "../src/PlaybackManager.vala"
					match_genre = _tmp70_;
#line 588 "../src/PlaybackManager.vala"
					_tmp77_ = automatic_enabled;
#line 588 "../src/PlaybackManager.vala"
					if (_tmp77_) {
#line 4048 "PlaybackManager.c"
						gboolean _tmp78_;
#line 588 "../src/PlaybackManager.vala"
						_tmp78_ = match_genre;
#line 588 "../src/PlaybackManager.vala"
						_tmp76_ = _tmp78_;
#line 4054 "PlaybackManager.c"
					} else {
#line 588 "../src/PlaybackManager.vala"
						_tmp76_ = FALSE;
#line 4058 "PlaybackManager.c"
					}
#line 588 "../src/PlaybackManager.vala"
					if (_tmp76_) {
#line 588 "../src/PlaybackManager.vala"
						_tmp75_ = TRUE;
#line 4064 "PlaybackManager.c"
					} else {
						gboolean _tmp79_ = FALSE;
						gboolean _tmp80_;
#line 589 "../src/PlaybackManager.vala"
						_tmp80_ = automatic_enabled;
#line 589 "../src/PlaybackManager.vala"
						if (!_tmp80_) {
#line 4072 "PlaybackManager.c"
							NoiseEqualizerPreset* _tmp81_;
							const gchar* _tmp82_;
							const gchar* _tmp83_;
							const gchar* _tmp84_;
#line 589 "../src/PlaybackManager.vala"
							_tmp81_ = p;
#line 589 "../src/PlaybackManager.vala"
							_tmp82_ = noise_equalizer_preset_get_name (_tmp81_);
#line 589 "../src/PlaybackManager.vala"
							_tmp83_ = _tmp82_;
#line 589 "../src/PlaybackManager.vala"
							_tmp84_ = selected_preset;
#line 589 "../src/PlaybackManager.vala"
							_tmp79_ = g_strcmp0 (_tmp83_, _tmp84_) == 0;
#line 4087 "PlaybackManager.c"
						} else {
#line 589 "../src/PlaybackManager.vala"
							_tmp79_ = FALSE;
#line 4091 "PlaybackManager.c"
						}
#line 589 "../src/PlaybackManager.vala"
						_tmp75_ = _tmp79_;
#line 4095 "PlaybackManager.c"
					}
#line 588 "../src/PlaybackManager.vala"
					if (_tmp75_) {
#line 4099 "PlaybackManager.c"
						{
							gint i = 0;
#line 590 "../src/PlaybackManager.vala"
							i = 0;
#line 4104 "PlaybackManager.c"
							{
								gboolean _tmp85_ = FALSE;
#line 590 "../src/PlaybackManager.vala"
								_tmp85_ = TRUE;
#line 590 "../src/PlaybackManager.vala"
								while (TRUE) {
#line 4111 "PlaybackManager.c"
									gint _tmp87_;
									NoisePlayback* _tmp88_;
									gint _tmp89_;
									NoiseEqualizerPreset* _tmp90_;
									gint _tmp91_;
#line 590 "../src/PlaybackManager.vala"
									if (!_tmp85_) {
#line 4119 "PlaybackManager.c"
										gint _tmp86_;
#line 590 "../src/PlaybackManager.vala"
										_tmp86_ = i;
#line 590 "../src/PlaybackManager.vala"
										i = _tmp86_ + 1;
#line 4125 "PlaybackManager.c"
									}
#line 590 "../src/PlaybackManager.vala"
									_tmp85_ = FALSE;
#line 590 "../src/PlaybackManager.vala"
									_tmp87_ = i;
#line 590 "../src/PlaybackManager.vala"
									if (!(_tmp87_ < 10)) {
#line 590 "../src/PlaybackManager.vala"
										break;
#line 4135 "PlaybackManager.c"
									}
#line 591 "../src/PlaybackManager.vala"
									_tmp88_ = self->player;
#line 591 "../src/PlaybackManager.vala"
									_tmp89_ = i;
#line 591 "../src/PlaybackManager.vala"
									_tmp90_ = p;
#line 591 "../src/PlaybackManager.vala"
									_tmp91_ = i;
#line 591 "../src/PlaybackManager.vala"
									noise_playback_set_equalizer_gain (_tmp88_, _tmp89_, noise_equalizer_preset_get_gain (_tmp90_, _tmp91_));
#line 4147 "PlaybackManager.c"
								}
							}
						}
#line 594 "../src/PlaybackManager.vala"
						_g_free0 (media_genre);
#line 594 "../src/PlaybackManager.vala"
						_g_free0 (preset_name);
#line 594 "../src/PlaybackManager.vala"
						_g_object_unref0 (p);
#line 594 "../src/PlaybackManager.vala"
						_g_object_unref0 (_p_it);
#line 594 "../src/PlaybackManager.vala"
						_g_free0 (selected_preset);
#line 594 "../src/PlaybackManager.vala"
						_g_object_unref0 (equalizer_settings);
#line 594 "../src/PlaybackManager.vala"
						return;
#line 4165 "PlaybackManager.c"
					}
#line 582 "../src/PlaybackManager.vala"
					_g_free0 (media_genre);
#line 582 "../src/PlaybackManager.vala"
					_g_free0 (preset_name);
#line 4171 "PlaybackManager.c"
				}
#line 581 "../src/PlaybackManager.vala"
				_g_object_unref0 (p);
#line 4175 "PlaybackManager.c"
			}
#line 581 "../src/PlaybackManager.vala"
			_g_object_unref0 (_p_it);
#line 4179 "PlaybackManager.c"
		}
#line 559 "../src/PlaybackManager.vala"
		_g_free0 (selected_preset);
#line 4183 "PlaybackManager.c"
	}
	{
		gint i = 0;
#line 600 "../src/PlaybackManager.vala"
		i = 0;
#line 4189 "PlaybackManager.c"
		{
			gboolean _tmp92_ = FALSE;
#line 600 "../src/PlaybackManager.vala"
			_tmp92_ = TRUE;
#line 600 "../src/PlaybackManager.vala"
			while (TRUE) {
#line 4196 "PlaybackManager.c"
				gint _tmp94_;
				NoisePlayback* _tmp95_;
				gint _tmp96_;
#line 600 "../src/PlaybackManager.vala"
				if (!_tmp92_) {
#line 4202 "PlaybackManager.c"
					gint _tmp93_;
#line 600 "../src/PlaybackManager.vala"
					_tmp93_ = i;
#line 600 "../src/PlaybackManager.vala"
					i = _tmp93_ + 1;
#line 4208 "PlaybackManager.c"
				}
#line 600 "../src/PlaybackManager.vala"
				_tmp92_ = FALSE;
#line 600 "../src/PlaybackManager.vala"
				_tmp94_ = i;
#line 600 "../src/PlaybackManager.vala"
				if (!(_tmp94_ < 10)) {
#line 600 "../src/PlaybackManager.vala"
					break;
#line 4218 "PlaybackManager.c"
				}
#line 601 "../src/PlaybackManager.vala"
				_tmp95_ = self->player;
#line 601 "../src/PlaybackManager.vala"
				_tmp96_ = i;
#line 601 "../src/PlaybackManager.vala"
				noise_playback_set_equalizer_gain (_tmp95_, _tmp96_, 0);
#line 4226 "PlaybackManager.c"
			}
		}
	}
#line 557 "../src/PlaybackManager.vala"
	_g_object_unref0 (equalizer_settings);
#line 4232 "PlaybackManager.c"
}


void
noise_playback_manager_stop_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	gint64 was_playing = 0LL;
	NoiseMedia* _tmp1_;
	NoiseSettingsMain* _tmp5_;
	NoiseSettingsMain* _tmp6_;
	gboolean _tmp7_;
	gint64 _tmp10_;
#line 605 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 606 "../src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 607 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 609 "../src/PlaybackManager.vala"
	was_playing = (gint64) 0;
#line 610 "../src/PlaybackManager.vala"
	_tmp1_ = self->priv->_current_media;
#line 610 "../src/PlaybackManager.vala"
	if (_tmp1_ != NULL) {
#line 4260 "PlaybackManager.c"
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
#line 611 "../src/PlaybackManager.vala"
		_tmp2_ = self->priv->_current_media;
#line 611 "../src/PlaybackManager.vala"
		_tmp3_ = noise_media_get_rowid (_tmp2_);
#line 611 "../src/PlaybackManager.vala"
		_tmp4_ = _tmp3_;
#line 611 "../src/PlaybackManager.vala"
		was_playing = _tmp4_;
#line 4272 "PlaybackManager.c"
	}
#line 614 "../src/PlaybackManager.vala"
	_tmp5_ = noise_settings_main_get_default ();
#line 614 "../src/PlaybackManager.vala"
	_tmp6_ = _tmp5_;
#line 614 "../src/PlaybackManager.vala"
	_tmp7_ = !noise_settings_main_privacy_mode_enabled (_tmp6_);
#line 614 "../src/PlaybackManager.vala"
	_g_object_unref0 (_tmp6_);
#line 614 "../src/PlaybackManager.vala"
	if (_tmp7_) {
#line 4284 "PlaybackManager.c"
		GSettings* _tmp8_;
		GSettings* _tmp9_;
#line 615 "../src/PlaybackManager.vala"
		_tmp8_ = noise_app_get_saved_state ();
#line 615 "../src/PlaybackManager.vala"
		_tmp9_ = _tmp8_;
#line 615 "../src/PlaybackManager.vala"
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
#line 4293 "PlaybackManager.c"
	}
#line 617 "../src/PlaybackManager.vala"
	noise_playback_manager_set_current_media (self, NULL);
#line 619 "../src/PlaybackManager.vala"
	_tmp10_ = was_playing;
#line 619 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, _tmp10_);
#line 4301 "PlaybackManager.c"
}


static GVariant*
_variant_new4 (gboolean value)
{
#line 625 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4310 "PlaybackManager.c"
}


void
noise_playback_manager_start_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
#line 622 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 623 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 623 "../src/PlaybackManager.vala"
	noise_playback_play (_tmp0_);
#line 624 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, TRUE);
#line 625 "../src/PlaybackManager.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 625 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 625 "../src/PlaybackManager.vala"
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
#line 625 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 625 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
#line 625 "../src/PlaybackManager.vala"
	_tmp6_ = _variant_new4 (TRUE);
#line 625 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 625 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp6_);
#line 626 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
#line 4350 "PlaybackManager.c"
}


static GVariant*
_variant_new5 (gboolean value)
{
#line 632 "../src/PlaybackManager.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 4359 "PlaybackManager.c"
}


void
noise_playback_manager_pause_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
#line 629 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 630 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 630 "../src/PlaybackManager.vala"
	noise_playback_pause (_tmp0_);
#line 631 "../src/PlaybackManager.vala"
	noise_playback_manager_set_playing (self, FALSE);
#line 632 "../src/PlaybackManager.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 632 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 632 "../src/PlaybackManager.vala"
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
#line 632 "../src/PlaybackManager.vala"
	_tmp4_ = _tmp3_;
#line 632 "../src/PlaybackManager.vala"
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
#line 632 "../src/PlaybackManager.vala"
	_tmp6_ = _variant_new5 (FALSE);
#line 632 "../src/PlaybackManager.vala"
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
#line 632 "../src/PlaybackManager.vala"
	_g_variant_unref0 (_tmp6_);
#line 633 "../src/PlaybackManager.vala"
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL], 0);
#line 4399 "PlaybackManager.c"
}


NoisePlaybackManager*
noise_playback_manager_construct (GType object_type)
{
	NoisePlaybackManager * self = NULL;
#line 35 "../src/PlaybackManager.vala"
	self = (NoisePlaybackManager*) g_object_new (object_type, NULL);
#line 35 "../src/PlaybackManager.vala"
	return self;
#line 4411 "PlaybackManager.c"
}


NoisePlaybackManager*
noise_playback_manager_new (void)
{
#line 35 "../src/PlaybackManager.vala"
	return noise_playback_manager_construct (NOISE_TYPE_PLAYBACK_MANAGER);
#line 4420 "PlaybackManager.c"
}


static NoiseLibrary*
noise_playback_manager_get_library (NoisePlaybackManager* self)
{
	NoiseLibrary* result;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 60 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/PlaybackManager.vala"
	_tmp0_ = noise_libraries_manager;
#line 60 "../src/PlaybackManager.vala"
	_tmp1_ = _tmp0_->local_library;
#line 60 "../src/PlaybackManager.vala"
	result = _tmp1_;
#line 60 "../src/PlaybackManager.vala"
	return result;
#line 4440 "PlaybackManager.c"
}


gint
noise_playback_manager_get_current_index (NoisePlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 64 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 65 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 65 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 65 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 4461 "PlaybackManager.c"
		gint _tmp3_;
#line 66 "../src/PlaybackManager.vala"
		_tmp3_ = self->priv->_current_index;
#line 66 "../src/PlaybackManager.vala"
		result = _tmp3_;
#line 66 "../src/PlaybackManager.vala"
		return result;
#line 4469 "PlaybackManager.c"
	} else {
		gint _tmp4_;
#line 68 "../src/PlaybackManager.vala"
		_tmp4_ = self->priv->_current_shuffled_index;
#line 68 "../src/PlaybackManager.vala"
		result = _tmp4_;
#line 68 "../src/PlaybackManager.vala"
		return result;
#line 4478 "PlaybackManager.c"
	}
}


void
noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 71 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/PlaybackManager.vala"
	g_debug ("PlaybackManager.vala:72: Current index: %d", value);
#line 73 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_shuffled;
#line 73 "../src/PlaybackManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 73 "../src/PlaybackManager.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/PlaybackManager.vala"
	if (_tmp2_ == 0) {
#line 74 "../src/PlaybackManager.vala"
		self->priv->_current_index = value;
#line 4504 "PlaybackManager.c"
	} else {
#line 76 "../src/PlaybackManager.vala"
		self->priv->_current_shuffled_index = value;
#line 4508 "PlaybackManager.c"
	}
#line 71 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
#line 4512 "PlaybackManager.c"
}


gboolean
noise_playback_manager_get_playing (NoisePlaybackManager* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 83 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_playing;
#line 83 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 83 "../src/PlaybackManager.vala"
	return result;
#line 4529 "PlaybackManager.c"
}


static void
noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                    gboolean value)
{
#line 83 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/PlaybackManager.vala"
	if (noise_playback_manager_get_playing (self) != value) {
#line 83 "../src/PlaybackManager.vala"
		self->priv->_playing = value;
#line 83 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
#line 4545 "PlaybackManager.c"
	}
}


gdouble
noise_playback_manager_get_volume (NoisePlaybackManager* self)
{
	gdouble result;
	NoisePlayback* _tmp0_;
#line 87 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 88 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 88 "../src/PlaybackManager.vala"
	result = noise_playback_get_volume (_tmp0_);
#line 88 "../src/PlaybackManager.vala"
	return result;
#line 4563 "PlaybackManager.c"
}


void
noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                   gdouble value)
{
	NoisePlayback* _tmp0_;
#line 90 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/PlaybackManager.vala"
	self->priv->saved_volume = value;
#line 92 "../src/PlaybackManager.vala"
	_tmp0_ = self->player;
#line 92 "../src/PlaybackManager.vala"
	noise_playback_set_volume (_tmp0_, value);
#line 90 "../src/PlaybackManager.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
#line 4582 "PlaybackManager.c"
}


NoiseMedia*
noise_playback_manager_get_current_media (NoisePlaybackManager* self)
{
	NoiseMedia* result;
	NoiseMedia* _tmp0_;
#line 100 "../src/PlaybackManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../src/PlaybackManager.vala"
	_tmp0_ = self->priv->_current_media;
#line 100 "../src/PlaybackManager.vala"
	result = _tmp0_;
#line 100 "../src/PlaybackManager.vala"
	return result;
#line 4599 "PlaybackManager.c"
}


static void
noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                          NoiseMedia* value)
{
#line 100 "../src/PlaybackManager.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/PlaybackManager.vala"
	if (noise_playback_manager_get_current_media (self) != value) {
#line 4611 "PlaybackManager.c"
		NoiseMedia* _tmp0_;
#line 100 "../src/PlaybackManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 100 "../src/PlaybackManager.vala"
		_g_object_unref0 (self->priv->_current_media);
#line 100 "../src/PlaybackManager.vala"
		self->priv->_current_media = _tmp0_;
#line 100 "../src/PlaybackManager.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
#line 4621 "PlaybackManager.c"
	}
}


static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 35 "../src/PlaybackManager.vala"
	g_return_if_fail (n_param_values == 2);
#line 35 "../src/PlaybackManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 35 "../src/PlaybackManager.vala"
		data1 = closure->data;
#line 35 "../src/PlaybackManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 4648 "PlaybackManager.c"
	} else {
#line 35 "../src/PlaybackManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 35 "../src/PlaybackManager.vala"
		data2 = closure->data;
#line 4654 "PlaybackManager.c"
	}
#line 35 "../src/PlaybackManager.vala"
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
#line 35 "../src/PlaybackManager.vala"
	callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 4660 "PlaybackManager.c"
}


static GObject *
noise_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlaybackManager * self;
	NoiseHistoryPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	NoiseStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	NoiseStreamer* _tmp10_;
	NoiseStreamer* _tmp11_;
	NoisePlayback* _tmp12_;
#line 102 "../src/PlaybackManager.vala"
	parent_class = G_OBJECT_CLASS (noise_playback_manager_parent_class);
#line 102 "../src/PlaybackManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 102 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 103 "../src/PlaybackManager.vala"
	_tmp0_ = noise_history_playlist_new ();
#line 103 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 103 "../src/PlaybackManager.vala"
	self->history_playlist = _tmp0_;
#line 104 "../src/PlaybackManager.vala"
	_tmp1_ = noise_static_playlist_new ();
#line 104 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 104 "../src/PlaybackManager.vala"
	self->queue_playlist = _tmp1_;
#line 105 "../src/PlaybackManager.vala"
	_tmp2_ = self->queue_playlist;
#line 105 "../src/PlaybackManager.vala"
	noise_playlist_set_name ((NoisePlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
#line 106 "../src/PlaybackManager.vala"
	_tmp3_ = self->queue_playlist;
#line 106 "../src/PlaybackManager.vala"
	noise_static_playlist_set_read_only (_tmp3_, TRUE);
#line 107 "../src/PlaybackManager.vala"
	_tmp4_ = self->queue_playlist;
#line 107 "../src/PlaybackManager.vala"
	noise_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
#line 108 "../src/PlaybackManager.vala"
	_tmp5_ = self->queue_playlist;
#line 108 "../src/PlaybackManager.vala"
	noise_static_playlist_set_show_badge (_tmp5_, TRUE);
#line 109 "../src/PlaybackManager.vala"
	_tmp6_ = self->queue_playlist;
#line 109 "../src/PlaybackManager.vala"
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
#line 109 "../src/PlaybackManager.vala"
	_g_object_unref0 (((NoisePlaylist*) _tmp6_)->icon);
#line 109 "../src/PlaybackManager.vala"
	((NoisePlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
#line 111 "../src/PlaybackManager.vala"
	_tmp8_ = noise_streamer_new ();
#line 111 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 111 "../src/PlaybackManager.vala"
	self->file_player = _tmp8_;
#line 112 "../src/PlaybackManager.vala"
	_tmp9_ = self->priv->playbacks;
#line 112 "../src/PlaybackManager.vala"
	_tmp10_ = self->file_player;
#line 112 "../src/PlaybackManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (NoisePlayback*) _tmp10_);
#line 113 "../src/PlaybackManager.vala"
	_tmp11_ = self->file_player;
#line 113 "../src/PlaybackManager.vala"
	_tmp12_ = _g_object_ref0 ((NoisePlayback*) _tmp11_);
#line 113 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 113 "../src/PlaybackManager.vala"
	self->player = _tmp12_;
#line 102 "../src/PlaybackManager.vala"
	return obj;
#line 4749 "PlaybackManager.c"
}


static void
noise_playback_manager_class_init (NoisePlaybackManagerClass * klass)
{
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/PlaybackManager.vala"
	g_type_class_adjust_private_offset (klass, &NoisePlaybackManager_private_offset);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playback_manager_get_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playback_manager_set_property;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_playback_manager_constructor;
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_playback_manager_finalize;
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/PlaybackManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", NOISE_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL] = g_signal_new ("playback-paused", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 35 "../src/PlaybackManager.vala"
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4790 "PlaybackManager.c"
}


static void
noise_playback_manager_instance_init (NoisePlaybackManager * self)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
#line 35 "../src/PlaybackManager.vala"
	self->priv = noise_playback_manager_get_instance_private (self);
#line 48 "../src/PlaybackManager.vala"
	g_rec_mutex_init (&self->priv->__lock_playbacks);
#line 48 "../src/PlaybackManager.vala"
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/PlaybackManager.vala"
	self->priv->playbacks = _tmp0_;
#line 51 "../src/PlaybackManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "../src/PlaybackManager.vala"
	self->priv->_current = _tmp1_;
#line 54 "../src/PlaybackManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 54 "../src/PlaybackManager.vala"
	self->priv->_current_shuffled = _tmp2_;
#line 83 "../src/PlaybackManager.vala"
	self->priv->_playing = FALSE;
#line 85 "../src/PlaybackManager.vala"
	self->priv->saved_volume = (gdouble) 1;
#line 4820 "PlaybackManager.c"
}


static void
noise_playback_manager_finalize (GObject * obj)
{
	NoisePlaybackManager * self;
#line 35 "../src/PlaybackManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 48 "../src/PlaybackManager.vala"
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
#line 48 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->playbacks);
#line 51 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current);
#line 54 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_shuffled);
#line 56 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->queue_playlist);
#line 57 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->history_playlist);
#line 98 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->file_player);
#line 99 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->player);
#line 100 "../src/PlaybackManager.vala"
	_g_object_unref0 (self->priv->_current_media);
#line 35 "../src/PlaybackManager.vala"
	G_OBJECT_CLASS (noise_playback_manager_parent_class)->finalize (obj);
#line 4850 "PlaybackManager.c"
}


/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Noise.Playback} to play a media
*/
GType
noise_playback_manager_get_type (void)
{
	static volatile gsize noise_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaybackManager), 0, (GInstanceInitFunc) noise_playback_manager_instance_init, NULL };
		GType noise_playback_manager_type_id;
		noise_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaybackManager", &g_define_type_info, 0);
		NoisePlaybackManager_private_offset = g_type_add_instance_private (noise_playback_manager_type_id, sizeof (NoisePlaybackManagerPrivate));
		g_once_init_leave (&noise_playback_manager_type_id__volatile, noise_playback_manager_type_id);
	}
	return noise_playback_manager_type_id__volatile;
}


static void
_vala_noise_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_int (value, noise_playback_manager_get_current_index (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_boolean (value, noise_playback_manager_get_playing (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_double (value, noise_playback_manager_get_volume (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		g_value_set_object (value, noise_playback_manager_get_current_media (self));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4908 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4914 "PlaybackManager.c"
	}
}


static void
_vala_noise_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
#line 35 "../src/PlaybackManager.vala"
	switch (property_id) {
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_current_index (self, g_value_get_int (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_playing (self, g_value_get_boolean (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_volume (self, g_value_get_double (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 35 "../src/PlaybackManager.vala"
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
#line 35 "../src/PlaybackManager.vala"
		noise_playback_manager_set_current_media (self, g_value_get_object (value));
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4953 "PlaybackManager.c"
		default:
#line 35 "../src/PlaybackManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "../src/PlaybackManager.vala"
		break;
#line 4959 "PlaybackManager.c"
	}
}



