/* ViewWrapper.c generated by valac 0.42.6, the Vala compiler
 * generated from ViewWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */
/*
 * Container and controller of the list and grid views, and info widgets
 * (welcome screen and embedded alert).
 *
 * A ViewWrapper triggers searches, status info updates, and also handles
 * view switching. It also works as a proxy for setting the media contained
 * by all the views. Please see set_media(), update_media(), remove_media()
 * and add_media().
 *
 * The views it contains implement the {@link Noise.ContentView} interface.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <granite.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>


#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;
typedef struct _NoiseViewWrapperPrivate NoiseViewWrapperPrivate;

#define NOISE_TYPE_LIST_VIEW (noise_list_view_get_type ())
#define NOISE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIST_VIEW, NoiseListView))
#define NOISE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))
#define NOISE_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIST_VIEW))
#define NOISE_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIST_VIEW))
#define NOISE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))

typedef struct _NoiseListView NoiseListView;
typedef struct _NoiseListViewClass NoiseListViewClass;

#define NOISE_TYPE_ALBUMS_VIEW (noise_albums_view_get_type ())
#define NOISE_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUMS_VIEW, NoiseAlbumsView))
#define NOISE_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUMS_VIEW, NoiseAlbumsViewClass))
#define NOISE_IS_ALBUMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUMS_VIEW))
#define NOISE_IS_ALBUMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUMS_VIEW))
#define NOISE_ALBUMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUMS_VIEW, NoiseAlbumsViewClass))

typedef struct _NoiseAlbumsView NoiseAlbumsView;
typedef struct _NoiseAlbumsViewClass NoiseAlbumsViewClass;
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;


#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())

#define NOISE_TYPE_VIEW_STACK (noise_view_stack_get_type ())
#define NOISE_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_STACK, NoiseViewStack))
#define NOISE_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_STACK, NoiseViewStackClass))
#define NOISE_IS_VIEW_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_STACK))
#define NOISE_IS_VIEW_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_STACK))
#define NOISE_VIEW_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_STACK, NoiseViewStackClass))

typedef struct _NoiseViewStack NoiseViewStack;
typedef struct _NoiseViewStackClass NoiseViewStackClass;
typedef enum  {
	NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID = 0,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST = 1,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT = 2,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME = 3,
	NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE = 4
} NoiseViewWrapperViewType;


#define NOISE_VIEW_WRAPPER_TYPE_VIEW_TYPE (noise_view_wrapper_view_type_get_type ())
enum  {
	NOISE_VIEW_WRAPPER_0_PROPERTY,
	NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY,
	NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY,
	NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY,
	NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY,
	NOISE_VIEW_WRAPPER_HINT_PROPERTY,
	NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY,
	NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY,
	NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY,
	NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY,
	NOISE_VIEW_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;

#define NOISE_WIDGETS_TYPE_VIEW_SELECTOR (noise_widgets_view_selector_get_type ())
#define NOISE_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector))
#define NOISE_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))

typedef struct _NoiseWidgetsViewSelector NoiseWidgetsViewSelector;
typedef struct _NoiseWidgetsViewSelectorClass NoiseWidgetsViewSelectorClass;

#define NOISE_TYPE_COLUMN_BROWSER (noise_column_browser_get_type ())
#define NOISE_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowser))
#define NOISE_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))
#define NOISE_IS_COLUMN_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_IS_COLUMN_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_COLUMN_BROWSER))
#define NOISE_COLUMN_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_COLUMN_BROWSER, NoiseColumnBrowserClass))

typedef struct _NoiseColumnBrowser NoiseColumnBrowser;
typedef struct _NoiseColumnBrowserClass NoiseColumnBrowserClass;
typedef enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} NoiseWidgetsViewSelectorMode;


#define NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE (noise_widgets_view_selector_mode_get_type ())

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;

#define NOISE_TYPE_VIEW_INTERFACE (noise_view_interface_get_type ())
#define NOISE_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterface))
#define NOISE_IS_VIEW_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_INTERFACE))
#define NOISE_VIEW_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), NOISE_TYPE_VIEW_INTERFACE, NoiseViewInterfaceIface))

typedef struct _NoiseViewInterface NoiseViewInterface;
typedef struct _NoiseViewInterfaceIface NoiseViewInterfaceIface;
typedef struct _NoiseViewWrapperSetMediaAsyncData NoiseViewWrapperSetMediaAsyncData;
typedef struct _NoiseViewWrapperAddMediaAsyncData NoiseViewWrapperAddMediaAsyncData;
typedef struct _NoiseViewWrapperRemoveMediaAsyncData NoiseViewWrapperRemoveMediaAsyncData;
typedef struct _NoiseViewWrapperUpdateMediaAsyncData NoiseViewWrapperUpdateMediaAsyncData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NoiseViewWrapper {
	GtkGrid parent_instance;
	NoiseViewWrapperPrivate * priv;
};

struct _NoiseViewWrapperClass {
	GtkGridClass parent_class;
	gboolean (*check_have_media) (NoiseViewWrapper* self);
	void (*select_proper_content_view) (NoiseViewWrapper* self);
	void (*set_no_media_alert) (NoiseViewWrapper* self);
};

struct _NoiseViewWrapperPrivate {
	NoiseListView* _list_view;
	NoiseAlbumsView* _grid_view;
	GraniteWidgetsAlertView* _embedded_alert;
	GraniteWidgetsWelcome* _welcome_screen;
	NoiseViewWrapperHint _hint;
	NoiseLibrary* _library;
	NoisePlaylist* _playlist;
	gboolean widgets_ready;
	NoiseViewStack* view_stack;
	NoiseViewWrapperViewType last_used_view;
	gboolean data_initialized;
	GRecMutex __lock_NoiseViewWrapperlist_view;
	GRecMutex __lock_NoiseViewWrappergrid_view;
};

struct _NoiseViewInterfaceIface {
	GTypeInterface parent_iface;
	NoiseViewWrapperHint (*get_hint) (NoiseViewInterface* self);
	GeeCollection* (*get_media) (NoiseViewInterface* self);
	GeeCollection* (*get_visible_media) (NoiseViewInterface* self);
	void (*refilter) (NoiseViewInterface* self);
	void (*set_media) (NoiseViewInterface* self, GeeCollection* new_media);
	void (*add_media) (NoiseViewInterface* self, GeeCollection* to_add);
	void (*remove_media) (NoiseViewInterface* self, GeeCollection* to_remove);
	void (*update_media) (NoiseViewInterface* self, GeeCollection* to_update);
};

struct _NoiseViewWrapperSetMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* new_media;
	gboolean _tmp0_;
};

struct _NoiseViewWrapperAddMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* to_add;
	gboolean _tmp0_;
};

struct _NoiseViewWrapperRemoveMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* to_remove;
	gboolean _tmp0_;
};

struct _NoiseViewWrapperUpdateMediaAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseViewWrapper* self;
	GeeCollection* to_update;
	gboolean _tmp0_;
};


static gint NoiseViewWrapper_private_offset;
static gpointer noise_view_wrapper_parent_class = NULL;

GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
GType noise_list_view_get_type (void) G_GNUC_CONST;
GType noise_albums_view_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
GType noise_view_stack_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_view_type_get_type (void) G_GNUC_CONST;
#define NOISE_VIEW_WRAPPER_VIEW_CONSTRUCT_PRIORITY (G_PRIORITY_DEFAULT_IDLE - 10)
NoiseViewWrapper* noise_view_wrapper_construct (GType object_type,
                                                NoiseViewWrapperHint hint,
                                                NoiseLibrary* library);
void noise_view_wrapper_pack_views (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_has_grid_view (NoiseViewWrapper* self);
NoiseAlbumsView* noise_view_wrapper_get_grid_view (NoiseViewWrapper* self);
void noise_view_stack_add_view (NoiseViewStack* self,
                                GtkWidget* view);
gboolean noise_view_wrapper_get_has_list_view (NoiseViewWrapper* self);
NoiseListView* noise_view_wrapper_get_list_view (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_has_welcome_screen (NoiseViewWrapper* self);
GraniteWidgetsWelcome* noise_view_wrapper_get_welcome_screen (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_has_embedded_alert (NoiseViewWrapper* self);
GraniteWidgetsAlertView* noise_view_wrapper_get_embedded_alert (NoiseViewWrapper* self);
void noise_view_wrapper_set_active_view (NoiseViewWrapper* self,
                                         NoiseViewWrapperViewType type,
                                         gboolean* successful);
NoiseViewWrapperViewType noise_view_wrapper_get_current_view (NoiseViewWrapper* self);
gboolean noise_view_wrapper_get_is_current_wrapper (NoiseViewWrapper* self);
GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
NoiseMusicListView* noise_list_view_get_list_view (NoiseListView* self);
void noise_generic_list_scroll_to_current_media (NoiseGenericList* self,
                                                 gboolean unfilter_if_not_found);
NoiseViewWrapperHint noise_view_wrapper_get_hint (NoiseViewWrapper* self);
const gchar* noise_view_wrapper_hint_to_string (NoiseViewWrapperHint self);
const gchar* noise_view_wrapper_view_type_to_string (NoiseViewWrapperViewType self);
void noise_view_wrapper_update_library_window_widgets (NoiseViewWrapper* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
gboolean noise_library_window_get_initialization_finished (NoiseLibraryWindow* self);
GtkSearchEntry* noise_library_window_get_search_entry (NoiseLibraryWindow* self);
gint noise_view_wrapper_get_media_count (NoiseViewWrapper* self);
GType noise_widgets_view_selector_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelector* noise_library_window_get_view_selector (NoiseLibraryWindow* self);
void noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self,
                                                gboolean value);
GType noise_column_browser_get_type (void) G_GNUC_CONST;
NoiseColumnBrowser* noise_list_view_get_column_browser (NoiseListView* self);
void noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self,
                                                                   gboolean active);
gboolean noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self);
GType noise_widgets_view_selector_mode_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelectorMode noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self,
                                               NoiseWidgetsViewSelectorMode value);
void noise_view_wrapper_view_selector_changed (NoiseViewWrapper* self);
gboolean noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self);
void noise_view_wrapper_play_first_media (NoiseViewWrapper* self,
                                          gboolean* force);
void noise_list_view_set_as_current_list (NoiseListView* self,
                                          gint media_id);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
void noise_view_wrapper_set_as_current_view (NoiseViewWrapper* self);
void noise_view_wrapper_update_visible_media (NoiseViewWrapper* self);
gboolean noise_view_wrapper_check_have_media (NoiseViewWrapper* self);
static void noise_view_wrapper_search_field_changed (NoiseViewWrapper* self);
static gboolean noise_view_wrapper_real_check_have_media (NoiseViewWrapper* self);
void noise_view_wrapper_select_proper_content_view (NoiseViewWrapper* self);
void noise_view_wrapper_set_no_media_alert (NoiseViewWrapper* self);
static void noise_view_wrapper_real_select_proper_content_view (NoiseViewWrapper* self);
GeeCollection* noise_view_wrapper_get_media_list (NoiseViewWrapper* self);
GType noise_view_interface_get_type (void) G_GNUC_CONST;
GeeCollection* noise_view_interface_get_media (NoiseViewInterface* self);
void noise_view_wrapper_clear_filters (NoiseViewWrapper* self);
void noise_view_interface_refilter (NoiseViewInterface* self);
static void noise_view_wrapper_real_set_no_media_alert (NoiseViewWrapper* self);
static void noise_view_wrapper_set_media_async_data_free (gpointer _data);
static void noise_view_wrapper_set_media_async_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
void noise_view_wrapper_set_media_async (NoiseViewWrapper* self,
                                         GeeCollection* new_media,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void noise_view_wrapper_set_media_finish (NoiseViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean noise_view_wrapper_set_media_async_co (NoiseViewWrapperSetMediaAsyncData* _data_);
static void noise_view_wrapper_set_media (NoiseViewWrapper* self,
                                   GeeCollection* new_media);
static void noise_view_wrapper_add_media_async_data_free (gpointer _data);
static void noise_view_wrapper_add_media_async_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
void noise_view_wrapper_add_media_async (NoiseViewWrapper* self,
                                         GeeCollection* to_add,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void noise_view_wrapper_add_media_finish (NoiseViewWrapper* self,
                                          GAsyncResult* _res_);
static gboolean noise_view_wrapper_add_media_async_co (NoiseViewWrapperAddMediaAsyncData* _data_);
static void noise_view_wrapper_add_media (NoiseViewWrapper* self,
                                   GeeCollection* new_media);
static void noise_view_wrapper_remove_media_async_data_free (gpointer _data);
static void noise_view_wrapper_remove_media_async_async_ready_wrapper (GObject *source_object,
                                                                GAsyncResult *res,
                                                                void *user_data);
void noise_view_wrapper_remove_media_async (NoiseViewWrapper* self,
                                            GeeCollection* to_remove,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
void noise_view_wrapper_remove_media_finish (NoiseViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean noise_view_wrapper_remove_media_async_co (NoiseViewWrapperRemoveMediaAsyncData* _data_);
static void noise_view_wrapper_remove_media (NoiseViewWrapper* self,
                                      GeeCollection* media);
static void noise_view_wrapper_update_media_async_data_free (gpointer _data);
static void noise_view_wrapper_update_media_async_async_ready_wrapper (GObject *source_object,
                                                                GAsyncResult *res,
                                                                void *user_data);
void noise_view_wrapper_update_media_async (NoiseViewWrapper* self,
                                            GeeCollection* to_update,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
void noise_view_wrapper_update_media_finish (NoiseViewWrapper* self,
                                             GAsyncResult* _res_);
static gboolean noise_view_wrapper_update_media_async_co (NoiseViewWrapperUpdateMediaAsyncData* _data_);
static void noise_view_wrapper_update_media (NoiseViewWrapper* self,
                                      GeeCollection* media);
void noise_view_interface_set_media (NoiseViewInterface* self,
                                     GeeCollection* new_media);
static void noise_view_wrapper_update_widget_state (NoiseViewWrapper* self);
void noise_view_interface_update_media (NoiseViewInterface* self,
                                        GeeCollection* to_update);
void noise_view_interface_add_media (NoiseViewInterface* self,
                                     GeeCollection* to_add);
void noise_view_interface_remove_media (NoiseViewInterface* self,
                                        GeeCollection* to_remove);
void noise_view_wrapper_set_list_view (NoiseViewWrapper* self,
                                       NoiseListView* value);
void noise_view_wrapper_set_grid_view (NoiseViewWrapper* self,
                                       NoiseAlbumsView* value);
void noise_view_wrapper_set_embedded_alert (NoiseViewWrapper* self,
                                            GraniteWidgetsAlertView* value);
void noise_view_wrapper_set_welcome_screen (NoiseViewWrapper* self,
                                            GraniteWidgetsWelcome* value);
void noise_view_wrapper_set_hint (NoiseViewWrapper* self,
                                  NoiseViewWrapperHint value);
NoiseLibrary* noise_view_wrapper_get_library (NoiseViewWrapper* self);
void noise_view_wrapper_set_library (NoiseViewWrapper* self,
                                     NoiseLibrary* value);
NoiseViewStack* noise_library_window_get_view_stack (NoiseLibraryWindow* self);
NoisePlaylist* noise_view_wrapper_get_playlist (NoiseViewWrapper* self);
void noise_view_wrapper_set_playlist (NoiseViewWrapper* self,
                                      NoisePlaylist* value);
guint noise_list_view_get_n_media (NoiseListView* self);
static GObject * noise_view_wrapper_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
NoiseViewStack* noise_view_stack_new (void);
NoiseViewStack* noise_view_stack_construct (GType object_type);
static void _noise_view_wrapper_view_selector_changed_noise_widgets_view_selector_mode_changed (NoiseWidgetsViewSelector* _sender,
                                                                                         NoiseWidgetsViewSelectorMode new_mode,
                                                                                         gpointer self);
static void _noise_view_wrapper_search_field_changed_noise_library_search_finished (NoiseLibrary* _sender,
                                                                             gpointer self);
static void noise_view_wrapper_finalize (GObject * obj);
static void _vala_noise_view_wrapper_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_noise_view_wrapper_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);


static inline gpointer
noise_view_wrapper_get_instance_private (NoiseViewWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseViewWrapper_private_offset);
}


GType
noise_view_wrapper_hint_get_type (void)
{
	static volatile gsize noise_view_wrapper_hint_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_wrapper_hint_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_VIEW_WRAPPER_HINT_NONE, "NOISE_VIEW_WRAPPER_HINT_NONE", "none"}, {NOISE_VIEW_WRAPPER_HINT_MUSIC, "NOISE_VIEW_WRAPPER_HINT_MUSIC", "music"}, {NOISE_VIEW_WRAPPER_HINT_PLAYLIST, "NOISE_VIEW_WRAPPER_HINT_PLAYLIST", "playlist"}, {NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST, "NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST", "read-only-playlist"}, {NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST, "NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST", "smart-playlist"}, {NOISE_VIEW_WRAPPER_HINT_CDROM, "NOISE_VIEW_WRAPPER_HINT_CDROM", "cdrom"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE, "NOISE_VIEW_WRAPPER_HINT_DEVICE", "device"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO, "NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO", "device-audio"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST, "NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST", "device-podcast"}, {NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK, "NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK", "device-audiobook"}, {NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE, "NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE", "network-device"}, {NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST, "NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST", "album-list"}, {NOISE_VIEW_WRAPPER_HINT_QUEUE, "NOISE_VIEW_WRAPPER_HINT_QUEUE", "queue"}, {0, NULL, NULL}};
		GType noise_view_wrapper_hint_type_id;
		noise_view_wrapper_hint_type_id = g_enum_register_static ("NoiseViewWrapperHint", values);
		g_once_init_leave (&noise_view_wrapper_hint_type_id__volatile, noise_view_wrapper_hint_type_id);
	}
	return noise_view_wrapper_hint_type_id__volatile;
}


/**
     * Type of visual representation of the media.
     *
     * Values *must* match the index of the respective view in the view selector.
     */
GType
noise_view_wrapper_view_type_get_type (void)
{
	static volatile gsize noise_view_wrapper_view_type_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_wrapper_view_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID, "NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID", "grid"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST, "NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST", "list"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT, "NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT", "alert"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME, "NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME", "welcome"}, {NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE, "NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE", "none"}, {0, NULL, NULL}};
		GType noise_view_wrapper_view_type_type_id;
		noise_view_wrapper_view_type_type_id = g_enum_register_static ("NoiseViewWrapperViewType", values);
		g_once_init_leave (&noise_view_wrapper_view_type_type_id__volatile, noise_view_wrapper_view_type_type_id);
	}
	return noise_view_wrapper_view_type_type_id__volatile;
}


NoiseViewWrapper*
noise_view_wrapper_construct (GType object_type,
                              NoiseViewWrapperHint hint,
                              NoiseLibrary* library)
{
	NoiseViewWrapper * self = NULL;
#line 133 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (library != NULL, NULL);
#line 134 "../src/Views/Wrappers/ViewWrapper.vala"
	self = (NoiseViewWrapper*) g_object_new (object_type, "hint", hint, "library", library, NULL);
#line 133 "../src/Views/Wrappers/ViewWrapper.vala"
	return self;
#line 555 "ViewWrapper.c"
}


/**
     * Checks which views are available and packs them in (if they are not packed yet)
     */
void
noise_view_wrapper_pack_views (NoiseViewWrapper* self)
{
	NoiseViewStack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	gboolean _tmp30_;
#line 150 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->view_stack;
#line 151 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_assert (_tmp0_ != NULL, "view_stack != null");
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = noise_view_wrapper_get_has_grid_view (self);
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp3_) {
#line 590 "ViewWrapper.c"
		NoiseAlbumsView* _tmp4_;
		GtkContainer* _tmp5_;
		GtkContainer* _tmp6_;
		NoiseViewStack* _tmp7_;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = self->priv->_grid_view;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = gtk_widget_get_parent ((GtkWidget*) _tmp4_);
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp5_;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = self->priv->view_stack;
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = _tmp6_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_container_get_type (), GtkContainer);
#line 605 "ViewWrapper.c"
	} else {
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = FALSE;
#line 609 "ViewWrapper.c"
	}
#line 153 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 613 "ViewWrapper.c"
		NoiseViewStack* _tmp8_;
		NoiseAlbumsView* _tmp9_;
#line 154 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = self->priv->view_stack;
#line 154 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = self->priv->_grid_view;
#line 154 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_stack_add_view (_tmp8_, (GtkWidget*) _tmp9_);
#line 622 "ViewWrapper.c"
	}
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = noise_view_wrapper_get_has_list_view (self);
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp12_ = _tmp11_;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp12_) {
#line 630 "ViewWrapper.c"
		NoiseListView* _tmp13_;
		GtkContainer* _tmp14_;
		GtkContainer* _tmp15_;
		NoiseViewStack* _tmp16_;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp13_ = self->priv->_list_view;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp14_ = gtk_widget_get_parent ((GtkWidget*) _tmp13_);
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp15_ = _tmp14_;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp16_ = self->priv->view_stack;
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = _tmp15_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer);
#line 645 "ViewWrapper.c"
	} else {
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = FALSE;
#line 649 "ViewWrapper.c"
	}
#line 156 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_) {
#line 653 "ViewWrapper.c"
		NoiseViewStack* _tmp17_;
		NoiseListView* _tmp18_;
#line 157 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp17_ = self->priv->view_stack;
#line 157 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = self->priv->_list_view;
#line 157 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_stack_add_view (_tmp17_, (GtkWidget*) _tmp18_);
#line 662 "ViewWrapper.c"
	}
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp20_ = noise_view_wrapper_get_has_welcome_screen (self);
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp21_ = _tmp20_;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp21_) {
#line 670 "ViewWrapper.c"
		GraniteWidgetsWelcome* _tmp22_;
		GtkContainer* _tmp23_;
		GtkContainer* _tmp24_;
		NoiseViewStack* _tmp25_;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp22_ = self->priv->_welcome_screen;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp23_ = gtk_widget_get_parent ((GtkWidget*) _tmp22_);
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp24_ = _tmp23_;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp25_ = self->priv->view_stack;
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = _tmp24_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_container_get_type (), GtkContainer);
#line 685 "ViewWrapper.c"
	} else {
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = FALSE;
#line 689 "ViewWrapper.c"
	}
#line 159 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp19_) {
#line 693 "ViewWrapper.c"
		NoiseViewStack* _tmp26_;
		GraniteWidgetsWelcome* _tmp27_;
#line 160 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp26_ = self->priv->view_stack;
#line 160 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp27_ = self->priv->_welcome_screen;
#line 160 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_stack_add_view (_tmp26_, (GtkWidget*) _tmp27_);
#line 702 "ViewWrapper.c"
	}
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp29_ = noise_view_wrapper_get_has_embedded_alert (self);
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp30_ = _tmp29_;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp30_) {
#line 710 "ViewWrapper.c"
		GraniteWidgetsAlertView* _tmp31_;
		GtkContainer* _tmp32_;
		GtkContainer* _tmp33_;
		NoiseViewStack* _tmp34_;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp31_ = self->priv->_embedded_alert;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp32_ = gtk_widget_get_parent ((GtkWidget*) _tmp31_);
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp33_ = _tmp32_;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp34_ = self->priv->view_stack;
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = _tmp33_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_container_get_type (), GtkContainer);
#line 725 "ViewWrapper.c"
	} else {
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = FALSE;
#line 729 "ViewWrapper.c"
	}
#line 162 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp28_) {
#line 733 "ViewWrapper.c"
		NoiseViewStack* _tmp35_;
		GraniteWidgetsAlertView* _tmp36_;
#line 163 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp35_ = self->priv->view_stack;
#line 163 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp36_ = self->priv->_embedded_alert;
#line 163 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_stack_add_view (_tmp35_, (GtkWidget*) _tmp36_);
#line 742 "ViewWrapper.c"
	}
#line 165 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->widgets_ready = TRUE;
#line 166 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 748 "ViewWrapper.c"
}


/**
     * Convenient visibility method
     */
void
noise_view_wrapper_set_active_view (NoiseViewWrapper* self,
                                    NoiseViewWrapperViewType type,
                                    gboolean* successful)
{
	gboolean _vala_successful = FALSE;
	gboolean _tmp0_ = FALSE;
	NoiseViewWrapperViewType _tmp1_;
	NoiseViewWrapperViewType _tmp2_;
	gboolean _tmp27_;
#line 172 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_successful = TRUE;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = noise_view_wrapper_get_current_view (self);
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	if (type == _tmp2_) {
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = TRUE;
#line 777 "ViewWrapper.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp3_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = _tmp3_;
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = !_tmp4_;
#line 787 "ViewWrapper.c"
	}
#line 175 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp0_) {
#line 176 "../src/Views/Wrappers/ViewWrapper.vala"
		if (successful) {
#line 176 "../src/Views/Wrappers/ViewWrapper.vala"
			*successful = _vala_successful;
#line 795 "ViewWrapper.c"
		}
#line 176 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 799 "ViewWrapper.c"
	}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (type) {
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST:
#line 805 "ViewWrapper.c"
		{
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 180 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp5_ = noise_view_wrapper_get_has_list_view (self);
#line 180 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = _tmp5_;
#line 180 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp6_) {
#line 815 "ViewWrapper.c"
				NoiseViewStack* _tmp7_;
				NoiseListView* _tmp8_;
				NoiseListView* _tmp9_;
				NoiseMusicListView* _tmp10_;
				NoiseMusicListView* _tmp11_;
#line 181 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->view_stack;
#line 181 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 181 "../src/Views/Wrappers/ViewWrapper.vala"
				gtk_stack_set_visible_child ((GtkStack*) _tmp7_, (GtkWidget*) _tmp8_);
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp9_ = self->priv->_list_view;
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp10_ = noise_list_view_get_list_view (_tmp9_);
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp11_ = _tmp10_;
#line 182 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_generic_list_scroll_to_current_media ((NoiseGenericList*) _tmp11_, TRUE);
#line 835 "ViewWrapper.c"
			} else {
#line 184 "../src/Views/Wrappers/ViewWrapper.vala"
				_vala_successful = FALSE;
#line 839 "ViewWrapper.c"
			}
#line 186 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 843 "ViewWrapper.c"
		}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID:
#line 847 "ViewWrapper.c"
		{
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 188 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp12_ = noise_view_wrapper_get_has_grid_view (self);
#line 188 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp13_ = _tmp12_;
#line 188 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp13_) {
#line 857 "ViewWrapper.c"
				NoiseViewStack* _tmp14_;
				NoiseAlbumsView* _tmp15_;
#line 189 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp14_ = self->priv->view_stack;
#line 189 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp15_ = self->priv->_grid_view;
#line 189 "../src/Views/Wrappers/ViewWrapper.vala"
				gtk_stack_set_visible_child ((GtkStack*) _tmp14_, (GtkWidget*) _tmp15_);
#line 866 "ViewWrapper.c"
			} else {
				gboolean _tmp16_;
				gboolean _tmp17_;
#line 191 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp16_ = noise_view_wrapper_get_has_list_view (self);
#line 191 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp17_ = _tmp16_;
#line 191 "../src/Views/Wrappers/ViewWrapper.vala"
				if (_tmp17_) {
#line 876 "ViewWrapper.c"
					NoiseViewStack* _tmp18_;
					NoiseListView* _tmp19_;
					NoiseListView* _tmp20_;
					NoiseMusicListView* _tmp21_;
					NoiseMusicListView* _tmp22_;
#line 192 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp18_ = self->priv->view_stack;
#line 192 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp19_ = self->priv->_list_view;
#line 192 "../src/Views/Wrappers/ViewWrapper.vala"
					gtk_stack_set_visible_child ((GtkStack*) _tmp18_, (GtkWidget*) _tmp19_);
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp20_ = self->priv->_list_view;
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp21_ = noise_list_view_get_list_view (_tmp20_);
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp22_ = _tmp21_;
#line 193 "../src/Views/Wrappers/ViewWrapper.vala"
					noise_generic_list_scroll_to_current_media ((NoiseGenericList*) _tmp22_, TRUE);
#line 896 "ViewWrapper.c"
				}
#line 195 "../src/Views/Wrappers/ViewWrapper.vala"
				_vala_successful = FALSE;
#line 900 "ViewWrapper.c"
			}
#line 197 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 904 "ViewWrapper.c"
		}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT:
#line 908 "ViewWrapper.c"
		{
			NoiseViewStack* _tmp23_;
			GraniteWidgetsAlertView* _tmp24_;
#line 199 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp23_ = self->priv->view_stack;
#line 199 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp24_ = self->priv->_embedded_alert;
#line 199 "../src/Views/Wrappers/ViewWrapper.vala"
			gtk_stack_set_visible_child ((GtkStack*) _tmp23_, (GtkWidget*) _tmp24_);
#line 200 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 920 "ViewWrapper.c"
		}
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME:
#line 924 "ViewWrapper.c"
		{
			NoiseViewStack* _tmp25_;
			GraniteWidgetsWelcome* _tmp26_;
#line 202 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp25_ = self->priv->view_stack;
#line 202 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp26_ = self->priv->_welcome_screen;
#line 202 "../src/Views/Wrappers/ViewWrapper.vala"
			gtk_stack_set_visible_child ((GtkStack*) _tmp25_, (GtkWidget*) _tmp26_);
#line 203 "../src/Views/Wrappers/ViewWrapper.vala"
			break;
#line 936 "ViewWrapper.c"
		}
		default:
#line 178 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 941 "ViewWrapper.c"
	}
#line 207 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp27_ = _vala_successful;
#line 207 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp27_) {
#line 947 "ViewWrapper.c"
		NoiseViewWrapperHint _tmp28_;
		GEnumValue* _tmp29_;
		GEnumValue* _tmp30_;
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = self->priv->_hint;
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp29_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp28_);
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp30_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_VIEW_TYPE), type);
#line 208 "../src/Views/Wrappers/ViewWrapper.vala"
		g_debug ("ViewWrapper.vala:208: %s : VIEW %s was not available", (_tmp29_ != NULL) ? _tmp29_->value_name : NULL, (_tmp30_ != NULL) ? _tmp30_->value_name : NULL);
#line 209 "../src/Views/Wrappers/ViewWrapper.vala"
		if (successful) {
#line 209 "../src/Views/Wrappers/ViewWrapper.vala"
			*successful = _vala_successful;
#line 963 "ViewWrapper.c"
		}
#line 209 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 967 "ViewWrapper.c"
	}
#line 212 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->last_used_view = type;
#line 215 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_library_window_widgets (self);
#line 172 "../src/Views/Wrappers/ViewWrapper.vala"
	if (successful) {
#line 172 "../src/Views/Wrappers/ViewWrapper.vala"
		*successful = _vala_successful;
#line 977 "ViewWrapper.c"
	}
}


/**
     * This method ensures that the view switcher and search box are sensitive/insensitive
     * when they have to. It also selects the proper view switcher item based on the
     * current view.
     */
void
noise_view_wrapper_update_library_window_widgets (NoiseViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NoiseViewWrapperHint _tmp10_;
	GEnumValue* _tmp11_;
	NoiseLibraryWindow* _tmp12_;
	NoiseLibraryWindow* _tmp13_;
	GtkSearchEntry* _tmp14_;
	GtkSearchEntry* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_;
	gboolean _tmp22_;
	NoiseLibraryWindow* _tmp29_;
	NoiseLibraryWindow* _tmp30_;
	NoiseWidgetsViewSelector* _tmp31_;
	NoiseWidgetsViewSelector* _tmp32_;
	gboolean _tmp33_ = FALSE;
	NoiseListView* _tmp34_;
	NoiseColumnBrowser* _tmp35_;
	NoiseColumnBrowser* _tmp36_;
	NoiseLibraryWindow* _tmp42_;
	NoiseLibraryWindow* _tmp43_;
	NoiseWidgetsViewSelector* _tmp44_;
	NoiseWidgetsViewSelector* _tmp45_;
	NoiseLibraryWindow* _tmp46_;
	NoiseLibraryWindow* _tmp47_;
	NoiseWidgetsViewSelector* _tmp48_;
	NoiseWidgetsViewSelector* _tmp49_;
#line 223 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp3_) {
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = TRUE;
#line 1033 "ViewWrapper.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = noise_view_wrapper_get_has_list_view (self);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = _tmp4_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp1_ = !_tmp5_;
#line 1043 "ViewWrapper.c"
	}
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = TRUE;
#line 1049 "ViewWrapper.c"
	} else {
		NoiseLibraryWindow* _tmp6_;
		NoiseLibraryWindow* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = noise_app_get_main_window ();
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = _tmp6_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = noise_library_window_get_initialization_finished (_tmp7_);
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = _tmp8_;
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = !_tmp9_;
#line 1065 "ViewWrapper.c"
	}
#line 224 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp0_) {
#line 225 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1071 "ViewWrapper.c"
	}
#line 227 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = self->priv->_hint;
#line 227 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp10_);
#line 227 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:227: update_library_window_widgets [%s]", (_tmp11_ != NULL) ? _tmp11_->value_name : NULL);
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp12_ = noise_app_get_main_window ();
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp13_ = _tmp12_;
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp14_ = noise_library_window_get_search_entry (_tmp13_);
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp15_ = _tmp14_;
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp16_ = noise_view_wrapper_get_media_count (self);
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp17_ = _tmp16_;
#line 231 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, _tmp17_ > 0);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp21_ = noise_view_wrapper_get_has_grid_view (self);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp22_ = _tmp21_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp22_) {
#line 1099 "ViewWrapper.c"
		gboolean _tmp23_;
		gboolean _tmp24_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp23_ = noise_view_wrapper_get_has_list_view (self);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp24_ = _tmp23_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp20_ = _tmp24_;
#line 1108 "ViewWrapper.c"
	} else {
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp20_ = FALSE;
#line 1112 "ViewWrapper.c"
	}
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp20_) {
#line 1116 "ViewWrapper.c"
		NoiseViewWrapperViewType _tmp25_;
		NoiseViewWrapperViewType _tmp26_;
#line 237 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp25_ = noise_view_wrapper_get_current_view (self);
#line 237 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp26_ = _tmp25_;
#line 237 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = _tmp26_ != NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
#line 1125 "ViewWrapper.c"
	} else {
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp19_ = FALSE;
#line 1129 "ViewWrapper.c"
	}
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp19_) {
#line 1133 "ViewWrapper.c"
		NoiseViewWrapperViewType _tmp27_;
		NoiseViewWrapperViewType _tmp28_;
#line 238 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp27_ = noise_view_wrapper_get_current_view (self);
#line 238 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp28_ = _tmp27_;
#line 238 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = _tmp28_ != NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT;
#line 1142 "ViewWrapper.c"
	} else {
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = FALSE;
#line 1146 "ViewWrapper.c"
	}
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp29_ = noise_app_get_main_window ();
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp30_ = _tmp29_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp31_ = noise_library_window_get_view_selector (_tmp30_);
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp32_ = _tmp31_;
#line 236 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_widgets_view_selector_set_sensitive (_tmp32_, _tmp18_);
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp34_ = self->priv->_list_view;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp35_ = noise_list_view_get_column_browser (_tmp34_);
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp36_ = _tmp35_;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp36_ != NULL) {
#line 1166 "ViewWrapper.c"
		NoiseListView* _tmp37_;
		NoiseColumnBrowser* _tmp38_;
		NoiseColumnBrowser* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp37_ = self->priv->_list_view;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp38_ = noise_list_view_get_column_browser (_tmp37_);
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp39_ = _tmp38_;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp40_ = gtk_widget_get_visible ((GtkWidget*) _tmp39_);
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp41_ = _tmp40_;
#line 245 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp33_ = _tmp41_;
#line 1184 "ViewWrapper.c"
	} else {
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp33_ = FALSE;
#line 1188 "ViewWrapper.c"
	}
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp42_ = noise_app_get_main_window ();
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp43_ = _tmp42_;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp44_ = noise_library_window_get_view_selector (_tmp43_);
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp45_ = _tmp44_;
#line 244 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_widgets_view_selector_set_column_browser_toggle_active (_tmp45_, _tmp33_);
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp46_ = noise_app_get_main_window ();
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp47_ = _tmp46_;
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp48_ = noise_library_window_get_view_selector (_tmp47_);
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp49_ = _tmp48_;
#line 250 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!noise_widgets_view_selector_get_column_browser_toggle_active (_tmp49_)) {
#line 1210 "ViewWrapper.c"
		gboolean _tmp50_ = FALSE;
		NoiseLibraryWindow* _tmp51_;
		NoiseLibraryWindow* _tmp52_;
		NoiseWidgetsViewSelector* _tmp53_;
		NoiseWidgetsViewSelector* _tmp54_;
		NoiseWidgetsViewSelectorMode _tmp55_;
		NoiseWidgetsViewSelectorMode _tmp56_;
		NoiseViewWrapperViewType _tmp57_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp51_ = noise_app_get_main_window ();
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp52_ = _tmp51_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp53_ = noise_library_window_get_view_selector (_tmp52_);
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp54_ = _tmp53_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp55_ = noise_widgets_view_selector_get_selected (_tmp54_);
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp56_ = _tmp55_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp57_ = self->priv->last_used_view;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp56_ != ((gint) _tmp57_)) {
#line 1235 "ViewWrapper.c"
			NoiseViewWrapperViewType _tmp58_;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp58_ = self->priv->last_used_view;
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp50_ = ((gint) _tmp58_) <= 1;
#line 1241 "ViewWrapper.c"
		} else {
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp50_ = FALSE;
#line 1245 "ViewWrapper.c"
		}
#line 251 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp50_) {
#line 1249 "ViewWrapper.c"
			NoiseLibraryWindow* _tmp59_;
			NoiseLibraryWindow* _tmp60_;
			NoiseWidgetsViewSelector* _tmp61_;
			NoiseWidgetsViewSelector* _tmp62_;
			NoiseViewWrapperViewType _tmp63_;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp59_ = noise_app_get_main_window ();
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp60_ = _tmp59_;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp61_ = noise_library_window_get_view_selector (_tmp60_);
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp62_ = _tmp61_;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp63_ = self->priv->last_used_view;
#line 252 "../src/Views/Wrappers/ViewWrapper.vala"
			noise_widgets_view_selector_set_selected (_tmp62_, (NoiseWidgetsViewSelectorMode) _tmp63_);
#line 1267 "ViewWrapper.c"
		}
	}
}


void
noise_view_wrapper_view_selector_changed (NoiseViewWrapper* self)
{
	gboolean _tmp0_ = FALSE;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	NoiseViewWrapperViewType _tmp13_;
	NoiseViewWrapperViewType _tmp14_;
	NoiseViewWrapperHint _tmp19_;
	GEnumValue* _tmp20_;
	NoiseViewWrapperViewType selected_view = 0;
	NoiseLibraryWindow* _tmp21_;
	NoiseLibraryWindow* _tmp22_;
	NoiseWidgetsViewSelector* _tmp23_;
	NoiseWidgetsViewSelector* _tmp24_;
	NoiseWidgetsViewSelectorMode _tmp25_;
	NoiseWidgetsViewSelectorMode _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
#line 256 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = noise_library_window_get_initialization_finished (_tmp2_);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp4_) {
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = TRUE;
#line 1310 "ViewWrapper.c"
	} else {
		NoiseLibraryWindow* _tmp5_;
		NoiseLibraryWindow* _tmp6_;
		NoiseWidgetsViewSelector* _tmp7_;
		NoiseWidgetsViewSelector* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = noise_app_get_main_window ();
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp5_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = noise_library_window_get_view_selector (_tmp6_);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = _tmp7_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = noise_widgets_view_selector_get_sensitive (_tmp8_);
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = _tmp9_;
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = !_tmp10_;
#line 1332 "ViewWrapper.c"
	}
#line 257 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp0_) {
#line 258 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1338 "ViewWrapper.c"
	}
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp13_ = noise_view_wrapper_get_current_view (self);
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp14_ = _tmp13_;
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp14_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT) {
#line 1346 "ViewWrapper.c"
		gint _tmp15_;
		gint _tmp16_;
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp15_ = noise_view_wrapper_get_media_count (self);
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp16_ = _tmp15_;
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp12_ = _tmp16_ < 1;
#line 1355 "ViewWrapper.c"
	} else {
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp12_ = FALSE;
#line 1359 "ViewWrapper.c"
	}
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp12_) {
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp11_ = TRUE;
#line 1365 "ViewWrapper.c"
	} else {
		NoiseViewWrapperViewType _tmp17_;
		NoiseViewWrapperViewType _tmp18_;
#line 261 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp17_ = noise_view_wrapper_get_current_view (self);
#line 261 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp18_ = _tmp17_;
#line 261 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp11_ = _tmp18_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
#line 1375 "ViewWrapper.c"
	}
#line 260 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp11_) {
#line 262 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1381 "ViewWrapper.c"
	}
#line 264 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp19_ = self->priv->_hint;
#line 264 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp20_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp19_);
#line 264 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:264: view_selector_changed [%s]", (_tmp20_ != NULL) ? _tmp20_->value_name : NULL);
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp21_ = noise_app_get_main_window ();
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp22_ = _tmp21_;
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp23_ = noise_library_window_get_view_selector (_tmp22_);
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp24_ = _tmp23_;
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp25_ = noise_widgets_view_selector_get_selected (_tmp24_);
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp26_ = _tmp25_;
#line 266 "../src/Views/Wrappers/ViewWrapper.vala"
	selected_view = (NoiseViewWrapperViewType) _tmp26_;
#line 268 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp27_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 268 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp28_ = _tmp27_;
#line 268 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp28_) {
#line 1409 "ViewWrapper.c"
		NoiseViewWrapperViewType _tmp29_;
#line 269 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp29_ = selected_view;
#line 269 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_active_view (self, _tmp29_, NULL);
#line 1415 "ViewWrapper.c"
	} else {
		NoiseViewWrapperViewType _tmp30_;
#line 271 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp30_ = selected_view;
#line 271 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->last_used_view = _tmp30_;
#line 1422 "ViewWrapper.c"
	}
}


void
noise_view_wrapper_play_first_media (NoiseViewWrapper* self,
                                     gboolean* force)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	NoiseViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	NoiseListView* _tmp4_;
	NoiseMedia* m = NULL;
	NoisePlaybackManager* _tmp5_;
	NoisePlaybackManager* _tmp6_;
	NoiseMedia* _tmp7_;
	NoiseMedia* _tmp8_;
	NoisePlaybackManager* _tmp9_;
	NoisePlaybackManager* _tmp10_;
	NoiseMedia* _tmp11_;
	NoisePlaybackManager* _tmp12_;
	NoisePlaybackManager* _tmp13_;
#line 274 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_view_wrapper_get_has_list_view (self);
#line 275 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 275 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp1_) {
#line 276 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1456 "ViewWrapper.c"
	}
#line 278 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = self->priv->_hint;
#line 278 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
#line 278 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:278: play_first_media [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
#line 280 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = self->priv->_list_view;
#line 280 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_list_view_set_as_current_list (_tmp4_, 1);
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = noise_app_get_player ();
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = _tmp5_;
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = noise_playback_manager_media_from_current_index (_tmp6_, 0);
#line 281 "../src/Views/Wrappers/ViewWrapper.vala"
	m = _tmp7_;
#line 283 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = m;
#line 283 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_ == NULL) {
#line 284 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (m);
#line 284 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1484 "ViewWrapper.c"
	}
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = noise_app_get_player ();
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = _tmp9_;
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = m;
#line 285 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_playback_manager_play_media (_tmp10_, _tmp11_);
#line 286 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp12_ = noise_app_get_player ();
#line 286 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp13_ = _tmp12_;
#line 286 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_playback_manager_start_playback (_tmp13_);
#line 274 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (m);
#line 1502 "ViewWrapper.c"
}


/**
     * This handles updating all the shared stuff outside the view area.
     *
     * You should only call this method on the respective ViewWrapper whenever the sidebar's
     * selected view changes.
     *
     * Note: The sidebar-item selection and other stuff is handled automatically by the LibraryWindow
     *       by request of SideTreeView. See LibraryWindow :: set_active_view() for more details.
     */
void
noise_view_wrapper_set_as_current_view (NoiseViewWrapper* self)
{
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	GEnumValue* _tmp5_;
#line 298 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = noise_library_window_get_initialization_finished (_tmp1_);
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 299 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp3_) {
#line 300 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1538 "ViewWrapper.c"
	}
#line 301 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = self->priv->_hint;
#line 301 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp4_);
#line 301 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:301: SETTING AS CURRENT VIEW [%s]", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 303 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_visible_media (self);
#line 304 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_check_have_media (self);
#line 305 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_library_window_widgets (self);
#line 1552 "ViewWrapper.c"
}


static void
noise_view_wrapper_search_field_changed (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 308 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 309 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 309 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp1_) {
#line 310 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1571 "ViewWrapper.c"
	}
#line 313 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_visible_media (self);
#line 1575 "ViewWrapper.c"
}


static gboolean
noise_view_wrapper_real_check_have_media (NoiseViewWrapper* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean have_media = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_;
#line 344 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->data_initialized;
#line 344 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp0_) {
#line 345 "../src/Views/Wrappers/ViewWrapper.vala"
		result = FALSE;
#line 345 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 1596 "ViewWrapper.c"
	}
#line 347 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = noise_view_wrapper_get_media_count (self);
#line 347 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 347 "../src/Views/Wrappers/ViewWrapper.vala"
	have_media = _tmp2_ > 0;
#line 349 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = have_media;
#line 349 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp3_) {
#line 350 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_select_proper_content_view (self);
#line 1610 "ViewWrapper.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 351 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp4_ = noise_view_wrapper_get_has_welcome_screen (self);
#line 351 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = _tmp4_;
#line 351 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp5_) {
#line 352 "../src/Views/Wrappers/ViewWrapper.vala"
			noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME, NULL);
#line 1622 "ViewWrapper.c"
		} else {
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 353 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = noise_view_wrapper_get_has_embedded_alert (self);
#line 353 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp7_ = _tmp6_;
#line 353 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp7_) {
#line 354 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_wrapper_set_no_media_alert (self);
#line 355 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT, NULL);
#line 1636 "ViewWrapper.c"
			}
		}
	}
#line 358 "../src/Views/Wrappers/ViewWrapper.vala"
	result = have_media;
#line 358 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 1644 "ViewWrapper.c"
}


gboolean
noise_view_wrapper_check_have_media (NoiseViewWrapper* self)
{
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 342 "../src/Views/Wrappers/ViewWrapper.vala"
	return NOISE_VIEW_WRAPPER_GET_CLASS (self)->check_have_media (self);
#line 1655 "ViewWrapper.c"
}


static void
noise_view_wrapper_real_select_proper_content_view (NoiseViewWrapper* self)
{
	NoiseViewWrapperViewType new_view = 0;
	NoiseLibraryWindow* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseWidgetsViewSelector* _tmp2_;
	NoiseWidgetsViewSelector* _tmp3_;
	NoiseWidgetsViewSelectorMode _tmp4_;
	NoiseWidgetsViewSelectorMode _tmp5_;
#line 364 "../src/Views/Wrappers/ViewWrapper.vala"
	static const gint N_VIEWS = 2;
#line 1671 "ViewWrapper.c"
	gboolean _tmp6_ = FALSE;
	NoiseViewWrapperViewType _tmp7_;
	gboolean _tmp9_ = FALSE;
	NoiseViewWrapperViewType _tmp10_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_app_get_main_window ();
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = noise_library_window_get_view_selector (_tmp1_);
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = noise_widgets_view_selector_get_selected (_tmp3_);
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 362 "../src/Views/Wrappers/ViewWrapper.vala"
	new_view = (NoiseViewWrapperViewType) _tmp5_;
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = new_view;
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp7_ < 0) {
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = TRUE;
#line 1696 "ViewWrapper.c"
	} else {
		NoiseViewWrapperViewType _tmp8_;
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = new_view;
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp8_ > (N_VIEWS - 1);
#line 1703 "ViewWrapper.c"
	}
#line 365 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp6_) {
#line 366 "../src/Views/Wrappers/ViewWrapper.vala"
		new_view = NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST;
#line 1709 "ViewWrapper.c"
	}
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = new_view;
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST) {
#line 1715 "ViewWrapper.c"
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp11_ = noise_view_wrapper_get_has_list_view (self);
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp12_ = _tmp11_;
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = _tmp12_;
#line 1724 "ViewWrapper.c"
	} else {
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = FALSE;
#line 1728 "ViewWrapper.c"
	}
#line 368 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp9_) {
#line 369 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST, NULL);
#line 1734 "ViewWrapper.c"
	} else {
		gboolean _tmp13_ = FALSE;
		NoiseViewWrapperViewType _tmp14_;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp14_ = new_view;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp14_ == NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID) {
#line 1742 "ViewWrapper.c"
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp15_ = noise_view_wrapper_get_has_grid_view (self);
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp16_ = _tmp15_;
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp13_ = _tmp16_;
#line 1751 "ViewWrapper.c"
		} else {
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp13_ = FALSE;
#line 1755 "ViewWrapper.c"
		}
#line 370 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_tmp13_) {
#line 371 "../src/Views/Wrappers/ViewWrapper.vala"
			noise_view_wrapper_set_active_view (self, NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID, NULL);
#line 1761 "ViewWrapper.c"
		} else {
			gboolean _tmp17_;
			gboolean _tmp18_;
#line 372 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp17_ = noise_view_wrapper_get_has_list_view (self);
#line 372 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp18_ = _tmp17_;
#line 372 "../src/Views/Wrappers/ViewWrapper.vala"
			if (_tmp18_) {
#line 1771 "ViewWrapper.c"
				NoiseViewStack* _tmp19_;
				NoiseListView* _tmp20_;
				NoiseListView* _tmp21_;
				NoiseMusicListView* _tmp22_;
				NoiseMusicListView* _tmp23_;
#line 373 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp19_ = self->priv->view_stack;
#line 373 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp20_ = self->priv->_list_view;
#line 373 "../src/Views/Wrappers/ViewWrapper.vala"
				gtk_stack_set_visible_child ((GtkStack*) _tmp19_, (GtkWidget*) _tmp20_);
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp21_ = self->priv->_list_view;
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp22_ = noise_list_view_get_list_view (_tmp21_);
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp23_ = _tmp22_;
#line 374 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_generic_list_scroll_to_current_media ((NoiseGenericList*) _tmp23_, TRUE);
#line 1791 "ViewWrapper.c"
			} else {
				gboolean _tmp24_;
				gboolean _tmp25_;
#line 375 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp24_ = noise_view_wrapper_get_has_grid_view (self);
#line 375 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp25_ = _tmp24_;
#line 375 "../src/Views/Wrappers/ViewWrapper.vala"
				if (_tmp25_) {
#line 1801 "ViewWrapper.c"
					NoiseViewStack* _tmp26_;
					NoiseAlbumsView* _tmp27_;
#line 376 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp26_ = self->priv->view_stack;
#line 376 "../src/Views/Wrappers/ViewWrapper.vala"
					_tmp27_ = self->priv->_grid_view;
#line 376 "../src/Views/Wrappers/ViewWrapper.vala"
					gtk_stack_set_visible_child ((GtkStack*) _tmp26_, (GtkWidget*) _tmp27_);
#line 1810 "ViewWrapper.c"
				}
			}
		}
	}
}


void
noise_view_wrapper_select_proper_content_view (NoiseViewWrapper* self)
{
#line 361 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 361 "../src/Views/Wrappers/ViewWrapper.vala"
	NOISE_VIEW_WRAPPER_GET_CLASS (self)->select_proper_content_view (self);
#line 1825 "ViewWrapper.c"
}


/**
     * @return A collection containing ALL the media associated to this view.
     */
GeeCollection*
noise_view_wrapper_get_media_list (NoiseViewWrapper* self)
{
	GeeCollection* result = NULL;
	NoiseListView* _tmp0_;
	GeeCollection* _tmp1_;
#line 382 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 383 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 383 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = noise_view_interface_get_media ((NoiseViewInterface*) _tmp0_);
#line 383 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp1_;
#line 383 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 1848 "ViewWrapper.c"
}


/**
     * Resets all the filters (external and internal) applied to a view inside
     * the view wrapper. It should only be called if the view is the current active
     * wrapper.
     */
void
noise_view_wrapper_clear_filters (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 391 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 391 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 391 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (_tmp1_, "is_current_wrapper");
#line 392 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_visible_media (self);
#line 1872 "ViewWrapper.c"
}


/**
     * Updates the data in visible_media and re-populates all the views.
     * Primarily used for searches
     */
void
noise_view_wrapper_update_visible_media (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	NoiseViewWrapperHint _tmp2_;
	GEnumValue* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GError* _inner_error0_ = NULL;
#line 399 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 400 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 400 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_tmp1_) {
#line 401 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 1902 "ViewWrapper.c"
	}
#line 402 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = self->priv->_hint;
#line 402 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp2_);
#line 402 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:402: UPDATING VISIBLE MEDIA [%s]", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL);
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = noise_view_wrapper_get_has_list_view (self);
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 404 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp5_) {
#line 1916 "ViewWrapper.c"
		{
			NoiseListView* _tmp6_;
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp6_ = self->priv->_list_view;
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 1923 "ViewWrapper.c"
			{
				NoiseListView* _tmp7_;
#line 406 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->_list_view;
#line 406 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_refilter ((NoiseViewInterface*) _tmp7_);
#line 1930 "ViewWrapper.c"
			}
			__finally93:
			{
				NoiseListView* _tmp8_;
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 1939 "ViewWrapper.c"
			}
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 405 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 1949 "ViewWrapper.c"
			}
		}
	}
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = noise_view_wrapper_get_has_grid_view (self);
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = _tmp9_;
#line 410 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_) {
#line 1959 "ViewWrapper.c"
		{
			NoiseAlbumsView* _tmp11_;
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp11_ = self->priv->_grid_view;
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 1966 "ViewWrapper.c"
			{
				NoiseAlbumsView* _tmp12_;
#line 412 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp12_ = self->priv->_grid_view;
#line 412 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_refilter ((NoiseViewInterface*) _tmp12_);
#line 1973 "ViewWrapper.c"
			}
			__finally94:
			{
				NoiseAlbumsView* _tmp13_;
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp13_ = self->priv->_grid_view;
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 1982 "ViewWrapper.c"
			}
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 411 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 1992 "ViewWrapper.c"
			}
		}
	}
}


static void
noise_view_wrapper_real_set_no_media_alert (NoiseViewWrapper* self)
{
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
#line 418 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_embedded_alert;
#line 418 "../src/Views/Wrappers/ViewWrapper.vala"
	granite_widgets_alert_view_set_icon_name (_tmp0_, "dialog-information");
#line 419 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = self->priv->_embedded_alert;
#line 419 "../src/Views/Wrappers/ViewWrapper.vala"
	granite_widgets_alert_view_set_title (_tmp1_, _ ("No media"));
#line 2012 "ViewWrapper.c"
}


void
noise_view_wrapper_set_no_media_alert (NoiseViewWrapper* self)
{
#line 417 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/Views/Wrappers/ViewWrapper.vala"
	NOISE_VIEW_WRAPPER_GET_CLASS (self)->set_no_media_alert (self);
#line 2023 "ViewWrapper.c"
}


static void
noise_view_wrapper_set_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperSetMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->new_media);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (NoiseViewWrapperSetMediaAsyncData, _data_);
#line 2038 "ViewWrapper.c"
}


static void
noise_view_wrapper_set_media_async_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	NoiseViewWrapperSetMediaAsyncData* _task_data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_task_data_->_callback_ != NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2054 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2058 "ViewWrapper.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	return self ? g_object_ref (self) : NULL;
#line 2067 "ViewWrapper.c"
}


void
noise_view_wrapper_set_media_async (NoiseViewWrapper* self,
                                    GeeCollection* new_media,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	NoiseViewWrapperSetMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (NoiseViewWrapperSetMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_callback_ = _callback_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_set_media_async_async_ready_wrapper, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_callback_ == NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_data_->_task_complete_ = TRUE;
#line 2090 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_set_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (new_media);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->new_media);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->new_media = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_set_media_async_co (_data_);
#line 2106 "ViewWrapper.c"
}


void
noise_view_wrapper_set_media_finish (NoiseViewWrapper* self,
                                     GAsyncResult* _res_)
{
	NoiseViewWrapperSetMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2117 "ViewWrapper.c"
}


static gboolean
noise_view_wrapper_set_media_async_co (NoiseViewWrapperSetMediaAsyncData* _data_)
{
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2128 "ViewWrapper.c"
		goto _state_0;
		default:
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2133 "ViewWrapper.c"
	}
	_state_0:
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
#line 423 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->_tmp0_) {
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!_data_->_task_complete_) {
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2148 "ViewWrapper.c"
			}
		}
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 424 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2155 "ViewWrapper.c"
	}
#line 425 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_set_media (_data_->self, _data_->new_media);
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!_data_->_task_complete_) {
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2167 "ViewWrapper.c"
		}
	}
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 422 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2174 "ViewWrapper.c"
}


static void
noise_view_wrapper_add_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperAddMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_add);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (NoiseViewWrapperAddMediaAsyncData, _data_);
#line 2189 "ViewWrapper.c"
}


static void
noise_view_wrapper_add_media_async_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	NoiseViewWrapperAddMediaAsyncData* _task_data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_task_data_->_callback_ != NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2205 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2209 "ViewWrapper.c"
}


void
noise_view_wrapper_add_media_async (NoiseViewWrapper* self,
                                    GeeCollection* to_add,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	NoiseViewWrapperAddMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (NoiseViewWrapperAddMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_callback_ = _callback_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_add_media_async_async_ready_wrapper, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_callback_ == NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_data_->_task_complete_ = TRUE;
#line 2232 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_add_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_add);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_add);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->to_add = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_add_media_async_co (_data_);
#line 2248 "ViewWrapper.c"
}


void
noise_view_wrapper_add_media_finish (NoiseViewWrapper* self,
                                     GAsyncResult* _res_)
{
	NoiseViewWrapperAddMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2259 "ViewWrapper.c"
}


static gboolean
noise_view_wrapper_add_media_async_co (NoiseViewWrapperAddMediaAsyncData* _data_)
{
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2270 "ViewWrapper.c"
		goto _state_0;
		default:
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2275 "ViewWrapper.c"
	}
	_state_0:
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
#line 429 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->_tmp0_) {
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!_data_->_task_complete_) {
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2290 "ViewWrapper.c"
			}
		}
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 430 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2297 "ViewWrapper.c"
	}
#line 431 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_add_media (_data_->self, _data_->to_add);
#line 432 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_visible_media (_data_->self);
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!_data_->_task_complete_) {
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2311 "ViewWrapper.c"
		}
	}
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 428 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2318 "ViewWrapper.c"
}


static void
noise_view_wrapper_remove_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperRemoveMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_remove);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (NoiseViewWrapperRemoveMediaAsyncData, _data_);
#line 2333 "ViewWrapper.c"
}


static void
noise_view_wrapper_remove_media_async_async_ready_wrapper (GObject *source_object,
                                                           GAsyncResult *res,
                                                           void *user_data)
{
	NoiseViewWrapperRemoveMediaAsyncData* _task_data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_task_data_->_callback_ != NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2349 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2353 "ViewWrapper.c"
}


void
noise_view_wrapper_remove_media_async (NoiseViewWrapper* self,
                                       GeeCollection* to_remove,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	NoiseViewWrapperRemoveMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (NoiseViewWrapperRemoveMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_callback_ = _callback_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_remove_media_async_async_ready_wrapper, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_callback_ == NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_data_->_task_complete_ = TRUE;
#line 2376 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_remove_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_remove);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_remove);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->to_remove = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_remove_media_async_co (_data_);
#line 2392 "ViewWrapper.c"
}


void
noise_view_wrapper_remove_media_finish (NoiseViewWrapper* self,
                                        GAsyncResult* _res_)
{
	NoiseViewWrapperRemoveMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2403 "ViewWrapper.c"
}


static gboolean
noise_view_wrapper_remove_media_async_co (NoiseViewWrapperRemoveMediaAsyncData* _data_)
{
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2414 "ViewWrapper.c"
		goto _state_0;
		default:
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2419 "ViewWrapper.c"
	}
	_state_0:
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
#line 436 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->_tmp0_) {
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!_data_->_task_complete_) {
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2434 "ViewWrapper.c"
			}
		}
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 437 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2441 "ViewWrapper.c"
	}
#line 438 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_remove_media (_data_->self, _data_->to_remove);
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!_data_->_task_complete_) {
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2453 "ViewWrapper.c"
		}
	}
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 435 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2460 "ViewWrapper.c"
}


static void
noise_view_wrapper_update_media_async_data_free (gpointer _data)
{
	NoiseViewWrapperUpdateMediaAsyncData* _data_;
	_data_ = _data;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_update);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_slice_free (NoiseViewWrapperUpdateMediaAsyncData, _data_);
#line 2475 "ViewWrapper.c"
}


static void
noise_view_wrapper_update_media_async_async_ready_wrapper (GObject *source_object,
                                                           GAsyncResult *res,
                                                           void *user_data)
{
	NoiseViewWrapperUpdateMediaAsyncData* _task_data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_task_data_->_callback_ != NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2491 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2495 "ViewWrapper.c"
}


void
noise_view_wrapper_update_media_async (NoiseViewWrapper* self,
                                       GeeCollection* to_update,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	NoiseViewWrapperUpdateMediaAsyncData* _data_;
	NoiseViewWrapper* _tmp0_;
	GeeCollection* _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_slice_new0 (NoiseViewWrapperUpdateMediaAsyncData);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_callback_ = _callback_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_view_wrapper_update_media_async_async_ready_wrapper, _user_data_);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_callback_ == NULL) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		_data_->_task_complete_ = TRUE;
#line 2518 "ViewWrapper.c"
	}
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_view_wrapper_update_media_async_data_free);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->self = _tmp0_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _g_object_ref0 (to_update);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (_data_->to_update);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->to_update = _tmp1_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_media_async_co (_data_);
#line 2534 "ViewWrapper.c"
}


void
noise_view_wrapper_update_media_finish (NoiseViewWrapper* self,
                                        GAsyncResult* _res_)
{
	NoiseViewWrapperUpdateMediaAsyncData* _data_;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2545 "ViewWrapper.c"
}


static gboolean
noise_view_wrapper_update_media_async_co (NoiseViewWrapperUpdateMediaAsyncData* _data_)
{
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (_data_->_state_) {
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
		case 0:
#line 2556 "ViewWrapper.c"
		goto _state_0;
		default:
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
		g_assert_not_reached ();
#line 2561 "ViewWrapper.c"
	}
	_state_0:
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
	_data_->_tmp0_ = _data_->self->priv->widgets_ready;
#line 442 "../src/Views/Wrappers/ViewWrapper.vala"
	if (!_data_->_tmp0_) {
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
		if (_data_->_state_ != 0) {
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
			while (!_data_->_task_complete_) {
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2576 "ViewWrapper.c"
			}
		}
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_unref (_data_->_async_result);
#line 443 "../src/Views/Wrappers/ViewWrapper.vala"
		return FALSE;
#line 2583 "ViewWrapper.c"
	}
#line 444 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_media (_data_->self, _data_->to_update);
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_data_->_state_ != 0) {
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
		while (!_data_->_task_complete_) {
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2595 "ViewWrapper.c"
		}
	}
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_unref (_data_->_async_result);
#line 441 "../src/Views/Wrappers/ViewWrapper.vala"
	return FALSE;
#line 2602 "ViewWrapper.c"
}


static void
noise_view_wrapper_set_media (NoiseViewWrapper* self,
                              GeeCollection* new_media)
{
	NoiseViewWrapperHint _tmp0_;
	GEnumValue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GError* _inner_error0_ = NULL;
#line 447 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (new_media != NULL);
#line 448 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_hint;
#line 448 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp0_);
#line 448 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:448: SETTING MEDIA [%s]", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = noise_view_wrapper_get_has_list_view (self);
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 450 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp3_) {
#line 2633 "ViewWrapper.c"
		{
			NoiseListView* _tmp4_;
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp4_ = self->priv->_list_view;
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 2640 "ViewWrapper.c"
			{
				NoiseListView* _tmp5_;
#line 452 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp5_ = self->priv->_list_view;
#line 452 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_set_media ((NoiseViewInterface*) _tmp5_, new_media);
#line 2647 "ViewWrapper.c"
			}
			__finally95:
			{
				NoiseListView* _tmp6_;
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp6_ = self->priv->_list_view;
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 2656 "ViewWrapper.c"
			}
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 451 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2666 "ViewWrapper.c"
			}
		}
	}
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = noise_view_wrapper_get_has_grid_view (self);
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = _tmp7_;
#line 456 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_) {
#line 2676 "ViewWrapper.c"
		{
			NoiseAlbumsView* _tmp9_;
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp9_ = self->priv->_grid_view;
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 2683 "ViewWrapper.c"
			{
				NoiseAlbumsView* _tmp10_;
#line 458 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp10_ = self->priv->_grid_view;
#line 458 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_set_media ((NoiseViewInterface*) _tmp10_, new_media);
#line 2690 "ViewWrapper.c"
			}
			__finally96:
			{
				NoiseAlbumsView* _tmp11_;
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp11_ = self->priv->_grid_view;
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 2699 "ViewWrapper.c"
			}
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 457 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2709 "ViewWrapper.c"
			}
		}
	}
#line 462 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->data_initialized = TRUE;
#line 464 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_visible_media (self);
#line 465 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_widget_state (self);
#line 2719 "ViewWrapper.c"
}


static void
noise_view_wrapper_update_media (NoiseViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	NoiseViewWrapperHint _tmp3_;
	GEnumValue* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GError* _inner_error0_ = NULL;
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (media != NULL);
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->data_initialized;
#line 468 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (_tmp0_, "data_initialized");
#line 469 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = gee_collection_get_is_empty (media);
#line 469 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 469 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp2_) {
#line 470 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 2753 "ViewWrapper.c"
	}
#line 472 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = self->priv->_hint;
#line 472 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp3_);
#line 472 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:472: UPDATING MEDIA [%s]", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL);
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = noise_view_wrapper_get_has_list_view (self);
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = _tmp5_;
#line 474 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp6_) {
#line 2767 "ViewWrapper.c"
		{
			NoiseListView* _tmp7_;
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp7_ = self->priv->_list_view;
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 2774 "ViewWrapper.c"
			{
				NoiseListView* _tmp8_;
#line 476 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 476 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_update_media ((NoiseViewInterface*) _tmp8_, media);
#line 2781 "ViewWrapper.c"
			}
			__finally97:
			{
				NoiseListView* _tmp9_;
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp9_ = self->priv->_list_view;
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 2790 "ViewWrapper.c"
			}
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 475 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2800 "ViewWrapper.c"
			}
		}
	}
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = noise_view_wrapper_get_has_grid_view (self);
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = _tmp10_;
#line 480 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp11_) {
#line 2810 "ViewWrapper.c"
		{
			NoiseAlbumsView* _tmp12_;
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp12_ = self->priv->_grid_view;
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 2817 "ViewWrapper.c"
			{
				NoiseAlbumsView* _tmp13_;
#line 482 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp13_ = self->priv->_grid_view;
#line 482 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_update_media ((NoiseViewInterface*) _tmp13_, media);
#line 2824 "ViewWrapper.c"
			}
			__finally98:
			{
				NoiseAlbumsView* _tmp14_;
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp14_ = self->priv->_grid_view;
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 2833 "ViewWrapper.c"
			}
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 481 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2843 "ViewWrapper.c"
			}
		}
	}
#line 486 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_widget_state (self);
#line 2849 "ViewWrapper.c"
}


static void
noise_view_wrapper_add_media (NoiseViewWrapper* self,
                              GeeCollection* new_media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GError* _inner_error0_ = NULL;
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (new_media != NULL);
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->data_initialized;
#line 489 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (_tmp0_, "data_initialized");
#line 490 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = gee_collection_get_is_empty (new_media);
#line 490 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 490 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp2_) {
#line 491 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 2881 "ViewWrapper.c"
	}
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = noise_view_wrapper_get_has_list_view (self);
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 493 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp4_) {
#line 2889 "ViewWrapper.c"
		{
			NoiseListView* _tmp5_;
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp5_ = self->priv->_list_view;
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 2896 "ViewWrapper.c"
			{
				NoiseListView* _tmp6_;
#line 495 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp6_ = self->priv->_list_view;
#line 495 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_add_media ((NoiseViewInterface*) _tmp6_, new_media);
#line 2903 "ViewWrapper.c"
			}
			__finally99:
			{
				NoiseListView* _tmp7_;
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp7_ = self->priv->_list_view;
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 2912 "ViewWrapper.c"
			}
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 494 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2922 "ViewWrapper.c"
			}
		}
	}
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = noise_view_wrapper_get_has_grid_view (self);
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = _tmp8_;
#line 499 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp9_) {
#line 2932 "ViewWrapper.c"
		{
			NoiseAlbumsView* _tmp10_;
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp10_ = self->priv->_grid_view;
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 2939 "ViewWrapper.c"
			{
				NoiseAlbumsView* _tmp11_;
#line 501 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp11_ = self->priv->_grid_view;
#line 501 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_add_media ((NoiseViewInterface*) _tmp11_, new_media);
#line 2946 "ViewWrapper.c"
			}
			__finally100:
			{
				NoiseAlbumsView* _tmp12_;
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp12_ = self->priv->_grid_view;
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 2955 "ViewWrapper.c"
			}
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 500 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 2965 "ViewWrapper.c"
			}
		}
	}
#line 505 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_widget_state (self);
#line 2971 "ViewWrapper.c"
}


static void
noise_view_wrapper_remove_media (NoiseViewWrapper* self,
                                 GeeCollection* media)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	NoiseViewWrapperHint _tmp3_;
	GEnumValue* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GError* _inner_error0_ = NULL;
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (media != NULL);
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->data_initialized;
#line 508 "../src/Views/Wrappers/ViewWrapper.vala"
	_vala_return_if_fail (_tmp0_, "data_initialized");
#line 509 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = gee_collection_get_is_empty (media);
#line 509 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 509 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp2_) {
#line 510 "../src/Views/Wrappers/ViewWrapper.vala"
		return;
#line 3005 "ViewWrapper.c"
	}
#line 512 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = self->priv->_hint;
#line 512 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = g_enum_get_value (g_type_class_ref (NOISE_VIEW_WRAPPER_TYPE_HINT), _tmp3_);
#line 512 "../src/Views/Wrappers/ViewWrapper.vala"
	g_debug ("ViewWrapper.vala:512: REMOVING MEDIA [%s]", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL);
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = noise_view_wrapper_get_has_list_view (self);
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = _tmp5_;
#line 514 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp6_) {
#line 3019 "ViewWrapper.c"
		{
			NoiseListView* _tmp7_;
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp7_ = self->priv->_list_view;
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 3026 "ViewWrapper.c"
			{
				NoiseListView* _tmp8_;
#line 516 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp8_ = self->priv->_list_view;
#line 516 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_remove_media ((NoiseViewInterface*) _tmp8_, media);
#line 3033 "ViewWrapper.c"
			}
			__finally101:
			{
				NoiseListView* _tmp9_;
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp9_ = self->priv->_list_view;
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 3042 "ViewWrapper.c"
			}
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 515 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 3052 "ViewWrapper.c"
			}
		}
	}
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = noise_view_wrapper_get_has_grid_view (self);
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = _tmp10_;
#line 520 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp11_) {
#line 3062 "ViewWrapper.c"
		{
			NoiseAlbumsView* _tmp12_;
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
			_tmp12_ = self->priv->_grid_view;
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
			g_rec_mutex_lock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 3069 "ViewWrapper.c"
			{
				NoiseAlbumsView* _tmp13_;
#line 522 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp13_ = self->priv->_grid_view;
#line 522 "../src/Views/Wrappers/ViewWrapper.vala"
				noise_view_interface_remove_media ((NoiseViewInterface*) _tmp13_, media);
#line 3076 "ViewWrapper.c"
			}
			__finally102:
			{
				NoiseAlbumsView* _tmp14_;
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				_tmp14_ = self->priv->_grid_view;
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				g_rec_mutex_unlock (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 3085 "ViewWrapper.c"
			}
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				g_clear_error (&_inner_error0_);
#line 521 "../src/Views/Wrappers/ViewWrapper.vala"
				return;
#line 3095 "ViewWrapper.c"
			}
		}
	}
#line 526 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_update_widget_state (self);
#line 3101 "ViewWrapper.c"
}


static void
noise_view_wrapper_update_widget_state (NoiseViewWrapper* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 529 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 530 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_check_have_media (self);
#line 533 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_view_wrapper_get_is_current_wrapper (self);
#line 533 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = _tmp0_;
#line 533 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp1_) {
#line 534 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_update_library_window_widgets (self);
#line 3122 "ViewWrapper.c"
	}
}


NoiseListView*
noise_view_wrapper_get_list_view (NoiseViewWrapper* self)
{
	NoiseListView* result;
	NoiseListView* _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3140 "ViewWrapper.c"
}


void
noise_view_wrapper_set_list_view (NoiseViewWrapper* self,
                                  NoiseListView* value)
{
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_list_view (self) != value) {
#line 3152 "ViewWrapper.c"
		NoiseListView* _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_list_view);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_list_view = _tmp0_;
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY]);
#line 3162 "ViewWrapper.c"
	}
}


NoiseAlbumsView*
noise_view_wrapper_get_grid_view (NoiseViewWrapper* self)
{
	NoiseAlbumsView* result;
	NoiseAlbumsView* _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_grid_view;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3180 "ViewWrapper.c"
}


void
noise_view_wrapper_set_grid_view (NoiseViewWrapper* self,
                                  NoiseAlbumsView* value)
{
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_grid_view (self) != value) {
#line 3192 "ViewWrapper.c"
		NoiseAlbumsView* _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_grid_view);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_grid_view = _tmp0_;
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY]);
#line 3202 "ViewWrapper.c"
	}
}


GraniteWidgetsAlertView*
noise_view_wrapper_get_embedded_alert (NoiseViewWrapper* self)
{
	GraniteWidgetsAlertView* result;
	GraniteWidgetsAlertView* _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_embedded_alert;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3220 "ViewWrapper.c"
}


void
noise_view_wrapper_set_embedded_alert (NoiseViewWrapper* self,
                                       GraniteWidgetsAlertView* value)
{
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_embedded_alert (self) != value) {
#line 3232 "ViewWrapper.c"
		GraniteWidgetsAlertView* _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_embedded_alert);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_embedded_alert = _tmp0_;
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY]);
#line 3242 "ViewWrapper.c"
	}
}


GraniteWidgetsWelcome*
noise_view_wrapper_get_welcome_screen (NoiseViewWrapper* self)
{
	GraniteWidgetsWelcome* result;
	GraniteWidgetsWelcome* _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_welcome_screen;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3260 "ViewWrapper.c"
}


void
noise_view_wrapper_set_welcome_screen (NoiseViewWrapper* self,
                                       GraniteWidgetsWelcome* value)
{
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_welcome_screen (self) != value) {
#line 3272 "ViewWrapper.c"
		GraniteWidgetsWelcome* _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_welcome_screen);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_welcome_screen = _tmp0_;
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY]);
#line 3282 "ViewWrapper.c"
	}
}


gboolean
noise_view_wrapper_get_has_grid_view (NoiseViewWrapper* self)
{
	gboolean result;
	NoiseAlbumsView* _tmp0_;
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_grid_view;
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 76 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3300 "ViewWrapper.c"
}


gboolean
noise_view_wrapper_get_has_list_view (NoiseViewWrapper* self)
{
	gboolean result;
	NoiseListView* _tmp0_;
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 77 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3317 "ViewWrapper.c"
}


gboolean
noise_view_wrapper_get_has_embedded_alert (NoiseViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsAlertView* _tmp0_;
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_embedded_alert;
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 78 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3334 "ViewWrapper.c"
}


gboolean
noise_view_wrapper_get_has_welcome_screen (NoiseViewWrapper* self)
{
	gboolean result;
	GraniteWidgetsWelcome* _tmp0_;
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_welcome_screen;
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_ != NULL;
#line 79 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3351 "ViewWrapper.c"
}


NoiseViewWrapperViewType
noise_view_wrapper_get_current_view (NoiseViewWrapper* self)
{
	NoiseViewWrapperViewType result;
	GtkWidget* view = NULL;
	NoiseViewStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	NoiseAlbumsView* _tmp5_;
	GtkWidget* _tmp6_;
	NoiseListView* _tmp7_;
	GtkWidget* _tmp8_;
	GraniteWidgetsAlertView* _tmp9_;
	GtkWidget* _tmp10_;
	GraniteWidgetsWelcome* _tmp11_;
#line 82 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->view_stack;
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = gtk_stack_get_visible_child ((GtkStack*) _tmp0_);
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 83 "../src/Views/Wrappers/ViewWrapper.vala"
	view = _tmp3_;
#line 85 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = view;
#line 85 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = self->priv->_grid_view;
#line 85 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 86 "../src/Views/Wrappers/ViewWrapper.vala"
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_GRID;
#line 86 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 86 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3396 "ViewWrapper.c"
	}
#line 88 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = view;
#line 88 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp7_ = self->priv->_list_view;
#line 88 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp6_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget)) {
#line 89 "../src/Views/Wrappers/ViewWrapper.vala"
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_LIST;
#line 89 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 89 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3410 "ViewWrapper.c"
	}
#line 91 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp8_ = view;
#line 91 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp9_ = self->priv->_embedded_alert;
#line 91 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
#line 92 "../src/Views/Wrappers/ViewWrapper.vala"
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_ALERT;
#line 92 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 92 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3424 "ViewWrapper.c"
	}
#line 95 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp10_ = view;
#line 95 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp11_ = self->priv->_welcome_screen;
#line 95 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget)) {
#line 96 "../src/Views/Wrappers/ViewWrapper.vala"
		result = NOISE_VIEW_WRAPPER_VIEW_TYPE_WELCOME;
#line 96 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (view);
#line 96 "../src/Views/Wrappers/ViewWrapper.vala"
		return result;
#line 3438 "ViewWrapper.c"
	}
#line 98 "../src/Views/Wrappers/ViewWrapper.vala"
	result = NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE;
#line 98 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (view);
#line 98 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3446 "ViewWrapper.c"
}


NoiseViewWrapperHint
noise_view_wrapper_get_hint (NoiseViewWrapper* self)
{
	NoiseViewWrapperHint result;
	NoiseViewWrapperHint _tmp0_;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_hint;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3463 "ViewWrapper.c"
}


void
noise_view_wrapper_set_hint (NoiseViewWrapper* self,
                             NoiseViewWrapperHint value)
{
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_hint (self) != value) {
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_hint = value;
#line 107 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HINT_PROPERTY]);
#line 3479 "ViewWrapper.c"
	}
}


NoiseLibrary*
noise_view_wrapper_get_library (NoiseViewWrapper* self)
{
	NoiseLibrary* result;
	NoiseLibrary* _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_library;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3497 "ViewWrapper.c"
}


void
noise_view_wrapper_set_library (NoiseViewWrapper* self,
                                NoiseLibrary* value)
{
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_library (self) != value) {
#line 3509 "ViewWrapper.c"
		NoiseLibrary* _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_library);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_library = _tmp0_;
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY]);
#line 3519 "ViewWrapper.c"
	}
}


gboolean
noise_view_wrapper_get_is_current_wrapper (NoiseViewWrapper* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 111 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = noise_app_get_main_window ();
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = noise_library_window_get_initialization_finished (_tmp2_);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = _tmp3_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	if (_tmp4_) {
#line 3545 "ViewWrapper.c"
		NoiseLibraryWindow* _tmp5_;
		NoiseLibraryWindow* _tmp6_;
		NoiseViewStack* _tmp7_;
		NoiseViewStack* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp5_ = noise_app_get_main_window ();
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp6_ = _tmp5_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp7_ = noise_library_window_get_view_stack (_tmp6_);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp8_ = _tmp7_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp9_ = gtk_stack_get_visible_child ((GtkStack*) _tmp8_);
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp10_ = _tmp9_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _tmp10_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
#line 3566 "ViewWrapper.c"
	} else {
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = FALSE;
#line 3570 "ViewWrapper.c"
	}
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 112 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3576 "ViewWrapper.c"
}


NoisePlaylist*
noise_view_wrapper_get_playlist (NoiseViewWrapper* self)
{
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_playlist;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	result = _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3593 "ViewWrapper.c"
}


void
noise_view_wrapper_set_playlist (NoiseViewWrapper* self,
                                 NoisePlaylist* value)
{
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	if (noise_view_wrapper_get_playlist (self) != value) {
#line 3605 "ViewWrapper.c"
		NoisePlaylist* _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		_g_object_unref0 (self->priv->_playlist);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		self->priv->_playlist = _tmp0_;
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY]);
#line 3615 "ViewWrapper.c"
	}
}


gint
noise_view_wrapper_get_media_count (NoiseViewWrapper* self)
{
	gint result;
	NoiseListView* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = self->priv->_list_view;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = noise_list_view_get_n_media (_tmp0_);
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = _tmp1_;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	result = (gint) _tmp2_;
#line 119 "../src/Views/Wrappers/ViewWrapper.vala"
	return result;
#line 3639 "ViewWrapper.c"
}


static void
_noise_view_wrapper_view_selector_changed_noise_widgets_view_selector_mode_changed (NoiseWidgetsViewSelector* _sender,
                                                                                    NoiseWidgetsViewSelectorMode new_mode,
                                                                                    gpointer self)
{
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_view_selector_changed ((NoiseViewWrapper*) self);
#line 3650 "ViewWrapper.c"
}


static void
_noise_view_wrapper_search_field_changed_noise_library_search_finished (NoiseLibrary* _sender,
                                                                        gpointer self)
{
#line 144 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_search_field_changed ((NoiseViewWrapper*) self);
#line 3660 "ViewWrapper.c"
}


static GObject *
noise_view_wrapper_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseViewWrapper * self;
	NoiseViewStack* _tmp0_;
	NoiseViewStack* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	NoiseLibraryWindow* _tmp3_;
	NoiseWidgetsViewSelector* _tmp4_;
	NoiseWidgetsViewSelector* _tmp5_;
	NoiseLibrary* _tmp6_;
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	parent_class = G_OBJECT_CLASS (noise_view_wrapper_parent_class);
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
#line 138 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp0_ = noise_view_stack_new ();
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_ref_sink (_tmp0_);
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->view_stack);
#line 140 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->view_stack = _tmp0_;
#line 141 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp1_ = self->priv->view_stack;
#line 141 "../src/Views/Wrappers/ViewWrapper.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp2_ = noise_app_get_main_window ();
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp3_ = _tmp2_;
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp4_ = noise_library_window_get_view_selector (_tmp3_);
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/Views/Wrappers/ViewWrapper.vala"
	g_signal_connect_object (_tmp5_, "mode-changed", (GCallback) _noise_view_wrapper_view_selector_changed_noise_widgets_view_selector_mode_changed, self, 0);
#line 144 "../src/Views/Wrappers/ViewWrapper.vala"
	_tmp6_ = self->priv->_library;
#line 144 "../src/Views/Wrappers/ViewWrapper.vala"
	g_signal_connect_object (_tmp6_, "search-finished", (GCallback) _noise_view_wrapper_search_field_changed_noise_library_search_finished, self, 0);
#line 137 "../src/Views/Wrappers/ViewWrapper.vala"
	return obj;
#line 3715 "ViewWrapper.c"
}


static void
noise_view_wrapper_class_init (NoiseViewWrapperClass * klass)
{
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	noise_view_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_type_class_adjust_private_offset (klass, &NoiseViewWrapper_private_offset);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	((NoiseViewWrapperClass *) klass)->check_have_media = (gboolean (*) (NoiseViewWrapper*)) noise_view_wrapper_real_check_have_media;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	((NoiseViewWrapperClass *) klass)->select_proper_content_view = (void (*) (NoiseViewWrapper*)) noise_view_wrapper_real_select_proper_content_view;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	((NoiseViewWrapperClass *) klass)->set_no_media_alert = (void (*) (NoiseViewWrapper*)) noise_view_wrapper_real_set_no_media_alert;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_view_wrapper_get_property;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_view_wrapper_set_property;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_view_wrapper_constructor;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_view_wrapper_finalize;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY] = g_param_spec_object ("list-view", "list-view", "list-view", NOISE_TYPE_LIST_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY] = g_param_spec_object ("grid-view", "grid-view", "grid-view", NOISE_TYPE_ALBUMS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY] = g_param_spec_object ("embedded-alert", "embedded-alert", "embedded-alert", GRANITE_WIDGETS_TYPE_ALERT_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY] = g_param_spec_object ("welcome-screen", "welcome-screen", "welcome-screen", GRANITE_WIDGETS_TYPE_WELCOME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY] = g_param_spec_boolean ("has-grid-view", "has-grid-view", "has-grid-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY] = g_param_spec_boolean ("has-list-view", "has-list-view", "has-list-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY] = g_param_spec_boolean ("has-embedded-alert", "has-embedded-alert", "has-embedded-alert", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY] = g_param_spec_boolean ("has-welcome-screen", "has-welcome-screen", "has-welcome-screen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY] = g_param_spec_enum ("current-view", "current-view", "current-view", NOISE_VIEW_WRAPPER_TYPE_VIEW_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3758 "ViewWrapper.c"
	/**
	     * This is by far the most important property of this object.
	     * It defines how child widgets behave and some other properties.
	     */
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_HINT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY] = g_param_spec_object ("library", "library", "library", NOISE_TYPE_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY] = g_param_spec_boolean ("is-current-wrapper", "is-current-wrapper", "is-current-wrapper", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY, noise_view_wrapper_properties[NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY] = g_param_spec_int ("media-count", "media-count", "media-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3773 "ViewWrapper.c"
}


static void
noise_view_wrapper_instance_init (NoiseViewWrapper * self)
{
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv = noise_view_wrapper_get_instance_private (self);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->_playlist = NULL;
#line 125 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->widgets_ready = FALSE;
#line 127 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->last_used_view = NOISE_VIEW_WRAPPER_VIEW_TYPE_NONE;
#line 131 "../src/Views/Wrappers/ViewWrapper.vala"
	self->priv->data_initialized = FALSE;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_init (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_init (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 3794 "ViewWrapper.c"
}


static void
noise_view_wrapper_finalize (GObject * obj)
{
	NoiseViewWrapper * self;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
#line 71 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_list_view);
#line 72 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_grid_view);
#line 73 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_embedded_alert);
#line 74 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_welcome_screen);
#line 108 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_library);
#line 116 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->_playlist);
#line 126 "../src/Views/Wrappers/ViewWrapper.vala"
	_g_object_unref0 (self->priv->view_stack);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_clear (&self->priv->__lock_NoiseViewWrapperlist_view);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	g_rec_mutex_clear (&self->priv->__lock_NoiseViewWrappergrid_view);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	G_OBJECT_CLASS (noise_view_wrapper_parent_class)->finalize (obj);
#line 3824 "ViewWrapper.c"
}


GType
noise_view_wrapper_get_type (void)
{
	static volatile gsize noise_view_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&noise_view_wrapper_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseViewWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_view_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseViewWrapper), 0, (GInstanceInitFunc) noise_view_wrapper_instance_init, NULL };
		GType noise_view_wrapper_type_id;
		noise_view_wrapper_type_id = g_type_register_static (gtk_grid_get_type (), "NoiseViewWrapper", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		NoiseViewWrapper_private_offset = g_type_add_instance_private (noise_view_wrapper_type_id, sizeof (NoiseViewWrapperPrivate));
		g_once_init_leave (&noise_view_wrapper_type_id__volatile, noise_view_wrapper_type_id);
	}
	return noise_view_wrapper_type_id__volatile;
}


static void
_vala_noise_view_wrapper_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	NoiseViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (property_id) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, noise_view_wrapper_get_list_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, noise_view_wrapper_get_grid_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, noise_view_wrapper_get_embedded_alert (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, noise_view_wrapper_get_welcome_screen (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_HAS_GRID_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, noise_view_wrapper_get_has_grid_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_HAS_LIST_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, noise_view_wrapper_get_has_list_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_HAS_EMBEDDED_ALERT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, noise_view_wrapper_get_has_embedded_alert (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_HAS_WELCOME_SCREEN_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, noise_view_wrapper_get_has_welcome_screen (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_CURRENT_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_enum (value, noise_view_wrapper_get_current_view (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_HINT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_enum (value, noise_view_wrapper_get_hint (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, noise_view_wrapper_get_library (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_IS_CURRENT_WRAPPER_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_boolean (value, noise_view_wrapper_get_is_current_wrapper (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_object (value, noise_view_wrapper_get_playlist (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_MEDIA_COUNT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		g_value_set_int (value, noise_view_wrapper_get_media_count (self));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 3937 "ViewWrapper.c"
		default:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 3943 "ViewWrapper.c"
	}
}


static void
_vala_noise_view_wrapper_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	NoiseViewWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
	switch (property_id) {
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_LIST_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_list_view (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_GRID_VIEW_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_grid_view (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_EMBEDDED_ALERT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_embedded_alert (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_WELCOME_SCREEN_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_welcome_screen (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_HINT_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_hint (self, g_value_get_enum (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_LIBRARY_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_library (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		case NOISE_VIEW_WRAPPER_PLAYLIST_PROPERTY:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		noise_view_wrapper_set_playlist (self, g_value_get_object (value));
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 4000 "ViewWrapper.c"
		default:
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/Views/Wrappers/ViewWrapper.vala"
		break;
#line 4006 "ViewWrapper.c"
	}
}



